/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/workbench/api/common/extHostTypeConverters","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/extpath","vs/workbench/api/common/extHostCommands","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/stopwatch","vs/base/common/severity","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/errorMessage","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/iterator","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/collections","vs/base/common/decorators","vs/base/common/assert","vs/base/common/lazy","vs/base/common/themables","net","vs/editor/common/core/position","vs/base/common/marshalling","os","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatSlashCommand","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function($e){for(var e=[],D=0,M=$e.length;D<M;D++)e[D]=Se[$e[D]];return e};define(Se[156],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class D{static get(){const g=new Map,L=new Map,R=new Map,m=new Map;function k(S,C){S.has(C.detail)||S.set(C.detail,-C.timestamp)}function b(S,C){const v=S.get(C.detail);v&&(v>=0||S.set(C.detail,v+C.timestamp))}let P=[];typeof $e=="function"&&typeof $e.getStats=="function"&&(P=$e.getStats().slice(0).sort((S,C)=>S.timestamp-C.timestamp));for(const S of P)switch(S.type){case 10:k(g,S);break;case 11:case 12:b(g,S);break;case 21:k(L,S);break;case 22:b(L,S);break;case 33:k(R,S);break;case 34:b(R,S);break;case 31:k(m,S);break;case 32:b(m,S);break}let I=0;R.forEach(S=>I+=S);function p(S){const C=[];return S.forEach((v,o)=>C.push([o,v])),C}return{amdLoad:p(g),amdInvoke:p(L),nodeRequire:p(R),nodeEval:p(m),nodeRequireTotal:I}}static toMarkdownTable(g,L){let R="";const m=[];return g.forEach((k,b)=>{m[b]=k.length}),L.forEach(k=>{k.forEach((b,P)=>{typeof b>"u"&&(b=k[P]="-");const I=b.toString().length;m[P]=Math.max(I,m[P])})}),g.forEach((k,b)=>{R+=`| ${k+" ".repeat(m[b]-k.toString().length)} `}),R+=`|
`,g.forEach((k,b)=>{R+=`| ${"-".repeat(m[b])} `}),R+=`|
`,L.forEach(k=>{k.forEach((b,P)=>{typeof b<"u"&&(R+=`| ${b+" ".repeat(m[P]-b.toString().length)} `)}),R+=`|
`}),R}}e.$S=D}),define(Se[118],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;function D(v,o,s){const n=M(v,o);if(n!==-1)return v[n]}e.$db=D;function M(v,o,s=v.length-1){for(let n=s;n>=0;n--){const h=v[n];if(o(h))return n}return-1}e.$eb=M;function g(v,o){const s=L(v,o);return s===-1?void 0:v[s]}e.$fb=g;function L(v,o,s=0,n=v.length){let h=s,$=n;for(;h<$;){const d=Math.floor((h+$)/2);o(v[d])?h=d+1:$=d}return h-1}e.$gb=L;function R(v,o){const s=m(v,o);return s===v.length?void 0:v[s]}e.$hb=R;function m(v,o,s=0,n=v.length){let h=s,$=n;for(;h<$;){const d=Math.floor((h+$)/2);o(v[d])?$=d:h=d+1}return h}e.$ib=m;function k(v,o,s=0,n=v.length){const h=m(v,o,s,n);return h===v.length?-1:h}e.$jb=k;class b{static{this.assertInvariants=!1}constructor(o){this.e=o,this.c=0}findLastMonotonous(o){if(b.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!o(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=o}const s=L(this.e,o,this.c);return this.c=s+1,s===-1?void 0:this.e[s]}}e.$kb=b;function P(v,o){if(v.length===0)return;let s=v[0];for(let n=1;n<v.length;n++){const h=v[n];o(h,s)>0&&(s=h)}return s}e.$lb=P;function I(v,o){if(v.length===0)return;let s=v[0];for(let n=1;n<v.length;n++){const h=v[n];o(h,s)>=0&&(s=h)}return s}e.$mb=I;function p(v,o){return P(v,(s,n)=>-o(s,n))}e.$nb=p;function S(v,o){if(v.length===0)return-1;let s=0;for(let n=1;n<v.length;n++){const h=v[n];o(h,v[s])>0&&(s=n)}return s}e.$ob=S;function C(v,o){for(const s of v){const n=o(s);if(n!==void 0)return n}}e.$pb=C}),define(Se[56],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function D(R,m){const k=Object.create(null);for(const b of R){const P=m(b);let I=k[P];I||(I=k[P]=[]),I.push(b)}return k}e.$I=D;function M(R,m){const k=[],b=[];for(const P of R)m.has(P)||k.push(P);for(const P of m)R.has(P)||b.push(P);return{removed:k,added:b}}e.$J=M;function g(R,m){const k=[],b=[];for(const[P,I]of R)m.has(P)||k.push(I);for(const[P,I]of m)R.has(P)||b.push(I);return{removed:k,added:b}}e.$K=g;class L{constructor(){this.a=new Map}add(m,k){let b=this.a.get(m);b||(b=new Set,this.a.set(m,b)),b.add(k)}delete(m,k){const b=this.a.get(m);b&&(b.delete(k),b.size===0&&this.a.delete(m))}forEach(m,k){const b=this.a.get(m);b&&b.forEach(k)}get(m){const k=this.a.get(m);return k||new Set}}e.$L=L}),define(Se[57],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8g=e.$7g=e.$6g=void 0;function D(R){return(m,k,b)=>{let P=null,I=null;if(typeof b.value=="function"?(P="value",I=b.value):typeof b.get=="function"&&(P="get",I=b.get),!I)throw new Error("not supported");b[P]=R(I,k)}}function M(R,m,k){let b=null,P=null;if(typeof k.value=="function"?(b="value",P=k.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(b="get",P=k.get),!P)throw new Error("not supported");const I=`$memoize$${m}`;k[b]=function(...p){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,p)}),this[I]}}e.$6g=M;function g(R,m,k){return D((b,P)=>{const I=`$debounce$${P}`,p=`$debounce$result$${P}`;return function(...S){this[p]||(this[p]=k?k():void 0),clearTimeout(this[I]),m&&(this[p]=m(this[p],...S),S=[this[p]]),this[I]=setTimeout(()=>{b.apply(this,S),this[p]=k?k():void 0},R)}})}e.$7g=g;function L(R,m,k){return D((b,P)=>{const I=`$throttle$timer$${P}`,p=`$throttle$result$${P}`,S=`$throttle$lastRun$${P}`,C=`$throttle$pending$${P}`;return function(...v){if(this[p]||(this[p]=k?k():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),m&&(this[p]=m(this[p],...v)),this[C])return;const o=this[S]+R;o<=Date.now()?(this[S]=Date.now(),b.apply(this,[this[p]]),this[p]=k?k():void 0):(this[C]=!0,this[I]=setTimeout(()=>{this[C]=!1,this[S]=Date.now(),b.apply(this,[this[p]]),this[p]=k?k():void 0},o-Date.now()))}})}e.$8g=L}),define(Se[8],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?h.isErrorNoTelemetry(t)?new h(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$U=D,e.$V=new D;function M(d){e.$V.setUnexpectedErrorHandler(d)}e.setUnexpectedErrorHandler=M;function g(d){if(!d||typeof d!="object")return!1;const t=d;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$X=g;function L(d){b(d)||e.$V.onUnexpectedError(d)}e.$Y=L;function R(d){b(d)||e.$V.onUnexpectedExternalError(d)}e.$Z=R;function m(d){if(d instanceof Error){const{name:t,message:r}=d,a=d.stacktrace||d.stack;return{$isError:!0,name:t,message:r,stack:a,noTelemetry:h.isErrorNoTelemetry(d)}}return d}e.$1=m;const k="Canceled";function b(d){return d instanceof P?!0:d instanceof Error&&d.name===k&&d.message===k}e.$2=b;class P extends Error{constructor(){super(k),this.name=this.message}}e.$3=P;function I(){const d=new Error(k);return d.name=d.message,d}e.$4=I;function p(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}e.$5=p;function S(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}e.$6=S;class C extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$7=C;function v(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}e.$8=v;class o extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$9=o;class s extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$0=s;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=n;class h extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof h)return t;const r=new h;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$_=h;class $ extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,$.prototype)}}e.$ab=$}),define(Se[19],De([1,0,8,118]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.$5b=e.CompareResult=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.top=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=e.$qb=void 0;function g(te,re=0){return te[te.length-(1+re)]}e.$qb=g;function L(te){if(te.length===0)throw new Error("Invalid tail call");return[te.slice(0,te.length-1),te[te.length-1]]}e.$rb=L;function R(te,re,ne=(Ee,oe)=>Ee===oe){if(te===re)return!0;if(!te||!re||te.length!==re.length)return!1;for(let Ee=0,oe=te.length;Ee<oe;Ee++)if(!ne(te[Ee],re[Ee]))return!1;return!0}e.$sb=R;function m(te,re){const ne=te.length-1;re<ne&&(te[re]=te[ne]),te.pop()}e.$tb=m;function k(te,re,ne){return b(te.length,Ee=>ne(te[Ee],re))}e.$ub=k;function b(te,re){let ne=0,Ee=te-1;for(;ne<=Ee;){const oe=(ne+Ee)/2|0,he=re(oe);if(he<0)ne=oe+1;else if(he>0)Ee=oe-1;else return oe}return-(ne+1)}e.$vb=b;function P(te,re,ne){if(te=te|0,te>=re.length)throw new TypeError("invalid index");const Ee=re[Math.floor(re.length*Math.random())],oe=[],he=[],ee=[];for(const le of re){const be=ne(le,Ee);be<0?oe.push(le):be>0?he.push(le):ee.push(le)}return te<oe.length?P(te,oe,ne):te<oe.length+ee.length?ee[0]:P(te-(oe.length+ee.length),he,ne)}e.$wb=P;function I(te,re){const ne=[];let Ee;for(const oe of te.slice(0).sort(re))!Ee||re(Ee[0],oe)!==0?(Ee=[oe],ne.push(Ee)):Ee.push(oe);return ne}e.$xb=I;function*p(te,re){let ne,Ee;for(const oe of te)Ee!==void 0&&re(Ee,oe)?ne.push(oe):(ne&&(yield ne),ne=[oe]),Ee=oe;ne&&(yield ne)}e.$yb=p;function S(te,re){for(let ne=0;ne<=te.length;ne++)re(ne===0?void 0:te[ne-1],ne===te.length?void 0:te[ne])}e.$zb=S;function C(te,re){for(let ne=0;ne<te.length;ne++)re(ne===0?void 0:te[ne-1],te[ne],ne+1===te.length?void 0:te[ne+1])}e.$Ab=C;function v(te,re,ne){const Ee=[];function oe(le,be,Ie){if(be===0&&Ie.length===0)return;const B=Ee[Ee.length-1];B&&B.start+B.deleteCount===le?(B.deleteCount+=be,B.toInsert.push(...Ie)):Ee.push({start:le,deleteCount:be,toInsert:Ie})}let he=0,ee=0;for(;;){if(he===te.length){oe(he,0,re.slice(ee));break}if(ee===re.length){oe(he,te.length-he,[]);break}const le=te[he],be=re[ee],Ie=ne(le,be);Ie===0?(he+=1,ee+=1):Ie<0?(oe(he,1,[]),he+=1):Ie>0&&(oe(he,0,[be]),ee+=1)}return Ee}e.$Bb=v;function o(te,re,ne){const Ee=v(te,re,ne),oe=[],he=[];for(const ee of Ee)oe.push(...te.slice(ee.start,ee.start+ee.deleteCount)),he.push(...ee.toInsert);return{removed:oe,added:he}}e.$Cb=o;function s(te,re,ne){if(ne===0)return[];const Ee=te.slice(0,ne).sort(re);return h(te,re,Ee,ne,te.length),Ee}e.top=s;function n(te,re,ne,Ee,oe){return ne===0?Promise.resolve([]):new Promise((he,ee)=>{(async()=>{const le=te.length,be=te.slice(0,ne).sort(re);for(let Ie=ne,B=Math.min(ne+Ee,le);Ie<le;Ie=B,B=Math.min(B+Ee,le)){if(Ie>ne&&await new Promise(Q=>setTimeout(Q)),oe&&oe.isCancellationRequested)throw new D.$3;h(te,re,be,Ie,B)}return be})().then(he,ee)})}e.$Eb=n;function h(te,re,ne,Ee,oe){for(const he=ne.length;Ee<oe;Ee++){const ee=te[Ee];if(re(ee,ne[he-1])<0){ne.pop();const le=(0,M.$ib)(ne,be=>re(ee,be)<0);ne.splice(le,0,ee)}}}function $(te){return te.filter(re=>!!re)}e.$Fb=$;function d(te){let re=0;for(let ne=0;ne<te.length;ne++)te[ne]&&(te[re]=te[ne],re+=1);te.length=re}e.$Gb=d;function t(te,re,ne){te.splice(ne,0,te.splice(re,1)[0])}e.$Hb=t;function r(te){return!Array.isArray(te)||te.length===0}e.$Ib=r;function a(te){return Array.isArray(te)&&te.length>0}e.$Jb=a;function i(te,re=ne=>ne){const ne=new Set;return te.filter(Ee=>{const oe=re(Ee);return ne.has(oe)?!1:(ne.add(oe),!0)})}e.$Kb=i;function c(te){const re=new Set;return ne=>{const Ee=te(ne);return re.has(Ee)?!1:(re.add(Ee),!0)}}e.$Lb=c;function f(te,re){return te.length>0?te[0]:re}e.$Mb=f;function y(te,re){return te.length>0?te[te.length-1]:re}e.$Nb=y;function E(te,re,ne=(Ee,oe)=>Ee===oe){let Ee=0;for(let oe=0,he=Math.min(te.length,re.length);oe<he&&ne(te[oe],re[oe]);oe++)Ee++;return Ee}e.$Ob=E;function u(te){return[].concat(...te)}e.$Pb=u;function l(te,re){let ne=typeof re=="number"?te:0;typeof re=="number"?ne=te:(ne=0,re=te);const Ee=[];if(ne<=re)for(let oe=ne;oe<re;oe++)Ee.push(oe);else for(let oe=ne;oe>re;oe--)Ee.push(oe);return Ee}e.$Qb=l;function w(te,re,ne){return te.reduce((Ee,oe)=>(Ee[re(oe)]=ne?ne(oe):oe,Ee),Object.create(null))}e.$Rb=w;function A(te,re){return te.push(re),()=>N(te,re)}e.$Sb=A;function N(te,re){const ne=te.indexOf(re);if(ne>-1)return te.splice(ne,1),re}e.$Tb=N;function O(te,re,ne){const Ee=te.slice(0,re),oe=te.slice(re);return Ee.concat(ne,oe)}e.$Ub=O;function F(te,re){let ne;if(typeof re=="number"){let Ee=re;ne=()=>{const oe=Math.sin(Ee++)*179426549;return oe-Math.floor(oe)}}else ne=Math.random;for(let Ee=te.length-1;Ee>0;Ee-=1){const oe=Math.floor(ne()*(Ee+1)),he=te[Ee];te[Ee]=te[oe],te[oe]=he}}e.$Vb=F;function j(te,re){const ne=te.indexOf(re);ne>-1&&(te.splice(ne,1),te.unshift(re))}e.$Wb=j;function z(te,re){const ne=te.indexOf(re);ne>-1&&(te.splice(ne,1),te.push(re))}e.$Xb=z;function T(te,re){for(const ne of re)te.push(ne)}e.$Yb=T;function H(te,re){return Array.isArray(te)?te.map(re):re(te)}e.$Zb=H;function q(te){return Array.isArray(te)?te:[te]}e.$1b=q;function me(te){return te[Math.floor(Math.random()*te.length)]}e.$2b=me;function X(te,re,ne){const Ee=V(te,re),oe=te.length,he=ne.length;te.length=oe+he;for(let ee=oe-1;ee>=Ee;ee--)te[ee+he]=te[ee];for(let ee=0;ee<he;ee++)te[ee+Ee]=ne[ee]}e.$3b=X;function Z(te,re,ne,Ee){const oe=V(te,re);let he=te.splice(oe,ne);return he===void 0&&(he=[]),X(te,oe,Ee),he}e.$4b=Z;function V(te,re){return re<0?Math.max(re+te.length,0):Math.min(re,te.length)}var x;(function(te){function re(he){return he<0}te.isLessThan=re;function ne(he){return he<=0}te.isLessThanOrEqual=ne;function Ee(he){return he>0}te.isGreaterThan=Ee;function oe(he){return he===0}te.isNeitherLessOrGreaterThan=oe,te.greaterThan=1,te.lessThan=-1,te.neitherLessOrGreaterThan=0})(x||(e.CompareResult=x={}));function ge(te,re){return(ne,Ee)=>re(te(ne),te(Ee))}e.$5b=ge;function ue(...te){return(re,ne)=>{for(const Ee of te){const oe=Ee(re,ne);if(!x.isNeitherLessOrGreaterThan(oe))return oe}return x.neitherLessOrGreaterThan}}e.$6b=ue;const we=(te,re)=>te-re;e.$7b=we;const G=(te,re)=>(0,e.$7b)(te?1:0,re?1:0);e.$8b=G;function U(te){return(re,ne)=>-te(re,ne)}e.$9b=U;class K{constructor(re){this.g=re,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(re){let ne=this.c;for(;ne<this.g.length&&re(this.g[ne]);)ne++;const Ee=ne===this.c?null:this.g.slice(this.c,ne);return this.c=ne,Ee}takeFromEndWhile(re){let ne=this.d;for(;ne>=0&&re(this.g[ne]);)ne--;const Ee=ne===this.d?null:this.g.slice(ne+1,this.d+1);return this.d=ne,Ee}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const re=this.g[this.c];return this.c++,re}removeLast(){const re=this.g[this.d];return this.d--,re}takeCount(re){const ne=this.g.slice(this.c,this.c+re);return this.c+=re,ne}}e.$0b=K;class fe{static{this.empty=new fe(re=>{})}constructor(re){this.iterate=re}forEach(re){this.iterate(ne=>(re(ne),!0))}toArray(){const re=[];return this.iterate(ne=>(re.push(ne),!0)),re}filter(re){return new fe(ne=>this.iterate(Ee=>re(Ee)?ne(Ee):!0))}map(re){return new fe(ne=>this.iterate(Ee=>ne(re(Ee))))}some(re){let ne=!1;return this.iterate(Ee=>(ne=re(Ee),!ne)),ne}findFirst(re){let ne;return this.iterate(Ee=>re(Ee)?(ne=Ee,!1):!0),ne}findLast(re){let ne;return this.iterate(Ee=>(re(Ee)&&(ne=Ee),!0)),ne}findLastMaxBy(re){let ne,Ee=!0;return this.iterate(oe=>((Ee||x.isGreaterThan(re(oe,ne)))&&(Ee=!1,ne=oe),!0)),ne}}e.$$b=fe}),define(Se[58],De([1,0,8]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yc=e.$xc=e.$wc=e.$vc=e.ok=void 0;function M(k,b){if(!k)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=M;function g(k,b="Unreachable"){throw new Error(b)}e.$vc=g;function L(k){if(!k)throw new D.$ab("Assertion Failed")}e.$wc=L;function R(k){if(!k()){debugger;k(),(0,D.$Y)(new D.$ab("Assertion Failed"))}}e.$xc=R;function m(k,b){let P=0;for(;P<k.length-1;){const I=k[P],p=k[P+1];if(!b(I,p))return!1;P++}return!0}e.$yc=m}),define(Se[75],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function D(M){const g=this;let L=!1,R;return function(){return L||(L=!0,R=M.apply(g,arguments)),R}}e.$bb=D}),define(Se[119],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8L=e.$7L=void 0;class D{constructor(g){this.a=g,this.b=0}nextId(){return this.a+ ++this.b}}e.$7L=D,e.$8L=new D("id#")}),define(Se[50],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(M){function g(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}M.is=g;const L=Object.freeze([]);function R(){return L}M.empty=R;function*m(d){yield d}M.single=m;function k(d){return g(d)?d:m(d)}M.wrap=k;function b(d){return d||L}M.from=b;function*P(d){for(let t=d.length-1;t>=0;t--)yield d[t]}M.reverse=P;function I(d){return!d||d[Symbol.iterator]().next().done===!0}M.isEmpty=I;function p(d){return d[Symbol.iterator]().next().value}M.first=p;function S(d,t){for(const r of d)if(t(r))return!0;return!1}M.some=S;function C(d,t){for(const r of d)if(t(r))return r}M.find=C;function*v(d,t){for(const r of d)t(r)&&(yield r)}M.filter=v;function*o(d,t){let r=0;for(const a of d)yield t(a,r++)}M.map=o;function*s(...d){for(const t of d)for(const r of t)yield r}M.concat=s;function n(d,t,r){let a=r;for(const i of d)a=t(a,i);return a}M.reduce=n;function*h(d,t,r=d.length){for(t<0&&(t+=d.length),r<0?r+=d.length:r>d.length&&(r=d.length);t<r;t++)yield d[t]}M.slice=h;function $(d,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,d];const a=d[Symbol.iterator]();for(let i=0;i<t;i++){const c=a.next();if(c.done)return[r,M.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return a}}]}M.consume=$})(D||(e.Iterable=D={}))}),define(Se[157],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var g;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(g||(e.ParseErrorCode=g={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function R(t,r=!1){let a=0;const i=t.length;let c="",f=0,y=16,E=0;function u(j){let z=0,T=0;for(;z<j;){const H=t.charCodeAt(a);if(H>=48&&H<=57)T=T*16+H-48;else if(H>=65&&H<=70)T=T*16+H-65+10;else if(H>=97&&H<=102)T=T*16+H-97+10;else break;a++,z++}return z<j&&(T=-1),T}function l(j){a=j,c="",f=0,y=16,E=0}function w(){const j=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&b(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&b(t.charCodeAt(a)))for(a++;a<t.length&&b(t.charCodeAt(a));)a++;else return E=3,t.substring(j,a);let z=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&b(t.charCodeAt(a))){for(a++;a<t.length&&b(t.charCodeAt(a));)a++;z=a}else E=3;return t.substring(j,z)}function A(){let j="",z=a;for(;;){if(a>=i){j+=t.substring(z,a),E=2;break}const T=t.charCodeAt(a);if(T===34){j+=t.substring(z,a),a++;break}if(T===92){if(j+=t.substring(z,a),a++,a>=i){E=2;break}switch(t.charCodeAt(a++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const q=u(4);q>=0?j+=String.fromCharCode(q):E=4;break}default:E=5}z=a;continue}if(T>=0&&T<=31)if(k(T)){j+=t.substring(z,a),E=2;break}else E=6;a++}return j}function N(){if(c="",E=0,f=a,a>=i)return f=i,y=17;let j=t.charCodeAt(a);if(m(j)){do a++,c+=String.fromCharCode(j),j=t.charCodeAt(a);while(m(j));return y=15}if(k(j))return a++,c+=String.fromCharCode(j),j===13&&t.charCodeAt(a)===10&&(a++,c+=`
`),y=14;switch(j){case 123:return a++,y=1;case 125:return a++,y=2;case 91:return a++,y=3;case 93:return a++,y=4;case 58:return a++,y=6;case 44:return a++,y=5;case 34:return a++,c=A(),y=10;case 47:{const z=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<i&&!k(t.charCodeAt(a));)a++;return c=t.substring(z,a),y=12}if(t.charCodeAt(a+1)===42){a+=2;const T=i-1;let H=!1;for(;a<T;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,H=!0;break}a++}return H||(a++,E=1),c=t.substring(z,a),y=13}return c+=String.fromCharCode(j),a++,y=16}case 45:if(c+=String.fromCharCode(j),a++,a===i||!b(t.charCodeAt(a)))return y=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=w(),y=11;default:for(;a<i&&O(j);)a++,j=t.charCodeAt(a);if(f!==a){switch(c=t.substring(f,a),c){case"true":return y=8;case"false":return y=9;case"null":return y=7}return y=16}return c+=String.fromCharCode(j),a++,y=16}}function O(j){if(m(j)||k(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let j;do j=N();while(j>=12&&j<=15);return j}return{setPosition:l,getPosition:()=>a,scan:r?F:N,getToken:()=>y,getTokenValue:()=>c,getTokenOffset:()=>f,getTokenLength:()=>a-f,getTokenError:()=>E}}e.$Jm=R;function m(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function k(t){return t===10||t===13||t===8232||t===8233}function b(t){return t>=48&&t<=57}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function I(t,r){const a=[],i=new Object;let c;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let y=!1;function E(u,l,w,A){f.value=u,f.offset=l,f.length=w,f.type=A,f.colonOffset=void 0,c=f}try{h(t,{onObjectBegin:(u,l)=>{if(r<=u)throw i;c=void 0,y=r>u,a.push("")},onObjectProperty:(u,l,w)=>{if(r<l||(E(u,l,w,"property"),a[a.length-1]=u,r<=l+w))throw i},onObjectEnd:(u,l)=>{if(r<=u)throw i;c=void 0,a.pop()},onArrayBegin:(u,l)=>{if(r<=u)throw i;c=void 0,a.push(0)},onArrayEnd:(u,l)=>{if(r<=u)throw i;c=void 0,a.pop()},onLiteralValue:(u,l,w)=>{if(r<l||(E(u,l,w,d(u)),r<=l+w))throw i},onSeparator:(u,l,w)=>{if(r<=l)throw i;if(u===":"&&c&&c.type==="property")c.colonOffset=l,y=!1,c=void 0;else if(u===","){const A=a[a.length-1];typeof A=="number"?a[a.length-1]=A+1:(y=!0,a[a.length-1]=""),c=void 0}}})}catch(u){if(u!==i)throw u}return{path:a,previousNode:c,isAtPropertyKey:y,matches:u=>{let l=0;for(let w=0;l<u.length&&w<a.length;w++)if(u[l]===a[w]||u[l]==="*")l++;else if(u[l]!=="**")return!1;return l===u.length}}}e.$Km=I;function p(t,r=[],a=L.DEFAULT){let i=null,c=[];const f=[];function y(u){Array.isArray(c)?c.push(u):i!==null&&(c[i]=u)}return h(t,{onObjectBegin:()=>{const u={};y(u),f.push(c),c=u,i=null},onObjectProperty:u=>{i=u},onObjectEnd:()=>{c=f.pop()},onArrayBegin:()=>{const u=[];y(u),f.push(c),c=u,i=null},onArrayEnd:()=>{c=f.pop()},onLiteralValue:y,onError:(u,l,w)=>{r.push({error:u,offset:l,length:w})}},a),c[0]}e.$Lm=p;function S(t,r=[],a=L.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(u){i.type==="property"&&(i.length=u-i.offset,i=i.parent)}function f(u){return i.children.push(u),u}h(t,{onObjectBegin:u=>{i=f({type:"object",offset:u,length:-1,parent:i,children:[]})},onObjectProperty:(u,l,w)=>{i=f({type:"property",offset:l,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:u,offset:l,length:w,parent:i})},onObjectEnd:(u,l)=>{i.length=u+l-i.offset,i=i.parent,c(u+l)},onArrayBegin:(u,l)=>{i=f({type:"array",offset:u,length:-1,parent:i,children:[]})},onArrayEnd:(u,l)=>{i.length=u+l-i.offset,i=i.parent,c(u+l)},onLiteralValue:(u,l,w)=>{f({type:d(u),offset:l,length:w,parent:i,value:u}),c(l+w)},onSeparator:(u,l,w)=>{i.type==="property"&&(u===":"?i.colonOffset=l:u===","&&c(l))},onError:(u,l,w)=>{r.push({error:u,offset:l,length:w})}},a);const E=i.children[0];return E&&delete E.parent,E}e.$Mm=S;function C(t,r){if(!t)return;let a=t;for(const i of r)if(typeof i=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let c=!1;for(const f of a.children)if(Array.isArray(f.children)&&f.children[0].value===i){a=f.children[1],c=!0;break}if(!c)return}else{const c=i;if(a.type!=="array"||c<0||!Array.isArray(a.children)||c>=a.children.length)return;a=a.children[c]}return a}e.$Nm=C;function v(t){if(!t.parent||!t.parent.children)return[];const r=v(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;r.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&r.push(a)}return r}e.$Om=v;function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const r=Object.create(null);for(const a of t.children){const i=a.children[1];i&&(r[a.children[0].value]=o(i))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Pm=o;function s(t,r,a=!1){return r>=t.offset&&r<t.offset+t.length||a&&r===t.offset+t.length}e.$Qm=s;function n(t,r,a=!1){if(s(t,r,a)){const i=t.children;if(Array.isArray(i))for(let c=0;c<i.length&&i[c].offset<=r;c++){const f=n(i[c],r,a);if(f)return f}return t}}e.$Rm=n;function h(t,r,a=L.DEFAULT){const i=R(t,!1);function c(ge){return ge?()=>ge(i.getTokenOffset(),i.getTokenLength()):()=>!0}function f(ge){return ge?ue=>ge(ue,i.getTokenOffset(),i.getTokenLength()):()=>!0}const y=c(r.onObjectBegin),E=f(r.onObjectProperty),u=c(r.onObjectEnd),l=c(r.onArrayBegin),w=c(r.onArrayEnd),A=f(r.onLiteralValue),N=f(r.onSeparator),O=c(r.onComment),F=f(r.onError),j=a&&a.disallowComments,z=a&&a.allowTrailingComma;function T(){for(;;){const ge=i.scan();switch(i.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:j||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(ge){case 12:case 13:j?H(10):O();break;case 16:H(1);break;case 15:case 14:break;default:return ge}}}function H(ge,ue=[],we=[]){if(F(ge),ue.length+we.length>0){let G=i.getToken();for(;G!==17;){if(ue.indexOf(G)!==-1){T();break}else if(we.indexOf(G)!==-1)break;G=T()}}}function q(ge){const ue=i.getTokenValue();return ge?A(ue):E(ue),T(),!0}function me(){switch(i.getToken()){case 11:{let ge=0;try{ge=JSON.parse(i.getTokenValue()),typeof ge!="number"&&(H(2),ge=0)}catch{H(2)}A(ge);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return T(),!0}function X(){return i.getToken()!==10?(H(3,[],[2,5]),!1):(q(!1),i.getToken()===6?(N(":"),T(),x()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function Z(){y(),T();let ge=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ge||H(4,[],[]),N(","),T(),i.getToken()===2&&z)break}else ge&&H(6,[],[]);X()||H(4,[],[2,5]),ge=!0}return u(),i.getToken()!==2?H(7,[2],[]):T(),!0}function V(){l(),T();let ge=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ge||H(4,[],[]),N(","),T(),i.getToken()===4&&z)break}else ge&&H(6,[],[]);x()||H(4,[],[4,5]),ge=!0}return w(),i.getToken()!==4?H(8,[4],[]):T(),!0}function x(){switch(i.getToken()){case 3:return V();case 1:return Z();case 10:return q(!0);default:return me()}}return T(),i.getToken()===17?a.allowEmptyContent?!0:(H(4,[],[]),!1):x()?(i.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.$Sm=h;function $(t,r){const a=R(t),i=[];let c,f=0,y;do switch(y=a.getPosition(),c=a.scan(),c){case 12:case 13:case 17:f!==y&&i.push(t.substring(f,y)),r!==void 0&&i.push(a.getTokenValue().replace(/[^\r\n]/g,r)),f=a.getPosition();break}while(c!==17);return i.join("")}e.$Tm=$;function d(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Um=d}),define(Se[59],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class D{constructor(g){this.d=g,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(g){this.c=g}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=D}),define(Se[3],De([1,0,19,56,75,50]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.$bc=e.$ac=e.$_b=void 0;const R=!1;let m=null;class k{constructor(){this.b=new Map}static{this.a=0}c(l){let w=this.b.get(l);return w||(w={parent:null,source:null,isSingleton:!1,value:l,idx:k.a++},this.b.set(l,w)),w}trackDisposable(l){const w=this.c(l);w.source||(w.source=new Error().stack)}setParent(l,w){const A=this.c(l);A.parent=w}markAsDisposed(l){this.b.delete(l)}markAsSingleton(l){this.c(l).isSingleton=!0}f(l,w){const A=w.get(l);if(A)return A;const N=l.parent?this.f(this.c(l.parent),w):l;return w.set(l,N),N}getTrackedDisposables(){const l=new Map;return[...this.b.entries()].filter(([,A])=>A.source!==null&&!this.f(A,l).isSingleton).map(([A])=>A).flat()}computeLeakingDisposables(l=10,w){let A;if(w)A=w;else{const z=new Map,T=[...this.b.values()].filter(q=>q.source!==null&&!this.f(q,z).isSingleton);if(T.length===0)return;const H=new Set(T.map(q=>q.value));if(A=T.filter(q=>!(q.parent&&H.has(q.parent))),A.length===0)throw new Error("There are cyclic diposable chains!")}if(!A)return;function N(z){function T(q,me){for(;q.length>0&&me.some(X=>typeof X=="string"?X===q[0]:q[0].match(X));)q.shift()}const H=z.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return T(H,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),H.reverse()}const O=new M.$L;for(const z of A){const T=N(z);for(let H=0;H<=T.length;H++)O.add(T.slice(0,H).join(`
`),z)}A.sort((0,D.$5b)(z=>z.idx,D.$7b));let F="",j=0;for(const z of A.slice(0,l)){j++;const T=N(z),H=[];for(let q=0;q<T.length;q++){let me=T[q];me=`(shared with ${O.get(T.slice(0,q+1).join(`
`)).size}/${A.length} leaks) at ${me}`;const Z=O.get(T.slice(0,q).join(`
`)),V=(0,M.$I)([...Z].map(x=>N(x)[q]),x=>x);delete V[T[q]];for(const[x,ge]of Object.entries(V))H.unshift(`    - stacktraces of ${ge.length} other leaks continue with ${x}`);H.unshift(me)}F+=`


==================== Leaking disposable ${j}/${A.length}: ${z.value.constructor.name} ====================
${H.join(`
`)}
============================================================

`}return A.length>l&&(F+=`


... and ${A.length-l} more leaking disposables

`),{leaks:A,details:F}}}e.$_b=k;function b(u){m=u}if(e.$ac=b,R){const u="__is_disposable_tracked__";b(new class{trackDisposable(l){const w=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[u]||console.log(w)},3e3)}setParent(l,w){if(l&&l!==d.None)try{l[u]=!0}catch{}}markAsDisposed(l){if(l&&l!==d.None)try{l[u]=!0}catch{}}markAsSingleton(l){}})}function P(u){return m?.trackDisposable(u),u}e.$bc=P;function I(u){m?.markAsDisposed(u)}e.$cc=I;function p(u,l){m?.setParent(u,l)}function S(u,l){if(m)for(const w of u)m.setParent(w,l)}function C(u){return m?.markAsSingleton(u),u}e.$dc=C;function v(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.$ec=v;function o(u){if(L.Iterable.is(u)){const l=[];for(const w of u)if(w)try{w.dispose()}catch(A){l.push(A)}if(l.length===1)throw l[0];if(l.length>1)throw new AggregateError(l,"Encountered errors while disposing of store");return Array.isArray(u)?[]:u}else if(u)return u.dispose(),u}e.$fc=o;function s(u){for(const l of u)v(l)&&l.dispose();return[]}e.$gc=s;function n(...u){const l=h(()=>o(u));return S(u,l),l}e.$hc=n;function h(u){const l=P({dispose:(0,g.$bb)(()=>{I(l),u()})});return l}e.$ic=h;class ${static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(I(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return p(l,this),this.g?$.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(l),l}}e.$jc=$;class d{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new $,P(this),p(this.q,this)}dispose(){I(this),this.q.dispose()}B(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(l)}}e.$kc=d;class t{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(l){this.b||l===this.a||(this.a?.dispose(),l&&p(l,this),this.a=l)}clear(){this.value=void 0}dispose(){this.b=!0,I(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const l=this.a;return this.a=void 0,l&&p(l,null),l}}e.$lc=t;class r{constructor(l){this.b=l,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$mc=r;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(l){let w=l;return this.unset=()=>w=void 0,this.isset=()=>w!==void 0,this.dispose=()=>{w&&(w(),w=void 0,I(this))},this}}e.$nc=a;class i{constructor(){this.a=new Map}acquire(l,...w){let A=this.a.get(l);A||(A={counter:0,object:this.b(l,...w)},this.a.set(l,A));const{object:N}=A,O=(0,g.$bb)(()=>{--A.counter===0&&(this.c(l,A.object),this.a.delete(l))});return A.counter++,{object:N,dispose:O}}}e.$oc=i;class c{constructor(l){this.a=l}async acquire(l,...w){const A=this.a.acquire(l,...w);try{return{object:await A.object,dispose:()=>A.dispose()}}catch(N){throw A.dispose(),N}}}e.$pc=c;class f{constructor(l){this.object=l}dispose(){}}e.$qc=f;function y(u){const l=new $;try{u(l)}finally{l.dispose()}}e.$rc=y;class E{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){I(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(l){return this.a.has(l)}get size(){return this.a.size}get(l){return this.a.get(l)}set(l,w,A=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),A||this.a.get(l)?.dispose(),this.a.set(l,w)}deleteAndDispose(l){this.a.get(l)?.dispose(),this.a.delete(l)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$sc=E}),define(Se[76],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=void 0;class D{static{this.Undefined=new D(void 0)}constructor(L){this.element=L,this.next=D.Undefined,this.prev=D.Undefined}}class M{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let L=this.a;for(;L!==D.Undefined;){const R=L.next;L.prev=D.Undefined,L.next=D.Undefined,L=R}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,R){const m=new D(L);if(this.a===D.Undefined)this.a=m,this.b=m;else if(R){const b=this.b;this.b=m,m.prev=b,b.next=m}else{const b=this.a;this.a=m,m.next=b,b.prev=m}this.c+=1;let k=!1;return()=>{k||(k=!0,this.e(m))}}shift(){if(this.a!==D.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==D.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==D.Undefined&&L.next!==D.Undefined){const R=L.prev;R.next=L.next,L.next.prev=R}else L.prev===D.Undefined&&L.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):L.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):L.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==D.Undefined;)yield L.element,L=L.next}}e.$tc=M}),define(Se[28],De([1,0]),function($e,e){"use strict";var D,M,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.Touch=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=void 0;function L(s,n,h){let $=s.get(n);return $===void 0&&($=h,s.set(n,$)),$}e.$wi=L;function R(s){const n=[];return s.forEach((h,$)=>{n.push(`${$} => ${h}`)}),`Map(${s.size}) {${n.join(", ")}}`}e.$xi=R;function m(s){const n=[];return s.forEach(h=>{n.push(h)}),`Set(${s.size}) {${n.join(", ")}}`}e.$yi=m;class k{constructor(n,h){this.uri=n,this.value=h}}function b(s){return Array.isArray(s)}class P{static{this.a=n=>n.toString()}constructor(n,h){if(this[D]="ResourceMap",n instanceof P)this.b=new Map(n.b),this.c=h??P.a;else if(b(n)){this.b=new Map,this.c=h??P.a;for(const[$,d]of n)this.set($,d)}else this.b=new Map,this.c=n??P.a}set(n,h){return this.b.set(this.c(n),new k(n,h)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,h){typeof h<"u"&&(n=n.bind(h));for(const[$,d]of this.b)n(d.value,d.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}e.$zi=P;class I{constructor(n,h){this[M]="ResourceSet",!n||typeof n=="function"?this.a=new P(n):(this.a=new P(h),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,h){this.a.forEach(($,d)=>n.call(h,d,d,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ai=I;var p;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class S{constructor(){this[g]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,h=0){const $=this.a.get(n);if($)return h!==0&&this.j($,h),$.value}set(n,h,$=0){let d=this.a.get(n);if(d)d.value=h,$!==0&&this.j(d,$);else{switch(d={key:n,value:h,next:void 0,previous:void 0},$){case 0:this.h(d);break;case 1:this.g(d);break;case 2:this.h(d);break;default:this.h(d);break}this.a.set(n,d),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const h=this.a.get(n);if(h)return this.a.delete(n),this.i(h),this.d--,h.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,h){const $=this.e;let d=this.b;for(;d;){if(h?n.bind(h)(d.value,d.key,this):n(d.value,d.key,this),this.e!==$)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const n=this,h=this.e;let $=this.b;const d={[Symbol.iterator](){return d},next(){if(n.e!==h)throw new Error("LinkedMap got modified during iteration.");if($){const t={value:$.key,done:!1};return $=$.next,t}else return{value:void 0,done:!0}}};return d}values(){const n=this,h=this.e;let $=this.b;const d={[Symbol.iterator](){return d},next(){if(n.e!==h)throw new Error("LinkedMap got modified during iteration.");if($){const t={value:$.value,done:!1};return $=$.next,t}else return{value:void 0,done:!0}}};return d}entries(){const n=this,h=this.e;let $=this.b;const d={[Symbol.iterator](){return d},next(){if(n.e!==h)throw new Error("LinkedMap got modified during iteration.");if($){const t={value:[$.key,$.value],done:!1};return $=$.next,t}else return{value:void 0,done:!0}}};return d}[(g=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let h=this.b,$=this.size;for(;h&&$>n;)this.a.delete(h.key),h=h.next,$--;this.b=h,this.d=$,h&&(h.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const h=n.next,$=n.previous;if(!h||!$)throw new Error("Invalid list");h.previous=$,$.next=h}n.next=void 0,n.previous=void 0,this.e++}j(n,h){if(!this.b||!this.c)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(n===this.b)return;const $=n.next,d=n.previous;n===this.c?(d.next=void 0,this.c=d):($.previous=d,d.next=$),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(h===2){if(n===this.c)return;const $=n.next,d=n.previous;n===this.b?($.previous=void 0,this.b=$):($.previous=d,d.next=$),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((h,$)=>{n.push([$,h])}),n}fromJSON(n){this.clear();for(const[h,$]of n)this.set(h,$)}}e.$Bi=S;class C extends S{constructor(n,h=1){super(),this.k=n,this.l=Math.min(Math.max(0,h),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,h=2){return super.get(n,h)}peek(n){return super.get(n,0)}set(n,h){return super.set(n,h,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Ci=C;class v{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let h=this.a.get(n)||0;return h===0?!1:(h--,h===0?this.a.delete(n):this.a.set(n,h),!0)}has(n){return this.a.has(n)}}e.$Di=v;class o{constructor(n){if(this.a=new Map,this.b=new Map,n)for(const[h,$]of n)this.set(h,$)}clear(){this.a.clear(),this.b.clear()}set(n,h){this.a.set(n,h),this.b.set(h,n)}get(n){return this.a.get(n)}getKey(n){return this.b.get(n)}delete(n){const h=this.a.get(n);return h===void 0?!1:(this.a.delete(n),this.b.delete(h),!0)}forEach(n,h){this.a.forEach(($,d)=>{n.call(h,$,d,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ei=o}),function($e,e){typeof define=="function"&&define.amd?define(Se[158],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(re,ne){for(var Ee=0;Ee<ne.length;Ee++){var oe=ne[Ee];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(re,oe.key,oe)}}function D(re,ne,Ee){return ne&&e(re.prototype,ne),Ee&&e(re,Ee),Object.defineProperty(re,"prototype",{writable:!1}),re}function M(re,ne){if(re){if(typeof re=="string")return g(re,ne);var Ee=Object.prototype.toString.call(re).slice(8,-1);if(Ee==="Object"&&re.constructor&&(Ee=re.constructor.name),Ee==="Map"||Ee==="Set")return Array.from(re);if(Ee==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ee))return g(re,ne)}}function g(re,ne){(ne==null||ne>re.length)&&(ne=re.length);for(var Ee=0,oe=new Array(ne);Ee<ne;Ee++)oe[Ee]=re[Ee];return oe}function L(re,ne){var Ee=typeof Symbol<"u"&&re[Symbol.iterator]||re["@@iterator"];if(Ee)return(Ee=Ee.call(re)).next.bind(Ee);if(Array.isArray(re)||(Ee=M(re))||ne&&re&&typeof re.length=="number"){Ee&&(re=Ee);var oe=0;return function(){return oe>=re.length?{done:!0}:{done:!1,value:re[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=R();function m(re){$e.defaults=re}var k=/[&<>"']/,b=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(ne){return p[ne]};function C(re,ne){if(ne){if(k.test(re))return re.replace(b,S)}else if(P.test(re))return re.replace(I,S);return re}var v=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(re){return re.replace(v,function(ne,Ee){return Ee=Ee.toLowerCase(),Ee==="colon"?":":Ee.charAt(0)==="#"?Ee.charAt(1)==="x"?String.fromCharCode(parseInt(Ee.substring(2),16)):String.fromCharCode(+Ee.substring(1)):""})}var s=/(^|[^\[])\^/g;function n(re,ne){re=typeof re=="string"?re:re.source,ne=ne||"";var Ee={replace:function(he,ee){return ee=ee.source||ee,ee=ee.replace(s,"$1"),re=re.replace(he,ee),Ee},getRegex:function(){return new RegExp(re,ne)}};return Ee}var h=/[^\w:]/g,$=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(re,ne,Ee){if(re){var oe;try{oe=decodeURIComponent(o(Ee)).replace(h,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}ne&&!$.test(Ee)&&(Ee=c(ne,Ee));try{Ee=encodeURI(Ee).replace(/%25/g,"%")}catch{return null}return Ee}var t={},r=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(re,ne){t[" "+re]||(r.test(re)?t[" "+re]=re+"/":t[" "+re]=u(re,"/",!0)),re=t[" "+re];var Ee=re.indexOf(":")===-1;return ne.substring(0,2)==="//"?Ee?ne:re.replace(a,"$1")+ne:ne.charAt(0)==="/"?Ee?ne:re.replace(i,"$1")+ne:re+ne}var f={exec:function(){}};function y(re){for(var ne=1,Ee,oe;ne<arguments.length;ne++){Ee=arguments[ne];for(oe in Ee)Object.prototype.hasOwnProperty.call(Ee,oe)&&(re[oe]=Ee[oe])}return re}function E(re,ne){var Ee=re.replace(/\|/g,function(ee,le,be){for(var Ie=!1,B=le;--B>=0&&be[B]==="\\";)Ie=!Ie;return Ie?"|":" |"}),oe=Ee.split(/ \|/),he=0;if(oe[0].trim()||oe.shift(),oe.length>0&&!oe[oe.length-1].trim()&&oe.pop(),oe.length>ne)oe.splice(ne);else for(;oe.length<ne;)oe.push("");for(;he<oe.length;he++)oe[he]=oe[he].trim().replace(/\\\|/g,"|");return oe}function u(re,ne,Ee){var oe=re.length;if(oe===0)return"";for(var he=0;he<oe;){var ee=re.charAt(oe-he-1);if(ee===ne&&!Ee)he++;else if(ee!==ne&&Ee)he++;else break}return re.slice(0,oe-he)}function l(re,ne){if(re.indexOf(ne[1])===-1)return-1;for(var Ee=re.length,oe=0,he=0;he<Ee;he++)if(re[he]==="\\")he++;else if(re[he]===ne[0])oe++;else if(re[he]===ne[1]&&(oe--,oe<0))return he;return-1}function w(re){re&&re.sanitize&&!re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(re,ne){if(ne<1)return"";for(var Ee="";ne>1;)ne&1&&(Ee+=re),ne>>=1,re+=re;return Ee+re}function N(re,ne,Ee,oe){var he=ne.href,ee=ne.title?C(ne.title):null,le=re[1].replace(/\\([\[\]])/g,"$1");if(re[0].charAt(0)!=="!"){oe.state.inLink=!0;var be={type:"link",raw:Ee,href:he,title:ee,text:le,tokens:oe.inlineTokens(le)};return oe.state.inLink=!1,be}return{type:"image",raw:Ee,href:he,title:ee,text:C(le)}}function O(re,ne){var Ee=re.match(/^(\s+)(?:```)/);if(Ee===null)return ne;var oe=Ee[1];return ne.split(`
`).map(function(he){var ee=he.match(/^\s+/);if(ee===null)return he;var le=ee[0];return le.length>=oe.length?he.slice(oe.length):he}).join(`
`)}var F=function(){function re(Ee){this.options=Ee||$e.defaults}var ne=re.prototype;return ne.space=function(oe){var he=this.rules.block.newline.exec(oe);if(he&&he[0].length>0)return{type:"space",raw:he[0]}},ne.code=function(oe){var he=this.rules.block.code.exec(oe);if(he){var ee=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:u(ee,`
`)}}},ne.fences=function(oe){var he=this.rules.block.fences.exec(oe);if(he){var ee=he[0],le=O(ee,he[3]||"");return{type:"code",raw:ee,lang:he[2]?he[2].trim():he[2],text:le}}},ne.heading=function(oe){var he=this.rules.block.heading.exec(oe);if(he){var ee=he[2].trim();if(/#$/.test(ee)){var le=u(ee,"#");(this.options.pedantic||!le||/ $/.test(le))&&(ee=le.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:ee,tokens:this.lexer.inline(ee)}}},ne.hr=function(oe){var he=this.rules.block.hr.exec(oe);if(he)return{type:"hr",raw:he[0]}},ne.blockquote=function(oe){var he=this.rules.block.blockquote.exec(oe);if(he){var ee=he[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:he[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},ne.list=function(oe){var he=this.rules.block.list.exec(oe);if(he){var ee,le,be,Ie,B,Q,ie,se,Y,de,ye,je,We=he[1].trim(),_e=We.length>1,Ye={type:"list",raw:"",ordered:_e,start:_e?+We.slice(0,-1):"",loose:!1,items:[]};We=_e?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=_e?We:"[*+-]");for(var it=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");oe&&(je=!1,!(!(he=it.exec(oe))||this.rules.block.hr.test(oe)));){if(ee=he[0],oe=oe.substring(ee.length),se=he[2].split(`
`,1)[0],Y=oe.split(`
`,1)[0],this.options.pedantic?(Ie=2,ye=se.trimLeft()):(Ie=he[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ye=se.slice(Ie),Ie+=he[1].length),Q=!1,!se&&/^ *$/.test(Y)&&(ee+=Y+`
`,oe=oe.substring(Y.length+1),je=!0),!je)for(var et=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ae=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Oe=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),Ve=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");oe&&(de=oe.split(`
`,1)[0],se=de,this.options.pedantic&&(se=se.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Oe.test(se)||Ve.test(se)||et.test(se)||Ae.test(oe)));){if(se.search(/[^ ]/)>=Ie||!se.trim())ye+=`
`+se.slice(Ie);else if(!Q)ye+=`
`+se;else break;!Q&&!se.trim()&&(Q=!0),ee+=de+`
`,oe=oe.substring(de.length+1)}Ye.loose||(ie?Ye.loose=!0:/\n *\n *$/.test(ee)&&(ie=!0)),this.options.gfm&&(le=/^\[[ xX]\] /.exec(ye),le&&(be=le[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:ee,task:!!le,checked:be,loose:!1,text:ye}),Ye.raw+=ee}Ye.items[Ye.items.length-1].raw=ee.trimRight(),Ye.items[Ye.items.length-1].text=ye.trimRight(),Ye.raw=Ye.raw.trimRight();var Le=Ye.items.length;for(B=0;B<Le;B++){this.lexer.state.top=!1,Ye.items[B].tokens=this.lexer.blockTokens(Ye.items[B].text,[]);var Ze=Ye.items[B].tokens.filter(function(ae){return ae.type==="space"}),ce=Ze.every(function(ae){for(var Ce=ae.raw.split(""),qe=0,Ue=L(Ce),Xe;!(Xe=Ue()).done;){var rt=Xe.value;if(rt===`
`&&(qe+=1),qe>1)return!0}return!1});!Ye.loose&&Ze.length&&ce&&(Ye.loose=!0,Ye.items[B].loose=!0)}return Ye}},ne.html=function(oe){var he=this.rules.block.html.exec(oe);if(he){var ee={type:"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:he[0]};if(this.options.sanitize){var le=this.options.sanitizer?this.options.sanitizer(he[0]):C(he[0]);ee.type="paragraph",ee.text=le,ee.tokens=this.lexer.inline(le)}return ee}},ne.def=function(oe){var he=this.rules.block.def.exec(oe);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var ee=he[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:he[0],href:he[2],title:he[3]}}},ne.table=function(oe){var he=this.rules.block.table.exec(oe);if(he){var ee={type:"table",header:E(he[1]).map(function(ie){return{text:ie}}),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:he[3]&&he[3].trim()?he[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=he[0];var le=ee.align.length,be,Ie,B,Q;for(be=0;be<le;be++)/^ *-+: *$/.test(ee.align[be])?ee.align[be]="right":/^ *:-+: *$/.test(ee.align[be])?ee.align[be]="center":/^ *:-+ *$/.test(ee.align[be])?ee.align[be]="left":ee.align[be]=null;for(le=ee.rows.length,be=0;be<le;be++)ee.rows[be]=E(ee.rows[be],ee.header.length).map(function(ie){return{text:ie}});for(le=ee.header.length,Ie=0;Ie<le;Ie++)ee.header[Ie].tokens=this.lexer.inline(ee.header[Ie].text);for(le=ee.rows.length,Ie=0;Ie<le;Ie++)for(Q=ee.rows[Ie],B=0;B<Q.length;B++)Q[B].tokens=this.lexer.inline(Q[B].text);return ee}}},ne.lheading=function(oe){var he=this.rules.block.lheading.exec(oe);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1],tokens:this.lexer.inline(he[1])}},ne.paragraph=function(oe){var he=this.rules.block.paragraph.exec(oe);if(he){var ee=he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1];return{type:"paragraph",raw:he[0],text:ee,tokens:this.lexer.inline(ee)}}},ne.text=function(oe){var he=this.rules.block.text.exec(oe);if(he)return{type:"text",raw:he[0],text:he[0],tokens:this.lexer.inline(he[0])}},ne.escape=function(oe){var he=this.rules.inline.escape.exec(oe);if(he)return{type:"escape",raw:he[0],text:C(he[1])}},ne.tag=function(oe){var he=this.rules.inline.tag.exec(oe);if(he)return!this.lexer.state.inLink&&/^<a /i.test(he[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(he[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):C(he[0]):he[0]}},ne.link=function(oe){var he=this.rules.inline.link.exec(oe);if(he){var ee=he[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var le=u(ee.slice(0,-1),"\\");if((ee.length-le.length)%2===0)return}else{var be=l(he[2],"()");if(be>-1){var Ie=he[0].indexOf("!")===0?5:4,B=Ie+he[1].length+be;he[2]=he[2].substring(0,be),he[0]=he[0].substring(0,B).trim(),he[3]=""}}var Q=he[2],ie="";if(this.options.pedantic){var se=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Q);se&&(Q=se[1],ie=se[3])}else ie=he[3]?he[3].slice(1,-1):"";return Q=Q.trim(),/^</.test(Q)&&(this.options.pedantic&&!/>$/.test(ee)?Q=Q.slice(1):Q=Q.slice(1,-1)),N(he,{href:Q&&Q.replace(this.rules.inline._escapes,"$1"),title:ie&&ie.replace(this.rules.inline._escapes,"$1")},he[0],this.lexer)}},ne.reflink=function(oe,he){var ee;if((ee=this.rules.inline.reflink.exec(oe))||(ee=this.rules.inline.nolink.exec(oe))){var le=(ee[2]||ee[1]).replace(/\s+/g," ");if(le=he[le.toLowerCase()],!le||!le.href){var be=ee[0].charAt(0);return{type:"text",raw:be,text:be}}return N(ee,le,ee[0],this.lexer)}},ne.emStrong=function(oe,he,ee){ee===void 0&&(ee="");var le=this.rules.inline.emStrong.lDelim.exec(oe);if(le&&!(le[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var be=le[1]||le[2]||"";if(!be||be&&(ee===""||this.rules.inline.punctuation.exec(ee))){var Ie=le[0].length-1,B,Q,ie=Ie,se=0,Y=le[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Y.lastIndex=0,he=he.slice(-1*oe.length+Ie);(le=Y.exec(he))!=null;)if(B=le[1]||le[2]||le[3]||le[4]||le[5]||le[6],!!B){if(Q=B.length,le[3]||le[4]){ie+=Q;continue}else if((le[5]||le[6])&&Ie%3&&!((Ie+Q)%3)){se+=Q;continue}if(ie-=Q,!(ie>0)){if(Q=Math.min(Q,Q+ie+se),Math.min(Ie,Q)%2){var de=oe.slice(1,Ie+le.index+Q);return{type:"em",raw:oe.slice(0,Ie+le.index+Q+1),text:de,tokens:this.lexer.inlineTokens(de)}}var ye=oe.slice(2,Ie+le.index+Q-1);return{type:"strong",raw:oe.slice(0,Ie+le.index+Q+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},ne.codespan=function(oe){var he=this.rules.inline.code.exec(oe);if(he){var ee=he[2].replace(/\n/g," "),le=/[^ ]/.test(ee),be=/^ /.test(ee)&&/ $/.test(ee);return le&&be&&(ee=ee.substring(1,ee.length-1)),ee=C(ee,!0),{type:"codespan",raw:he[0],text:ee}}},ne.br=function(oe){var he=this.rules.inline.br.exec(oe);if(he)return{type:"br",raw:he[0]}},ne.del=function(oe){var he=this.rules.inline.del.exec(oe);if(he)return{type:"del",raw:he[0],text:he[2],tokens:this.lexer.inlineTokens(he[2])}},ne.autolink=function(oe,he){var ee=this.rules.inline.autolink.exec(oe);if(ee){var le,be;return ee[2]==="@"?(le=C(this.options.mangle?he(ee[1]):ee[1]),be="mailto:"+le):(le=C(ee[1]),be=le),{type:"link",raw:ee[0],text:le,href:be,tokens:[{type:"text",raw:le,text:le}]}}},ne.url=function(oe,he){var ee;if(ee=this.rules.inline.url.exec(oe)){var le,be;if(ee[2]==="@")le=C(this.options.mangle?he(ee[0]):ee[0]),be="mailto:"+le;else{var Ie;do Ie=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(Ie!==ee[0]);le=C(ee[0]),ee[1]==="www."?be="http://"+le:be=le}return{type:"link",raw:ee[0],text:le,href:be,tokens:[{type:"text",raw:le,text:le}]}}},ne.inlineText=function(oe,he){var ee=this.rules.inline.text.exec(oe);if(ee){var le;return this.lexer.state.inRawBlock?le=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):C(ee[0]):ee[0]:le=C(this.options.smartypants?he(ee[0]):ee[0]),{type:"text",raw:ee[0],text:le}}},re}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=n(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=n(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=n(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=n(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=n(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=n(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=y({},j),j.gfm=y({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=n(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=n(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=y({},j.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:n(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=n(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=n(j._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=n(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=n(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=n(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=n(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=n(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=n(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=n(z.reflink).replace("label",z._label).replace("ref",j._label).getRegex(),z.nolink=n(z.nolink).replace("ref",j._label).getRegex(),z.reflinkSearch=n(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=y({},z),z.pedantic=y({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=y({},z.normal,{escape:n(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=n(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=y({},z.gfm,{br:n(z.br).replace("{2,}","*").getRegex(),text:n(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(re){return re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(re){var ne="",Ee,oe,he=re.length;for(Ee=0;Ee<he;Ee++)oe=re.charCodeAt(Ee),Math.random()>.5&&(oe="x"+oe.toString(16)),ne+="&#"+oe+";";return ne}var q=function(){function re(Ee){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ee||$e.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:j.normal,inline:z.normal};this.options.pedantic?(oe.block=j.pedantic,oe.inline=z.pedantic):this.options.gfm&&(oe.block=j.gfm,this.options.breaks?oe.inline=z.breaks:oe.inline=z.gfm),this.tokenizer.rules=oe}re.lex=function(oe,he){var ee=new re(he);return ee.lex(oe)},re.lexInline=function(oe,he){var ee=new re(he);return ee.inlineTokens(oe)};var ne=re.prototype;return ne.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`),this.blockTokens(oe,this.tokens);for(var he;he=this.inlineQueue.shift();)this.inlineTokens(he.src,he.tokens);return this.tokens},ne.blockTokens=function(oe,he){var ee=this;he===void 0&&(he=[]),this.options.pedantic?oe=oe.replace(/\t/g,"    ").replace(/^ +$/gm,""):oe=oe.replace(/^( *)(\t+)/gm,function(ie,se,Y){return se+"    ".repeat(Y.length)});for(var le,be,Ie,B;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ie){return(le=ie.call({lexer:ee},oe,he))?(oe=oe.substring(le.raw.length),he.push(le),!0):!1}))){if(le=this.tokenizer.space(oe)){oe=oe.substring(le.raw.length),le.raw.length===1&&he.length>0?he[he.length-1].raw+=`
`:he.push(le);continue}if(le=this.tokenizer.code(oe)){oe=oe.substring(le.raw.length),be=he[he.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+le.raw,be.text+=`
`+le.text,this.inlineQueue[this.inlineQueue.length-1].src=be.text):he.push(le);continue}if(le=this.tokenizer.fences(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.heading(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.hr(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.blockquote(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.list(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.html(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.def(oe)){oe=oe.substring(le.raw.length),be=he[he.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+le.raw,be.text+=`
`+le.raw,this.inlineQueue[this.inlineQueue.length-1].src=be.text):this.tokens.links[le.tag]||(this.tokens.links[le.tag]={href:le.href,title:le.title});continue}if(le=this.tokenizer.table(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.lheading(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(Ie=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var ie=1/0,se=oe.slice(1),Y=void 0;ee.options.extensions.startBlock.forEach(function(de){Y=de.call({lexer:this},se),typeof Y=="number"&&Y>=0&&(ie=Math.min(ie,Y))}),ie<1/0&&ie>=0&&(Ie=oe.substring(0,ie+1))}(),this.state.top&&(le=this.tokenizer.paragraph(Ie))){be=he[he.length-1],B&&be.type==="paragraph"?(be.raw+=`
`+le.raw,be.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):he.push(le),B=Ie.length!==oe.length,oe=oe.substring(le.raw.length);continue}if(le=this.tokenizer.text(oe)){oe=oe.substring(le.raw.length),be=he[he.length-1],be&&be.type==="text"?(be.raw+=`
`+le.raw,be.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):he.push(le);continue}if(oe){var Q="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return this.state.top=!0,he},ne.inline=function(oe,he){return he===void 0&&(he=[]),this.inlineQueue.push({src:oe,tokens:he}),he},ne.inlineTokens=function(oe,he){var ee=this;he===void 0&&(he=[]);var le,be,Ie,B=oe,Q,ie,se;if(this.tokens.links){var Y=Object.keys(this.tokens.links);if(Y.length>0)for(;(Q=this.tokenizer.rules.inline.reflinkSearch.exec(B))!=null;)Y.includes(Q[0].slice(Q[0].lastIndexOf("[")+1,-1))&&(B=B.slice(0,Q.index)+"["+A("a",Q[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Q=this.tokenizer.rules.inline.blockSkip.exec(B))!=null;)B=B.slice(0,Q.index)+"["+A("a",Q[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Q=this.tokenizer.rules.inline.escapedEmSt.exec(B))!=null;)B=B.slice(0,Q.index)+"++"+B.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(ie||(se=""),ie=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(le=ye.call({lexer:ee},oe,he))?(oe=oe.substring(le.raw.length),he.push(le),!0):!1}))){if(le=this.tokenizer.escape(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.tag(oe)){oe=oe.substring(le.raw.length),be=he[he.length-1],be&&le.type==="text"&&be.type==="text"?(be.raw+=le.raw,be.text+=le.text):he.push(le);continue}if(le=this.tokenizer.link(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(le.raw.length),be=he[he.length-1],be&&le.type==="text"&&be.type==="text"?(be.raw+=le.raw,be.text+=le.text):he.push(le);continue}if(le=this.tokenizer.emStrong(oe,B,se)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.codespan(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.br(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.del(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.autolink(oe,H)){oe=oe.substring(le.raw.length),he.push(le);continue}if(!this.state.inLink&&(le=this.tokenizer.url(oe,H))){oe=oe.substring(le.raw.length),he.push(le);continue}if(Ie=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,je=oe.slice(1),We=void 0;ee.options.extensions.startInline.forEach(function(_e){We=_e.call({lexer:this},je),typeof We=="number"&&We>=0&&(ye=Math.min(ye,We))}),ye<1/0&&ye>=0&&(Ie=oe.substring(0,ye+1))}(),le=this.tokenizer.inlineText(Ie,T)){oe=oe.substring(le.raw.length),le.raw.slice(-1)!=="_"&&(se=le.raw.slice(-1)),ie=!0,be=he[he.length-1],be&&be.type==="text"?(be.raw+=le.raw,be.text+=le.text):he.push(le);continue}if(oe){var de="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return he},D(re,null,[{key:"rules",get:function(){return{block:j,inline:z}}}]),re}(),me=function(){function re(Ee){this.options=Ee||$e.defaults}var ne=re.prototype;return ne.code=function(oe,he,ee){var le=(he||"").match(/\S*/)[0];if(this.options.highlight){var be=this.options.highlight(oe,le);be!=null&&be!==oe&&(ee=!0,oe=be)}return oe=oe.replace(/\n$/,"")+`
`,le?'<pre><code class="'+this.options.langPrefix+C(le,!0)+'">'+(ee?oe:C(oe,!0))+`</code></pre>
`:"<pre><code>"+(ee?oe:C(oe,!0))+`</code></pre>
`},ne.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},ne.html=function(oe){return oe},ne.heading=function(oe,he,ee,le){if(this.options.headerIds){var be=this.options.headerPrefix+le.slug(ee);return"<h"+he+' id="'+be+'">'+oe+"</h"+he+`>
`}return"<h"+he+">"+oe+"</h"+he+`>
`},ne.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ne.list=function(oe,he,ee){var le=he?"ol":"ul",be=he&&ee!==1?' start="'+ee+'"':"";return"<"+le+be+`>
`+oe+"</"+le+`>
`},ne.listitem=function(oe){return"<li>"+oe+`</li>
`},ne.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ne.paragraph=function(oe){return"<p>"+oe+`</p>
`},ne.table=function(oe,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+he+`</table>
`},ne.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},ne.tablecell=function(oe,he){var ee=he.header?"th":"td",le=he.align?"<"+ee+' align="'+he.align+'">':"<"+ee+">";return le+oe+("</"+ee+`>
`)},ne.strong=function(oe){return"<strong>"+oe+"</strong>"},ne.em=function(oe){return"<em>"+oe+"</em>"},ne.codespan=function(oe){return"<code>"+oe+"</code>"},ne.br=function(){return this.options.xhtml?"<br/>":"<br>"},ne.del=function(oe){return"<del>"+oe+"</del>"},ne.link=function(oe,he,ee){if(oe=d(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ee;var le='<a href="'+C(oe)+'"';return he&&(le+=' title="'+he+'"'),le+=">"+ee+"</a>",le},ne.image=function(oe,he,ee){if(oe=d(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ee;var le='<img src="'+oe+'" alt="'+ee+'"';return he&&(le+=' title="'+he+'"'),le+=this.options.xhtml?"/>":">",le},ne.text=function(oe){return oe},re}(),X=function(){function re(){}var ne=re.prototype;return ne.strong=function(oe){return oe},ne.em=function(oe){return oe},ne.codespan=function(oe){return oe},ne.del=function(oe){return oe},ne.html=function(oe){return oe},ne.text=function(oe){return oe},ne.link=function(oe,he,ee){return""+ee},ne.image=function(oe,he,ee){return""+ee},ne.br=function(){return""},re}(),Z=function(){function re(){this.seen={}}var ne=re.prototype;return ne.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ne.getNextSafeSlug=function(oe,he){var ee=oe,le=0;if(this.seen.hasOwnProperty(ee)){le=this.seen[oe];do le++,ee=oe+"-"+le;while(this.seen.hasOwnProperty(ee))}return he||(this.seen[oe]=le,this.seen[ee]=0),ee},ne.slug=function(oe,he){he===void 0&&(he={});var ee=this.serialize(oe);return this.getNextSafeSlug(ee,he.dryrun)},re}(),V=function(){function re(Ee){this.options=Ee||$e.defaults,this.options.renderer=this.options.renderer||new me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new X,this.slugger=new Z}re.parse=function(oe,he){var ee=new re(he);return ee.parse(oe)},re.parseInline=function(oe,he){var ee=new re(he);return ee.parseInline(oe)};var ne=re.prototype;return ne.parse=function(oe,he){he===void 0&&(he=!0);var ee="",le,be,Ie,B,Q,ie,se,Y,de,ye,je,We,_e,Ye,it,et,Ae,Oe,Ve,Le=oe.length;for(le=0;le<Le;le++){if(ye=oe[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Ve=this.options.extensions.renderers[ye.type].call({parser:this},ye),Ve!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){ee+=Ve||"";continue}switch(ye.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,o(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(Y="",se="",B=ye.header.length,be=0;be<B;be++)se+=this.renderer.tablecell(this.parseInline(ye.header[be].tokens),{header:!0,align:ye.align[be]});for(Y+=this.renderer.tablerow(se),de="",B=ye.rows.length,be=0;be<B;be++){for(ie=ye.rows[be],se="",Q=ie.length,Ie=0;Ie<Q;Ie++)se+=this.renderer.tablecell(this.parseInline(ie[Ie].tokens),{header:!1,align:ye.align[Ie]});de+=this.renderer.tablerow(se)}ee+=this.renderer.table(Y,de);continue}case"blockquote":{de=this.parse(ye.tokens),ee+=this.renderer.blockquote(de);continue}case"list":{for(je=ye.ordered,We=ye.start,_e=ye.loose,B=ye.items.length,de="",be=0;be<B;be++)it=ye.items[be],et=it.checked,Ae=it.task,Ye="",it.task&&(Oe=this.renderer.checkbox(et),_e?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Oe+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Oe+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Oe}):Ye+=Oe),Ye+=this.parse(it.tokens,_e),de+=this.renderer.listitem(Ye,Ae,et);ee+=this.renderer.list(de,je,We);continue}case"html":{ee+=this.renderer.html(ye.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(de=ye.tokens?this.parseInline(ye.tokens):ye.text;le+1<Le&&oe[le+1].type==="text";)ye=oe[++le],de+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);ee+=he?this.renderer.paragraph(de):de;continue}default:{var Ze='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}}return ee},ne.parseInline=function(oe,he){he=he||this.renderer;var ee="",le,be,Ie,B=oe.length;for(le=0;le<B;le++){if(be=oe[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(Ie=this.options.extensions.renderers[be.type].call({parser:this},be),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(be.type))){ee+=Ie||"";continue}switch(be.type){case"escape":{ee+=he.text(be.text);break}case"html":{ee+=he.html(be.text);break}case"link":{ee+=he.link(be.href,be.title,this.parseInline(be.tokens,he));break}case"image":{ee+=he.image(be.href,be.title,be.text);break}case"strong":{ee+=he.strong(this.parseInline(be.tokens,he));break}case"em":{ee+=he.em(this.parseInline(be.tokens,he));break}case"codespan":{ee+=he.codespan(be.text);break}case"br":{ee+=he.br();break}case"del":{ee+=he.del(this.parseInline(be.tokens,he));break}case"text":{ee+=he.text(be.text);break}default:{var Q='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(Q);return}else throw new Error(Q)}}}return ee},re}();function x(re,ne,Ee){if(typeof re>"u"||re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");if(typeof ne=="function"&&(Ee=ne,ne=null),ne=y({},x.defaults,ne||{}),w(ne),Ee){var oe=ne.highlight,he;try{he=q.lex(re,ne)}catch(B){return Ee(B)}var ee=function(Q){var ie;if(!Q)try{ne.walkTokens&&x.walkTokens(he,ne.walkTokens),ie=V.parse(he,ne)}catch(se){Q=se}return ne.highlight=oe,Q?Ee(Q):Ee(null,ie)};if(!oe||oe.length<3||(delete ne.highlight,!he.length))return ee();var le=0;x.walkTokens(he,function(B){B.type==="code"&&(le++,setTimeout(function(){oe(B.text,B.lang,function(Q,ie){if(Q)return ee(Q);ie!=null&&ie!==B.text&&(B.text=ie,B.escaped=!0),le--,le===0&&ee()})},0))}),le===0&&ee();return}function be(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+C(B.message+"",!0)+"</pre>";throw B}try{var Ie=q.lex(re,ne);if(ne.walkTokens){if(ne.async)return Promise.all(x.walkTokens(Ie,ne.walkTokens)).then(function(){return V.parse(Ie,ne)}).catch(be);x.walkTokens(Ie,ne.walkTokens)}return V.parse(Ie,ne)}catch(B){be(B)}}x.options=x.setOptions=function(re){return y(x.defaults,re),m(x.defaults),x},x.getDefaults=R,x.defaults=$e.defaults,x.use=function(){for(var re=arguments.length,ne=new Array(re),Ee=0;Ee<re;Ee++)ne[Ee]=arguments[Ee];var oe=y.apply(void 0,[{}].concat(ne)),he=x.defaults.extensions||{renderers:{},childTokens:{}},ee;ne.forEach(function(le){if(le.extensions&&(ee=!0,le.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var B=he.renderers?he.renderers[Ie.name]:null;B?he.renderers[Ie.name]=function(){for(var Q=arguments.length,ie=new Array(Q),se=0;se<Q;se++)ie[se]=arguments[se];var Y=Ie.renderer.apply(this,ie);return Y===!1&&(Y=B.apply(this,ie)),Y}:he.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Ie.level]?he[Ie.level].unshift(Ie.tokenizer):he[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?he.startBlock?he.startBlock.push(Ie.start):he.startBlock=[Ie.start]:Ie.level==="inline"&&(he.startInline?he.startInline.push(Ie.start):he.startInline=[Ie.start]))}Ie.childTokens&&(he.childTokens[Ie.name]=Ie.childTokens)})),le.renderer&&function(){var Ie=x.defaults.renderer||new me,B=function(se){var Y=Ie[se];Ie[se]=function(){for(var de=arguments.length,ye=new Array(de),je=0;je<de;je++)ye[je]=arguments[je];var We=le.renderer[se].apply(Ie,ye);return We===!1&&(We=Y.apply(Ie,ye)),We}};for(var Q in le.renderer)B(Q);oe.renderer=Ie}(),le.tokenizer&&function(){var Ie=x.defaults.tokenizer||new F,B=function(se){var Y=Ie[se];Ie[se]=function(){for(var de=arguments.length,ye=new Array(de),je=0;je<de;je++)ye[je]=arguments[je];var We=le.tokenizer[se].apply(Ie,ye);return We===!1&&(We=Y.apply(Ie,ye)),We}};for(var Q in le.tokenizer)B(Q);oe.tokenizer=Ie}(),le.walkTokens){var be=x.defaults.walkTokens;oe.walkTokens=function(Ie){var B=[];return B.push(le.walkTokens.call(this,Ie)),be&&(B=B.concat(be.call(this,Ie))),B}}ee&&(oe.extensions=he),x.setOptions(oe)})},x.walkTokens=function(re,ne){for(var Ee=[],oe=function(){var be=ee.value;switch(Ee=Ee.concat(ne.call(x,be)),be.type){case"table":{for(var Ie=L(be.header),B;!(B=Ie()).done;){var Q=B.value;Ee=Ee.concat(x.walkTokens(Q.tokens,ne))}for(var ie=L(be.rows),se;!(se=ie()).done;)for(var Y=se.value,de=L(Y),ye;!(ye=de()).done;){var je=ye.value;Ee=Ee.concat(x.walkTokens(je.tokens,ne))}break}case"list":{Ee=Ee.concat(x.walkTokens(be.items,ne));break}default:x.defaults.extensions&&x.defaults.extensions.childTokens&&x.defaults.extensions.childTokens[be.type]?x.defaults.extensions.childTokens[be.type].forEach(function(We){Ee=Ee.concat(x.walkTokens(be[We],ne))}):be.tokens&&(Ee=Ee.concat(x.walkTokens(be.tokens,ne)))}},he=L(re),ee;!(ee=he()).done;)oe();return Ee},x.parseInline=function(re,ne){if(typeof re>"u"||re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");ne=y({},x.defaults,ne||{}),w(ne);try{var Ee=q.lexInline(re,ne);return ne.walkTokens&&x.walkTokens(Ee,ne.walkTokens),V.parseInline(Ee,ne)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+C(oe.message+"",!0)+"</pre>";throw oe}},x.Parser=V,x.parser=V.parse,x.Renderer=me,x.TextRenderer=X,x.Lexer=q,x.lexer=q.lex,x.Tokenizer=F,x.Slugger=Z,x.parse=x;var ge=x.options,ue=x.setOptions,we=x.use,G=x.walkTokens,U=x.parseInline,K=x,fe=V.parse,te=q.lex;$e.Lexer=q,$e.Parser=V,$e.Renderer=me,$e.Slugger=Z,$e.TextRenderer=X,$e.Tokenizer=F,$e.getDefaults=R,$e.lexer=te,$e.marked=x,$e.options=ge,$e.parse=K,$e.parseInline=U,$e.parser=fe,$e.setOptions=ue,$e.use=we,$e.walkTokens=G,Object.defineProperty($e,"__esModule",{value:!0})}),define(Se[77],De([1,0,28]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$il=e.$hl=void 0;const M=new D.$Ci(1e4);function g(b){return k(b,"NFC",M)}e.$hl=g;const L=new D.$Ci(1e4);function R(b){return k(b,"NFD",L)}e.$il=R;const m=/[^\u0000-\u0080]/;function k(b,P,I){if(!b)return b;const p=I.get(b);if(p)return p;let S;return m.test(b)?S=b.normalize(P):S=b,I.set(b,S),S}e.$jl=function(){const b=/[\u0300-\u036f]/g;return function(P){return R(P).replace(b,"")}}()}),define(Se[120],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=e.$Jl=e.rot=e.$Hl=void 0;function D(m,k,b){return Math.min(Math.max(m,k),b)}e.$Hl=D;function M(m,k){return(k+m%k)%k}e.rot=M;class g{constructor(){this.a=0}getNext(){return this.a++}}e.$Jl=g;class L{constructor(){this.a=1,this.b=0}update(k){return this.b=this.b+(k-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Kl=L;class R{constructor(k){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(k),this.c.fill(0,0,k)}update(k){const b=this.c[this.d];return this.c[this.d]=k,this.d=(this.d+1)%this.c.length,this.e-=b,this.e+=k,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ll=R}),function(){function $e(g){const L=[];typeof g=="number"&&L.push("code/timeOrigin",g);function R(k){L.push(k,Date.now())}function m(){const k=[];for(let b=0;b<L.length;b+=2)k.push({name:L[b],startTime:L[b+1]});return k}return{mark:R,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(g){performance.mark(g)},getMarks(){let g=performance.timeOrigin;typeof g!="number"&&(g=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(g)}];for(const R of performance.getEntriesByType("mark"))L.push({name:R.name,startTime:Math.round(g+R.startTime)});return L}};if(typeof process=="object"){const g=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(g)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function D(g){return g.MonacoPerformanceMarks||(g.MonacoPerformanceMarks=e()),g.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=D(M))}(),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var M in D)(typeof exports=="object"?exports:$e)[M]=D[M]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function D(M){if(e[M])return e[M].exports;var g=e[M]={i:M,l:!1,exports:{}};return $e[M].call(g.exports,g,g.exports,D),g.l=!0,g.exports}return D.m=$e,D.c=e,D.d=function(M,g,L){D.o(M,g)||Object.defineProperty(M,g,{enumerable:!0,get:L})},D.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},D.t=function(M,g){if(1&g&&(M=D(M)),8&g||4&g&&typeof M=="object"&&M&&M.__esModule)return M;var L=Object.create(null);if(D.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:M}),2&g&&typeof M!="string")for(var R in M)D.d(L,R,function(m){return M[m]}.bind(null,R));return L},D.n=function(M){var g=M&&M.__esModule?function(){return M.default}:function(){return M};return D.d(g,"a",g),g},D.o=function(M,g){return Object.prototype.hasOwnProperty.call(M,g)},D.p="",D(D.s=0)}([function($e,e,D){(function(M){var g;e=$e.exports=we,g=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],k=e.src=[],b=0,P=b++;k[P]="0|[1-9]\\d*";var I=b++;k[I]="[0-9]+";var p=b++;k[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=b++;k[S]="("+k[P]+")\\.("+k[P]+")\\.("+k[P]+")";var C=b++;k[C]="("+k[I]+")\\.("+k[I]+")\\.("+k[I]+")";var v=b++;k[v]="(?:"+k[P]+"|"+k[p]+")";var o=b++;k[o]="(?:"+k[I]+"|"+k[p]+")";var s=b++;k[s]="(?:-("+k[v]+"(?:\\."+k[v]+")*))";var n=b++;k[n]="(?:-?("+k[o]+"(?:\\."+k[o]+")*))";var h=b++;k[h]="[0-9A-Za-z-]+";var $=b++;k[$]="(?:\\+("+k[h]+"(?:\\."+k[h]+")*))";var d=b++,t="v?"+k[S]+k[s]+"?"+k[$]+"?";k[d]="^"+t+"$";var r="[v=\\s]*"+k[C]+k[n]+"?"+k[$]+"?",a=b++;k[a]="^"+r+"$";var i=b++;k[i]="((?:<|>)?=?)";var c=b++;k[c]=k[I]+"|x|X|\\*";var f=b++;k[f]=k[P]+"|x|X|\\*";var y=b++;k[y]="[v=\\s]*("+k[f]+")(?:\\.("+k[f]+")(?:\\.("+k[f]+")(?:"+k[s]+")?"+k[$]+"?)?)?";var E=b++;k[E]="[v=\\s]*("+k[c]+")(?:\\.("+k[c]+")(?:\\.("+k[c]+")(?:"+k[n]+")?"+k[$]+"?)?)?";var u=b++;k[u]="^"+k[i]+"\\s*"+k[y]+"$";var l=b++;k[l]="^"+k[i]+"\\s*"+k[E]+"$";var w=b++;k[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=b++;k[A]="(?:~>?)";var N=b++;k[N]="(\\s*)"+k[A]+"\\s+",m[N]=new RegExp(k[N],"g");var O=b++;k[O]="^"+k[A]+k[y]+"$";var F=b++;k[F]="^"+k[A]+k[E]+"$";var j=b++;k[j]="(?:\\^)";var z=b++;k[z]="(\\s*)"+k[j]+"\\s+",m[z]=new RegExp(k[z],"g");var T=b++;k[T]="^"+k[j]+k[y]+"$";var H=b++;k[H]="^"+k[j]+k[E]+"$";var q=b++;k[q]="^"+k[i]+"\\s*("+r+")$|^$";var me=b++;k[me]="^"+k[i]+"\\s*("+t+")$|^$";var X=b++;k[X]="(\\s*)"+k[i]+"\\s*("+r+"|"+k[y]+")",m[X]=new RegExp(k[X],"g");var Z=b++;k[Z]="^\\s*("+k[y]+")\\s+-\\s+("+k[y]+")\\s*$";var V=b++;k[V]="^\\s*("+k[E]+")\\s+-\\s+("+k[E]+")\\s*$";var x=b++;k[x]="(<|>)?=?\\s*\\*";for(var ge=0;ge<35;ge++)g(ge,k[ge]),m[ge]||(m[ge]=new RegExp(k[ge]));function ue(Y,de){if(Y instanceof we)return Y;if(typeof Y!="string"||Y.length>L||!(de?m[a]:m[d]).test(Y))return null;try{return new we(Y,de)}catch{return null}}function we(Y,de){if(Y instanceof we){if(Y.loose===de)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof we))return new we(Y,de);g("SemVer",Y,de),this.loose=de;var ye=Y.trim().match(de?m[a]:m[d]);if(!ye)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var We=+je;if(We>=0&&We<R)return We}return je}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=ue,e.valid=function(Y,de){var ye=ue(Y,de);return ye?ye.version:null},e.clean=function(Y,de){var ye=ue(Y.trim().replace(/^[=v]+/,""),de);return ye?ye.version:null},e.SemVer=we,we.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},we.prototype.toString=function(){return this.version},we.prototype.compare=function(Y){return g("SemVer.compare",this.version,this.loose,Y),Y instanceof we||(Y=new we(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},we.prototype.compareMain=function(Y){return Y instanceof we||(Y=new we(Y,this.loose)),U(this.major,Y.major)||U(this.minor,Y.minor)||U(this.patch,Y.patch)},we.prototype.comparePre=function(Y){if(Y instanceof we||(Y=new we(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var de=0;do{var ye=this.prerelease[de],je=Y.prerelease[de];if(g("prerelease compare",de,ye,je),ye===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ye===void 0)return-1;if(ye!==je)return U(ye,je)}while(++de)},we.prototype.inc=function(Y,de){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,de,ye,je){typeof ye=="string"&&(je=ye,ye=void 0);try{return new we(Y,ye).inc(de,je).version}catch{return null}},e.diff=function(Y,de){if(re(Y,de))return null;var ye=ue(Y),je=ue(de);if(ye.prerelease.length||je.prerelease.length){for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return"pre"+We;return"prerelease"}for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return We},e.compareIdentifiers=U;var G=/^[0-9]+$/;function U(Y,de){var ye=G.test(Y),je=G.test(de);return ye&&je&&(Y=+Y,de=+de),ye&&!je?-1:je&&!ye?1:Y<de?-1:Y>de?1:0}function K(Y,de,ye){return new we(Y,ye).compare(new we(de,ye))}function fe(Y,de,ye){return K(Y,de,ye)>0}function te(Y,de,ye){return K(Y,de,ye)<0}function re(Y,de,ye){return K(Y,de,ye)===0}function ne(Y,de,ye){return K(Y,de,ye)!==0}function Ee(Y,de,ye){return K(Y,de,ye)>=0}function oe(Y,de,ye){return K(Y,de,ye)<=0}function he(Y,de,ye,je){var We;switch(de){case"===":typeof Y=="object"&&(Y=Y.version),typeof ye=="object"&&(ye=ye.version),We=Y===ye;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof ye=="object"&&(ye=ye.version),We=Y!==ye;break;case"":case"=":case"==":We=re(Y,ye,je);break;case"!=":We=ne(Y,ye,je);break;case">":We=fe(Y,ye,je);break;case">=":We=Ee(Y,ye,je);break;case"<":We=te(Y,ye,je);break;case"<=":We=oe(Y,ye,je);break;default:throw new TypeError("Invalid operator: "+de)}return We}function ee(Y,de){if(Y instanceof ee){if(Y.loose===de)return Y;Y=Y.value}if(!(this instanceof ee))return new ee(Y,de);g("comparator",Y,de),this.loose=de,this.parse(Y),this.semver===le?this.value="":this.value=this.operator+this.semver.version,g("comp",this)}e.rcompareIdentifiers=function(Y,de){return U(de,Y)},e.major=function(Y,de){return new we(Y,de).major},e.minor=function(Y,de){return new we(Y,de).minor},e.patch=function(Y,de){return new we(Y,de).patch},e.compare=K,e.compareLoose=function(Y,de){return K(Y,de,!0)},e.rcompare=function(Y,de,ye){return K(de,Y,ye)},e.sort=function(Y,de){return Y.sort(function(ye,je){return e.compare(ye,je,de)})},e.rsort=function(Y,de){return Y.sort(function(ye,je){return e.rcompare(ye,je,de)})},e.gt=fe,e.lt=te,e.eq=re,e.neq=ne,e.gte=Ee,e.lte=oe,e.cmp=he,e.Comparator=ee;var le={};function be(Y,de){if(Y instanceof be)return Y.loose===de?Y:new be(Y.raw,de);if(Y instanceof ee)return new be(Y.value,de);if(!(this instanceof be))return new be(Y,de);if(this.loose=de,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function Ie(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function B(Y,de,ye,je,We,_e,Ye,it,et,Ae,Oe,Ve,Le){return((de=Ie(ye)?"":Ie(je)?">="+ye+".0.0":Ie(We)?">="+ye+"."+je+".0":">="+de)+" "+(it=Ie(et)?"":Ie(Ae)?"<"+(+et+1)+".0.0":Ie(Oe)?"<"+et+"."+(+Ae+1)+".0":Ve?"<="+et+"."+Ae+"."+Oe+"-"+Ve:"<="+it)).trim()}function Q(Y,de){for(var ye=0;ye<Y.length;ye++)if(!Y[ye].test(de))return!1;if(de.prerelease.length){for(ye=0;ye<Y.length;ye++)if(g(Y[ye].semver),Y[ye].semver!==le&&Y[ye].semver.prerelease.length>0){var je=Y[ye].semver;if(je.major===de.major&&je.minor===de.minor&&je.patch===de.patch)return!0}return!1}return!0}function ie(Y,de,ye){try{de=new be(de,ye)}catch{return!1}return de.test(Y)}function se(Y,de,ye,je){var We,_e,Ye,it,et;switch(Y=new we(Y,je),de=new be(de,je),ye){case">":We=fe,_e=oe,Ye=te,it=">",et=">=";break;case"<":We=te,_e=Ee,Ye=fe,it="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ie(Y,de,je))return!1;for(var Ae=0;Ae<de.set.length;++Ae){var Oe=de.set[Ae],Ve=null,Le=null;if(Oe.forEach(function(Ze){Ze.semver===le&&(Ze=new ee(">=0.0.0")),Ve=Ve||Ze,Le=Le||Ze,We(Ze.semver,Ve.semver,je)?Ve=Ze:Ye(Ze.semver,Le.semver,je)&&(Le=Ze)}),Ve.operator===it||Ve.operator===et||(!Le.operator||Le.operator===it)&&_e(Y,Le.semver)||Le.operator===et&&Ye(Y,Le.semver))return!1}return!0}ee.prototype.parse=function(Y){var de=this.loose?m[q]:m[me],ye=Y.match(de);if(!ye)throw new TypeError("Invalid comparator: "+Y);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new we(ye[2],this.loose):this.semver=le},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(Y){return g("Comparator.test",Y,this.loose),this.semver===le||(typeof Y=="string"&&(Y=new we(Y,this.loose)),he(Y,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(Y,de){if(!(Y instanceof ee))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new be(Y.value,de),ie(this.value,ye,de);if(Y.operator==="")return ye=new be(this.value,de),ie(Y.semver,ye,de);var je=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),_e=this.semver.version===Y.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),it=he(this.semver,"<",Y.semver,de)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),et=he(this.semver,">",Y.semver,de)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return je||We||_e&&Ye||it||et},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(Y){var de=this.loose;Y=Y.trim(),g("range",Y,de);var ye=de?m[V]:m[Z];Y=Y.replace(ye,B),g("hyphen replace",Y),Y=Y.replace(m[X],"$1$2$3"),g("comparator trim",Y,m[X]),Y=(Y=(Y=Y.replace(m[N],"$1~")).replace(m[z],"$1^")).split(/\s+/).join(" ");var je=de?m[q]:m[me],We=Y.split(" ").map(function(_e){return function(Ye,it){return g("comp",Ye),Ye=function(et,Ae){return et.trim().split(/\s+/).map(function(Oe){return function(Ve,Le){g("caret",Ve,Le);var Ze=Le?m[H]:m[T];return Ve.replace(Ze,function(ce,ae,Ce,qe,Ue){var Xe;return g("caret",Ve,ce,ae,Ce,qe,Ue),Ie(ae)?Xe="":Ie(Ce)?Xe=">="+ae+".0.0 <"+(+ae+1)+".0.0":Ie(qe)?Xe=ae==="0"?">="+ae+"."+Ce+".0 <"+ae+"."+(+Ce+1)+".0":">="+ae+"."+Ce+".0 <"+(+ae+1)+".0.0":Ue?(g("replaceCaret pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Xe=ae==="0"?Ce==="0"?">="+ae+"."+Ce+"."+qe+Ue+" <"+ae+"."+Ce+"."+(+qe+1):">="+ae+"."+Ce+"."+qe+Ue+" <"+ae+"."+(+Ce+1)+".0":">="+ae+"."+Ce+"."+qe+Ue+" <"+(+ae+1)+".0.0"):(g("no pr"),Xe=ae==="0"?Ce==="0"?">="+ae+"."+Ce+"."+qe+" <"+ae+"."+Ce+"."+(+qe+1):">="+ae+"."+Ce+"."+qe+" <"+ae+"."+(+Ce+1)+".0":">="+ae+"."+Ce+"."+qe+" <"+(+ae+1)+".0.0"),g("caret return",Xe),Xe})}(Oe,Ae)}).join(" ")}(Ye,it),g("caret",Ye),Ye=function(et,Ae){return et.trim().split(/\s+/).map(function(Oe){return function(Ve,Le){var Ze=Le?m[F]:m[O];return Ve.replace(Ze,function(ce,ae,Ce,qe,Ue){var Xe;return g("tilde",Ve,ce,ae,Ce,qe,Ue),Ie(ae)?Xe="":Ie(Ce)?Xe=">="+ae+".0.0 <"+(+ae+1)+".0.0":Ie(qe)?Xe=">="+ae+"."+Ce+".0 <"+ae+"."+(+Ce+1)+".0":Ue?(g("replaceTilde pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Xe=">="+ae+"."+Ce+"."+qe+Ue+" <"+ae+"."+(+Ce+1)+".0"):Xe=">="+ae+"."+Ce+"."+qe+" <"+ae+"."+(+Ce+1)+".0",g("tilde return",Xe),Xe})}(Oe,Ae)}).join(" ")}(Ye,it),g("tildes",Ye),Ye=function(et,Ae){return g("replaceXRanges",et,Ae),et.split(/\s+/).map(function(Oe){return function(Ve,Le){Ve=Ve.trim();var Ze=Le?m[l]:m[u];return Ve.replace(Ze,function(ce,ae,Ce,qe,Ue,Xe){g("xRange",Ve,ce,ae,Ce,qe,Ue,Xe);var rt=Ie(Ce),at=rt||Ie(qe),$t=at||Ie(Ue);return ae==="="&&$t&&(ae=""),rt?ce=ae===">"||ae==="<"?"<0.0.0":"*":ae&&$t?(at&&(qe=0),$t&&(Ue=0),ae===">"?(ae=">=",at?(Ce=+Ce+1,qe=0,Ue=0):$t&&(qe=+qe+1,Ue=0)):ae==="<="&&(ae="<",at?Ce=+Ce+1:qe=+qe+1),ce=ae+Ce+"."+qe+"."+Ue):at?ce=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":$t&&(ce=">="+Ce+"."+qe+".0 <"+Ce+"."+(+qe+1)+".0"),g("xRange return",ce),ce})}(Oe,Ae)}).join(" ")}(Ye,it),g("xrange",Ye),Ye=function(et,Ae){return g("replaceStars",et,Ae),et.trim().replace(m[x],"")}(Ye,it),g("stars",Ye),Ye}(_e,de)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(_e){return!!_e.match(je)})),We=We.map(function(_e){return new ee(_e,de)})},be.prototype.intersects=function(Y,de){if(!(Y instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(je){return Y.set.some(function(We){return We.every(function(_e){return je.intersects(_e,de)})})})})},e.toComparators=function(Y,de){return new be(Y,de).set.map(function(ye){return ye.map(function(je){return je.value}).join(" ").trim().split(" ")})},be.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new we(Y,this.loose));for(var de=0;de<this.set.length;de++)if(Q(this.set[de],Y))return!0;return!1},e.satisfies=ie,e.maxSatisfying=function(Y,de,ye){var je=null,We=null;try{var _e=new be(de,ye)}catch{return null}return Y.forEach(function(Ye){_e.test(Ye)&&(je&&We.compare(Ye)!==-1||(We=new we(je=Ye,ye)))}),je},e.minSatisfying=function(Y,de,ye){var je=null,We=null;try{var _e=new be(de,ye)}catch{return null}return Y.forEach(function(Ye){_e.test(Ye)&&(je&&We.compare(Ye)!==1||(We=new we(je=Ye,ye)))}),je},e.validRange=function(Y,de){try{return new be(Y,de).range||"*"}catch{return null}},e.ltr=function(Y,de,ye){return se(Y,de,"<",ye)},e.gtr=function(Y,de,ye){return se(Y,de,">",ye)},e.outside=se,e.prerelease=function(Y,de){var ye=ue(Y,de);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(Y,de,ye){return Y=new be(Y,ye),de=new be(de,ye),Y.intersects(de)},e.coerce=function(Y){if(Y instanceof we)return Y;if(typeof Y!="string")return null;var de=Y.match(m[w]);return de==null?null:ue((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,D(1))},function($e,e){var D,M,g=$e.exports={};function L(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function m(o){if(D===setTimeout)return setTimeout(o,0);if((D===L||!D)&&setTimeout)return D=setTimeout,setTimeout(o,0);try{return D(o,0)}catch{try{return D.call(null,o,0)}catch{return D.call(this,o,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:L}catch{D=L}try{M=typeof clearTimeout=="function"?clearTimeout:R}catch{M=R}})();var k,b=[],P=!1,I=-1;function p(){P&&k&&(P=!1,k.length?b=k.concat(b):I=-1,b.length&&S())}function S(){if(!P){var o=m(p);P=!0;for(var s=b.length;s;){for(k=b,b=[];++I<s;)k&&k[I].run();I=-1,s=b.length}k=null,P=!1,function(n){if(M===clearTimeout)return clearTimeout(n);if((M===R||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(n);try{M(n)}catch{try{return M.call(null,n)}catch{return M.call(this,n)}}}(o)}}function C(o,s){this.fun=o,this.array=s}function v(){}g.nextTick=function(o){var s=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)s[n-1]=arguments[n];b.push(new C(o,s)),b.length!==1||P||m(S)},C.prototype.run=function(){this.fun.apply(null,this.array)},g.title="browser",g.browser=!0,g.env={},g.argv=[],g.version="",g.versions={},g.on=v,g.addListener=v,g.once=v,g.off=v,g.removeListener=v,g.removeAllListeners=v,g.emit=v,g.prependListener=v,g.prependOnceListener=v,g.listeners=function(o){return[]},g.binding=function(o){throw new Error("process.binding is not supported")},g.cwd=function(){return"/"},g.chdir=function(o){throw new Error("process.chdir is not supported")},g.umask=function(){return 0}}])}),define(Se[37],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class M{static create(L){return new M(L)}constructor(L){this.c=D&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$bd=M}),define(Se[4],De([1,0,8,75,3,76,37]),function($e,e,D,M,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.Event=void 0;const m=!1,k=!1;var b;(function(u){u.None=()=>g.$kc.None;function l(he){if(k){const{onDidAddListener:ee}=he,le=C.create();let be=0;he.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),le.print()),ee?.()}}}function w(he,ee){return me(he,()=>{},0,void 0,!0,void 0,ee)}u.defer=w;function A(he){return(ee,le=null,be)=>{let Ie=!1,B;return B=he(Q=>{if(!Ie)return B?B.dispose():Ie=!0,ee.call(le,Q)},null,be),Ie&&B.dispose(),B}}u.once=A;function N(he,ee,le){return H((be,Ie=null,B)=>he(Q=>be.call(Ie,ee(Q)),null,B),le)}u.map=N;function O(he,ee,le){return H((be,Ie=null,B)=>he(Q=>{ee(Q),be.call(Ie,Q)},null,B),le)}u.forEach=O;function F(he,ee,le){return H((be,Ie=null,B)=>he(Q=>ee(Q)&&be.call(Ie,Q),null,B),le)}u.filter=F;function j(he){return he}u.signal=j;function z(...he){return(ee,le=null,be)=>{const Ie=(0,g.$hc)(...he.map(B=>B(Q=>ee.call(le,Q))));return q(Ie,be)}}u.any=z;function T(he,ee,le,be){let Ie=le;return N(he,B=>(Ie=ee(Ie,B),Ie),be)}u.reduce=T;function H(he,ee){let le;const be={onWillAddFirstListener(){le=he(Ie.fire,Ie)},onDidRemoveLastListener(){le?.dispose()}};ee||l(be);const Ie=new h(be);return ee?.add(Ie),Ie.event}function q(he,ee){return ee instanceof Array?ee.push(he):ee&&ee.add(he),he}function me(he,ee,le=100,be=!1,Ie=!1,B,Q){let ie,se,Y,de=0,ye;const je={leakWarningThreshold:B,onWillAddFirstListener(){ie=he(_e=>{de++,se=ee(se,_e),be&&!Y&&(We.fire(se),se=void 0),ye=()=>{const Ye=se;se=void 0,Y=void 0,(!be||de>1)&&We.fire(Ye),de=0},typeof le=="number"?(clearTimeout(Y),Y=setTimeout(ye,le)):Y===void 0&&(Y=0,queueMicrotask(ye))})},onWillRemoveListener(){Ie&&de>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,ie.dispose()}};Q||l(je);const We=new h(je);return Q?.add(We),We.event}u.debounce=me;function X(he,ee=0,le){return u.debounce(he,(be,Ie)=>be?(be.push(Ie),be):[Ie],ee,void 0,!0,void 0,le)}u.accumulate=X;function Z(he,ee=(be,Ie)=>be===Ie,le){let be=!0,Ie;return F(he,B=>{const Q=be||!ee(B,Ie);return be=!1,Ie=B,Q},le)}u.latch=Z;function V(he,ee,le){return[u.filter(he,ee,le),u.filter(he,be=>!ee(be),le)]}u.split=V;function x(he,ee=!1,le=[],be){let Ie=le.slice(),B=he(se=>{Ie?Ie.push(se):ie.fire(se)});be&&be.add(B);const Q=()=>{Ie?.forEach(se=>ie.fire(se)),Ie=null},ie=new h({onWillAddFirstListener(){B||(B=he(se=>ie.fire(se)),be&&be.add(B))},onDidAddFirstListener(){Ie&&(ee?setTimeout(Q):Q())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return be&&be.add(ie),ie.event}u.buffer=x;function ge(he,ee){return(be,Ie,B)=>{const Q=ee(new we);return he(function(ie){const se=Q.evaluate(ie);se!==ue&&be.call(Ie,se)},void 0,B)}}u.chain=ge;const ue=Symbol("HaltChainable");class we{constructor(){this.f=[]}map(ee){return this.f.push(ee),this}forEach(ee){return this.f.push(le=>(ee(le),le)),this}filter(ee){return this.f.push(le=>ee(le)?le:ue),this}reduce(ee,le){let be=le;return this.f.push(Ie=>(be=ee(be,Ie),be)),this}latch(ee=(le,be)=>le===be){let le=!0,be;return this.f.push(Ie=>{const B=le||!ee(Ie,be);return le=!1,be=Ie,B?Ie:ue}),this}evaluate(ee){for(const le of this.f)if(ee=le(ee),ee===ue)break;return ee}}function G(he,ee,le=be=>be){const be=(...ie)=>Q.fire(le(...ie)),Ie=()=>he.on(ee,be),B=()=>he.removeListener(ee,be),Q=new h({onWillAddFirstListener:Ie,onDidRemoveLastListener:B});return Q.event}u.fromNodeEventEmitter=G;function U(he,ee,le=be=>be){const be=(...ie)=>Q.fire(le(...ie)),Ie=()=>he.addEventListener(ee,be),B=()=>he.removeEventListener(ee,be),Q=new h({onWillAddFirstListener:Ie,onDidRemoveLastListener:B});return Q.event}u.fromDOMEventEmitter=U;function K(he){return new Promise(ee=>A(he)(ee))}u.toPromise=K;function fe(he){const ee=new h;return he.then(le=>{ee.fire(le)},()=>{ee.fire(void 0)}).finally(()=>{ee.dispose()}),ee.event}u.fromPromise=fe;function te(he,ee){return ee(void 0),he(le=>ee(le))}u.runAndSubscribe=te;function re(he,ee){let le=null;function be(B){le?.dispose(),le=new g.$jc,ee(B,le)}be(void 0);const Ie=he(B=>be(B));return(0,g.$ic)(()=>{Ie.dispose(),le?.dispose()})}u.runAndSubscribeWithStore=re;class ne{constructor(ee,le){this._observable=ee,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};le||l(be),this.emitter=new h(be),le&&le.add(this.emitter)}beginUpdate(ee){this.f++}handlePossibleChange(ee){}handleChange(ee,le){this.g=!0}endUpdate(ee){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ee(he,ee){return new ne(he,ee).emitter.event}u.fromObservable=Ee;function oe(he){return ee=>{let le=0,be=!1;const Ie={beginUpdate(){le++},endUpdate(){le--,le===0&&(he.reportChanges(),be&&(be=!1,ee()))},handlePossibleChange(){},handleChange(){be=!0}};return he.addObserver(Ie),he.reportChanges(),{dispose(){he.removeObserver(Ie)}}}}u.fromObservableLight=oe})(b||(e.Event=b={}));class P{static{this.all=new Set}static{this.f=0}constructor(l){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${l}_${P.f++}`,P.all.add(this)}start(l){this.g=new R.$bd,this.listenerCount=l}stop(){if(this.g){const l=this.g.elapsed();this.durations.push(l),this.elapsedOverall+=l,this.invocationCount+=1,this.g=void 0}}}e.$dd=P;let I=-1;function p(u){const l=I;return I=u,{dispose(){I=l}}}e.$ed=p;class S{constructor(l,w=Math.random().toString(18).slice(2,5)){this.threshold=l,this.name=w,this.g=0}dispose(){this.f?.clear()}check(l,w){const A=this.threshold;if(A<=0||w<A)return;this.f||(this.f=new Map);const N=this.f.get(l.value)||0;if(this.f.set(l.value,N+1),this.g-=1,this.g<=0){this.g=A*.5;let O,F=0;for(const[j,z]of this.f)(!O||F<z)&&(O=j,F=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${w} listeners already. MOST frequent listener (${F}):`),console.warn(O)}return()=>{const O=this.f.get(l.value)||0;this.f.set(l.value,O-1)}}}class C{static create(){return new C(new Error().stack??"")}constructor(l){this.value=l}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let v=0;class o{constructor(l){this.value=l,this.id=v++}}const s=2,n=(u,l)=>{if(u instanceof o)l(u);else for(let w=0;w<u.length;w++){const A=u[w];A&&l(A)}};class h{constructor(l){this.x=0,this.f=l,this.g=I>0||this.f?.leakWarningThreshold?new S(this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(m){const l=this.t;queueMicrotask(()=>{n(l,w=>w.stack?.print())})}this.t=void 0,this.x=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(l,w,A)=>{if(this.g&&this.x>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),g.$kc.None;if(this.m)return g.$kc.None;w&&(l=l.bind(w));const N=new o(l);let O,F;this.g&&this.x>=Math.ceil(this.g.threshold*.2)&&(N.stack=C.create(),O=this.g.check(N.stack,this.x+1)),m&&(N.stack=F??C.create()),this.t?this.t instanceof o?(this.u??=new d,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.x++;const j=(0,g.$ic)(()=>{O?.(),this.y(N)});return A instanceof g.$jc?A.add(j):Array.isArray(A)&&A.push(j),j},this.q}y(l){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.x===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.x=0;return}const w=this.t,A=w.indexOf(l);if(A===-1)throw console.log("disposed?",this.m),console.log("size?",this.x),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.x--,w[A]=void 0;const N=this.u.current===this;if(this.x*s<=w.length){let O=0;for(let F=0;F<w.length;F++)w[F]?w[O++]=w[F]:N&&(this.u.end--,O<this.u.i&&this.u.i--);w.length=O}}z(l,w){if(!l)return;const A=this.f?.onListenerError||D.$Y;if(!A){l.value(w);return}try{l.value(w)}catch(N){A(N)}}A(l){const w=l.current.t;for(;l.i<l.end;)this.z(w[l.i++],l.value);l.reset()}fire(l){if(this.u?.current&&(this.A(this.u),this.j?.stop()),this.j?.start(this.x),this.t)if(this.t instanceof o)this.z(this.t,l);else{const w=this.u;w.enqueue(this,l,this.t.length),this.A(w)}this.j?.stop()}hasListeners(){return this.x>0}}e.$fd=h;const $=()=>new d;e.$gd=$;class d{constructor(){this.i=-1,this.end=0}enqueue(l,w,A){this.i=0,this.end=A,this.current=l,this.value=w}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends h{async fireAsync(l,w,A){if(this.t)for(this.h||(this.h=new L.$tc),n(this.t,N=>this.h.push([N.value,l]));this.h.size>0&&!w.isCancellationRequested;){const[N,O]=this.h.shift(),F=[],j={...O,token:w,waitUntil:z=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");A&&(z=A(z,N)),F.push(z)}};try{N(j)}catch(z){(0,D.$Y)(z);continue}Object.freeze(F),await Promise.allSettled(F).then(z=>{for(const T of z)T.status==="rejected"&&(0,D.$Y)(T.reason)})}}}e.$hd=t;class r extends h{get isPaused(){return this.h!==0}constructor(l){super(l),this.h=0,this.s=new L.$tc,this.w=l?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.w){if(this.s.size>0){const l=Array.from(this.s);this.s.clear(),super.fire(this.w(l))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(l){this.x&&(this.h!==0?this.s.push(l):super.fire(l))}}e.$id=r;class a extends r{constructor(l){super(l),this.k=l.delay??100}fire(l){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(l)}}e.$jd=a;class i extends h{constructor(l){super(l),this.h=[],this.k=l?.merge}fire(l){this.hasListeners()&&(this.h.push(l),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(w=>super.fire(w)),this.h=[]}))}}e.$kd=i;class c{constructor(){this.g=!1,this.h=[],this.f=new h({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(l){const w={event:l,listener:null};this.h.push(w),this.g&&this.m(w);const A=()=>{this.g&&this.o(w);const N=this.h.indexOf(w);this.h.splice(N,1)};return(0,g.$ic)((0,M.$bb)(A))}j(){this.g=!0,this.h.forEach(l=>this.m(l))}k(){this.g=!1,this.h.forEach(l=>this.o(l))}m(l){l.listener=l.event(w=>this.f.fire(w))}o(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.f.dispose()}}e.$ld=c;class f{constructor(l,w,A,N){this.f=new g.$jc;const O=this.f.add(new c),F=this.f.add(new g.$sc);function j(z){F.set(z,O.add(N(z)))}for(const z of l)j(z);this.f.add(w(z=>{j(z)})),this.f.add(A(z=>{F.deleteAndDispose(z)})),this.event=O.event}dispose(){this.f.dispose()}}e.$md=f;class y{constructor(){this.f=[]}wrapEvent(l){return(w,A,N)=>l(O=>{const F=this.f[this.f.length-1];F?F.push(()=>w.call(A,O)):w.call(A,O)},void 0,N)}bufferEvents(l){const w=[];this.f.push(w);const A=l();return this.f.pop(),w.forEach(N=>N()),A}}e.$nd=y;class E{constructor(){this.f=!1,this.g=b.None,this.h=g.$kc.None,this.j=new h({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(l){this.g=l,this.f&&(this.h.dispose(),this.h=l(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$od=E}),define(Se[21],De([1,0,4]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pd=e.CancellationToken=void 0;const M=Object.freeze(function(m,k){const b=setTimeout(m.bind(k),0);return{dispose(){clearTimeout(b)}}});var g;(function(m){function k(b){return b===m.None||b===m.Cancelled||b instanceof L?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}m.isCancellationToken=k,m.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),m.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(g||(e.CancellationToken=g={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?M:(this.b||(this.b=new D.$fd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(k){this.f=void 0,this.g=void 0,this.g=k&&k.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=g.Cancelled}dispose(k=!1){k&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=g.None}}e.$pd=R}),define(Se[159],De([1,0,21]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=void 0;class M{constructor(m){this.b=m,this.a=null}get(){if(this.a)return this.a;const m=new D.$pd,k=this.b(m.token);return this.a={promise:k,dispose:()=>{this.a=null,m.cancel(),m.dispose()}},this.a}}e.$he=M;class g{constructor(m){this.c=m,this.a=void 0,this.b=void 0}get(m){const k=JSON.stringify(m);return this.b!==k&&(this.b=k,this.a=this.c(m)),this.a}}e.$ie=g;class L{get cachedValues(){return this.a}constructor(m){this.b=m,this.a=new Map}get(m){if(this.a.has(m))return this.a.get(m);const k=this.b(m);return this.a.set(m,k),k}}e.$je=L}),define(Se[97],De([1,0,8,3]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=void 0;function g($){const d=$;return d?typeof d.read=="function":!1}e.$qd=g;function L($){const d=$;return d?[d.on,d.pause,d.resume,d.destroy].every(t=>typeof t=="function"):!1}e.$rd=L;function R($){const d=$;return d?L(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.$sd=R;function m($,d){return new k($,d)}e.$td=m;class k{constructor(d,t){this.e=d,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(d){if(!this.a.destroyed){if(this.a.flowing)this.g(d);else if(this.b.data.push(d),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(d){this.a.destroyed||(this.a.flowing?this.h(d):this.b.error.push(d))}end(d){this.a.destroyed||(typeof d<"u"&&this.write(d),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(d){this.c.data.slice(0).forEach(t=>t(d))}h(d){this.c.error.length===0?(0,D.$Y)(d):this.c.error.slice(0).forEach(t=>t(d))}i(){this.c.end.slice(0).forEach(d=>d())}on(d,t){if(!this.a.destroyed)switch(d){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(d,t){if(this.a.destroyed)return;let r;switch(d){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const a=r.indexOf(t);a>=0&&r.splice(a,1)}}j(){if(this.b.data.length>0){const d=this.e(this.b.data);this.g(d),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const d of this.b.error)this.h(d);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b($,d){const t=[];let r;for(;(r=$.read())!==null;)t.push(r);return d(t)}e.$ud=b;function P($,d,t){const r=[];let a;for(;(a=$.read())!==null&&r.length<t;)r.push(a);return a===null&&r.length>0?d(r):{read:()=>{if(r.length>0)return r.shift();if(typeof a<"u"){const i=a;return a=void 0,i}return $.read()}}}e.$vd=P;function I($,d){return new Promise((t,r)=>{const a=[];p($,{onData:i=>{d&&a.push(i)},onError:i=>{d?r(i):t(void 0)},onEnd:()=>{t(d?d(a):void 0)}})})}e.$wd=I;function p($,d,t){$.on("error",r=>{t?.isCancellationRequested||d.onError(r)}),$.on("end",()=>{t?.isCancellationRequested||d.onEnd()}),$.on("data",r=>{t?.isCancellationRequested||d.onData(r)})}e.$xd=p;function S($,d){return new Promise((t,r)=>{const a=new M.$jc,i=[],c=E=>{if(i.push(E),i.length>d)return a.dispose(),$.pause(),t({stream:$,buffer:i,ended:!1})},f=E=>(a.dispose(),r(E)),y=()=>(a.dispose(),t({stream:$,buffer:i,ended:!0}));a.add((0,M.$ic)(()=>$.removeListener("error",f))),$.on("error",f),a.add((0,M.$ic)(()=>$.removeListener("end",y))),$.on("end",y),a.add((0,M.$ic)(()=>$.removeListener("data",c))),$.on("data",c)})}e.$yd=S;function C($,d){const t=m(d);return t.end($),t}e.$zd=C;function v(){const $=m(()=>{throw new Error("not supported")});return $.end(),$}e.$Ad=v;function o($){let d=!1;return{read:()=>d?null:(d=!0,$)}}e.$Bd=o;function s($,d,t){const r=m(t);return p($,{onData:a=>r.write(d.data(a)),onError:a=>r.error(d.error?d.error(a):a),onEnd:()=>r.end()}),r}e.$Cd=s;function n($,d,t){let r=!1;return{read:()=>{const a=d.read();return r?a:(r=!0,a!==null?t([$,a]):$)}}}e.$Dd=n;function h($,d,t){let r=!1;const a=m(t);return p(d,{onData:i=>r?a.write(i):(r=!0,a.write(t([$,i]))),onError:i=>a.error(i),onEnd:()=>{r||(r=!0,a.write($)),a.end()}}),a}e.$Ed=h}),define(Se[22],De([1,0,59,97]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=void 0;const g=typeof Buffer<"u",L=new D.$T(()=>new Uint8Array(256));let R,m;class k{static alloc(w){return g?new k(Buffer.allocUnsafe(w)):new k(new Uint8Array(w))}static wrap(w){return g&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new k(w)}static fromString(w,A){return!(A?.dontUseNodeBuffer||!1)&&g?new k(Buffer.from(w)):(R||(R=new TextEncoder),new k(R.encode(w)))}static fromByteArray(w){const A=k.alloc(w.length);for(let N=0,O=w.length;N<O;N++)A.buffer[N]=w[N];return A}static concat(w,A){if(typeof A>"u"){A=0;for(let F=0,j=w.length;F<j;F++)A+=w[F].byteLength}const N=k.alloc(A);let O=0;for(let F=0,j=w.length;F<j;F++){const z=w[F];N.set(z,O),O+=z.byteLength}return N}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=k.alloc(this.byteLength);return w.set(this),w}toString(){return g?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(w,A){return new k(this.buffer.subarray(w,A))}set(w,A){if(w instanceof k)this.buffer.set(w.buffer,A);else if(w instanceof Uint8Array)this.buffer.set(w,A);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),A);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return p(this.buffer,w)}writeUInt32BE(w,A){S(this.buffer,w,A)}readUInt32LE(w){return C(this.buffer,w)}writeUInt32LE(w,A){v(this.buffer,w,A)}readUInt8(w){return o(this.buffer,w)}writeUInt8(w,A){s(this.buffer,w,A)}indexOf(w,A=0){return b(this.buffer,w instanceof k?w.buffer:w,A)}}e.$Fd=k;function b(l,w,A=0){const N=w.byteLength,O=l.byteLength;if(N===0)return 0;if(N===1)return l.indexOf(w[0]);if(N>O-A)return-1;const F=L.value;F.fill(w.length);for(let H=0;H<w.length;H++)F[w[H]]=w.length-H-1;let j=A+w.length-1,z=j,T=-1;for(;j<O;)if(l[j]===w[z]){if(z===0){T=j;break}j--,z--}else j+=Math.max(w.length-z,F[l[j]]),z=w.length-1;return T}e.$Gd=b;function P(l,w){return l[w+0]<<0>>>0|l[w+1]<<8>>>0}e.$Hd=P;function I(l,w,A){l[A+0]=w&255,w=w>>>8,l[A+1]=w&255}e.$Id=I;function p(l,w){return l[w]*2**24+l[w+1]*2**16+l[w+2]*2**8+l[w+3]}e.$Jd=p;function S(l,w,A){l[A+3]=w,w=w>>>8,l[A+2]=w,w=w>>>8,l[A+1]=w,w=w>>>8,l[A]=w}e.$Kd=S;function C(l,w){return l[w+0]<<0>>>0|l[w+1]<<8>>>0|l[w+2]<<16>>>0|l[w+3]<<24>>>0}e.$Ld=C;function v(l,w,A){l[A+0]=w&255,w=w>>>8,l[A+1]=w&255,w=w>>>8,l[A+2]=w&255,w=w>>>8,l[A+3]=w&255}e.$Md=v;function o(l,w){return l[w]}e.$Nd=o;function s(l,w,A){l[A]=w}e.$Od=s;function n(l){return M.$ud(l,w=>k.concat(w))}e.$Pd=n;function h(l){return M.$Bd(l)}e.$Qd=h;function $(l){return M.$wd(l,w=>k.concat(w))}e.$Rd=$;async function d(l){return l.ended?k.concat(l.buffer):k.concat([...l.buffer,await $(l.stream)])}e.$Sd=d;function t(l){return M.$zd(l,w=>k.concat(w))}e.$Td=t;function r(l){return M.$Cd(l,{data:w=>typeof w=="string"?k.fromString(w):k.wrap(w)},w=>k.concat(w))}e.$Ud=r;function a(l){return M.$td(w=>k.concat(w),l)}e.$Vd=a;function i(l,w){return M.$Dd(l,w,A=>k.concat(A))}e.$Wd=i;function c(l,w){return M.$Ed(l,w,A=>k.concat(A))}e.$Xd=c;function f(l){let w=0,A=0,N=0;const O=new Uint8Array(Math.floor(l.length/4*3)),F=z=>{switch(A){case 3:O[N++]=w|z,A=0;break;case 2:O[N++]=w|z>>>2,w=z<<6,A=3;break;case 1:O[N++]=w|z>>>4,w=z<<4,A=2;break;default:w=z<<2,A=1}};for(let z=0;z<l.length;z++){const T=l.charCodeAt(z);if(T>=65&&T<=90)F(T-65);else if(T>=97&&T<=122)F(T-97+26);else if(T>=48&&T<=57)F(T-48+52);else if(T===43||T===45)F(62);else if(T===47||T===95)F(63);else{if(T===61)break;throw new SyntaxError(`Unexpected base64 character ${l[z]}`)}}const j=N;for(;A>0;)F(0);return k.wrap(O).slice(0,j)}e.$Yd=f;const y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:l},w=!0,A=!1){const N=A?E:y;let O="";const F=l.byteLength%3;let j=0;for(;j<l.byteLength-F;j+=3){const z=l[j+0],T=l[j+1],H=l[j+2];O+=N[z>>>2],O+=N[(z<<4|T>>>4)&63],O+=N[(T<<2|H>>>6)&63],O+=N[H&63]}if(F===1){const z=l[j+0];O+=N[z>>>2],O+=N[z<<4&63],w&&(O+="==")}else if(F===2){const z=l[j+0],T=l[j+1];O+=N[z>>>2],O+=N[(z<<4|T>>>4)&63],O+=N[T<<2&63],w&&(O+="=")}return O}e.$Zd=u}),define(Se[15],De([1,0,159,59]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$if=e.$hf=e.$gf=e.$ff=e.GraphemeBreakType=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=void 0;function g(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$me=g;const L=/{(\d+)}/g;function R(Ae,...Oe){return Oe.length===0?Ae:Ae.replace(L,function(Ve,Le){const Ze=parseInt(Le,10);return isNaN(Ze)||Ze<0||Ze>=Oe.length?Ve:Oe[Ze]})}e.$ne=R;const m=/{([^}]+)}/g;function k(Ae,Oe){return Ae.replace(m,(Ve,Le)=>Oe[Le]??Ve)}e.$oe=k;function b(Ae){return Ae.replace(/[<>&]/g,function(Oe){switch(Oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Oe}})}e.$pe=b;function P(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$qe=P;function I(Ae,Oe){let Ve=0;const Le=Oe.charCodeAt(0);for(let Ze=Ae.length-1;Ze>=0;Ze--)Ae.charCodeAt(Ze)===Le&&Ve++;return Ve}e.$re=I;function p(Ae,Oe,Ve="\u2026"){return Ae.length<=Oe?Ae:`${Ae.substr(0,Oe)}${Ve}`}e.$se=p;function S(Ae,Oe=" "){const Ve=C(Ae,Oe);return v(Ve,Oe)}e.$te=S;function C(Ae,Oe){if(!Ae||!Oe)return Ae;const Ve=Oe.length;if(Ve===0||Ae.length===0)return Ae;let Le=0;for(;Ae.indexOf(Oe,Le)===Le;)Le=Le+Ve;return Ae.substring(Le)}e.$ue=C;function v(Ae,Oe){if(!Ae||!Oe)return Ae;const Ve=Oe.length,Le=Ae.length;if(Ve===0||Le===0)return Ae;let Ze=Le,ce=-1;for(;ce=Ae.lastIndexOf(Oe,Ze-1),!(ce===-1||ce+Ve!==Ze);){if(ce===0)return"";Ze=ce}return Ae.substring(0,Ze)}e.$ve=v;function o(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$we=o;function s(Ae){return Ae.replace(/\*/g,"")}e.$xe=s;function n(Ae,Oe,Ve={}){if(!Ae)throw new Error("Cannot create regex from empty string");Oe||(Ae=P(Ae)),Ve.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Le="";return Ve.global&&(Le+="g"),Ve.matchCase||(Le+="i"),Ve.multiline&&(Le+="m"),Ve.unicode&&(Le+="u"),new RegExp(Ae,Le)}e.$ye=n;function h(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$ze=h;function $(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Ae=$;function d(Ae){for(let Oe=0,Ve=Ae.length;Oe<Ve;Oe++){const Le=Ae.charCodeAt(Oe);if(Le!==32&&Le!==9)return Oe}return-1}e.$Be=d;function t(Ae,Oe=0,Ve=Ae.length){for(let Le=Oe;Le<Ve;Le++){const Ze=Ae.charCodeAt(Le);if(Ze!==32&&Ze!==9)return Ae.substring(Oe,Le)}return Ae.substring(Oe,Ve)}e.$Ce=t;function r(Ae,Oe=Ae.length-1){for(let Ve=Oe;Ve>=0;Ve--){const Le=Ae.charCodeAt(Ve);if(Le!==32&&Le!==9)return Ve}return-1}e.$De=r;function a(Ae,Oe,Ve){const Le=[];let Ze=0;for(const ce of Ae.matchAll(Oe)){if(Le.push(Ae.slice(Ze,ce.index)),ce.index===void 0)throw new Error("match.index should be defined");Ze=ce.index+ce[0].length,Le.push(Ve(ce[0],...ce.slice(1),ce.index,Ae,ce.groups))}return Le.push(Ae.slice(Ze)),Promise.all(Le).then(ce=>ce.join(""))}e.$Ee=a;function i(Ae,Oe){return Ae<Oe?-1:Ae>Oe?1:0}e.$Fe=i;function c(Ae,Oe,Ve=0,Le=Ae.length,Ze=0,ce=Oe.length){for(;Ve<Le&&Ze<ce;Ve++,Ze++){const qe=Ae.charCodeAt(Ve),Ue=Oe.charCodeAt(Ze);if(qe<Ue)return-1;if(qe>Ue)return 1}const ae=Le-Ve,Ce=ce-Ze;return ae<Ce?-1:ae>Ce?1:0}e.$Ge=c;function f(Ae,Oe){return y(Ae,Oe,0,Ae.length,0,Oe.length)}e.$He=f;function y(Ae,Oe,Ve=0,Le=Ae.length,Ze=0,ce=Oe.length){for(;Ve<Le&&Ze<ce;Ve++,Ze++){let qe=Ae.charCodeAt(Ve),Ue=Oe.charCodeAt(Ze);if(qe===Ue)continue;if(qe>=128||Ue>=128)return c(Ae.toLowerCase(),Oe.toLowerCase(),Ve,Le,Ze,ce);u(qe)&&(qe-=32),u(Ue)&&(Ue-=32);const Xe=qe-Ue;if(Xe!==0)return Xe}const ae=Le-Ve,Ce=ce-Ze;return ae<Ce?-1:ae>Ce?1:0}e.$Ie=y;function E(Ae){return Ae>=48&&Ae<=57}e.$Je=E;function u(Ae){return Ae>=97&&Ae<=122}e.$Ke=u;function l(Ae){return Ae>=65&&Ae<=90}e.$Le=l;function w(Ae,Oe){return Ae.length===Oe.length&&y(Ae,Oe)===0}e.$Me=w;function A(Ae,Oe){const Ve=Oe.length;return Oe.length>Ae.length?!1:y(Ae,Oe,0,Ve)===0}e.$Ne=A;function N(Ae,Oe){const Ve=Math.min(Ae.length,Oe.length);let Le;for(Le=0;Le<Ve;Le++)if(Ae.charCodeAt(Le)!==Oe.charCodeAt(Le))return Le;return Ve}e.$Oe=N;function O(Ae,Oe){const Ve=Math.min(Ae.length,Oe.length);let Le;const Ze=Ae.length-1,ce=Oe.length-1;for(Le=0;Le<Ve;Le++)if(Ae.charCodeAt(Ze-Le)!==Oe.charCodeAt(ce-Le))return Le;return Ve}e.$Pe=O;function F(Ae){return 55296<=Ae&&Ae<=56319}e.$Qe=F;function j(Ae){return 56320<=Ae&&Ae<=57343}e.$Re=j;function z(Ae,Oe){return(Ae-55296<<10)+(Oe-56320)+65536}e.$Se=z;function T(Ae,Oe,Ve){const Le=Ae.charCodeAt(Ve);if(F(Le)&&Ve+1<Oe){const Ze=Ae.charCodeAt(Ve+1);if(j(Ze))return z(Le,Ze)}return Le}e.$Te=T;function H(Ae,Oe){const Ve=Ae.charCodeAt(Oe-1);if(j(Ve)&&Oe>1){const Le=Ae.charCodeAt(Oe-2);if(F(Le))return z(Le,Ve)}return Ve}class q{get offset(){return this.e}constructor(Oe,Ve=0){this.c=Oe,this.d=Oe.length,this.e=Ve}setOffset(Oe){this.e=Oe}prevCodePoint(){const Oe=H(this.c,this.e);return this.e-=Oe>=65536?2:1,Oe}nextCodePoint(){const Oe=T(this.c,this.d,this.e);return this.e+=Oe>=65536?2:1,Oe}eol(){return this.e>=this.d}}e.$Ue=q;class me{get offset(){return this.c.offset}constructor(Oe,Ve=0){this.c=new q(Oe,Ve)}nextGraphemeLength(){const Oe=de.getInstance(),Ve=this.c,Le=Ve.offset;let Ze=Oe.getGraphemeBreakType(Ve.nextCodePoint());for(;!Ve.eol();){const ce=Ve.offset,ae=Oe.getGraphemeBreakType(Ve.nextCodePoint());if(se(Ze,ae)){Ve.setOffset(ce);break}Ze=ae}return Ve.offset-Le}prevGraphemeLength(){const Oe=de.getInstance(),Ve=this.c,Le=Ve.offset;let Ze=Oe.getGraphemeBreakType(Ve.prevCodePoint());for(;Ve.offset>0;){const ce=Ve.offset,ae=Oe.getGraphemeBreakType(Ve.prevCodePoint());if(se(ae,Ze)){Ve.setOffset(ce);break}Ze=ae}return Le-Ve.offset}eol(){return this.c.eol()}}e.$Ve=me;function X(Ae,Oe){return new me(Ae,Oe).nextGraphemeLength()}e.$We=X;function Z(Ae,Oe){return new me(Ae,Oe).prevGraphemeLength()}e.$Xe=Z;function V(Ae,Oe){Oe>0&&j(Ae.charCodeAt(Oe))&&Oe--;const Ve=Oe+X(Ae,Oe);return[Ve-Z(Ae,Ve),Ve]}e.$Ye=V;function x(Ae){const Oe=new me(Ae);let Ve=0;for(;!Oe.eol();)Ve++,Oe.nextGraphemeLength();return Ve}e.$Ze=x;let ge;function ue(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function we(Ae){return ge||(ge=ue()),ge.test(Ae)}e.$1e=we;const G=/^[\t\n\r\x20-\x7E]*$/;function U(Ae){return G.test(Ae)}e.$2e=U,e.$3e=/[\u2028\u2029]/;function K(Ae){return e.$3e.test(Ae)}e.$4e=K;function fe(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$5e=fe;function te(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$6e=te;function re(Ae,Oe){if(Ae.length<Oe)return Ae;const Ve=/\b/g;let Le=0;for(;Ve.test(Ae)&&!(Ae.length-Ve.lastIndex<Oe);)Le=Ve.lastIndex,Ve.lastIndex+=1;return Ae.substring(Le).replace(/^\s/,"")}e.$7e=re;const ne=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Ee=/\x1b\].*?\x07/g;function oe(Ae){return Ae&&(Ae=Ae.replace(ne,"").replace(Ee,"")),Ae}e.$8e=oe,e.$9e=String.fromCharCode(65279);function he(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$0e=he;function ee(Ae){return he(Ae)?Ae.substr(1):Ae}e.$$e=ee;function le(Ae,Oe){if(!Ae||!Oe||Ae.length<Oe.length)return!1;const Ve=Oe.length,Le=Ae.toLowerCase();let Ze=0,ce=-1;for(;Ze<Ve;){const ae=Le.indexOf(Oe[Ze],ce+1);if(ae<0)return!1;ce=ae,Ze++}return!0}e.$_e=le;function be(Ae,Oe=!1){return Ae?(Oe&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$af=be;function Ie(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$bf=Ie;function B(Ae,Oe=1){if(Oe===0)return"";let Ve=-1;do Ve=Ae.indexOf(`
`,Ve+1),Oe--;while(Oe>0&&Ve>=0);return Ve===-1?Ae:(Ae[Ve-1]==="\r"&&Ve--,Ae.substr(0,Ve))}e.$cf=B;function Q(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$df=Q;function ie(Ae){return de.getInstance().getGraphemeBreakType(Ae)}e.$ef=ie;function se(Ae,Oe){return Ae===0?Oe!==5&&Oe!==7:Ae===2&&Oe===3?!1:Ae===4||Ae===2||Ae===3||Oe===4||Oe===2||Oe===3?!0:!(Ae===8&&(Oe===8||Oe===9||Oe===11||Oe===12)||(Ae===11||Ae===9)&&(Oe===9||Oe===10)||(Ae===12||Ae===10)&&Oe===10||Oe===5||Oe===13||Oe===7||Ae===1||Ae===13&&Oe===14||Ae===6&&Oe===6)}var Y;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(Y||(e.GraphemeBreakType=Y={}));class de{static{this.c=null}static getInstance(){return de.c||(de.c=new de),de.c}constructor(){this.d=ye()}getGraphemeBreakType(Oe){if(Oe<32)return Oe===10?3:Oe===13?2:4;if(Oe<127)return 0;const Ve=this.d,Le=Ve.length/3;let Ze=1;for(;Ze<=Le;)if(Oe<Ve[3*Ze])Ze=2*Ze;else if(Oe>Ve[3*Ze+1])Ze=2*Ze+1;else return Ve[3*Ze+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(Ae,Oe){if(Ae===0)return 0;const Ve=We(Ae,Oe);if(Ve!==void 0)return Ve;const Le=new q(Oe,Ae);return Le.prevCodePoint(),Le.offset}e.$ff=je;function We(Ae,Oe){const Ve=new q(Oe,Ae);let Le=Ve.prevCodePoint();for(;_e(Le)||Le===65039||Le===8419;){if(Ve.offset===0)return;Le=Ve.prevCodePoint()}if(!te(Le))return;let Ze=Ve.offset;return Ze>0&&Ve.prevCodePoint()===8205&&(Ze=Ve.offset),Ze}function _e(Ae){return 127995<=Ae&&Ae<=127999}var Ye;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.$gf="\xA0";class it{static{this.c=new M.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$ie(Oe=>{function Ve(Xe){const rt=new Map;for(let at=0;at<Xe.length;at+=2)rt.set(Xe[at],Xe[at+1]);return rt}function Le(Xe,rt){const at=new Map(Xe);for(const[$t,St]of rt)at.set($t,St);return at}function Ze(Xe,rt){if(!Xe)return rt;const at=new Map;for(const[$t,St]of Xe)rt.has($t)&&at.set($t,St);return at}const ce=this.c.value;let ae=Oe.filter(Xe=>!Xe.startsWith("_")&&Xe in ce);ae.length===0&&(ae=["_default"]);let Ce;for(const Xe of ae){const rt=Ve(ce[Xe]);Ce=Ze(Ce,rt)}const qe=Ve(ce._common),Ue=Le(qe,Ce);return new it(Ue)})}static getInstance(Oe){return it.d.get(Array.from(Oe))}static{this.e=new M.$T(()=>Object.keys(it.c.value).filter(Oe=>!Oe.startsWith("_")))}static getLocales(){return it.e.value}constructor(Oe){this.f=Oe}isAmbiguous(Oe){return this.f.has(Oe)}getPrimaryConfusable(Oe){return this.f.get(Oe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$hf=it;class et{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(et.c())),this.d}static isInvisibleCharacter(Oe){return et.e().has(Oe)}static get codePoints(){return et.e()}}e.$if=et}),define(Se[121],De([1,0,28,15]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.FuzzyScore=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.or=void 0;function g(...ee){return function(le,be){for(let Ie=0,B=ee.length;Ie<B;Ie++){const Q=ee[Ie](le,be);if(Q)return Q}return null}}e.or=g,e.$xj=L.bind(void 0,!1),e.$yj=L.bind(void 0,!0);function L(ee,le,be){if(!be||be.length<le.length)return null;let Ie;return ee?Ie=M.$Ne(be,le):Ie=be.indexOf(le)===0,Ie?le.length>0?[{start:0,end:le.length}]:[]:null}function R(ee,le){const be=le.toLowerCase().indexOf(ee.toLowerCase());return be===-1?null:[{start:be,end:be+ee.length}]}e.$zj=R;function m(ee,le){return k(ee.toLowerCase(),le.toLowerCase(),0,0)}e.$Aj=m;function k(ee,le,be,Ie){if(be===ee.length)return[];if(Ie===le.length)return null;if(ee[be]===le[Ie]){let B=null;return(B=k(ee,le,be+1,Ie+1))?s({start:Ie,end:Ie+1},B):null}return k(ee,le,be,Ie+1)}function b(ee){return 97<=ee&&ee<=122}function P(ee){return 65<=ee&&ee<=90}e.$Bj=P;function I(ee){return 48<=ee&&ee<=57}function p(ee){return ee===32||ee===9||ee===10||ee===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>S.add(ee.charCodeAt(0)));function C(ee){return p(ee)||S.has(ee)}function v(ee,le){return ee===le||C(ee)&&C(le)}function o(ee){return b(ee)||P(ee)||I(ee)}function s(ee,le){return le.length===0?le=[ee]:ee.end===le[0].start?le[0].start=ee.start:le.unshift(ee),le}function n(ee,le){for(let be=le;be<ee.length;be++){const Ie=ee.charCodeAt(be);if(P(Ie)||I(Ie)||be>0&&!o(ee.charCodeAt(be-1)))return be}return ee.length}function h(ee,le,be,Ie){if(be===ee.length)return[];if(Ie===le.length)return null;if(ee[be]!==le[Ie].toLowerCase())return null;{let B=null,Q=Ie+1;for(B=h(ee,le,be+1,Ie+1);!B&&(Q=n(le,Q))<le.length;)B=h(ee,le,be+1,Q),Q++;return B===null?null:s({start:Ie,end:Ie+1},B)}}function $(ee){let le=0,be=0,Ie=0,B=0,Q=0;for(let ye=0;ye<ee.length;ye++)Q=ee.charCodeAt(ye),P(Q)&&le++,b(Q)&&be++,o(Q)&&Ie++,I(Q)&&B++;const ie=le/ee.length,se=be/ee.length,Y=Ie/ee.length,de=B/ee.length;return{upperPercent:ie,lowerPercent:se,alphaPercent:Y,numericPercent:de}}function d(ee){const{upperPercent:le,lowerPercent:be}=ee;return be===0&&le>.6}function t(ee){const{upperPercent:le,lowerPercent:be,alphaPercent:Ie,numericPercent:B}=ee;return be>.2&&le<.8&&Ie>.6&&B<.2}function r(ee){let le=0,be=0,Ie=0,B=0;for(let Q=0;Q<ee.length;Q++)Ie=ee.charCodeAt(Q),P(Ie)&&le++,b(Ie)&&be++,p(Ie)&&B++;return(le===0||be===0)&&B===0?ee.length<=30:le<=5}function a(ee,le){if(!le||(le=le.trim(),le.length===0)||!r(ee)||le.length>60)return null;const be=$(le);if(!t(be)){if(!d(be))return null;le=le.toLowerCase()}let Ie=null,B=0;for(ee=ee.toLowerCase();B<le.length&&(Ie=h(ee,le,0,B))===null;)B=n(le,B+1);return Ie}e.$Cj=a;function i(ee,le,be=!1){if(!le||le.length===0)return null;let Ie=null,B=0;for(ee=ee.toLowerCase(),le=le.toLowerCase();B<le.length&&(Ie=c(ee,le,0,B,be))===null;)B=f(le,B+1);return Ie}e.$Dj=i;function c(ee,le,be,Ie,B){if(be===ee.length)return[];if(Ie===le.length)return null;if(v(ee.charCodeAt(be),le.charCodeAt(Ie))){let Q=null,ie=Ie+1;if(Q=c(ee,le,be+1,Ie+1,B),!B)for(;!Q&&(ie=f(le,ie))<le.length;)Q=c(ee,le,be+1,ie,B),ie++;return Q?ee.charCodeAt(be)!==le.charCodeAt(Ie)?Q:s({start:Ie,end:Ie+1},Q):null}else return null}function f(ee,le){for(let be=le;be<ee.length;be++)if(C(ee.charCodeAt(be))||be>0&&C(ee.charCodeAt(be-1)))return be;return ee.length}const y=g(e.$yj,a,R),E=g(e.$yj,a,m),u=new D.$Ci(1e4);function l(ee,le,be=!1){if(typeof ee!="string"||typeof le!="string")return null;let Ie=u.get(ee);Ie||(Ie=new RegExp(M.$we(ee),"i"),u.set(ee,Ie));const B=Ie.exec(le);return B?[{start:B.index,end:B.index+B[0].length}]:be?E(ee,le):y(ee,le)}e.$Ej=l;function w(ee,le){const be=fe(ee,ee.toLowerCase(),0,le,le.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return be?N(be):null}e.$Fj=w;function A(ee,le,be,Ie,B,Q){const ie=Math.min(13,ee.length);for(;be<ie;be++){const se=fe(ee,le,be,Ie,B,Q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(se)return se}return[0,Q]}e.$Gj=A;function N(ee){if(typeof ee>"u")return[];const le=[],be=ee[1];for(let Ie=ee.length-1;Ie>1;Ie--){const B=ee[Ie]+be,Q=le[le.length-1];Q&&Q.end===B?Q.end=B+1:le.push({start:B,end:B+1})}return le}e.$Hj=N;const O=128;function F(){const ee=[],le=[];for(let be=0;be<=O;be++)le[be]=0;for(let be=0;be<=O;be++)ee.push(le.slice(0));return ee}function j(ee){const le=[];for(let be=0;be<=ee;be++)le[be]=0;return le}const z=j(2*O),T=j(2*O),H=F(),q=F(),me=F(),X=!1;function Z(ee,le,be,Ie,B){function Q(se,Y,de=" "){for(;se.length<Y;)se=de+se;return se}let ie=` |   |${Ie.split("").map(se=>Q(se,3)).join("|")}
`;for(let se=0;se<=be;se++)se===0?ie+=" |":ie+=`${le[se-1]}|`,ie+=ee[se].slice(0,B+1).map(Y=>Q(Y.toString(),3)).join("|")+`
`;return ie}function V(ee,le,be,Ie){ee=ee.substr(le),be=be.substr(Ie),console.log(Z(q,ee,ee.length,be,be.length)),console.log(Z(me,ee,ee.length,be,be.length)),console.log(Z(H,ee,ee.length,be,be.length))}function x(ee,le){if(le<0||le>=ee.length)return!1;const be=ee.codePointAt(le);switch(be){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$6e(be)}}function ge(ee,le){if(le<0||le>=ee.length)return!1;switch(ee.charCodeAt(le)){case 32:case 9:return!0;default:return!1}}function ue(ee,le,be){return le[ee]!==be[ee]}function we(ee,le,be,Ie,B,Q,ie=!1){for(;le<be&&B<Q;)ee[le]===Ie[B]&&(ie&&(z[le]=B),le+=1),B+=1;return le===be}e.$Ij=we;var G;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(G||(G={}));var U;(function(ee){ee.Default=[-100,0];function le(be){return!be||be.length===2&&be[0]===-100&&be[1]===0}ee.isDefault=le})(U||(e.FuzzyScore=U={}));class K{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(le,be){this.firstMatchCanBeWeak=le,this.boostFullMatch=be}}e.$Jj=K;function fe(ee,le,be,Ie,B,Q,ie=K.default){const se=ee.length>O?O:ee.length,Y=Ie.length>O?O:Ie.length;if(be>=se||Q>=Y||se-be>Y-Q||!we(le,be,se,B,Q,Y,!0))return;te(se,Y,be,Q,le,B);let de=1,ye=1,je=be,We=Q;const _e=[!1];for(de=1,je=be;je<se;de++,je++){const Oe=z[je],Ve=T[je],Le=je+1<se?T[je+1]:Y;for(ye=Oe-Q+1,We=Oe;We<Le;ye++,We++){let Ze=Number.MIN_SAFE_INTEGER,ce=!1;We<=Ve&&(Ze=re(ee,le,je,be,Ie,B,We,Y,Q,H[de-1][ye-1]===0,_e));let ae=0;Ze!==Number.MAX_SAFE_INTEGER&&(ce=!0,ae=Ze+q[de-1][ye-1]);const Ce=We>Oe,qe=Ce?q[de][ye-1]+(H[de][ye-1]>0?-5:0):0,Ue=We>Oe+1&&H[de][ye-1]>0,Xe=Ue?q[de][ye-2]+(H[de][ye-2]>0?-5:0):0;if(Ue&&(!Ce||Xe>=qe)&&(!ce||Xe>=ae))q[de][ye]=Xe,me[de][ye]=3,H[de][ye]=0;else if(Ce&&(!ce||qe>=ae))q[de][ye]=qe,me[de][ye]=2,H[de][ye]=0;else if(ce)q[de][ye]=ae,me[de][ye]=1,H[de][ye]=H[de-1][ye-1]+1;else throw new Error("not possible")}}if(X&&V(ee,be,Ie,Q),!_e[0]&&!ie.firstMatchCanBeWeak)return;de--,ye--;const Ye=[q[de][ye],Q];let it=0,et=0;for(;de>=1;){let Oe=ye;do{const Ve=me[de][Oe];if(Ve===3)Oe=Oe-2;else if(Ve===2)Oe=Oe-1;else break}while(Oe>=1);it>1&&le[be+de-1]===B[Q+ye-1]&&!ue(Oe+Q-1,Ie,B)&&it+1>H[de][Oe]&&(Oe=ye),Oe===ye?it++:it=1,et||(et=Oe),de--,ye=Oe-1,Ye.push(ye)}Y===se&&ie.boostFullMatch&&(Ye[0]+=2);const Ae=et-se;return Ye[0]-=Ae,Ye}e.$Kj=fe;function te(ee,le,be,Ie,B,Q){let ie=ee-1,se=le-1;for(;ie>=be&&se>=Ie;)B[ie]===Q[se]&&(T[ie]=se,ie--),se--}function re(ee,le,be,Ie,B,Q,ie,se,Y,de,ye){if(le[be]!==Q[ie])return Number.MIN_SAFE_INTEGER;let je=1,We=!1;return ie===be-Ie?je=ee[be]===B[ie]?7:5:ue(ie,B,Q)&&(ie===0||!ue(ie-1,B,Q))?(je=ee[be]===B[ie]?7:5,We=!0):x(Q,ie)&&(ie===0||!x(Q,ie-1))?je=5:(x(Q,ie-1)||ge(Q,ie-1))&&(je=5,We=!0),je>1&&be===Ie&&(ye[0]=!0),We||(We=ue(ie,B,Q)||x(Q,ie-1)||ge(Q,ie-1)),be===Ie?ie>Y&&(je-=We?3:5):de?je+=We?2:0:je+=We?0:1,ie+1===se&&(je-=We?3:5),je}function ne(ee,le,be,Ie,B,Q,ie){return oe(ee,le,be,Ie,B,Q,!0,ie)}e.$Lj=ne;function Ee(ee,le,be,Ie,B,Q,ie){return oe(ee,le,be,Ie,B,Q,!1,ie)}e.$Mj=Ee;function oe(ee,le,be,Ie,B,Q,ie,se){let Y=fe(ee,le,be,Ie,B,Q,se);if(Y&&!ie)return Y;if(ee.length>=3){const de=Math.min(7,ee.length-1);for(let ye=be+1;ye<de;ye++){const je=he(ee,ye);if(je){const We=fe(je,je.toLowerCase(),be,Ie,B,Q,se);We&&(We[0]-=3,(!Y||We[0]>Y[0])&&(Y=We))}}}return Y}function he(ee,le){if(le+1>=ee.length)return;const be=ee[le],Ie=ee[le+1];if(be!==Ie)return ee.slice(0,le)+Ie+be+ee.slice(le+2)}}),define(Se[51],De([1,0,15]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=void 0;function M(s){return g(s,0)}e.$pi=M;function g(s,n){switch(typeof s){case"object":return s===null?L(349,n):Array.isArray(s)?k(s,n):b(s,n);case"string":return m(s,n);case"boolean":return R(s,n);case"number":return L(s,n);case"undefined":return L(937,n);default:return L(617,n)}}e.$qi=g;function L(s,n){return(n<<5)-n+s|0}e.$ri=L;function R(s,n){return L(s?433:863,n)}function m(s,n){n=L(149417,n);for(let h=0,$=s.length;h<$;h++)n=L(s.charCodeAt(h),n);return n}e.$si=m;function k(s,n){return n=L(104579,n),s.reduce((h,$)=>g($,h),n)}function b(s,n){return n=L(181387,n),Object.keys(s).sort().reduce((h,$)=>(h=m($,h),g(s[$],h)),n)}class P{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=g(n,this.g),this.g}}e.$ti=P;var I;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function p(s,n,h=32){const $=h-n,d=~((1<<$)-1);return(s<<n|(d&s)>>>$)>>>0}function S(s,n=0,h=s.byteLength,$=0){for(let d=0;d<h;d++)s[n+d]=$}function C(s,n,h="0"){for(;s.length<n;)s=h+s;return s}function v(s,n=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(h=>h.toString(16).padStart(2,"0")).join(""):C((s>>>0).toString(16),n/4)}e.$ui=v;class o{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const h=n.length;if(h===0)return;const $=this.p;let d=this.r,t=this.u,r,a;for(t!==0?(r=t,a=-1,t=0):(r=n.charCodeAt(0),a=0);;){let i=r;if(D.$Qe(r))if(a+1<h){const c=n.charCodeAt(a+1);D.$Re(c)?(a++,i=D.$Se(r,c)):i=65533}else{t=r;break}else D.$Re(r)&&(i=65533);if(d=this.w($,d,i),a++,a<h)r=n.charCodeAt(a);else break}this.r=d,this.u=t}w(n,h,$){return $<128?n[h++]=$:$<2048?(n[h++]=192|($&1984)>>>6,n[h++]=128|($&63)>>>0):$<65536?(n[h++]=224|($&61440)>>>12,n[h++]=128|($&4032)>>>6,n[h++]=128|($&63)>>>0):(n[h++]=240|($&1835008)>>>18,n[h++]=128|($&258048)>>>12,n[h++]=128|($&4032)>>>6,n[h++]=128|($&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,S(this.p,this.r),this.r>56&&(this.y(),S(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=o.g,h=this.q;for(let y=0;y<64;y+=4)n.setUint32(y,h.getUint32(y,!1),!1);for(let y=64;y<320;y+=4)n.setUint32(y,p(n.getUint32(y-12,!1)^n.getUint32(y-32,!1)^n.getUint32(y-56,!1)^n.getUint32(y-64,!1),1),!1);let $=this.h,d=this.l,t=this.m,r=this.n,a=this.o,i,c,f;for(let y=0;y<80;y++)y<20?(i=d&t|~d&r,c=1518500249):y<40?(i=d^t^r,c=1859775393):y<60?(i=d&t|d&r|t&r,c=2400959708):(i=d^t^r,c=3395469782),f=p($,5)+i+a+c+n.getUint32(y*4,!1)&4294967295,a=r,r=t,t=p(d,30),d=$,$=f;this.h=this.h+$&4294967295,this.l=this.l+d&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+a&4294967295}}e.$vi=o}),define(Se[38],De([1,0,15]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(g){g[g.Ignore=0]="Ignore",g[g.Info=1]="Info",g[g.Warning=2]="Warning",g[g.Error=3]="Error"})(M||(M={})),function(g){const L="error",R="warning",m="warn",k="info",b="ignore";function P(p){return p?D.$Me(L,p)?g.Error:D.$Me(R,p)||D.$Me(m,p)?g.Warning:D.$Me(k,p)?g.Info:g.Ignore:g.Ignore}g.fromValue=P;function I(p){switch(p){case g.Error:return L;case g.Warning:return R;case g.Info:return k;default:return b}}g.toString=I}(M||(M={})),e.default=M}),define(Se[160],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cd=void 0,e.$cd=Symbol("MicrotaskDelay")}),define(Se[78],De([1,0,19,15]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=void 0;class g{constructor(){this.b="",this.c=0}reset(S){return this.b=S,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(S){const C=S.charCodeAt(0),v=this.b.charCodeAt(this.c);return C-v}value(){return this.b[this.c]}}e.$Dh=g;class L{constructor(S=!0){this.e=S}reset(S){return this.b=S,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let S=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(S)this.c++;else break;else S=!1;return this}cmp(S){return this.e?(0,M.$Ge)(S,this.b,0,S.length,this.c,this.d):(0,M.$Ie)(S,this.b,0,S.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Eh=L;class R{constructor(S=!0,C=!0){this.f=S,this.g=C}reset(S){this.d=0,this.e=0,this.b=S,this.c=S.length;for(let C=S.length-1;C>=0;C--,this.c--){const v=this.b.charCodeAt(C);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let S=!0;for(;this.e<this.c;this.e++){const C=this.b.charCodeAt(this.e);if(C===47||this.f&&C===92)if(S)this.d++;else break;else S=!1}return this}cmp(S){return this.g?(0,M.$Ge)(S,this.b,0,S.length,this.d,this.e):(0,M.$Ie)(S,this.b,0,S.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Fh=R;var m;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(m||(m={}));class k{constructor(S,C){this.f=S,this.g=C,this.d=[],this.e=0}reset(S){return this.c=S,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(S)),this.b.reset(S.path),this.b.value()&&this.d.push(3)),this.g(S)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(S){if(this.d[this.e]===1)return(0,M.$He)(S,this.c.scheme);if(this.d[this.e]===2)return(0,M.$He)(S,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(S);if(this.d[this.e]===4)return(0,M.$Fe)(S,this.c.query);if(this.d[this.e]===5)return(0,M.$Fe)(S,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Gh=k;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const S=this.right;return this.right=S.left,S.left=this,this.updateHeight(),S.updateHeight(),S}rotateRight(){const S=this.left;return this.left=S.right,S.right=this,this.updateHeight(),S.updateHeight(),S}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(P||(P={}));class I{static forUris(S=()=>!1,C=()=>!1){return new I(new k(S,C))}static forPaths(S=!1){return new I(new R(void 0,!S))}static forStrings(){return new I(new g)}static forConfigKeys(){return new I(new L)}constructor(S){this.b=S}clear(){this.c=void 0}fill(S,C){if(C){const v=C.slice(0);(0,D.$Vb)(v);for(const o of v)this.set(o,S)}else{const v=S.slice(0);(0,D.$Vb)(v);for(const o of v)this.set(o[0],o[1])}}set(S,C){const v=this.b.reset(S);let o;this.c||(this.c=new b,this.c.segment=v.value());const s=[];for(o=this.c;;){const h=v.cmp(o.segment);if(h>0)o.left||(o.left=new b,o.left.segment=v.value()),s.push([-1,o]),o=o.left;else if(h<0)o.right||(o.right=new b,o.right.segment=v.value()),s.push([1,o]),o=o.right;else if(v.hasNext())v.next(),o.mid||(o.mid=new b,o.mid.segment=v.value()),s.push([0,o]),o=o.mid;else break}const n=o.value;o.value=C,o.key=S;for(let h=s.length-1;h>=0;h--){const $=s[h][1];$.updateHeight();const d=$.balanceFactor();if(d<-1||d>1){const t=s[h][0],r=s[h+1][0];if(t===1&&r===1)s[h][1]=$.rotateLeft();else if(t===-1&&r===-1)s[h][1]=$.rotateRight();else if(t===1&&r===-1)$.right=s[h+1][1]=s[h+1][1].rotateRight(),s[h][1]=$.rotateLeft();else if(t===-1&&r===1)$.left=s[h+1][1]=s[h+1][1].rotateLeft(),s[h][1]=$.rotateRight();else throw new Error;if(h>0)switch(s[h-1][0]){case-1:s[h-1][1].left=s[h][1];break;case 1:s[h-1][1].right=s[h][1];break;case 0:s[h-1][1].mid=s[h][1];break}else this.c=s[0][1]}}return n}get(S){return this.d(S)?.value}d(S){const C=this.b.reset(S);let v=this.c;for(;v;){const o=C.cmp(v.segment);if(o>0)v=v.left;else if(o<0)v=v.right;else if(C.hasNext())C.next(),v=v.mid;else break}return v}has(S){const C=this.d(S);return!(C?.value===void 0&&C?.mid===void 0)}delete(S){return this.e(S,!1)}deleteSuperstr(S){return this.e(S,!0)}e(S,C){const v=this.b.reset(S),o=[];let s=this.c;for(;s;){const n=v.cmp(s.segment);if(n>0)o.push([-1,s]),s=s.left;else if(n<0)o.push([1,s]),s=s.right;else if(v.hasNext())v.next(),o.push([0,s]),s=s.mid;else break}if(s){if(C?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const n=this.f(s.right);if(n.key){const{key:h,value:$,segment:d}=n;this.e(n.key,!1),s.key=h,s.value=$,s.segment=d}}else{const n=s.left??s.right;if(o.length>0){const[h,$]=o[o.length-1];switch(h){case-1:$.left=n;break;case 0:$.mid=n;break;case 1:$.right=n;break}}else this.c=n}for(let n=o.length-1;n>=0;n--){const h=o[n][1];h.updateHeight();const $=h.balanceFactor();if($>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),o[n][1]=h.rotateLeft()):$<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),o[n][1]=h.rotateRight()),n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}}f(S){for(;S.left;)S=S.left;return S}findSubstr(S){const C=this.b.reset(S);let v=this.c,o;for(;v;){const s=C.cmp(v.segment);if(s>0)v=v.left;else if(s<0)v=v.right;else if(C.hasNext())C.next(),o=v.value||o,v=v.mid;else break}return v&&v.value||o}findSuperstr(S){return this.g(S,!1)}g(S,C){const v=this.b.reset(S);let o=this.c;for(;o;){const s=v.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(v.hasNext())v.next(),o=o.mid;else return o.mid?this.h(o.mid):C?o.value:void 0}}hasElementOrSubtree(S){return this.g(S,!0)!==void 0}forEach(S){for(const[C,v]of this)S(v,C)}*[Symbol.iterator](){yield*this.h(this.c)}h(S){const C=[];return this.j(S,C),C[Symbol.iterator]()}j(S,C){S&&(S.left&&this.j(S.left,C),S.value&&C.push([S.key,S.value]),S.mid&&this.j(S.mid,C),S.right&&this.j(S.right,C))}_isBalanced(){const S=C=>{if(!C)return!0;const v=C.balanceFactor();return v<-1||v>1?!1:S(C.left)&&S(C.right)};return S(this.c)}}e.$Hh=I}),define(Se[18],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=void 0;function D(d){return typeof d=="string"}e.$jf=D;function M(d){return Array.isArray(d)&&d.every(t=>D(t))}e.$kf=M;function g(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.$lf=g;function L(d){const t=Object.getPrototypeOf(Uint8Array);return typeof d=="object"&&d instanceof t}e.$mf=L;function R(d){return typeof d=="number"&&!isNaN(d)}e.$nf=R;function m(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.$of=m;function k(d){return d===!0||d===!1}e.$pf=k;function b(d){return typeof d>"u"}e.$qf=b;function P(d){return!I(d)}e.$rf=P;function I(d){return b(d)||d===null}e.$sf=I;function p(d,t){if(!d)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$tf=p;function S(d){if(I(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.$uf=S;function C(...d){const t=[];for(let r=0;r<d.length;r++){const a=d[r];if(I(a))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(a)}return t}e.$vf=C;const v=Object.prototype.hasOwnProperty;function o(d){if(!g(d))return!1;for(const t in d)if(v.call(d,t))return!1;return!0}e.$wf=o;function s(d){return typeof d=="function"}e.$xf=s;function n(...d){return d.length>0&&d.every(s)}e.$yf=n;function h(d,t){const r=Math.min(d.length,t.length);for(let a=0;a<r;a++)$(d[a],t[a])}e.$zf=h;function $(d,t){if(D(t)){if(typeof d!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(s(t)){try{if(d instanceof t)return}catch{}if(!I(d)&&d.constructor===t||t.length===1&&t.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Af=$}),define(Se[79],De([1,0,18]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=void 0;const M=Object.create(null);function g(m,k){if((0,D.$jf)(k)){const b=M[k];if(b===void 0)throw new Error(`${m} references an unknown codicon: ${k}`);k=b}return M[m]=k,{id:m}}function L(){return M}e.$Nj=L;function R(){return Object.values(e.$Pj)}e.$Oj=R,e.$Pj={add:g("add",6e4),plus:g("plus",6e4),gistNew:g("gist-new",6e4),repoCreate:g("repo-create",6e4),lightbulb:g("lightbulb",60001),lightBulb:g("light-bulb",60001),repo:g("repo",60002),repoDelete:g("repo-delete",60002),gistFork:g("gist-fork",60003),repoForked:g("repo-forked",60003),gitPullRequest:g("git-pull-request",60004),gitPullRequestAbandoned:g("git-pull-request-abandoned",60004),recordKeys:g("record-keys",60005),keyboard:g("keyboard",60005),tag:g("tag",60006),tagAdd:g("tag-add",60006),tagRemove:g("tag-remove",60006),gitPullRequestLabel:g("git-pull-request-label",60006),person:g("person",60007),personFollow:g("person-follow",60007),personOutline:g("person-outline",60007),personFilled:g("person-filled",60007),gitBranch:g("git-branch",60008),gitBranchCreate:g("git-branch-create",60008),gitBranchDelete:g("git-branch-delete",60008),sourceControl:g("source-control",60008),mirror:g("mirror",60009),mirrorPublic:g("mirror-public",60009),star:g("star",60010),starAdd:g("star-add",60010),starDelete:g("star-delete",60010),starEmpty:g("star-empty",60010),comment:g("comment",60011),commentAdd:g("comment-add",60011),alert:g("alert",60012),warning:g("warning",60012),search:g("search",60013),searchSave:g("search-save",60013),logOut:g("log-out",60014),signOut:g("sign-out",60014),logIn:g("log-in",60015),signIn:g("sign-in",60015),eye:g("eye",60016),eyeUnwatch:g("eye-unwatch",60016),eyeWatch:g("eye-watch",60016),circleFilled:g("circle-filled",60017),primitiveDot:g("primitive-dot",60017),closeDirty:g("close-dirty",60017),debugBreakpoint:g("debug-breakpoint",60017),debugBreakpointDisabled:g("debug-breakpoint-disabled",60017),debugHint:g("debug-hint",60017),primitiveSquare:g("primitive-square",60018),edit:g("edit",60019),pencil:g("pencil",60019),info:g("info",60020),issueOpened:g("issue-opened",60020),gistPrivate:g("gist-private",60021),gitForkPrivate:g("git-fork-private",60021),lock:g("lock",60021),mirrorPrivate:g("mirror-private",60021),close:g("close",60022),removeClose:g("remove-close",60022),x:g("x",60022),repoSync:g("repo-sync",60023),sync:g("sync",60023),clone:g("clone",60024),desktopDownload:g("desktop-download",60024),beaker:g("beaker",60025),microscope:g("microscope",60025),vm:g("vm",60026),deviceDesktop:g("device-desktop",60026),file:g("file",60027),fileText:g("file-text",60027),more:g("more",60028),ellipsis:g("ellipsis",60028),kebabHorizontal:g("kebab-horizontal",60028),mailReply:g("mail-reply",60029),reply:g("reply",60029),organization:g("organization",60030),organizationFilled:g("organization-filled",60030),organizationOutline:g("organization-outline",60030),newFile:g("new-file",60031),fileAdd:g("file-add",60031),newFolder:g("new-folder",60032),fileDirectoryCreate:g("file-directory-create",60032),trash:g("trash",60033),trashcan:g("trashcan",60033),history:g("history",60034),clock:g("clock",60034),folder:g("folder",60035),fileDirectory:g("file-directory",60035),symbolFolder:g("symbol-folder",60035),logoGithub:g("logo-github",60036),markGithub:g("mark-github",60036),github:g("github",60036),terminal:g("terminal",60037),console:g("console",60037),repl:g("repl",60037),zap:g("zap",60038),symbolEvent:g("symbol-event",60038),error:g("error",60039),stop:g("stop",60039),variable:g("variable",60040),symbolVariable:g("symbol-variable",60040),array:g("array",60042),symbolArray:g("symbol-array",60042),symbolModule:g("symbol-module",60043),symbolPackage:g("symbol-package",60043),symbolNamespace:g("symbol-namespace",60043),symbolObject:g("symbol-object",60043),symbolMethod:g("symbol-method",60044),symbolFunction:g("symbol-function",60044),symbolConstructor:g("symbol-constructor",60044),symbolBoolean:g("symbol-boolean",60047),symbolNull:g("symbol-null",60047),symbolNumeric:g("symbol-numeric",60048),symbolNumber:g("symbol-number",60048),symbolStructure:g("symbol-structure",60049),symbolStruct:g("symbol-struct",60049),symbolParameter:g("symbol-parameter",60050),symbolTypeParameter:g("symbol-type-parameter",60050),symbolKey:g("symbol-key",60051),symbolText:g("symbol-text",60051),symbolReference:g("symbol-reference",60052),goToFile:g("go-to-file",60052),symbolEnum:g("symbol-enum",60053),symbolValue:g("symbol-value",60053),symbolRuler:g("symbol-ruler",60054),symbolUnit:g("symbol-unit",60054),activateBreakpoints:g("activate-breakpoints",60055),archive:g("archive",60056),arrowBoth:g("arrow-both",60057),arrowDown:g("arrow-down",60058),arrowLeft:g("arrow-left",60059),arrowRight:g("arrow-right",60060),arrowSmallDown:g("arrow-small-down",60061),arrowSmallLeft:g("arrow-small-left",60062),arrowSmallRight:g("arrow-small-right",60063),arrowSmallUp:g("arrow-small-up",60064),arrowUp:g("arrow-up",60065),bell:g("bell",60066),bold:g("bold",60067),book:g("book",60068),bookmark:g("bookmark",60069),debugBreakpointConditionalUnverified:g("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:g("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:g("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:g("debug-breakpoint-data-unverified",60072),debugBreakpointData:g("debug-breakpoint-data",60073),debugBreakpointDataDisabled:g("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:g("debug-breakpoint-log-unverified",60074),debugBreakpointLog:g("debug-breakpoint-log",60075),debugBreakpointLogDisabled:g("debug-breakpoint-log-disabled",60075),briefcase:g("briefcase",60076),broadcast:g("broadcast",60077),browser:g("browser",60078),bug:g("bug",60079),calendar:g("calendar",60080),caseSensitive:g("case-sensitive",60081),check:g("check",60082),checklist:g("checklist",60083),chevronDown:g("chevron-down",60084),dropDownButton:g("drop-down-button",60084),chevronLeft:g("chevron-left",60085),chevronRight:g("chevron-right",60086),chevronUp:g("chevron-up",60087),chromeClose:g("chrome-close",60088),chromeMaximize:g("chrome-maximize",60089),chromeMinimize:g("chrome-minimize",60090),chromeRestore:g("chrome-restore",60091),circle:g("circle",60092),circleOutline:g("circle-outline",60092),debugBreakpointUnverified:g("debug-breakpoint-unverified",60092),circleSlash:g("circle-slash",60093),circuitBoard:g("circuit-board",60094),clearAll:g("clear-all",60095),clippy:g("clippy",60096),closeAll:g("close-all",60097),cloudDownload:g("cloud-download",60098),cloudUpload:g("cloud-upload",60099),code:g("code",60100),collapseAll:g("collapse-all",60101),colorMode:g("color-mode",60102),commentDiscussion:g("comment-discussion",60103),compareChanges:g("compare-changes",60157),creditCard:g("credit-card",60105),dash:g("dash",60108),dashboard:g("dashboard",60109),database:g("database",60110),debugContinue:g("debug-continue",60111),debugDisconnect:g("debug-disconnect",60112),debugPause:g("debug-pause",60113),debugRestart:g("debug-restart",60114),debugStart:g("debug-start",60115),debugStepInto:g("debug-step-into",60116),debugStepOut:g("debug-step-out",60117),debugStepOver:g("debug-step-over",60118),debugStop:g("debug-stop",60119),debug:g("debug",60120),deviceCameraVideo:g("device-camera-video",60121),deviceCamera:g("device-camera",60122),deviceMobile:g("device-mobile",60123),diffAdded:g("diff-added",60124),diffIgnored:g("diff-ignored",60125),diffModified:g("diff-modified",60126),diffRemoved:g("diff-removed",60127),diffRenamed:g("diff-renamed",60128),diff:g("diff",60129),discard:g("discard",60130),editorLayout:g("editor-layout",60131),emptyWindow:g("empty-window",60132),exclude:g("exclude",60133),extensions:g("extensions",60134),eyeClosed:g("eye-closed",60135),fileBinary:g("file-binary",60136),fileCode:g("file-code",60137),fileMedia:g("file-media",60138),filePdf:g("file-pdf",60139),fileSubmodule:g("file-submodule",60140),fileSymlinkDirectory:g("file-symlink-directory",60141),fileSymlinkFile:g("file-symlink-file",60142),fileZip:g("file-zip",60143),files:g("files",60144),filter:g("filter",60145),flame:g("flame",60146),foldDown:g("fold-down",60147),foldUp:g("fold-up",60148),fold:g("fold",60149),folderActive:g("folder-active",60150),folderOpened:g("folder-opened",60151),gear:g("gear",60152),gift:g("gift",60153),gistSecret:g("gist-secret",60154),gist:g("gist",60155),gitCommit:g("git-commit",60156),gitCompare:g("git-compare",60157),gitMerge:g("git-merge",60158),githubAction:g("github-action",60159),githubAlt:g("github-alt",60160),globe:g("globe",60161),grabber:g("grabber",60162),graph:g("graph",60163),gripper:g("gripper",60164),heart:g("heart",60165),home:g("home",60166),horizontalRule:g("horizontal-rule",60167),hubot:g("hubot",60168),inbox:g("inbox",60169),issueClosed:g("issue-closed",60324),issueReopened:g("issue-reopened",60171),issues:g("issues",60172),italic:g("italic",60173),jersey:g("jersey",60174),json:g("json",60175),bracket:g("bracket",60175),kebabVertical:g("kebab-vertical",60176),key:g("key",60177),law:g("law",60178),lightbulbAutofix:g("lightbulb-autofix",60179),linkExternal:g("link-external",60180),link:g("link",60181),listOrdered:g("list-ordered",60182),listUnordered:g("list-unordered",60183),liveShare:g("live-share",60184),loading:g("loading",60185),location:g("location",60186),mailRead:g("mail-read",60187),mail:g("mail",60188),markdown:g("markdown",60189),megaphone:g("megaphone",60190),mention:g("mention",60191),milestone:g("milestone",60192),gitPullRequestMilestone:g("git-pull-request-milestone",60192),mortarBoard:g("mortar-board",60193),move:g("move",60194),multipleWindows:g("multiple-windows",60195),mute:g("mute",60196),noNewline:g("no-newline",60197),note:g("note",60198),octoface:g("octoface",60199),openPreview:g("open-preview",60200),package_:g("package",60201),paintcan:g("paintcan",60202),pin:g("pin",60203),play:g("play",60204),run:g("run",60204),plug:g("plug",60205),preserveCase:g("preserve-case",60206),preview:g("preview",60207),project:g("project",60208),pulse:g("pulse",60209),question:g("question",60210),quote:g("quote",60211),radioTower:g("radio-tower",60212),reactions:g("reactions",60213),references:g("references",60214),refresh:g("refresh",60215),regex:g("regex",60216),remoteExplorer:g("remote-explorer",60217),remote:g("remote",60218),remove:g("remove",60219),replaceAll:g("replace-all",60220),replace:g("replace",60221),repoClone:g("repo-clone",60222),repoForcePush:g("repo-force-push",60223),repoPull:g("repo-pull",60224),repoPush:g("repo-push",60225),report:g("report",60226),requestChanges:g("request-changes",60227),rocket:g("rocket",60228),rootFolderOpened:g("root-folder-opened",60229),rootFolder:g("root-folder",60230),rss:g("rss",60231),ruby:g("ruby",60232),saveAll:g("save-all",60233),saveAs:g("save-as",60234),save:g("save",60235),screenFull:g("screen-full",60236),screenNormal:g("screen-normal",60237),searchStop:g("search-stop",60238),server:g("server",60240),settingsGear:g("settings-gear",60241),settings:g("settings",60242),shield:g("shield",60243),smiley:g("smiley",60244),sortPrecedence:g("sort-precedence",60245),splitHorizontal:g("split-horizontal",60246),splitVertical:g("split-vertical",60247),squirrel:g("squirrel",60248),starFull:g("star-full",60249),starHalf:g("star-half",60250),symbolClass:g("symbol-class",60251),symbolColor:g("symbol-color",60252),symbolCustomColor:g("symbol-customcolor",60252),symbolConstant:g("symbol-constant",60253),symbolEnumMember:g("symbol-enum-member",60254),symbolField:g("symbol-field",60255),symbolFile:g("symbol-file",60256),symbolInterface:g("symbol-interface",60257),symbolKeyword:g("symbol-keyword",60258),symbolMisc:g("symbol-misc",60259),symbolOperator:g("symbol-operator",60260),symbolProperty:g("symbol-property",60261),wrench:g("wrench",60261),wrenchSubaction:g("wrench-subaction",60261),symbolSnippet:g("symbol-snippet",60262),tasklist:g("tasklist",60263),telescope:g("telescope",60264),textSize:g("text-size",60265),threeBars:g("three-bars",60266),thumbsdown:g("thumbsdown",60267),thumbsup:g("thumbsup",60268),tools:g("tools",60269),triangleDown:g("triangle-down",60270),triangleLeft:g("triangle-left",60271),triangleRight:g("triangle-right",60272),triangleUp:g("triangle-up",60273),twitter:g("twitter",60274),unfold:g("unfold",60275),unlock:g("unlock",60276),unmute:g("unmute",60277),unverified:g("unverified",60278),verified:g("verified",60279),versions:g("versions",60280),vmActive:g("vm-active",60281),vmOutline:g("vm-outline",60282),vmRunning:g("vm-running",60283),watch:g("watch",60284),whitespace:g("whitespace",60285),wholeWord:g("whole-word",60286),window:g("window",60287),wordWrap:g("word-wrap",60288),zoomIn:g("zoom-in",60289),zoomOut:g("zoom-out",60290),listFilter:g("list-filter",60291),listFlat:g("list-flat",60292),listSelection:g("list-selection",60293),selection:g("selection",60293),listTree:g("list-tree",60294),debugBreakpointFunctionUnverified:g("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:g("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:g("debug-breakpoint-function-disabled",60296),debugStackframeActive:g("debug-stackframe-active",60297),circleSmallFilled:g("circle-small-filled",60298),debugStackframeDot:g("debug-stackframe-dot",60298),debugStackframe:g("debug-stackframe",60299),debugStackframeFocused:g("debug-stackframe-focused",60299),debugBreakpointUnsupported:g("debug-breakpoint-unsupported",60300),symbolString:g("symbol-string",60301),debugReverseContinue:g("debug-reverse-continue",60302),debugStepBack:g("debug-step-back",60303),debugRestartFrame:g("debug-restart-frame",60304),callIncoming:g("call-incoming",60306),callOutgoing:g("call-outgoing",60307),menu:g("menu",60308),expandAll:g("expand-all",60309),feedback:g("feedback",60310),gitPullRequestReviewer:g("git-pull-request-reviewer",60310),groupByRefType:g("group-by-ref-type",60311),ungroupByRefType:g("ungroup-by-ref-type",60312),account:g("account",60313),gitPullRequestAssignee:g("git-pull-request-assignee",60313),bellDot:g("bell-dot",60314),debugConsole:g("debug-console",60315),library:g("library",60316),output:g("output",60317),runAll:g("run-all",60318),syncIgnored:g("sync-ignored",60319),pinned:g("pinned",60320),githubInverted:g("github-inverted",60321),debugAlt:g("debug-alt",60305),serverProcess:g("server-process",60322),serverEnvironment:g("server-environment",60323),pass:g("pass",60324),stopCircle:g("stop-circle",60325),playCircle:g("play-circle",60326),record:g("record",60327),debugAltSmall:g("debug-alt-small",60328),vmConnect:g("vm-connect",60329),cloud:g("cloud",60330),merge:g("merge",60331),exportIcon:g("export",60332),graphLeft:g("graph-left",60333),magnet:g("magnet",60334),notebook:g("notebook",60335),redo:g("redo",60336),checkAll:g("check-all",60337),pinnedDirty:g("pinned-dirty",60338),passFilled:g("pass-filled",60339),circleLargeFilled:g("circle-large-filled",60340),circleLarge:g("circle-large",60341),circleLargeOutline:g("circle-large-outline",60341),combine:g("combine",60342),gather:g("gather",60342),table:g("table",60343),variableGroup:g("variable-group",60344),typeHierarchy:g("type-hierarchy",60345),typeHierarchySub:g("type-hierarchy-sub",60346),typeHierarchySuper:g("type-hierarchy-super",60347),gitPullRequestCreate:g("git-pull-request-create",60348),runAbove:g("run-above",60349),runBelow:g("run-below",60350),notebookTemplate:g("notebook-template",60351),debugRerun:g("debug-rerun",60352),workspaceTrusted:g("workspace-trusted",60353),workspaceUntrusted:g("workspace-untrusted",60354),workspaceUnspecified:g("workspace-unspecified",60355),terminalCmd:g("terminal-cmd",60356),terminalDebian:g("terminal-debian",60357),terminalLinux:g("terminal-linux",60358),terminalPowershell:g("terminal-powershell",60359),terminalTmux:g("terminal-tmux",60360),terminalUbuntu:g("terminal-ubuntu",60361),terminalBash:g("terminal-bash",60362),arrowSwap:g("arrow-swap",60363),copy:g("copy",60364),personAdd:g("person-add",60365),filterFilled:g("filter-filled",60366),wand:g("wand",60367),debugLineByLine:g("debug-line-by-line",60368),inspect:g("inspect",60369),layers:g("layers",60370),layersDot:g("layers-dot",60371),layersActive:g("layers-active",60372),compass:g("compass",60373),compassDot:g("compass-dot",60374),compassActive:g("compass-active",60375),azure:g("azure",60376),issueDraft:g("issue-draft",60377),gitPullRequestClosed:g("git-pull-request-closed",60378),gitPullRequestDraft:g("git-pull-request-draft",60379),debugAll:g("debug-all",60380),debugCoverage:g("debug-coverage",60381),runErrors:g("run-errors",60382),folderLibrary:g("folder-library",60383),debugContinueSmall:g("debug-continue-small",60384),beakerStop:g("beaker-stop",60385),graphLine:g("graph-line",60386),graphScatter:g("graph-scatter",60387),pieChart:g("pie-chart",60388),bracketDot:g("bracket-dot",60389),bracketError:g("bracket-error",60390),lockSmall:g("lock-small",60391),azureDevops:g("azure-devops",60392),verifiedFilled:g("verified-filled",60393),newLine:g("newline",60394),layout:g("layout",60395),layoutActivitybarLeft:g("layout-activitybar-left",60396),layoutActivitybarRight:g("layout-activitybar-right",60397),layoutPanelLeft:g("layout-panel-left",60398),layoutPanelCenter:g("layout-panel-center",60399),layoutPanelJustify:g("layout-panel-justify",60400),layoutPanelRight:g("layout-panel-right",60401),layoutPanel:g("layout-panel",60402),layoutSidebarLeft:g("layout-sidebar-left",60403),layoutSidebarRight:g("layout-sidebar-right",60404),layoutStatusbar:g("layout-statusbar",60405),layoutMenubar:g("layout-menubar",60406),layoutCentered:g("layout-centered",60407),layoutSidebarRightOff:g("layout-sidebar-right-off",60416),layoutPanelOff:g("layout-panel-off",60417),layoutSidebarLeftOff:g("layout-sidebar-left-off",60418),target:g("target",60408),indent:g("indent",60409),recordSmall:g("record-small",60410),errorSmall:g("error-small",60411),arrowCircleDown:g("arrow-circle-down",60412),arrowCircleLeft:g("arrow-circle-left",60413),arrowCircleRight:g("arrow-circle-right",60414),arrowCircleUp:g("arrow-circle-up",60415),heartFilled:g("heart-filled",60420),map:g("map",60421),mapFilled:g("map-filled",60422),circleSmall:g("circle-small",60423),bellSlash:g("bell-slash",60424),bellSlashDot:g("bell-slash-dot",60425),commentUnresolved:g("comment-unresolved",60426),gitPullRequestGoToChanges:g("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:g("git-pull-request-new-changes",60428),searchFuzzy:g("search-fuzzy",60429),commentDraft:g("comment-draft",60430),send:g("send",60431),sparkle:g("sparkle",60432),insert:g("insert",60433),mic:g("mic",60434),dialogError:g("dialog-error","error"),dialogWarning:g("dialog-warning","warning"),dialogInfo:g("dialog-info","info"),dialogClose:g("dialog-close","close"),treeItemExpanded:g("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:g("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:g("tree-filter-on-type-off","list-selection"),treeFilterClear:g("tree-filter-clear","close"),treeItemLoading:g("tree-item-loading","loading"),menuSelection:g("menu-selection","check"),menuSubmenu:g("menu-submenu","chevron-right"),menuBarMore:g("menubar-more","more"),scrollbarButtonLeft:g("scrollbar-button-left","triangle-left"),scrollbarButtonRight:g("scrollbar-button-right","triangle-right"),scrollbarButtonUp:g("scrollbar-button-up","triangle-up"),scrollbarButtonDown:g("scrollbar-button-down","triangle-down"),toolBarMore:g("toolbar-more","more"),quickInputBack:g("quick-input-back","arrow-left")}}),define(Se[23],De([1,0,18]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=void 0;function M(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const n=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([h,$])=>{n[h]=$&&typeof $=="object"?M($):$}),n}e.$Vm=M;function g(s){if(!s||typeof s!="object")return s;const n=[s];for(;n.length>0;){const h=n.shift();Object.freeze(h);for(const $ in h)if(L.call(h,$)){const d=h[$];typeof d=="object"&&!Object.isFrozen(d)&&!(0,D.$mf)(d)&&n.push(d)}}return s}e.$Wm=g;const L=Object.prototype.hasOwnProperty;function R(s,n){return m(s,n,new Set)}e.$Xm=R;function m(s,n,h){if((0,D.$sf)(s))return s;const $=n(s);if(typeof $<"u")return $;if(Array.isArray(s)){const d=[];for(const t of s)d.push(m(t,n,h));return d}if((0,D.$lf)(s)){if(h.has(s))throw new Error("Cannot clone recursive data-structure");h.add(s);const d={};for(const t in s)L.call(s,t)&&(d[t]=m(s[t],n,h));return h.delete(s),d}return s}function k(s,n,h=!0){return(0,D.$lf)(s)?((0,D.$lf)(n)&&Object.keys(n).forEach($=>{$ in s?h&&((0,D.$lf)(s[$])&&(0,D.$lf)(n[$])?k(s[$],n[$],h):s[$]=n[$]):s[$]=n[$]}),s):n}e.$Ym=k;function b(s,n){if(s===n)return!0;if(s==null||n===null||n===void 0||typeof s!=typeof n||typeof s!="object"||Array.isArray(s)!==Array.isArray(n))return!1;let h,$;if(Array.isArray(s)){if(s.length!==n.length)return!1;for(h=0;h<s.length;h++)if(!b(s[h],n[h]))return!1}else{const d=[];for($ in s)d.push($);d.sort();const t=[];for($ in n)t.push($);if(t.sort(),!b(d,t))return!1;for(h=0;h<d.length;h++)if(!b(s[d[h]],n[d[h]]))return!1}return!0}e.$Zm=b;function P(s){const n=new Set;return JSON.stringify(s,(h,$)=>{if((0,D.$lf)($)||Array.isArray($)){if(n.has($))return"[Circular]";n.add($)}return $})}e.$1m=P;function I(s,n){const h=Object.create(null);return!s||!n||Object.keys(n).forEach(d=>{const t=s[d],r=n[d];b(t,r)||(h[d]=r)}),h}e.$2m=I;function p(s,n){const h=n.toLowerCase(),$=Object.keys(s).find(d=>d.toLowerCase()===h);return $?s[$]:s[n]}e.$3m=p;function S(s,n){const h=Object.create(null);for(const[$,d]of Object.entries(s))n($,d)&&(h[$]=d);return h}e.$4m=S;function C(s){let n=[];for(;Object.prototype!==s;)n=n.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return n}e.$5m=C;function v(s){const n=[];for(const h of C(s))typeof s[h]=="function"&&n.push(h);return n}e.$6m=v;function o(s,n){const h=d=>function(){const t=Array.prototype.slice.call(arguments,0);return n(d,t)},$={};for(const d of s)$[d]=h(d);return $}e.$7m=o}),define(Se[60],De([1,0,79]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Qj=e.ThemeColor=void 0;var M;(function(R){function m(k){return k&&typeof k=="object"&&typeof k.id=="string"}R.isThemeColor=m})(M||(e.ThemeColor=M={}));function g(R){return{id:R}}e.$Qj=g;var L;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function k(n){const h=m.exec(n.id);if(!h)return k(D.$Pj.error);const[,$,d]=h,t=["codicon","codicon-"+$];return d&&t.push("codicon-modifier-"+d.substring(1)),t}R.asClassNameArray=k;function b(n){return k(n).join(" ")}R.asClassName=b;function P(n){return"."+k(n).join(".")}R.asCSSSelector=P;function I(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||M.isThemeColor(n.color))}R.isThemeIcon=I;const p=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function S(n){const h=p.exec(n);if(!h)return;const[,$]=h;return{id:$}}R.fromString=S;function C(n){return{id:n}}R.fromId=C;function v(n,h){let $=n.id;const d=$.lastIndexOf("~");return d!==-1&&($=$.substring(0,d)),h&&($=`${$}~${h}`),{id:$}}R.modify=v;function o(n){const h=n.id.lastIndexOf("~");if(h!==-1)return n.id.substring(h+1)}R.getModifier=o;function s(n,h){return n.id===h.id&&n.color?.id===h.color?.id}R.isEqual=s})(L||(e.ThemeIcon=L={}))}),define(Se[161],De([1,0,121,15,60]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=void 0;const L="$(",R=new RegExp(`\\$\\(${g.ThemeIcon.iconNameExpression}(?:${g.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${R.source}`,"g");function k(s){return s.replace(m,(n,h)=>h?n:`\\${n}`)}e.$Rj=k;const b=new RegExp(`\\\\${R.source}`,"g");function P(s){return s.replace(b,n=>`\\${n}`)}e.$Sj=P;const I=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function p(s){return s.indexOf(L)===-1?s:s.replace(I,(n,h,$,d)=>$?n:h||d||"")}e.$Tj=p;function S(s){return s?s.replace(/\$\((.*?)\)/g,(n,h)=>` ${h} `).trim():""}e.$Uj=S;const C=new RegExp(`\\$\\(${g.ThemeIcon.iconNameCharacter}+\\)`,"g");function v(s){C.lastIndex=0;let n="";const h=[];let $=0;for(;;){const d=C.lastIndex,t=C.exec(s),r=s.substring(d,t?.index);if(r.length>0){n+=r;for(let a=0;a<r.length;a++)h.push($)}if(!t)break;$+=t[0].length}return{text:n,iconOffsets:h}}e.$Vj=v;function o(s,n,h=!1){const{text:$,iconOffsets:d}=n;if(!d||d.length===0)return(0,D.$Ej)(s,$,h);const t=(0,M.$ue)($," "),r=$.length-t.length,a=(0,D.$Ej)(s,t,h);if(a)for(const i of a){const c=d[i.start+r]+r;i.start+=c,i.end+=c}return a}e.$Wj=o}),define(Se[122],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$le=e.$ke=e.Constants=void 0;var D;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function M(L){return L<0?0:L>255?255:L|0}e.$ke=M;function g(L){return L<0?0:L>4294967295?4294967295:L|0}e.$le=g}),define(Se[31],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(g){return D.test(g)}e.$3f=M,e.$4f=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let g;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?g=crypto.getRandomValues.bind(crypto):g=function(m){for(let k=0;k<m.length;k++)m[k]=Math.floor(Math.random()*256);return m};const L=new Uint8Array(16),R=[];for(let m=0;m<256;m++)R.push(m.toString(16).padStart(2,"0"));return function(){g(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let k=0,b="";return b+=R[L[k++]],b+=R[L[k++]],b+=R[L[k++]],b+=R[L[k++]],b+="-",b+=R[L[k++]],b+=R[L[k++]],b+="-",b+=R[L[k++]],b+=R[L[k++]],b+="-",b+=R[L[k++]],b+=R[L[k++]],b+="-",b+=R[L[k++]],b+=R[L[k++]],b+=R[L[k++]],b+=R[L[k++]],b+=R[L[k++]],b+=R[L[k++]],b}}()}),define(Se[162],De([1,0,19,50,31]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=e.$Ss=e.$Rs=e.$Qs=e.$Ps=void 0;function L(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.$Ps=L;function R(I,p,S){const C={id:(0,g.$4f)(),name:I,uri:p,data:S};return{asString:async()=>"",asFile:()=>C,value:void 0}}e.$Qs=R;class m{constructor(){this.a=new Map}get size(){let p=0;for(const S of this.a)p++;return p}has(p){return this.a.has(this.b(p))}matches(p){const S=[...this.a.keys()];return M.Iterable.some(this,([C,v])=>v.asFile())&&S.push("files"),P(k(p),S)}get(p){return this.a.get(this.b(p))?.[0]}append(p,S){const C=this.a.get(p);C?C.push(S):this.a.set(this.b(p),[S])}replace(p,S){this.a.set(this.b(p),[S])}delete(p){this.a.delete(this.b(p))}*[Symbol.iterator](){for(const[p,S]of this.a)for(const C of S)yield[p,C]}b(p){return k(p)}}e.$Rs=m;function k(I){return I.toLowerCase()}function b(I,p){return P(k(I),p.map(k))}e.$Ss=b;function P(I,p){if(I==="*/*")return p.length>0;if(p.includes(I))return!0;const S=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[C,v,o]=S;return o==="*"?p.some(s=>s.startsWith(v+"/")):!1}e.$Ts=Object.freeze({create:I=>(0,D.$Kb)(I.map(p=>p.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$Ts.split(I).filter(p=>!p.startsWith("#"))})}),define(Se[163],De([1,0,61]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=e.$7f=e.$6f=void 0;function M(m,k,b,P=1){let I=!1;return new Promise(p=>{const S=setTimeout(()=>{if(!I)return I=!0,p(0)},b);g(m,k,P,C=>{if(!I)return I=!0,clearTimeout(S),p(C)})})}e.$6f=M;function g(m,k,b,P){if(k===0)return P(0);const I=new D.Socket;I.once("connect",()=>(R(I),g(m+b,k-1,b,P))),I.once("data",()=>{}),I.once("error",p=>(R(I),p.code!=="ECONNREFUSED"?g(m+b,k-1,b,P):P(m))),I.connect(m,"127.0.0.1")}e.$7f={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(m,k,b,P="127.0.0.1"){let I=!1,p,S=1;const C=D.createServer({pauseOnConnect:!0});function v(o,s){I||(I=!0,C.removeAllListeners(),C.close(),p&&clearTimeout(p),s(o))}return new Promise(o=>{p=setTimeout(()=>{v(0,o)},b),C.on("listening",()=>{v(m,o)}),C.on("error",s=>{s&&(s.code==="EADDRINUSE"||s.code==="EACCES")&&S<k?(m++,S++,C.listen(m,P)):v(0,o)}),C.on("close",()=>{v(0,o)}),C.listen(m,P)})}e.$8f=L;function R(m){try{m.removeAllListeners("connect"),m.removeAllListeners("error"),m.end(),m.destroy(),m.unref()}catch(k){console.error(k)}}}),define(Se[123],De([1,0,122]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=e.$Hs=void 0;class M{constructor(m){const k=(0,D.$ke)(m);this.c=k,this.a=M.d(k),this.b=new Map}static d(m){const k=new Uint8Array(256);return k.fill(m),k}set(m,k){const b=(0,D.$ke)(k);m>=0&&m<256?this.a[m]=b:this.b.set(m,b)}get(m){return m>=0&&m<256?this.a[m]:this.b.get(m)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Hs=M;var g;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(g||(g={}));class L{constructor(){this.a=new M(0)}add(m){this.a.set(m,1)}has(m){return this.a.get(m)===1}clear(){return this.a.clear()}}e.$Is=L}),define(Se[62],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=void 0;class D{constructor(g,L){this.lineNumber=g,this.column=L}with(g=this.lineNumber,L=this.column){return g===this.lineNumber&&L===this.column?this:new D(g,L)}delta(g=0,L=0){return this.with(this.lineNumber+g,this.column+L)}equals(g){return D.equals(this,g)}static equals(g,L){return!g&&!L?!0:!!g&&!!L&&g.lineNumber===L.lineNumber&&g.column===L.column}isBefore(g){return D.isBefore(this,g)}static isBefore(g,L){return g.lineNumber<L.lineNumber?!0:L.lineNumber<g.lineNumber?!1:g.column<L.column}isBeforeOrEqual(g){return D.isBeforeOrEqual(this,g)}static isBeforeOrEqual(g,L){return g.lineNumber<L.lineNumber?!0:L.lineNumber<g.lineNumber?!1:g.column<=L.column}static compare(g,L){const R=g.lineNumber|0,m=L.lineNumber|0;if(R===m){const k=g.column|0,b=L.column|0;return k-b}return R-m}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(g){return new D(g.lineNumber,g.column)}static isIPosition(g){return g&&typeof g.lineNumber=="number"&&typeof g.column=="number"}}e.$js=D}),define(Se[34],De([1,0,62]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=void 0;class M{constructor(L,R,m,k){L>m||L===m&&R>k?(this.startLineNumber=m,this.startColumn=k,this.endLineNumber=L,this.endColumn=R):(this.startLineNumber=L,this.startColumn=R,this.endLineNumber=m,this.endColumn=k)}isEmpty(){return M.isEmpty(this)}static isEmpty(L){return L.startLineNumber===L.endLineNumber&&L.startColumn===L.endColumn}containsPosition(L){return M.containsPosition(this,L)}static containsPosition(L,R){return!(R.lineNumber<L.startLineNumber||R.lineNumber>L.endLineNumber||R.lineNumber===L.startLineNumber&&R.column<L.startColumn||R.lineNumber===L.endLineNumber&&R.column>L.endColumn)}static strictContainsPosition(L,R){return!(R.lineNumber<L.startLineNumber||R.lineNumber>L.endLineNumber||R.lineNumber===L.startLineNumber&&R.column<=L.startColumn||R.lineNumber===L.endLineNumber&&R.column>=L.endColumn)}containsRange(L){return M.containsRange(this,L)}static containsRange(L,R){return!(R.startLineNumber<L.startLineNumber||R.endLineNumber<L.startLineNumber||R.startLineNumber>L.endLineNumber||R.endLineNumber>L.endLineNumber||R.startLineNumber===L.startLineNumber&&R.startColumn<L.startColumn||R.endLineNumber===L.endLineNumber&&R.endColumn>L.endColumn)}strictContainsRange(L){return M.strictContainsRange(this,L)}static strictContainsRange(L,R){return!(R.startLineNumber<L.startLineNumber||R.endLineNumber<L.startLineNumber||R.startLineNumber>L.endLineNumber||R.endLineNumber>L.endLineNumber||R.startLineNumber===L.startLineNumber&&R.startColumn<=L.startColumn||R.endLineNumber===L.endLineNumber&&R.endColumn>=L.endColumn)}plusRange(L){return M.plusRange(this,L)}static plusRange(L,R){let m,k,b,P;return R.startLineNumber<L.startLineNumber?(m=R.startLineNumber,k=R.startColumn):R.startLineNumber===L.startLineNumber?(m=R.startLineNumber,k=Math.min(R.startColumn,L.startColumn)):(m=L.startLineNumber,k=L.startColumn),R.endLineNumber>L.endLineNumber?(b=R.endLineNumber,P=R.endColumn):R.endLineNumber===L.endLineNumber?(b=R.endLineNumber,P=Math.max(R.endColumn,L.endColumn)):(b=L.endLineNumber,P=L.endColumn),new M(m,k,b,P)}intersectRanges(L){return M.intersectRanges(this,L)}static intersectRanges(L,R){let m=L.startLineNumber,k=L.startColumn,b=L.endLineNumber,P=L.endColumn;const I=R.startLineNumber,p=R.startColumn,S=R.endLineNumber,C=R.endColumn;return m<I?(m=I,k=p):m===I&&(k=Math.max(k,p)),b>S?(b=S,P=C):b===S&&(P=Math.min(P,C)),m>b||m===b&&k>P?null:new M(m,k,b,P)}equalsRange(L){return M.equalsRange(this,L)}static equalsRange(L,R){return!L&&!R?!0:!!L&&!!R&&L.startLineNumber===R.startLineNumber&&L.startColumn===R.startColumn&&L.endLineNumber===R.endLineNumber&&L.endColumn===R.endColumn}getEndPosition(){return M.getEndPosition(this)}static getEndPosition(L){return new D.$js(L.endLineNumber,L.endColumn)}getStartPosition(){return M.getStartPosition(this)}static getStartPosition(L){return new D.$js(L.startLineNumber,L.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(L,R){return new M(this.startLineNumber,this.startColumn,L,R)}setStartPosition(L,R){return new M(L,R,this.endLineNumber,this.endColumn)}collapseToStart(){return M.collapseToStart(this)}static collapseToStart(L){return new M(L.startLineNumber,L.startColumn,L.startLineNumber,L.startColumn)}collapseToEnd(){return M.collapseToEnd(this)}static collapseToEnd(L){return new M(L.endLineNumber,L.endColumn,L.endLineNumber,L.endColumn)}delta(L){return new M(this.startLineNumber+L,this.startColumn,this.endLineNumber+L,this.endColumn)}static fromPositions(L,R=L){return new M(L.lineNumber,L.column,R.lineNumber,R.column)}static lift(L){return L?new M(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):null}static isIRange(L){return L&&typeof L.startLineNumber=="number"&&typeof L.startColumn=="number"&&typeof L.endLineNumber=="number"&&typeof L.endColumn=="number"}static areIntersectingOrTouching(L,R){return!(L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<R.startColumn||R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<L.startColumn)}static areIntersecting(L,R){return!(L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<=R.startColumn||R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<=L.startColumn)}static compareRangesUsingStarts(L,R){if(L&&R){const b=L.startLineNumber|0,P=R.startLineNumber|0;if(b===P){const I=L.startColumn|0,p=R.startColumn|0;if(I===p){const S=L.endLineNumber|0,C=R.endLineNumber|0;if(S===C){const v=L.endColumn|0,o=R.endColumn|0;return v-o}return S-C}return I-p}return b-P}return(L?1:0)-(R?1:0)}static compareRangesUsingEnds(L,R){return L.endLineNumber===R.endLineNumber?L.endColumn===R.endColumn?L.startLineNumber===R.startLineNumber?L.startColumn-R.startColumn:L.startLineNumber-R.startLineNumber:L.endColumn-R.endColumn:L.endLineNumber-R.endLineNumber}static spansMultipleLines(L){return L.endLineNumber>L.startLineNumber}toJSON(){return this}}e.$ks=M}),define(Se[164],De([1,0,34]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=void 0;class M{static insert(L,R){return{range:new D.$ks(L.lineNumber,L.column,L.lineNumber,L.column),text:R,forceMoveMarkers:!0}}static delete(L){return{range:L,text:null}}static replace(L,R){return{range:L,text:R}}static replaceMove(L,R){return{range:L,text:R,forceMoveMarkers:!0}}}e.$ls=M}),define(Se[165],De([1,0,62,34]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=e.SelectionDirection=void 0;var g;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(g||(e.SelectionDirection=g={}));class L extends M.$ks{constructor(m,k,b,P){super(m,k,b,P),this.selectionStartLineNumber=m,this.selectionStartColumn=k,this.positionLineNumber=b,this.positionColumn=P}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(m){return L.selectionsEqual(this,m)}static selectionsEqual(m,k){return m.selectionStartLineNumber===k.selectionStartLineNumber&&m.selectionStartColumn===k.selectionStartColumn&&m.positionLineNumber===k.positionLineNumber&&m.positionColumn===k.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(m,k){return this.getDirection()===0?new L(this.startLineNumber,this.startColumn,m,k):new L(m,k,this.startLineNumber,this.startColumn)}getPosition(){return new D.$js(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$js(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(m,k){return this.getDirection()===0?new L(m,k,this.endLineNumber,this.endColumn):new L(this.endLineNumber,this.endColumn,m,k)}static fromPositions(m,k=m){return new L(m.lineNumber,m.column,k.lineNumber,k.column)}static fromRange(m,k){return k===0?new L(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):new L(m.endLineNumber,m.endColumn,m.startLineNumber,m.startColumn)}static liftSelection(m){return new L(m.selectionStartLineNumber,m.selectionStartColumn,m.positionLineNumber,m.positionColumn)}static selectionsArrEqual(m,k){if(m&&!k||!m&&k)return!1;if(!m&&!k)return!0;if(m.length!==k.length)return!1;for(let b=0,P=m.length;b<P;b++)if(!this.selectionsEqual(m[b],k[b]))return!1;return!0}static isISelection(m){return m&&typeof m.selectionStartLineNumber=="number"&&typeof m.selectionStartColumn=="number"&&typeof m.positionLineNumber=="number"&&typeof m.positionColumn=="number"}static createWithDirection(m,k,b,P,I){return I===0?new L(m,k,b,P):new L(b,P,m,k)}}e.$ms=L}),define(Se[166],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=void 0,e.$Ur={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[167],De([1,0,123]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=e.$Js=e.WordCharacterClass=void 0;var M;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(M||(e.WordCharacterClass=M={}));class g extends D.$Hs{constructor(m){super(0);for(let k=0,b=m.length;k<b;k++)this.set(m.charCodeAt(k),2);this.set(32,1),this.set(9,1)}}e.$Js=g;function L(R){const m={};return k=>(m.hasOwnProperty(k)||(m[k]=R(k)),m[k])}e.$Ks=L(R=>new g(R))}),define(Se[124],De([1,0,50,3,76]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.$Xr=e.$Wr=e.$Vr=void 0,e.$Vr="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function L(I=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const S of e.$Vr)I.indexOf(S)>=0||(p+="\\"+S);return p+="\\s]+)",new RegExp(p,"g")}e.$Wr=L();function R(I){let p=e.$Wr;if(I&&I instanceof RegExp)if(I.global)p=I;else{let S="g";I.ignoreCase&&(S+="i"),I.multiline&&(S+="m"),I.unicode&&(S+="u"),p=new RegExp(I.source,S)}return p.lastIndex=0,p}e.$Xr=R;const m=new g.$tc;m.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function k(I){const p=m.unshift(I);return(0,M.$ic)(p)}e.$Yr=k;function b(I,p,S,C,v){if(v||(v=D.Iterable.first(m)),S.length>v.maxLen){let $=I-v.maxLen/2;return $<0?$=0:C+=$,S=S.substring($,I+v.maxLen/2),b(I,p,S,C,v)}const o=Date.now(),s=I-1-C;let n=-1,h=null;for(let $=1;!(Date.now()-o>=v.timeBudget);$++){const d=s-v.windowSize*$;p.lastIndex=Math.max(0,d);const t=P(p,S,s,n);if(!t&&h||(h=t,d<=0))break;n=d}if(h){const $={word:h[0],startColumn:C+1+h.index,endColumn:C+1+h.index+h[0].length};return p.lastIndex=0,$}return null}e.$Zr=b;function P(I,p,S,C){let v;for(;v=I.exec(p);){const o=v.index||0;if(o<=S&&I.lastIndex>=S)return v;if(C>0&&o>C)return null}return null}}),define(Se[168],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=e.$gt=e.IndentAction=void 0;var D;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class M{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let k=0,b=m.notIn.length;k<b;k++)switch(m.notIn[k]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,k){if(m.getTokenCount()===0)return!0;const b=m.findTokenIndexAtOffset(k-2),P=m.getStandardTokenType(b);return this.isOK(P)}g(m,k){for(let b=m;b<=k;b++){const P=String.fromCharCode(b);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$gt=M;class g{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const k of m)L(this.autoClosingPairsOpenByStart,k.open.charAt(0),k),L(this.autoClosingPairsOpenByEnd,k.open.charAt(k.open.length-1),k),L(this.autoClosingPairsCloseByStart,k.close.charAt(0),k),L(this.autoClosingPairsCloseByEnd,k.close.charAt(k.close.length-1),k),k.close.length===1&&k.open.length===1&&L(this.autoClosingPairsCloseSingleChar,k.close,k)}}e.$ht=g;function L(R,m,k){R.has(m)?R.get(m).push(k):R.set(m,[k])}}),define(Se[169],De([1,0,123]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yY=e.$xY=e.$wY=e.State=void 0;var M;(function(S){S[S.Invalid=0]="Invalid",S[S.Start=1]="Start",S[S.H=2]="H",S[S.HT=3]="HT",S[S.HTT=4]="HTT",S[S.HTTP=5]="HTTP",S[S.F=6]="F",S[S.FI=7]="FI",S[S.FIL=8]="FIL",S[S.BeforeColon=9]="BeforeColon",S[S.AfterColon=10]="AfterColon",S[S.AlmostThere=11]="AlmostThere",S[S.End=12]="End",S[S.Accept=13]="Accept",S[S.LastKnownState=14]="LastKnownState"})(M||(e.State=M={}));class g{constructor(C,v,o){const s=new Uint8Array(C*v);for(let n=0,h=C*v;n<h;n++)s[n]=o;this.a=s,this.rows=C,this.cols=v}get(C,v){return this.a[C*this.cols+v]}set(C,v,o){this.a[C*this.cols+v]=o}}class L{constructor(C){let v=0,o=0;for(let n=0,h=C.length;n<h;n++){const[$,d,t]=C[n];d>v&&(v=d),$>o&&(o=$),t>o&&(o=t)}v++,o++;const s=new g(o,v,0);for(let n=0,h=C.length;n<h;n++){const[$,d,t]=C[n];s.set($,d,t)}this.a=s,this.b=v}nextState(C,v){return v<0||v>=this.b?0:this.a.get(C,v)}}e.$wY=L;let R=null;function m(){return R===null&&(R=new L([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var k;(function(S){S[S.None=0]="None",S[S.ForceTermination=1]="ForceTermination",S[S.CannotEndIn=2]="CannotEndIn"})(k||(k={}));let b=null;function P(){if(b===null){b=new D.$Hs(0);const S=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<S.length;v++)b.set(S.charCodeAt(v),1);const C=".,;:";for(let v=0;v<C.length;v++)b.set(C.charCodeAt(v),2)}return b}class I{static a(C,v,o,s,n){let h=n-1;do{const $=v.charCodeAt(h);if(C.get($)!==2)break;h--}while(h>s);if(s>0){const $=v.charCodeAt(s-1),d=v.charCodeAt(h);($===40&&d===41||$===91&&d===93||$===123&&d===125)&&h--}return{range:{startLineNumber:o,startColumn:s+1,endLineNumber:o,endColumn:h+2},url:v.substring(s,h+1)}}static computeLinks(C,v=m()){const o=P(),s=[];for(let n=1,h=C.getLineCount();n<=h;n++){const $=C.getLineContent(n),d=$.length;let t=0,r=0,a=0,i=1,c=!1,f=!1,y=!1,E=!1;for(;t<d;){let u=!1;const l=$.charCodeAt(t);if(i===13){let w;switch(l){case 40:c=!0,w=0;break;case 41:w=c?0:1;break;case 91:y=!0,f=!0,w=0;break;case 93:y=!1,w=f?0:1;break;case 123:E=!0,w=0;break;case 125:w=E?0:1;break;case 39:case 34:case 96:a===l?w=1:a===39||a===34||a===96?w=0:w=1;break;case 42:w=a===42?1:0;break;case 124:w=a===124?1:0;break;case 32:w=y?0:1;break;default:w=o.get(l)}w===1&&(s.push(I.a(o,$,n,r,t)),u=!0)}else if(i===12){let w;l===91?(f=!0,w=0):w=o.get(l),w===1?u=!0:i=13}else i=v.nextState(i,l),i===0&&(u=!0);u&&(i=1,c=!1,f=!1,E=!1,r=t+1,a=l),t++}i===13&&s.push(I.a(o,$,n,r,d))}return s}}e.$xY=I;function p(S){return!S||typeof S.getLineCount!="function"||typeof S.getLineContent!="function"?[]:I.computeLinks(S)}e.$yY=p}),define(Se[125],De([1,0,23]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gu=e.$Fu=e.$Eu=e.$Du=e.ModelConstants=e.PositionAffinity=e.$Cu=e.TrackedRangeStickiness=e.$Bu=e.$Au=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var M;(function($){$[$.Left=1]="Left",$[$.Center=2]="Center",$[$.Right=4]="Right",$[$.Full=7]="Full"})(M||(e.OverviewRulerLane=M={}));var g;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(g||(e.GlyphMarginLane=g={}));var L;(function($){$[$.Inline=1]="Inline",$[$.Gutter=2]="Gutter"})(L||(e.MinimapPosition=L={}));var R;(function($){$[$.Both=0]="Both",$[$.Right=1]="Right",$[$.Left=2]="Left",$[$.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var m;(function($){$[$.TextDefined=0]="TextDefined",$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(m||(e.EndOfLinePreference=m={}));var k;(function($){$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(k||(e.DefaultEndOfLine=k={}));var b;(function($){$[$.LF=0]="LF",$[$.CRLF=1]="CRLF"})(b||(e.EndOfLineSequence=b={}));class P{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(d){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,d.tabSize|0),d.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,d.indentSize|0),this.a=!1),this.insertSpaces=!!d.insertSpaces,this.defaultEOL=d.defaultEOL|0,this.trimAutoWhitespace=!!d.trimAutoWhitespace,this.bracketPairColorizationOptions=d.bracketPairColorizationOptions}equals(d){return this.tabSize===d.tabSize&&this.a===d.a&&this.indentSize===d.indentSize&&this.insertSpaces===d.insertSpaces&&this.defaultEOL===d.defaultEOL&&this.trimAutoWhitespace===d.trimAutoWhitespace&&(0,D.$Zm)(this.bracketPairColorizationOptions,d.bracketPairColorizationOptions)}createChangeEvent(d){return{tabSize:this.tabSize!==d.tabSize,indentSize:this.indentSize!==d.indentSize,insertSpaces:this.insertSpaces!==d.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==d.trimAutoWhitespace}}}e.$Au=P;class I{constructor(d,t){this._findMatchBrand=void 0,this.range=d,this.matches=t}}e.$Bu=I;var p;(function($){$[$.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",$[$.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",$[$.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",$[$.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(p||(e.TrackedRangeStickiness=p={}));function S($){return $&&typeof $.read=="function"}e.$Cu=S;var C;(function($){$[$.Left=0]="Left",$[$.Right=1]="Right",$[$.None=2]="None",$[$.LeftOfInjectedText=3]="LeftOfInjectedText",$[$.RightOfInjectedText=4]="RightOfInjectedText"})(C||(e.PositionAffinity=C={}));var v;(function($){$[$.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v||(e.ModelConstants=v={}));class o{constructor(d,t,r,a,i,c){this.identifier=d,this.range=t,this.text=r,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=i,this._isTracked=c}}e.$Du=o;class s{constructor(d,t,r){this.regex=d,this.wordSeparators=t,this.simpleSearch=r}}e.$Eu=s;class n{constructor(d,t,r){this.reverseEdits=d,this.changes=t,this.trimAutoWhitespaceLineNumbers=r}}e.$Fu=n;function h($){return!$.isTooLargeForSyncing()&&!$.isForSimpleWidget}e.$Gu=h}),define(Se[170],De([1,0,19,122]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lu=e.$Ku=e.$Ju=void 0;class g{constructor(k){this.a=k,this.b=new Uint32Array(k.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(k,b){k=(0,M.$le)(k);const P=this.a,I=this.b,p=b.length;return p===0?!1:(this.a=new Uint32Array(P.length+p),this.a.set(P.subarray(0,k),0),this.a.set(P.subarray(k),k+p),this.a.set(b,k),k-1<this.c[0]&&(this.c[0]=k-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue(k,b){return k=(0,M.$le)(k),b=(0,M.$le)(b),this.a[k]===b?!1:(this.a[k]=b,k-1<this.c[0]&&(this.c[0]=k-1),!0)}removeValues(k,b){k=(0,M.$le)(k),b=(0,M.$le)(b);const P=this.a,I=this.b;if(k>=P.length)return!1;const p=P.length-k;return b>=p&&(b=p),b===0?!1:(this.a=new Uint32Array(P.length-b),this.a.set(P.subarray(0,k),0),this.a.set(P.subarray(k+b),k),this.b=new Uint32Array(this.a.length),k-1<this.c[0]&&(this.c[0]=k-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(k){return k<0?0:(k=(0,M.$le)(k),this.d(k))}d(k){if(k<=this.c[0])return this.b[k];let b=this.c[0]+1;b===0&&(this.b[0]=this.a[0],b++),k>=this.a.length&&(k=this.a.length-1);for(let P=b;P<=k;P++)this.b[P]=this.b[P-1]+this.a[P];return this.c[0]=Math.max(this.c[0],k),this.b[k]}getIndexOf(k){k=Math.floor(k),this.getTotalSum();let b=0,P=this.a.length-1,I=0,p=0,S=0;for(;b<=P;)if(I=b+(P-b)/2|0,p=this.b[I],S=p-this.a[I],k<S)P=I-1;else if(k>=p)b=I+1;else break;return new R(I,k-S)}}e.$Ju=g;class L{constructor(k){this.a=k,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(k){return this.g(),k===0?0:this.d[k-1]}getIndexOf(k){this.g();const b=this.e[k],P=b>0?this.d[b-1]:0;return new R(b,k-P)}removeValues(k,b){this.a.splice(k,b),this.f(k)}insertValues(k,b){this.a=(0,D.$Ub)(this.a,k,b),this.f(k)}f(k){this.b=!1,this.c=Math.min(this.c,k-1)}g(){if(!this.b){for(let k=this.c+1,b=this.a.length;k<b;k++){const P=this.a[k],I=k>0?this.d[k-1]:0;this.d[k]=I+P;for(let p=0;p<P;p++)this.e[I+p]=k}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(k,b){this.a[k]!==b&&(this.a[k]=b,this.f(k))}}e.$Ku=L;class R{constructor(k,b){this.index=k,this.remainder=b,this._prefixSumIndexOfResultBrand=void 0,this.index=k,this.remainder=b}}e.$Lu=R}),define(Se[171],De([1,0,15,62,170]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mu=void 0;class L{constructor(m,k,b,P){this.d=m,this.f=k,this.g=b,this.h=P,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(m){m.eol&&m.eol!==this.g&&(this.g=m.eol,this.j=null);const k=m.changes;for(const b of k)this.o(b.range),this.p(new M.$js(b.range.startLineNumber,b.range.startColumn),b.text);this.h=m.versionId,this.k=null}l(){if(!this.j){const m=this.g.length,k=this.f.length,b=new Uint32Array(k);for(let P=0;P<k;P++)b[P]=this.f[P].length+m;this.j=new g.$Ju(b)}}n(m,k){this.f[m]=k,this.j&&this.j.setValue(m,this.f[m].length+this.g.length)}o(m){if(m.startLineNumber===m.endLineNumber){if(m.startColumn===m.endColumn)return;this.n(m.startLineNumber-1,this.f[m.startLineNumber-1].substring(0,m.startColumn-1)+this.f[m.startLineNumber-1].substring(m.endColumn-1));return}this.n(m.startLineNumber-1,this.f[m.startLineNumber-1].substring(0,m.startColumn-1)+this.f[m.endLineNumber-1].substring(m.endColumn-1)),this.f.splice(m.startLineNumber,m.endLineNumber-m.startLineNumber),this.j&&this.j.removeValues(m.startLineNumber,m.endLineNumber-m.startLineNumber)}p(m,k){if(k.length===0)return;const b=(0,D.$Ae)(k);if(b.length===1){this.n(m.lineNumber-1,this.f[m.lineNumber-1].substring(0,m.column-1)+b[0]+this.f[m.lineNumber-1].substring(m.column-1));return}b[b.length-1]+=this.f[m.lineNumber-1].substring(m.column-1),this.n(m.lineNumber-1,this.f[m.lineNumber-1].substring(0,m.column-1)+b[0]);const P=new Uint32Array(b.length-1);for(let I=1;I<b.length;I++)this.f.splice(m.lineNumber+I-1,0,b[I]),P[I-1]=b[I].length+this.g.length;this.j&&this.j.insertValues(m.lineNumber,P)}}e.$Mu=L}),define(Se[172],De([1,0,15,167,62,34,125]),function($e,e,D,M,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mC=e.$lC=e.$kC=e.$jC=e.$iC=e.$hC=void 0;const m=999;class k{constructor(n,h,$,d){this.searchString=n,this.isRegex=h,this.matchCase=$,this.wordSeparators=d}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=b(this.searchString):n=this.searchString.indexOf(`
`)>=0;let h=null;try{h=D.$ye(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!h)return null;let $=!this.isRegex&&!n;return $&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&($=this.matchCase),new R.$Eu(h,this.wordSeparators?(0,M.$Ks)(this.wordSeparators):null,$?this.searchString:null)}}e.$hC=k;function b(s){if(!s||s.length===0)return!1;for(let n=0,h=s.length;n<h;n++){const $=s.charCodeAt(n);if($===10)return!0;if($===92){if(n++,n>=h)break;const d=s.charCodeAt(n);if(d===110||d===114||d===87)return!0}}return!1}e.$iC=b;function P(s,n,h){if(!h)return new R.$Bu(s,null);const $=[];for(let d=0,t=n.length;d<t;d++)$[d]=n[d];return new R.$Bu(s,$)}e.$jC=P;class I{constructor(n){const h=[];let $=0;for(let d=0,t=n.length;d<t;d++)n.charCodeAt(d)===10&&(h[$++]=d);this.a=h}findLineFeedCountBeforeOffset(n){const h=this.a;let $=0,d=h.length-1;if(d===-1||n<=h[0])return 0;for(;$<d;){const t=$+((d-$)/2>>0);h[t]>=n?d=t-1:h[t+1]>=n?($=t,d=t):$=t+1}return $+1}}class p{static findMatches(n,h,$,d,t){const r=h.parseSearchRequest();return r?r.regex.multiline?this.b(n,$,new o(r.wordSeparators,r.regex),d,t):this.c(n,$,r,d,t):[]}static a(n,h,$,d,t,r){let a,i=0;d?(i=d.findLineFeedCountBeforeOffset(t),a=h+t+i):a=h+t;let c;if(d){const u=d.findLineFeedCountBeforeOffset(t+r.length)-i;c=a+r.length+u}else c=a+r.length;const f=n.getPositionAt(a),y=n.getPositionAt(c);return new L.$ks(f.lineNumber,f.column,y.lineNumber,y.column)}static b(n,h,$,d,t){const r=n.getOffsetAt(h.getStartPosition()),a=n.getValueInRange(h,1),i=n.getEOL()===`\r
`?new I(a):null,c=[];let f=0,y;for($.reset(0);y=$.next(a);)if(c[f++]=P(this.a(n,r,a,i,y.index,y[0]),y,d),f>=t)return c;return c}static c(n,h,$,d,t){const r=[];let a=0;if(h.startLineNumber===h.endLineNumber){const c=n.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return a=this.d($,c,h.startLineNumber,h.startColumn-1,a,r,d,t),r}const i=n.getLineContent(h.startLineNumber).substring(h.startColumn-1);a=this.d($,i,h.startLineNumber,h.startColumn-1,a,r,d,t);for(let c=h.startLineNumber+1;c<h.endLineNumber&&a<t;c++)a=this.d($,n.getLineContent(c),c,0,a,r,d,t);if(a<t){const c=n.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);a=this.d($,c,h.endLineNumber,0,a,r,d,t)}return r}static d(n,h,$,d,t,r,a,i){const c=n.wordSeparators;if(!a&&n.simpleSearch){const E=n.simpleSearch,u=E.length,l=h.length;let w=-u;for(;(w=h.indexOf(E,w+u))!==-1;)if((!c||v(c,h,l,w,u))&&(r[t++]=new R.$Bu(new L.$ks($,w+1+d,$,w+1+u+d),null),t>=i))return t;return t}const f=new o(n.wordSeparators,n.regex);let y;f.reset(0);do if(y=f.next(h),y&&(r[t++]=P(new L.$ks($,y.index+1+d,$,y.index+1+y[0].length+d),y,a),t>=i))return t;while(y);return t}static findNextMatch(n,h,$,d){const t=h.parseSearchRequest();if(!t)return null;const r=new o(t.wordSeparators,t.regex);return t.regex.multiline?this.e(n,$,r,d):this.f(n,$,r,d)}static e(n,h,$,d){const t=new g.$js(h.lineNumber,1),r=n.getOffsetAt(t),a=n.getLineCount(),i=n.getValueInRange(new L.$ks(t.lineNumber,t.column,a,n.getLineMaxColumn(a)),1),c=n.getEOL()===`\r
`?new I(i):null;$.reset(h.column-1);const f=$.next(i);return f?P(this.a(n,r,i,c,f.index,f[0]),f,d):h.lineNumber!==1||h.column!==1?this.e(n,new g.$js(1,1),$,d):null}static f(n,h,$,d){const t=n.getLineCount(),r=h.lineNumber,a=n.getLineContent(r),i=this.g($,a,r,h.column,d);if(i)return i;for(let c=1;c<=t;c++){const f=(r+c-1)%t,y=n.getLineContent(f+1),E=this.g($,y,f+1,1,d);if(E)return E}return null}static g(n,h,$,d,t){n.reset(d-1);const r=n.next(h);return r?P(new L.$ks($,r.index+1,$,r.index+1+r[0].length),r,t):null}static findPreviousMatch(n,h,$,d){const t=h.parseSearchRequest();if(!t)return null;const r=new o(t.wordSeparators,t.regex);return t.regex.multiline?this.h(n,$,r,d):this.j(n,$,r,d)}static h(n,h,$,d){const t=this.b(n,new L.$ks(1,1,h.lineNumber,h.column),$,d,10*m);if(t.length>0)return t[t.length-1];const r=n.getLineCount();return h.lineNumber!==r||h.column!==n.getLineMaxColumn(r)?this.h(n,new g.$js(r,n.getLineMaxColumn(r)),$,d):null}static j(n,h,$,d){const t=n.getLineCount(),r=h.lineNumber,a=n.getLineContent(r).substring(0,h.column-1),i=this.k($,a,r,d);if(i)return i;for(let c=1;c<=t;c++){const f=(t+r-c-1)%t,y=n.getLineContent(f+1),E=this.k($,y,f+1,d);if(E)return E}return null}static k(n,h,$,d){let t=null,r;for(n.reset(0);r=n.next(h);)t=P(new L.$ks($,r.index+1,$,r.index+1+r[0].length),r,d);return t}}e.$kC=p;function S(s,n,h,$,d){if($===0)return!0;const t=n.charCodeAt($-1);if(s.get(t)!==0||t===13||t===10)return!0;if(d>0){const r=n.charCodeAt($);if(s.get(r)!==0)return!0}return!1}function C(s,n,h,$,d){if($+d===h)return!0;const t=n.charCodeAt($+d);if(s.get(t)!==0||t===13||t===10)return!0;if(d>0){const r=n.charCodeAt($+d-1);if(s.get(r)!==0)return!0}return!1}function v(s,n,h,$,d){return S(s,n,h,$,d)&&C(s,n,h,$,d)}e.$lC=v;class o{constructor(n,h){this._wordSeparators=n,this.a=h,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const h=n.length;let $;do{if(this.b+this.c===h||($=this.a.exec(n),!$))return null;const d=$.index,t=$[0].length;if(d===this.b&&t===this.c){if(t===0){D.$Te(n,h,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=d,this.c=t,!this._wordSeparators||v(this._wordSeparators,n,h,d,t))return $}while($);return null}}e.$mC=o}),define(Se[173],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k7=e.$j7=void 0;class D{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const R=this.a.get(L);return this.a.delete(L),R}}addDragOperationTransfer(L,R){this.a.set(L,R)}}e.$j7=D;class M{constructor(L){this.identifier=L}}e.$k7=M}),define(Se[174],De([1,0,4,3]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=void 0;class g{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$fd,this.onDidChange=this.c.event,this.d=null}handleChange(m){this.c.fire({changedLanguages:m,changedColorMap:!1})}register(m,k){return this.a.set(m,k),this.handleChange([m]),(0,M.$ic)(()=>{this.a.get(m)===k&&(this.a.delete(m),this.handleChange([m]))})}get(m){return this.a.get(m)||null}registerFactory(m,k){this.b.get(m)?.dispose();const b=new L(this,m,k);return this.b.set(m,b),(0,M.$ic)(()=>{const P=this.b.get(m);!P||P!==b||(this.b.delete(m),P.dispose())})}async getOrCreate(m){const k=this.get(m);if(k)return k;const b=this.b.get(m);return!b||b.isResolved?null:(await b.resolve(),this.get(m))}isResolved(m){if(this.get(m))return!0;const b=this.b.get(m);return!!(!b||b.isResolved)}setColorMap(m){this.d=m,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Vs=g;class L extends M.$kc{get isResolved(){return this.c}constructor(m,k,b){super(),this.f=m,this.g=k,this.h=b,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const m=await this.h.tokenizationSupport;this.c=!0,m&&!this.a&&this.B(this.f.register(this.g,m))}}}),define(Se[175],De([10,11]),function($e,e){return $e.create("vs/base/common/actions",e)}),define(Se[176],De([1,0,4,3,175]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=void 0;class L extends M.$kc{constructor(p,S="",C="",v=!0,o){super(),this.h=this.B(new D.$fd),this.onDidChange=this.h.event,this.w=!0,this.j=p,this.m=S,this.u=C,this.w=v,this.C=o}get id(){return this.j}get label(){return this.m}set label(p){this.D(p)}D(p){this.m!==p&&(this.m=p,this.h.fire({label:p}))}get tooltip(){return this.n||""}set tooltip(p){this.F(p)}F(p){this.n!==p&&(this.n=p,this.h.fire({tooltip:p}))}get class(){return this.u}set class(p){this.G(p)}G(p){this.u!==p&&(this.u=p,this.h.fire({class:p}))}get enabled(){return this.w}set enabled(p){this.H(p)}H(p){this.w!==p&&(this.w=p,this.h.fire({enabled:p}))}get checked(){return this.z}set checked(p){this.I(p)}I(p){this.z!==p&&(this.z=p,this.h.fire({checked:p}))}async run(p,S){this.C&&await this.C(p)}}e.$gi=L;class R extends M.$kc{constructor(){super(...arguments),this.f=this.B(new D.$fd),this.onWillRun=this.f.event,this.m=this.B(new D.$fd),this.onDidRun=this.m.event}async run(p,S){if(!p.enabled)return;this.f.fire({action:p});let C;try{await this.u(p,S)}catch(v){C=v}this.m.fire({action:p,error:C})}async u(p,S){await p.run(S)}}e.$hi=R;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let S=[];for(const C of p)C.length&&(S.length?S=[...S,new m,...C]:S=C);return S}static{this.ID="vs.actions.separator"}async run(){}}e.$ii=m;class k{get actions(){return this.a}constructor(p,S,C,v){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=S,this.class=v,this.a=C}async run(){}}e.$ji=k;class b extends L{static{this.ID="vs.actions.empty"}constructor(){super(b.ID,g.localize(0,null),void 0,!1)}}e.$ki=b;function P(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async(...p)=>I.run(),tooltip:I.label}}e.$li=P}),define(Se[177],De([10,11]),function($e,e){return $e.create("vs/base/common/date",e)}),define(Se[178],De([1,0,177]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=void 0;const M=60,g=M*60,L=g*24,R=L*7,m=L*30,k=L*365;function b(I,p,S,C){typeof I!="number"&&(I=I.getTime());const v=Math.round((new Date().getTime()-I)/1e3);if(v<-30)return(0,D.localize)(0,null,b(new Date().getTime()+v*1e3,!1));if(!C&&v<30)return(0,D.localize)(1,null);let o;return v<M?(o=v,p?o===1?S?(0,D.localize)(2,null,o):(0,D.localize)(3,null,o):S?(0,D.localize)(4,null,o):(0,D.localize)(5,null,o):o===1?S?(0,D.localize)(6,null,o):(0,D.localize)(7,null,o):S?(0,D.localize)(8,null,o):(0,D.localize)(9,null,o)):v<g?(o=Math.floor(v/M),p?o===1?S?(0,D.localize)(10,null,o):(0,D.localize)(11,null,o):S?(0,D.localize)(12,null,o):(0,D.localize)(13,null,o):o===1?S?(0,D.localize)(14,null,o):(0,D.localize)(15,null,o):S?(0,D.localize)(16,null,o):(0,D.localize)(17,null,o)):v<L?(o=Math.floor(v/g),p?o===1?S?(0,D.localize)(18,null,o):(0,D.localize)(19,null,o):S?(0,D.localize)(20,null,o):(0,D.localize)(21,null,o):o===1?S?(0,D.localize)(22,null,o):(0,D.localize)(23,null,o):S?(0,D.localize)(24,null,o):(0,D.localize)(25,null,o)):v<R?(o=Math.floor(v/L),p?o===1?(0,D.localize)(26,null,o):(0,D.localize)(27,null,o):o===1?(0,D.localize)(28,null,o):(0,D.localize)(29,null,o)):v<m?(o=Math.floor(v/R),p?o===1?S?(0,D.localize)(30,null,o):(0,D.localize)(31,null,o):S?(0,D.localize)(32,null,o):(0,D.localize)(33,null,o):o===1?S?(0,D.localize)(34,null,o):(0,D.localize)(35,null,o):S?(0,D.localize)(36,null,o):(0,D.localize)(37,null,o)):v<k?(o=Math.floor(v/m),p?o===1?S?(0,D.localize)(38,null,o):(0,D.localize)(39,null,o):S?(0,D.localize)(40,null,o):(0,D.localize)(41,null,o):o===1?S?(0,D.localize)(42,null,o):(0,D.localize)(43,null,o):S?(0,D.localize)(44,null,o):(0,D.localize)(45,null,o)):(o=Math.floor(v/k),p?o===1?S?(0,D.localize)(46,null,o):(0,D.localize)(47,null,o):S?(0,D.localize)(48,null,o):(0,D.localize)(49,null,o):o===1?S?(0,D.localize)(50,null,o):(0,D.localize)(51,null,o):S?(0,D.localize)(52,null,o):(0,D.localize)(53,null,o))}e.$6l=b;function P(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$7l=P}),define(Se[179],De([10,11]),function($e,e){return $e.create("vs/base/common/errorMessage",e)}),define(Se[46],De([1,0,19,18,179]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=void 0;function L(I,p){return p&&(I.stack||I.stacktrace)?g.localize(0,null,m(I),R(I.stack)||R(I.stacktrace)):m(I)}function R(I){return Array.isArray(I)?I.join(`
`):I}function m(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?g.localize(1,null,I.message):I.message||g.localize(2,null)}function k(I=null,p=!1){if(!I)return g.localize(3,null);if(Array.isArray(I)){const S=D.$Fb(I),C=k(S[0],p);return S.length>1?g.localize(4,null,C,S.length):C}if(M.$jf(I))return I;if(I.detail){const S=I.detail;if(S.error)return L(S.error,p);if(S.exception)return L(S.exception,p)}return I.stack?L(I,p):I.message?I.message:g.localize(5,null)}e.$mi=k;function b(I){const p=I;return p instanceof Error&&Array.isArray(p.actions)}e.$ni=b;function P(I,p){let S;return typeof I=="string"?S=new Error(I):S=I,S.actions=p,S}e.$oi=P}),define(Se[180],De([10,11]),function($e,e){return $e.create("vs/base/common/platform",e)}),define(Se[12],De([1,0,180]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let M=!1,g=!1,L=!1,R=!1,m=!1,k=!1,b=!1,P=!1,I=!1,p=!1,S,C=e.$f,v=e.$f,o,s;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let n;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?n=e.$g.vscode.process:typeof process<"u"&&(n=process);const h=typeof n?.versions?.electron=="string",$=h&&n?.type==="renderer";if(typeof navigator=="object"&&!$)s=navigator.userAgent,M=s.indexOf("Windows")>=0,g=s.indexOf("Macintosh")>=0,P=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=s.indexOf("Linux")>=0,p=s?.indexOf("Mobi")>=0,k=!0,S=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$f,C=S,v=navigator.language;else if(typeof n=="object"){M=n.platform==="win32",g=n.platform==="darwin",L=n.platform==="linux",R=L&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,b=h,I=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,S=e.$f,C=e.$f;const E=n.env.VSCODE_NLS_CONFIG;if(E)try{const u=JSON.parse(E),l=u.availableLanguages["*"];S=u.locale,v=u.osLocale,C=l||e.$f,o=u._translationsConfigFile}catch{}m=!0}else console.error("Unable to resolve platform.");var d;(function(E){E[E.Web=0]="Web",E[E.Mac=1]="Mac",E[E.Linux=2]="Linux",E[E.Windows=3]="Windows"})(d||(e.Platform=d={}));function t(E){switch(E){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let r=0;g?r=1:M?r=3:L&&(r=2),e.$i=M,e.$j=g,e.$k=L,e.$l=R,e.$m=m,e.$n=b,e.$o=k,e.$p=k&&typeof e.$g.importScripts=="function",e.$q=P,e.$r=p,e.$s=I,e.$t=r,e.$u=s,e.$v=C;var a;(function(E){function u(){return e.$v}E.value=u;function l(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}E.isDefaultVariant=l;function w(){return e.$v==="en"}E.isDefault=w})(a||(e.Language=a={})),e.$w=S,e.$x=v,e.$y=o,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const E=[];e.$g.addEventListener("message",l=>{if(l.data&&l.data.vscodeScheduleAsyncWork)for(let w=0,A=E.length;w<A;w++){const N=E[w];if(N.id===l.data.vscodeScheduleAsyncWork){E.splice(w,1),N.callback();return}}});let u=0;return l=>{const w=++u;E.push({id:w,callback:l}),e.$g.postMessage({vscodeScheduleAsyncWork:w},"*")}}return E=>setTimeout(E)})();var i;(function(E){E[E.Windows=1]="Windows",E[E.Macintosh=2]="Macintosh",E[E.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=g||P?2:M?1:3;let c=!0,f=!1;function y(){if(!f){f=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,c=new Uint16Array(E.buffer)[0]===(2<<8)+1}return c}e.$C=y,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(Se[47],De([1,0,12]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=e.$3d=e.env=e.cwd=void 0;let M;if(typeof D.$g.vscode<"u"&&typeof D.$g.vscode.process<"u"){const g=D.$g.vscode.process;M={get platform(){return g.platform},get arch(){return g.arch},get env(){return g.env},cwd(){return g.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=M.cwd,e.env=M.env,e.$3d=M.platform,e.$4d=M.arch}),define(Se[16],De([1,0,47]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=e.sep=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=void 0;const M=65,g=97,L=90,R=122,m=46,k=47,b=92,P=58,I=63;class p extends Error{constructor(r,a,i){let c;typeof a=="string"&&a.indexOf("not ")===0?(c="must not be",a=a.replace(/^not /,"")):c="must be";const f=r.indexOf(".")!==-1?"property":"argument";let y=`The "${r}" ${f} ${c} of type ${a}`;y+=`. Received type ${typeof i}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function S(t,r){if(t===null||typeof t!="object")throw new p(r,"Object",t)}function C(t,r){if(typeof t!="string")throw new p(r,"string",t)}const v=D.$3d==="win32";function o(t){return t===k||t===b}function s(t){return t===k}function n(t){return t>=M&&t<=L||t>=g&&t<=R}function h(t,r,a,i){let c="",f=0,y=-1,E=0,u=0;for(let l=0;l<=t.length;++l){if(l<t.length)u=t.charCodeAt(l);else{if(i(u))break;u=k}if(i(u)){if(!(y===l-1||E===1))if(E===2){if(c.length<2||f!==2||c.charCodeAt(c.length-1)!==m||c.charCodeAt(c.length-2)!==m){if(c.length>2){const w=c.lastIndexOf(a);w===-1?(c="",f=0):(c=c.slice(0,w),f=c.length-1-c.lastIndexOf(a)),y=l,E=0;continue}else if(c.length!==0){c="",f=0,y=l,E=0;continue}}r&&(c+=c.length>0?`${a}..`:"..",f=2)}else c.length>0?c+=`${a}${t.slice(y+1,l)}`:c=t.slice(y+1,l),f=l-y-1;y=l,E=0}else u===m&&E!==-1?++E:E=-1}return c}function $(t,r){S(r,"pathObject");const a=r.dir||r.root,i=r.base||`${r.name||""}${r.ext||""}`;return a?a===r.root?`${a}${i}`:`${a}${t}${i}`:i}e.$5d={resolve(...t){let r="",a="",i=!1;for(let c=t.length-1;c>=-1;c--){let f;if(c>=0){if(f=t[c],C(f,"path"),f.length===0)continue}else r.length===0?f=D.cwd():(f=D.env[`=${r}`]||D.cwd(),(f===void 0||f.slice(0,2).toLowerCase()!==r.toLowerCase()&&f.charCodeAt(2)===b)&&(f=`${r}\\`));const y=f.length;let E=0,u="",l=!1;const w=f.charCodeAt(0);if(y===1)o(w)&&(E=1,l=!0);else if(o(w))if(l=!0,o(f.charCodeAt(1))){let A=2,N=A;for(;A<y&&!o(f.charCodeAt(A));)A++;if(A<y&&A!==N){const O=f.slice(N,A);for(N=A;A<y&&o(f.charCodeAt(A));)A++;if(A<y&&A!==N){for(N=A;A<y&&!o(f.charCodeAt(A));)A++;(A===y||A!==N)&&(u=`\\\\${O}\\${f.slice(N,A)}`,E=A)}}}else E=1;else n(w)&&f.charCodeAt(1)===P&&(u=f.slice(0,2),E=2,y>2&&o(f.charCodeAt(2))&&(l=!0,E=3));if(u.length>0)if(r.length>0){if(u.toLowerCase()!==r.toLowerCase())continue}else r=u;if(i){if(r.length>0)break}else if(a=`${f.slice(E)}\\${a}`,i=l,l&&r.length>0)break}return a=h(a,!i,"\\",o),i?`${r}\\${a}`:`${r}${a}`||"."},normalize(t){C(t,"path");const r=t.length;if(r===0)return".";let a=0,i,c=!1;const f=t.charCodeAt(0);if(r===1)return s(f)?"\\":t;if(o(f))if(c=!0,o(t.charCodeAt(1))){let E=2,u=E;for(;E<r&&!o(t.charCodeAt(E));)E++;if(E<r&&E!==u){const l=t.slice(u,E);for(u=E;E<r&&o(t.charCodeAt(E));)E++;if(E<r&&E!==u){for(u=E;E<r&&!o(t.charCodeAt(E));)E++;if(E===r)return`\\\\${l}\\${t.slice(u)}\\`;E!==u&&(i=`\\\\${l}\\${t.slice(u,E)}`,a=E)}}}else a=1;else n(f)&&t.charCodeAt(1)===P&&(i=t.slice(0,2),a=2,r>2&&o(t.charCodeAt(2))&&(c=!0,a=3));let y=a<r?h(t.slice(a),!c,"\\",o):"";return y.length===0&&!c&&(y="."),y.length>0&&o(t.charCodeAt(r-1))&&(y+="\\"),i===void 0?c?`\\${y}`:y:c?`${i}\\${y}`:`${i}${y}`},isAbsolute(t){C(t,"path");const r=t.length;if(r===0)return!1;const a=t.charCodeAt(0);return o(a)||r>2&&n(a)&&t.charCodeAt(1)===P&&o(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,a;for(let f=0;f<t.length;++f){const y=t[f];C(y,"path"),y.length>0&&(r===void 0?r=a=y:r+=`\\${y}`)}if(r===void 0)return".";let i=!0,c=0;if(typeof a=="string"&&o(a.charCodeAt(0))){++c;const f=a.length;f>1&&o(a.charCodeAt(1))&&(++c,f>2&&(o(a.charCodeAt(2))?++c:i=!1))}if(i){for(;c<r.length&&o(r.charCodeAt(c));)c++;c>=2&&(r=`\\${r.slice(c)}`)}return e.$5d.normalize(r)},relative(t,r){if(C(t,"from"),C(r,"to"),t===r)return"";const a=e.$5d.resolve(t),i=e.$5d.resolve(r);if(a===i||(t=a.toLowerCase(),r=i.toLowerCase(),t===r))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===b;)c++;let f=t.length;for(;f-1>c&&t.charCodeAt(f-1)===b;)f--;const y=f-c;let E=0;for(;E<r.length&&r.charCodeAt(E)===b;)E++;let u=r.length;for(;u-1>E&&r.charCodeAt(u-1)===b;)u--;const l=u-E,w=y<l?y:l;let A=-1,N=0;for(;N<w;N++){const F=t.charCodeAt(c+N);if(F!==r.charCodeAt(E+N))break;F===b&&(A=N)}if(N!==w){if(A===-1)return i}else{if(l>w){if(r.charCodeAt(E+N)===b)return i.slice(E+N+1);if(N===2)return i.slice(E+N)}y>w&&(t.charCodeAt(c+N)===b?A=N:N===2&&(A=3)),A===-1&&(A=0)}let O="";for(N=c+A+1;N<=f;++N)(N===f||t.charCodeAt(N)===b)&&(O+=O.length===0?"..":"\\..");return E+=A,O.length>0?`${O}${i.slice(E,u)}`:(i.charCodeAt(E)===b&&++E,i.slice(E,u))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$5d.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===b){if(r.charCodeAt(1)===b){const a=r.charCodeAt(2);if(a!==I&&a!==m)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(n(r.charCodeAt(0))&&r.charCodeAt(1)===P&&r.charCodeAt(2)===b)return`\\\\?\\${r}`;return t},dirname(t){C(t,"path");const r=t.length;if(r===0)return".";let a=-1,i=0;const c=t.charCodeAt(0);if(r===1)return o(c)?t:".";if(o(c)){if(a=i=1,o(t.charCodeAt(1))){let E=2,u=E;for(;E<r&&!o(t.charCodeAt(E));)E++;if(E<r&&E!==u){for(u=E;E<r&&o(t.charCodeAt(E));)E++;if(E<r&&E!==u){for(u=E;E<r&&!o(t.charCodeAt(E));)E++;if(E===r)return t;E!==u&&(a=i=E+1)}}}}else n(c)&&t.charCodeAt(1)===P&&(a=r>2&&o(t.charCodeAt(2))?3:2,i=a);let f=-1,y=!0;for(let E=r-1;E>=i;--E)if(o(t.charCodeAt(E))){if(!y){f=E;break}}else y=!1;if(f===-1){if(a===-1)return".";f=a}return t.slice(0,f)},basename(t,r){r!==void 0&&C(r,"ext"),C(t,"path");let a=0,i=-1,c=!0,f;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===P&&(a=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let y=r.length-1,E=-1;for(f=t.length-1;f>=a;--f){const u=t.charCodeAt(f);if(o(u)){if(!c){a=f+1;break}}else E===-1&&(c=!1,E=f+1),y>=0&&(u===r.charCodeAt(y)?--y===-1&&(i=f):(y=-1,i=E))}return a===i?i=E:i===-1&&(i=t.length),t.slice(a,i)}for(f=t.length-1;f>=a;--f)if(o(t.charCodeAt(f))){if(!c){a=f+1;break}}else i===-1&&(c=!1,i=f+1);return i===-1?"":t.slice(a,i)},extname(t){C(t,"path");let r=0,a=-1,i=0,c=-1,f=!0,y=0;t.length>=2&&t.charCodeAt(1)===P&&n(t.charCodeAt(0))&&(r=i=2);for(let E=t.length-1;E>=r;--E){const u=t.charCodeAt(E);if(o(u)){if(!f){i=E+1;break}continue}c===-1&&(f=!1,c=E+1),u===m?a===-1?a=E:y!==1&&(y=1):a!==-1&&(y=-1)}return a===-1||c===-1||y===0||y===1&&a===c-1&&a===i+1?"":t.slice(a,c)},format:$.bind(null,"\\"),parse(t){C(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const a=t.length;let i=0,c=t.charCodeAt(0);if(a===1)return o(c)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(o(c)){if(i=1,o(t.charCodeAt(1))){let A=2,N=A;for(;A<a&&!o(t.charCodeAt(A));)A++;if(A<a&&A!==N){for(N=A;A<a&&o(t.charCodeAt(A));)A++;if(A<a&&A!==N){for(N=A;A<a&&!o(t.charCodeAt(A));)A++;A===a?i=A:A!==N&&(i=A+1)}}}}else if(n(c)&&t.charCodeAt(1)===P){if(a<=2)return r.root=r.dir=t,r;if(i=2,o(t.charCodeAt(2))){if(a===3)return r.root=r.dir=t,r;i=3}}i>0&&(r.root=t.slice(0,i));let f=-1,y=i,E=-1,u=!0,l=t.length-1,w=0;for(;l>=i;--l){if(c=t.charCodeAt(l),o(c)){if(!u){y=l+1;break}continue}E===-1&&(u=!1,E=l+1),c===m?f===-1?f=l:w!==1&&(w=1):f!==-1&&(w=-1)}return E!==-1&&(f===-1||w===0||w===1&&f===E-1&&f===y+1?r.base=r.name=t.slice(y,E):(r.name=t.slice(y,f),r.base=t.slice(y,E),r.ext=t.slice(f,E))),y>0&&y!==i?r.dir=t.slice(0,y-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const d=(()=>{if(v){const t=/\\/g;return()=>{const r=D.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>D.cwd()})();e.$6d={resolve(...t){let r="",a=!1;for(let i=t.length-1;i>=-1&&!a;i--){const c=i>=0?t[i]:d();C(c,"path"),c.length!==0&&(r=`${c}/${r}`,a=c.charCodeAt(0)===k)}return r=h(r,!a,"/",s),a?`/${r}`:r.length>0?r:"."},normalize(t){if(C(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===k,a=t.charCodeAt(t.length-1)===k;return t=h(t,!r,"/",s),t.length===0?r?"/":a?"./":".":(a&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return C(t,"path"),t.length>0&&t.charCodeAt(0)===k},join(...t){if(t.length===0)return".";let r;for(let a=0;a<t.length;++a){const i=t[a];C(i,"path"),i.length>0&&(r===void 0?r=i:r+=`/${i}`)}return r===void 0?".":e.$6d.normalize(r)},relative(t,r){if(C(t,"from"),C(r,"to"),t===r||(t=e.$6d.resolve(t),r=e.$6d.resolve(r),t===r))return"";const a=1,i=t.length,c=i-a,f=1,y=r.length-f,E=c<y?c:y;let u=-1,l=0;for(;l<E;l++){const A=t.charCodeAt(a+l);if(A!==r.charCodeAt(f+l))break;A===k&&(u=l)}if(l===E)if(y>E){if(r.charCodeAt(f+l)===k)return r.slice(f+l+1);if(l===0)return r.slice(f+l)}else c>E&&(t.charCodeAt(a+l)===k?u=l:l===0&&(u=0));let w="";for(l=a+u+1;l<=i;++l)(l===i||t.charCodeAt(l)===k)&&(w+=w.length===0?"..":"/..");return`${w}${r.slice(f+u)}`},toNamespacedPath(t){return t},dirname(t){if(C(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===k;let a=-1,i=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===k){if(!i){a=c;break}}else i=!1;return a===-1?r?"/":".":r&&a===1?"//":t.slice(0,a)},basename(t,r){r!==void 0&&C(r,"ext"),C(t,"path");let a=0,i=-1,c=!0,f;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let y=r.length-1,E=-1;for(f=t.length-1;f>=0;--f){const u=t.charCodeAt(f);if(u===k){if(!c){a=f+1;break}}else E===-1&&(c=!1,E=f+1),y>=0&&(u===r.charCodeAt(y)?--y===-1&&(i=f):(y=-1,i=E))}return a===i?i=E:i===-1&&(i=t.length),t.slice(a,i)}for(f=t.length-1;f>=0;--f)if(t.charCodeAt(f)===k){if(!c){a=f+1;break}}else i===-1&&(c=!1,i=f+1);return i===-1?"":t.slice(a,i)},extname(t){C(t,"path");let r=-1,a=0,i=-1,c=!0,f=0;for(let y=t.length-1;y>=0;--y){const E=t.charCodeAt(y);if(E===k){if(!c){a=y+1;break}continue}i===-1&&(c=!1,i=y+1),E===m?r===-1?r=y:f!==1&&(f=1):r!==-1&&(f=-1)}return r===-1||i===-1||f===0||f===1&&r===i-1&&r===a+1?"":t.slice(r,i)},format:$.bind(null,"/"),parse(t){C(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const a=t.charCodeAt(0)===k;let i;a?(r.root="/",i=1):i=0;let c=-1,f=0,y=-1,E=!0,u=t.length-1,l=0;for(;u>=i;--u){const w=t.charCodeAt(u);if(w===k){if(!E){f=u+1;break}continue}y===-1&&(E=!1,y=u+1),w===m?c===-1?c=u:l!==1&&(l=1):c!==-1&&(l=-1)}if(y!==-1){const w=f===0&&a?1:f;c===-1||l===0||l===1&&c===y-1&&c===f+1?r.base=r.name=t.slice(w,y):(r.name=t.slice(w,c),r.base=t.slice(w,y),r.ext=t.slice(c,y))}return f>0?r.dir=t.slice(0,f-1):a&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$6d.win32=e.$5d.win32=e.$5d,e.$6d.posix=e.$5d.posix=e.$6d,e.$7d=v?e.$5d.normalize:e.$6d.normalize,e.$8d=v?e.$5d.isAbsolute:e.$6d.isAbsolute,e.$9d=v?e.$5d.join:e.$6d.join,e.$0d=v?e.$5d.resolve:e.$6d.resolve,e.$$d=v?e.$5d.relative:e.$6d.relative,e.$_d=v?e.$5d.dirname:e.$6d.dirname,e.$ae=v?e.$5d.basename:e.$6d.basename,e.$be=v?e.$5d.extname:e.$6d.extname,e.$ce=v?e.$5d.format:e.$6d.format,e.$de=v?e.$5d.parse:e.$6d.parse,e.$ee=v?e.$5d.toNamespacedPath:e.$6d.toNamespacedPath,e.sep=v?e.$5d.sep:e.$6d.sep,e.$ge=v?e.$5d.delimiter:e.$6d.delimiter}),define(Se[126],De([1,0,59,16]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=e.$bq=e.$aq=e.$_p=e.$$p=e.$0p=void 0;const g=new D.$T(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),L=new D.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new D.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(E,u,l=!1){const w=E||"",A=u||"",N=g.value.collator.compare(w,A);return g.value.collatorIsNumeric&&N===0&&w!==A?w<A?-1:1:N}e.$0p=m;function k(E,u){const l=L.value.collator;return E=E||"",u=u||"",$(l,E,u)}e.$$p=k;function b(E,u){const l=L.value.collator;return E=E||"",u=u||"",a(E,u)||$(l,E,u)}e.$_p=b;function P(E,u){const l=L.value.collator;return E=E||"",u=u||"",r(E,u)||$(l,E,u)}e.$aq=P;function I(E,u){return E=E||"",u=u||"",E===u?0:E<u?-1:1}e.$bq=I;function p(E,u){const[l,w]=n(E),[A,N]=n(u);let O=g.value.collator.compare(w,N);if(O===0){if(g.value.collatorIsNumeric&&w!==N)return w<N?-1:1;if(O=g.value.collator.compare(l,A),g.value.collatorIsNumeric&&O===0&&l!==A)return l<A?-1:1}return O}e.$cq=p;function S(E,u){E=E||"",u=u||"";const l=h(E),w=h(u),A=L.value.collator,N=R.value.collator;return $(N,l,w)||$(A,E,u)}e.$dq=S;function C(E,u){E=E||"",u=u||"";const l=h(E),w=h(u),A=L.value.collator,N=R.value.collator;return $(N,l,w)||a(E,u)||$(A,E,u)}e.$eq=C;function v(E,u){E=E||"",u=u||"";const l=h(E),w=h(u),A=L.value.collator,N=R.value.collator;return $(N,l,w)||r(E,u)||$(A,E,u)}e.$fq=v;function o(E,u){E=E||"",u=u||"";const l=h(E).toLowerCase(),w=h(u).toLowerCase();return l!==w?l<w?-1:1:E!==u?E<u?-1:1:0}e.$gq=o;const s=/^(.*?)(\.([^.]*))?$/;function n(E,u=!1){const l=E?s.exec(E):[];let w=[l&&l[1]||"",l&&l[3]||""];return u&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function h(E){const u=E?s.exec(E):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function $(E,u,l){const w=E.compare(u,l);return w!==0?w:u.length!==l.length?u.length<l.length?-1:1:0}function d(E){const u=E.charAt(0);return u.toLocaleUpperCase()!==u}function t(E){const u=E.charAt(0);return u.toLocaleLowerCase()!==u}function r(E,u){return d(E)&&t(u)?-1:t(E)&&d(u)?1:0}function a(E,u){return t(E)&&d(u)?-1:d(E)&&t(u)?1:0}function i(E,u,l=!1){return l||(E=E&&E.toLowerCase(),u=u&&u.toLowerCase()),E===u?0:E<u?-1:1}function c(E,u,l=!1){const w=E.split(M.sep),A=u.split(M.sep),N=w.length-1,O=A.length-1;let F,j;for(let z=0;;z++){if(F=N===z,j=O===z,F&&j)return m(w[z],A[z],l);if(F)return-1;if(j)return 1;const T=i(w[z],A[z],l);if(T!==0)return T}}e.$hq=c;function f(E,u,l){const w=E.toLowerCase(),A=u.toLowerCase(),N=y(E,u,l);if(N)return N;const O=w.endsWith(l),F=A.endsWith(l);if(O!==F)return O?-1:1;const j=m(w,A);return j!==0?j:w.localeCompare(A)}e.$iq=f;function y(E,u,l){const w=E.toLowerCase(),A=u.toLowerCase(),N=w.startsWith(l),O=A.startsWith(l);if(N!==O)return N?-1:1;if(N&&O){if(w.length<A.length)return-1;if(w.length>A.length)return 1}return 0}e.$jq=y}),define(Se[32],De([1,0,16,12,15,18]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=void 0;function R(f){return f===47||f===92}e.$Bf=R;function m(f){return f.replace(/[\\/]/g,D.$6d.sep)}e.$Cf=m;function k(f){return f.indexOf("/")===-1&&(f=m(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.$Df=k;function b(f,y=D.$6d.sep){if(!f)return"";const E=f.length,u=f.charCodeAt(0);if(R(u)){if(R(f.charCodeAt(1))&&!R(f.charCodeAt(2))){let w=3;const A=w;for(;w<E&&!R(f.charCodeAt(w));w++);if(A!==w&&!R(f.charCodeAt(w+1))){for(w+=1;w<E;w++)if(R(f.charCodeAt(w)))return f.slice(0,w+1).replace(/[\\/]/g,y)}}return y}else if(s(u)&&f.charCodeAt(1)===58)return R(f.charCodeAt(2))?f.slice(0,2)+y:f.slice(0,2);let l=f.indexOf("://");if(l!==-1){for(l+=3;l<E;l++)if(R(f.charCodeAt(l)))return f.slice(0,l+1)}return""}e.$Ef=b;function P(f){if(!M.$i||!f||f.length<5)return!1;let y=f.charCodeAt(0);if(y!==92||(y=f.charCodeAt(1),y!==92))return!1;let E=2;const u=E;for(;E<f.length&&(y=f.charCodeAt(E),y!==92);E++);return!(u===E||(y=f.charCodeAt(E+1),isNaN(y)||y===92))}e.$Ff=P;const I=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function C(f,y=M.$i){const E=y?I:p;return!(!f||f.length===0||/^\s+$/.test(f)||(E.lastIndex=0,E.test(f))||y&&S.test(f)||f==="."||f===".."||y&&f[f.length-1]==="."||y&&f.length!==f.trim().length||f.length>255)}e.$Gf=C;function v(f,y,E){const u=f===y;return!E||u?u:!f||!y?!1:(0,g.$Me)(f,y)}e.$Hf=v;function o(f,y,E,u=D.sep){if(f===y)return!0;if(!f||!y||y.length>f.length)return!1;if(E){if(!(0,g.$Ne)(f,y))return!1;if(y.length===f.length)return!0;let w=y.length;return y.charAt(y.length-1)===u&&w--,f.charAt(w)===u}return y.charAt(y.length-1)!==u&&(y+=u),f.indexOf(y)===0}e.$If=o;function s(f){return f>=65&&f<=90||f>=97&&f<=122}e.$Jf=s;function n(f,y){return M.$i&&f.endsWith(":")&&(f+=D.sep),(0,D.$8d)(f)||(f=(0,D.$9d)(y,f)),f=(0,D.$7d)(f),M.$i?(f=(0,g.$ve)(f,D.sep),f.endsWith(":")&&(f+=D.sep)):(f=(0,g.$ve)(f,D.sep),f||(f=D.sep)),f}e.$Kf=n;function h(f){const y=(0,D.$7d)(f);return M.$i?f.length>3?!1:$(y)&&(f.length===2||y.charCodeAt(2)===92):y===D.$6d.sep}e.$Lf=h;function $(f,y=M.$i){return y?s(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.$Mf=$;function d(f,y=M.$i){return $(f,y)?f[0]:void 0}e.$Nf=d;function t(f,y,E){return y.length>f.length?-1:f===y?0:(E&&(f=f.toLowerCase(),y=y.toLowerCase()),f.indexOf(y))}e.$Of=t;function r(f){const y=f.split(":");let E,u,l;for(const w of y){const A=Number(w);(0,L.$nf)(A)?u===void 0?u=A:l===void 0&&(l=A):E=E?[E,w].join(":"):w}if(!E)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:E,line:u!==void 0?u:void 0,column:l!==void 0?l:u!==void 0?1:void 0}}e.$Pf=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function c(f,y,E=8){let u="";for(let w=0;w<E;w++){let A;w===0&&M.$i&&!y&&(E===3||E===4)?A=i:A=a,u+=A.charAt(Math.floor(Math.random()*A.length))}let l;return y?l=`${y}-${u}`:l=u,f?(0,D.$9d)(f,l):l}e.$Qf=c}),define(Se[127],De([1,0,126,121,51,16,12,15]),function($e,e,D,M,g,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=e.$kq=void 0;const k=0,b=[k,[]];function P(H,q,me,X){if(!H||!q)return b;const Z=H.length,V=q.length;if(Z<V)return b;const x=H.toLowerCase();return I(q,me,V,H,x,Z,X)}e.$kq=P;function I(H,q,me,X,Z,V,x){const ge=[],ue=[];for(let K=0;K<me;K++){const fe=K*V,te=fe-V,re=K>0,ne=H[K],Ee=q[K];for(let oe=0;oe<V;oe++){const he=oe>0,ee=fe+oe,le=ee-1,be=te+oe-1,Ie=he?ge[le]:0,B=re&&he?ge[be]:0,Q=re&&he?ue[be]:0;let ie;!B&&re?ie=0:ie=p(ne,Ee,X,Z,oe,Q),ie&&B+ie>=Ie&&(x||re||Z.startsWith(q,oe))?(ue[ee]=Q+1,ge[ee]=B+ie):(ue[ee]=k,ge[ee]=Ie)}}const we=[];let G=me-1,U=V-1;for(;G>=0&&U>=0;){const K=G*V+U;ue[K]===k||(we.push(U),G--),U--}return[ge[me*V-1],we.reverse()]}function p(H,q,me,X,Z,V){let x=0;if(!S(q,X[Z]))return x;if(x+=1,V>0&&(x+=V*5),H===me[Z]&&(x+=1),Z===0)x+=8;else{const ge=C(me.charCodeAt(Z-1));ge?x+=ge:(0,M.$Bj)(me.charCodeAt(Z))&&V===0&&(x+=2)}return x}function S(H,q){return H===q?!0:H==="/"||H==="\\"?q==="/"||q==="\\":!1}function C(H){switch(H){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const v=[void 0,[]];function o(H,q,me=0,X=0){const Z=q;return Z.values&&Z.values.length>1?s(H,Z.values,me,X):n(H,q,me,X)}e.$lq=o;function s(H,q,me,X){let Z=0;const V=[];for(const x of q){const[ge,ue]=n(H,x,me,X);if(typeof ge!="number")return v;Z+=ge,V.push(...ue)}return[Z,E(V)]}function n(H,q,me,X){const Z=(0,M.$Kj)(q.original,q.originalLowercase,me,H,H.toLowerCase(),X,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Z?[Z[0],(0,M.$Hj)(Z)]:v}const h=Object.freeze({score:0}),$=1<<18,d=1<<17,t=1<<16;function r(H,q,me,X){const Z=X.values?X.values:[X];return(0,g.$pi)({[X.normalized]:{values:Z.map(x=>({value:x.normalized,expectContiguousMatch:x.expectContiguousMatch})),label:H,description:q,allowNonContiguousMatches:me}})}function a(H,q,me,X,Z){if(!H||!q.normalized)return h;const V=X.getItemLabel(H);if(!V)return h;const x=X.getItemDescription(H),ge=r(V,x,me,q),ue=Z[ge];if(ue)return ue;const we=i(V,x,X.getItemPath(H),q,me);return Z[ge]=we,we}e.$mq=a;function i(H,q,me,X,Z){const V=!me||!X.containsPathSeparator;return me&&(R.$k?X.pathNormalized===me:(0,m.$Me)(X.pathNormalized,me))?{score:$,labelMatch:[{start:0,end:H.length}],descriptionMatch:q?[{start:0,end:q.length}]:void 0}:X.values&&X.values.length>1?c(H,q,me,X.values,V,Z):f(H,q,me,X,V,Z)}function c(H,q,me,X,Z,V){let x=0;const ge=[],ue=[];for(const we of X){const{score:G,labelMatch:U,descriptionMatch:K}=f(H,q,me,we,Z,V);if(G===k)return h;x+=G,U&&ge.push(...U),K&&ue.push(...K)}return{score:x,labelMatch:E(ge),descriptionMatch:E(ue)}}function f(H,q,me,X,Z,V){if(Z||!q){const[x,ge]=P(H,X.normalized,X.normalizedLowercase,V&&!X.expectContiguousMatch);if(x){const ue=(0,M.$yj)(X.normalized,H);let we;if(ue){we=d;const G=Math.round(X.normalized.length/H.length*100);we+=G}else we=t;return{score:we+x,labelMatch:ue||y(ge)}}}if(q){let x=q;me&&(x=`${q}${L.sep}`);const ge=x.length,ue=`${x}${H}`,[we,G]=P(ue,X.normalized,X.normalizedLowercase,V&&!X.expectContiguousMatch);if(we){const U=y(G),K=[],fe=[];return U.forEach(te=>{te.start<ge&&te.end>ge?(K.push({start:0,end:te.end-ge}),fe.push({start:te.start,end:ge})):te.start>=ge?K.push({start:te.start-ge,end:te.end-ge}):fe.push(te)}),{score:we,labelMatch:K,descriptionMatch:fe}}}return h}function y(H){const q=[];if(!H)return q;let me;for(const X of H)me&&me.end===X?me.end+=1:(me={start:X,end:X+1},q.push(me));return q}function E(H){const q=H.sort((Z,V)=>Z.start-V.start),me=[];let X;for(const Z of q)!X||!u(X,Z)?(X=Z,me.push(Z)):(X.start=Math.min(X.start,Z.start),X.end=Math.max(X.end,Z.end));return me}function u(H,q){return!(H.end<q.start||q.end<H.start)}function l(H,q,me,X,Z,V){const x=a(H,me,X,Z,V),ge=a(q,me,X,Z,V),ue=x.score,we=ge.score;if((ue===$||we===$)&&ue!==we)return ue===$?-1:1;if(ue>t||we>t){if(ue!==we)return ue>we?-1:1;if(ue<d&&we<d){const ne=A(x.labelMatch,ge.labelMatch);if(ne!==0)return ne}const te=Z.getItemLabel(H)||"",re=Z.getItemLabel(q)||"";if(te.length!==re.length)return te.length-re.length}if(ue!==we)return ue>we?-1:1;const G=Array.isArray(x.labelMatch)&&x.labelMatch.length>0,U=Array.isArray(ge.labelMatch)&&ge.labelMatch.length>0;if(G&&!U)return-1;if(U&&!G)return 1;const K=w(H,x,Z),fe=w(q,ge,Z);return K&&fe&&K!==fe?fe>K?-1:1:N(H,q,me,Z)}e.$nq=l;function w(H,q,me){let X=-1,Z=-1;if(q.descriptionMatch&&q.descriptionMatch.length?X=q.descriptionMatch[0].start:q.labelMatch&&q.labelMatch.length&&(X=q.labelMatch[0].start),q.labelMatch&&q.labelMatch.length){if(Z=q.labelMatch[q.labelMatch.length-1].end,q.descriptionMatch&&q.descriptionMatch.length){const V=me.getItemDescription(H);V&&(Z+=V.length)}}else q.descriptionMatch&&q.descriptionMatch.length&&(Z=q.descriptionMatch[q.descriptionMatch.length-1].end);return Z-X}function A(H,q){if(!H&&!q||(!H||!H.length)&&(!q||!q.length))return 0;if(!q||!q.length)return-1;if(!H||!H.length)return 1;const me=H[0].start,Z=H[H.length-1].end-me,V=q[0].start,ge=q[q.length-1].end-V;return Z===ge?0:ge<Z?1:-1}function N(H,q,me,X){const Z=X.getItemLabel(H)||"",V=X.getItemLabel(q)||"",x=X.getItemDescription(H),ge=X.getItemDescription(q),ue=Z.length+(x?x.length:0),we=V.length+(ge?ge.length:0);if(ue!==we)return ue-we;const G=X.getItemPath(H),U=X.getItemPath(q);return G&&U&&G.length!==U.length?G.length-U.length:Z!==V?(0,D.$iq)(Z,V,me.normalized):x&&ge&&x!==ge?(0,D.$iq)(x,ge,me.normalized):G&&U&&G!==U?(0,D.$iq)(G,U,me.normalized):0}function O(H){return H.startsWith('"')&&H.endsWith('"')}const F=" ";function j(H){typeof H!="string"&&(H="");const q=H.toLowerCase(),{pathNormalized:me,normalized:X,normalizedLowercase:Z}=z(H),V=me.indexOf(L.sep)>=0,x=O(H);let ge;const ue=H.split(F);if(ue.length>1)for(const we of ue){const G=O(we),{pathNormalized:U,normalized:K,normalizedLowercase:fe}=z(we);K&&(ge||(ge=[]),ge.push({original:we,originalLowercase:we.toLowerCase(),pathNormalized:U,normalized:K,normalizedLowercase:fe,expectContiguousMatch:G}))}return{original:H,originalLowercase:q,pathNormalized:me,normalized:X,normalizedLowercase:Z,values:ge,containsPathSeparator:V,expectContiguousMatch:x}}e.$oq=j;function z(H){let q;R.$i?q=H.replace(/\//g,L.sep):q=H.replace(/\\/g,L.sep);const me=(0,m.$xe)(q).replace(/\s|"/g,"");return{pathNormalized:q,normalized:me,normalizedLowercase:me.toLowerCase()}}function T(H){return Array.isArray(H)?j(H.map(q=>q.original).join(F)):j(H.original)}e.$pq=T}),define(Se[98],De([1,0,16]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=e.$Kr=e.$Jr=e.$Ir=e.$Hr=void 0,e.$Hr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},g={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(P){const I=(0,D.$be)(P),p=M[I.toLowerCase()];return p!==void 0?p:R(P)}e.$Ir=L;function R(P){const I=(0,D.$be)(P);return g[I.toLowerCase()]}e.$Jr=R;function m(P){for(const I in g)if(g[I]===P)return I}e.$Kr=m;const k=/^(.+)\/(.+?)(;.+)?$/;function b(P,I){const p=k.exec(P);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:I?void 0:P}e.$Lr=b}),define(Se[99],De([1,0,12]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=e.TerminateResponseCode=e.Source=void 0;var M;(function(m){m[m.stdout=0]="stdout",m[m.stderr=1]="stderr"})(M||(e.Source=M={}));var g;(function(m){m[m.Success=0]="Success",m[m.Unknown=1]="Unknown",m[m.AccessDenied=2]="AccessDenied",m[m.ProcessNotFound=3]="ProcessNotFound"})(g||(e.TerminateResponseCode=g={}));function L(m,...k){const b=k.reduce((p,S)=>(p[S]=!0,p),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(m).filter(p=>!b[p]).forEach(p=>{for(let S=0;S<P.length;S++)if(p.search(P[S])!==-1){delete m[p];break}})}e.$sl=L;function R(m){m&&(delete m.DEBUG,D.$j&&delete m.DYLD_LIBRARY_PATH,D.$k&&delete m.LD_PRELOAD)}e.$tl=R}),define(Se[2],De([1,0,16,12]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.URI=void 0;const g=/^\w[\w\d+.-]*$/,L=/^\//,R=/^\/\//;function m(i,c){if(!i.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!g.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!L.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function k(i,c){return!i&&!c?"file":i}function b(i,c){switch(i){case"https":case"http":case"file":c?c[0]!==I&&(c=I+c):c=I;break}return c}const P="",I="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{static isUri(c){return c instanceof S?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,f,y,E,u,l=!1){typeof c=="object"?(this.scheme=c.scheme||P,this.authority=c.authority||P,this.path=c.path||P,this.query=c.query||P,this.fragment=c.fragment||P):(this.scheme=k(c,l),this.authority=f||P,this.path=b(this.scheme,y||P),this.query=E||P,this.fragment=u||P,m(this,l))}get fsPath(){return $(this,!1)}with(c){if(!c)return this;let{scheme:f,authority:y,path:E,query:u,fragment:l}=c;return f===void 0?f=this.scheme:f===null&&(f=P),y===void 0?y=this.authority:y===null&&(y=P),E===void 0?E=this.path:E===null&&(E=P),u===void 0?u=this.query:u===null&&(u=P),l===void 0?l=this.fragment:l===null&&(l=P),f===this.scheme&&y===this.authority&&E===this.path&&u===this.query&&l===this.fragment?this:new o(f,y,E,u,l)}static parse(c,f=!1){const y=p.exec(c);return y?new o(y[2]||P,a(y[4]||P),a(y[5]||P),a(y[7]||P),a(y[9]||P),f):new o(P,P,P,P,P)}static file(c){let f=P;if(M.$i&&(c=c.replace(/\\/g,I)),c[0]===I&&c[1]===I){const y=c.indexOf(I,2);y===-1?(f=c.substring(2),c=I):(f=c.substring(2,y),c=c.substring(y)||I)}return new o("file",f,c,P,P)}static from(c,f){return new o(c.scheme,c.authority,c.path,c.query,c.fragment,f)}static joinPath(c,...f){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return M.$i&&c.scheme==="file"?y=S.file(D.$5d.join($(c,!0),...f)).path:y=D.$6d.join(c.path,...f),c.with({path:y})}toString(c=!1){return d(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof S)return c;{const f=new o(c);return f._formatted=c.external??null,f._fsPath=c._sep===v?c.fsPath??null:null,f}}else return c}}e.URI=S;function C(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$Sf=C;const v=M.$i?1:void 0;class o extends S{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=$(this,!1)),this._fsPath}toString(c=!1){return c?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=v),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function n(i,c,f){let y,E=-1;for(let u=0;u<i.length;u++){const l=i.charCodeAt(u);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||c&&l===47||f&&l===91||f&&l===93||f&&l===58)E!==-1&&(y+=encodeURIComponent(i.substring(E,u)),E=-1),y!==void 0&&(y+=i.charAt(u));else{y===void 0&&(y=i.substr(0,u));const w=s[l];w!==void 0?(E!==-1&&(y+=encodeURIComponent(i.substring(E,u)),E=-1),y+=w):E===-1&&(E=u)}}return E!==-1&&(y+=encodeURIComponent(i.substring(E))),y!==void 0?y:i}function h(i){let c;for(let f=0;f<i.length;f++){const y=i.charCodeAt(f);y===35||y===63?(c===void 0&&(c=i.substr(0,f)),c+=s[y]):c!==void 0&&(c+=i[f])}return c!==void 0?c:i}function $(i,c){let f;return i.authority&&i.path.length>1&&i.scheme==="file"?f=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?c?f=i.path.substr(1):f=i.path[1].toLowerCase()+i.path.substr(2):f=i.path,M.$i&&(f=f.replace(/\//g,"\\")),f}e.$Tf=$;function d(i,c){const f=c?h:n;let y="",{scheme:E,authority:u,path:l,query:w,fragment:A}=i;if(E&&(y+=E,y+=":"),(u||E==="file")&&(y+=I,y+=I),u){let N=u.indexOf("@");if(N!==-1){const O=u.substr(0,N);u=u.substr(N+1),N=O.lastIndexOf(":"),N===-1?y+=f(O,!1,!1):(y+=f(O.substr(0,N),!1,!1),y+=":",y+=f(O.substr(N+1),!1,!0)),y+="@"}u=u.toLowerCase(),N=u.lastIndexOf(":"),N===-1?y+=f(u,!1,!0):(y+=f(u.substr(0,N),!1,!0),y+=u.substr(N))}if(l){if(l.length>=3&&l.charCodeAt(0)===47&&l.charCodeAt(2)===58){const N=l.charCodeAt(1);N>=65&&N<=90&&(l=`/${String.fromCharCode(N+32)}:${l.substr(3)}`)}else if(l.length>=2&&l.charCodeAt(1)===58){const N=l.charCodeAt(0);N>=65&&N<=90&&(l=`${String.fromCharCode(N+32)}:${l.substr(2)}`)}y+=f(l,!0,!1)}return w&&(y+="?",y+=f(w,!1,!1)),A&&(y+="#",y+=c?A:n(A,!1,!1)),y}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(r)?i.replace(r,c=>t(c)):i}}),define(Se[181],De([1,0,2]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Pp=e.$Op=e.$Np=void 0;function M(b){const P=b;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$Np=M;function g(b){const P=[];let I;try{const p=JSON.parse(b.arguments),S=p[p.length-1];S&&S.__$stack&&(p.pop(),I=S.__$stack),P.push(...p)}catch{P.push("Unable to log remote console arguments",b.arguments)}return{args:P,stack:I}}e.$Op=g;function L(b){if(typeof b!="string")return L(g(b).stack);const P=b;if(P){const I=R(P),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(p&&p.length===4)return{uri:D.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$Pp=L;function R(b){if(!b)return b;const P=b.indexOf(`
`);return P===-1?b:b.substring(0,P)}function m(b,P){const{args:I,stack:p}=g(b),S=typeof I[0]=="string"&&I.length===1;let C=R(p);C&&(C=`(${C.trim()})`);let v=[];if(typeof I[0]=="string"?C&&S?v=[`%c[${P}] %c${I[0]} %c${C}`,k("blue"),k(""),k("grey")]:v=[`%c[${P}] %c${I[0]}`,k("blue"),k(""),...I.slice(1)]:v=[`%c[${P}]%`,k("blue"),...I],C&&!S&&v.push(C),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,v)}e.log=m;function k(b){return`color: ${b}`}}),define(Se[63],De([1,0,22,2]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$g=e.$0g=e.$9g=void 0;function g(k){return JSON.stringify(k,R)}e.$9g=g;function L(k){let b=JSON.parse(k);return b=m(b),b}e.$0g=L;function R(k,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:b.flags}:b}function m(k,b=0){if(!k||b>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return M.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 17:return new Date(k.source)}if(k instanceof D.$Fd||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let P=0;P<k.length;++P)k[P]=m(k[P],b+1);else for(const P in k)Object.hasOwnProperty.call(k,P)&&(k[P]=m(k[P],b+1))}return k}e.$$g=m}),define(Se[17],De([1,0,8,12,2]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.Schemas=void 0;var L;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeManagedRemoteResource="vscode-managed-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.vscodeChatSesssion="vscode-chat-editor",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$Uf="vscode-tkn",e.$Vf="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${L.vscodeRemoteResource}`}set(P,I,p){this.a[P]=I,this.b[P]=p}setConnectionToken(P,I){this.c[P]=I}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(o){return D.$Y(o),P}const I=P.authority;let p=this.a[I];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const S=this.b[I],C=this.c[I];let v=`path=${encodeURIComponent(P.path)}`;return typeof C=="string"&&(v+=`&${e.$Vf}=${encodeURIComponent(C)}`),g.URI.from({scheme:M.$o?this.d:L.vscodeRemoteResource,authority:`${p}:${S}`,path:this.f,query:v})}}e.$Wf=new R,e.$Xf="vs/../../extensions",e.$Yf="vs/../../node_modules",e.$Zf="vs/../../node_modules.asar",e.$1f="vs/../../node_modules.asar.unpacked";class m{static{this.a="vscode-app"}asBrowserUri(P){const I=this.b(P,$e);return this.uriToBrowserUri(I)}uriToBrowserUri(P){return P.scheme===L.vscodeRemote?e.$Wf.rewrite(P):P.scheme===L.file&&(M.$m||M.$p&&M.$g.origin===`${L.vscodeFileResource}://${m.a}`)?P.with({scheme:L.vscodeFileResource,authority:P.authority||m.a,query:null,fragment:null}):P}asFileUri(P){const I=this.b(P,$e);return this.uriToFileUri(I)}uriToFileUri(P){return P.scheme===L.vscodeFileResource?P.with({scheme:L.file,authority:P.authority!==m.a?P.authority:null,query:null,fragment:null}):P}b(P,I){return g.URI.isUri(P)?P:g.URI.parse(I.toUrl(P))}}e.$2f=new m;var k;(function(b){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(P.get("3"));const I="vscode-coi";function p(C){let v;typeof C=="string"?v=new URL(C).searchParams:C instanceof URL?v=C.searchParams:g.URI.isUri(C)&&(v=new URL(C.toString(!0)).searchParams);const o=v?.get(I);if(o)return P.get(o)}b.getHeadersFromQuery=p;function S(C,v,o){if(!globalThis.crossOriginIsolated)return;const s=v&&o?"3":o?"2":"1";C instanceof URLSearchParams?C.set(I,s):C[I]=s}b.addSearchParam=S})(k||(e.COI=k={}))}),define(Se[182],De([1,0,156,17,12,2]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aD=void 0;class R{constructor(p,S,C){this.id=p,this.dependencies=S,this.callback=C}}class m{static{this.INSTANCE=new m}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,S,C)=>{typeof p!="string"&&(C=S,S=p,p=null),(typeof S!="object"||!Array.isArray(S))&&(C=S,S=null),this.c.push(new R(p,S,C))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const S=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!S)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(S.dependencies)&&S.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${S.dependencies.join(", ")}`);return typeof S.callback=="function"?S.callback([]):S.callback}h(p){return new Promise((S,C)=>{const v=document.createElement("script");v.setAttribute("async","async"),v.setAttribute("type","text/javascript");const o=()=>{v.removeEventListener("load",s),v.removeEventListener("error",n)},s=h=>{o(),S(this.c.pop())},n=h=>{o(),C(h)};v.addEventListener("load",s),v.addEventListener("error",n),this.f&&(p=this.f.createScriptURL(p)),v.setAttribute("src",p),document.getElementsByTagName("head")[0].appendChild(v)})}i(p){return new Promise((S,C)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),S(this.c.pop())}catch(v){C(v)}})}async j(p){try{const S=globalThis._VSCODE_NODE_MODULES.fs,C=globalThis._VSCODE_NODE_MODULES.vm,v=globalThis._VSCODE_NODE_MODULES.module,o=L.URI.parse(p).fsPath,s=S.readFileSync(o).toString(),n=v.wrap(s.replace(/^#!.*/,""));return new C.Script(n).runInThisContext().apply(),this.c.pop()}catch(S){throw S}}}const k=new Map;let b={};typeof globalThis.require=="object"&&(b=globalThis.require.paths??{});async function P(I,p,S){if(D.$R){S===void 0&&(S=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),b[I]&&(I=b[I]);const C=`${I}/${p}`;if(k.has(C))return k.get(C);let v;if(/^\w[\w\d+.-]*:\/\//.test(C))v=C;else{const h=`${S&&!g.$o?M.$Zf:M.$Yf}/${C}`;v=M.$2f.asBrowserUri(h).toString(!0)}const o=m.INSTANCE.load(v);return k.set(C,o),o}else return await new Promise((C,v)=>{$e([I],C,v)})}e.$aD=P}),define(Se[24],De([1,0,32,17,16,12,15,2]),function($e,e,D,M,g,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=e.DataUri=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=void 0;function k(S){return(0,m.$Tf)(S,!0)}e.$9f=k;class b{constructor(C){this.a=C}compare(C,v,o=!1){return C===v?0:(0,R.$Fe)(this.getComparisonKey(C,o),this.getComparisonKey(v,o))}isEqual(C,v,o=!1){return C===v?!0:!C||!v?!1:this.getComparisonKey(C,o)===this.getComparisonKey(v,o)}getComparisonKey(C,v=!1){return C.with({path:this.a(C)?C.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(C){return this.a(C)}isEqualOrParent(C,v,o=!1){if(C.scheme===v.scheme){if(C.scheme===M.Schemas.file)return D.$If(k(C),k(v),this.a(C))&&C.query===v.query&&(o||C.fragment===v.fragment);if((0,e.$ng)(C.authority,v.authority))return D.$If(C.path,v.path,this.a(C),"/")&&C.query===v.query&&(o||C.fragment===v.fragment)}return!1}joinPath(C,...v){return m.URI.joinPath(C,...v)}basenameOrAuthority(C){return(0,e.$fg)(C)||C.authority}basename(C){return g.$6d.basename(C.path)}extname(C){return g.$6d.extname(C.path)}dirname(C){if(C.path.length===0)return C;let v;return C.scheme===M.Schemas.file?v=m.URI.file(g.$_d(k(C))).path:(v=g.$6d.dirname(C.path),C.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${C.toString})) resulted in a relative path`),v="/")),C.with({path:v})}normalizePath(C){if(!C.path.length)return C;let v;return C.scheme===M.Schemas.file?v=m.URI.file(g.$7d(k(C))).path:v=g.$6d.normalize(C.path),C.with({path:v})}relativePath(C,v){if(C.scheme!==v.scheme||!(0,e.$ng)(C.authority,v.authority))return;if(C.scheme===M.Schemas.file){const n=g.$$d(k(C),k(v));return L.$i?D.$Cf(n):n}let o=C.path||"/";const s=v.path||"/";if(this.a(C)){let n=0;for(const h=Math.min(o.length,s.length);n<h&&!(o.charCodeAt(n)!==s.charCodeAt(n)&&o.charAt(n).toLowerCase()!==s.charAt(n).toLowerCase());n++);o=s.substr(0,n)+o.substr(n)}return g.$6d.relative(o,s)}resolvePath(C,v){if(C.scheme===M.Schemas.file){const o=m.URI.file(g.$0d(k(C),v));return C.with({authority:o.authority,path:o.path})}return v=D.$Df(v),C.with({path:g.$6d.resolve(C.path,v)})}isAbsolutePath(C){return!!C.path&&C.path[0]==="/"}isEqualAuthority(C,v){return C===v||C!==void 0&&v!==void 0&&(0,R.$Me)(C,v)}hasTrailingPathSeparator(C,v=g.sep){if(C.scheme===M.Schemas.file){const o=k(C);return o.length>D.$Ef(o).length&&o[o.length-1]===v}else{const o=C.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(C.fsPath)}}removeTrailingPathSeparator(C,v=g.sep){return(0,e.$og)(C,v)?C.with({path:C.path.substr(0,C.path.length-1)}):C}addTrailingPathSeparator(C,v=g.sep){let o=!1;if(C.scheme===M.Schemas.file){const s=k(C);o=s!==void 0&&s.length===D.$Ef(s).length&&s[s.length-1]===v}else{v="/";const s=C.path;o=s.length===1&&s.charCodeAt(s.length-1)===47}return!o&&!(0,e.$og)(C,v)?C.with({path:C.path+"/"}):C}}e.$0f=b,e.$$f=new b(()=>!1),e.$_f=new b(S=>S.scheme===M.Schemas.file?!L.$k:!0),e.$ag=new b(S=>!0),e.$bg=e.$$f.isEqual.bind(e.$$f),e.$cg=e.$$f.isEqualOrParent.bind(e.$$f),e.$dg=e.$$f.getComparisonKey.bind(e.$$f),e.$eg=e.$$f.basenameOrAuthority.bind(e.$$f),e.$fg=e.$$f.basename.bind(e.$$f),e.$gg=e.$$f.extname.bind(e.$$f),e.$hg=e.$$f.dirname.bind(e.$$f),e.$ig=e.$$f.joinPath.bind(e.$$f),e.$jg=e.$$f.normalizePath.bind(e.$$f),e.$kg=e.$$f.relativePath.bind(e.$$f),e.$lg=e.$$f.resolvePath.bind(e.$$f),e.$mg=e.$$f.isAbsolutePath.bind(e.$$f),e.$ng=e.$$f.isEqualAuthority.bind(e.$$f),e.$og=e.$$f.hasTrailingPathSeparator.bind(e.$$f),e.$pg=e.$$f.removeTrailingPathSeparator.bind(e.$$f),e.$qg=e.$$f.addTrailingPathSeparator.bind(e.$$f);function P(S,C){const v=[];for(let o=0;o<S.length;o++){const s=C(S[o]);S.some((n,h)=>h===o?!1:(0,e.$cg)(s,C(n)))||v.push(S[o])}return v}e.$rg=P;var I;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function C(v){const o=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(h=>{const[$,d]=h.split(":");$&&d&&o.set($,d)});const n=v.path.substring(0,v.path.indexOf(";"));return n&&o.set(S.META_DATA_MIME,n),o}S.parseMetaData=C})(I||(e.DataUri=I={}));function p(S,C,v){if(C){let o=S.path;return o&&o[0]!==g.$6d.sep&&(o=g.$6d.sep+o),S.with({scheme:v,authority:C,path:o})}return S.with({scheme:v})}e.$sg=p}),define(Se[9],De([1,0,21,8,4,3,24,12,160]),function($e,e,D,M,g,L,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=e.$4g=e.$3g=e.Promises=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=void 0;function b(U){return!!U&&typeof U.then=="function"}e.$tg=b;function P(U){const K=new D.$pd,fe=U(K.token),te=new Promise((re,ne)=>{const Ee=K.token.onCancellationRequested(()=>{Ee.dispose(),K.dispose(),ne(new M.$3)});Promise.resolve(fe).then(oe=>{Ee.dispose(),K.dispose(),re(oe)},oe=>{Ee.dispose(),K.dispose(),ne(oe)})});return new class{cancel(){K.cancel()}then(re,ne){return te.then(re,ne)}catch(re){return this.then(void 0,re)}finally(re){return te.finally(re)}}}e.$ug=P;function I(U,K,fe){return new Promise((te,re)=>{const ne=K.onCancellationRequested(()=>{ne.dispose(),te(fe)});U.then(te,re).finally(()=>ne.dispose())})}e.$vg=I;function p(U,K){return new Promise((fe,te)=>{const re=K.onCancellationRequested(()=>{re.dispose(),te(new M.$3)});U.then(fe,te).finally(()=>re.dispose())})}e.$wg=p;async function S(U){let K=-1;const fe=U.map((te,re)=>te.then(ne=>(K=re,ne)));try{return await Promise.race(fe)}finally{U.forEach((te,re)=>{re!==K&&te.cancel()})}}e.$xg=S;function C(U,K,fe){let te;const re=setTimeout(()=>{te?.(void 0),fe?.()},K);return Promise.race([U.finally(()=>clearTimeout(re)),new Promise(ne=>te=ne)])}e.$yg=C;function v(U){return new Promise((K,fe)=>{const te=U();b(te)?te.then(K,fe):K(te)})}e.$zg=v;class o{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(K){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=K,!this.b){const fe=()=>{if(this.b=null,this.f)return;const te=this.queue(this.d);return this.d=null,te};this.b=new Promise(te=>{this.a.then(fe,fe).then(te)})}return new Promise((fe,te)=>{this.b.then(fe,te)})}return this.a=K(),new Promise((fe,te)=>{this.a.then(re=>{this.a=null,fe(re)},re=>{this.a=null,te(re)})})}dispose(){this.f=!0}}e.$Ag=o;class s{constructor(){this.a=Promise.resolve(null)}queue(K){return this.a=this.a.then(()=>K(),()=>K())}}e.$Bg=s;class n{constructor(){this.a=new Map}queue(K,fe){const re=(this.a.get(K)??Promise.resolve()).catch(()=>{}).then(fe).finally(()=>{this.a.get(K)===re&&this.a.delete(K)});return this.a.set(K,re),re}}e.$Cg=n;const h=(U,K)=>{let fe=!0;const te=setTimeout(()=>{fe=!1,K()},U);return{isTriggered:()=>fe,dispose:()=>{clearTimeout(te),fe=!1}}},$=U=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,U())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class d{constructor(K){this.defaultDelay=K,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(K,fe=this.defaultDelay){this.g=K,this.h(),this.b||(this.b=new Promise((re,ne)=>{this.d=re,this.f=ne}).then(()=>{if(this.b=null,this.d=null,this.g){const re=this.g;return this.g=null,re()}}));const te=()=>{this.a=null,this.d?.(null)};return this.a=fe===k.$cd?$(te):h(fe,te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dg=d;class t{constructor(K){this.a=new d(K),this.b=new o}trigger(K,fe){return this.a.trigger(()=>this.b.queue(K),fe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eg=t;class r{constructor(){this.a=!1,this.b=new Promise((K,fe)=>{this.d=K})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fg=r;class a extends r{constructor(K){super(),this.f=setTimeout(()=>this.open(),K)}open(){clearTimeout(this.f),super.open()}}e.$Gg=a;function i(U,K){return K?new Promise((fe,te)=>{const re=setTimeout(()=>{ne.dispose(),fe()},U),ne=K.onCancellationRequested(()=>{clearTimeout(re),ne.dispose(),te(new M.$3)})}):P(fe=>i(U,fe))}e.$Hg=i;function c(U,K=0){const fe=setTimeout(U,K);return(0,L.$ic)(()=>clearTimeout(fe))}e.$Ig=c;function f(U){const K=[];let fe=0;const te=U.length;function re(){return fe<te?U[fe++]():null}function ne(Ee){Ee!=null&&K.push(Ee);const oe=re();return oe?oe.then(ne):Promise.resolve(K)}return Promise.resolve(null).then(ne)}e.$Jg=f;function y(U,K=te=>!!te,fe=null){let te=0;const re=U.length,ne=()=>{if(te>=re)return Promise.resolve(fe);const Ee=U[te++];return Promise.resolve(Ee()).then(he=>K(he)?Promise.resolve(he):ne())};return ne()}e.$Kg=y;function E(U,K=te=>!!te,fe=null){if(U.length===0)return Promise.resolve(fe);let te=U.length;const re=()=>{te=-1;for(const ne of U)ne.cancel?.()};return new Promise((ne,Ee)=>{for(const oe of U)oe.then(he=>{--te>=0&&K(he)?(re(),ne(he)):te===0&&ne(fe)}).catch(he=>{--te>=0&&(re(),Ee(he))})})}e.$Lg=E;class u{constructor(K){this.a=0,this.d=K,this.f=[],this.b=0,this.g=new g.$fd}get onDrained(){return this.g.event}get size(){return this.a}queue(K){return this.a++,new Promise((fe,te)=>{this.f.push({factory:K,c:fe,e:te}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const K=this.f.shift();this.b++;const fe=K.factory();fe.then(K.c,K.e),fe.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Mg=u;class l extends u{constructor(){super(1)}}e.$Ng=l;class w{constructor(){this.a=new me,this.b=0}queue(K){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,K())):this.a.run(this.b++,K())}}e.$Og=w;class A{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const K=new V;return this.b.add(K),K.p}g(){for(const[,K]of this.a)if(K.size>0)return!1;return!0}queueFor(K,fe=R.$$f){const te=fe.getComparisonKey(K);let re=this.a.get(te);if(!re){re=new l;const ne=this.f++,Ee=g.Event.once(re.onDrained)(()=>{re?.dispose(),this.a.delete(te),this.h(),this.d?.deleteAndDispose(ne),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$sc),this.d.set(ne,Ee),this.a.set(te,re)}return re}h(){this.g()&&this.j()}j(){for(const K of this.b)K.complete();this.b.clear()}dispose(){for(const[,K]of this.a)K.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Pg=A;class N{constructor(K,fe){this.a=-1,typeof K=="function"&&typeof fe=="number"&&this.setIfNotSet(K,fe)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(K,fe){this.cancel(),this.a=setTimeout(()=>{this.a=-1,K()},fe)}setIfNotSet(K,fe){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,K()},fe))}}e.$Qg=N;class O{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(K,fe){this.cancel(),this.a=setInterval(()=>{K()},fe)}}e.$Rg=O;class F{constructor(K,fe){this.b=-1,this.a=K,this.d=fe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(K=this.d){this.cancel(),this.b=setTimeout(this.f,K)}get delay(){return this.d}set delay(K){this.d=K}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sg=F;class j{constructor(K,fe){fe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${fe}ms is not a multiple of 1000ms.`),this.a=K,this.b=fe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(K=this.b){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(K/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Tg=j;class z extends F{constructor(K,fe){super(K,fe),this.j=[]}work(K){this.j.push(K),this.isScheduled()||this.schedule()}h(){const K=this.j;this.j=[],this.a?.(K)}dispose(){this.j=[],super.dispose()}}e.$Ug=z;class T extends L.$kc{constructor(K,fe){super(),this.g=K,this.h=fe,this.a=[],this.b=this.B(new L.$lc),this.f=!1}get pending(){return this.a.length}work(K){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+K.length>this.g.maxBufferedWork)return!1}else if(this.pending+K.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const fe of K)this.a.push(fe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new F(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vg=T,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Wg=U=>{(0,m.$A)(()=>{if(K)return;const fe=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,fe-Date.now())}}))});let K=!1;return{dispose(){K||(K=!0)}}}:e.$Wg=(U,K)=>{const fe=requestIdleCallback(U,typeof K=="number"?{timeout:K}:void 0);let te=!1;return{dispose(){te||(te=!0,cancelIdleCallback(fe))}}}}();class H{constructor(K){this.d=!1,this.a=()=>{try{this.f=K()}catch(fe){this.g=fe}finally{this.d=!0}},this.b=(0,e.$Wg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Xg=H;async function q(U,K,fe){let te;for(let re=0;re<fe;re++)try{return await U()}catch(ne){te=ne,await i(K)}throw te}e.$Yg=q;class me{isRunning(K){return typeof K=="number"?this.a?.taskId===K:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(K,fe,te){return this.a={taskId:K,cancel:()=>te?.(),promise:fe},fe.then(()=>this.d(K),()=>this.d(K)),fe}d(K){this.a&&K===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const K=this.b;this.b=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this.b)this.b.run=K;else{let fe,te;const re=new Promise((ne,Ee)=>{fe=ne,te=Ee});this.b={run:K,promise:re,promiseResolve:fe,promiseReject:te}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Zg=me;class X{constructor(K,fe=()=>Date.now()){this.d=K,this.f=fe,this.a=0,this.b=0}increment(){const K=this.f();return K-this.a>this.d&&(this.a=K,this.b=0),this.b++,this.b}}e.$1g=X;var Z;(function(U){U[U.Resolved=0]="Resolved",U[U.Rejected=1]="Rejected"})(Z||(Z={}));class V{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((K,fe)=>{this.a=K,this.b=fe})}complete(K){return new Promise(fe=>{this.a(K),this.d={outcome:0,value:K},fe()})}error(K){return new Promise(fe=>{this.b(K),this.d={outcome:1,value:K},fe()})}cancel(){return this.error(new M.$3)}}e.$2g=V;var x;(function(U){async function K(te){let re;const ne=await Promise.all(te.map(Ee=>Ee.then(oe=>oe,oe=>{re||(re=oe)})));if(typeof re<"u")throw re;return ne}U.settled=K;function fe(te){return new Promise(async(re,ne)=>{try{await te(re,ne)}catch(Ee){ne(Ee)}})}U.withAsyncBody=fe})(x||(e.Promises=x={}));var ge;(function(U){U[U.Initial=0]="Initial",U[U.DoneOK=1]="DoneOK",U[U.DoneError=2]="DoneError"})(ge||(ge={}));class ue{static fromArray(K){return new ue(fe=>{fe.emitMany(K)})}static fromPromise(K){return new ue(async fe=>{fe.emitMany(await K)})}static fromPromises(K){return new ue(async fe=>{await Promise.all(K.map(async te=>fe.emitOne(await te)))})}static merge(K){return new ue(async fe=>{await Promise.all(K.map(async te=>{for await(const re of te)fe.emitOne(re)}))})}static{this.EMPTY=ue.fromArray([])}constructor(K){this.a=0,this.b=[],this.d=null,this.f=new g.$fd,queueMicrotask(async()=>{const fe={emitOne:te=>this.g(te),emitMany:te=>this.h(te),reject:te=>this.k(te)};try{await Promise.resolve(K(fe)),this.j()}catch(te){this.k(te)}finally{fe.emitOne=void 0,fe.emitMany=void 0,fe.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(K<this.b.length)return{done:!1,value:this.b[K++]};if(this.a===1)return{done:!0,value:void 0};await g.Event.toPromise(this.f.event)}while(!0)}}}static map(K,fe){return new ue(async te=>{for await(const re of K)te.emitOne(fe(re))})}map(K){return ue.map(this,K)}static filter(K,fe){return new ue(async te=>{for await(const re of K)fe(re)&&te.emitOne(re)})}filter(K){return ue.filter(this,K)}static coalesce(K){return ue.filter(K,fe=>!!fe)}coalesce(){return ue.coalesce(this)}static async toPromise(K){const fe=[];for await(const te of K)fe.push(te);return fe}toPromise(){return ue.toPromise(this)}g(K){this.a===0&&(this.b.push(K),this.f.fire())}h(K){this.a===0&&(this.b=this.b.concat(K),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(K){this.a===0&&(this.a=2,this.d=K,this.f.fire())}}e.$3g=ue;class we extends ue{constructor(K,fe){super(fe),this.l=K}cancel(){this.l.cancel()}}e.$4g=we;function G(U){const K=new D.$pd,fe=U(K.token);return new we(K,async te=>{const re=K.token.onCancellationRequested(()=>{re.dispose(),K.dispose(),te.reject(new M.$3)});try{for await(const ne of fe){if(K.token.isCancellationRequested)return;te.emitOne(ne)}re.dispose(),K.dispose()}catch(ne){re.dispose(),K.dispose(),te.reject(ne)}})}e.$5g=G}),define(Se[35],De([1,0,19,9,32,28,16,12,15]),function($e,e,D,M,g,L,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=void 0;function b(){return Object.create(null)}e.$mj=b,e.$nj="**",e.$oj="/";const P="[/\\\\]",I="[^/\\\\]",p=/\//g;function S(me,X){switch(me){case 0:return"";case 1:return`${I}*?`;default:return`(?:${P}|${I}+${P}${X?`|${P}${I}+`:""})*?`}}function C(me,X){if(!me)return[];const Z=[];let V=!1,x=!1,ge="";for(const ue of me){switch(ue){case X:if(!V&&!x){Z.push(ge),ge="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":x=!0;break;case"]":x=!1;break}ge+=ue}return ge&&Z.push(ge),Z}e.$pj=C;function v(me){if(!me)return"";let X="";const Z=C(me,e.$oj);if(Z.every(V=>V===e.$nj))X=".*";else{let V=!1;Z.forEach((x,ge)=>{if(x===e.$nj){if(V)return;X+=S(2,ge===Z.length-1)}else{let ue=!1,we="",G=!1,U="";for(const K of x){if(K!=="}"&&ue){we+=K;continue}if(G&&(K!=="]"||!U)){let fe;K==="-"?fe=K:(K==="^"||K==="!")&&!U?fe="^":K===e.$oj?fe="":fe=(0,k.$qe)(K),U+=fe;continue}switch(K){case"{":ue=!0;continue;case"[":G=!0;continue;case"}":{const te=`(?:${C(we,",").map(re=>v(re)).join("|")})`;X+=te,ue=!1,we="";break}case"]":{X+="["+U+"]",G=!1,U="";break}case"?":X+=I;continue;case"*":X+=S(1);continue;default:X+=(0,k.$qe)(K)}}ge<Z.length-1&&(Z[ge+1]!==e.$nj||ge+2<Z.length)&&(X+=P)}V=x===e.$nj})}return X}const o=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,$=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.$Ci(1e4),r=function(){return!1},a=function(){return null};function i(me,X){if(!me)return a;let Z;typeof me!="string"?Z=me.pattern:Z=me,Z=Z.trim();const V=`${Z}_${!!X.trimForExclusions}`;let x=t.get(V);if(x)return c(x,me);let ge;return o.test(Z)?x=y(Z.substr(4),Z):(ge=s.exec(f(Z,X)))?x=E(ge[1],Z):(X.trimForExclusions?h:n).test(Z)?x=u(Z,X):(ge=$.exec(f(Z,X)))?x=l(ge[1].substr(1),Z,!0):(ge=d.exec(f(Z,X)))?x=l(ge[1],Z,!1):x=w(Z),t.set(V,x),c(x,me)}function c(me,X){if(typeof X=="string")return me;const Z=function(V,x){return(0,g.$If)(V,X.base,!m.$k)?me((0,k.$ue)(V.substr(X.base.length),R.sep),x):null};return Z.allBasenames=me.allBasenames,Z.allPaths=me.allPaths,Z.basenames=me.basenames,Z.patterns=me.patterns,Z}function f(me,X){return X.trimForExclusions&&me.endsWith("/**")?me.substr(0,me.length-2):me}function y(me,X){return function(Z,V){return typeof Z=="string"&&Z.endsWith(me)?X:null}}function E(me,X){const Z=`/${me}`,V=`\\${me}`,x=function(ue,we){return typeof ue!="string"?null:we?we===me?X:null:ue===me||ue.endsWith(Z)||ue.endsWith(V)?X:null},ge=[me];return x.basenames=ge,x.patterns=[X],x.allBasenames=ge,x}function u(me,X){const Z=H(me.slice(1,-1).split(",").map(we=>i(we,X)).filter(we=>we!==a),me),V=Z.length;if(!V)return a;if(V===1)return Z[0];const x=function(we,G){for(let U=0,K=Z.length;U<K;U++)if(Z[U](we,G))return me;return null},ge=Z.find(we=>!!we.allBasenames);ge&&(x.allBasenames=ge.allBasenames);const ue=Z.reduce((we,G)=>G.allPaths?we.concat(G.allPaths):we,[]);return ue.length&&(x.allPaths=ue),x}function l(me,X,Z){const V=R.sep===R.$6d.sep,x=V?me:me.replace(p,R.sep),ge=R.sep+x,ue=R.$6d.sep+me;let we;return Z?we=function(G,U){return typeof G=="string"&&(G===x||G.endsWith(ge)||!V&&(G===me||G.endsWith(ue)))?X:null}:we=function(G,U){return typeof G=="string"&&(G===x||!V&&G===me)?X:null},we.allPaths=[(Z?"*/":"./")+me],we}function w(me){try{const X=new RegExp(`^${v(me)}$`);return function(Z){return X.lastIndex=0,typeof Z=="string"&&X.test(Z)?me:null}}catch{return a}}function A(me,X,Z){return!me||typeof X!="string"?!1:N(me)(X,void 0,Z)}e.$qj=A;function N(me,X={}){if(!me)return r;if(typeof me=="string"||O(me)){const Z=i(me,X);if(Z===a)return r;const V=function(x,ge){return!!Z(x,ge)};return Z.allBasenames&&(V.allBasenames=Z.allBasenames),Z.allPaths&&(V.allPaths=Z.allPaths),V}return z(me,X)}e.$rj=N;function O(me){const X=me;return X?typeof X.base=="string"&&typeof X.pattern=="string":!1}e.$sj=O;function F(me){return me.allBasenames||[]}e.$tj=F;function j(me){return me.allPaths||[]}e.$uj=j;function z(me,X){const Z=H(Object.getOwnPropertyNames(me).map(we=>T(we,me[we],X)).filter(we=>we!==a)),V=Z.length;if(!V)return a;if(!Z.some(we=>!!we.requiresSiblings)){if(V===1)return Z[0];const we=function(K,fe){let te;for(let re=0,ne=Z.length;re<ne;re++){const Ee=Z[re](K,fe);if(typeof Ee=="string")return Ee;(0,M.$tg)(Ee)&&(te||(te=[]),te.push(Ee))}return te?(async()=>{for(const re of te){const ne=await re;if(typeof ne=="string")return ne}return null})():null},G=Z.find(K=>!!K.allBasenames);G&&(we.allBasenames=G.allBasenames);const U=Z.reduce((K,fe)=>fe.allPaths?K.concat(fe.allPaths):K,[]);return U.length&&(we.allPaths=U),we}const x=function(we,G,U){let K,fe;for(let te=0,re=Z.length;te<re;te++){const ne=Z[te];ne.requiresSiblings&&U&&(G||(G=(0,R.$ae)(we)),K||(K=G.substr(0,G.length-(0,R.$be)(we).length)));const Ee=ne(we,G,K,U);if(typeof Ee=="string")return Ee;(0,M.$tg)(Ee)&&(fe||(fe=[]),fe.push(Ee))}return fe?(async()=>{for(const te of fe){const re=await te;if(typeof re=="string")return re}return null})():null},ge=Z.find(we=>!!we.allBasenames);ge&&(x.allBasenames=ge.allBasenames);const ue=Z.reduce((we,G)=>G.allPaths?we.concat(G.allPaths):we,[]);return ue.length&&(x.allPaths=ue),x}function T(me,X,Z){if(X===!1)return a;const V=i(me,Z);if(V===a)return a;if(typeof X=="boolean")return V;if(X){const x=X.when;if(typeof x=="string"){const ge=(ue,we,G,U)=>{if(!U||!V(ue,we))return null;const K=x.replace("$(basename)",()=>G),fe=U(K);return(0,M.$tg)(fe)?fe.then(te=>te?me:null):fe?me:null};return ge.requiresSiblings=!0,ge}}return V}function H(me,X){const Z=me.filter(we=>!!we.basenames);if(Z.length<2)return me;const V=Z.reduce((we,G)=>{const U=G.basenames;return U?we.concat(U):we},[]);let x;if(X){x=[];for(let we=0,G=V.length;we<G;we++)x.push(X)}else x=Z.reduce((we,G)=>{const U=G.patterns;return U?we.concat(U):we},[]);const ge=function(we,G){if(typeof we!="string")return null;if(!G){let K;for(K=we.length;K>0;K--){const fe=we.charCodeAt(K-1);if(fe===47||fe===92)break}G=we.substr(K)}const U=V.indexOf(G);return U!==-1?x[U]:null};ge.basenames=V,ge.patterns=x,ge.allBasenames=V;const ue=me.filter(we=>!we.basenames);return ue.push(ge),ue}function q(me,X){return(0,D.$sb)(me,X,(Z,V)=>typeof Z=="string"&&typeof V=="string"?Z===V:typeof Z!="string"&&typeof V!="string"?Z.base===V.base&&Z.pattern===V.pattern:!1)}e.$vj=q}),define(Se[80],De([1,0,8,161,24,15,2]),function($e,e,D,M,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class k{constructor(s="",n=!1){if(this.value=s,typeof this.value!="string")throw(0,D.$5)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(s,n=0){return this.value+=p(this.supportThemeIcons?(0,M.$Rj)(s):s).replace(/([ \t]+)/g,(h,$)=>"&nbsp;".repeat($.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,n){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(s,n,h){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(s),")"),h&&(this.value+=` "${this.c(this.c(h,'"'),")")}"`),this.value+=")",this}c(s,n){const h=new RegExp((0,L.$qe)(n),"g");return s.replace(h,($,d)=>s.charAt(d-1)!=="\\"?`\\${$}`:$)}}e.$Xj=k;function b(o){return P(o)?!o.value:Array.isArray(o)?o.every(b):!0}e.$Yj=b;function P(o){return o instanceof k?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.$Zj=P;function I(o,s){return o===s?!0:!o||!s?!1:o.value===s.value&&o.isTrusted===s.isTrusted&&o.supportThemeIcons===s.supportThemeIcons&&o.supportHtml===s.supportHtml&&(o.baseUri===s.baseUri||!!o.baseUri&&!!s.baseUri&&(0,g.$bg)(R.URI.from(o.baseUri),R.URI.from(s.baseUri)))}e.$1j=I;function p(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$2j=p;function S(o){return o.replace(/"/g,"&quot;")}e.$3j=S;function C(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$4j=C;function v(o){const s=[],n=o.split("|").map($=>$.trim());o=n[0];const h=n[1];if(h){const $=/height=(\d+)/.exec(h),d=/width=(\d+)/.exec(h),t=$?$[1]:"",r=d?d[1]:"",a=isFinite(parseInt(r)),i=isFinite(parseInt(t));a&&s.push(`width="${r}"`),i&&s.push(`height="${t}"`)}return{href:o,dimensions:s}}e.$5j=v}),define(Se[100],De([1,0,19,32,16,12,24,15]),function($e,e,D,M,g,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nA=e.$mA=e.$lA=e.$kA=e.$jA=e.$iA=e.$hA=e.$gA=e.$fA=e.$eA=void 0;function k(i,c){const{os:f,tildify:y,relative:E}=c;if(E){const w=b(i,E,f);if(typeof w=="string")return w}let u=i.fsPath;if(f===1&&!L.$i?u=u.replace(/\//g,"\\"):f!==1&&L.$i&&(u=u.replace(/\\/g,"/")),f!==1&&y?.userHome){const w=y.userHome.fsPath;let A;i.scheme!==y.userHome.scheme&&i.path.startsWith(g.$6d.sep)?A=y.userHome.with({path:i.path}).fsPath:A=i.fsPath,u=p(A,w,f)}return(f===1?g.$5d:g.$6d).normalize(P(u,f===1))}e.$eA=k;function b(i,c,f){const y=f===1?g.$5d:g.$6d,E=f===3?R.$$f:R.$ag,u=c.getWorkspace(),l=(0,D.$Mb)(u.folders);if(!l)return;i.scheme!==l.uri.scheme&&i.path.startsWith(g.$6d.sep)&&(i=l.uri.with({path:i.path}));const w=c.getWorkspaceFolder(i);if(!w)return;let A;if(E.isEqual(w.uri,i)?A="":A=E.relativePath(w.uri,i)??"",A&&(A=y.normalize(A)),u.folders.length>1&&!c.noPrefix){const N=w.name?w.name:E.basenameOrAuthority(w.uri);A=A?`${N} \u2022 ${A}`:N}return A}function P(i,c=L.$i){return(0,M.$Mf)(i,c)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$fA=P;let I=Object.create(null);function p(i,c,f=L.OS){if(f===1||!i||!c)return i;let y=I.original===c?I.normalized:void 0;y||(y=c,L.$i&&(y=(0,M.$Cf)(y)),y=`${(0,m.$ve)(y,g.$6d.sep)}${g.$6d.sep}`,I={original:c,normalized:y});let E=i;return L.$i&&(E=(0,M.$Cf)(E)),(f===3?E.startsWith(y):(0,m.$Ne)(E,y))?`~/${E.substr(y.length)}`:i}e.$gA=p;function S(i,c){return i.replace(/^~($|\/|\\)/,`${c}$1`)}e.$hA=S;const C="\u2026",v="\\\\",o="~";function s(i,c=g.sep){const f=new Array(i.length);let y=!1;for(let E=0;E<i.length;E++){const u=i[E];if(u===""){f[E]=`.${c}`;continue}if(!u){f[E]=u;continue}y=!0;let l="",w=u;w.indexOf(v)===0?(l=w.substr(0,w.indexOf(v)+v.length),w=w.substr(w.indexOf(v)+v.length)):w.indexOf(c)===0?(l=w.substr(0,w.indexOf(c)+c.length),w=w.substr(w.indexOf(c)+c.length)):w.indexOf(o)===0&&(l=w.substr(0,w.indexOf(o)+o.length),w=w.substr(w.indexOf(o)+o.length));const A=w.split(c);for(let N=1;y&&N<=A.length;N++)for(let O=A.length-N;y&&O>=0;O--){y=!1;let F=A.slice(O,O+N).join(c);for(let j=0;!y&&j<i.length;j++)if(j!==E&&i[j]&&i[j].indexOf(F)>-1){const z=O+N===A.length,T=O>0&&i[j].indexOf(c)>-1?c+F:F,H=i[j].endsWith(T);y=!z||H}if(!y){let j="";(A[0].endsWith(":")||l!=="")&&(O===1&&(O=0,N++,F=A[0]+c+F),O>0&&(j=A[0]+c),j=l+j),O>0&&(j=j+C+c),j=j+F,O+N<A.length&&(j=j+c+C),f[E]=j}}y&&(f[E]=u)}return f}e.$iA=s;var n;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function h(i,c=Object.create(null)){const f=[];let y=!1,E="";for(const u of i)if(u==="$"||y&&u==="{")E&&f.push({value:E,type:n.TEXT}),E="",y=!0;else if(u==="}"&&y){const l=c[E];if(typeof l=="string")l.length&&f.push({value:l,type:n.VARIABLE});else if(l){const w=f[f.length-1];(!w||w.type!==n.SEPARATOR)&&f.push({value:l.label,type:n.SEPARATOR})}E="",y=!1}else E+=u;return E&&!y&&f.push({value:E,type:n.TEXT}),f.filter((u,l)=>{if(u.type===n.SEPARATOR){const w=f[l-1],A=f[l+1];return[w,A].every(N=>N&&(N.type===n.VARIABLE||N.type===n.TEXT)&&N.value.length>0)}return!0}).map(u=>u.value).join("")}e.$jA=h;function $(i,c){return L.$j||c?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$j?"&":"&&"):i.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.$kA=$;function d(i,c){return L.$j||c?i.replace(/\(&&\w\)|&&/g,""):L.$i?i.replace(/&&|&/g,f=>f==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$lA=d;function t(i){return i.replace(/&/g,"&&")}e.$mA=t;function r(i){if(i.endsWith("]")){const c=i.lastIndexOf(" [",i.length-2);if(c!==-1){const f=a(i.substring(0,c));return{name:f.name,parentPath:f.parentPath+i.substring(c)}}}return a(i)}e.$nA=r;function a(i){const c=i.indexOf("/")!==-1?g.$6d:g.$5d,f=c.basename(i),y=c.dirname(i);return f.length?{name:f,parentPath:y}:{name:y,parentPath:""}}}),define(Se[128],De([1,0,22,2]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=void 0;function g(I){return I.toJSON()}class L{constructor(p){this.a=p}transformIncoming(p){const S=this.a.transformIncoming(p);return S===p?p:g(M.URI.from(S))}transformOutgoing(p){const S=this.a.transformOutgoing(p);return S===p?p:g(M.URI.from(S))}transformOutgoingURI(p){const S=this.a.transformOutgoing(p);return S===p?p:M.URI.from(S)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$Bm=L,e.$Cm=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function R(I,p,S){if(!I||S>200)return null;if(typeof I=="object"){if(I instanceof M.URI)return p.transformOutgoing(I);for(const C in I)if(Object.hasOwnProperty.call(I,C)){const v=R(I[C],p,S+1);v!==null&&(I[C]=v)}}return null}function m(I,p){const S=R(I,p,0);return S===null?I:S}e.$Dm=m;function k(I,p,S,C){if(!I||C>200)return null;if(typeof I=="object"){if(I.$mid===1)return S?M.URI.revive(p.transformIncoming(I)):p.transformIncoming(I);if(I instanceof D.$Fd)return null;for(const v in I)if(Object.hasOwnProperty.call(I,v)){const o=k(I[v],p,S,C+1);o!==null&&(I[v]=o)}}return null}function b(I,p){const S=k(I,p,!1,0);return S===null?I:S}e.$Em=b;function P(I,p){const S=k(I,p,!0,0);return S===null?I:S}e.$Fm=P}),define(Se[29],De([1,0,52,64,371,9,32,77,16,12,24,2]),function($e,e,D,M,g,L,R,m,k,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function S(T,H=p.UNLINK,q){if((0,R.$Lf)(T))throw new Error("rimraf - will refuse to recursively delete root");return H===p.UNLINK?v(T):C(T,q)}async function C(T,H=(0,R.$Qf)((0,M.tmpdir)())){try{try{await D.promises.rename(T,H)}catch(q){return q.code==="ENOENT"?void 0:v(T)}v(H).catch(q=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function v(T){return(0,g.promisify)(D.rm)(T,{recursive:!0,force:!0,maxRetries:3})}function o(T){if((0,R.$Lf)(T))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(T,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=o;async function s(T,H){return $(await(H?n(T):(0,g.promisify)(D.readdir)(T)))}async function n(T){try{return await(0,g.promisify)(D.readdir)(T,{withFileTypes:!0})}catch(me){console.warn("[node.js fs] readdir with filetypes failed with error: ",me)}const H=[],q=await s(T);for(const me of q){let X=!1,Z=!1,V=!1;try{const x=await e.Promises.lstat((0,k.$9d)(T,me));X=x.isFile(),Z=x.isDirectory(),V=x.isSymbolicLink()}catch(x){console.warn("[node.js fs] unexpected error from lstat after readdir: ",x)}H.push({name:me,isFile:()=>X,isDirectory:()=>Z,isSymbolicLink:()=>V})}return H}function h(T){return $(D.readdirSync(T))}e.readdirSync=h;function $(T){return T.map(H=>typeof H=="string"?b.$j?(0,m.$hl)(H):H:(H.name=b.$j?(0,m.$hl)(H.name):H.name,H))}async function d(T){const H=await s(T),q=[];for(const me of H)await r.existsDirectory((0,k.$9d)(T,me))&&q.push(me);return q}function t(T,H=1e3){return new Promise(q=>{let me=!1;const X=setInterval(()=>{me||(me=!0,D.access(T,Z=>{me=!1,Z&&(clearInterval(X),q(void 0))}))},H)})}e.whenDeleted=t;var r;(function(T){async function H(X){let Z;try{if(Z=await e.Promises.lstat(X),!Z.isSymbolicLink())return{stat:Z}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:Z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&Z)return{stat:Z,symbolicLink:{dangling:!0}};if(b.$i&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(x){if(x.code==="ENOENT"&&Z)return{stat:Z,symbolicLink:{dangling:!0}};throw x}throw V}}T.stat=H;async function q(X){try{const{stat:Z,symbolicLink:V}=await T.stat(X);return Z.isFile()&&V?.dangling!==!0}catch{}return!1}T.existsFile=q;async function me(X){try{const{stat:Z,symbolicLink:V}=await T.stat(X);return Z.isDirectory()&&V?.dangling!==!0}catch{}return!1}T.existsDirectory=me})(r||(e.SymlinkSupport=r={}));const a=new L.$Pg;function i(T,H,q){return a.queueFor(I.URI.file(T),P.$_f).queue(()=>{const me=u(q);return new Promise((X,Z)=>y(T,H,me,V=>V?Z(V):X()))})}let c=!0;function f(T){c=T}e.configureFlushOnWrite=f;function y(T,H,q,me){if(!c)return D.writeFile(T,H,{mode:q.mode,flag:q.flag},me);D.open(T,q.flag,q.mode,(X,Z)=>{if(X)return me(X);D.writeFile(Z,H,V=>{if(V)return D.close(Z,()=>me(V));D.fdatasync(Z,x=>(x&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",x),f(!1)),D.close(Z,ge=>me(ge))))})})}function E(T,H,q){const me=u(q);if(!c)return D.writeFileSync(T,H,{mode:me.mode,flag:me.flag});const X=D.openSync(T,me.flag,me.mode);try{D.writeFileSync(X,H);try{D.fdatasyncSync(X)}catch(Z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Z),f(!1)}}finally{D.closeSync(X)}}e.writeFileSync=E;function u(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function l(T,H,q=6e4){if(T!==H)try{b.$i&&typeof q=="number"?await w(T,H,Date.now(),q):await(0,g.promisify)(D.rename)(T,H)}catch(me){if(T.toLowerCase()!==H.toLowerCase()&&me.code==="EXDEV"||T.endsWith("."))await A(T,H,{preserveSymlinks:!1}),await S(T,p.MOVE);else throw me}}async function w(T,H,q,me,X=0){try{return await(0,g.promisify)(D.rename)(T,H)}catch(Z){if(Z.code!=="EACCES"&&Z.code!=="EPERM"&&Z.code!=="EBUSY")throw Z;if(Date.now()-q>=me)throw console.error(`[node.js fs] rename failed after ${X} retries with error: ${Z}`),Z;if(X===0){let V=!1;try{const{stat:x}=await r.stat(H);x.isFile()||(V=!0)}catch{}if(V)throw Z}return await(0,L.$Hg)(Math.min(100,X*10)),w(T,H,q,me,X+1)}}async function A(T,H,q){return O(T,H,{root:{source:T,target:H},options:q,handledSourcePaths:new Set})}const N=511;async function O(T,H,q){if(q.handledSourcePaths.has(T))return;q.handledSourcePaths.add(T);const{stat:me,symbolicLink:X}=await r.stat(T);if(X){if(q.options.preserveSymlinks)try{return await z(T,H,q)}catch(Z){console.warn("[node.js fs] copy of symlink failed: ",Z)}if(X.dangling)return}return me.isDirectory()?F(T,H,me.mode&N,q):j(T,H,me.mode&N)}async function F(T,H,q,me){await e.Promises.mkdir(H,{recursive:!0,mode:q});const X=await s(T);for(const Z of X)await O((0,k.$9d)(T,Z),(0,k.$9d)(H,Z),me)}async function j(T,H,q){await e.Promises.copyFile(T,H),await e.Promises.chmod(H,q)}async function z(T,H,q){let me=await e.Promises.readlink(T);(0,R.$If)(me,q.root.source,!b.$k)&&(me=(0,k.$9d)(q.root.target,me.substr(q.root.source.length+1))),await e.Promises.symlink(me,H)}e.Promises=new class{get access(){return(0,g.promisify)(D.access)}get stat(){return(0,g.promisify)(D.stat)}get lstat(){return(0,g.promisify)(D.lstat)}get utimes(){return(0,g.promisify)(D.utimes)}get read(){return(T,H,q,me,X)=>new Promise((Z,V)=>{D.read(T,H,q,me,X,(x,ge,ue)=>x?V(x):Z({bytesRead:ge,buffer:ue}))})}get readFile(){return(0,g.promisify)(D.readFile)}get write(){return(T,H,q,me,X)=>new Promise((Z,V)=>{D.write(T,H,q,me,X,(x,ge,ue)=>x?V(x):Z({bytesWritten:ge,buffer:ue}))})}get appendFile(){return(0,g.promisify)(D.appendFile)}get fdatasync(){return(0,g.promisify)(D.fdatasync)}get truncate(){return(0,g.promisify)(D.truncate)}get copyFile(){return(0,g.promisify)(D.copyFile)}get open(){return(0,g.promisify)(D.open)}get close(){return(0,g.promisify)(D.close)}get symlink(){return(0,g.promisify)(D.symlink)}get readlink(){return(0,g.promisify)(D.readlink)}get chmod(){return(0,g.promisify)(D.chmod)}get mkdir(){return(0,g.promisify)(D.mkdir)}get unlink(){return(0,g.promisify)(D.unlink)}get rmdir(){return(0,g.promisify)(D.rmdir)}get realpath(){return(0,g.promisify)(D.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return s}get readDirsInDir(){return d}get writeFile(){return i}get rm(){return S}get rename(){return l}get copy(){return A}}}),define(Se[101],De([1,0,52,16,12,15,29]),function($e,e,D,M,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=e.$Vp=e.$Up=void 0;function m(p){if(g.$k)return p;const S=(0,M.$_d)(p);if(p===S)return p;const C=((0,M.$ae)(p)||p).toLowerCase();try{const o=(0,R.readdirSync)(S).filter(s=>s.toLowerCase()===C);if(o.length===1){const s=m(S);if(s)return(0,M.$9d)(s,o[0])}else if(o.length>1){const s=o.indexOf(C);if(s>=0){const n=m(S);if(n)return(0,M.$9d)(n,o[s])}}}catch{}return null}e.$Up=m;async function k(p){if(g.$k)return p;const S=(0,M.$_d)(p);if(p===S)return p;const C=((0,M.$ae)(p)||p).toLowerCase();try{const o=(await R.Promises.readdir(S)).filter(s=>s.toLowerCase()===C);if(o.length===1){const s=await k(S);if(s)return(0,M.$9d)(s,o[0])}else if(o.length>1){const s=o.indexOf(C);if(s>=0){const n=await k(S);if(n)return(0,M.$9d)(n,o[s])}}}catch{}return null}e.$Vp=k;async function b(p){try{return await R.Promises.realpath(p)}catch{const C=I(p);return await R.Promises.access(C,D.constants.R_OK),C}}e.$Wp=b;function P(p){try{return D.realpathSync(p)}catch{const C=I(p);return D.accessSync(C,D.constants.R_OK),C}}e.$Xp=P;function I(p){return(0,L.$ve)((0,M.$7d)(p),M.sep)}}),define(Se[102],De([1,0,16,12,47,99,18,29]),function($e,e,D,M,g,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$vl=e.$ul=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function k(I=g.env){return I.comspec||"cmd.exe"}e.$ul=k;function b(I){let p=[],S=!1;const C=function(v){if(S){p.push(v);return}(!I.send(v,s=>{if(s&&console.error(s),S=!1,p.length>0){const n=p.slice(0);p=[],n.forEach(h=>C(h))}})||M.$i)&&(S=!0)};return{send:C}}e.$vl=b;var P;(function(I){async function p(S,C,v){if(D.$8d(S))return S;if(C===void 0&&(C=g.cwd()),D.$_d(S)!=="."||(v===void 0&&R.$jf(g.env.PATH)&&(v=g.env.PATH.split(D.$ge)),v===void 0||v.length===0))return D.$9d(C,S);async function s(n){if(await m.Promises.exists(n)){let h;try{h=await m.Promises.stat(n)}catch($){$.message.startsWith("EACCES")&&(h=await m.Promises.lstat(n))}return h?!h.isDirectory():!1}return!1}for(const n of v){let h;if(D.$8d(n)?h=D.$9d(n,S):h=D.$9d(C,n,S),await s(h))return h;let $=h+".com";if(await s($)||($=h+".exe",await s($)))return $}return D.$9d(C,S)}I.findExecutable=p})(P||(e.win32=P={}))});var Ke=this&&this.__decorate||function($e,e,D,M){var g=arguments.length,L=g<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,D):M,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate($e,e,D,M);else for(var m=$e.length-1;m>=0;m--)(R=$e[m])&&(L=(g<3?R(L):g>3?R(e,D,L):R(e,D))||L);return g>3&&L&&Object.defineProperty(e,D,L),L};define(Se[81],De([1,0,19,9,22,21,57,8,4,3,63,15,18]),function($e,e,D,M,g,L,R,m,k,b,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.ProxyChannel=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.RequestInitiator=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=void 0;var S;(function(X){X[X.Promise=100]="Promise",X[X.PromiseCancel=101]="PromiseCancel",X[X.EventListen=102]="EventListen",X[X.EventDispose=103]="EventDispose"})(S||(S={}));function C(X){switch(X){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(X){X[X.Initialize=200]="Initialize",X[X.PromiseSuccess=201]="PromiseSuccess",X[X.PromiseError=202]="PromiseError",X[X.PromiseErrorObj=203]="PromiseErrorObj",X[X.EventFire=204]="EventFire"})(v||(v={}));function o(X){switch(X){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(X){X[X.Uninitialized=0]="Uninitialized",X[X.Idle=1]="Idle"})(s||(s={}));function n(X){let Z=0;for(let V=0;;V+=7){const x=X.read(1);if(Z|=(x.buffer[0]&127)<<V,!(x.buffer[0]&128))return Z}}const h=a(0);function $(X,Z){if(Z===0){X.write(h);return}let V=0;for(let ge=Z;ge!==0;ge=ge>>>7)V++;const x=g.$Fd.alloc(V);for(let ge=0;Z!==0;ge++)x.buffer[ge]=Z&127,Z=Z>>>7,Z>0&&(x.buffer[ge]|=128);X.write(x)}class d{constructor(Z){this.b=Z,this.a=0}read(Z){const V=this.b.slice(this.a,this.a+Z);return this.a+=V.byteLength,V}}e.$_g=d;class t{constructor(){this.a=[]}get buffer(){return g.$Fd.concat(this.a)}write(Z){this.a.push(Z)}}e.$ah=t;var r;(function(X){X[X.Undefined=0]="Undefined",X[X.String=1]="String",X[X.Buffer=2]="Buffer",X[X.VSBuffer=3]="VSBuffer",X[X.Array=4]="Array",X[X.Object=5]="Object",X[X.Int=6]="Int"})(r||(r={}));function a(X){const Z=g.$Fd.alloc(1);return Z.writeUInt8(X,0),Z}const i={Undefined:a(r.Undefined),String:a(r.String),Buffer:a(r.Buffer),VSBuffer:a(r.VSBuffer),Array:a(r.Array),Object:a(r.Object),Uint:a(r.Int)},c=typeof Buffer<"u";function f(X,Z){if(typeof Z>"u")X.write(i.Undefined);else if(typeof Z=="string"){const V=g.$Fd.fromString(Z);X.write(i.String),$(X,V.byteLength),X.write(V)}else if(c&&Buffer.isBuffer(Z)){const V=g.$Fd.wrap(Z);X.write(i.Buffer),$(X,V.byteLength),X.write(V)}else if(Z instanceof g.$Fd)X.write(i.VSBuffer),$(X,Z.byteLength),X.write(Z);else if(Array.isArray(Z)){X.write(i.Array),$(X,Z.length);for(const V of Z)f(X,V)}else if(typeof Z=="number"&&(Z|0)===Z)X.write(i.Uint),$(X,Z);else{const V=g.$Fd.fromString(JSON.stringify(Z));X.write(i.Object),$(X,V.byteLength),X.write(V)}}e.$bh=f;function y(X){switch(X.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return X.read(n(X)).toString();case r.Buffer:return X.read(n(X)).buffer;case r.VSBuffer:return X.read(n(X));case r.Array:{const V=n(X),x=[];for(let ge=0;ge<V;ge++)x.push(y(X));return x}case r.Object:return JSON.parse(X.read(n(X)).toString());case r.Int:return n(X)}}e.$ch=y;class E{constructor(Z,V,x=null,ge=1e3){this.h=Z,this.j=V,this.k=x,this.l=ge,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ue=>this.q(ue)),this.m({type:200})}registerChannel(Z,V){this.b.set(Z,V),setTimeout(()=>this.w(Z),0)}m(Z){switch(Z.type){case 200:{const V=this.o([Z.type]);this.k?.logOutgoing(V,0,1,o(Z.type));return}case 201:case 202:case 204:case 203:{const V=this.o([Z.type,Z.id],Z.data);this.k?.logOutgoing(V,Z.id,1,o(Z.type),Z.data);return}}}o(Z,V=void 0){const x=new t;return f(x,Z),f(x,V),this.p(x.buffer)}p(Z){try{return this.h.send(Z),Z.byteLength}catch{return 0}}q(Z){const V=new d(Z),x=y(V),ge=y(V),ue=x[0];switch(ue){case 100:return this.k?.logIncoming(Z.byteLength,x[1],1,`${C(ue)}: ${x[2]}.${x[3]}`,ge),this.s({type:ue,id:x[1],channelName:x[2],name:x[3],arg:ge});case 102:return this.k?.logIncoming(Z.byteLength,x[1],1,`${C(ue)}: ${x[2]}.${x[3]}`,ge),this.t({type:ue,id:x[1],channelName:x[2],name:x[3],arg:ge});case 101:return this.k?.logIncoming(Z.byteLength,x[1],1,`${C(ue)}`),this.u({type:ue,id:x[1]});case 103:return this.k?.logIncoming(Z.byteLength,x[1],1,`${C(ue)}`),this.u({type:ue,id:x[1]})}}s(Z){const V=this.b.get(Z.channelName);if(!V){this.v(Z);return}const x=new L.$pd;let ge;try{ge=V.call(this.j,Z.name,Z.arg,x.token)}catch(G){ge=Promise.reject(G)}const ue=Z.id;ge.then(G=>{this.m({id:ue,data:G,type:201})},G=>{G instanceof Error?this.m({id:ue,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.m({id:ue,data:G,type:203})}).finally(()=>{we.dispose(),this.d.delete(Z.id)});const we=(0,b.$ic)(()=>x.cancel());this.d.set(Z.id,we)}t(Z){const V=this.b.get(Z.channelName);if(!V){this.v(Z);return}const x=Z.id,ue=V.listen(this.j,Z.name,Z.arg)(we=>this.m({id:x,data:we,type:204}));this.d.set(Z.id,ue)}u(Z){const V=this.d.get(Z.id);V&&(V.dispose(),this.d.delete(Z.id))}v(Z){let V=this.g.get(Z.channelName);V||(V=[],this.g.set(Z.channelName,V));const x=setTimeout(()=>{console.error(`Unknown channel: ${Z.channelName}`),Z.type===100&&this.m({id:Z.id,data:{name:"Unknown channel",message:`Channel name '${Z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:Z,timeoutTimer:x})}w(Z){const V=this.g.get(Z);if(V){for(const x of V)switch(clearTimeout(x.timeoutTimer),x.request.type){case 100:this.s(x.request);break;case 102:this.t(x.request);break}this.g.delete(Z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.$fc)(this.d.values()),this.d.clear()}}e.$dh=E;var u;(function(X){X[X.LocalSide=0]="LocalSide",X[X.OtherSide=1]="OtherSide"})(u||(e.RequestInitiator=u={}));class l{constructor(Z,V=null){this.l=Z,this.a=!1,this.b=s.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new k.$fd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(x=>this.s(x)),this.j=V}getChannel(Z){const V=this;return{call(x,ge,ue){return V.a?Promise.reject(new m.$3):V.m(Z,x,ge,ue)},listen(x,ge){return V.a?k.Event.None:V.o(Z,x,ge)}}}m(Z,V,x,ge=L.CancellationToken.None){const ue=this.g++,G={id:ue,type:100,channelName:Z,name:V,arg:x};if(ge.isCancellationRequested)return Promise.reject(new m.$3);let U;return new Promise((fe,te)=>{if(ge.isCancellationRequested)return te(new m.$3);const re=()=>{const he=ee=>{switch(ee.type){case 201:this.f.delete(ue),fe(ee.data);break;case 202:{this.f.delete(ue);const le=new Error(ee.data.message);le.stack=Array.isArray(ee.data.stack)?ee.data.stack.join(`
`):ee.data.stack,le.name=ee.data.name,te(le);break}case 203:this.f.delete(ue),te(ee.data);break}};this.f.set(ue,he),this.p(G)};let ne=null;this.b===s.Idle?re():(ne=(0,M.$ug)(he=>this.u()),ne.then(()=>{ne=null,re()}));const Ee=()=>{ne?(ne.cancel(),ne=null):this.p({id:ue,type:101}),te(new m.$3)},oe=ge.onCancellationRequested(Ee);U=(0,b.$hc)((0,b.$ic)(Ee),oe),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(Z,V,x){const ge=this.g++,we={id:ge,type:102,channelName:Z,name:V,arg:x};let G=null;const U=new k.$fd({onWillAddFirstListener:()=>{G=(0,M.$ug)(fe=>this.u()),G.then(()=>{G=null,this.d.add(U),this.p(we)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.d.delete(U),this.p({id:ge,type:103}))}}),K=fe=>U.fire(fe.data);return this.f.set(ge,K),U.event}p(Z){switch(Z.type){case 100:case 102:{const V=this.q([Z.type,Z.id,Z.channelName,Z.name],Z.arg);this.j?.logOutgoing(V,Z.id,0,`${C(Z.type)}: ${Z.channelName}.${Z.name}`,Z.arg);return}case 101:case 103:{const V=this.q([Z.type,Z.id]);this.j?.logOutgoing(V,Z.id,0,C(Z.type));return}}}q(Z,V=void 0){const x=new t;return f(x,Z),f(x,V),this.r(x.buffer)}r(Z){try{return this.l.send(Z),Z.byteLength}catch{return 0}}s(Z){const V=new d(Z),x=y(V),ge=y(V),ue=x[0];switch(ue){case 200:return this.j?.logIncoming(Z.byteLength,0,0,o(ue)),this.t({type:x[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Z.byteLength,x[1],0,o(ue),ge),this.t({type:x[0],id:x[1],data:ge})}}t(Z){if(Z.type===200){this.b=s.Idle,this.k.fire();return}this.f.get(Z.id)?.(Z)}get onDidInitializePromise(){return k.Event.toPromise(this.onDidInitialize)}u(){return this.b===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.$fc)(this.d.values()),this.d.clear()}}e.$eh=l,Ke([R.$6g],l.prototype,"onDidInitializePromise",null);class w{get connections(){const Z=[];return this.f.forEach(V=>Z.push(V)),Z}constructor(Z){this.a=new Map,this.f=new Set,this.g=new k.$fd,this.onDidAddConnection=this.g.event,this.h=new k.$fd,this.onDidRemoveConnection=this.h.event,this.j=new b.$jc,this.j.add(Z(({protocol:V,onDidClientDisconnect:x})=>{const ge=k.Event.once(V.onMessage);this.j.add(ge(ue=>{const we=new d(ue),G=y(we),U=new E(V,G),K=new l(V);this.a.forEach((te,re)=>U.registerChannel(re,te));const fe={channelServer:U,channelClient:K,ctx:G};this.f.add(fe),this.g.fire(fe),this.j.add(x(()=>{U.dispose(),K.dispose(),this.f.delete(fe),this.h.fire(fe)}))}))}))}getChannel(Z,V){const x=this;return{call(ge,ue,we){let G;if((0,p.$xf)(V)){const K=(0,D.$2b)(x.connections.filter(V));G=K?Promise.resolve(K):k.Event.toPromise(k.Event.filter(x.onDidAddConnection,V))}else G=V.routeCall(x,ge,ue);const U=G.then(K=>K.channelClient.getChannel(Z));return N(U).call(ge,ue,we)},listen(ge,ue){if((0,p.$xf)(V))return x.k(Z,V,ge,ue);const we=V.routeEvent(x,ge,ue).then(G=>G.channelClient.getChannel(Z));return N(we).listen(ge,ue)}}}k(Z,V,x,ge){const ue=this;let we;const G=new k.$fd({onWillAddFirstListener:()=>{we=new b.$jc;const U=new k.$ld,K=new Map,fe=re=>{const Ee=re.channelClient.getChannel(Z).listen(x,ge),oe=U.add(Ee);K.set(re,oe)},te=re=>{const ne=K.get(re);ne&&(ne.dispose(),K.delete(re))};ue.connections.filter(V).forEach(fe),k.Event.filter(ue.onDidAddConnection,V)(fe,void 0,we),ue.onDidRemoveConnection(te,void 0,we),U.event(G.fire,G,we),we.add(U)},onDidRemoveLastListener:()=>{we?.dispose(),we=void 0}});return G.event}registerChannel(Z,V){this.a.set(Z,V);for(const x of this.f)x.channelServer.registerChannel(Z,V)}dispose(){this.j.dispose();for(const Z of this.f)Z.channelClient.dispose(),Z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$fh=w;class A{constructor(Z,V,x=null){const ge=new t;f(ge,V),Z.send(ge.buffer),this.a=new l(Z,x),this.d=new E(Z,V,x)}getChannel(Z){return this.a.getChannel(Z)}registerChannel(Z,V){this.d.registerChannel(Z,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.$gh=A;function N(X){return{call(Z,V,x){return X.then(ge=>ge.call(Z,V,x))},listen(Z,V){const x=new k.$od;return X.then(ge=>x.input=ge.listen(Z,V)),x.event}}}e.$hh=N;function O(X){let Z=!1;return{call(V,x,ge){return Z?X.call(V,x,ge):(0,M.$Hg)(0).then(()=>Z=!0).then(()=>X.call(V,x,ge))},listen(V,x){if(Z)return X.listen(V,x);const ge=new k.$od;return(0,M.$Hg)(0).then(()=>Z=!0).then(()=>ge.input=X.listen(V,x)),ge.event}}}e.$ih=O;class F{constructor(Z){this.a=Z}routeCall(Z){return this.b(Z)}routeEvent(Z){return this.b(Z)}async b(Z){for(const V of Z.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await k.Event.toPromise(Z.onDidAddConnection),await this.b(Z)}}e.$jh=F;var j;(function(X){function Z(ue,we,G){const U=ue,K=G&&G.disableMarshalling,fe=new Map;for(const te in U)x(te)&&fe.set(te,k.Event.buffer(U[te],!0,void 0,we));return new class{listen(te,re,ne){const Ee=fe.get(re);if(Ee)return Ee;if(ge(re)){const oe=U[re];if(typeof oe=="function")return oe.call(U,ne)}throw new m.$_(`Event not found: ${re}`)}call(te,re,ne){const Ee=U[re];if(typeof Ee=="function"){if(!K&&Array.isArray(ne))for(let oe=0;oe<ne.length;oe++)ne[oe]=(0,P.$$g)(ne[oe]);return Ee.apply(U,ne)}throw new m.$_(`Method not found: ${re}`)}}}X.fromService=Z;function V(ue,we){const G=we&&we.disableMarshalling;return new Proxy({},{get(U,K){if(typeof K=="string")return we?.properties?.has(K)?we.properties.get(K):ge(K)?function(fe){return ue.listen(K,fe)}:x(K)?ue.listen(K):async function(...fe){let te;we&&!(0,p.$sf)(we.context)?te=[we.context,...fe]:te=fe;const re=await ue.call(K,te);return G?re:(0,P.$$g)(re)};throw new m.$_(`Property not found: ${String(K)}`)}})}X.toService=V;function x(ue){return ue[0]==="o"&&ue[1]==="n"&&I.$Le(ue.charCodeAt(2))}function ge(ue){return/^onDynamic/.test(ue)&&I.$Le(ue.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(X){if(Array.isArray(X))return X;if(X&&typeof X=="object"&&typeof X.toString=="function"){const Z=X.toString();if(Z!=="[object Object]")return Z}return X}function H(X){return Array.isArray(X)?X.map(T):T(X)}function q(X,Z,V,x,ge,ue,we){we=H(we);const G=z[ge],U=G[x%G.length];let K=[`%c[${X}]%c[${String(Z).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${ue}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ue)?(K=K.concat(we),K.push(")")):K.push(we),console.log.apply(console,K)}class me{constructor(Z,V){this.d=Z,this.f=V,this.a=0,this.b=0}logOutgoing(Z,V,x,ge,ue){this.b+=Z,q(this.d,this.b,Z,V,x,ge,ue)}logIncoming(Z,V,x,ge,ue){this.a+=Z,q(this.f,this.a,Z,V,x,ge,ue)}}e.$kh=me}),define(Se[82],De([1,0,22,4,3,81]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ph=e.$oh=e.$nh=e.$mh=e.ProtocolConstants=e.$lh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var m;(function(i){i.enableDiagnostics=!1,i.records=[];const c=new WeakMap;let f=0;function y(u,l){if(!c.has(u)){const w=String(++f);c.set(u,w)}return c.get(u)}function E(u,l,w,A){if(!i.enableDiagnostics)return;const N=y(u,l);if(A instanceof D.$Fd||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const O=D.$Fd.alloc(A.byteLength);O.set(A),i.records.push({timestamp:Date.now(),id:N,label:l,type:w,buff:O})}else i.records.push({timestamp:Date.now(),id:N,label:l,type:w,data:A})}i.traceSocketEvent=E})(m||(e.SocketDiagnostics=m={}));var k;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k||(e.SocketCloseEventType=k={}));let b=null;function P(){return b||(b=D.$Fd.alloc(0)),b}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,f){if(c===0)return P();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const l=this.a[0];return f&&(this.a.shift(),this.b-=c),l}if(this.a[0].byteLength>c){const l=this.a[0].slice(0,c);return f&&(this.a[0]=this.a[0].slice(c),this.b-=c),l}const y=D.$Fd.alloc(c);let E=0,u=0;for(;c>0;){const l=this.a[u];if(l.byteLength>c){const w=l.slice(0,c);y.set(w,E),E+=c,f&&(this.a[u]=l.slice(c),this.b-=c),c-=c}else y.set(l,E),E+=l.byteLength,f?(this.a.shift(),this.b-=l.byteLength):u++,c-=l.byteLength}return y}}e.$lh=I;var p;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(p||(p={}));function S(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var C;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(C||(e.ProtocolConstants=C={}));class v{constructor(c,f,y,E){this.type=c,this.id=f,this.ack=y,this.data=E,this.writtenTime=0}get size(){return this.data.byteLength}}class o extends g.$kc{constructor(c){super(),this.f=this.B(new M.$fd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=c,this.b=!1,this.c=new I,this.B(this.a.onData(f=>this.acceptChunk(f))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const f=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=f.readUInt32BE(9),this.g.messageType=f.readUInt8(0),this.g.id=f.readUInt32BE(1),this.g.ack=f.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:S(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const y=this.g.messageType,E=this.g.id,u=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",f),this.f.fire(new v(y,E,u,f)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class s{constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const f=D.$Fd.alloc(13);f.writeUInt8(c.type,0),f.writeUInt32BE(c.id,1),f.writeUInt32BE(c.ack,5),f.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:S(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",c.data),this.j(f,c.data)}g(c,f){const y=this.f===0;return this.d.push(c,f),this.f+=c.byteLength+f.byteLength,y}h(){const c=D.$Fd.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,f){this.g(c,f)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this.c.write(c)}}class n extends g.$kc{constructor(c){super(),this.f=new M.$fd,this.onMessage=this.f.event,this.g=new M.$fd,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new s(this.a)),this.c=this.B(new o(this.a)),this.B(this.c.onMessage(f=>{f.type===1&&this.f.fire(f.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new v(1,0,0,c))}}e.$mh=n;class h extends L.$gh{static fromSocket(c,f){return new h(new n(c),f)}get onDidDispose(){return this.b.onDidDispose}constructor(c,f,y=null){super(c,f,y),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$nh=h;class ${constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new M.$fd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$oh=$;class d{constructor(c){this.data=c,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let c=0,f=this.a;for(;f;)f=f.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let f=0,y=this.a;for(;y;)c[f++]=y.data,y=y.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const f=new d(c);if(!this.a){this.a=f,this.b=f;return}this.b.next=f,this.b=f}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const c=Date.now();for(let f=0;f<r.a;f++)this.c[f]=c-1e3*f;setInterval(()=>{for(let f=r.a;f>=1;f--)this.c[f]=this.c[f-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),f=(1+r.a)*1e3;let y=0;for(let E=0;E<r.a;E++)c-this.c[E]<=f&&y++;return 1-y/r.a}hasHighLoad(){return this.d()>=.5}}class a{get unacknowledgedCount(){return this.c-this.d}constructor(c){this.u=new $,this.onControlMessage=this.u.event,this.v=new $,this.onMessage=this.v.event,this.w=new $,this.onDidDispose=this.w.event,this.x=new $,this.onSocketClose=this.x.event,this.y=new $,this.onSocketTimeout=this.y.event,this.s=c.loadEstimator??r.getInstance(),this.t=c.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new g.$jc,this.o=c.socket,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new o(this.o)),this.r.add(this.q.onMessage(f=>this.z(f))),this.r.add(this.o.onClose(f=>this.x.fire(f))),c.initialChunk&&this.q.acceptChunk(c.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const c=new v(5,0,0,P());this.p.write(c),this.p.flush()}sendPause(){const c=new v(7,0,0,P());this.p.write(c)}sendResume(){const c=new v(8,0,0,P());this.p.write(c)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(c,f){this.a=!0,this.r.dispose(),this.r=new g.$jc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=c,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new o(this.o)),this.r.add(this.q.onMessage(y=>this.z(y))),this.r.add(this.o.onClose(y=>this.x.fire(y))),this.q.acceptChunk(f)}endAcceptReconnection(){this.a=!1,this.h=this.g;const c=new v(3,0,this.h,P());this.p.write(c);const f=this.b.toArray();for(let y=0,E=f.length;y<E;y++)this.p.write(f[y]);this.B()}acceptDisconnect(){this.w.fire()}z(c){if(c.ack>this.d){this.d=c.ack;do{const f=this.b.peek();if(f&&f.id<=c.ack)this.b.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this.g)if(c.id!==this.g+1){const f=Date.now();f-this.m>1e4&&(this.m=f,this.p.write(new v(6,0,0,P())))}else this.g=c.id,this.j=Date.now(),this.A(),this.v.fire(c.data);break}case 2:{this.u.fire(c.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const f=this.b.toArray();for(let y=0,E=f.length;y<E;y++)this.p.write(f[y]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(c){const f=++this.c;this.h=this.g;const y=new v(1,f,this.h,c);this.b.push(y),this.a||(this.p.write(y),this.B())}sendControl(c){const f=new v(2,0,0,c);this.p.write(f)}A(){if(this.g<=this.h||this.k)return;const c=Date.now()-this.j;if(c>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-c+5)}B(){if(this.c<=this.d||this.f||this.a)return;const c=this.b.peek(),f=Date.now()-c.writtenTime,y=Date.now()-this.q.lastReadTime,E=Date.now()-this.n;if(f>=2e4&&y>=2e4&&E>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:f,timeSinceLastReceivedSomeData:y});return}const u=Math.max(2e4-f,2e4-y,2e4-E,500);this.f=setTimeout(()=>{this.f=null,this.B()},u)}C(){if(this.g<=this.h)return;this.h=this.g;const c=new v(3,0,this.h,P());this.p.write(c)}D(){this.h=this.g;const c=new v(9,0,this.h,P());this.p.write(c)}}e.$ph=a}),define(Se[183],De([1,0,48,9,22,21,181,8,4,3,23,102,99,81]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=void 0;class C extends S.$dh{constructor(s){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:k.Event.fromNodeEventEmitter(process,"message",n=>g.$Fd.wrap(Buffer.from(n,"base64")))},s),process.once("disconnect",()=>this.dispose())}}e.$Rp=C;class v{constructor(s,n){this.i=s,this.j=n,this.c=new Set,this.g=new Map,this.h=new k.$fd,this.onDidProcessExit=this.h.event;const h=n&&n.timeout?n.timeout:6e4;this.b=new M.$Dg(h),this.d=null,this.f=null}getChannel(s){const n=this;return{call(h,$,d){return n.k(s,h,$,d)},listen(h,$){return n.l(s,h,$)}}}k(s,n,h,$=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if($.isCancellationRequested)return Promise.reject(m.$4());this.b.cancel();const d=this.n(s),t=(0,M.$ug)(i=>d.call(n,h,i)),r=$.onCancellationRequested(()=>t.cancel()),a=(0,b.$ic)(()=>t.cancel());return this.c.add(a),t.finally(()=>{r.dispose(),this.c.delete(a),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(s,n,h){if(!this.b)return k.Event.None;this.b.cancel();let $;const d=new k.$fd({onWillAddFirstListener:()=>{$=this.n(s).listen(n,h)(d.fire,d),this.c.add($)},onDidRemoveLastListener:()=>{this.c.delete($),$.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return d.event}get m(){if(!this.f){const s=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,P.$Vm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c)).filter(c=>!c.startsWith("--vscode-"))),(0,p.$tl)(n.env),this.d=(0,D.fork)(this.i,s,n);const h=new k.$fd;k.Event.fromNodeEventEmitter(this.d,"message",c=>c)(c=>{if((0,R.$Np)(c)){(0,R.log)(c,`IPC Library: ${this.j.serverName}`);return}h.fire(g.$Fd.wrap(Buffer.from(c,"base64")))});const d=this.j.useQueue?(0,I.$vl)(this.d):this.d,t=c=>this.d&&this.d.connected&&d.send(c.buffer.toString("base64")),r=h.event,a={send:t,onMessage:r};this.f=new S.$eh(a);const i=()=>this.o();process.once("exit",i),this.d.on("error",c=>console.warn('IPC "'+this.j.serverName+'" errored with '+c)),this.d.on("exit",(c,f)=>{process.removeListener("exit",i),this.c.forEach(y=>(0,b.$fc)(y)),this.c.clear(),c!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+c+" and signal "+f),this.b?.cancel(),this.o(),this.h.fire({code:c,signal:f})})}return this.f}n(s){let n=this.g.get(s);return n||(n=this.m.getChannel(s),this.g.set(s,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Sp=v}),define(Se[184],De([1,0,9,4,3,63,18]),function($e,e,D,M,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.StorageState=e.$Qo=e.StorageHint=void 0;var m;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(m||(e.StorageHint=m={}));function k(p){const S=p;return S?.changed instanceof Map||S?.deleted instanceof Set}e.$Qo=k;var b;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(b||(e.StorageState=b={}));class P extends g.$kc{static{this.a=100}constructor(S,C=Object.create(null)){super(),this.r=S,this.s=C,this.b=this.B(new M.$id),this.onDidChangeStorage=this.b.event,this.c=b.None,this.f=new Map,this.g=this.B(new D.$Eg(P.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(S=>this.u(S)))}u(S){this.b.pause();try{S.changed?.forEach((C,v)=>this.w(v,C)),S.deleted?.forEach(C=>this.w(C,void 0))}finally{this.b.resume()}}w(S,C){if(this.c===b.Closed)return;let v=!1;(0,R.$sf)(C)?v=this.f.delete(S):this.f.get(S)!==C&&(this.f.set(S,C),v=!0),v&&this.b.fire({key:S,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===b.None&&(this.c=b.Initialized,this.s.hint!==m.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(S,C){const v=this.f.get(S);return(0,R.$sf)(v)?C:v}getBoolean(S,C){const v=this.get(S);return(0,R.$sf)(v)?C:v==="true"}getNumber(S,C){const v=this.get(S);return(0,R.$sf)(v)?C:parseInt(v,10)}getObject(S,C){const v=this.get(S);return(0,R.$sf)(v)?C:(0,L.$0g)(v)}async set(S,C,v=!1){if(this.c===b.Closed)return;if((0,R.$sf)(C))return this.delete(S,v);const o=(0,R.$lf)(C)||Array.isArray(C)?(0,L.$9g)(C):String(C);if(this.f.get(S)!==o)return this.f.set(S,o),this.j.set(S,o),this.h.delete(S),this.b.fire({key:S,external:v}),this.D()}async delete(S,C=!1){if(!(this.c===b.Closed||!this.f.delete(S)))return this.h.has(S)||this.h.add(S),this.j.delete(S),this.b.fire({key:S,external:C}),this.D()}async optimize(){if(this.c!==b.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=b.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const S={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(S).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(S){if(this.z)return this.D(S)}async D(S){return this.s.hint===m.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),S)}async whenFlushed(){if(this.z)return new Promise(S=>this.n.push(S))}isInMemory(){return this.s.hint===m.STORAGE_IN_MEMORY}}e.$Ro=P;class I{constructor(){this.onDidChangeItemsExternal=M.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(S){S.insert?.forEach((C,v)=>this.a.set(v,C)),S.delete?.forEach(C=>this.a.delete(C))}async optimize(){}async close(){}}e.$So=I}),define(Se[185],De([1,0,35,16]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cF=void 0;function g(L,R,m,k,b,P){if(Array.isArray(L)){let I=0;for(const p of L){const S=g(p,R,m,k,b,P);if(S===10)return S;S>I&&(I=S)}return I}else{if(typeof L=="string")return k?L==="*"?5:L===m?10:0:0;if(L){const{language:I,pattern:p,scheme:S,hasAccessToAllModels:C,notebookType:v}=L;if(!k&&!C)return 0;v&&b&&(R=b);let o=0;if(S)if(S===R.scheme)o=10;else if(S==="*")o=5;else return 0;if(I)if(I===m)o=10;else if(I==="*")o=Math.max(o,5);else return 0;if(v)if(v===P)o=10;else if(v==="*"&&P!==void 0)o=Math.max(o,5);else return 0;if(p){let s;if(typeof p=="string"?s=p:s={...p,base:(0,M.$7d)(p.base)},s===R.fsPath||(0,D.$qj)(s,R.fsPath))o=10;else return 0}return o}else return 0}}e.$cF=g}),define(Se[129],De([1,0,22,12]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u0=e.$t0=void 0;var g;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(g||(g={}));function L(I){for(let p=0,S=I.length;p<S;p+=4){const C=I[p+0],v=I[p+1],o=I[p+2],s=I[p+3];I[p+0]=s,I[p+1]=o,I[p+2]=v,I[p+3]=C}}function R(I){const p=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return M.$C()||L(p),D.$Fd.wrap(p)}function m(I){const p=I.buffer;if(M.$C()||L(p),p.byteOffset%4===0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const S=new Uint8Array(p.byteLength);return S.set(p),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function k(I){const p=new Uint32Array(b(I));let S=0;if(p[S++]=I.id,I.type==="full")p[S++]=1,p[S++]=I.data.length,p.set(I.data,S),S+=I.data.length;else{p[S++]=2,p[S++]=I.deltas.length;for(const C of I.deltas)p[S++]=C.start,p[S++]=C.deleteCount,C.data?(p[S++]=C.data.length,p.set(C.data,S),S+=C.data.length):p[S++]=0}return R(p)}e.$t0=k;function b(I){let p=0;if(p+=1+1,I.type==="full")p+=1+I.data.length;else{p+=1,p+=(1+1+1)*I.deltas.length;for(const S of I.deltas)S.data&&(p+=S.data.length)}return p}function P(I){const p=m(I);let S=0;const C=p[S++];if(p[S++]===1){const n=p[S++],h=p.subarray(S,S+n);return S+=n,{id:C,type:"full",data:h}}const o=p[S++],s=[];for(let n=0;n<o;n++){const h=p[S++],$=p[S++],d=p[S++];let t;d>0&&(t=p.subarray(S,S+d),S+=d),s[n]={start:h,deleteCount:$,data:t}}return{id:C,type:"delta",deltas:s}}e.$u0=P}),define(Se[186],De([10,11]),function($e,e){return $e.create("vs/editor/common/config/editorOptions",e)}),define(Se[130],De([1,0,19,23,12,166,124,186]),function($e,e,D,M,g,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var k;(function(ce){ce[ce.None=0]="None",ce[ce.Keep=1]="Keep",ce[ce.Brackets=2]="Brackets",ce[ce.Advanced=3]="Advanced",ce[ce.Full=4]="Full"})(k||(e.EditorAutoIndentStrategy=k={})),e.MINIMAP_GUTTER_WIDTH=8;class b{constructor(ae){this.c=ae}hasChanged(ae){return this.c[ae]}}e.ConfigurationChangedEvent=b;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class I{constructor(ae,Ce,qe,Ue){this.id=ae,this.name=Ce,this.defaultValue=qe,this.schema=Ue}applyUpdate(ae,Ce){return S(ae,Ce)}compute(ae,Ce,qe){return qe}}class p{constructor(ae,Ce){this.newValue=ae,this.didChange=Ce}}e.ApplyUpdateResult=p;function S(ce,ae){if(typeof ce!="object"||typeof ae!="object"||!ce||!ae)return new p(ae,ce!==ae);if(Array.isArray(ce)||Array.isArray(ae)){const qe=Array.isArray(ce)&&Array.isArray(ae)&&D.$sb(ce,ae);return new p(ae,!qe)}let Ce=!1;for(const qe in ae)if(ae.hasOwnProperty(qe)){const Ue=S(ce[qe],ae[qe]);Ue.didChange&&(ce[qe]=Ue.newValue,Ce=!0)}return new p(ce,Ce)}class C{constructor(ae){this.schema=void 0,this.id=ae,this.name="_never_",this.defaultValue=void 0}applyUpdate(ae,Ce){return S(ae,Ce)}validate(ae){return this.defaultValue}}class v{constructor(ae,Ce,qe,Ue){this.id=ae,this.name=Ce,this.defaultValue=qe,this.schema=Ue}applyUpdate(ae,Ce){return S(ae,Ce)}validate(ae){return typeof ae>"u"?this.defaultValue:ae}compute(ae,Ce,qe){return qe}}function o(ce,ae){return typeof ce>"u"?ae:ce==="false"?!1:!!ce}e.boolean=o;class s extends v{constructor(ae,Ce,qe,Ue=void 0){typeof Ue<"u"&&(Ue.type="boolean",Ue.default=qe),super(ae,Ce,qe,Ue)}validate(ae){return o(ae,this.defaultValue)}}function n(ce,ae,Ce,qe){if(typeof ce>"u")return ae;let Ue=parseInt(ce,10);return isNaN(Ue)?ae:(Ue=Math.max(Ce,Ue),Ue=Math.min(qe,Ue),Ue|0)}e.clampedInt=n;class h extends v{static clampedInt(ae,Ce,qe,Ue){return n(ae,Ce,qe,Ue)}constructor(ae,Ce,qe,Ue,Xe,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=qe,rt.minimum=Ue,rt.maximum=Xe),super(ae,Ce,qe,rt),this.minimum=Ue,this.maximum=Xe}validate(ae){return h.clampedInt(ae,this.defaultValue,this.minimum,this.maximum)}}function $(ce,ae,Ce,qe){if(typeof ce>"u")return ae;const Ue=d.float(ce,ae);return d.clamp(Ue,Ce,qe)}e.clampedFloat=$;class d extends v{static clamp(ae,Ce,qe){return ae<Ce?Ce:ae>qe?qe:ae}static float(ae,Ce){if(typeof ae=="number")return ae;if(typeof ae>"u")return Ce;const qe=parseFloat(ae);return isNaN(qe)?Ce:qe}constructor(ae,Ce,qe,Ue,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=qe),super(ae,Ce,qe,Xe),this.validationFn=Ue}validate(ae){return this.validationFn(d.float(ae,this.defaultValue))}}class t extends v{static string(ae,Ce){return typeof ae!="string"?Ce:ae}constructor(ae,Ce,qe,Ue=void 0){typeof Ue<"u"&&(Ue.type="string",Ue.default=qe),super(ae,Ce,qe,Ue)}validate(ae){return t.string(ae,this.defaultValue)}}function r(ce,ae,Ce,qe){return typeof ce!="string"?ae:qe&&ce in qe?qe[ce]:Ce.indexOf(ce)===-1?ae:ce}e.stringSet=r;class a extends v{constructor(ae,Ce,qe,Ue,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=Ue,Xe.default=qe),super(ae,Ce,qe,Xe),this.c=Ue}validate(ae){return r(ae,this.defaultValue,this.c)}}class i extends I{constructor(ae,Ce,qe,Ue,Xe,rt,at=void 0){typeof at<"u"&&(at.type="string",at.enum=Xe,at.default=Ue),super(ae,Ce,qe,at),this.c=Xe,this.d=rt}validate(ae){return typeof ae!="string"?this.defaultValue:this.c.indexOf(ae)===-1?this.defaultValue:this.d(ae)}}function c(ce){switch(ce){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(ae){switch(ae){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ae,Ce,qe){return qe===0?ae.accessibilitySupport:qe}}class y extends I{constructor(){const ae={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ae,{"editor.comments.insertSpace":{type:"boolean",default:ae.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ae.ignoreEmptyLines,description:m.localize(5,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{insertSpace:o(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var E;(function(ce){ce[ce.Hidden=0]="Hidden",ce[ce.Blink=1]="Blink",ce[ce.Smooth=2]="Smooth",ce[ce.Phase=3]="Phase",ce[ce.Expand=4]="Expand",ce[ce.Solid=5]="Solid"})(E||(e.TextEditorCursorBlinkingStyle=E={}));function u(ce){switch(ce){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var l;(function(ce){ce[ce.Line=1]="Line",ce[ce.Block=2]="Block",ce[ce.Underline=3]="Underline",ce[ce.LineThin=4]="LineThin",ce[ce.BlockOutline=5]="BlockOutline",ce[ce.UnderlineThin=6]="UnderlineThin"})(l||(e.TextEditorCursorStyle=l={}));function w(ce){switch(ce){case l.Line:return"line";case l.Block:return"block";case l.Underline:return"underline";case l.LineThin:return"line-thin";case l.BlockOutline:return"block-outline";case l.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function A(ce){switch(ce){case"line":return l.Line;case"block":return l.Block;case"underline":return l.Underline;case"line-thin":return l.LineThin;case"block-outline":return l.BlockOutline;case"underline-thin":return l.UnderlineThin}}class N extends C{constructor(){super(140)}compute(ae,Ce,qe){const Ue=["monaco-editor"];return Ce.get(39)&&Ue.push(Ce.get(39)),ae.extraEditorClassName&&Ue.push(ae.extraEditorClassName),Ce.get(73)==="default"?Ue.push("mouse-default"):Ce.get(73)==="copy"&&Ue.push("mouse-copy"),Ce.get(110)&&Ue.push("showUnused"),Ce.get(138)&&Ue.push("showDeprecated"),Ue.join(" ")}}class O extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(ae,Ce,qe){return qe&&ae.emptySelectionClipboard}}class F extends I{constructor(){const ae={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ae,{"editor.find.cursorMoveOnType":{type:"boolean",default:ae.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ae.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ae.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ae.globalFindClipboard,description:m.localize(16,null),included:g.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ae.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:ae.loop,description:m.localize(18,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{cursorMoveOnType:o(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ae.seedSearchStringFromSelection=="boolean"?ae.seedSearchStringFromSelection?"always":"never":r(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ae.autoFindInSelection=="boolean"?ae.autoFindInSelection?"always":"never":r(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(Ce.loop,this.defaultValue.loop)}}}class j extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(ae){return typeof ae>"u"?this.defaultValue:typeof ae=="string"?ae==="false"?j.OFF:ae==="true"?j.ON:ae:ae?j.ON:j.OFF}}e.EditorFontLigatures=j;class z extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",z.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(ae){return typeof ae>"u"?this.defaultValue:typeof ae=="string"?ae==="false"?z.OFF:ae==="true"?z.TRANSLATE:ae:ae?z.TRANSLATE:z.OFF}compute(ae,Ce,qe){return ae.fontInfo.fontVariationSettings}}e.EditorFontVariations=z;class T extends C{constructor(){super(50)}compute(ae,Ce,qe){return ae.fontInfo}}class H extends v{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(ae){const Ce=d.float(ae,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(Ce,6,100)}compute(ae,Ce,qe){return ae.fontInfo.fontSize}}class q extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:q.d,maximum:q.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:q.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(ae){return ae==="normal"||ae==="bold"?ae:String(h.clampedInt(ae,e.EDITOR_FONT_DEFAULTS.fontWeight,q.d,q.e))}}class me extends I{constructor(){const ae={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:ae.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ae,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ae.alternativeDefinitionCommand,enum:qe,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ae.alternativeTypeDefinitionCommand,enum:qe,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ae.alternativeDeclarationCommand,enum:qe,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ae.alternativeImplementationCommand,enum:qe,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ae.alternativeReferenceCommand,enum:qe,description:m.localize(41,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{multiple:r(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??r(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??r(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??r(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??r(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??r(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class X extends I{constructor(){const ae={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ae,{"editor.hover.enabled":{type:"boolean",default:ae.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:ae.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ae.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ae.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:ae.above,description:m.localize(46,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:o(Ce.enabled,this.defaultValue.enabled),delay:h.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:o(Ce.sticky,this.defaultValue.sticky),hidingDelay:h.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(Ce.above,this.defaultValue.above)}}}var Z;(function(ce){ce[ce.None=0]="None",ce[ce.Text=1]="Text",ce[ce.Blocks=2]="Blocks"})(Z||(e.RenderMinimap=Z={}));class V extends C{constructor(){super(143)}compute(ae,Ce,qe){return V.computeLayout(Ce,{memory:ae.memory,outerWidth:ae.outerWidth,outerHeight:ae.outerHeight,isDominatedByLongLines:ae.isDominatedByLongLines,lineHeight:ae.fontInfo.lineHeight,viewLineCount:ae.viewLineCount,lineNumbersDigitCount:ae.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ae.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ae.fontInfo.maxDigitWidth,pixelRatio:ae.pixelRatio,glyphMarginDecorationLaneCount:ae.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ae){const Ce=ae.height/ae.lineHeight,qe=Math.floor(ae.paddingTop/ae.lineHeight);let Ue=Math.floor(ae.paddingBottom/ae.lineHeight);ae.scrollBeyondLastLine&&(Ue=Math.max(Ue,Ce-1));const Xe=(qe+ae.viewLineCount+Ue)/(ae.pixelRatio*ae.height),rt=Math.floor(ae.viewLineCount/Xe);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:Ue,desiredRatio:Xe,minimapLineCount:rt}}static c(ae,Ce){const qe=ae.outerWidth,Ue=ae.outerHeight,Xe=ae.pixelRatio;if(!ae.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*Ue),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ue};const rt=Ce.stableMinimapLayoutInput,at=rt&&ae.outerHeight===rt.outerHeight&&ae.lineHeight===rt.lineHeight&&ae.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&ae.pixelRatio===rt.pixelRatio&&ae.scrollBeyondLastLine===rt.scrollBeyondLastLine&&ae.paddingTop===rt.paddingTop&&ae.paddingBottom===rt.paddingBottom&&ae.minimap.enabled===rt.minimap.enabled&&ae.minimap.side===rt.minimap.side&&ae.minimap.size===rt.minimap.size&&ae.minimap.showSlider===rt.minimap.showSlider&&ae.minimap.renderCharacters===rt.minimap.renderCharacters&&ae.minimap.maxColumn===rt.minimap.maxColumn&&ae.minimap.scale===rt.minimap.scale&&ae.verticalScrollbarWidth===rt.verticalScrollbarWidth&&ae.isViewportWrapping===rt.isViewportWrapping,$t=ae.lineHeight,St=ae.typicalHalfwidthCharacterWidth,Zt=ae.scrollBeyondLastLine,qt=ae.minimap.renderCharacters;let vt=Xe>=2?Math.round(ae.minimap.scale*2):ae.minimap.scale;const Nt=ae.minimap.maxColumn,jt=ae.minimap.size,Jt=ae.minimap.side,At=ae.verticalScrollbarWidth,Rt=ae.viewLineCount,zt=ae.remainingWidth,Bt=ae.isViewportWrapping,Ht=qt?2:3;let Wt=Math.floor(Xe*Ue);const Vt=Wt/Xe;let ot=!1,ft=!1,Lt=Ht*vt,Ft=vt/Xe,It=1;if(jt==="fill"||jt==="fit"){const{typicalViewportLineCount:Me,extraLinesBeforeFirstLine:Pe,extraLinesBeyondLastLine:_,desiredRatio:Te,minimapLineCount:He}=V.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Zt,paddingTop:ae.paddingTop,paddingBottom:ae.paddingBottom,height:Ue,lineHeight:$t,pixelRatio:Xe});if(Rt/He>1)ot=!0,ft=!0,vt=1,Lt=1,Ft=vt/Xe;else{let Je=!1,nt=vt+1;if(jt==="fit"){const bt=Math.ceil((Pe+Rt+_)*Lt);Bt&&at&&zt<=Ce.stableFitRemainingWidth?(Je=!0,nt=Ce.stableFitMaxMinimapScale):Je=bt>Wt}if(jt==="fill"||Je){ot=!0;const bt=vt;Lt=Math.min($t*Xe,Math.max(1,Math.floor(1/Te))),Bt&&at&&zt<=Ce.stableFitRemainingWidth&&(nt=Ce.stableFitMaxMinimapScale),vt=Math.min(nt,Math.max(1,Math.floor(Lt/Ht))),vt>bt&&(It=Math.min(2,vt/bt)),Ft=vt/Xe/It,Wt=Math.ceil(Math.max(Me,Pe+Rt+_)*Lt),Bt?(Ce.stableMinimapLayoutInput=ae,Ce.stableFitRemainingWidth=zt,Ce.stableFitMaxMinimapScale=vt):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const dt=Math.floor(Nt*Ft),kt=Math.min(dt,Math.max(0,Math.floor((zt-At-2)*Ft/(St+Ft)))+e.MINIMAP_GUTTER_WIDTH);let Dt=Math.floor(Xe*kt);const Mt=Dt/Xe;Dt=Math.floor(Dt*It);const Ge=qt?1:2,Fe=Jt==="left"?0:qe-kt-At;return{renderMinimap:Ge,minimapLeft:Fe,minimapWidth:kt,minimapHeightIsEditorHeight:ot,minimapIsSampling:ft,minimapScale:vt,minimapLineHeight:Lt,minimapCanvasInnerWidth:Dt,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:Mt,minimapCanvasOuterHeight:Vt}}static computeLayout(ae,Ce){const qe=Ce.outerWidth|0,Ue=Ce.outerHeight|0,Xe=Ce.lineHeight|0,rt=Ce.lineNumbersDigitCount|0,at=Ce.typicalHalfwidthCharacterWidth,$t=Ce.maxDigitWidth,St=Ce.pixelRatio,Zt=Ce.viewLineCount,qt=ae.get(135),vt=qt==="inherit"?ae.get(134):qt,Nt=vt==="inherit"?ae.get(130):vt,jt=ae.get(133),Jt=Ce.isDominatedByLongLines,At=ae.get(57),Rt=ae.get(67).renderType!==0,zt=ae.get(68),Bt=ae.get(104),Ht=ae.get(83),Wt=ae.get(72),Vt=ae.get(102),ot=Vt.verticalScrollbarSize,ft=Vt.verticalHasArrows,Lt=Vt.arrowSize,Ft=Vt.horizontalScrollbarSize,It=ae.get(43),dt=ae.get(109)!=="never";let kt=ae.get(65);It&&dt&&(kt+=16);let Dt=0;if(Rt){const wt=Math.max(rt,zt);Dt=Math.round(wt*$t)}let Mt=0;At&&(Mt=Xe*Ce.glyphMarginDecorationLaneCount);let Ge=0,Fe=Ge+Mt,Me=Fe+Dt,Pe=Me+kt;const _=qe-Mt-Dt-kt;let Te=!1,He=!1,xe=-1;vt==="inherit"&&Jt?(Te=!0,He=!0):Nt==="on"||Nt==="bounded"?He=!0:Nt==="wordWrapColumn"&&(xe=jt);const Je=V.c({outerWidth:qe,outerHeight:Ue,lineHeight:Xe,typicalHalfwidthCharacterWidth:at,pixelRatio:St,scrollBeyondLastLine:Bt,paddingTop:Ht.top,paddingBottom:Ht.bottom,minimap:Wt,verticalScrollbarWidth:ot,viewLineCount:Zt,remainingWidth:_,isViewportWrapping:He},Ce.memory||new P);Je.renderMinimap!==0&&Je.minimapLeft===0&&(Ge+=Je.minimapWidth,Fe+=Je.minimapWidth,Me+=Je.minimapWidth,Pe+=Je.minimapWidth);const nt=_-Je.minimapWidth,bt=Math.max(1,Math.floor((nt-ot-2)/at)),Pt=ft?Lt:0;return He&&(xe=Math.max(1,bt),Nt==="bounded"&&(xe=Math.min(xe,jt))),{width:qe,height:Ue,glyphMarginLeft:Ge,glyphMarginWidth:Mt,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:Fe,lineNumbersWidth:Dt,decorationsLeft:Me,decorationsWidth:kt,contentLeft:Pe,contentWidth:nt,minimap:Je,viewportColumn:bt,isWordWrapMinified:Te,isViewportWrapping:He,wrappingColumn:xe,verticalScrollbarWidth:ot,horizontalScrollbarHeight:Ft,overviewRuler:{top:Pt,width:ot,height:Ue-2*Pt,right:0}}}}e.EditorLayoutInfoComputer=V;class x extends I{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(ae){return r(ae,"simple",["simple","advanced"])}compute(ae,Ce,qe){return Ce.get(2)===2?"advanced":qe}}class ge extends I{constructor(){const ae={enabled:!0};super(64,"lightbulb",ae,{"editor.lightbulb.enabled":{type:"boolean",default:ae.enabled,description:m.localize(50,null)}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{enabled:o(ae.enabled,this.defaultValue.enabled)}}}class ue extends I{constructor(){const ae={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",ae,{"editor.stickyScroll.enabled":{type:"boolean",default:ae.enabled,description:m.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ae.maxLineCount,minimum:1,maximum:10,description:m.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ae.defaultModel,description:m.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ae.scrollWithEditor,description:m.localize(54,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:o(Ce.enabled,this.defaultValue.enabled),maxLineCount:h.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class we extends I{constructor(){const ae={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",ae,{"editor.inlayHints.enabled":{type:"string",default:ae.enabled,description:m.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(56,null),m.localize(57,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(58,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:ae.fontSize,markdownDescription:m.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ae.fontFamily,markdownDescription:m.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ae.padding,description:m.localize(62,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:r(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:h.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:o(Ce.padding,this.defaultValue.padding)}}}class G extends I{constructor(){super(65,"lineDecorationsWidth",10)}validate(ae){return typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)?-parseFloat(ae.substring(0,ae.length-2)):h.clampedInt(ae,this.defaultValue,0,1e3)}compute(ae,Ce,qe){return qe<0?h.clampedInt(-qe*ae.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):qe}}class U extends d{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ae=>d.clamp(ae,0,150),{markdownDescription:m.localize(63,null)})}compute(ae,Ce,qe){return ae.fontInfo.lineHeight}}class K extends I{constructor(){const ae={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ae,{"editor.minimap.enabled":{type:"boolean",default:ae.enabled,description:m.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:ae.autohide,description:m.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(66,null),m.localize(67,null),m.localize(68,null)],default:ae.size,description:m.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ae.side,description:m.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ae.showSlider,description:m.localize(71,null)},"editor.minimap.scale":{type:"number",default:ae.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ae.renderCharacters,description:m.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:ae.maxColumn,description:m.localize(74,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:o(Ce.enabled,this.defaultValue.enabled),autohide:o(Ce.autohide,this.defaultValue.autohide),size:r(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(Ce.side,this.defaultValue.side,["right","left"]),showSlider:r(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:h.clampedInt(Ce.scale,1,1,3),maxColumn:h.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function fe(ce){return ce==="ctrlCmd"?g.$j?"metaKey":"ctrlKey":"altKey"}class te extends I{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(76,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{top:h.clampedInt(Ce.top,0,0,1e3),bottom:h.clampedInt(Ce.bottom,0,0,1e3)}}}class re extends I{constructor(){const ae={enabled:!0,cycle:!0};super(85,"parameterHints",ae,{"editor.parameterHints.enabled":{type:"boolean",default:ae.enabled,description:m.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:ae.cycle,description:m.localize(78,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:o(Ce.enabled,this.defaultValue.enabled),cycle:o(Ce.cycle,this.defaultValue.cycle)}}}class ne extends C{constructor(){super(141)}compute(ae,Ce,qe){return ae.pixelRatio}}class Ee extends I{constructor(){const ae={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(79,null),m.localize(80,null),m.localize(81,null)]}];super(88,"quickSuggestions",ae,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:ae.strings,description:m.localize(82,null)},comments:{anyOf:Ce,default:ae.comments,description:m.localize(83,null)},other:{anyOf:Ce,default:ae.other,description:m.localize(84,null)}},default:ae,markdownDescription:m.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ae}validate(ae){if(typeof ae=="boolean"){const St=ae?"on":"off";return{comments:St,strings:St,other:St}}if(!ae||typeof ae!="object")return this.defaultValue;const{other:Ce,comments:qe,strings:Ue}=ae,Xe=["on","inline","off"];let rt,at,$t;return typeof Ce=="boolean"?rt=Ce?"on":"off":rt=r(Ce,this.defaultValue.other,Xe),typeof qe=="boolean"?at=qe?"on":"off":at=r(qe,this.defaultValue.comments,Xe),typeof Ue=="boolean"?$t=Ue?"on":"off":$t=r(Ue,this.defaultValue.strings,Xe),{other:rt,comments:at,strings:$t}}}var oe;(function(ce){ce[ce.Off=0]="Off",ce[ce.On=1]="On",ce[ce.Relative=2]="Relative",ce[ce.Interval=3]="Interval",ce[ce.Custom=4]="Custom"})(oe||(e.RenderLineNumbersType=oe={}));class he extends I{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(86,null),m.localize(87,null),m.localize(88,null),m.localize(89,null)],default:"on",description:m.localize(90,null)})}validate(ae){let Ce=this.defaultValue.renderType,qe=this.defaultValue.renderFn;return typeof ae<"u"&&(typeof ae=="function"?(Ce=4,qe=ae):ae==="interval"?Ce=3:ae==="relative"?Ce=2:ae==="on"?Ce=1:Ce=0),{renderType:Ce,renderFn:qe}}}function ee(ce){const ae=ce.get(97);return ae==="editable"?ce.get(90):ae!=="on"}e.filterValidationDecorations=ee;class le extends I{constructor(){const ae=[],Ce={type:"number",description:m.localize(91,null)};super(101,"rulers",ae,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:m.localize(92,null),format:"color-hex"}}}]},default:ae,description:m.localize(93,null)})}validate(ae){if(Array.isArray(ae)){const Ce=[];for(const qe of ae)if(typeof qe=="number")Ce.push({column:h.clampedInt(qe,0,0,1e4),color:null});else if(qe&&typeof qe=="object"){const Ue=qe;Ce.push({column:h.clampedInt(Ue.column,0,0,1e4),color:Ue.color})}return Ce.sort((qe,Ue)=>qe.column-Ue.column),Ce}return this.defaultValue}}class be extends I{constructor(){super(91,"readOnlyMessage",void 0)}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:ae}}function Ie(ce,ae){if(typeof ce!="string")return ae;switch(ce){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends I{constructor(){const ae={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",ae,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(94,null),m.localize(95,null),m.localize(96,null)],default:"auto",description:m.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(98,null),m.localize(99,null),m.localize(100,null)],default:"auto",description:m.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ae.verticalScrollbarSize,description:m.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ae.horizontalScrollbarSize,description:m.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ae.scrollByPage,description:m.localize(104,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae,qe=h.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ue=h.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:h.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(Ce.vertical,this.defaultValue.vertical),horizontal:Ie(Ce.horizontal,this.defaultValue.horizontal),useShadows:o(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:qe,horizontalSliderSize:h.clampedInt(Ce.horizontalSliderSize,qe,0,1e3),verticalScrollbarSize:Ue,verticalSliderSize:h.clampedInt(Ce.verticalSliderSize,Ue,0,1e3),scrollByPage:o(Ce.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends I{constructor(){const ae={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",ae,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.nonBasicASCII,description:m.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ae.invisibleCharacters,description:m.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ae.ambiguousCharacters,description:m.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeComments,description:m.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeStrings,description:m.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ae.allowedCharacters,description:m.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ae.allowedLocales,description:m.localize(111,null)}})}applyUpdate(ae,Ce){let qe=!1;Ce.allowedCharacters&&ae&&(M.$Zm(ae.allowedCharacters,Ce.allowedCharacters)||(ae={...ae,allowedCharacters:Ce.allowedCharacters},qe=!0)),Ce.allowedLocales&&ae&&(M.$Zm(ae.allowedLocales,Ce.allowedLocales)||(ae={...ae,allowedLocales:Ce.allowedLocales},qe=!0));const Ue=super.applyUpdate(ae,Ce);return qe?new p(Ue.newValue,!0):Ue}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{nonBasicASCII:de(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:de(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:de(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ae.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ae.allowedLocales,this.defaultValue.allowedLocales)}}c(ae,Ce){if(typeof ae!="object"||!ae)return Ce;const qe={};for(const[Ue,Xe]of Object.entries(ae))Xe===!0&&(qe[Ue]=!0);return qe}}class ie extends I{constructor(){const ae={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ae,{"editor.inlineSuggest.enabled":{type:"boolean",default:ae.enabled,description:m.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ae.showToolbar,enum:["always","onHover"],enumDescriptions:[m.localize(113,null),m.localize(114,null)],description:m.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ae.suppressSuggestions,description:m.localize(116,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:o(Ce.enabled,this.defaultValue.enabled),mode:r(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:o(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(Ce.keepOnBlur,this.defaultValue.keepOnBlur)}}}class se extends I{constructor(){const ae={enabled:L.$Ur.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$Ur.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ae,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ae.enabled,markdownDescription:m.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ae.independentColorPoolPerBracketType,description:m.localize(118,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:o(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Y extends I{constructor(){const ae={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ae,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(119,null),m.localize(120,null),m.localize(121,null)],default:ae.bracketPairs,description:m.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(123,null),m.localize(124,null),m.localize(125,null)],default:ae.bracketPairsHorizontal,description:m.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ae.highlightActiveBracketPair,description:m.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:ae.indentation,description:m.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(129,null),m.localize(130,null),m.localize(131,null)],default:ae.highlightActiveIndentation,description:m.localize(132,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{bracketPairs:de(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:de(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:de(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function de(ce,ae,Ce){const qe=Ce.indexOf(ce);return qe===-1?ae:Ce[qe]}class ye extends I{constructor(){const ae={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",ae,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(133,null),m.localize(134,null)],default:ae.insertMode,description:m.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ae.filterGraceful,description:m.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:ae.localityBonus,description:m.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ae.shareSuggestSelections,markdownDescription:m.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(139,null),m.localize(140,null),m.localize(141,null),m.localize(142,null)],default:ae.selectionMode,markdownDescription:m.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ae.snippetsPreventQuickSuggestions,description:m.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:ae.showIcons,description:m.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ae.showStatusBar,description:m.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:ae.preview,description:m.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ae.showInlineDetails,description:m.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{insertMode:r(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:o(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:o(Ce.preview,this.defaultValue.preview),previewMode:r(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(Ce.showMethods,this.defaultValue.showMethods),showFunctions:o(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:o(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(Ce.showFields,this.defaultValue.showFields),showVariables:o(Ce.showVariables,this.defaultValue.showVariables),showClasses:o(Ce.showClasses,this.defaultValue.showClasses),showStructs:o(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:o(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:o(Ce.showModules,this.defaultValue.showModules),showProperties:o(Ce.showProperties,this.defaultValue.showProperties),showEvents:o(Ce.showEvents,this.defaultValue.showEvents),showOperators:o(Ce.showOperators,this.defaultValue.showOperators),showUnits:o(Ce.showUnits,this.defaultValue.showUnits),showValues:o(Ce.showValues,this.defaultValue.showValues),showConstants:o(Ce.showConstants,this.defaultValue.showConstants),showEnums:o(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:o(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(Ce.showKeywords,this.defaultValue.showKeywords),showWords:o(Ce.showWords,this.defaultValue.showWords),showColors:o(Ce.showColors,this.defaultValue.showColors),showFiles:o(Ce.showFiles,this.defaultValue.showFiles),showReferences:o(Ce.showReferences,this.defaultValue.showReferences),showFolders:o(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:o(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:o(Ce.showUsers,this.defaultValue.showUsers),showIssues:o(Ce.showIssues,this.defaultValue.showIssues)}}}class je extends I{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(182,null),default:!0,type:"boolean"}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(ae.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(ae.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(ce){ce[ce.None=0]="None",ce[ce.Same=1]="Same",ce[ce.Indent=2]="Indent",ce[ce.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class _e extends I{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(183,null),m.localize(184,null),m.localize(185,null),m.localize(186,null)],description:m.localize(187,null),default:"same"}})}validate(ae){switch(ae){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ae,Ce,qe){return Ce.get(2)===2?0:qe}}class Ye extends C{constructor(){super(144)}compute(ae,Ce,qe){const Ue=Ce.get(143);return{isDominatedByLongLines:ae.isDominatedByLongLines,isWordWrapMinified:Ue.isWordWrapMinified,isViewportWrapping:Ue.isViewportWrapping,wrappingColumn:Ue.wrappingColumn}}}class it extends I{constructor(){const ae={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ae,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ae.enabled,markdownDescription:m.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(190,null),m.localize(191,null)],default:"afterDrop"}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:o(Ce.enabled,this.defaultValue.enabled),showDropSelector:r(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class et extends I{constructor(){const ae={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",ae,{"editor.pasteAs.enabled":{type:"boolean",default:ae.enabled,markdownDescription:m.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(194,null),m.localize(195,null)],default:"afterPaste"}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:o(Ce.enabled,this.defaultValue.enabled),showPasteSelector:r(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ae="Consolas, 'Courier New', monospace",Oe="Menlo, Monaco, 'Courier New', monospace",Ve="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:g.$j?Oe:g.$k?Ve:Ae,fontWeight:"normal",fontSize:g.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(ce){return e.editorOptionsRegistry[ce.id]=ce,ce}var Ze;(function(ce){ce[ce.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ce[ce.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ce[ce.accessibilitySupport=2]="accessibilitySupport",ce[ce.accessibilityPageSize=3]="accessibilityPageSize",ce[ce.ariaLabel=4]="ariaLabel",ce[ce.ariaRequired=5]="ariaRequired",ce[ce.autoClosingBrackets=6]="autoClosingBrackets",ce[ce.autoClosingComments=7]="autoClosingComments",ce[ce.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ce[ce.autoClosingDelete=9]="autoClosingDelete",ce[ce.autoClosingOvertype=10]="autoClosingOvertype",ce[ce.autoClosingQuotes=11]="autoClosingQuotes",ce[ce.autoIndent=12]="autoIndent",ce[ce.automaticLayout=13]="automaticLayout",ce[ce.autoSurround=14]="autoSurround",ce[ce.bracketPairColorization=15]="bracketPairColorization",ce[ce.guides=16]="guides",ce[ce.codeLens=17]="codeLens",ce[ce.codeLensFontFamily=18]="codeLensFontFamily",ce[ce.codeLensFontSize=19]="codeLensFontSize",ce[ce.colorDecorators=20]="colorDecorators",ce[ce.colorDecoratorsLimit=21]="colorDecoratorsLimit",ce[ce.columnSelection=22]="columnSelection",ce[ce.comments=23]="comments",ce[ce.contextmenu=24]="contextmenu",ce[ce.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ce[ce.cursorBlinking=26]="cursorBlinking",ce[ce.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ce[ce.cursorStyle=28]="cursorStyle",ce[ce.cursorSurroundingLines=29]="cursorSurroundingLines",ce[ce.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ce[ce.cursorWidth=31]="cursorWidth",ce[ce.disableLayerHinting=32]="disableLayerHinting",ce[ce.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ce[ce.domReadOnly=34]="domReadOnly",ce[ce.dragAndDrop=35]="dragAndDrop",ce[ce.dropIntoEditor=36]="dropIntoEditor",ce[ce.emptySelectionClipboard=37]="emptySelectionClipboard",ce[ce.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ce[ce.extraEditorClassName=39]="extraEditorClassName",ce[ce.fastScrollSensitivity=40]="fastScrollSensitivity",ce[ce.find=41]="find",ce[ce.fixedOverflowWidgets=42]="fixedOverflowWidgets",ce[ce.folding=43]="folding",ce[ce.foldingStrategy=44]="foldingStrategy",ce[ce.foldingHighlight=45]="foldingHighlight",ce[ce.foldingImportsByDefault=46]="foldingImportsByDefault",ce[ce.foldingMaximumRegions=47]="foldingMaximumRegions",ce[ce.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ce[ce.fontFamily=49]="fontFamily",ce[ce.fontInfo=50]="fontInfo",ce[ce.fontLigatures=51]="fontLigatures",ce[ce.fontSize=52]="fontSize",ce[ce.fontWeight=53]="fontWeight",ce[ce.fontVariations=54]="fontVariations",ce[ce.formatOnPaste=55]="formatOnPaste",ce[ce.formatOnType=56]="formatOnType",ce[ce.glyphMargin=57]="glyphMargin",ce[ce.gotoLocation=58]="gotoLocation",ce[ce.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ce[ce.hover=60]="hover",ce[ce.inDiffEditor=61]="inDiffEditor",ce[ce.inlineSuggest=62]="inlineSuggest",ce[ce.letterSpacing=63]="letterSpacing",ce[ce.lightbulb=64]="lightbulb",ce[ce.lineDecorationsWidth=65]="lineDecorationsWidth",ce[ce.lineHeight=66]="lineHeight",ce[ce.lineNumbers=67]="lineNumbers",ce[ce.lineNumbersMinChars=68]="lineNumbersMinChars",ce[ce.linkedEditing=69]="linkedEditing",ce[ce.links=70]="links",ce[ce.matchBrackets=71]="matchBrackets",ce[ce.minimap=72]="minimap",ce[ce.mouseStyle=73]="mouseStyle",ce[ce.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ce[ce.mouseWheelZoom=75]="mouseWheelZoom",ce[ce.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ce[ce.multiCursorModifier=77]="multiCursorModifier",ce[ce.multiCursorPaste=78]="multiCursorPaste",ce[ce.multiCursorLimit=79]="multiCursorLimit",ce[ce.occurrencesHighlight=80]="occurrencesHighlight",ce[ce.overviewRulerBorder=81]="overviewRulerBorder",ce[ce.overviewRulerLanes=82]="overviewRulerLanes",ce[ce.padding=83]="padding",ce[ce.pasteAs=84]="pasteAs",ce[ce.parameterHints=85]="parameterHints",ce[ce.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ce[ce.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ce[ce.quickSuggestions=88]="quickSuggestions",ce[ce.quickSuggestionsDelay=89]="quickSuggestionsDelay",ce[ce.readOnly=90]="readOnly",ce[ce.readOnlyMessage=91]="readOnlyMessage",ce[ce.renameOnType=92]="renameOnType",ce[ce.renderControlCharacters=93]="renderControlCharacters",ce[ce.renderFinalNewline=94]="renderFinalNewline",ce[ce.renderLineHighlight=95]="renderLineHighlight",ce[ce.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ce[ce.renderValidationDecorations=97]="renderValidationDecorations",ce[ce.renderWhitespace=98]="renderWhitespace",ce[ce.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ce[ce.roundedSelection=100]="roundedSelection",ce[ce.rulers=101]="rulers",ce[ce.scrollbar=102]="scrollbar",ce[ce.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ce[ce.scrollBeyondLastLine=104]="scrollBeyondLastLine",ce[ce.scrollPredominantAxis=105]="scrollPredominantAxis",ce[ce.selectionClipboard=106]="selectionClipboard",ce[ce.selectionHighlight=107]="selectionHighlight",ce[ce.selectOnLineNumbers=108]="selectOnLineNumbers",ce[ce.showFoldingControls=109]="showFoldingControls",ce[ce.showUnused=110]="showUnused",ce[ce.snippetSuggestions=111]="snippetSuggestions",ce[ce.smartSelect=112]="smartSelect",ce[ce.smoothScrolling=113]="smoothScrolling",ce[ce.stickyScroll=114]="stickyScroll",ce[ce.stickyTabStops=115]="stickyTabStops",ce[ce.stopRenderingLineAfter=116]="stopRenderingLineAfter",ce[ce.suggest=117]="suggest",ce[ce.suggestFontSize=118]="suggestFontSize",ce[ce.suggestLineHeight=119]="suggestLineHeight",ce[ce.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ce[ce.suggestSelection=121]="suggestSelection",ce[ce.tabCompletion=122]="tabCompletion",ce[ce.tabIndex=123]="tabIndex",ce[ce.unicodeHighlighting=124]="unicodeHighlighting",ce[ce.unusualLineTerminators=125]="unusualLineTerminators",ce[ce.useShadowDOM=126]="useShadowDOM",ce[ce.useTabStops=127]="useTabStops",ce[ce.wordBreak=128]="wordBreak",ce[ce.wordSeparators=129]="wordSeparators",ce[ce.wordWrap=130]="wordWrap",ce[ce.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ce[ce.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ce[ce.wordWrapColumn=133]="wordWrapColumn",ce[ce.wordWrapOverride1=134]="wordWrapOverride1",ce[ce.wordWrapOverride2=135]="wordWrapOverride2",ce[ce.wrappingIndent=136]="wrappingIndent",ce[ce.wrappingStrategy=137]="wrappingStrategy",ce[ce.showDeprecated=138]="showDeprecated",ce[ce.inlayHints=139]="inlayHints",ce[ce.editorClassName=140]="editorClassName",ce[ce.pixelRatio=141]="pixelRatio",ce[ce.tabFocusMode=142]="tabFocusMode",ce[ce.layoutInfo=143]="layoutInfo",ce[ce.wrappingInfo=144]="wrappingInfo",ce[ce.defaultColorDecorators=145]="defaultColorDecorators",ce[ce.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ce[ce.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Ze||(e.EditorOption=Ze={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(196,null)})),acceptSuggestionOnEnter:Le(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(197,null),""],markdownDescription:m.localize(198,null)})),accessibilitySupport:Le(new f),accessibilityPageSize:Le(new h(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(199,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",m.localize(200,null))),ariaRequired:Le(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:Le(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(202,null),m.localize(203,null),""],description:m.localize(204,null)})),autoClosingComments:Le(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(205,null),m.localize(206,null),""],description:m.localize(207,null)})),autoClosingDelete:Le(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(208,null),""],description:m.localize(209,null)})),autoClosingOvertype:Le(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(210,null),""],description:m.localize(211,null)})),autoClosingQuotes:Le(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(212,null),m.localize(213,null),""],description:m.localize(214,null)})),autoIndent:Le(new i(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[m.localize(215,null),m.localize(216,null),m.localize(217,null),m.localize(218,null),m.localize(219,null)],description:m.localize(220,null)})),automaticLayout:Le(new s(13,"automaticLayout",!1)),autoSurround:Le(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(221,null),m.localize(222,null),m.localize(223,null),""],description:m.localize(224,null)})),bracketPairColorization:Le(new se),bracketPairGuides:Le(new Y),stickyTabStops:Le(new s(115,"stickyTabStops",!1,{description:m.localize(225,null)})),codeLens:Le(new s(17,"codeLens",!0,{description:m.localize(226,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:m.localize(227,null)})),codeLensFontSize:Le(new h(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(228,null)})),colorDecorators:Le(new s(20,"colorDecorators",!0,{description:m.localize(229,null)})),colorDecoratorActivatedOn:Le(new a(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(230,null),m.localize(231,null),m.localize(232,null)],description:m.localize(233,null)})),colorDecoratorsLimit:Le(new h(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(234,null)})),columnSelection:Le(new s(22,"columnSelection",!1,{description:m.localize(235,null)})),comments:Le(new y),contextmenu:Le(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new s(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(236,null)})),cursorBlinking:Le(new i(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:m.localize(237,null)})),cursorSmoothCaretAnimation:Le(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(238,null),m.localize(239,null),m.localize(240,null)],description:m.localize(241,null)})),cursorStyle:Le(new i(28,"cursorStyle",l.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],A,{description:m.localize(242,null)})),cursorSurroundingLines:Le(new h(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(243,null)})),cursorSurroundingLinesStyle:Le(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(244,null),m.localize(245,null)],markdownDescription:m.localize(246,null)})),cursorWidth:Le(new h(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(247,null)})),disableLayerHinting:Le(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new s(34,"domReadOnly",!1)),dragAndDrop:Le(new s(35,"dragAndDrop",!0,{description:m.localize(248,null)})),emptySelectionClipboard:Le(new O),dropIntoEditor:Le(new it),stickyScroll:Le(new ue),experimentalWhitespaceRendering:Le(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(249,null),m.localize(250,null),m.localize(251,null)],description:m.localize(252,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new d(40,"fastScrollSensitivity",5,ce=>ce<=0?5:ce,{markdownDescription:m.localize(253,null)})),find:Le(new F),fixedOverflowWidgets:Le(new s(42,"fixedOverflowWidgets",!1)),folding:Le(new s(43,"folding",!0,{description:m.localize(254,null)})),foldingStrategy:Le(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(255,null),m.localize(256,null)],description:m.localize(257,null)})),foldingHighlight:Le(new s(45,"foldingHighlight",!0,{description:m.localize(258,null)})),foldingImportsByDefault:Le(new s(46,"foldingImportsByDefault",!1,{description:m.localize(259,null)})),foldingMaximumRegions:Le(new h(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(260,null)})),unfoldOnClickAfterEndOfLine:Le(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(261,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(262,null)})),fontInfo:Le(new T),fontLigatures2:Le(new j),fontSize:Le(new H),fontWeight:Le(new q),fontVariations:Le(new z),formatOnPaste:Le(new s(55,"formatOnPaste",!1,{description:m.localize(263,null)})),formatOnType:Le(new s(56,"formatOnType",!1,{description:m.localize(264,null)})),glyphMargin:Le(new s(57,"glyphMargin",!0,{description:m.localize(265,null)})),gotoLocation:Le(new me),hideCursorInOverviewRuler:Le(new s(59,"hideCursorInOverviewRuler",!1,{description:m.localize(266,null)})),hover:Le(new X),inDiffEditor:Le(new s(61,"inDiffEditor",!1)),letterSpacing:Le(new d(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ce=>d.clamp(ce,-5,20),{description:m.localize(267,null)})),lightbulb:Le(new ge),lineDecorationsWidth:Le(new G),lineHeight:Le(new U),lineNumbers:Le(new he),lineNumbersMinChars:Le(new h(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new s(69,"linkedEditing",!1,{description:m.localize(268,null)})),links:Le(new s(70,"links",!0,{description:m.localize(269,null)})),matchBrackets:Le(new a(71,"matchBrackets","always",["always","near","never"],{description:m.localize(270,null)})),minimap:Le(new K),mouseStyle:Le(new a(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new d(74,"mouseWheelScrollSensitivity",1,ce=>ce===0?1:ce,{markdownDescription:m.localize(271,null)})),mouseWheelZoom:Le(new s(75,"mouseWheelZoom",!1,{markdownDescription:m.localize(272,null)})),multiCursorMergeOverlapping:Le(new s(76,"multiCursorMergeOverlapping",!0,{description:m.localize(273,null)})),multiCursorModifier:Le(new i(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],fe,{markdownEnumDescriptions:[m.localize(274,null),m.localize(275,null)],markdownDescription:m.localize(276,null)})),multiCursorPaste:Le(new a(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(277,null),m.localize(278,null)],markdownDescription:m.localize(279,null)})),multiCursorLimit:Le(new h(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(280,null)})),occurrencesHighlight:Le(new s(80,"occurrencesHighlight",!0,{description:m.localize(281,null)})),overviewRulerBorder:Le(new s(81,"overviewRulerBorder",!0,{description:m.localize(282,null)})),overviewRulerLanes:Le(new h(82,"overviewRulerLanes",3,0,3)),padding:Le(new te),pasteAs:Le(new et),parameterHints:Le(new re),peekWidgetDefaultFocus:Le(new a(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(283,null),m.localize(284,null)],description:m.localize(285,null)})),definitionLinkOpensInPeek:Le(new s(87,"definitionLinkOpensInPeek",!1,{description:m.localize(286,null)})),quickSuggestions:Le(new Ee),quickSuggestionsDelay:Le(new h(89,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(287,null)})),readOnly:Le(new s(90,"readOnly",!1)),readOnlyMessage:Le(new be),renameOnType:Le(new s(92,"renameOnType",!1,{description:m.localize(288,null),markdownDeprecationMessage:m.localize(289,null)})),renderControlCharacters:Le(new s(93,"renderControlCharacters",!0,{description:m.localize(290,null),restricted:!0})),renderFinalNewline:Le(new a(94,"renderFinalNewline",g.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(291,null)})),renderLineHighlight:Le(new a(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(292,null)],description:m.localize(293,null)})),renderLineHighlightOnlyWhenFocus:Le(new s(96,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(294,null)})),renderValidationDecorations:Le(new a(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new a(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(295,null),m.localize(296,null),m.localize(297,null),""],description:m.localize(298,null)})),revealHorizontalRightPadding:Le(new h(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new s(100,"roundedSelection",!0,{description:m.localize(299,null)})),rulers:Le(new le),scrollbar:Le(new B),scrollBeyondLastColumn:Le(new h(103,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(300,null)})),scrollBeyondLastLine:Le(new s(104,"scrollBeyondLastLine",!0,{description:m.localize(301,null)})),scrollPredominantAxis:Le(new s(105,"scrollPredominantAxis",!0,{description:m.localize(302,null)})),selectionClipboard:Le(new s(106,"selectionClipboard",!0,{description:m.localize(303,null),included:g.$k})),selectionHighlight:Le(new s(107,"selectionHighlight",!0,{description:m.localize(304,null)})),selectOnLineNumbers:Le(new s(108,"selectOnLineNumbers",!0)),showFoldingControls:Le(new a(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(305,null),m.localize(306,null),m.localize(307,null)],description:m.localize(308,null)})),showUnused:Le(new s(110,"showUnused",!0,{description:m.localize(309,null)})),showDeprecated:Le(new s(138,"showDeprecated",!0,{description:m.localize(310,null)})),inlayHints:Le(new we),snippetSuggestions:Le(new a(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(311,null),m.localize(312,null),m.localize(313,null),m.localize(314,null)],description:m.localize(315,null)})),smartSelect:Le(new je),smoothScrolling:Le(new s(113,"smoothScrolling",!1,{description:m.localize(316,null)})),stopRenderingLineAfter:Le(new h(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new ye),inlineSuggest:Le(new ie),inlineCompletionsAccessibilityVerbose:Le(new s(147,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(317,null)})),suggestFontSize:Le(new h(118,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new h(119,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new s(120,"suggestOnTriggerCharacters",!0,{description:m.localize(320,null)})),suggestSelection:Le(new a(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(321,null),m.localize(322,null),m.localize(323,null)],description:m.localize(324,null)})),tabCompletion:Le(new a(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(325,null),m.localize(326,null),m.localize(327,null)],description:m.localize(328,null)})),tabIndex:Le(new h(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new Q),unusualLineTerminators:Le(new a(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(329,null),m.localize(330,null),m.localize(331,null)],description:m.localize(332,null)})),useShadowDOM:Le(new s(126,"useShadowDOM",!0)),useTabStops:Le(new s(127,"useTabStops",!0,{description:m.localize(333,null)})),wordBreak:Le(new a(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(334,null),m.localize(335,null)],description:m.localize(336,null)})),wordSeparators:Le(new t(129,"wordSeparators",R.$Vr,{description:m.localize(337,null)})),wordWrap:Le(new a(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(338,null),m.localize(339,null),m.localize(340,null),m.localize(341,null)],description:m.localize(342,null)})),wordWrapBreakAfterCharacters:Le(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new h(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(343,null)})),wordWrapOverride1:Le(new a(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new a(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new N),defaultColorDecorators:Le(new s(145,"defaultColorDecorators",!1,{markdownDescription:m.localize(344,null)})),pixelRatio:Le(new ne),tabFocusMode:Le(new s(142,"tabFocusMode",!1,{markdownDescription:m.localize(345,null)})),layoutInfo:Le(new V),wrappingInfo:Le(new Ye),wrappingIndent:Le(new _e),wrappingStrategy:Le(new x)}}),define(Se[187],De([10,11]),function($e,e){return $e.create("vs/editor/common/languages",e)}),define(Se[83],De([1,0,79,2,164,34,174,187]),function($e,e,D,M,g,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$bt=e.$at=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$_s=e.$$s=e.SymbolKinds=e.SymbolTag=e.$0s=e.$9s=e.SymbolKind=e.$8s=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$7s=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$6s=e.$5s=e.$4s=void 0;class k{constructor(j,z,T){this.offset=j,this.type=z,this.language=T,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$4s=k;class b{constructor(j,z){this.tokens=j,this.endState=z,this._tokenizationResultBrand=void 0}}e.$5s=b;class P{constructor(j,z){this.tokens=j,this.endState=z,this._encodedTokenizationResultBrand=void 0}}e.$6s=P;var I;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var p;(function(F){const j=new Map;j.set(0,D.$Pj.symbolMethod),j.set(1,D.$Pj.symbolFunction),j.set(2,D.$Pj.symbolConstructor),j.set(3,D.$Pj.symbolField),j.set(4,D.$Pj.symbolVariable),j.set(5,D.$Pj.symbolClass),j.set(6,D.$Pj.symbolStruct),j.set(7,D.$Pj.symbolInterface),j.set(8,D.$Pj.symbolModule),j.set(9,D.$Pj.symbolProperty),j.set(10,D.$Pj.symbolEvent),j.set(11,D.$Pj.symbolOperator),j.set(12,D.$Pj.symbolUnit),j.set(13,D.$Pj.symbolValue),j.set(15,D.$Pj.symbolEnum),j.set(14,D.$Pj.symbolConstant),j.set(15,D.$Pj.symbolEnum),j.set(16,D.$Pj.symbolEnumMember),j.set(17,D.$Pj.symbolKeyword),j.set(27,D.$Pj.symbolSnippet),j.set(18,D.$Pj.symbolText),j.set(19,D.$Pj.symbolColor),j.set(20,D.$Pj.symbolFile),j.set(21,D.$Pj.symbolReference),j.set(22,D.$Pj.symbolCustomColor),j.set(23,D.$Pj.symbolFolder),j.set(24,D.$Pj.symbolTypeParameter),j.set(25,D.$Pj.account),j.set(26,D.$Pj.issues);function z(q){let me=j.get(q);return me||(console.info("No codicon found for CompletionItemKind "+q),me=D.$Pj.symbolProperty),me}F.toIcon=z;const T=new Map;T.set("method",0),T.set("function",1),T.set("constructor",2),T.set("field",3),T.set("variable",4),T.set("class",5),T.set("struct",6),T.set("interface",7),T.set("module",8),T.set("property",9),T.set("event",10),T.set("operator",11),T.set("unit",12),T.set("value",13),T.set("constant",14),T.set("enum",15),T.set("enum-member",16),T.set("enumMember",16),T.set("keyword",17),T.set("snippet",27),T.set("text",18),T.set("color",19),T.set("file",20),T.set("reference",21),T.set("customcolor",22),T.set("folder",23),T.set("type-parameter",24),T.set("typeParameter",24),T.set("account",25),T.set("issue",26);function H(q,me){let X=T.get(q);return typeof X>"u"&&!me&&(X=9),X}F.fromString=H})(p||(e.CompletionItemKinds=p={}));var S;(function(F){F[F.Deprecated=1]="Deprecated"})(S||(e.CompletionItemTag=S={}));var C;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(C||(e.CompletionItemInsertTextRule=C={}));var v;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v||(e.CompletionTriggerKind=v={}));var o;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})(o||(e.InlineCompletionTriggerKind=o={}));class s{constructor(j,z,T,H){this.range=j,this.text=z,this.completionKind=T,this.isSnippetText=H}equals(j){return L.$ks.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}e.$7s=s;var n;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(n||(e.CodeActionTriggerType=n={}));var h;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(h||(e.SignatureHelpTriggerKind=h={}));var $;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})($||(e.DocumentHighlightKind=$={}));function d(F){return F&&M.URI.isUri(F.uri)&&L.$ks.isIRange(F.range)&&(L.$ks.isIRange(F.originSelectionRange)||L.$ks.isIRange(F.targetSelectionRange))}e.$8s=d;var t;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$9s={[17]:(0,m.localize)(0,null),[16]:(0,m.localize)(1,null),[4]:(0,m.localize)(2,null),[13]:(0,m.localize)(3,null),[8]:(0,m.localize)(4,null),[9]:(0,m.localize)(5,null),[21]:(0,m.localize)(6,null),[23]:(0,m.localize)(7,null),[7]:(0,m.localize)(8,null),[0]:(0,m.localize)(9,null),[11]:(0,m.localize)(10,null),[10]:(0,m.localize)(11,null),[19]:(0,m.localize)(12,null),[5]:(0,m.localize)(13,null),[1]:(0,m.localize)(14,null),[2]:(0,m.localize)(15,null),[20]:(0,m.localize)(16,null),[15]:(0,m.localize)(17,null),[18]:(0,m.localize)(18,null),[24]:(0,m.localize)(19,null),[3]:(0,m.localize)(20,null),[6]:(0,m.localize)(21,null),[14]:(0,m.localize)(22,null),[22]:(0,m.localize)(23,null),[25]:(0,m.localize)(24,null),[12]:(0,m.localize)(25,null)};function r(F,j){return(0,m.localize)(26,null,F,e.$9s[j])}e.$0s=r;var a;(function(F){F[F.Deprecated=1]="Deprecated"})(a||(e.SymbolTag=a={}));var i;(function(F){const j=new Map;j.set(0,D.$Pj.symbolFile),j.set(1,D.$Pj.symbolModule),j.set(2,D.$Pj.symbolNamespace),j.set(3,D.$Pj.symbolPackage),j.set(4,D.$Pj.symbolClass),j.set(5,D.$Pj.symbolMethod),j.set(6,D.$Pj.symbolProperty),j.set(7,D.$Pj.symbolField),j.set(8,D.$Pj.symbolConstructor),j.set(9,D.$Pj.symbolEnum),j.set(10,D.$Pj.symbolInterface),j.set(11,D.$Pj.symbolFunction),j.set(12,D.$Pj.symbolVariable),j.set(13,D.$Pj.symbolConstant),j.set(14,D.$Pj.symbolString),j.set(15,D.$Pj.symbolNumber),j.set(16,D.$Pj.symbolBoolean),j.set(17,D.$Pj.symbolArray),j.set(18,D.$Pj.symbolObject),j.set(19,D.$Pj.symbolKey),j.set(20,D.$Pj.symbolNull),j.set(21,D.$Pj.symbolEnumMember),j.set(22,D.$Pj.symbolStruct),j.set(23,D.$Pj.symbolEvent),j.set(24,D.$Pj.symbolOperator),j.set(25,D.$Pj.symbolTypeParameter);function z(T){let H=j.get(T);return H||(console.info("No codicon found for SymbolKind "+T),H=D.$Pj.symbolProperty),H}F.toIcon=z})(i||(e.SymbolKinds=i={}));class c{static asEditOperation(j){return g.$ls.replace(L.$ks.lift(j.range),j.text)}}e.$$s=c;class f{static{this.Comment=new f("comment")}static{this.Imports=new f("imports")}static{this.Region=new f("region")}static fromValue(j){switch(j){case"comment":return f.Comment;case"imports":return f.Imports;case"region":return f.Region}return new f(j)}constructor(j){this.value=j}}e.$_s=f;var y;(function(F){function j(z){return!z||typeof z!="object"?!1:typeof z.id=="string"&&typeof z.title=="string"}F.is=j})(y||(e.Command=y={}));var E;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(E||(e.CommentThreadCollapsibleState=E={}));var u;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(u||(e.CommentThreadState=u={}));var l;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(l||(e.CommentMode=l={}));var w;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(w||(e.CommentState=w={}));var A;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(A||(e.InlayHintKind=A={}));class N{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$at=N,e.$bt=new R.$Vs;var O;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(O||(e.ExternalUriOpenerPriority=O={}))}),define(Se[188],De([10,11]),function($e,e){return $e.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[189],De([10,11]),function($e,e){return $e.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[190],De([10,11]),function($e,e){return $e.create("vs/platform/contextkey/common/scanner",e)}),define(Se[191],De([10,11]),function($e,e){return $e.create("vs/platform/dialogs/common/dialogs",e)}),define(Se[192],De([10,11]),function($e,e){return $e.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[193],De([10,11]),function($e,e){return $e.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[194],De([10,11]),function($e,e){return $e.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[195],De([10,11]),function($e,e){return $e.create("vs/platform/files/common/files",e)}),define(Se[196],De([10,11]),function($e,e){return $e.create("vs/platform/files/common/io",e)}),define(Se[197],De([10,11]),function($e,e){return $e.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Se[198],De([10,11]),function($e,e){return $e.create("vs/platform/markers/common/markers",e)}),define(Se[199],De([10,11]),function($e,e){return $e.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[200],De([10,11]),function($e,e){return $e.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[201],De([10,11]),function($e,e){return $e.create("vs/platform/workspace/common/workspace",e)}),define(Se[202],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostChat",e)}),define(Se[203],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[204],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[205],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[206],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[207],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[208],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostProgress",e)}),define(Se[209],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[210],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[211],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[212],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[213],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[214],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[215],De([10,11]),function($e,e){return $e.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[216],De([10,11]),function($e,e){return $e.create("vs/workbench/common/editor",e)}),define(Se[217],De([10,11]),function($e,e){return $e.create("vs/workbench/common/views",e)}),define(Se[218],De([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[219],De([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[220],De([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[221],De([10,11]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[222],De([10,11]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[223],De([10,11]),function($e,e){return $e.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[224],De([10,11]),function($e,e){return $e.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[225],De([10,11]),function($e,e){return $e.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Se[226],De([10,11]),function($e,e){return $e.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[227],De([1,0,8,190]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.TokenType=void 0;var g;(function(b){b[b.LParen=0]="LParen",b[b.RParen=1]="RParen",b[b.Neg=2]="Neg",b[b.Eq=3]="Eq",b[b.NotEq=4]="NotEq",b[b.Lt=5]="Lt",b[b.LtEq=6]="LtEq",b[b.Gt=7]="Gt",b[b.GtEq=8]="GtEq",b[b.RegexOp=9]="RegexOp",b[b.RegexStr=10]="RegexStr",b[b.True=11]="True",b[b.False=12]="False",b[b.In=13]="In",b[b.Not=14]="Not",b[b.And=15]="And",b[b.Or=16]="Or",b[b.Str=17]="Str",b[b.QuotedStr=18]="QuotedStr",b[b.Error=19]="Error",b[b.EOF=20]="EOF"})(g||(e.TokenType=g={}));function L(...b){switch(b.length){case 1:return(0,M.localize)(0,null,b[0]);case 2:return(0,M.localize)(1,null,b[0],b[1]);case 3:return(0,M.localize)(2,null,b[0],b[1],b[2]);default:return}}const R=(0,M.localize)(3,null),m=(0,M.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,D.$6)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const I=this.d,p=this.c.substring(this.d,this.e),S={type:19,offset:this.d,lexeme:p};this.g.push({offset:I,lexeme:p,additionalInfo:P}),this.f.push(S)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const I=this.c.substring(this.d,this.e),p=k.b.get(I);p?this.k(p):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,I=!1,p=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(m);return}const C=this.c.charCodeAt(P);if(I)I=!1;else if(C===47&&!p){P++;break}else C===91?p=!0:C===92?I=!0:C===93&&(p=!1);P++}for(;P<this.c.length&&k.a.has(this.c.charCodeAt(P));)P++;this.e=P;const S=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:S,offset:this.d})}r(){return this.e>=this.c.length}}e.$Fi=k}),define(Se[228],De([1,0,24,38,193,372]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function k(s){return s=s.trim(),s==="*"||R.test(s)}e.$Bo=k;function b(s){if(!k(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=s.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$Co=b;function P(s){if(!s)return null;const n=s.majorBase,h=s.majorMustEqual,$=s.minorBase;let d=s.minorMustEqual;const t=s.patchBase;let r=s.patchMustEqual;s.hasCaret&&(n===0||(d=!1),r=!1);let a=0;if(s.preRelease){const i=m.exec(s.preRelease);if(i){const[,c,f,y]=i;a=Date.UTC(Number(c),Number(f)-1,Number(y))}}return{majorBase:n,majorMustEqual:h,minorBase:$,minorMustEqual:d,patchBase:t,patchMustEqual:r,isMinimum:s.hasGreaterEquals,notBefore:a}}e.$Do=P;function I(s,n,h){let $;typeof s=="string"?$=P(b(s)):$=s;let d;n instanceof Date?d=n.getTime():typeof n=="string"&&(d=new Date(n).getTime());let t;if(typeof h=="string"?t=P(b(h)):t=h,!$||!t)return!1;const r=$.majorBase,a=$.minorBase,i=$.patchBase;let c=t.majorBase,f=t.minorBase,y=t.patchBase;const E=t.notBefore;let u=t.majorMustEqual,l=t.minorMustEqual,w=t.patchMustEqual;return t.isMinimum?r>c?!0:r<c?!1:a>f?!0:a<f||d&&d<E?!1:i>=y:(r===1&&c===0&&(!u||!l||!w)&&(c=1,f=0,y=0,u=!0,l=!1,w=!1),r<c?!1:r>c?!u:a<f?!1:a>f?!l:i<y?!1:i>y?!w:!(d&&d<E))}e.$Eo=I;function p(s,n,h,$,d){const t=[];if(typeof $.publisher<"u"&&typeof $.publisher!="string")return t.push([M.default.Error,g.localize(0,null)]),t;if(typeof $.name!="string")return t.push([M.default.Error,g.localize(1,null,"name")]),t;if(typeof $.version!="string")return t.push([M.default.Error,g.localize(2,null,"version")]),t;if(!$.engines)return t.push([M.default.Error,g.localize(3,null,"engines")]),t;if(typeof $.engines.vscode!="string")return t.push([M.default.Error,g.localize(4,null,"engines.vscode")]),t;if(typeof $.extensionDependencies<"u"&&!o($.extensionDependencies))return t.push([M.default.Error,g.localize(5,null,"extensionDependencies")]),t;if(typeof $.activationEvents<"u"){if(!o($.activationEvents))return t.push([M.default.Error,g.localize(6,null,"activationEvents")]),t;if(typeof $.main>"u"&&typeof $.browser>"u")return t.push([M.default.Error,g.localize(7,null,"activationEvents","main","browser")]),t}if(typeof $.extensionKind<"u"&&typeof $.main>"u"&&t.push([M.default.Warning,g.localize(8,null,"extensionKind")]),typeof $.main<"u"){if(typeof $.main!="string")return t.push([M.default.Error,g.localize(9,null,"main")]),t;{const i=(0,D.$ig)(h,$.main);(0,D.$cg)(i,h)||t.push([M.default.Warning,g.localize(10,null,i.path,h.path)])}}if(typeof $.browser<"u"){if(typeof $.browser!="string")return t.push([M.default.Error,g.localize(11,null,"browser")]),t;{const i=(0,D.$ig)(h,$.browser);(0,D.$cg)(i,h)||t.push([M.default.Warning,g.localize(12,null,i.path,h.path)])}}if(!L.valid($.version))return t.push([M.default.Error,g.localize(13,null)]),t;const r=[];if(!S(s,n,$,d,r))for(const i of r)t.push([M.default.Error,i]);return t}e.$Fo=p;function S(s,n,h,$,d){return $||typeof h.main>"u"&&typeof h.browser>"u"?!0:v(s,n,h.engines.vscode,d)}e.$Go=S;function C(s,n,h){return s==="*"||v(n,h,s)}e.$Ho=C;function v(s,n,h,$=[]){const d=P(b(h));if(!d)return $.push(g.localize(14,null,h)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return $.push(g.localize(15,null,h)),!1}else if(!d.majorMustEqual)return $.push(g.localize(16,null,h)),!1;return I(s,n,d)?!0:($.push(g.localize(17,null,s,h)),!1)}function o(s){if(!Array.isArray(s))return!1;for(let n=0,h=s.length;n<h;n++)if(typeof s[n]!="string")return!1;return!0}}),define(Se[103],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=void 0;class D{constructor(g,L=[],R=!1){this.ctor=g,this.staticArguments=L,this.supportsDelayedInstantiation=R}}e.$yh=D}),define(Se[104],De([1,0,103]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.InstantiationType=void 0;const M=[];var g;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(g||(e.InstantiationType=g={}));function L(m,k,b){k instanceof D.$yh||(k=new D.$yh(k,[],!!b)),M.push([m,k])}e.$mr=L;function R(){return M}e.$nr=R}),define(Se[229],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0;class D{constructor(L,R){this.key=L,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$4p=D;class M{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const R of this.a.values())R.outgoing.size===0&&L.push(R);return L}insertEdge(L,R){const m=this.lookupOrInsertNode(L),k=this.lookupOrInsertNode(R);m.outgoing.set(k.key,k),k.incoming.set(m.key,m)}removeNode(L){const R=this.b(L);this.a.delete(R);for(const m of this.a.values())m.outgoing.delete(R),m.incoming.delete(R)}lookupOrInsertNode(L){const R=this.b(L);let m=this.a.get(R);return m||(m=new D(R,L),this.a.set(R,m)),m}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[R,m]of this.a)L.push(`${R}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,R]of this.a){const m=new Set([L]),k=this.c(R,m);if(k)return k}}c(L,R){for(const[m,k]of L.outgoing){if(R.has(m))return[...R,m].join(" -> ");R.add(m);const b=this.c(k,R);if(b)return b;R.delete(m)}}}e.$5p=M}),define(Se[5],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=e._util=void 0;var D;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function m(k){return k[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=m})(D||(e._util=D={})),e.$Ah=g("instantiationService");function M(R,m,k){m[D.DI_TARGET]===m?m[D.DI_DEPENDENCIES].push({id:R,index:k}):(m[D.DI_DEPENDENCIES]=[{id:R,index:k}],m[D.DI_TARGET]=m)}function g(R){if(D.serviceIds.has(R))return D.serviceIds.get(R);const m=function(k,b,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(m,k,P)};return m.toString=()=>R,D.serviceIds.set(R,m),m}e.$Bh=g;function L(R){return R}e.$Ch=L}),define(Se[49],De([1,0,18,2,5]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.ConfigurationTarget=e.$0h=e.$9h=e.$8h=void 0,e.$8h=(0,g.$Bh)("configurationService");function L(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof M.URI)}e.$9h=L;function R(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof M.URI)}e.$0h=R;var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function k(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$$h=k;function b(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.$_h=b;function P(s,n){const h=Object.create(null);for(const $ in s)I(h,$,s[$],n);return h}e.$ai=P;function I(s,n,h,$){const d=n.split("."),t=d.pop();let r=s;for(let a=0;a<d.length;a++){const i=d[a];let c=r[i];switch(typeof c){case"undefined":c=r[i]=Object.create(null);break;case"object":break;default:$(`Ignoring ${n} as ${d.slice(0,a+1).join(".")} is ${JSON.stringify(c)}`);return}r=c}if(typeof r=="object"&&r!==null)try{r[t]=h}catch{$(`Ignoring ${n} as ${d.join(".")} is ${JSON.stringify(r)}`)}else $(`Ignoring ${n} as ${d.join(".")} is ${JSON.stringify(r)}`)}e.$bi=I;function p(s,n){const h=n.split(".");S(s,h)}e.$ci=p;function S(s,n){const h=n.shift();if(n.length===0){delete s[h];return}if(Object.keys(s).indexOf(h)!==-1){const $=s[h];typeof $=="object"&&!Array.isArray($)&&(S($,n),Object.keys($).length===0&&delete s[h])}}function C(s,n,h){function $(r,a){let i=r;for(const c of a){if(typeof i!="object"||i===null)return;i=i[c]}return i}const d=n.split("."),t=$(s,d);return typeof t>"u"?h:t}e.$di=C;function v(s,n,h){Object.keys(n).forEach($=>{$!=="__proto__"&&($ in s?D.$lf(s[$])&&D.$lf(n[$])?v(s[$],n[$],h):h&&(s[$]=n[$]):s[$]=n[$])})}e.$ei=v;function o(s){return s.replace(/[\[\]]/g,"")}e.$fi=o}),define(Se[41],De([1,0,12,15,227,5,189,8]),function($e,e,D,M,g,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.ContextKeyExprType=e.$Gi=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",D.$j),k.set("isLinux",D.$k),k.set("isWindows",D.$i),k.set("isWeb",D.$o),k.set("isMacNative",D.$j&&!D.$o),k.set("isEdge",D.$G),k.set("isFirefox",D.$E),k.set("isChrome",D.$D),k.set("isSafari",D.$F);function b(G,U){if(k.get(G)!==void 0)throw(0,m.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(G,U)}e.$Gi=b;const P=Object.prototype.hasOwnProperty;var I;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const p={regexParsingWithErrorRecovery:!0},S=(0,R.localize)(0,null),C=(0,R.localize)(1,null),v=(0,R.localize)(2,null),o=(0,R.localize)(3,null),s=(0,R.localize)(4,null),n=(0,R.localize)(5,null),h=(0,R.localize)(6,null),$=(0,R.localize)(7,null);class d{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=p){this.k=U,this.d=new g.$Fi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:S,offset:0,lexeme:"",additionalInfo:C});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const K=this.l();if(!this.E()){const fe=this.D(),te=fe.type===17?n:void 0;throw this.h.push({message:s,offset:fe.offset,lexeme:g.$Fi.getLexeme(fe),additionalInfo:te}),d.c}return K}catch(K){if(K!==d.c)throw K;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const K=this.o();U.push(K)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const K=this.s();U.push(K)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),c.INSTANCE;case 12:return this.z(),f.INSTANCE;case 0:{this.z();const K=this.l();return this.A(1,o),K?.negate()}case 17:return this.z(),A.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const K=this.l();return this.A(1,o),K}case 17:{const K=U.lexeme;if(this.z(),this.y(9)){const te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),te.type!==10)throw this.B("REGEX",te);const re=te.lexeme,ne=re.lastIndexOf("/"),Ee=ne===re.length-1?void 0:this.w(re.substring(ne+1));let oe;try{oe=new RegExp(re.substring(1,ne),Ee)}catch{throw this.B("REGEX",te)}return T.create(K,oe)}switch(te.type){case 10:case 19:{const re=[te.lexeme];this.z();let ne=this.D(),Ee=0;for(let be=0;be<te.lexeme.length;be++)te.lexeme.charCodeAt(be)===40?Ee++:te.lexeme.charCodeAt(be)===41&&Ee--;for(;!this.E()&&ne.type!==15&&ne.type!==16;){switch(ne.type){case 0:Ee++;break;case 1:Ee--;break;case 10:case 18:for(let be=0;be<ne.lexeme.length;be++)ne.lexeme.charCodeAt(be)===40?Ee++:te.lexeme.charCodeAt(be)===41&&Ee--}if(Ee<0)break;re.push(g.$Fi.getLexeme(ne)),this.z(),ne=this.D()}const oe=re.join(""),he=oe.lastIndexOf("/"),ee=he===oe.length-1?void 0:this.w(oe.substring(he+1));let le;try{le=new RegExp(oe.substring(1,he),ee)}catch{throw this.B("REGEX",te)}return t.regex(K,le)}case 18:{const re=te.lexeme;this.z();let ne=null;if(!(0,M.$me)(re)){const Ee=re.indexOf("/"),oe=re.lastIndexOf("/");if(Ee!==oe&&Ee>=0){const he=re.slice(Ee+1,oe),ee=re[oe+1]==="i"?"i":"";try{ne=new RegExp(he,ee)}catch{throw this.B("REGEX",te)}}}if(ne===null)throw this.B("REGEX",te);return T.create(K,ne)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const te=this.u();return t.notIn(K,te)}switch(this.D().type){case 3:{this.z();const te=this.u();if(this.x().type===18)return t.equals(K,te);switch(te){case"true":return t.has(K);case"false":return t.not(K);default:return t.equals(K,te)}}case 4:{this.z();const te=this.u();if(this.x().type===18)return t.notEquals(K,te);switch(te){case"true":return t.not(K);case"false":return t.has(K);default:return t.notEquals(K,te)}}case 5:return this.z(),j.create(K,this.u());case 6:return this.z(),z.create(K,this.u());case 7:return this.z(),O.create(K,this.u());case 8:return this.z(),F.create(K,this.u());case 13:return this.z(),t.in(K,this.u());default:return t.has(K)}}case 20:throw this.h.push({message:h,offset:U.offset,lexeme:"",additionalInfo:$}),d.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,K){if(this.C(U))return this.z();throw this.B(K,this.D())}B(U,K,fe){const te=(0,R.localize)(8,null,U,g.$Fi.getLexeme(K)),re=K.offset,ne=g.$Fi.getLexeme(K);return this.h.push({message:te,offset:re,lexeme:ne,additionalInfo:fe}),d.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Hi=d;class t{static false(){return c.INSTANCE}static true(){return f.INSTANCE}static has(U){return y.create(U)}static equals(U,K){return E.create(U,K)}static notEquals(U,K){return w.create(U,K)}static regex(U,K){return T.create(U,K)}static in(U,K){return u.create(U,K)}static notIn(U,K){return l.create(U,K)}static not(U){return A.create(U)}static and(...U){return me.create(U,null,!0)}static or(...U){return X.create(U,null,!0)}static greater(U,K){return O.create(U,K)}static greaterEquals(U,K){return F.create(U,K)}static smaller(U,K){return j.create(U,K)}static smallerEquals(U,K){return z.create(U,K)}static{this.c=new d({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Ii=t;function r(G){const U=new d({regexParsingWithErrorRecovery:!1});return G.map(K=>(U.parse(K),U.lexingErrors.length>0?U.lexingErrors.map(fe=>({errorMessage:fe.additionalInfo?(0,R.localize)(9,null,fe.additionalInfo):(0,R.localize)(10,null),offset:fe.offset,length:fe.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(fe=>({errorMessage:fe.additionalInfo?`${fe.message}. ${fe.additionalInfo}`:fe.message,offset:fe.offset,length:fe.lexeme.length})):[]))}e.$Ji=r;function a(G,U){const K=G?G.substituteConstants():void 0,fe=U?U.substituteConstants():void 0;return!K&&!fe?!0:!K||!fe?!1:K.equals(fe)}e.$Ki=a;function i(G,U){return G.cmp(U)}class c{static{this.INSTANCE=new c}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return f.INSTANCE}}e.$Li=c;class f{static{this.INSTANCE=new f}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return c.INSTANCE}}e.$Mi=f;class y{static create(U,K=null){const fe=k.get(U);return typeof fe=="boolean"?fe?f.INSTANCE:c.INSTANCE:new y(U,K)}constructor(U,K){this.key=U,this.c=K,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:V(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=k.get(this.key);return typeof U=="boolean"?U?f.INSTANCE:c.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=A.create(this.key,this)),this.c}}e.$Ni=y;class E{static create(U,K,fe=null){if(typeof K=="boolean")return K?y.create(U,fe):A.create(U,fe);const te=k.get(U);return typeof te=="boolean"?K===(te?"true":"false")?f.INSTANCE:c.INSTANCE:new E(U,K,fe)}constructor(U,K,fe){this.c=U,this.d=K,this.f=fe,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:x(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=k.get(this.c);if(typeof U=="boolean"){const K=U?"true":"false";return this.d===K?f.INSTANCE:c.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Oi=E;class u{static create(U,K){return new u(U,K)}constructor(U,K){this.d=U,this.f=K,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:x(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const K=U.getValue(this.f),fe=U.getValue(this.d);return Array.isArray(K)?K.includes(fe):typeof fe=="string"&&typeof K=="object"&&K!==null?P.call(K,fe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=l.create(this.d,this.f)),this.c}}e.$Pi=u;class l{static create(U,K){return new l(U,K)}constructor(U,K){this.d=U,this.f=K,this.type=11,this.c=u.create(U,K)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Qi=l;class w{static create(U,K,fe=null){if(typeof K=="boolean")return K?A.create(U,fe):y.create(U,fe);const te=k.get(U);return typeof te=="boolean"?K===(te?"true":"false")?c.INSTANCE:f.INSTANCE:new w(U,K,fe)}constructor(U,K,fe){this.c=U,this.d=K,this.f=fe,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:x(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=k.get(this.c);if(typeof U=="boolean"){const K=U?"true":"false";return this.d===K?c.INSTANCE:f.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$Ri=w;class A{static create(U,K=null){const fe=k.get(U);return typeof fe=="boolean"?fe?c.INSTANCE:f.INSTANCE:new A(U,K)}constructor(U,K){this.c=U,this.d=K,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:V(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=k.get(this.c);return typeof U=="boolean"?U?c.INSTANCE:f.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Si=A;function N(G,U){if(typeof G=="string"){const K=parseFloat(G);isNaN(K)||(G=K)}return typeof G=="string"||typeof G=="number"?U(G):c.INSTANCE}class O{static create(U,K,fe=null){return N(K,te=>new O(U,te,fe))}constructor(U,K,fe){this.c=U,this.d=K,this.f=fe,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:x(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Ti=O;class F{static create(U,K,fe=null){return N(K,te=>new F(U,te,fe))}constructor(U,K,fe){this.c=U,this.d=K,this.f=fe,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:x(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Ui=F;class j{static create(U,K,fe=null){return N(K,te=>new j(U,te,fe))}constructor(U,K,fe){this.c=U,this.d=K,this.f=fe,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:x(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Vi=j;class z{static create(U,K,fe=null){return N(K,te=>new z(U,te,fe))}constructor(U,K,fe){this.c=U,this.d=K,this.f=fe,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:x(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Wi=z;class T{static create(U,K){return new T(U,K)}constructor(U,K){this.d=U,this.f=K,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const K=this.f?this.f.source:"",fe=U.f?U.f.source:"";return K<fe?-1:K>fe?1:0}equals(U){if(U.type===this.type){const K=this.f?this.f.source:"",fe=U.f?U.f.source:"";return this.d===U.d&&K===fe}return!1}substituteConstants(){return this}evaluate(U){const K=U.getValue(this.d);return this.f?this.f.test(K):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=H.create(this)),this.c}}e.$Xi=T;class H{static create(U){return new H(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new H(this.c.map(U))}negate(){return this.c}}e.$Yi=H;function q(G){let U=null;for(let K=0,fe=G.length;K<fe;K++){const te=G[K].substituteConstants();if(G[K]!==te&&U===null){U=[];for(let re=0;re<K;re++)U[re]=G[re]}U!==null&&(U[K]=te)}return U===null?G:U}class me{static create(U,K,fe){return me.d(U,K,fe)}constructor(U,K){this.expr=U,this.c=K,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let K=0,fe=this.expr.length;K<fe;K++){const te=i(this.expr[K],U.expr[K]);if(te!==0)return te}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let K=0,fe=this.expr.length;K<fe;K++)if(!this.expr[K].equals(U.expr[K]))return!1;return!0}return!1}substituteConstants(){const U=q(this.expr);return U===this.expr?this:me.create(U,this.c,!1)}evaluate(U){for(let K=0,fe=this.expr.length;K<fe;K++)if(!this.expr[K].evaluate(U))return!1;return!0}static d(U,K,fe){const te=[];let re=!1;for(const ne of U)if(ne){if(ne.type===1){re=!0;continue}if(ne.type===0)return c.INSTANCE;if(ne.type===6){te.push(...ne.expr);continue}te.push(ne)}if(te.length===0&&re)return f.INSTANCE;if(te.length!==0){if(te.length===1)return te[0];te.sort(i);for(let ne=1;ne<te.length;ne++)te[ne-1].equals(te[ne])&&(te.splice(ne,1),ne--);if(te.length===1)return te[0];for(;te.length>1;){const ne=te[te.length-1];if(ne.type!==9)break;te.pop();const Ee=te.pop(),oe=te.length===0,he=X.create(ne.expr.map(ee=>me.create([ee,Ee],null,fe)),null,oe);he&&(te.push(he),te.sort(i))}if(te.length===1)return te[0];if(fe){for(let ne=0;ne<te.length;ne++)for(let Ee=ne+1;Ee<te.length;Ee++)if(te[ne].negate().equals(te[Ee]))return c.INSTANCE;if(te.length===1)return te[0]}return new me(te,K)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const K of this.expr)U.push(...K.keys());return U}map(U){return new me(this.expr.map(K=>K.map(U)),null)}negate(){if(!this.c){const U=[];for(const K of this.expr)U.push(K.negate());this.c=X.create(U,this,!0)}return this.c}}e.$Zi=me;class X{static create(U,K,fe){return X.d(U,K,fe)}constructor(U,K){this.expr=U,this.c=K,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let K=0,fe=this.expr.length;K<fe;K++){const te=i(this.expr[K],U.expr[K]);if(te!==0)return te}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let K=0,fe=this.expr.length;K<fe;K++)if(!this.expr[K].equals(U.expr[K]))return!1;return!0}return!1}substituteConstants(){const U=q(this.expr);return U===this.expr?this:X.create(U,this.c,!1)}evaluate(U){for(let K=0,fe=this.expr.length;K<fe;K++)if(this.expr[K].evaluate(U))return!0;return!1}static d(U,K,fe){let te=[],re=!1;if(U){for(let ne=0,Ee=U.length;ne<Ee;ne++){const oe=U[ne];if(oe){if(oe.type===0){re=!0;continue}if(oe.type===1)return f.INSTANCE;if(oe.type===9){te=te.concat(oe.expr);continue}te.push(oe)}}if(te.length===0&&re)return c.INSTANCE;te.sort(i)}if(te.length!==0){if(te.length===1)return te[0];for(let ne=1;ne<te.length;ne++)te[ne-1].equals(te[ne])&&(te.splice(ne,1),ne--);if(te.length===1)return te[0];if(fe){for(let ne=0;ne<te.length;ne++)for(let Ee=ne+1;Ee<te.length;Ee++)if(te[ne].negate().equals(te[Ee]))return f.INSTANCE;if(te.length===1)return te[0]}return new X(te,K)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const K of this.expr)U.push(...K.keys());return U}map(U){return new X(this.expr.map(K=>K.map(U)),null)}negate(){if(!this.c){const U=[];for(const K of this.expr)U.push(K.negate());for(;U.length>1;){const K=U.shift(),fe=U.shift(),te=[];for(const re of we(K))for(const ne of we(fe))te.push(me.create([re,ne],null,!1));U.unshift(X.create(te,null,!1))}this.c=X.create(U,this,!0)}return this.c}}e.$1i=X;class Z extends y{static{this.d=[]}static all(){return Z.d.values()}constructor(U,K,fe){super(U,null),this.f=K,typeof fe=="object"?Z.d.push({...fe,key:U}):fe!==!0&&Z.d.push({key:U,description:fe,type:K!=null?typeof K:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return E.create(this.key,U)}notEqualsTo(U){return w.create(this.key,U)}}e.$2i=Z,e.$3i=(0,L.$Bh)("contextKeyService");function V(G,U){return G<U?-1:G>U?1:0}function x(G,U,K,fe){return G<K?-1:G>K?1:U<fe?-1:U>fe?1:0}function ge(G,U){if(G.type===0||U.type===1)return!0;if(G.type===9)return U.type===9?ue(G.expr,U.expr):!1;if(U.type===9){for(const K of U.expr)if(ge(G,K))return!0;return!1}if(G.type===6){if(U.type===6)return ue(U.expr,G.expr);for(const K of G.expr)if(ge(K,U))return!0;return!1}return G.equals(U)}e.$4i=ge;function ue(G,U){let K=0,fe=0;for(;K<G.length&&fe<U.length;){const te=G[K].cmp(U[fe]);if(te<0)return!1;te===0&&K++,fe++}return K===G.length}function we(G){return G.type===9?G.expr:[G]}}),define(Se[230],De([1,0,24,38,191,5,100,12,23]),function($e,e,D,M,g,L,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sA=e.$rA=e.ConfirmResult=e.$qA=e.$pA=e.$oA=void 0,e.$oA=(0,L.$Bh)("dialogService");var b;(function(v){v[v.Confirmation=1]="Confirmation",v[v.Prompt=2]="Prompt",v[v.Input=3]="Input"})(b||(b={}));class P{a(o){return this.d(o,b.Confirmation)}b(o){return this.d(o,b.Prompt)}c(o){return this.d(o,b.Input)}d(o,s){const n=[];switch(s){case b.Confirmation:{const h=o;h.primaryButton?n.push(h.primaryButton):n.push((0,g.localize)(0,null)),h.cancelButton?n.push(h.cancelButton):n.push((0,g.localize)(1,null));break}case b.Prompt:{const h=o;Array.isArray(h.buttons)&&h.buttons.length>0&&n.push(...h.buttons.map($=>$.label)),h.cancelButton&&(h.cancelButton===!0?n.push((0,g.localize)(2,null)):typeof h.cancelButton=="string"?n.push(h.cancelButton):h.cancelButton.label?n.push(h.cancelButton.label):n.push((0,g.localize)(3,null))),n.length===0&&n.push((0,g.localize)(4,null));break}case b.Input:{const h=o;h.primaryButton?n.push(h.primaryButton):n.push((0,g.localize)(5,null)),h.cancelButton?n.push(h.cancelButton):n.push((0,g.localize)(6,null));break}}return n}e(o){if(typeof o=="string")return o;if(typeof o=="number")return o===M.default.Info?"info":o===M.default.Error?"error":o===M.default.Warning?"warning":"none"}async f(o,s,n){const h=[...o.buttons??[]];return o.cancelButton&&typeof o.cancelButton!="string"&&typeof o.cancelButton!="boolean"&&h.push(o.cancelButton),{result:await h[s]?.run({checkboxChecked:n}),checkboxChecked:n}}}e.$pA=P,e.$qA=(0,L.$Bh)("fileDialogService");var I;(function(v){v[v.SAVE=0]="SAVE",v[v.DONT_SAVE=1]="DONT_SAVE",v[v.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const p=10;function S(v){const o=[];return o.push(...v.slice(0,p).map(s=>typeof s=="string"?s:(0,D.$fg)(s))),v.length>p&&(v.length-p===1?o.push((0,g.localize)(7,null)):o.push((0,g.localize)(8,null,v.length-p))),o.push(""),o.join(`
`)}e.$rA=S;function C(v,o){const s=(0,k.$Vm)(v);let n=(s.buttons??[]).map(t=>(0,R.$lA)(t)),h=(v.buttons||[]).map((t,r)=>r),$=0,d=s.cancelId??n.length-1;if(n.length>1){const t=typeof d=="number"?n[d]:void 0;if(m.$k||m.$j){if(typeof t=="string"&&n.length>1&&d!==1){n.splice(d,1),n.splice(1,0,t);const r=h[d];h.splice(d,1),h.splice(1,0,r),d=1}m.$k&&n.length>1&&(n=n.reverse(),h=h.reverse(),$=n.length-1,typeof t=="string"&&(d=$-1))}else if(m.$i&&typeof t=="string"&&n.length>1&&d!==n.length-1){n.splice(d,1),n.push(t);const r=h[d];h.splice(d,1),h.push(r),d=n.length-1}}return s.buttons=n,s.defaultId=$,s.cancelId=d,s.noLink=!0,s.title=s.title||o.nameLong,{options:s,buttonIndeces:h}}e.$sA=C}),define(Se[131],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=void 0,e.$Ih=(0,D.$Bh)("environmentService"),e.$Jh=(0,D.$Ch)(e.$Ih)}),define(Se[132],De([1,0,192,5]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Zn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=void 0,e.$Mn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Nn=new RegExp(e.$Mn),e.$On="__web_extension",e.$Pn="skipWalkthrough",e.$Qn="extensionsSync",e.$Rn="dependecyOrPackExtensionInstall";function g(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Sn=g;function L(n){switch(n){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Tn=L;function R(n,h){switch(n){case 3:return h==="x64"?"win32-x64":h==="ia32"?"win32-ia32":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Un=R;function m(n,h){return h==="web"&&!n.includes("web")}e.$Vn=m;function k(n,h,$){return m(h,$)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===$?!0:b($).includes(n)}e.$Wn=k;function b(n){switch(n){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Xn=b;function P(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.$Yn=P;var I;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var p;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var S;(function(n){n.Install="install",n.Uninstall="uninstall"})(S||(e.StatisticType=S={}));var C;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(C||(e.InstallOperation=C={})),e.$Zn=(0,M.$Bh)("extensionGalleryService");var v;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.Extract="Extract",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var o;(function(n){n.UnknownError="UnknownError",n.PackageIsInvalidZip="PackageIsInvalidZip",n.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(o||(e.ExtensionSignaturetErrorCode=o={}));class s extends Error{constructor(h,$){super(h),this.code=$,this.name=$}}e.$1n=s,e.$2n=(0,M.$Bh)("extensionManagementService"),e.$3n="extensionsIdentifiers/disabled",e.$4n="extensionsIdentifiers/enabled",e.$5n=(0,M.$Bh)("IGlobalExtensionEnablementService"),e.$6n=(0,M.$Bh)("IExtensionTipsService"),e.$7n=(0,D.localize)(0,null),e.$8n={value:e.$7n,original:"Extensions"},e.$9n={value:(0,D.localize)(1,null),original:"Preferences"}}),define(Se[231],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fXb=e.$eXb=e.$dXb=void 0,e.$dXb=(0,D.$Bh)("externalTerminal"),e.$eXb="Terminal.app",e.$fXb=(0,D.$Bh)("externalTerminal")}),define(Se[232],De([1,0,48,17,16,12,99,29,102,194,231]),function($e,e,D,M,g,L,R,m,k,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$25b=e.$15b=e.$Z5b=void 0;const I=b.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends p{static{this.b="cmd.exe"}openTerminal($,d){return this.spawnTerminal(D,$,k.$ul(),d)}spawnTerminal($,d,t,r){const a=d.windowsExec||S.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const i=g.$ae(a,".exe").toLowerCase();if(i==="cmder")return $.spawn(a,r?[r]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return a.indexOf(" ")>=0&&c.push('""'),c.push(a),i==="wt"&&c.push("-d ."),new Promise((f,y)=>{const E=o(process),u=$.spawn(t,c,{cwd:r,env:E});u.on("error",y),u.on("exit",()=>f())})}runInTerminal($,d,t,r,a){const i="windowsExec"in a&&a.windowsExec?a.windowsExec:S.getDefaultTerminalWindows();return new Promise((c,f)=>{const y=`"${d} - ${I}"`,E=`""${t.join('" "')}" & pause"`,u=Object.assign({},o(process),r);Object.keys(u).filter(O=>u[O]===null).forEach(O=>delete u[O]);const l={cwd:d,env:u,windowsVerbatimArguments:!0};let w,A;g.$ae(i,".exe")==="wt"?(w=i,A=["-d",".",S.b,"/c",E]):(w=S.b,A=["/c","start",y,"/wait",i,"/c",E]),D.spawn(w,A,l).on("error",O=>{f(s(O))}),c(void 0)})}static getDefaultTerminalWindows(){if(!S.d){const $=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${$?"Sysnative":"System32"}\\cmd.exe`}return S.d}}e.$Z5b=S;class C extends p{static{this.b="/usr/bin/osascript"}openTerminal($,d){return this.spawnTerminal(D,$,d)}runInTerminal($,d,t,r,a){const i=a.osxExec||P.$eXb;return new Promise((c,f)=>{if(i===P.$eXb||i==="iTerm.app"){const y=i===P.$eXb?"TerminalHelper":"iTermHelper",u=[M.$2f.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`).fsPath,"-t",$||I,"-w",d];for(const A of t)u.push("-a"),u.push(A);if(r){const A=Object.assign({},o(process),r);for(const N in A){const O=A[N];O===null?(u.push("-u"),u.push(N)):(u.push("-e"),u.push(`${N}=${O}`))}}let l="";const w=D.spawn(C.b,u);w.on("error",A=>{f(s(A))}),w.stderr.on("data",A=>{l+=A.toString()}),w.on("exit",A=>{if(A===0)c(void 0);else if(l){const N=l.split(`
`,1);f(new Error(N[0]))}else f(new Error(b.localize(1,null,y,A)))})}else f(new Error(b.localize(2,null,i)))})}spawnTerminal($,d,t){const r=d.osxExec||P.$eXb;return new Promise((a,i)=>{const c=["-a",r];t&&c.push(t);const f=o(process),y=$.spawn("/usr/bin/open",c,{cwd:t,env:f});y.on("error",i),y.on("exit",()=>a())})}}e.$15b=C;class v extends p{static{this.b=b.localize(3,null)}openTerminal($,d){return this.spawnTerminal(D,$,d)}runInTerminal($,d,t,r,a){const i=a.linuxExec?Promise.resolve(a.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((c,f)=>{const y=[];i.then(E=>{E.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const u=`${n(t)}; echo; read -p "${v.b}" -n1;`;y.push(`''${u}''`);const l=Object.assign({},o(process),r);Object.keys(l).filter(O=>l[O]===null).forEach(O=>delete l[O]);const w={cwd:d,env:l};let A="";const N=D.spawn(E,y,w);N.on("error",O=>{f(s(O))}),N.stderr.on("data",O=>{A+=O.toString()}),N.on("exit",O=>{if(O===0)c(void 0);else if(A){const F=A.split(`
`,1);f(new Error(F[0]))}else f(new Error(b.localize(4,null,E,O)))})})})}static async getDefaultTerminalLinuxReady(){if(!v.d)if(!L.$k)v.d=Promise.resolve("xterm");else{const $=await m.Promises.exists("/etc/debian_version");v.d=new Promise(d=>{$?d("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?d("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?d("konsole"):process.env.COLORTERM?d(process.env.COLORTERM):process.env.TERM?d(process.env.TERM):d("xterm")})}return v.d}spawnTerminal($,d,t){const r=d.linuxExec?Promise.resolve(d.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((a,i)=>{r.then(c=>{const f=o(process),y=$.spawn(c,[],{cwd:t,env:f});y.on("error",i),y.on("exit",()=>a())})})}}e.$25b=v;function o(h){const $={...h.env};return(0,R.$sl)($),$}function s(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(b.localize(5,null,h.path)):h}function n(h){let $="";for(const d of h)d.indexOf(" ")>=0?$+='"'+d+'"':$+=d,$+=" ";return $}}),define(Se[30],De([1,0,78,16,15,18,2,195,5,12,17]),function($e,e,D,M,g,L,R,m,k,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileKind=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileOperationResult=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileChangeType=e.$kk=e.FileOperation=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.FileSystemProviderErrorCode=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$7j=e.$6j=void 0,e.$6j=(0,k.$Bh)("fileService");function I(V){return V.create===!0}e.$7j=I;var p;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var S;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(S||(e.FilePermission=S={}));var C;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})(C||(e.FileSystemProviderCapabilities=C={}));function v(V){return!!(V.capabilities&2)}e.$8j=v;function o(V){return!!(V.capabilities&8)}e.$9j=o;function s(V){return!!(V.capabilities&131072)}e.$0j=s;function n(V){return!!(V.capabilities&4)}e.$$j=n;function h(V){return!!(V.capabilities&16)}e.$_j=h;function $(V){return v(V)?!!(V.capabilities&16384):!1}e.$ak=$;function d(V){return v(V)?!!(V.capabilities&32768):!1}e.$bk=d;function t(V){return!!(V.capabilities&65536)}e.$ck=t;function r(V){return!!(V.capabilities&2048)}e.$dk=r;var a;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(a||(e.FileSystemProviderErrorCode=a={}));class i extends Error{static create(x,ge){const ue=new i(x.toString(),ge);return y(ue,ge),ue}constructor(x,ge){super(x),this.code=ge}}e.$ek=i;function c(V,x){return i.create(V,x)}e.$fk=c;function f(V){return V||c((0,m.localize)(0,null),a.Unknown)}e.$gk=f;function y(V,x){return V.name=x?`${x} (FileSystemError)`:"FileSystemError",V}e.$hk=y;function E(V){if(!V)return a.Unknown;if(V instanceof i)return V.code;const x=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!x)return a.Unknown;switch(x[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.$ik=E;function u(V){if(V instanceof F)return V.fileOperationResult;switch(E(V)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 9;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileTooLarge:return 7;default:return 10}}e.$jk=u;var l;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(l||(e.FileOperation=l={}));class w{constructor(x,ge,ue){this.resource=x,this.operation=ge,this.target=ue}isOperation(x){return this.operation===x}}e.$kk=w;var A;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(A||(e.FileChangeType=A={}));class N{constructor(x,ge){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ue=new Map;for(const we of x){const G=ue.get(we.type);switch(G?G.push([we.resource,we]):ue.set(we.type,[[we.resource,we]]),we.type){case 1:this.rawAdded.push(we.resource);break;case 0:this.rawUpdated.push(we.resource);break;case 2:this.rawDeleted.push(we.resource);break}}for(const[we,G]of ue)switch(we){case 1:this.a=D.$Hh.forUris(()=>ge),this.a.fill(G);break;case 0:this.b=D.$Hh.forUris(()=>ge),this.b.fill(G);break;case 2:this.c=D.$Hh.forUris(()=>ge),this.c.fill(G);break}}contains(x,...ge){return this.d(x,{includeChildren:!1},...ge)}affects(x,...ge){return this.d(x,{includeChildren:!0},...ge)}d(x,ge,...ue){if(!x)return!1;const we=ue.length>0;return!!((!we||ue.includes(1))&&(this.a?.get(x)||ge.includeChildren&&this.a?.findSuperstr(x))||(!we||ue.includes(0))&&(this.b?.get(x)||ge.includeChildren&&this.b?.findSuperstr(x))||(!we||ue.includes(2))&&(this.c?.findSubstr(x)||ge.includeChildren&&this.c?.findSuperstr(x)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$lk=N;function O(V,x,ge){return!V||!x||V===x||x.length>V.length?!1:(x.charAt(x.length-1)!==M.sep&&(x+=M.sep),ge?(0,g.$Ne)(V,x):V.indexOf(x)===0)}e.$mk=O;class F extends Error{constructor(x,ge,ue){super(x),this.fileOperationResult=ge,this.options=ue}}e.$nk=F;class j extends F{constructor(x,ge,ue,we){super(x,ge,we),this.fileOperationResult=ge,this.size=ue}}e.$ok=j;class z extends F{constructor(x,ge,ue){super(x,2,ue),this.stat=ge}}e.$pk=z;var T;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(T||(e.FileOperationResult=T={})),e.$qk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$rk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$sk="files.associations",e.$tk="files.exclude",e.$uk="files.readonlyInclude",e.$vk="files.readonlyExclude",e.$wk="files.readonlyFromPermissions";var H;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(H||(e.FileKind=H={})),e.$xk="";function q(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.$yk=q;async function me(V,x){if(!x.hasProvider(R.URI.from({scheme:V.scheme})))return new Promise(ge=>{const ue=x.onDidChangeFileSystemProviderRegistrations(we=>{we.scheme===V.scheme&&we.added&&(ue.dispose(),ge())})})}e.$zk=me;class X{static{this.KB=1024}static{this.MB=X.KB*X.KB}static{this.GB=X.MB*X.KB}static{this.TB=X.GB*X.KB}static formatSize(x){return(0,L.$nf)(x)||(x=0),x<X.KB?(0,m.localize)(1,null,x.toFixed(0)):x<X.MB?(0,m.localize)(2,null,(x/X.KB).toFixed(2)):x<X.GB?(0,m.localize)(3,null,(x/X.MB).toFixed(2)):x<X.TB?(0,m.localize)(4,null,(x/X.GB).toFixed(2)):(0,m.localize)(5,null,(x/X.TB).toFixed(2))}}e.$Ak=X;function Z(V){const x=typeof V=="string"||V?.scheme===P.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===P.Schemas.file?1024*X.MB:x?10*X.MB:b.$o?50*X.MB:1024*X.MB}e.$Bk=Z}),define(Se[233],De([1,0,22,8,196,30]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;async function R(P,I,p,S,C,v){let o;try{await m(P,I,p,S,C,v)}catch(s){o=s}finally{o&&C.errorTransformer&&(o=C.errorTransformer(o)),typeof o<"u"&&p.error(o),p.end()}}e.$Cp=R;async function m(P,I,p,S,C,v){k(v);const o=await P.open(I,{create:!1});try{k(v);let s=0,n=0,h=C&&typeof C.length=="number"?C.length:void 0,$=D.$Fd.alloc(Math.min(C.bufferSize,typeof h=="number"?h:C.bufferSize)),d=C&&typeof C.position=="number"?C.position:0,t=0;do n=await P.read(o,d,$.buffer,t,$.byteLength-t),d+=n,t+=n,s+=n,typeof h=="number"&&(h-=n),t===$.byteLength&&(await p.write(S($)),$=D.$Fd.alloc(Math.min(C.bufferSize,typeof h=="number"?h:C.bufferSize)),t=0);while(n>0&&(typeof h!="number"||h>0)&&k(v)&&b(s,C));if(t>0){let r=t;typeof h=="number"&&(r=Math.min(t,h)),p.write(S($.slice(0,r)))}}catch(s){throw(0,L.$gk)(s)}finally{await P.close(o)}}function k(P){if(P.isCancellationRequested)throw(0,M.$4)();return!0}function b(P,I){if(typeof I?.limits?.size=="number"&&P>I.limits.size)throw(0,L.$fk)((0,g.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[84],De([1,0,35,3,16,12,2,30]),function($e,e,D,M,g,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=void 0;function k(s){return s.recursive===!0}e.$Ep=k;class b extends M.$kc{static{this.a=5}constructor(n,h,$,d){super(),this.h=n,this.j=h,this.m=$,this.n=d,this.c=this.B(new M.$lc),this.f=void 0,this.g=0}s(){const n=new M.$jc;this.c.value=n,this.b=this.r(n),this.b.setVerboseLogging(this.m),n.add(this.b.onDidChangeFile(h=>this.h(h))),n.add(this.b.onDidLogMessage(h=>this.j(h))),n.add(this.b.onDidError(h=>this.t(h)))}t(n){this.n.restartOnError?this.g<b.a&&this.f?(this.w(`restarting watcher after error: ${n}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${n}`):this.w(n)}u(n){this.g++,this.s(),this.watch(n)}async watch(n){this.f=n,await this.b?.watch(n)}async setVerboseLogging(n){this.m=n,await this.b?.setVerboseLogging(n)}w(n){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${n}`})}y(n){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${n}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Fp=b;class P extends b{constructor(n,h,$){super(n,h,$,{type:"node.js",restartOnError:!1})}}e.$Gp=P;class I extends b{constructor(n,h,$){super(n,h,$,{type:"universal",restartOnError:!0})}}e.$Hp=I;function p(s){return s.map(n=>({type:n.type,resource:R.URI.file(n.path)}))}e.$Ip=p;function S(s){const n=new o;for(const h of s)n.processEvent(h);return n.coalesce()}e.$Jp=S;function C(s,n){return typeof n=="string"&&!n.startsWith(D.$nj)&&!(0,g.$8d)(n)?{base:s,pattern:n}:n}e.$Kp=C;function v(s,n){const h=[];for(const $ of n)h.push((0,D.$rj)(C(s,$)));return h}e.$Lp=v;class o{constructor(){this.a=new Set,this.b=new Map}c(n){return L.$k?n.path:n.path.toLowerCase()}processEvent(n){const h=this.b.get(this.c(n));let $=!1;if(h){const d=h.type,t=n.type;h.path!==n.path&&(n.type===2||n.type===1)?$=!0:d===1&&t===2?(this.b.delete(this.c(n)),this.a.delete(h)):d===2&&t===1?h.type=0:d===1&&t===0||(h.type=t)}else $=!0;$&&(this.a.add(n),this.b.set(this.c(n),n))}coalesce(){const n=[],h=[];return Array.from(this.a).filter($=>$.type!==2?(n.push($),!1):!0).sort(($,d)=>$.path.length-d.path.length).filter($=>h.some(d=>(0,m.$mk)($.path,d,!L.$k))?!1:(h.push($.path),!0)).concat(n)}}}),define(Se[234],De([1,0,52,9,21,32,3,77,16,12,101,29,84]),function($e,e,D,M,g,L,R,m,k,b,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=void 0;class S extends R.$kc{static{this.a=100}static{this.b=75}constructor(o,s,n,h){super(),this.m=o,this.n=s,this.r=n,this.s=h,this.c=this.B(new M.$Vg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},$=>this.n($))),this.f=this.B(new M.$Ug($=>this.z($),S.b)),this.g=(0,p.$Lp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,p.$Lp)(this.m.path,this.m.includes):void 0,this.j=new g.$pd,this.ready=this.t()}async t(){try{const o=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const s=await I.Promises.stat(o);this.B(await this.w(o,s.isDirectory()))}catch(o){o.code!=="ENOENT"?this.D(o):this.G(o)}}async u(o){let s=o.path;try{s=await I.Promises.realpath(o.path),o.path===s&&(s=await(0,P.$Vp)(o.path)??o.path),o.path!==s&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${o.path}, real: ${s})`)}catch{}return s}async w(o,s){if(b.$j&&(0,L.$If)(o,"/Volumes/",!0))return this.D(`Refusing to watch ${o} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.$kc.None;const n=new g.$pd(this.j.token),h=new R.$jc;try{const $=(0,k.$ae)(o),d=(0,D.watch)(o);h.add((0,R.$ic)(()=>{d.removeAllListeners(),d.close()})),this.G(`Started watching: '${o}'`);const t=new Set;if(s)try{for(const a of await I.Promises.readdir(o))t.add(a)}catch(a){this.D(a)}const r=new Map;h.add((0,R.$ic)(()=>{for(const[,a]of r)a.dispose();r.clear()})),d.on("error",(a,i)=>{this.D(`Failed to watch ${o} for changes using fs.watch() (${a}, ${i})`),this.dispose()}),d.on("change",(a,i)=>{if(n.token.isCancellationRequested)return;this.G(`[raw] ["${a}"] ${i}`);let c="";if(i&&(c=i.toString(),b.$j&&(c=(0,m.$hl)(c))),!(!c||a!=="change"&&a!=="rename"))if(s)if(a==="rename"){r.get(c)?.dispose();const f=setTimeout(async()=>{if(r.delete(c),c===$&&!await I.Promises.exists(o)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const y=await this.C((0,k.$9d)(o,c));if(n.token.isCancellationRequested)return;let E;y?t.has(c)?E=0:(E=1,t.add(c)):(t.delete(c),E=2),this.y({path:(0,k.$9d)(this.m.path,c),type:E})},S.a);r.set(c,(0,R.$ic)(()=>clearTimeout(f)))}else{let f;t.has(c)?f=0:(f=1,t.add(c)),this.y({path:(0,k.$9d)(this.m.path,c),type:f})}else if(a==="rename"||c!==$){const f=setTimeout(async()=>{const y=await I.Promises.exists(o);n.token.isCancellationRequested||(y?(this.y({path:this.m.path,type:0},!0),h.add(await this.w(o,!1))):(this.y({path:this.m.path,type:2},!0),this.f.flush(),this.dispose()))},S.a);h.clear(),h.add((0,R.$ic)(()=>clearTimeout(f)))}else this.y({path:this.m.path,type:0},!0)})}catch($){await I.Promises.exists(o)&&!n.token.isCancellationRequested&&this.D(`Failed to watch ${o} for changes using fs.watch() (${$.toString()})`)}return(0,R.$ic)(()=>{n.dispose(!0),h.dispose()})}y(o,s=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`),!s&&this.g.some(n=>n(o.path))?this.s&&this.G(` >> ignored (excluded) ${o.path}`):!s&&this.h&&this.h.length>0&&!this.h.some(n=>n(o.path))?this.s&&this.G(` >> ignored (not included) ${o.path}`):this.f.work(o))}z(o){const s=(0,p.$Jp)(o);if(s.length>0){if(this.s)for(const h of s)this.G(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);this.c.work(s)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${s[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(o){if(b.$k)return I.Promises.exists(o);try{const s=(0,k.$ae)(o);return(await I.Promises.readdir((0,k.$_d)(o))).some(h=>h===s)}catch(s){return this.G(s),!1}}setVerboseLogging(o){this.s=o}D(o){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${o}`})}F(o){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${o}`})}G(o){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${o}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Yp=S;async function C(v,o,s,n,h=512){const $=await I.Promises.open(v,"r"),d=Buffer.allocUnsafe(h),t=new g.$pd(n);let r,a=!1;const i={path:v,excludes:[],recursive:!1},c=new S(i,f=>{(async()=>{for(const{type:y}of f)if(y===0){if(a)return;a=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:E}=await I.Promises.read($,d,0,h,null);if(!E||t.token.isCancellationRequested)break;o(d.slice(0,E))}}catch(E){r=new Error(E),t.dispose(!0)}finally{a=!1}}})()});return await c.ready,s(),new Promise((f,y)=>{t.token.onCancellationRequested(async()=>{c.dispose();try{await I.Promises.close($)}catch(E){r=new Error(E)}r?y(r):f()})})}e.$Zp=C}),define(Se[235],De([1,0,4,35,3,12,234]),function($e,e,D,M,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;class m extends g.$kc{constructor(){super(...arguments),this.a=this.B(new D.$fd),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$fd),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(b){const P=this.j(b),I=P.filter(S=>{const C=this.c.get(S.path);return C?!(0,M.$vj)(C.request.excludes,S.excludes)||!(0,M.$vj)(C.request.includes,S.includes):!0}),p=Array.from(this.c.values()).filter(({request:S})=>!P.find(C=>C.path===S.path&&(0,M.$vj)(C.excludes,S.excludes)&&(0,M.$vj)(C.includes,S.includes))).map(({request:S})=>S.path);I.length&&this.m(`Request to start watching: ${I.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"})`).join(",")}`),p.length&&this.m(`Request to stop watching: ${p.join(",")}`);for(const S of p)this.h(S);for(const S of I)this.g(S)}g(b){const P=new R.$Yp(b,p=>this.a.fire(p),p=>this.b.fire(p),this.f),I={request:b,instance:P};this.c.set(b.path,I)}async stop(){for(const[b]of this.c)this.h(b);this.c.clear()}h(b){const P=this.c.get(b);P&&(this.c.delete(b),P.instance.dispose())}j(b){const P=new Map;for(const I of b){const p=L.$k?I.path:I.path.toLowerCase();P.set(p,I)}return Array.from(P.values())}async setVerboseLogging(b){this.f=b;for(const[,P]of this.c)P.instance.setVerboseLogging(b)}m(b){this.f&&this.b.fire({type:"trace",message:this.n(b)})}n(b,P){return P?`[File Watcher (node.js)] ${b} (path: ${P.request.path})`:`[File Watcher (node.js)] ${b}`}}e.$1p=m}),define(Se[236],De([1,0,84,235]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0;class g extends D.$Gp{constructor(R,m,k){super(R,m,k),this.s()}r(R){return R.add(new M.$1p)}}e.$2p=g}),define(Se[237],De([1,0,17,81,183,84]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;class R extends L.$Hp{constructor(k,b,P){super(k,b,P),this.s()}r(k){const b=k.add(new g.$Sp(D.$2f.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return k.add(b.onDidProcessExit(({code:P,signal:I})=>this.t(`terminated by itself with code ${P}, signal: ${I}`))),M.ProxyChannel.toService((0,M.$ih)(b.getChannel("watcher")))}}e.$Tp=R}),define(Se[105],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=void 0;class D{constructor(...g){this.a=new Map;for(const[L,R]of g)this.set(L,R)}set(g,L){const R=this.a.get(g);return this.a.set(g,L),R}has(g){return this.a.has(g)}get(g){return this.a.get(g)}}e.$zh=D}),define(Se[238],De([1,0,9,8,3,103,229,5,105,76]),function($e,e,D,M,g,L,R,m,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;const P=!1;class I extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class p{constructor(o=new k.$zh,s=!1,n,h=P){this.f=o,this.g=s,this.h=n,this.i=h,this.o=new Set,this.f.set(m.$Ah,this),this._globalGraph=h?n?._globalGraph??new R.$5p($=>$):void 0}createChild(o){return new p(o,this.g,this,this.i)}invokeFunction(o,...s){const n=C.traceInvocation(this.i,o);let h=!1;try{return o({get:d=>{if(h)throw(0,M.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(d,n);if(!t)throw new Error(`[invokeFunction] unknown service '${d}'`);return t}},...s)}finally{h=!0,n.stop()}}createInstance(o,...s){let n,h;return o instanceof L.$yh?(n=C.traceCreation(this.i,o.ctor),h=this.j(o.ctor,o.staticArguments.concat(s),n)):(n=C.traceCreation(this.i,o),h=this.j(o,s,n)),n.stop(),h}j(o,s=[],n){const h=m._util.getServiceDependencies(o).sort((t,r)=>t.index-r.index),$=[];for(const t of h){const r=this.m(t.id,n);r||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),$.push(r)}const d=h.length>0?h[0].index:s.length;if(s.length!==d){console.trace(`[createInstance] First service dependency of ${o.name} at position ${d+1} conflicts with ${s.length} static arguments`);const t=d-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,d)}return Reflect.construct(o,s.concat($))}k(o,s){if(this.f.get(o)instanceof L.$yh)this.f.set(o,s);else if(this.h)this.h.k(o,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const s=this.f.get(o);return!s&&this.h?this.h.l(o):s}m(o,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const n=this.l(o);return n instanceof L.$yh?this.q(o,n,s.branch(o,!0)):(s.branch(o,!1),n)}q(o,s,n){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,s,n)}finally{this.o.delete(o)}}r(o,s,n){const h=new R.$5p(t=>t.id.toString());let $=0;const d=[{id:o,desc:s,_trace:n}];for(;d.length;){const t=d.pop();if(h.lookupOrInsertNode(t),$++>1e3)throw new I(h);for(const r of m._util.getServiceDependencies(t.desc.ctor)){const a=this.l(r.id);if(a||this.u(`[createInstance] ${o} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),a instanceof L.$yh){const i={id:r.id,desc:a,_trace:t._trace.branch(r.id,!0)};h.insertEdge(t,i),d.push(i)}}}for(;;){const t=h.roots();if(t.length===0){if(!h.isEmpty())throw new I(h);break}for(const{data:r}of t){if(this.l(r.id)instanceof L.$yh){const i=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,i)}h.removeNode(r)}}return this.l(o)}s(o,s,n=[],h,$){if(this.f.get(o)instanceof L.$yh)return this.t(o,s,n,h,$);if(this.h)return this.h.s(o,s,n,h,$);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(o,s,n=[],h,$){if(h){const d=new p(void 0,this.g,this,this.i);d.c=String(o);const t=new Map,r=new D.$Xg(()=>{const a=d.j(s,n,$);for(const[i,c]of t){const f=a[i];if(typeof f=="function")for(const y of c)f.apply(a,y)}return t.clear(),a});return new Proxy(Object.create(null),{get(a,i){if(!r.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let y=t.get(i);return y||(y=new b.$tc,t.set(i,y)),(u,l,w)=>{const A=y.push([u,l,w]);return(0,g.$ic)(A)}}if(i in a)return a[i];const c=r.value;let f=c[i];return typeof f!="function"||(f=f.bind(c),a[i]=f),f},set(a,i,c){return r.value[i]=c,!0},getPrototypeOf(a){return s.prototype}})}else return this.j(s,n,$)}u(o,s){if(s&&console.warn(o),this.g)throw new Error(o)}}e.$6p=p;var S;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(S||(S={}));class C{static{this.all=new Set}static{this.c=new class extends C{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,s){return o?new C(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):C.c}static traceCreation(o,s){return o?new C(1,s.name):C.c}static{this.f=0}constructor(o,s){this.type=o,this.name=s,this.g=Date.now(),this.h=[]}branch(o,s){const n=new C(3,o.toString());return this.h.push([o,s,n]),n}stop(){const o=Date.now()-this.g;C.f+=o;let s=!1;function n($,d){const t=[],r=new Array($+1).join("	");for(const[a,i,c]of d.h)if(i&&c){s=!0,t.push(`${r}CREATES -> ${a}`);const f=n($+1,c);f&&t.push(f)}else t.push(`${r}uses -> ${a}`);return t.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${C.f.toFixed(2)}ms)`];(o>2||s)&&C.all.add(h.join(`
`))}}e.$7p=C}),define(Se[14],De([1,0,46,4,51,3,28,12,24,18,2,41,5]),function($e,e,D,M,g,L,R,m,k,b,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.log=e.$8i=e.LogLevel=e.$7i=e.$6i=e.$5i=void 0,e.$5i=(0,p.$Bh)("logService"),e.$6i=(0,p.$Bh)("loggerService");function S(){return new Date().toISOString()}function C(u){return(0,b.$nf)(u)}e.$7i=C;var v;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$8i=v.Info;function o(u,l,w){switch(l){case v.Trace:u.trace(w);break;case v.Debug:u.debug(w);break;case v.Info:u.info(w);break;case v.Warning:u.warn(w);break;case v.Error:u.error(w);break;case v.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=o;function s(u,l=!1){let w="";for(let A=0;A<u.length;A++){let N=u[A];if(N instanceof Error&&(N=(0,D.$mi)(N,l)),typeof N=="object")try{N=JSON.stringify(N)}catch{}w+=(A>0?" ":"")+N}return w}class n extends L.$kc{constructor(){super(...arguments),this.b=e.$8i,this.c=this.B(new M.$fd),this.onDidChangeLogLevel=this.c.event}setLevel(l){this.b!==l&&(this.b=l,this.c.fire(this.b))}getLevel(){return this.b}f(l){return this.b!==v.Off&&this.b<=l}}e.$0i=n;class h extends n{constructor(l){super(),this.h=l}f(l){return this.h||super.f(l)}trace(l,...w){this.f(v.Trace)&&this.g(v.Trace,s([l,...w],!0))}debug(l,...w){this.f(v.Debug)&&this.g(v.Debug,s([l,...w]))}info(l,...w){this.f(v.Info)&&this.g(v.Info,s([l,...w]))}warn(l,...w){this.f(v.Warning)&&this.g(v.Warning,s([l,...w]))}error(l,...w){if(this.f(v.Error))if(l instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=l.stack,this.g(v.Error,s(A))}else this.g(v.Error,s([l,...w]))}flush(){}}e.$$i=h;class $ extends n{constructor(l=e.$8i){super(),this.setLevel(l),this.g=!m.$i}trace(l,...w){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,l,...w):console.log(`[main ${S()}]`,l,...w))}debug(l,...w){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,l,...w):console.log(`[main ${S()}]`,l,...w))}info(l,...w){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,l,...w):console.log(`[main ${S()}]`,l,...w))}warn(l,...w){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,l,...w):console.warn(`[main ${S()}]`,l,...w))}error(l,...w){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,l,...w):console.error(`[main ${S()}]`,l,...w))}dispose(){}flush(){}}e.$_i=$;class d extends n{constructor(l=e.$8i,w=!0){super(),this.g=w,this.setLevel(l)}trace(l,...w){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",l,...w):console.log(l,...w))}debug(l,...w){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",l,...w):console.log(l,...w))}info(l,...w){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",l,...w):console.log(l,...w))}warn(l,...w){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",l,...w):console.log(l,...w))}error(l,...w){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",l,...w):console.error(l,...w))}dispose(){}flush(){}}e.$aj=d;class t extends n{constructor(l,w=e.$8i){super(),this.g=l,this.setLevel(w)}trace(l,...w){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(l),...w])}debug(l,...w){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(l),...w])}info(l,...w){this.f(v.Info)&&this.g.log(v.Info,[this.h(l),...w])}warn(l,...w){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(l),...w])}error(l,...w){this.f(v.Error)&&this.g.log(v.Error,[this.h(l),...w])}h(l){return typeof l=="string"?l:(0,D.$mi)(l,this.f(v.Trace))}dispose(){}flush(){}}e.$bj=t;class r extends n{constructor(l){super(),this.g=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const w of this.g)w.setLevel(l);super.setLevel(l)}trace(l,...w){for(const A of this.g)A.trace(l,...w)}debug(l,...w){for(const A of this.g)A.debug(l,...w)}info(l,...w){for(const A of this.g)A.info(l,...w)}warn(l,...w){for(const A of this.g)A.warn(l,...w)}error(l,...w){for(const A of this.g)A.error(l,...w)}flush(){for(const l of this.g)l.flush()}dispose(){for(const l of this.g)l.dispose()}}e.$cj=r;class a extends L.$kc{constructor(l,w,A){if(super(),this.h=l,this.j=w,this.b=new R.$zi,this.c=this.B(new M.$fd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$fd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$fd),this.onDidChangeVisibility=this.g.event,A)for(const N of A)this.b.set(N.resource,{logger:void 0,info:N})}m(l){return(0,b.$jf)(l)?[...this.b.values()].find(w=>w.info.id===l):this.b.get(l)}getLogger(l){return this.m(l)?.logger}createLogger(l,w){const A=this.n(l),N=(0,b.$jf)(l)?l:w?.id??(0,g.$pi)(A.toString()).toString(16);let O=this.b.get(A)?.logger;const F=w?.logLevel==="always"?v.Trace:w?.logLevel;O||(O=this.s(A,F??this.getLogLevel(A)??this.h,{...w,id:N}));const j={logger:O,info:{resource:A,id:N,logLevel:F,name:w?.name,hidden:w?.hidden,extensionId:w?.extensionId,when:w?.when}};return this.registerLogger(j.info),this.b.set(A,j),O}n(l){return(0,b.$jf)(l)?(0,k.$ig)(this.j,`${l}.log`):l}setLogLevel(l,w){if(P.URI.isUri(l)){const A=l,N=w,O=this.b.get(A);O&&N!==O.info.logLevel&&(O.info.logLevel=N===this.h?void 0:N,O.logger?.setLevel(N),this.b.set(O.info.resource,O),this.f.fire([A,N]))}else{this.h=l;for(const[A,N]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(l,w){const A=this.m(l);A&&w!==!A.info.hidden&&(A.info.hidden=!w,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,w]))}getLogLevel(l){let w;return l&&(w=this.b.get(l)?.info.logLevel),w??this.h}registerLogger(l){const w=this.b.get(l.resource);w?w.info.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this.b.set(l.resource,{info:l,logger:void 0}),this.c.fire({added:[l],removed:[]}))}deregisterLogger(l){const w=this.b.get(l);w&&(w.logger&&w.logger.dispose(),this.b.delete(l),this.c.fire({added:[],removed:[w.info]}))}*getRegisteredLoggers(){for(const l of this.b.values())yield l.info}getRegisteredLogger(l){return this.b.get(l)?.info}dispose(){this.b.forEach(l=>l.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dj=a;class i{constructor(){this.onDidChangeLogLevel=new M.$fd().event}setLevel(l){}getLevel(){return v.Info}trace(l,...w){}debug(l,...w){}info(l,...w){}warn(l,...w){}error(l,...w){}critical(l,...w){}dispose(){}flush(){}}e.$ej=i;class c extends i{}e.$fj=c;function f(u){if(u.verbose)return v.Trace;if(typeof u.logLevel=="string"){const l=E(u.logLevel.toLowerCase());if(l!==void 0)return l}return e.$8i}e.$gj=f;function y(u){switch(u){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.$hj=y;function E(u){switch(u){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$ij=E,e.$jj=new I.$2i("logLevel",y(v.Info))}),define(Se[239],De([1,0,19,9,8,4,3,16,84,14]),function($e,e,D,M,g,L,R,m,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;class P extends R.$kc{constructor(p,S){super(),this.a=p,this.b=S,this.c=this.B(new L.$fd),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$fd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new M.$Eg(0)),this.w=[],this.y=this.B(new M.$Eg(0))}watch(p,S){return S.recursive||this.b?.watcher?.forceUniversal?this.n(p,S):this.z(p,S)}n(p,S){const C={path:this.H(p),excludes:S.excludes,includes:S.includes,recursive:S.recursive},v=(0,D.$Sb)(this.j,C);return this.r(),(0,R.$ic)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,g.$Y)(p))}s(){this.h||(this.h=this.B(this.t(S=>this.c.fire((0,k.$Ip)(S)),S=>this.G(S),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const S of this.j)(0,k.$Ep)(S)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const S of this.j)(0,k.$Ep)(S)&&p.includes(S.path)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,S){const C={path:this.H(p),excludes:S.excludes,includes:S.includes,recursive:!1},v=(0,D.$Sb)(this.w,C);return this.C(),(0,R.$ic)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,g.$Y)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,k.$Ip)(p)),p=>this.G(p),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}H(p){return(0,m.$7d)(p.fsPath)}}e.$Mp=P}),define(Se[240],De([1,0,52,373,9,28,22,4,32,3,16,12,24,97,29,197,30,233,239,46,237,236]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o,s,n,h,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0,(()=>{try{(0,M.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,h.$mi)(r)}`)}})();class t extends n.$Mp{static{this.I=!1}constructor(a,i){super(a,i),this.onDidChangeCapabilities=m.Event.None,this.N=new L.$zi(c=>p.$_f.getComparisonKey(c)),this.S=new Map,this.U=new Map,this.W=new Map}get capabilities(){return this.J||(this.J=253982,I.$k&&(this.J|=1024)),this.J}async stat(a){try{const{stat:i,symbolicLink:c}=await C.SymlinkSupport.stat(this.H(a));return{type:this.M(i,c),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:o.FilePermission.Locked}}catch(i){throw this.eb(i)}}async L(a){try{return await this.stat(a)}catch{return}}async readdir(a){try{const i=await C.Promises.readdir(this.H(a),{withFileTypes:!0}),c=[];return await Promise.all(i.map(async f=>{try{let y;f.isSymbolicLink()?y=(await this.stat((0,p.$ig)(a,f.name))).type:y=this.M(f),c.push([f.name,y])}catch(y){this.a.trace(y)}})),c}catch(i){throw this.eb(i)}}M(a,i){let c;return i?.dangling?c=o.FileType.Unknown:a.isFile()?c=o.FileType.File:a.isDirectory()?c=o.FileType.Directory:c=o.FileType.Unknown,i&&(c|=o.FileType.SymbolicLink),c}async O(a){const i=this.H(a);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let c;for(;c=this.N.get(a);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await c.wait();const f=new g.$Fg;return this.N.set(a,f),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,b.$ic)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(a)===f&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(a)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),f.open()})}async readFile(a,i){let c;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(a)})`),c=await this.O(a));const f=this.H(a);return await C.Promises.readFile(f)}catch(f){throw this.eb(f)}finally{c?.dispose()}}P(a){t.I&&this.a.trace(a)}readFileStream(a,i,c){const f=(0,S.$td)(y=>R.$Fd.concat(y.map(E=>R.$Fd.wrap(E))).buffer);return(0,s.$Cp)(this,a,f,y=>y.buffer,{...i,bufferSize:256*1024},c),f}async writeFile(a,i,c){return c?.atomic!==!1&&c?.atomic?.postfix?this.Q(a,(0,p.$ig)((0,p.$hg)(a),`${(0,p.$fg)(a)}${c.atomic.postfix}`),i,c):this.R(a,i,c)}async Q(a,i,c,f){await this.R(i,c,f);try{await this.rename(i,a,{overwrite:!0})}catch(y){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw y}}async R(a,i,c){let f;try{const y=this.H(a);if(!c.create||!c.overwrite){if(await C.Promises.exists(y)){if(!c.overwrite)throw(0,o.$fk)((0,v.localize)(0,null),o.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,o.$fk)((0,v.localize)(1,null),o.FileSystemProviderErrorCode.FileNotFound)}f=await this.open(a,{create:!0,unlock:c.unlock}),await this.write(f,0,i,0,i.byteLength)}catch(y){throw await this.fb(a,y)}finally{typeof f=="number"&&await this.close(f)}}static{this.X=!0}static configureFlushOnWrite(a){t.X=a}async open(a,i){const c=this.H(a);let f;(0,o.$7j)(i)&&(f=await this.O(a));let y;try{if((0,o.$7j)(i)&&i.unlock)try{const{stat:u}=await C.SymlinkSupport.stat(c);u.mode&128||await C.Promises.chmod(c,u.mode|128)}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}let E;if((0,o.$7j)(i)){if(I.$i)try{await C.Promises.truncate(c,0),E="r+"}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}E||(E="w")}else E="r";y=await C.Promises.open(c,E)}catch(E){throw f?.dispose(),(0,o.$7j)(i)?await this.fb(a,E):this.eb(E)}if(this.S.set(y,0),(0,o.$7j)(i)&&this.W.set(y,a),f){const E=this.U.get(y);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${y} (${c})`),this.U.set(y,f),E&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${y} (${c})`),E.dispose())}return y}async close(a){const i=this.U.get(a);try{if(this.S.delete(a),this.W.delete(a)&&t.X)try{await C.Promises.fdatasync(a)}catch(c){t.configureFlushOnWrite(!1),this.a.error(c)}return await C.Promises.close(a)}catch(c){throw this.eb(c)}finally{i&&(this.U.get(a)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${a}`),this.U.delete(a)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${a}`),i.dispose())}}async read(a,i,c,f,y){const E=this.Y(a,i);let u=null;try{u=(await C.Promises.read(a,c,f,y,E)).bytesRead}catch(l){throw this.eb(l)}finally{this.Z(a,E,u)}return u}Y(a,i){return i===this.S.get(a)?null:i}Z(a,i,c){const f=this.S.get(a);typeof f=="number"&&(typeof i=="number"||(typeof c=="number"?this.S.set(a,f+c):this.S.delete(a)))}async write(a,i,c,f,y){return(0,g.$Yg)(()=>this.$(a,i,c,f,y),100,3)}async $(a,i,c,f,y){const E=this.Y(a,i);let u=null;try{u=(await C.Promises.write(a,c,f,y,E)).bytesWritten}catch(l){throw await this.fb(this.W.get(a),l)}finally{this.Z(a,E,u)}return u}async mkdir(a){try{await C.Promises.mkdir(this.H(a))}catch(i){throw this.eb(i)}}async delete(a,i){try{const c=this.H(a);if(i.recursive){let f;i?.atomic!==!1&&i.atomic.postfix&&(f=(0,P.$9d)((0,P.$_d)(c),`${(0,P.$ae)(c)}${i.atomic.postfix}`)),await C.Promises.rm(c,C.RimRafMode.MOVE,f)}else try{await C.Promises.unlink(c)}catch(f){if(f.code==="EPERM"||f.code==="EISDIR"){let y=!1;try{const{stat:E,symbolicLink:u}=await C.SymlinkSupport.stat(c);y=E.isDirectory()&&!u}catch{}if(y)await C.Promises.rmdir(c);else throw f}else throw f}}catch(c){throw this.eb(c)}}async rename(a,i,c){const f=this.H(a),y=this.H(i);if(f!==y)try{await this.ab(a,i,"move",c.overwrite),await C.Promises.rename(f,y)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,v.localize)(2,null,(0,P.$ae)(f),(0,P.$ae)((0,P.$_d)(y)),E.toString()))),this.eb(E)}}async copy(a,i,c){const f=this.H(a),y=this.H(i);if(f!==y)try{await this.ab(a,i,"copy",c.overwrite),await C.Promises.copy(f,y,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,v.localize)(3,null,(0,P.$ae)(f),(0,P.$ae)((0,P.$_d)(y)),E.toString()))),this.eb(E)}}async ab(a,i,c,f){const y=this.H(a),E=this.H(i);let u=!1;if(!!(this.capabilities&1024)||(u=(0,k.$Hf)(y,E,!0)),u){if(c==="copy")throw(0,o.$fk)((0,v.localize)(4,null),o.FileSystemProviderErrorCode.FileExists);if(c==="move")return}const w=await this.L(a);if(!w)throw(0,o.$fk)((0,v.localize)(5,null),o.FileSystemProviderErrorCode.FileNotFound);const A=await this.L(i);if(A){if(!f)throw(0,o.$fk)((0,v.localize)(6,null),o.FileSystemProviderErrorCode.FileExists);w.type&o.FileType.File&&A.type&o.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(a,i){return this.bb(a,i,!1)}async bb(a,i,c){const f=this.H(a),y=this.H(i),E=!!(this.capabilities&1024);if((0,k.$Hf)(f,y,!E))return;const u=new b.$jc;try{const[l,w]=await Promise.all([this.O(a),this.O(i)]);u.add(l),u.add(w),c&&await C.Promises.mkdir((0,P.$_d)(y),{recursive:!0}),await C.Promises.copyFile(f,y)}catch(l){if(l.code==="ENOENT"&&!c)return this.bb(a,i,!0);throw this.eb(l)}finally{u.dispose()}}t(a,i,c){return new $.$Tp(f=>a(f),f=>i(f),c)}F(a,i,c){return new d.$2p(f=>a(f),f=>i(f),c)}eb(a){if(a instanceof o.$ek)return a;let i=a,c;switch(a.code){case"ENOENT":c=o.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=o.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=o.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=o.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=o.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${a.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,c=o.FileSystemProviderErrorCode.Unknown;break;default:c=o.FileSystemProviderErrorCode.Unknown}return(0,o.$fk)(i,c)}async fb(a,i){let c=this.eb(i);if(a&&c.code===o.FileSystemProviderErrorCode.NoPermissions)try{const{stat:f}=await C.SymlinkSupport.stat(this.H(a));f.mode&128||(c=(0,o.$fk)(i,o.FileSystemProviderErrorCode.FileWriteLocked))}catch(f){this.a.trace(f)}return c}}e.$3p=t}),define(Se[241],De([1,0,3,14]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=void 0;class g extends D.$kc{constructor(R,m=[]){super(),this.a=new M.$cj([R,...m]),this.B(R.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...m){this.a.trace(R,...m)}debug(R,...m){this.a.debug(R,...m)}info(R,...m){this.a.info(R,...m)}warn(R,...m){this.a.warn(R,...m)}error(R,...m){this.a.error(R,...m)}flush(){this.a.flush()}}e.$mN=g}),define(Se[242],De([1,0,30,14]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bN=void 0;var g;(function(b){b[b.Trace=0]="Trace",b[b.Debug=1]="Debug",b[b.Info=2]="Info",b[b.Warning=3]="Warning",b[b.Error=4]="Error",b[b.Critical=5]="Critical",b[b.Off=6]="Off"})(g||(g={}));async function L(b,P,I,p,S){try{const C=await new Promise((o,s)=>{$e(["@vscode/spdlog"],o,s)});C.setFlushOn(g.Trace);const v=await C.createAsyncRotatingLogger(b,P,I,p);return S?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(C){console.error(C)}return null}function R(b,P,I){switch(P){case M.LogLevel.Trace:b.trace(I);break;case M.LogLevel.Debug:b.debug(I);break;case M.LogLevel.Info:b.info(I);break;case M.LogLevel.Warning:b.warn(I);break;case M.LogLevel.Error:b.error(I);break;case M.LogLevel.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function m(b,P){switch(P){case M.LogLevel.Trace:b.setLevel(g.Trace);break;case M.LogLevel.Debug:b.setLevel(g.Debug);break;case M.LogLevel.Info:b.setLevel(g.Info);break;case M.LogLevel.Warning:b.setLevel(g.Warning);break;case M.LogLevel.Error:b.setLevel(g.Error);break;case M.LogLevel.Off:b.setLevel(g.Off);break;default:throw new Error(`Invalid log level ${P}`)}}class k extends M.$$i{constructor(P,I,p,S,C){super(),this.m=[],this.setLevel(C),this.n=this.s(P,I,p,S),this.B(this.onDidChangeLogLevel(v=>{this.r&&m(this.r,v)}))}async s(P,I,p,S){const C=p?6:1,v=30/C*D.$Ak.MB,o=await L(P,I,v,C,S);if(o){this.r=o,m(this.r,this.getLevel());for(const{level:s,message:n}of this.m)R(this.r,s,n);this.m=[]}}g(P,I){this.r?R(this.r,P,I):this.getLevel()<=P&&this.m.push({level:P,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$bN=k}),define(Se[133],De([1,0,38,198,5]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(k){k[k.Unnecessary=1]="Unnecessary",k[k.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var R;(function(k){k[k.Hint=1]="Hint",k[k.Info=2]="Info",k[k.Warning=4]="Warning",k[k.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(k){function b(C,v){return v-C}k.compare=b;const P=Object.create(null);P[k.Error]=(0,M.localize)(0,null),P[k.Warning]=(0,M.localize)(1,null),P[k.Info]=(0,M.localize)(2,null);function I(C){return P[C]||""}k.toString=I;function p(C){switch(C){case D.default.Error:return k.Error;case D.default.Warning:return k.Warning;case D.default.Info:return k.Info;case D.default.Ignore:return k.Hint}}k.fromSeverity=p;function S(C){switch(C){case k.Error:return D.default.Error;case k.Warning:return D.default.Warning;case k.Info:return D.default.Info;case k.Hint:return D.default.Ignore}}k.toSeverity=S}(R||(e.MarkerSeverity=R={}));var m;(function(k){const b="";function P(p){return I(p,!0)}k.makeKey=P;function I(p,S){const C=[b];return p.source?C.push(p.source.replace("\xA6","\\\xA6")):C.push(b),p.code?typeof p.code=="string"?C.push(p.code.replace("\xA6","\\\xA6")):C.push(p.code.value.replace("\xA6","\\\xA6")):C.push(b),p.severity!==void 0&&p.severity!==null?C.push(R.toString(p.severity)):C.push(b),p.message&&S?C.push(p.message.replace("\xA6","\\\xA6")):C.push(b),p.startLineNumber!==void 0&&p.startLineNumber!==null?C.push(p.startLineNumber.toString()):C.push(b),p.startColumn!==void 0&&p.startColumn!==null?C.push(p.startColumn.toString()):C.push(b),p.endLineNumber!==void 0&&p.endLineNumber!==null?C.push(p.endLineNumber.toString()):C.push(b),p.endColumn!==void 0&&p.endColumn!==null?C.push(p.endColumn.toString()):C.push(b),C.push(b),C.join("\xA6")}k.makeKeyOptionalMessage=I})(m||(e.IMarkerData=m={})),e.$3s=(0,g.$Bh)("markerService")}),define(Se[243],De([1,0,4,38,5]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1u=e.$Zu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Yu=e.Severity=void 0,e.Severity=M.default,e.$Yu=(0,g.$Bh)("notificationService");var L;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var R;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var m;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(m||(e.NotificationsFilter=m={}));class k{constructor(){this.progress=new b,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.$Zu=k;class b{infinite(){}done(){}total(I){}worked(I){}}e.$1u=b}),define(Se[134],De([1,0,15,2,5]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PT=e.$OT=e.$NT=e.$MT=e.$LT=void 0,e.$LT=(0,g.$Bh)("openerService");function L(b,P){return M.URI.isUri(b)?(0,D.$Me)(b.scheme,P):(0,D.$Ne)(b,P+":")}e.$MT=L;function R(b,...P){return P.some(I=>L(b,I))}e.$NT=R;function m(b,P){return b.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.$OT=m;function k(b){let P;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(b.fragment);return I&&(P={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},b=b.with({fragment:""})),{selection:P,uri:b}}e.$PT=k}),define(Se[244],De([1,0,12,47]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let g;if(typeof D.$g.vscode<"u"&&typeof D.$g.vscode.context<"u"){const L=D.$g.vscode.context.configuration();if(L)g=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(g=globalThis._VSCODE_PRODUCT_JSON,M.env.VSCODE_DEV&&Object.assign(g,{nameShort:`${g.nameShort} Dev`,nameLong:`${g.nameLong} Dev`,dataFolderName:`${g.dataFolderName}-dev`,serverDataFolderName:g.serverDataFolderName?`${g.serverDataFolderName}-dev`:void 0}),!g.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(g,{version:L.version})}}else g={},Object.keys(g).length===0&&Object.assign(g,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=g}),define(Se[135],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=void 0,e.$kj=(0,D.$Bh)("productService"),e.$lj="vscode://schemas/vscode-product"});var Be=this&&this.__param||function($e,e){return function(D,M){e(D,M,$e)}};define(Se[65],De([1,0,9,21,3,5]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7u=e.$6u=e.$5u=e.$4u=e.$3u=e.ProgressLocation=e.$2u=void 0,e.$2u=(0,L.$Bh)("progressService");var R;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$3u=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(I,p){this.c=I,this.report=p?.async?this.e.bind(this):this.d.bind(this)}d(I){this.a=I,this.c(this.a)}e(I){Promise.resolve(this.b).finally(()=>{this.a=I;const p=this.c(this.a);this.b=Promise.resolve(p).finally(()=>this.b=void 0)})}}e.$4u=m;let k=class extends g.$kc{constructor(I,p){super(),this.a=new D.$2g,p.withProgress(I,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,g.$ic)(()=>this.a.complete()))}report(I){this.b?this.b.report(I):this.c=I}};e.$5u=k,e.$5u=k=Ke([Be(1,e.$2u)],k);class b extends g.$kc{constructor(I){super(),this.g=I,this.a=0,this.b=this.B(new g.$jc)}start(I){this.stop();const p=++this.a,S=new M.$pd;return this.f=setTimeout(()=>{p===this.a&&(this.c=this.g.show(!0))},I),this.b.add((0,g.$ic)(()=>clearTimeout(this.f))),this.b.add((0,g.$ic)(()=>S.cancel())),this.b.add((0,g.$ic)(()=>this.c?this.c.done():void 0)),{id:p,token:S.token,stop:()=>this.h(p),isCurrent:()=>this.a===p}}stop(){this.h(this.a)}h(I){this.a===I&&this.b.clear()}}e.$6u=b,e.$7u=(0,L.$Bh)("editorProgressService")}),define(Se[42],De([1,0,58,18]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0;class g{constructor(){this.a=new Map}add(R,m){D.ok(M.$jf(R)),D.ok(M.$lf(m)),D.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,m)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$8m=new g}),define(Se[106],De([1,0,4,42]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$9m={JSONContribution:"base.contributions.json"};function g(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class L{constructor(){this.b=new D.$fd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,b){this.a[g(k)]=b,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const R=new L;M.$8m.add(e.$9m.JSONContribution,R)}),define(Se[136],De([1,0,19,4,18,188,49,106,42]),function($e,e,D,M,g,L,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.ConfigurationScope=e.$an=e.EditPresentationTypes=void 0;var b;(function(d){d.Multiline="multilineText",d.Singleline="singlelineText"})(b||(e.EditPresentationTypes=b={})),e.$an={Configuration:"base.contributions.configuration"};var P;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.MACHINE=2]="MACHINE",d[d.WINDOW=3]="WINDOW",d[d.RESOURCE=4]="RESOURCE",d[d.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",d[d.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn="vscode://schemas/settings/resourceLanguage",e.$in="vscode://schemas/settings/configurationDefaults";const I=k.$8m.as(m.$9m.JSONContribution);class p{constructor(){this.h=new Set,this.i=new M.$fd,this.onDidSchemaChange=this.i.event,this.j=new M.$fd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$hn,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const a=new Set;this.n(t,r,a),I.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(t){const r=new Set;this.o(t,r),I.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const a=new Set;this.o(r,a),this.n(t,!1,a),I.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const a=[];for(const{overrides:i,source:c}of t)for(const f in i)if(r.add(f),e.$kn.test(f)){const y=this.a.get(f),E=y?.valuesSources??new Map;if(c)for(const A of Object.keys(i[f]))E.set(A,c);const u={...y?.value||{},...i[f]};this.a.set(f,{source:c,value:u,valuesSources:E});const l=(0,R.$fi)(f),w={type:"object",default:u,description:L.localize(1,null,l),$ref:e.$hn,defaultDefaultValue:u,source:g.$jf(c)?void 0:c,defaultValueSource:c};a.push(...v(f)),this.d[f]=w,this.b.properties[f]=w}else{this.a.set(f,{value:i[f],source:c});const y=this.d[f];y&&(this.w(f,y),this.r(f,y))}this.m(a)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:a,source:i}of t)for(const c in a){const f=this.a.get(c),y=g.$jf(i)?i:i?.id,E=g.$jf(f?.source)?f?.source:f?.source?.id;if(y===E)if(r.add(c),this.a.delete(c),e.$kn.test(c))delete this.d[c],delete this.b.properties[c];else{const u=this.d[c];u&&(this.w(c,u),this.r(c,u))}}this.u()}deltaConfiguration(t){let r=!1;const a=new Set;t.removedDefaults&&(this.l(t.removedDefaults,a),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,a),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,a),t.addedConfigurations&&this.n(t.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,a){t.forEach(i=>{this.p(i,r,i.extensionInfo,i.restrictedProperties,void 0,a),this.c.push(i),this.q(i)})}o(t,r){const a=i=>{if(i.properties)for(const c in i.properties){r.add(c);const f=this.d[c];f?.policy?.name&&this.e.delete(f.policy.name),delete this.d[c],this.s(c,i.properties[c])}i.allOf?.forEach(c=>a(c))};for(const i of t){a(i);const c=this.c.indexOf(i);c!==-1&&this.c.splice(c,1)}}p(t,r=!0,a,i,c=3,f){c=g.$sf(t.scope)?c:t.scope;const y=t.properties;if(y)for(const u in y){const l=y[u];if(r&&h(u,l)){delete y[u];continue}if(l.source=a,l.defaultDefaultValue=y[u].default,this.w(u,l),e.$kn.test(u)?l.scope=void 0:(l.scope=g.$sf(l.scope)?c:l.scope,l.restricted=g.$sf(l.restricted)?!!i?.includes(u):l.restricted),y[u].hasOwnProperty("included")&&!y[u].included){this.f[u]=y[u],delete y[u];continue}else this.d[u]=y[u],y[u].policy?.name&&this.e.set(y[u].policy.name,u);!y[u].deprecationMessage&&y[u].markdownDeprecationMessage&&(y[u].deprecationMessage=y[u].markdownDeprecationMessage),f.add(u)}const E=t.allOf;if(E)for(const u of E)this.p(u,r,a,i,c,f)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=a=>{const i=a.properties;if(i)for(const f in i)this.r(f,i[f]);a.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$bn.properties[t]=r,r.scope){case 1:e.$cn.properties[t]=r;break;case 2:e.$dn.properties[t]=r;break;case 6:e.$en.properties[t]=r;break;case 3:e.$fn.properties[t]=r;break;case 4:e.$gn.properties[t]=r;break;case 5:e.$gn.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$bn.properties[t],r.scope){case 1:delete e.$cn.properties[t];break;case 2:delete e.$dn.properties[t];break;case 6:delete e.$en.properties[t];break;case 3:delete e.$fn.properties[t];break;case 4:case 5:delete e.$gn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,a={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$hn};this.w(r,a),e.$bn.properties[r]=a,e.$cn.properties[r]=a,e.$dn.properties[r]=a,e.$en.properties[r]=a,e.$fn.properties[r]=a,e.$gn.properties[r]=a}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$hn};e.$bn.patternProperties[e.$jn]=t,e.$cn.patternProperties[e.$jn]=t,e.$dn.patternProperties[e.$jn]=t,e.$en.patternProperties[e.$jn]=t,e.$fn.patternProperties[e.$jn]=t,e.$gn.patternProperties[e.$jn]=t,this.i.fire()}w(t,r){const a=this.a.get(t);let i=a?.value,c=a?.source;g.$qf(i)&&(i=r.defaultDefaultValue,c=void 0),g.$qf(i)&&(i=s(r.type)),r.default=i,r.defaultValueSource=c}}const S="\\[([^\\]]+)\\]",C=new RegExp(S,"g");e.$jn=`^(${S})+$`,e.$kn=new RegExp(e.$jn);function v(d){const t=[];if(e.$kn.test(d)){let r=C.exec(d);for(;r?.length;){const a=r[1].trim();a&&t.push(a),r=C.exec(d)}}return(0,D.$Kb)(t)}e.$ln=v;function o(d){return d.reduce((t,r)=>`${t}[${r}]`,"")}e.$mn=o;function s(d){switch(Array.isArray(d)?d[0]:d){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$nn=s;const n=new p;k.$8m.add(e.$an.Configuration,n);function h(d,t){return d.trim()?e.$kn.test(d)?L.localize(7,null,d):n.getConfigurationProperties()[d]!==void 0?L.localize(8,null,d):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,d,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$on=h;function $(){const d=[],t=n.getConfigurationProperties();for(const r of Object.keys(t))d.push([r,t[r].scope]);return d.push(["launch",4]),d.push(["task",4]),d}e.$pn=$}),define(Se[245],De([1,0,19,4,157,3,28,23,18,2,49,136,42]),function($e,e,D,M,g,L,R,m,k,b,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=void 0;function S(r){return Object.isFrozen(r)?r:m.$Wm(r)}class C{constructor(a={},i=[],c=[],f){this.b=a,this.c=i,this.d=c,this.raw=f,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const a=this.raw.map(i=>{if(i instanceof C)return i;const c=new v("");return c.parseRaw(i),c.configurationModel});this.f=a.reduce((i,c)=>c===i?c:i.merge(c),a[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,P.$di)(this.contents,a):this.contents}inspect(a,i){const c=this.rawConfiguration.getValue(a),f=i?this.rawConfiguration.getOverrideValue(a,i):void 0,y=i?this.rawConfiguration.override(i).getValue(a):c;return{value:c,override:f,merged:y}}getOverrideValue(a,i){const c=this.i(i);return c?a?(0,P.$di)(c,a):c:void 0}getKeysForOverrideIdentifier(a){const i=[];for(const c of this.overrides)c.identifiers.includes(a)&&i.push(...c.keys);return D.$Kb(i)}getAllOverrideIdentifiers(){const a=[];for(const i of this.overrides)a.push(...i.identifiers);return D.$Kb(a)}override(a){let i=this.a.get(a);return i||(i=this.g(a),this.a.set(a,i)),i}merge(...a){const i=m.$Vm(this.contents),c=m.$Vm(this.overrides),f=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const E of a)if(y.push(...E.raw?.length?E.raw:[E]),!E.isEmpty()){this.h(i,E.contents);for(const u of E.overrides){const[l]=c.filter(w=>D.$sb(w.identifiers,u.identifiers));l?(this.h(l.contents,u.contents),l.keys.push(...u.keys),l.keys=D.$Kb(l.keys)):c.push(m.$Vm(u))}for(const u of E.keys)f.indexOf(u)===-1&&f.push(u)}return new C(i,f,c,y.every(E=>E instanceof C)?void 0:y)}g(a){const i=this.i(a);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const c={};for(const f of D.$Kb([...Object.keys(this.contents),...Object.keys(i)])){let y=this.contents[f];const E=i[f];E&&(typeof y=="object"&&typeof E=="object"?(y=m.$Vm(y),this.h(y,E)):y=E),c[f]=y}return new C(c,this.keys,this.overrides)}h(a,i){for(const c of Object.keys(i)){if(c in a&&k.$lf(a[c])&&k.$lf(i[c])){this.h(a[c],i[c]);continue}a[c]=m.$Vm(i[c])}}i(a){let i=null,c=null;const f=y=>{y&&(c?this.h(c,y):c=m.$Vm(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===a?i=y.contents:y.identifiers.includes(a)&&f(y.contents);return f(i),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,i){this.j(a,i,!0)}setValue(a,i){this.j(a,i,!1)}removeValue(a){const i=this.keys.indexOf(a);i!==-1&&(this.keys.splice(i,1),(0,P.$ci)(this.contents,a),I.$kn.test(a)&&this.overrides.splice(this.overrides.findIndex(c=>D.$sb(c.identifiers,(0,I.$ln)(a))),1))}j(a,i,c){(0,P.$bi)(this.contents,a,i,f=>console.error(f)),c=c||this.keys.indexOf(a)===-1,c&&this.keys.push(a),I.$kn.test(a)&&this.overrides.push({identifiers:(0,I.$ln)(a),keys:Object.keys(this.contents[a]),contents:(0,P.$ai)(this.contents[a],f=>console.error(f))})}}e.$qn=C;class v{constructor(a){this.f=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new C}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,i){if(!k.$sf(a)){const c=this.g(a);this.parseRaw(c,i)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,i){this.a=a;const{contents:c,keys:f,overrides:y,restricted:E,hasExcludedProperties:u}=this.h(a,i);this.b=new C(c,f,y,u?[a]:void 0),this.c=E||[]}g(a){let i={},c=null,f=[];const y=[],E=[];function u(w){Array.isArray(f)?f.push(w):c!==null&&(f[c]=w)}const l={onObjectBegin:()=>{const w={};u(w),y.push(f),f=w,c=null},onObjectProperty:w=>{c=w},onObjectEnd:()=>{f=y.pop()},onArrayBegin:()=>{const w=[];u(w),y.push(f),f=w,c=null},onArrayEnd:()=>{f=y.pop()},onLiteralValue:u,onError:(w,A,N)=>{E.push({error:w,offset:A,length:N})}};if(a)try{g.$Sm(a,l),i=f[0]||{}}catch(w){console.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return i}h(a,i){const c=p.$8m.as(I.$an.Configuration).getConfigurationProperties(),f=this.i(a,c,!0,i);a=f.raw;const y=(0,P.$ai)(a,l=>console.error(`Conflict in settings file ${this.f}: ${l}`)),E=Object.keys(a),u=this.j(a,l=>console.error(`Conflict in settings file ${this.f}: ${l}`));return{contents:y,keys:E,overrides:u,restricted:f.restricted,hasExcludedProperties:f.hasExcludedProperties}}i(a,i,c,f){let y=!1;if(!f?.scopes&&!f?.skipRestricted&&!f?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:y};const E={},u=[];for(const l in a)if(I.$kn.test(l)&&c){const w=this.i(a[l],i,!1,f);E[l]=w.raw,y=y||w.hasExcludedProperties,u.push(...w.restricted)}else{const w=i[l],A=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&u.push(l),!f.exclude?.includes(l)&&(f.include?.includes(l)||(A===void 0||f.scopes===void 0||f.scopes.includes(A))&&!(f.skipRestricted&&w?.restricted))?E[l]=a[l]:y=!0}return{raw:E,restricted:u,hasExcludedProperties:y}}j(a,i){const c=[];for(const f of Object.keys(a))if(I.$kn.test(f)){const y={};for(const E in a[f])y[E]=a[f][E];c.push({identifiers:(0,I.$ln)(f),keys:Object.keys(y),contents:(0,P.$ai)(y,i)})}return c}}e.$rn=v;class o extends L.$kc{constructor(a,i,c,f){super(),this.c=a,this.f=i,this.g=f,this.b=this.B(new M.$fd),this.onDidChange=this.b.event,this.a=new v(this.c.toString()),this.B(this.g.watch(c.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,y=>y.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,y=>(y.isOperation(0)||y.isOperation(3)||y.isOperation(1)||y.isOperation(4))&&c.isEqual(y.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new C}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$sn=o;class s{constructor(a,i,c,f,y,E,u,l,w,A,N,O,F){this.a=a,this.b=i,this.c=c,this.overrideIdentifiers=f,this.d=y,this.f=E,this.g=u,this.h=l,this.i=w,this.j=A,this.k=N,this.l=O,this.m=F}get value(){return S(this.c)}n(a,i,c){const f=a.inspect(i,c);return{get value(){return S(f.value)},get override(){return S(f.override)},get merged(){return S(f.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class n{constructor(a,i,c,f,y=new C,E=new C,u=new R.$zi,l=new C,w=new R.$zi){this.c=a,this.d=i,this.f=c,this.g=f,this.h=y,this.i=E,this.j=u,this.l=l,this.m=w,this.a=null,this.b=new R.$zi,this.n=null}getValue(a,i,c){return this.q(a,i,c).getValue(a)}updateValue(a,i,c={}){let f;c.resource?(f=this.m.get(c.resource),f||(f=new C,this.m.set(c.resource,f))):f=this.l,i===void 0?f.removeValue(a):f.setValue(a,i),c.resource||(this.a=null)}inspect(a,i,c){const f=this.q(a,i,c),y=this.u(i.resource,c),E=i.resource?this.m.get(i.resource)||this.l:this.l,u=new Set;for(const l of f.overrides)for(const w of l.identifiers)f.getOverrideValue(a,w)!==void 0&&u.add(w);return new s(a,i,f.getValue(a),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,y||void 0,E)}keys(a){const i=this.u(void 0,a);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(a){this.c=a,this.a=null,this.b.clear()}updatePolicyConfiguration(a){this.d=a}updateApplicationConfiguration(a){this.f=a,this.a=null,this.b.clear()}updateLocalUserConfiguration(a){this.g=a,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(a){this.h=a,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(a){this.i=a,this.a=null,this.b.clear()}updateFolderConfiguration(a,i){this.j.set(a,i),this.b.delete(a)}deleteFolderConfiguration(a){this.p.delete(a),this.b.delete(a)}compareAndUpdateDefaultConfiguration(a,i){const c=[];if(!i){const{added:f,updated:y,removed:E}=d(this.c,a);i=[...f,...y,...E]}for(const f of i)for(const y of(0,I.$ln)(f)){const E=this.c.getKeysForOverrideIdentifier(y),u=a.getKeysForOverrideIdentifier(y),l=[...u.filter(w=>E.indexOf(w)===-1),...E.filter(w=>u.indexOf(w)===-1),...E.filter(w=>!m.$Zm(this.c.override(y).getValue(w),a.override(y).getValue(w)))];c.push([y,l])}return this.updateDefaultConfiguration(a),{keys:i,overrides:c}}compareAndUpdatePolicyConfiguration(a){const{added:i,updated:c,removed:f}=d(this.d,a),y=[...i,...c,...f];return y.length&&this.updatePolicyConfiguration(a),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:i,updated:c,removed:f,overrides:y}=d(this.applicationConfiguration,a),E=[...i,...c,...f];return E.length&&this.updateApplicationConfiguration(a),{keys:E,overrides:y}}compareAndUpdateLocalUserConfiguration(a){const{added:i,updated:c,removed:f,overrides:y}=d(this.localUserConfiguration,a),E=[...i,...c,...f];return E.length&&this.updateLocalUserConfiguration(a),{keys:E,overrides:y}}compareAndUpdateRemoteUserConfiguration(a){const{added:i,updated:c,removed:f,overrides:y}=d(this.remoteUserConfiguration,a),E=[...i,...c,...f];return E.length&&this.updateRemoteUserConfiguration(a),{keys:E,overrides:y}}compareAndUpdateWorkspaceConfiguration(a){const{added:i,updated:c,removed:f,overrides:y}=d(this.workspaceConfiguration,a),E=[...i,...c,...f];return E.length&&this.updateWorkspaceConfiguration(a),{keys:E,overrides:y}}compareAndUpdateFolderConfiguration(a,i){const c=this.p.get(a),{added:f,updated:y,removed:E,overrides:u}=d(c,i),l=[...f,...y,...E];return(l.length||!c)&&this.updateFolderConfiguration(a,i),{keys:l,overrides:u}}compareAndDeleteFolderConfiguration(a){const i=this.p.get(a);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:c,updated:f,removed:y,overrides:E}=d(i,void 0);return{keys:[...c,...f,...y],overrides:E}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(a,i,c){let f=this.r(i,c);return i.overrideIdentifier&&(f=f.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(a)!==void 0&&(f=f.merge(this.d)),f}r({resource:a},i){let c=this.s();if(i&&a){const f=i.getFolder(a);f&&(c=this.t(f.uri)||c);const y=this.m.get(a);y&&(c=c.merge(y))}return c}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(a){let i=this.b.get(a);if(!i){const c=this.s(),f=this.j.get(a);f?(i=c.merge(f),this.b.set(a,i)):i=c}return i}u(a,i){if(i&&a){const c=i.getFolder(a);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((a,i)=>{const{contents:c,overrides:f,keys:y}=this.j.get(i);return a.push([i,{contents:c,overrides:f,keys:y}]),a},[])}}allKeys(){const a=new Set;return this.c.keys.forEach(i=>a.add(i)),this.userConfiguration.keys.forEach(i=>a.add(i)),this.i.keys.forEach(i=>a.add(i)),this.j.forEach(i=>i.keys.forEach(c=>a.add(c))),[...a.values()]}v(){const a=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>a.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>a.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>a.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(c=>a.add(c))),[...a.values()]}w(a){const i=new Set;return this.c.getKeysForOverrideIdentifier(a).forEach(c=>i.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(c=>i.add(c)),this.i.getKeysForOverrideIdentifier(a).forEach(c=>i.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(a).forEach(f=>i.add(f))),[...i.values()]}static parse(a){const i=this.x(a.defaults),c=this.x(a.policy),f=this.x(a.application),y=this.x(a.user),E=this.x(a.workspace),u=a.folders.reduce((l,w)=>(l.set(b.URI.revive(w[0]),this.x(w[1])),l),new R.$zi);return new n(i,c,f,y,new C,E,u,new C,new R.$zi)}static x(a){return new C(a.contents,a.keys,a.overrides)}}e.$tn=n;function h(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const a=new Set,i=new Map;for(const f of r)f.keys.forEach(y=>a.add(y)),f.overrides.forEach(([y,E])=>{const u=(0,R.$wi)(i,y,new Set);E.forEach(l=>u.add(l))});const c=[];return i.forEach((f,y)=>c.push([y,[...f.values()]])),{keys:[...a.values()],overrides:c}}e.$un=h;class ${constructor(a,i,c,f){this.change=a,this.f=i,this.g=c,this.h=f,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const y of a.keys)this.affectedKeys.add(y);for(const[,y]of a.overrides)for(const E of y)this.affectedKeys.add(E);this.d=this.a;for(const y of this.affectedKeys)this.d+=y+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(a,i){const c=this.a+a,f=this.d.indexOf(c);if(f<0)return!1;const y=f+c.length;if(y>=this.d.length)return!1;const E=this.d.charCodeAt(y);if(E!==this.b&&E!==this.c)return!1;if(i){const u=this.previousConfiguration?this.previousConfiguration.getValue(a,i,this.f?.workspace):void 0,l=this.g.getValue(a,i,this.h);return!m.$Zm(u,l)}return!0}}e.$vn=$;function d(r,a){const{added:i,removed:c,updated:f}=t(a?.rawConfiguration,r?.rawConfiguration),y=[],E=r?.getAllOverrideIdentifiers()||[],u=a?.getAllOverrideIdentifiers()||[];if(a){const l=u.filter(w=>!E.includes(w));for(const w of l)y.push([w,a.getKeysForOverrideIdentifier(w)])}if(r){const l=E.filter(w=>!u.includes(w));for(const w of l)y.push([w,r.getKeysForOverrideIdentifier(w)])}if(a&&r){for(const l of E)if(u.includes(l)){const w=t({contents:r.getOverrideValue(void 0,l)||{},keys:r.getKeysForOverrideIdentifier(l)},{contents:a.getOverrideValue(void 0,l)||{},keys:a.getKeysForOverrideIdentifier(l)});y.push([l,[...w.added,...w.removed,...w.updated]])}}return{added:i,removed:c,updated:f,overrides:y}}function t(r,a){const i=r?a?r.keys.filter(y=>a.keys.indexOf(y)===-1):[...r.keys]:[],c=a?r?a.keys.filter(y=>r.keys.indexOf(y)===-1):[...a.keys]:[],f=[];if(r&&a){for(const y of a.keys)if(r.keys.indexOf(y)!==-1){const E=(0,P.$di)(a.contents,y),u=(0,P.$di)(r.contents,y);m.$Zm(E,u)||f.push(y)}}return{added:i,removed:c,updated:f}}}),define(Se[246],De([1,0,22,4,3,82]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Akb=e.$zkb=e.$ykb=e.$xkb=void 0;const R=(b,P,I)=>{const p=new Uint8Array(16);for(let v=0;v<16;v++)p[v]=Math.round(Math.random()*256);const S=(0,D.$Zd)(D.$Fd.wrap(p));return[`GET ws://localhost${b}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`].join(`\r
`)+`\r
\r
`};e.$xkb=R,e.$ykb=D.$Fd.fromString(`\r
\r
`);async function m(b,P,I,p,S){b.write(D.$Fd.fromString((0,e.$xkb)(P,I,p)));const C=new g.$jc;try{return await new Promise((v,o)=>{let s;C.add(b.onData(n=>{s?s=D.$Fd.concat([s,n],s.byteLength+n.byteLength):s=n;const h=s.indexOf(e.$ykb);if(h===-1)return;v(b),b.pauseData();const $=s.slice(h+e.$ykb.byteLength);$.byteLength&&S.onData.fire($)})),C.add(b.onClose(n=>o(n??new Error("socket closed")))),C.add(b.onEnd(()=>o(new Error("socket ended"))))})}catch(v){throw b.dispose(),v}finally{C.dispose()}}e.$zkb=m;class k extends g.$kc{constructor(P,I){super(),this.g=P,this.a=this.B(new M.$id),this.onData=(...p)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...p)),this.b=this.B(new M.$fd),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event(p=>this.a.fire(p))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(P,I){L.SocketDiagnostics.traceSocketEvent(this,this.g,P,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Akb=k}),define(Se[66],De([1,0,8,5]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.$Mk=e.RemoteAuthorityResolverErrorCode=e.$Lk=e.$Kk=e.RemoteConnectionType=e.$Jk=void 0,e.$Jk=(0,M.$Bh)("remoteAuthorityResolverService");var g;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(g||(e.RemoteConnectionType=g={}));class L{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$Kk=L;class R{constructor(I,p){this.host=I,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Lk=R;var m;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class k extends D.$_{static isNotAvailable(I){return I instanceof k&&I._code===m.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof k&&I._code===m.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof k&&I._code===m.NoResolverFound}static isInvalidAuthority(I){return I instanceof k&&I._code===m.InvalidAuthority}static isHandled(I){return I instanceof k&&I.isHandled}constructor(I,p=m.Unknown,S){super(I),this._message=I,this._code=p,this._detail=S,this.isHandled=p===m.NotAvailable&&S===!0,Object.setPrototypeOf(this,k.prototype)}}e.$Mk=k;function b(P){const I=P.indexOf("+");return I===-1?P:P.substring(0,I)}e.$Nk=b}),define(Se[67],De([1,0,17]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=void 0;function M(b){return b.scheme===D.Schemas.vscodeRemote?b.authority:void 0}e.$Ok=M;function g(b){if(!b)return;const P=b.indexOf("+");return P<0?b:b.substr(0,P)}e.$Pk=g;function L(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.$Qk=L;function R(b){const{host:P,port:I}=k(b);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:I}}e.$Rk=R;function m(b,P){let{host:I,port:p}=k(b);return typeof p>"u"&&(p=P),{host:I,port:p}}e.$Sk=m;function k(b){const P=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const I=b.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const p=b.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:b,port:void 0}}}),define(Se[25],De([1,0,15,5,67]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.TargetPlatform=e.ExtensionType=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=void 0,e.$Pl="extensions.user.cache",e.$Ql="extensions.builtin.cache",e.$Rl="undefined_publisher",e.$Sl=["ui","workspace","web"];function L(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$Tl=L,e.$Ul=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(R||(e.ExtensionType=R={}));var m;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class k{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,s){if(typeof o>"u"||o===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof o=="string"||typeof s=="string"){const n=typeof o=="string"?o:o.value,h=typeof s=="string"?s:s.value;return D.$Me(n,h)}return o._lower===s._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Vl=k;class b{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const s of o)this.add(s)}add(o){this.c.add(k.toKey(o))}delete(o){return this.c.delete(k.toKey(o))}has(o){return this.c.has(k.toKey(o))}}e.$Wl=b;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(k.toKey(o))}get(o){return this.c.get(k.toKey(o))}has(o){return this.c.has(k.toKey(o))}set(o,s){this.c.set(k.toKey(o),s)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Xl=P;function I(v){return p(v)}e.$Yl=I;function p(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.$Zl=p;function S(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.$1l=S;function C(v,o){if(o){const s=`onResolveRemoteAuthority:${(0,g.$Pk)(o)}`;return!!v.activationEvents?.includes(s)}return!1}e.$2l=C,e.$3l=(0,M.$Bh)("IBuiltinExtensionsScannerService")}),define(Se[137],De([1,0,8,25]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BF=e.$AF=void 0;class g{constructor(){this.a=new Map,this.b=new WeakMap}register(R,m){this.a.set(R,m)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const m=Object.create(null);for(const k of R){const b=this.readActivationEvents(k);b.length>0&&(m[M.$Vl.toKey(k.identifier)]=b)}return m}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const m=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];if(!R.contributes)return m;for(const k in R.contributes){const b=this.a.get(k);if(!b)continue;const P=R.contributes[k],I=Array.isArray(P)?P:[P];try{b(I,m)}catch(p){(0,D.$Y)(p)}}return m}}e.$AF=g,e.$BF=new g}),define(Se[247],De([1,0,9,22,21,8,4,3,53,37,31,82,66,67]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.PersistentConnectionEventType=e.$Zk=e.$Yk=e.$Xk=e.ConnectionType=void 0;const C=30*1e3;var v;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(v||(e.ConnectionType=v={}));function o(G){switch(G){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function s(G){const U=new g.$pd;return setTimeout(()=>U.cancel(),G),U.token}function n(G,U){if(G.isCancellationRequested||U.isCancellationRequested)return g.CancellationToken.Cancelled;const K=new g.$pd;return G.onCancellationRequested(()=>K.cancel()),U.onCancellationRequested(()=>K.cancel()),K.token}class h{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new m.$jc,this.promise=new Promise((K,fe)=>{this.f=K,this.g=fe}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function $(G,U){const K=new h(U);return K.registerDisposable(G.onControlMessage(fe=>{const te=JSON.parse(fe.toString()),re=Z(te);re?K.reject(re):K.resolve(te)})),K.promise}function d(G,U,K,fe,te,re,ne,Ee){const oe=new h(Ee),he=b.$bd.create(!1);return G.info(`Creating a socket (${ne})...`),k.mark(`code/willCreateSocket/${re}`),U.connect(K,fe,te,ne).then(ee=>{oe.didTimeout?(k.mark(`code/didCreateSocketError/${re}`),G.info(`Creating a socket (${ne}) finished after ${he.elapsed()} ms, but this is too late and has timed out already.`),ee?.dispose()):(k.mark(`code/didCreateSocketOK/${re}`),G.info(`Creating a socket (${ne}) was successful after ${he.elapsed()} ms.`),oe.resolve(ee))},ee=>{k.mark(`code/didCreateSocketError/${re}`),G.info(`Creating a socket (${ne}) returned an error after ${he.elapsed()} ms.`),G.error(ee),oe.reject(ee)}),oe.promise}function t(G,U){const K=new h(U);return G.then(fe=>{K.didTimeout||K.resolve(fe)},fe=>{K.didTimeout||K.reject(fe)}),K.promise}async function r(G,U,K,fe){const te=ue(G,U);G.logService.trace(`${te} 1/6. invoking socketFactory.connect().`);let re;try{re=await d(G.logService,G.remoteSocketFactoryService,G.connectTo,(0,S.$Qk)(G),`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,o(U),`renderer-${o(U)}-${G.reconnectionToken}`,fe)}catch(ee){throw G.logService.error(`${te} socketFactory.connect() failed or timed out. Error:`),G.logService.error(ee),ee}G.logService.trace(`${te} 2/6. socketFactory.connect() was successful.`);let ne,Ee;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(re,null),ne=G.reconnectionProtocol,Ee=!1):(ne=new I.$ph({socket:re}),Ee=!0),G.logService.trace(`${te} 3/6. sending AuthRequest control message.`);const oe=await t(G.signService.createNewMessage((0,P.$4f)()),fe),he={type:"auth",auth:G.connectionToken||"00000000000000000000",data:oe.data};ne.sendControl(M.$Fd.fromString(JSON.stringify(he)));try{const ee=await $(ne,n(fe,s(1e4)));if(ee.type!=="sign"||typeof ee.data!="string"){const B=new Error("Unexpected handshake message");throw B.code="VSCODE_CONNECTION_ERROR",B}if(G.logService.trace(`${te} 4/6. received SignRequest control message.`),!await t(G.signService.validate(oe,ee.signedData),fe)){const B=new Error("Refused to connect to unsupported server");throw B.code="VSCODE_CONNECTION_ERROR",B}const be=await t(G.signService.sign(ee.data),fe),Ie={type:"connectionType",commit:G.commit,signedData:be,desiredConnectionType:U};return K&&(Ie.args=K),G.logService.trace(`${te} 5/6. sending ConnectionTypeRequest control message.`),ne.sendControl(M.$Fd.fromString(JSON.stringify(Ie))),{protocol:ne,ownsProtocol:Ee}}catch(ee){throw ee&&ee.code==="ETIMEDOUT"&&(G.logService.error(`${te} the handshake timed out. Error:`),G.logService.error(ee)),ee&&ee.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${te} received error control message when negotiating connection. Error:`),G.logService.error(ee)),Ee&&X(ne),ee}}async function a(G,U,K,fe){const te=Date.now(),re=ue(G,U),{protocol:ne,ownsProtocol:Ee}=await r(G,U,K,fe),oe=new h(fe);return oe.registerDisposable(ne.onControlMessage(he=>{const ee=JSON.parse(he.toString()),le=Z(ee);le?(G.logService.error(`${re} received error control message when negotiating connection. Error:`),G.logService.error(le),Ee&&X(ne),oe.reject(le)):(G.reconnectionProtocol?.endAcceptReconnection(),G.logService.trace(`${re} 6/6. handshake finished, connection is up and running after ${we(te)}!`),oe.resolve({protocol:ne,firstMessage:ee}))})),oe.promise}async function i(G,U){const{protocol:K}=await a(G,1,void 0,U);return{protocol:K}}async function c(G,U,K){const{protocol:fe,firstMessage:te}=await a(G,2,U,K),re=te&&te.debugPort;return{protocol:fe,debugPort:re}}async function f(G,U,K){const fe=Date.now(),te=ue(G,3),{protocol:re}=await r(G,3,U,K);return G.logService.trace(`${te} 6/6. handshake finished, connection is up and running after ${we(fe)}!`),re}async function y(G,U,K){const{connectTo:fe,connectionToken:te}=await G.addressProvider.getAddress();return{commit:G.commit,quality:G.quality,connectTo:fe,connectionToken:te,reconnectionToken:U,reconnectionProtocol:K,remoteSocketFactoryService:G.remoteSocketFactoryService,signService:G.signService,logService:G.logService}}async function E(G,U,K){return l(G,async fe=>{const{protocol:te}=await i(fe,g.CancellationToken.None);return new q(G,U,K,fe.reconnectionToken,te)})}e.$Xk=E;async function u(G,U){return l(G,async K=>{const{protocol:fe,debugPort:te}=await c(K,U,g.CancellationToken.None);return new me(G,U,K.reconnectionToken,fe,te)})}e.$Yk=u;async function l(G,U){for(let fe=1;;fe++)try{const te=(0,P.$4f)(),re=await y(G,te,null);return await U(re)}catch(te){if(fe<5)G.logService.error(`[remote-connection][attempt ${fe}] An error occurred in initial connection! Will retry... Error:`),G.logService.error(te);else throw G.logService.error(`[remote-connection][attempt ${fe}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),G.logService.error(te),H.triggerPermanentFailure(0,0,p.$Mk.isHandled(te)),te}}async function w(G,U,K){const fe=await y(G,(0,P.$4f)(),null);return await f(fe,{host:U,port:K},g.CancellationToken.None)}e.$Zk=w;function A(G){return(0,D.$ug)(U=>new Promise((K,fe)=>{const te=setTimeout(K,G*1e3);U.onCancellationRequested(()=>{clearTimeout(te),K()})}))}var N;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class O{constructor(U,K){this.reconnectionToken=U,this.millisSinceLastIncomingData=K,this.type=0}}e.$1k=O;class F{constructor(U,K,fe,te){this.reconnectionToken=U,this.millisSinceLastIncomingData=K,this.durationSeconds=fe,this.c=te,this.type=1}skipWait(){this.c.cancel()}}e.$2k=F;class j{constructor(U,K,fe){this.reconnectionToken=U,this.millisSinceLastIncomingData=K,this.attempt=fe,this.type=2}}e.$3k=j;class z{constructor(U,K,fe){this.reconnectionToken=U,this.millisSinceLastIncomingData=K,this.attempt=fe,this.type=4}}e.$4k=z;class T{constructor(U,K,fe,te){this.reconnectionToken=U,this.millisSinceLastIncomingData=K,this.attempt=fe,this.handled=te,this.type=3}}e.$5k=T;class H extends m.$kc{static triggerPermanentFailure(U,K,fe){this._permanentFailure=!0,this.f=U,this.g=K,this.h=fe,this.j.forEach(te=>te.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||H._permanentFailure}constructor(U,K,fe,te,re){super(),this.t=U,this.u=K,this.reconnectionToken=fe,this.protocol=te,this.w=re,this.m=this.B(new R.$fd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new z(this.reconnectionToken,0,0)),this.B(te.onSocketClose(ne=>{const Ee=ge(this.t,this.reconnectionToken,!0);ne?ne.type===0?(this.u.logService.info(`${Ee} received socket close event (hadError: ${ne.hadError}).`),ne.error&&this.u.logService.error(ne.error)):(this.u.logService.info(`${Ee} received socket close event (wasClean: ${ne.wasClean}, code: ${ne.code}, reason: ${ne.reason}).`),ne.event&&this.u.logService.error(ne.event)):this.u.logService.info(`${Ee} received socket close event.`),this.y()})),this.B(te.onSocketTimeout(ne=>{const Ee=ge(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Ee} received socket timeout event (unacknowledgedMsgCount: ${ne.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ne.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ne.timeSinceLastReceivedSomeData}).`),this.y()})),H.j.push(this),this.B((0,m.$ic)(()=>{const ne=H.j.indexOf(this);ne>=0&&H.j.splice(ne,1)})),this.n&&this.D(H.f,H.g,H.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=ge(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const K=[0,5,5,10,10,10,10,10,30];let fe=-1;do{fe++;const te=fe<K.length?K[fe]:K[K.length-1];try{if(te>0){const ne=A(te);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),te,ne)),this.u.logService.info(`${U} waiting for ${te} seconds before reconnecting...`);try{await ne}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),fe+1)),this.u.logService.info(`${U} resolving connection...`);const re=await y(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${re.connectTo}...`),await this.G(re,s(C)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),fe+1));break}catch(re){if(re.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(re),this.C(this.protocol.getMillisSinceLastIncomingData(),fe+1,!1);break}if(fe>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(re),this.C(this.protocol.getMillisSinceLastIncomingData(),fe+1,!1);break}if(p.$Mk.isTemporarilyNotAvailable(re)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(re);continue}if((re.code==="ETIMEDOUT"||re.code==="ENETUNREACH"||re.code==="ECONNREFUSED"||re.code==="ECONNRESET")&&re.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(re);continue}if((0,L.$2)(re)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(re);continue}if(re instanceof p.$Mk){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(re),this.C(this.protocol.getMillisSinceLastIncomingData(),fe+1,p.$Mk.isHandled(re));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(re),this.C(this.protocol.getMillisSinceLastIncomingData(),fe+1,!1);break}}while(!this.n&&!this.s)}C(U,K,fe){this.w?H.triggerPermanentFailure(U,K,fe):this.D(U,K,fe)}D(U,K,fe){this.m.fire(new T(this.reconnectionToken,U,K,fe)),X(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$6k=H;class q extends H{constructor(U,K,fe,te,re){super(1,U,te,re,!0),this.client=this.B(new I.$nh(re,{remoteAuthority:K,clientId:fe},U.ipcLogger))}async G(U,K){await i(U,K)}}e.$7k=q;class me extends H{constructor(U,K,fe,te,re){super(2,U,fe,te,!1),this.H=K,this.debugPort=re}async G(U,K){await c(U,this.H,K)}}e.$8k=me;function X(G){try{G.acceptDisconnect();const U=G.getSocket();G.dispose(),U.dispose()}catch(U){(0,L.$Y)(U)}}function Z(G){if(G&&G.type==="error"){const U=new Error(`Connection error: ${G.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function V(G,U){for(;G.length<U;)G+=" ";return G}function x(G,U){return`[remote-connection][${V(o(G),13)}][${U.substr(0,5)}\u2026]`}function ge(G,U,K){return`${x(G,U)}[${K?"reconnect":"initial"}]`}function ue(G,U){return`${ge(U,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.connectTo}]`}function we(G){return`${Date.now()-G} ms`}}),define(Se[248],De([1,0,3,5]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=void 0,e.$Tk=(0,M.$Bh)("remoteSocketFactoryService");class g{constructor(){this.a={}}register(R,m){return this.a[R]??=[],this.a[R].push(m),(0,D.$ic)(()=>{const k=this.a[R]?.indexOf(m);typeof k=="number"&&k>=0&&this.a[R]?.splice(k,1)})}b(R){return(this.a[R.type]||[]).find(k=>k.supports(R))}connect(R,m,k,b){const P=this.b(R);if(!P)throw new Error(`No socket factory found for ${R}`);return P.connect(R,m,k,b)}}e.$Uk=g}),define(Se[249],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s2b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(g){try{const L=await this.c();if(L){const R=String(D.a++);return this.b.set(R,L),{id:R,data:L.createNewMessage(g)}}}catch{}return{id:"",data:g}}async validate(g,L){if(!g.id)return!0;const R=this.b.get(g.id);if(!R)return!1;this.b.delete(g.id);try{return R.validate(L)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(g){try{return await this.d(g)}catch{}return g}}e.$s2b=D}),define(Se[107],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.$Vk=void 0,e.$Vk="signService",e.$Wk=(0,D.$Bh)(e.$Vk)}),define(Se[138],De([1,0,249]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e7b=void 0;class M extends D.$s2b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(R=>new R.signer().sign(L))}h(){return new Promise((L,R)=>$e(["vsda"],L,R))}}e.$e7b=M}),define(Se[250],De([1,0,12,47,31]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=void 0;function L(k){if(D.$t===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function R(k,b,P,I,p,S,C,v){const o=Object.create(null);o["common.machineId"]=S,o.sessionID=(0,g.$4f)()+Date.now(),o.commitHash=I,o.version=p,o["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,D.$h)(D.$t),o["common.nodePlatform"]=M.$3d,o["common.nodeArch"]=P,o["common.product"]=v||"desktop",C&&(o["common.msftInternal"]=C);let s=0;const n=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),D.$l&&(o["common.snap"]="true");const h=L(b);return h&&(o["common.platformDetail"]=h),o}e.$0n=R;function m(k){const b=M.env.USERDNSDOMAIN;if(!b)return!1;const P=b.toLowerCase();return k.some(I=>P===I)}e.$$n=m}),define(Se[251],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=void 0,e.$9k=(0,D.$Bh)("telemetryService"),e.$0k=(0,D.$Bh)("customEndpointTelemetryService"),e.$$k="telemetry.currentSessionDate",e.$_k="telemetry.firstSessionDate",e.$al="telemetry.lastSessionDate",e.$bl="telemetry.machineId",e.$cl="telemetry",e.$dl="telemetry.telemetryLevel",e.$el="telemetry.enableCrashReporter",e.$fl="telemetry.enableTelemetry";var M;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var g;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(g||(e.TelemetryConfiguration=g={}))}),define(Se[85],De([1,0,23,18,4,49,67,250,251]),function($e,e,D,M,g,L,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=void 0;class b{constructor(c){this.value=c,this.isTrustedTelemetryValue=!0}}e.$_n=b;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ao=P,e.$bo=new P;class I{async publicLog(c,f,y){}async publicLogError(c,f,y){}}e.$co=I,e.$do="telemetry",e.$eo="extensionTelemetryLog",e.$fo={log:()=>null,flush:()=>Promise.resolve(null)};function p(i,c){return g.Event.debounce(c.onDidChangeConfiguration,(y,E)=>{const u=y?new Set([...y.affectedKeys,...E.affectedKeys]):E.affectedKeys;return{...E,affectedKeys:u}},1e3,!0)(y=>{y.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,L.$$h)(y.source),configurationKeys:Array.from(y.affectedKeys)})})}e.$go=p;function S(i,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!i.enableTelemetry||c.extensionTestsLocationURI)}e.$ho=S;function C(i,c){return!(c.isBuilt||c.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$io=C;function v(i){const c=i.getValue(k.$dl),f=i.getValue(k.$el);if(i.getValue(k.$fl)===!1||f===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$jo=v;function o(i){const c={},f={},y={};h(i,y);for(let E in y){E=E.length>150?E.substr(E.length-149):E;const u=y[E];typeof u=="number"?f[E]=u:typeof u=="boolean"?f[E]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${u.length}`),c[E]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(c[E]=u)}return{properties:c,measurements:f}}e.$ko=o;const s=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(i){if(!i)return"none";const c=(0,R.$Pk)(i);return s.has(c)?c:"other"}e.$lo=n;function h(i,c,f=0,y){if(i)for(const E of Object.getOwnPropertyNames(i)){const u=i[E],l=y?y+E:E;Array.isArray(u)?c[l]=(0,D.$1m)(u):u instanceof Date?c[l]=u.toISOString():(0,M.$lf)(u)?f<2?h(u,c,f+1,l+"."):c[l]=(0,D.$1m)(u):c[l]=u}}function $(i,c){const f=i.msftInternalDomains||[],y=c.getValue("telemetry.internalTesting");return(0,m.$$n)(f)||y}e.$mo=$;function d(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$no=d;function t(i,c){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let f=i;const y=[];for(const w of c)for(;;){const A=w.exec(i);if(!A)break;y.push([A.index,w.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(f="";;){const w=u.exec(i);if(!w)break;const A=y.some(([N,O])=>w.index<O&&N<u.lastIndex);!E.test(w[0])&&!A&&(f+=i.substring(l,w.index)+"<REDACTED: user-file-path>",l=u.lastIndex)}return l<i.length&&(f+=i.substr(l)),f}function r(i){if(!i)return i;const c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of c)if(f.regex.test(i))return`<REDACTED: ${f.label}>`;return i}function a(i,c){return(0,D.$Xm)(i,f=>{if(f instanceof b||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let y=f.replaceAll("%20"," ");y=t(y,c);for(const E of c)y=y.replace(E,"");return y=r(y),y}})}e.$oo=a}),define(Se[252],De([1,0,15,132,25,12,2,8,47,85]),function($e,e,D,M,g,L,R,m,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;function P(a,i){return a.uuid&&i.uuid?a.uuid===i.uuid:a.id===i.id?!0:(0,D.$He)(a.id,i.id)===0}e.$po=P;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(i){const c=i.manifest?i.manifest.version:i.version,f=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new p(i.identifier,c,f)}static parse(i){const c=I.exec(i);return c&&c[1]&&c[2]?new p({id:c[1]},c[2],c[4]||void 0):null}constructor(i,c,f="undefined"){this.version=c,this.targetPlatform=f,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof p?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$qo=p;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function C(a){const i=S.exec(a);return i&&i[1]?[o(i[1]),i[2]]:[o(a),void 0]}e.$ro=C;function v(a,i){return`${a}.${i}`}e.$so=v;function o(a){return a.toLowerCase()}e.$to=o;function s(a,i){return o(v(a??g.$Rl,i))}e.$uo=s;function n(a,i){const c=[],f=y=>{for(const E of c)if(E.some(u=>P(i(u),i(y))))return E;return null};for(const y of a){const E=f(y);E?E.push(y):c.push([y])}return c}e.$vo=n;function h(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.$wo=h;function $(a){return{id:new b.$_n(a.identifier.id),name:new b.$_n(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$xo=$,e.$yo=new g.$Vl("pprice.better-merge");function d(a,i){const c=[],f=i.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const y=f.shift();if(y&&c.every(E=>!P(E.identifier,{id:y}))){const E=a.filter(u=>P(u.identifier,{id:y}));E.length===1&&(c.push(E[0]),f.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.$zo=d;async function t(a,i){if(!L.$k)return!1;let c;try{c=(await a.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await a.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(y){i.debug("Error while getting the os-release file.",(0,m.$8)(y))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(a,i){const c=await t(a,i),f=(0,M.$Un)(c?"alpine":L.$t,k.$4d);return i.debug("ComputeTargetPlatform:",f),f}e.$Ao=r}),define(Se[253],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=e.$dr=e.$cr=e.$br=e.$ar=void 0;function D(k){return[...k.entries()]}e.$ar=D;function M(k){return k?[...k.entries()]:[]}e.$br=M;function g(k){return new Map(k)}e.$cr=g;function L(k){return new Map(k??[])}e.$dr=L;function R(k){return Array.from(k.entries()).map(b=>[b[0],D(b[1].map),M(b[1].descriptionMap)])}e.$er=R;function m(k){return new Map(k.map(b=>[b[0],{map:g(b[1]),descriptionMap:L(b[2])}]))}e.$fr=m}),define(Se[254],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qkb=void 0;class D{constructor(g){this.b=g,this.a=new Map}dispose(){for(const g of this.a.values())g.dispose()}startBuffering(g,L,R=5){const m=L(k=>{const b=typeof k=="string"?k:k.data;let P=this.a.get(g);if(P){P.data.push(b);return}const I=setTimeout(()=>this.flushBuffer(g),R);P={data:[b],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(g),m.dispose()}},this.a.set(g,P)});return m}stopBuffering(g){this.a.get(g)?.dispose()}flushBuffer(g){const L=this.a.get(g);L&&(this.a.delete(g),this.b(g,L.data.join("")))}}e.$Qkb=D}),define(Se[255],De([1,0,9,79,60,4,18,2,199,106,42]),function($e,e,D,M,g,L,R,m,k,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dv=e.$cv=e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.IconFontDefinition=e.IconContribution=e.$8u=void 0,e.$8u={IconContribution:"base.contributions.icons"};var I;(function($){function d(t,r){let a=t.defaults;for(;g.ThemeIcon.isThemeIcon(a);){const i=C.getIcon(a.id);if(!i)return;a=i.defaults}return a}$.getDefinition=d})(I||(e.IconContribution=I={}));var p;(function($){function d(r){return{weight:r.weight,style:r.style,src:r.src.map(a=>({format:a.format,location:a.location.toString()}))}}$.toJSONObject=d;function t(r){const a=i=>(0,R.$jf)(i)?i:void 0;if(r&&Array.isArray(r.src)&&r.src.every(i=>(0,R.$jf)(i.format)&&(0,R.$jf)(i.location)))return{weight:a(r.weight),style:a(r.style),src:r.src.map(i=>({format:i.format,location:m.URI.parse(i.location)}))}}$.fromJSONObject=t})(p||(e.IconFontDefinition=p={}));class S{constructor(){this.a=new L.$fd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${g.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(d,t,r,a){const i=this.b[d];if(i){if(r&&!i.description){i.description=r,this.d.properties[d].markdownDescription=`${r} $(${d})`;const y=this.e.enum.indexOf(d);y!==-1&&(this.e.enumDescriptions[y]=r),this.a.fire()}return i}const c={id:d,description:r,defaults:t,deprecationMessage:a};this.b[d]=c;const f={$ref:"#/definitions/icons"};return a&&(f.deprecationMessage=a),r&&(f.markdownDescription=`${r}: $(${d})`),this.d.properties[d]=f,this.e.enum.push(d),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:d}}deregisterIcon(d){delete this.b[d],delete this.d.properties[d];const t=this.e.enum.indexOf(d);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(d=>this.b[d])}getIcon(d){return this.b[d]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(d,t){const r=this.f[d];return r||(this.f[d]=t,this.a.fire(),t)}deregisterIconFont(d){delete this.f[d]}getIconFont(d){return this.f[d]}toString(){const d=(i,c)=>i.id.localeCompare(c.id),t=i=>{for(;g.ThemeIcon.isThemeIcon(i.defaults);)i=this.b[i.defaults.id];return`codicon codicon-${i?i.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.b).map(i=>this.b[i]);for(const i of a.filter(c=>!!c.description).sort(d))r.push(`|<i class="${t(i)}"></i>|${i.id}|${g.ThemeIcon.isThemeIcon(i.defaults)?i.defaults.id:i.id}|${i.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const i of a.filter(c=>!g.ThemeIcon.isThemeIcon(c.defaults)).sort(d))r.push(`|<i class="${t(i)}"></i>|${i.id}|`);return r.join(`
`)}}const C=new S;P.$8m.add(e.$8u.IconContribution,C);function v($,d,t,r){return C.registerIcon($,d,t,r)}e.$9u=v;function o(){return C}e.$0u=o;function s(){const $=(0,M.$Nj)();for(const d in $){const t="\\"+$[d].toString(16);C.registerIcon(d,{fontCharacter:t})}}s(),e.$$u="vscode://schemas/icons";const n=P.$8m.as(b.$9m.JSONContribution);n.registerSchema(e.$$u,C.getIconSchema());const h=new D.$Sg(()=>n.notifySchemaChanged(e.$$u),200);C.onDidChange(()=>{h.isScheduled()||h.schedule()}),e.$_u=v("widget-close",M.$Pj.close,(0,k.localize)(2,null)),e.$av=v("goto-previous-location",M.$Pj.arrowUp,(0,k.localize)(3,null)),e.$bv=v("goto-next-location",M.$Pj.arrowDown,(0,k.localize)(4,null)),e.$cv=g.ThemeIcon.modify(M.$Pj.sync,"spin"),e.$dv=g.ThemeIcon.modify(M.$Pj.loading,"spin")}),define(Se[86],De([1,0,4,49,5,14]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7z=e.$6z=e.$5z=e.$4z=e.$3z=e.$2z=e.$1z=e.$Zz=e.ProvidedOnAutoForward=e.$Yz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Xz=e.$Wz=void 0,e.$Wz=(0,g.$Bh)("tunnelService"),e.$Xz=(0,g.$Bh)("sharedTunnelsService");var R;(function(o){o.Http="http",o.Https="https"})(R||(e.TunnelProtocol=R={}));var m;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(m||(e.TunnelPrivacyId=m={}));function k(o){return!!o.forwardPort}e.$Yz=k;var b;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(b||(e.ProvidedOnAutoForward=b={}));function P(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(s)return{address:s[1],port:+s[2]}}e.$Zz=P,e.$1z=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(o){return e.$1z.indexOf(o)>=0}e.$2z=I,e.$3z=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(o){return e.$3z.indexOf(o)>=0}e.$4z=p;function S(o,s,n,h){if(n===1)return!1;if(n===2&&p(s)){const $=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if($?.length===4&&parseInt($[1])>=18)return!1}return o<1024}e.$5z=S;class C{constructor(s,n,h){this.remoteAddress=s,this.localAddress=n,this.b=h,this.a=new D.$fd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$6z=C;let v=class{constructor(s,n){this.j=s,this.k=n,this.a=new D.$fd,this.onTunnelOpened=this.a.event,this.b=new D.$fd,this.onTunnelClosed=this.b.event,this.c=new D.$fd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const s=this.k.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.f=s,s?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.g=s.elevation,this.h=s.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const s=[],n=Array.from(this.e.values());for(const h of n){const $=Array.from(h.values());for(const d of $){const t=await d.value;t&&typeof t!="string"&&s.push(t)}}return s}async dispose(){for(const s of this.e.values()){for(const{value:n}of s.values())await n.then(h=>typeof h!="string"?h?.dispose():void 0);s.clear()}this.e.clear()}setEnvironmentTunnel(s,n,h,$,d){this.p(s,n,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:n,localAddress:h,privacy:$,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,n){(p(s)||I(s))&&(s=e.$1z[0]);const h=this.r(s,n);if(h)return++h.refcount,h.value}openTunnel(s,n,h,$,d,t=!1,r,a){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${h} on local port ${d}.`);const i=this.f??s;if(!i)return;if(n||(n="localhost"),$||($=this.l),this.f&&this.i.has(h)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const c=this.s(i,n,h,$,d,t,r,a);return c?c.then(f=>{if(f){if(typeof f=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(n,h),f}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(n,h);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const y=this.n(f);return(f.tunnelRemoteHost!==n||f.tunnelRemotePort!==h)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&f.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(y),y}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}n(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const n=this.e.get(s.tunnelRemoteHost);if(n){const h=n.get(s.tunnelRemotePort);h&&(h.refcount--,await this.o(s.tunnelRemoteHost,s.tunnelRemotePort,h))}}}}async o(s,n,h){if(h.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${n}.`);const $=h.value.then(async d=>{d&&typeof d!="string"&&(await d.dispose(!0),this.b.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this.e.has(s)&&this.e.get(s).delete(n),$}}async closeTunnel(s,n){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${n} `);const h=this.e.get(s);if(h&&h.has(n)){const $=h.get(n);$.refcount=0,await this.o(s,n,$)}}p(s,n,h){this.e.has(s)||this.e.set(s,new Map),this.e.get(s).set(n,{refcount:1,value:h})}async q(s,n){const h=this.e.get(s);if(h){const $=h.get(n),d=$?await $.value:void 0;(!d||typeof d=="string")&&h.delete(n),h.size===0&&this.e.delete(s)}}r(s,n){const h=[s];I(s)?(h.push(...e.$1z),h.push(...e.$3z)):p(s)&&h.push(...e.$3z);const $=h.map(d=>this.e.get(d));for(const d of $){const t=d?.get(n);if(t)return t}}canTunnel(s){return!!P(s)}t(s,n,h,$,d,t,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${h} on local port ${$}.`);const a=h;this.i.add(a);const i=$===void 0?h:$,c={elevationRequired:d?this.isPortPrivileged(i):!1},f={remoteAddress:{host:n,port:h},localAddressPort:$,privacy:t,public:t?t!==m.Private:void 0,protocol:r},y=s.forwardPort(f,c);return y?(this.p(n,h,y),y.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(a)})):this.i.delete(a),y}};e.$7z=v,e.$7z=v=Ke([Be(0,L.$5i),Be(1,M.$8h)],v)}),define(Se[256],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=void 0,e.$Ck=(0,D.$Bh)("IUriIdentityService")}),define(Se[257],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$8z=void 0,e.$8z=(0,D.$Bh)("editSessionIdentityService");var M;(function(g){g[g.Complete=100]="Complete",g[g.Partial=50]="Partial",g[g.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Se[258],De([1,0,17]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=void 0;function M(k){return k.scheme!==D.Schemas.file&&k.scheme!==D.Schemas.vscodeRemote}e.$sJ=M;function g(k){if(k.folders.length)return k.folders.every(b=>M(b.uri))?k.folders[0].uri:void 0;if(k.configuration&&M(k.configuration))return k.configuration}e.$tJ=g;function L(k){return g(k)?.scheme}e.$uJ=L;function R(k){return g(k)?.authority}e.$vJ=R;function m(k){return g(k)!==void 0}e.$wJ=m}),define(Se[43],De([1,0,201,16,78,24,2,5,17]),function($e,e,D,M,g,L,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.WorkbenchState=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=void 0,e.$Kh=(0,m.$Bh)("contextService");function b(i){const c=i;return typeof c?.id=="string"&&R.URI.isUri(c.uri)}e.$Lh=b;function P(i){return typeof i?.id=="string"&&!b(i)&&!p(i)}e.$Mh=P,e.$Nh={id:"ext-dev"},e.$Oh={id:"empty-window"};function I(i,c){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,M.$ae)(i)}:c?e.$Nh:e.$Oh;const f=i;return f.configuration?{id:f.id,configPath:f.configuration}:f.folders.length===1?{id:f.id,uri:f.folders[0].uri}:{id:f.id}}e.$Ph=I;function p(i){const c=i;return typeof c?.id=="string"&&R.URI.isUri(c.configPath)}e.$Qh=p;function S(i){const c=i;if(c?.uri)return{id:c.id,uri:R.URI.revive(c.uri)};const f=i;if(f?.configPath)return{id:f.id,configPath:R.URI.revive(f.configPath)};if(i?.id)return{id:i.id}}e.$Rh=S;var C;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(C||(e.WorkbenchState=C={}));function v(i){const c=i;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.$Sh=v;function o(i){const c=i;return!!(c&&typeof c=="object"&&R.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.$Th=o;class s{constructor(c,f,y,E,u){this.h=c,this.j=y,this.k=E,this.l=u,this.c=g.$Hh.forUris(this.l,()=>!0),this.folders=f}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=g.$Hh.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Uh=s;class n{constructor(c,f){this.raw=f,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,L.$ig)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Vh=n;function h(i){return new n({uri:i,index:0,name:(0,L.$eg)(i)},{uri:i.toString()})}e.$Wh=h,e.$Xh="code-workspace",e.$Yh=`.${e.$Xh}`,e.$Zh=[{name:(0,D.localize)(0,null),extensions:[e.$Xh]}],e.$1h="workspace.json";function $(i,c){return L.$_f.isEqualOrParent(i,c.untitledWorkspacesHome)}e.$2h=$;function d(i){let c;return R.URI.isUri(i)?c=i:c=i.configuration,c?.scheme===k.Schemas.tmp}e.$3h=d,e.$4h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$4h}e.$5h=t;function r(i,c){return!$(i,c)&&!d(i)}e.$6h=r;function a(i){return(typeof i=="string"?(0,M.$be)(i):(0,L.$gg)(i))===e.$Yh}e.$7h=a}),define(Se[259],De([1,0,51,4,3,24,2,200,131,30,5,14,43,28,256,9,31,15,18]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.ProfileResourceType=void 0;var h;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(h||(e.ProfileResourceType=h={}));function $(i){const c=i;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&R.URI.isUri(c.location)&&R.URI.isUri(c.globalStorageHome)&&R.URI.isUri(c.settingsResource)&&R.URI.isUri(c.keybindingsResource)&&R.URI.isUri(c.tasksResource)&&R.URI.isUri(c.snippetsHome)&&R.URI.isUri(c.extensionsResource))}e.$Dk=$,e.$Ek=(0,P.$Bh)("IUserDataProfilesService");function d(i,c){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:R.URI.revive(i.location).with({scheme:c}),globalStorageHome:R.URI.revive(i.globalStorageHome).with({scheme:c}),settingsResource:R.URI.revive(i.settingsResource).with({scheme:c}),keybindingsResource:R.URI.revive(i.keybindingsResource).with({scheme:c}),tasksResource:R.URI.revive(i.tasksResource).with({scheme:c}),snippetsHome:R.URI.revive(i.snippetsHome).with({scheme:c}),extensionsResource:R.URI.revive(i.extensionsResource).with({scheme:c}),cacheHome:R.URI.revive(i.cacheHome).with({scheme:c}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Fk=d;function t(i,c,f,y,E,u){return{id:i,name:c,location:f,isDefault:!1,shortName:E?.shortName,globalStorageHome:u&&E?.useDefaultFlags?.globalState?u.globalStorageHome:(0,L.$ig)(f,"globalStorage"),settingsResource:u&&E?.useDefaultFlags?.settings?u.settingsResource:(0,L.$ig)(f,"settings.json"),keybindingsResource:u&&E?.useDefaultFlags?.keybindings?u.keybindingsResource:(0,L.$ig)(f,"keybindings.json"),tasksResource:u&&E?.useDefaultFlags?.tasks?u.tasksResource:(0,L.$ig)(f,"tasks.json"),snippetsHome:u&&E?.useDefaultFlags?.snippets?u.snippetsHome:(0,L.$ig)(f,"snippets"),extensionsResource:u&&E?.useDefaultFlags?.extensions?u.extensionsResource:(0,L.$ig)(f,"extensions.json"),cacheHome:(0,L.$ig)(y,i),useDefaultFlags:E?.useDefaultFlags,isTransient:E?.transient}}e.$Gk=t;let r=class extends g.$kc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(c,f,y,E){super(),this.t=c,this.u=f,this.w=y,this.y=E,this.f=!0,this.h=this.B(new M.$fd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new M.$fd),this.onWillCreateProfile=this.j.event,this.m=this.B(new M.$fd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new M.$fd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new S.$zi,emptyWindows:new Map},this.profilesHome=(0,L.$ig)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$ig)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(c){this.f!==c&&(this.z=void 0,this.f=c)}isEnabled(){return this.f}get C(){if(!this.z){const c=this.D(),f=[c];if(this.f)try{for(const u of this.O()){if(!u.name||!(0,n.$jf)(u.name)||!u.location){this.y.warn("Skipping the invalid stored profile",u.location||u.name);continue}f.push(t((0,L.$fg)(u.location),u.name,u.location,this.g,{shortName:u.shortName,useDefaultFlags:u.useDefaultFlags},c))}}catch(u){this.y.error(u)}const y=new S.$zi,E=new Map;if(f.length)try{const u=this.Q();if(u.workspaces)for(const[l,w]of Object.entries(u.workspaces)){const A=R.URI.parse(l),N=f.find(O=>O.id===w);N&&y.set(A,N)}if(u.emptyWindows)for(const[l,w]of Object.entries(u.emptyWindows)){const A=f.find(N=>N.id===w);A&&E.set(l,A)}}catch(u){this.y.error(u)}this.z={profiles:f,workspaces:y,emptyWindows:E}}return this.z}D(){const c=t("__default__profile__",(0,m.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...c,extensionsResource:this.S()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const f="Temp",y=new RegExp(`${(0,s.$qe)(f)}\\s(\\d+)`);let E=0;for(const l of this.profiles){const w=y.exec(l.name),A=w?parseInt(w[1]):0;E=A>E?A:E}const u=`${f} ${E+1}`;return this.createProfile((0,D.$pi)((0,o.$4f)()).toString(16),u,{transient:!0},c)}async createNamedProfile(c,f,y){return this.createProfile((0,D.$pi)((0,o.$4f)()).toString(16),c,f,y)}async createProfile(c,f,y,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const u=await this.F(c,f,y);return E&&await this.setProfileForWorkspace(E,u),u}async F(c,f,y){if(!(0,n.$jf)(f)||!f)throw new Error("Name of the profile is mandatory and must be of type `string`");let E=this.r.get(f);return E||(E=(async()=>{try{const u=this.profiles.find(A=>A.name===f||A.id===c);if(u)return u;const l=t(c,f,(0,L.$ig)(this.profilesHome,c),this.g,y,this.defaultProfile);await this.u.createFolder(l.location);const w=[];return this.j.fire({profile:l,join(A){w.push(A)}}),await v.Promises.settled(w),this.I([l],[],[]),l}finally{this.r.delete(f)}})(),this.r.set(f,E)),E}async updateProfile(c,f){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let y=this.profiles.find(E=>E.id===c.id);if(!y)throw new Error(`Profile '${c.name}' does not exist`);return y=t(y.id,f.name??y.name,y.location,this.g,{shortName:f.shortName??y.shortName,transient:f.transient??y.isTransient,useDefaultFlags:f.useDefaultFlags??y.useDefaultFlags},this.defaultProfile),this.I([],[],[y]),y}async removeProfile(c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const f=this.profiles.find(E=>E.id===c.id);if(!f)throw new Error(`Profile '${c.name}' does not exist`);const y=[];this.m.fire({profile:f,join(E){y.push(E)}});try{await Promise.allSettled(y)}catch(E){this.y.error(E)}for(const E of[...this.C.emptyWindows.keys()])f.id===this.C.emptyWindows.get(E)?.id&&this.C.emptyWindows.delete(E);for(const E of[...this.C.workspaces.keys()])f.id===this.C.workspaces.get(E)?.id&&this.C.workspaces.delete(E);this.M(),this.I([],[f],[]);try{await this.u.del(f.cacheHome,{recursive:!0})}catch(E){(0,b.$jk)(E)!==1&&this.y.error(E)}}async setProfileForWorkspace(c,f){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=this.profiles.find(E=>E.id===f.id);if(!y)throw new Error(`Profile '${f.name}' does not exist`);this.L(c,y)}unsetWorkspace(c,f){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(c,void 0,f)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const c=await this.u.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(f=>f.isDirectory&&this.profiles.every(y=>!this.w.extUri.isEqual(y.location,f.resource))).map(f=>this.u.del(f.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const c=this.s.profiles.filter(f=>!this.H(f));await Promise.allSettled(c.map(f=>this.removeProfile(f)))}getProfileForWorkspace(c){const f=this.G(c);return R.URI.isUri(f)?this.s.workspaces.get(f)??this.C.workspaces.get(f):this.s.emptyWindows.get(f)??this.C.emptyWindows.get(f)}G(c){return(0,p.$Lh)(c)?c.uri:(0,p.$Qh)(c)?c.configPath:c.id}H(c){return!!([...this.s.emptyWindows.values()].some(f=>this.w.extUri.isEqual(f.location,c.location))||[...this.s.workspaces.values()].some(f=>this.w.extUri.isEqual(f.location,c.location))||[...this.C.emptyWindows.values()].some(f=>this.w.extUri.isEqual(f.location,c.location))||[...this.C.workspaces.values()].some(f=>this.w.extUri.isEqual(f.location,c.location)))}I(c,f,y){const E=[...this.profiles,...c],u=[];this.s.profiles=[];for(let l of E)l.isDefault||f.some(w=>l.id===w.id)||(l=y.find(w=>l.id===w.id)??l,l.isTransient?this.s.profiles.push(l):u.push({location:l.location,name:l.name,shortName:l.shortName,useDefaultFlags:l.useDefaultFlags}));this.P(u),this.z=void 0,this.J(c,f,y)}J(c,f,y){this.h.fire({added:c,removed:f,updated:y,all:this.profiles})}L(c,f,y){y=f?.isTransient?!0:y,y||this.L(c,void 0,!0);const E=this.G(c),u=y?this.s:this.C;R.URI.isUri(E)?(u.workspaces.delete(E),f&&u.workspaces.set(E,f)):(u.emptyWindows.delete(E),f&&u.emptyWindows.set(E,f)),y||this.M()}M(){const c={};for(const[y,E]of this.C.workspaces.entries())c[y.toString()]=E.id;const f={};for(const[y,E]of this.C.emptyWindows.entries())f[y.toString()]=E.id;this.R({workspaces:c,emptyWindows:f}),this.z=void 0}N(c){const f={},y=this.D();if(c.workspaces)for(const[u,l]of Object.entries(c.workspaces)){const w=R.URI.parse(l);f[u]=this.w.extUri.isEqual(w,y.location)?y.id:this.w.extUri.basename(w)}const E={};if(c.emptyWindows)for(const[u,l]of Object.entries(c.emptyWindows)){const w=R.URI.parse(l);E[u]=this.w.extUri.isEqual(w,y.location)?y.id:this.w.extUri.basename(w)}return{workspaces:f,emptyWindows:E}}O(){return[]}P(c){throw new Error("not implemented")}Q(){return{}}R(c){throw new Error("not implemented")}S(){}};e.$Hk=r,e.$Hk=r=Ke([Be(0,k.$Ih),Be(1,b.$6j),Be(2,C.$Ck),Be(3,I.$5i)],r);class a extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(c){this.a=c}Q(){return this.X}R(c){this.X=c}}e.$Ik=a}),define(Se[260],De([1,0,9,4,3,53,18,184,5,259]),function($e,e,D,M,g,L,R,m,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Vo=e.$Uo=e.$To=void 0,e.$To="__$__isNewStorageMarker",e.$Uo="__$__targetStorageMarker",e.$Vo=(0,k.$Bh)("storageService");var P;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var I;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var p;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function S(n){const h=n.get(e.$Uo);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}e.$Wo=S;class C extends g.$kc{static{this.a=60*1e3}constructor(h={flushInterval:C.a}){super(),this.m=h,this.b=this.B(new M.$id),this.c=this.B(new M.$id),this.onDidChangeTarget=this.c.event,this.f=this.B(new M.$fd),this.onWillSaveState=this.f.event,this.h=this.B(new D.$Sg(()=>this.n(),this.m.flushInterval)),this.j=this.B(new g.$lc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(h,$,d){return M.Event.filter(this.b.event,t=>t.scope===h&&($===void 0||t.key===$),d)}n(){this.j.value=(0,D.$Wg)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,g.$fc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(h,$){const{key:d,external:t}=$;if(d===e.$Uo){switch(h){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:h})}else this.b.fire({scope:h,key:d,target:this.J(h)[d],external:t})}w(h){this.f.fire({reason:h})}get(h,$,d){return this.P($)?.get(h,d)}getBoolean(h,$,d){return this.P($)?.getBoolean(h,d)}getNumber(h,$,d){return this.P($)?.getNumber(h,d)}getObject(h,$,d){return this.P($)?.getObject(h,d)}storeAll(h,$){this.y(()=>{for(const d of h)this.store(d.key,d.value,d.scope,d.target,$)})}store(h,$,d,t,r=!1){if((0,R.$sf)($)){this.remove(h,d,r);return}this.y(()=>{this.z(h,d,t),this.P(d)?.set(h,$,r)})}remove(h,$,d=!1){this.y(()=>{this.z(h,$,void 0),this.P($)?.delete(h,d)})}y(h){this.b.pause(),this.c.pause();try{h()}finally{this.b.resume(),this.c.resume()}}keys(h,$){const d=[],t=this.J(h);for(const r of Object.keys(t))t[r]===$&&d.push(r);return d}z(h,$,d,t=!1){const r=this.J($);typeof d=="number"?r[h]!==d&&(r[h]=d,this.P($)?.set(e.$Uo,JSON.stringify(r),t)):typeof r[h]=="number"&&(delete r[h],this.P($)?.set(e.$Uo,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(h){switch(h){case-1:return this.I;case 0:return this.G;default:return this.D}}L(h){const $=this.P(h);return $?S($):Object.create(null)}isNew(h){return this.getBoolean(e.$To,h)===!0}async flush(h=P.NONE){this.f.fire({reason:h});const $=this.P(-1),d=this.P(0),t=this.P(1);switch(h){case P.NONE:await D.Promises.settled([$?.whenFlushed()??Promise.resolve(),d?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await D.Promises.settled([$?.flush(0)??Promise.resolve(),d?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.P(-1)?.items??new Map,$=this.P(0)?.items??new Map,d=this.P(1)?.items??new Map;return s(h,$,d,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(h){return await this.flush(),this.P(h)?.optimize()}async switch(h,$){return this.w(P.NONE),(0,b.$Dk)(h)?this.R(h,$):this.S(h,$)}M(h,$){return!(h.id===$.id||v($)&&v(h))}N(h,$,d){this.y(()=>{const t=new Set;for(const[r,a]of h)t.add(r),$.get(r)!==a&&this.u(d,{key:r,external:!0});for(const[r]of $.items)t.has(r)||this.u(d,{key:r,external:!0})})}}e.$Xo=C;function v(n){return n.isDefault||!!n.useDefaultFlags?.globalState}e.$Yo=v;class o extends C{constructor(){super(),this.U=this.B(new m.$Ro(new m.$So,{hint:m.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new m.$Ro(new m.$So,{hint:m.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new m.$Ro(new m.$So,{hint:m.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(h=>this.u(1,h))),this.B(this.W.onDidChangeStorage(h=>this.u(0,h))),this.B(this.U.onDidChangeStorage(h=>this.u(-1,h)))}P(h){switch(h){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(h){return!1}}e.$Zo=o;async function s(n,h,$,d,t,r){const a=A=>{try{return JSON.parse(A)}catch{return A}},i=new Map,c=new Map;n.forEach((A,N)=>{i.set(N,A),c.set(N,a(A))});const f=new Map,y=new Map;h.forEach((A,N)=>{f.set(N,A),y.set(N,a(A))});const E=new Map,u=new Map;$.forEach((A,N)=>{E.set(N,A),u.set(N,a(A))}),console.group(d!==t?`Storage: Application (path: ${d})`:`Storage: Application & Profile (path: ${d}, default profile)`);const l=[];if(i.forEach((A,N)=>{l.push({key:N,value:A})}),console.table(l),console.groupEnd(),console.log(c),d!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const A=[];f.forEach((N,O)=>{A.push({key:O,value:N})}),console.table(A),console.groupEnd(),console.log(y)}console.group(`Storage: Workspace (path: ${r})`);const w=[];E.forEach((A,N)=>{w.push({key:N,value:A})}),console.table(w),console.groupEnd(),console.log(u)}e.$1o=s}),define(Se[87],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zac=void 0;class D{static{this.a=!1}constructor(g){this.d=g,this.b=new Map,this.c=1}add(g){const L=this.c++;return this.b.set(L,g),this.e(),L}get(g,L){return this.b.has(g)?this.b.get(g)[L]:void 0}delete(g){this.b.delete(g),this.e()}e(){D.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Zac=D}),define(Se[54],De([1,0,17,24,5]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ac=e.$2ac=void 0;class L{constructor(){this.a=new Set(Object.keys(D.Schemas)),this.b=new Map,this.extUri=new M.$0f(m=>{const k=this.b.get(m.scheme);return!(k===void 0||k&1024)})}$acceptProviderInfos(m,k){k===null?this.b.delete(m.scheme):this.b.set(m.scheme,k)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$2ac=L,e.$3ac=(0,g.$Bh)("IExtHostFileSystemInfo")}),define(Se[26],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fM=void 0,e.$fM=(0,D.$Bh)("IExtHostInitDataService")}),define(Se[261],De([1,0,206,14,241,26]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;let R=class extends g.$mN{constructor(k,b,P){const I=P.remote.isRemote?"remoteexthost":k?"workerexthost":"exthost",p=P.remote.isRemote?(0,D.localize)(0,null):k?(0,D.localize)(1,null):(0,D.localize)(2,null);super(b.createLogger(I,{name:p}))}};e.$0cc=R,e.$0cc=R=Ke([Be(1,M.$6i),Be(2,L.$fM)],R)}),define(Se[262],De([1,0,9]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tbc=e.$sbc=void 0;class M{constructor(R,m,k){this.h=new Map,this.a=R,this.b=m,this.c=k,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(b=>(this.f=b,this)),this.g=this.c.onDidChangeStorage(b=>{b.shared===this.b&&b.key===this.a&&(this.f=b.value)}),this.i=new D.$Sg(()=>{const b=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const P of b.values())P.complete()}catch(P){for(const I of b.values())I.error(P)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,m){let k=this.f[R];return typeof k>"u"&&(k=m),k}update(R,m){this.f[R]=m;const k=this.h.get(R);if(k!==void 0)return k.p;const b=new D.$2g;return this.h.set(R,b),this.i.isScheduled()||this.i.schedule(),b.p}dispose(){this.g.dispose()}}e.$sbc=M;class g extends M{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,m){super(R.identifier.value,!0,m),this.j=R}}e.$tbc=g}),define(Se[263],De([1,0,4,2]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=void 0;class g{constructor(R){this.c=R,this.a=new D.$fd,this.onDidSaveNotebookDocument=this.a.event,this.b=new D.$fd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,m,k,b){const I=this.c.getNotebookDocument(M.URI.revive(R)).acceptModelChanged(m.value,k,b);this.b.fire(I)}$acceptDirtyStateChanged(R,m){this.c.getNotebookDocument(M.URI.revive(R)).acceptDirty(m)}$acceptModelSaved(R){const m=this.c.getNotebookDocument(M.URI.revive(R));this.a.fire(m.apiNotebook)}}e.$Rcc=g}),define(Se[20],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3L=e.$2L=void 0,e.$2L=(0,D.$Bh)("IExtHostRpcService");class M{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$3L=M}),define(Se[264],De([1,0,25,4]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=void 0;class g{#e;constructor(R,m){this.b=new M.$fd,this.onDidChange=this.b.event,this.a=D.$Vl.toKey(R.identifier),this.#e=m,this.#e.onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(R){return this.#e.get(this.a,R)}store(R,m){return this.#e.store(this.a,R,m)}delete(R){return this.#e.delete(this.a,R)}}e.$Ebc=g}),define(Se[68],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bbc=e.$abc=void 0,e.$abc=(0,D.$Bh)("IURITransformerService");class M{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$bbc=M}),define(Se[265],De([1,0,22]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bb=e.$9bb=void 0;class M{constructor(){this.buffers=[]}add(k){let b=this.buffers.indexOf(k);return b<0&&(b=this.buffers.length,this.buffers.push(k)),b}}function g(m,k){if(k.serializeBuffersForPostMessage){const b=new M,I=JSON.stringify(m,(S,C)=>{if(C instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:b.add(C)};if(ArrayBuffer.isView(C)){const v=L(C);if(v)return{$$vscode_array_buffer_reference$$:!0,index:b.add(C.buffer),view:{type:v,byteLength:C.byteLength,byteOffset:C.byteOffset}}}return C}),p=b.buffers.map(S=>{const C=new Uint8Array(S);return D.$Fd.wrap(C)});return{message:I,buffers:p}}else return{message:JSON.stringify(m),buffers:[]}}e.$9bb=g;function L(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(m,k){const b=k.map(p=>{const S=new ArrayBuffer(p.byteLength);return new Uint8Array(S).set(p.buffer),S}),P=k.length?(p,S)=>{if(S&&typeof S=="object"&&S.$$vscode_array_buffer_reference$$){const C=S,{index:v}=C,o=b[v];if(C.view)switch(C.view.type){case 1:return new Int8Array(o,C.view.byteOffset,C.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,C.view.byteOffset,C.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,C.view.byteOffset,C.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,C.view.byteOffset,C.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,C.view.byteOffset,C.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,C.view.byteOffset,C.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,C.view.byteOffset,C.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,C.view.byteOffset,C.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,C.view.byteOffset,C.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,C.view.byteOffset,C.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,C.view.byteOffset,C.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return S}:void 0;return{message:JSON.parse(m,P),arrayBuffers:b}}e.$0bb=R}),define(Se[266],De([1,0,267,374,375,61,2,14,376]),function($e,e,D,M,g,L,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=void 0;const b=!0;function P(h,$,d,t,r,a){const i=a.environment.useHostProxy,c=typeof i=="boolean"?i:!a.remote.isRemote,f={resolveProxy:u=>h.resolveProxy(u),lookupProxyAuthorization:o.bind(void 0,t,r,$,{},a.remote.isRemote),getProxyURL:()=>$.getConfiguration("http").get("proxy"),getProxySupport:()=>$.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>p($),getSystemCertificatesV2:()=>S($),log:(u,l,...w)=>{switch(u){case k.LogLevel.Trace:t.trace(l,...w);break;case k.LogLevel.Debug:t.debug(l,...w);break;case k.LogLevel.Info:t.info(l,...w);break;case k.LogLevel.Warning:t.warn(l,...w);break;case k.LogLevel.Error:t.error(l,...w);break;case k.LogLevel.Critical:t.error(l,...w);break;case k.LogLevel.Off:break;default:A(u,l,w);break}function A(N,O,...F){t.error("Unknown log level",N),t.error(O,...F)}},getLogLevel:()=>{const u=t.getLevel();switch(u){case m.LogLevel.Trace:return k.LogLevel.Trace;case m.LogLevel.Debug:return k.LogLevel.Debug;case m.LogLevel.Info:return k.LogLevel.Info;case m.LogLevel.Warning:return k.LogLevel.Warning;case m.LogLevel.Error:return k.LogLevel.Error;case m.LogLevel.Off:return k.LogLevel.Off;default:return l(u)}function l(w){return t.error("Unknown log level",w),k.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:c,addCertificates:[],env:process.env},y=(0,k.createProxyResolver)(f),E=I(f,y);return v(d,E)}e.$Fdc=P;function I(h,$){return{http:Object.assign(D,(0,k.createHttpPatch)(h,D,$)),https:Object.assign(M,(0,k.createHttpPatch)(h,M,$)),net:Object.assign(L,(0,k.createNetPatch)(h,L)),tls:Object.assign(g,(0,k.createTlsPatch)(h,g))}}function p(h){const $=h.getConfiguration("http");return!$.get("experimental.systemCertificatesV2",b)&&!!$.get("systemCertificates")}function S(h){const $=h.getConfiguration("http");return!!$.get("experimental.systemCertificatesV2",b)&&!!$.get("systemCertificates")}const C=new Map;function v(h,$){return h.getExtensionPathIndex().then(d=>{const t=globalThis._VSCODE_NODE_MODULES.module,r=t._load;t._load=function(i,c,f){if(i==="net")return $.net;if(i==="tls")return $.tls;if(i!=="http"&&i!=="https")return r.apply(this,arguments);const y=d.findSubstr(R.URI.file(c.filename));let E=C.get(y);if(E||C.set(y,E={}),!E[i]){const u=$[i];E[i]={...u}}return E[i]}})}async function o(h,$,d,t,r,a,i,c){const f=t[a];i&&(t[a]=i),h.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${a}`,`proxyAuthenticate:${i}`,`proxyAuthenticateCache:${f}`);const y=i||f,E=Array.isArray(y)?y:typeof y=="string"?[y]:[];if(n($,E,r),E.some(u=>/^(Negotiate|Kerberos)( |$)/i.test(u))&&!c.kerberosRequested)try{c.kerberosRequested=!0;const u=await new Promise((O,F)=>{$e(["kerberos"],O,F)}),l=new URL(a),w=d.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${l.hostname}`:`HTTP@${l.hostname}`);return h.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${a}`,`spn:${w}`),"Negotiate "+await(await u.initializeClient(w)).step("")}catch(u){h.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",u)}}let s=!1;function n(h,$,d){s||!$.length||(s=!0,h.$publicLog2("proxyAuthenticationRequest",{authenticationType:$.map(t=>t.split(" ")[0]).join(","),extensionHostType:d?"remote":"local"}))}}),define(Se[268],De([1,0,128]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;function M(L){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:L,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function g(L){return new D.$Bm(M(L))}e.$qr=g}),define(Se[139],De([1,0,216,18,2,3,5,42,30,17,46,176,38]),function($e,e,D,M,g,L,R,m,k,b,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7E=e.$6E=e.$5E=e.EditorsOrder=e.$4E=e.CloseDirection=e.$3E=e.$2E=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=e.$UE=e.$TE=e.EditorInputCapabilities=e.$SE=e.SaveReason=e.Verbosity=e.$RE=e.$QE=e.$PE=e.$OE=e.$NE=e.$ME=e.$LE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$KE=e.$JE=e.$IE=e.$HE=e.$GE=void 0,e.$GE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$HE={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$IE="workbench.editor.sidebysideEditor",e.$JE="workbench.editors.textDiffEditor",e.$KE="workbench.editors.binaryResourceDiffEditor";var S;(function(ue){ue[ue.PROGRAMMATIC=1]="PROGRAMMATIC",ue[ue.USER=2]="USER",ue[ue.EDIT=3]="EDIT",ue[ue.NAVIGATION=4]="NAVIGATION",ue[ue.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var C;(function(ue){ue[ue.IDENTICAL=1]="IDENTICAL",ue[ue.SIMILAR=2]="SIMILAR",ue[ue.DIFFERENT=3]="DIFFERENT"})(C||(e.EditorPaneSelectionCompareResult=C={}));function v(ue){const we=ue;return!!we&&typeof we.getSelection=="function"&&!!we.onDidChangeSelection}e.$LE=v;function o(ue,we,G){for(const U of G.visibleEditorPanes)if(U.group.id===we&&ue.matches(U.input))return U.getViewState()}e.$ME=o;function s(ue){if(f(ue))return!1;const we=ue;return g.URI.isUri(we?.resource)}e.$NE=s;function n(ue){if(f(ue))return!1;const we=ue;return we?.original!==void 0&&we.modified!==void 0}e.$OE=n;function h(ue){if(f(ue)||n(ue))return!1;const we=ue;return we?.primary!==void 0&&we.secondary!==void 0}e.$PE=h;function $(ue){if(f(ue))return!1;const we=ue;return we?we.resource===void 0||we.resource.scheme===b.Schemas.untitled||we.forceUntitled===!0:!1}e.$QE=$;function d(ue){if(f(ue))return!1;const we=ue;return g.URI.isUri(we?.base?.resource)&&g.URI.isUri(we?.input1?.resource)&&g.URI.isUri(we?.input2?.resource)&&g.URI.isUri(we?.result?.resource)}e.$RE=d;var t;(function(ue){ue[ue.SHORT=0]="SHORT",ue[ue.MEDIUM=1]="MEDIUM",ue[ue.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var r;(function(ue){ue[ue.EXPLICIT=1]="EXPLICIT",ue[ue.AUTO=2]="AUTO",ue[ue.FOCUS_CHANGE=3]="FOCUS_CHANGE",ue[ue.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r||(e.SaveReason=r={}));class a{constructor(){this.a=new Map}registerSource(we,G){let U=this.a.get(we);return U||(U={source:we,label:G},this.a.set(we,U)),U.source}getSourceLabel(we){return this.a.get(we)?.label??we}}e.$SE=new a;var i;(function(ue){ue[ue.None=0]="None",ue[ue.Readonly=2]="Readonly",ue[ue.Untitled=4]="Untitled",ue[ue.Singleton=8]="Singleton",ue[ue.RequiresTrust=16]="RequiresTrust",ue[ue.CanSplitInGroup=32]="CanSplitInGroup",ue[ue.ForceDescription=64]="ForceDescription",ue[ue.CanDropIntoEditor=128]="CanDropIntoEditor",ue[ue.MultipleEditors=256]="MultipleEditors",ue[ue.Scratchpad=512]="Scratchpad"})(i||(e.EditorInputCapabilities=i={}));class c extends L.$kc{}e.$TE=c;function f(ue){return ue instanceof c}e.$UE=f;function y(ue){const we=ue;return g.URI.isUri(we?.preferredResource)}function E(ue){const we=ue;return f(we?.primary)&&f(we?.secondary)}e.$VE=E;function u(ue){const we=ue;return f(we?.modified)&&f(we?.original)}e.$WE=u;function l(ue,we,G,U,K){return ge(U,[(0,I.$li)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const fe={...G,limits:{size:Number.MAX_VALUE}};ue.openEditor(we,fe)}}),(0,I.$li)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>K.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}e.$XE=l;function w(ue){return f(ue?.editor)}e.$YE=w;function A(ue){const we=ue;return w(ue)&&we?.group!==void 0}e.$ZE=A;function N(ue){const we=ue;return typeof we?.groupId=="number"&&f(we.editor)}e.$1E=N;var O;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.REPLACE=1]="REPLACE",ue[ue.MOVE=2]="MOVE",ue[ue.UNPIN=3]="UNPIN"})(O||(e.EditorCloseContext=O={}));var F;(function(ue){ue[ue.GROUP_ACTIVE=0]="GROUP_ACTIVE",ue[ue.GROUP_INDEX=1]="GROUP_INDEX",ue[ue.GROUP_LOCKED=2]="GROUP_LOCKED",ue[ue.EDITOR_OPEN=3]="EDITOR_OPEN",ue[ue.EDITOR_CLOSE=4]="EDITOR_CLOSE",ue[ue.EDITOR_MOVE=5]="EDITOR_MOVE",ue[ue.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ue[ue.EDITOR_LABEL=7]="EDITOR_LABEL",ue[ue.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ue[ue.EDITOR_PIN=9]="EDITOR_PIN",ue[ue.EDITOR_STICKY=10]="EDITOR_STICKY",ue[ue.EDITOR_DIRTY=11]="EDITOR_DIRTY",ue[ue.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var j;(function(ue){ue[ue.PRIMARY=1]="PRIMARY",ue[ue.SECONDARY=2]="SECONDARY",ue[ue.BOTH=3]="BOTH",ue[ue.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class z{getOriginalUri(we,G){if(!we)return;if(d(we))return e.$3E.getOriginalUri(we.result,G);if(G?.supportSideBySide){const{primary:K,secondary:fe}=this.a(we);if(K&&fe){if(G?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(K,{filterByScheme:G.filterByScheme}),secondary:this.getOriginalUri(fe,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===j.ANY)return this.getOriginalUri(K,{filterByScheme:G.filterByScheme})??this.getOriginalUri(fe,{filterByScheme:G.filterByScheme});we=G.supportSideBySide===j.PRIMARY?K:fe}}if(n(we)||h(we)||d(we))return;const U=y(we)?we.preferredResource:we.resource;return!U||!G||!G.filterByScheme?U:this.b(U,G.filterByScheme)}a(we){return E(we)||h(we)?{primary:we.primary,secondary:we.secondary}:u(we)||n(we)?{primary:we.modified,secondary:we.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(we,G){if(!we)return;if(d(we))return e.$3E.getCanonicalUri(we.result,G);if(G?.supportSideBySide){const{primary:K,secondary:fe}=this.a(we);if(K&&fe){if(G?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(K,{filterByScheme:G.filterByScheme}),secondary:this.getCanonicalUri(fe,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===j.ANY)return this.getCanonicalUri(K,{filterByScheme:G.filterByScheme})??this.getCanonicalUri(fe,{filterByScheme:G.filterByScheme});we=G.supportSideBySide===j.PRIMARY?K:fe}}if(n(we)||h(we)||d(we))return;const U=we.resource;return!U||!G||!G.filterByScheme?U:this.b(U,G.filterByScheme)}b(we,G){if(Array.isArray(G)){if(G.some(U=>we.scheme===U))return we}else if(G===we.scheme)return we}}var T;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.KEYBOARD=1]="KEYBOARD",ue[ue.MOUSE=2]="MOUSE"})(T||(e.EditorCloseMethod=T={}));function H(ue,we,G,U){if(!ue.isSticky(we))return!1;switch(U.preventPinnedEditorClose){case"keyboardAndMouse":return G===T.MOUSE||G===T.KEYBOARD;case"mouse":return G===T.MOUSE;case"keyboard":return G===T.KEYBOARD}return!1}e.$2E=H,e.$3E=new z;var q;(function(ue){ue[ue.LEFT=0]="LEFT",ue[ue.RIGHT=1]="RIGHT"})(q||(e.CloseDirection=q={}));class me{constructor(){this.c=new Map,this.d=new Map}start(we){const G=this.a=we.get(R.$Ah);for(const[U,K]of this.c)this.e(U,K,G);this.c.clear()}e(we,G,U){const K=U.createInstance(G);this.d.set(we,K)}registerFileEditorFactory(we){if(this.b)throw new Error("Can only register one file editor factory.");this.b=we}getFileEditorFactory(){return(0,M.$uf)(this.b)}registerEditorSerializer(we,G){if(this.c.has(we)||this.d.has(we))throw new Error(`A editor serializer with type ID '${we}' was already registered.`);return this.a?this.e(we,G,this.a):this.c.set(we,G),(0,L.$ic)(()=>{this.c.delete(we),this.d.delete(we)})}getEditorSerializer(we){return this.d.get(typeof we=="string"?we:we.typeId)}}m.$8m.add(e.$GE.EditorFactory,new me);async function X(ue,we,G){return!ue||!ue.length?[]:await Promise.all(ue.map(async U=>{const K=g.URI.revive(U.fileUri);if(!K){G.info("Cannot resolve the path because it is not valid.",U);return}if(!await we.canHandleResource(K)){G.info("Cannot resolve the path because it cannot be handled",U);return}let te=U.exists,re=U.type;if(typeof te!="boolean"||typeof re!="number")try{re=(await we.stat(K)).isDirectory?k.FileType.Directory:k.FileType.Unknown,te=!0}catch(Ee){G.error(Ee),te=!1}if(!te&&U.openOnlyIfExists){G.info("Cannot resolve the path because it does not exist",U);return}if(re===k.FileType.Directory){G.info("Cannot resolve the path because it is a directory",U);return}const ne={...U.options,pinned:!0};return te?{resource:K,options:ne}:{resource:K,options:ne,forceUntitled:!0}}))}e.$4E=X;var Z;(function(ue){ue[ue.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ue[ue.SEQUENTIAL=1]="SEQUENTIAL"})(Z||(e.EditorsOrder=Z={}));function V(ue){const we=ue;if(!we)return!1;const G=we;if(G.modified)return V(G.modified);const U=we;return!!(U.contributionsState&&U.viewState&&Array.isArray(U.cursorState))}e.$5E=V;function x(ue){return(0,P.$ni)(ue)}e.$6E=x;function ge(ue,we,G){const U=(0,P.$oi)(ue,we);return U.forceMessage=G?.forceMessage,U.forceSeverity=G?.forceSeverity,U.allowDialog=G?.allowDialog,U}e.$7E=ge}),define(Se[269],De([1,0,4,217,5,3,28,42,19,56,23,79,255]),function($e,e,D,M,g,L,R,m,k,b,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bF=e.$aF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$_E=e.$$E=e.ViewContentGroups=e.$0E=e.$9E=e.ViewContainerLocation=e.Extensions=e.$8E=void 0,e.$8E=(0,p.$9u)("default-view-icon",I.$Pj.window,(0,M.localize)(0,null));var S;(function(a){a.ViewContainersRegistry="workbench.registry.view.containers",a.ViewsRegistry="workbench.registry.view"})(S||(e.Extensions=S={}));var C;(function(a){a[a.Sidebar=0]="Sidebar",a[a.Panel=1]="Panel",a[a.AuxiliaryBar=2]="AuxiliaryBar"})(C||(e.ViewContainerLocation=C={})),e.$9E=[0,1,2];function v(a){switch(a){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$0E=v;class o extends L.$kc{constructor(){super(...arguments),this.c=this.B(new D.$fd),this.onDidRegister=this.c.event,this.f=this.B(new D.$fd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,k.$Pb)([...this.g.values()])}registerViewContainer(i,c,f){const y=this.get(i.id);if(y)return y;const E=i;return E.openCommandActionDescriptor=f?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,R.$wi)(this.g,c,[]).push(E),f?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:c}),E}deregisterViewContainer(i){for(const c of this.g.keys()){const f=this.g.get(c),y=f?.indexOf(i);if(y!==-1){f?.splice(y,1),f.length===0&&this.g.delete(c),this.f.fire({viewContainer:i,viewContainerLocation:c});return}}}get(i){return this.all.filter(c=>c.id===i)[0]}getViewContainers(i){return[...this.g.get(i)||[]]}getViewContainerLocation(i){return[...this.g.keys()].filter(c=>this.getViewContainers(c).filter(f=>f?.id===i.id).length>0)[0]}getDefaultViewContainer(i){return this.h.find(c=>this.getViewContainerLocation(c)===i)}}m.$8m.add(S.ViewContainersRegistry,new o);var s;(function(a){a.Open="2_open",a.Debug="4_debug",a.SCM="5_scm",a.More="9_more"})(s||(e.ViewContentGroups=s={}));function n(a,i){const c=a.group??s.More,f=i.group??s.More;return c!==f?c.localeCompare(f):(a.order??5)-(i.order??5)}class h extends L.$kc{constructor(){super(...arguments),this.c=this.B(new D.$fd),this.onViewsRegistered=this.c.event,this.f=this.B(new D.$fd),this.onViewsDeregistered=this.f.event,this.g=this.B(new D.$fd),this.onDidChangeContainer=this.g.event,this.h=this.B(new D.$fd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new b.$L}registerViews(i,c){this.registerViews2([{views:i,viewContainer:c}])}registerViews2(i){i.forEach(({views:c,viewContainer:f})=>this.r(c,f)),this.c.fire(i)}deregisterViews(i,c){const f=this.s(i,c);f.length&&this.f.fire({views:f,viewContainer:c})}moveViews(i,c){for(const f of this.m.keys())if(f!==c){const y=this.s(i,f);y.length&&(this.r(y,c),this.g.fire({views:y,from:f,to:c}))}}getViews(i){return this.m.get(i)||[]}getView(i){for(const c of this.j){const f=(this.m.get(c)||[]).filter(y=>y.id===i)[0];if(f)return f}return null}getViewContainer(i){for(const c of this.j)if((this.m.get(c)||[]).filter(y=>y.id===i)[0])return c;return null}registerViewWelcomeContent(i,c){return this.n.add(i,c),this.h.fire(i),(0,L.$ic)(()=>{this.n.delete(i,c),this.h.fire(i)})}registerViewWelcomeContent2(i,c){const f=new Map;for(const[y,E]of c)this.n.add(i,E),f.set(y,(0,L.$ic)(()=>{this.n.delete(i,E),this.h.fire(i)}));return this.h.fire(i),f}getViewWelcomeContent(i){const c=[];return this.n.forEach(i,f=>c.push(f)),c.sort(n)}r(i,c){let f=this.m.get(c);f||(f=[],this.m.set(c,f),this.j.push(c));for(const y of i){if(this.getView(y.id)!==null)throw new Error((0,M.localize)(1,null,y.id));f.push(y)}}s(i,c){const f=this.m.get(c);if(!f)return[];const y=[],E=[];for(const u of f)i.includes(u)?y.push(u):E.push(u);return y.length&&(E.length?this.m.set(c,E):(this.m.delete(c),this.j.splice(this.j.indexOf(c),1))),y}}m.$8m.add(S.ViewsRegistry,new h),e.$$E=(0,g.$Bh)("viewsService"),e.$_E=(0,g.$Bh)("viewDescriptorService");var $;(function(a){a[a.Default=0]="Default",a[a.Expand=1]="Expand"})($||(e.ViewVisibilityState=$={}));var d;(function(a){a[a.None=0]="None",a[a.Collapsed=1]="Collapsed",a[a.Expanded=2]="Expanded"})(d||(e.TreeItemCollapsibleState=d={}));class t{constructor(i,c){this.c=!1,this.d=!1,(0,P.$Ym)(this,i),this.d=!!c,this.resolve=async f=>{if(c&&!this.c){const y=await c(f);y&&(this.tooltip=this.tooltip??y.tooltip,this.command=this.command??y.command)}f.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$aF=t;class r extends Error{constructor(i){super((0,M.localize)(2,null,i)),this.name="NoTreeViewError"}static is(i){return i.name==="NoTreeViewError"}}e.$bF=r}),define(Se[140],De([1,0,4,9,218]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new D.$fd,this.n=new D.$fd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(m){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=m}onEvent(m){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=m}onRequest(m){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.s("response",m)}sendRequest(m,k,b,P){const I={command:m};if(k&&Object.keys(k).length>0&&(I.arguments=k),this.s("request",I),typeof P=="number"){const p=setTimeout(()=>{clearTimeout(p);const S=this.f.get(I.seq);if(S){this.f.delete(I.seq);const C={type:"response",seq:0,request_seq:I.seq,success:!1,command:m,message:(0,g.localize)(0,null,P,m)};S(C)}},P)}return b&&this.f.set(I.seq,b),I.seq}acceptMessage(m){this.j?this.j(m):(this.k.push(m),this.k.length===1&&this.q())}o(m,k){return m.type!=="event"||k.type!=="event"}async q(){let m;for(;this.k.length;){if((!m||this.o(this.k[0],m))&&await(0,M.$Hg)(0),m=this.k.shift(),!m)return;switch(m.type){case"event":this.i?.(m);break;case"request":this.g?.(m);break;case"response":{const k=m,b=this.f.get(k.request_seq);b&&(this.f.delete(k.request_seq),b(k));break}}}}s(m,k){k.type=m,k.seq=this.d++,this.sendMessage(k)}async u(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((k,b)=>m.set(b,k)),await(0,M.$Hg)(500),m.forEach((k,b)=>{k({type:"response",seq:0,request_seq:b,success:!1,command:"canceled",message:"canceled"}),this.f.delete(b)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Ccb=L}),define(Se[270],De([1,0,219,41,5]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$nH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$mH=e.MemoryRangeType=e.$lH=e.State=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=void 0,e.$jG="workbench.view.debug",e.$kG="workbench.debug.variablesView",e.$lG="workbench.debug.watchExpressionsView",e.$mG="workbench.debug.callStackView",e.$nG="workbench.debug.loadedScriptsView",e.$oG="workbench.debug.breakPointsView",e.$pG="workbench.debug.disassemblyView",e.$qG="workbench.panel.repl",e.$rG="workbench.panel.repl.view",e.$sG=new M.$2i("debugType",void 0,{type:"string",description:D.localize(0,null)}),e.$tG=new M.$2i("debugConfigurationType",void 0,{type:"string",description:D.localize(1,null)}),e.$uG=new M.$2i("debugState","inactive",{type:"string",description:D.localize(2,null)}),e.$vG="debugUx",e.$wG=new M.$2i(e.$vG,"default",{type:"string",description:D.localize(3,null)}),e.$xG=new M.$2i("hasDebugged",!1,{type:"boolean",description:D.localize(4,null)}),e.$yG=new M.$2i("inDebugMode",!1,{type:"boolean",description:D.localize(5,null)}),e.$zG=new M.$2i("inDebugRepl",!1,{type:"boolean",description:D.localize(6,null)}),e.$AG=new M.$2i("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(7,null)}),e.$BG=new M.$2i("inBreakpointWidget",!1,{type:"boolean",description:D.localize(8,null)}),e.$CG=new M.$2i("breakpointsFocused",!0,{type:"boolean",description:D.localize(9,null)}),e.$DG=new M.$2i("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(10,null)}),e.$EG=new M.$2i("watchExpressionsExist",!1,{type:"boolean",description:D.localize(11,null)}),e.$FG=new M.$2i("variablesFocused",!0,{type:"boolean",description:D.localize(12,null)}),e.$GG=new M.$2i("expressionSelected",!1,{type:"boolean",description:D.localize(13,null)}),e.$HG=new M.$2i("breakpointInputFocused",!1,{type:"boolean",description:D.localize(14,null)}),e.$IG=new M.$2i("callStackItemType",void 0,{type:"string",description:D.localize(15,null)}),e.$JG=new M.$2i("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(16,null)}),e.$KG=new M.$2i("callStackItemStopped",!1,{type:"boolean",description:D.localize(17,null)}),e.$LG=new M.$2i("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(18,null)}),e.$MG=new M.$2i("watchItemType",void 0,{type:"string",description:D.localize(19,null)}),e.$NG=new M.$2i("canViewMemory",void 0,{type:"boolean",description:D.localize(20,null)}),e.$OG=new M.$2i("breakpointItemType",void 0,{type:"string",description:D.localize(21,null)}),e.$PG=new M.$2i("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(22,null)}),e.$QG=new M.$2i("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(23,null)}),e.$RG=new M.$2i("loadedScriptsItemType",void 0,{type:"string",description:D.localize(24,null)}),e.$SG=new M.$2i("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(25,null)}),e.$TG=new M.$2i("stepBackSupported",!1,{type:"boolean",description:D.localize(26,null)}),e.$UG=new M.$2i("restartFrameSupported",!1,{type:"boolean",description:D.localize(27,null)}),e.$VG=new M.$2i("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(28,null)}),e.$WG=new M.$2i("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(29,null)}),e.$XG=new M.$2i("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(30,null)}),e.$YG=new M.$2i("breakpointsExist",!1,{type:"boolean",description:D.localize(31,null)}),e.$ZG=new M.$2i("debuggersAvailable",!1,{type:"boolean",description:D.localize(32,null)}),e.$1G=new M.$2i("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(33,null)}),e.$2G=new M.$2i("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(34,null)}),e.$3G=new M.$2i("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(35,null)}),e.$4G=new M.$2i("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(36,null)}),e.$5G=new M.$2i("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(37,null)}),e.$6G=new M.$2i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(38,null)}),e.$7G=new M.$2i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(39,null)}),e.$8G=new M.$2i("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(40,null)}),e.$9G=new M.$2i("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(41,null)}),e.$0G=new M.$2i("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(42,null)}),e.$$G=new M.$2i("variableIsReadonly",!1,{type:"boolean",description:D.localize(43,null)}),e.$_G=new M.$2i("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(44,null)}),e.$aH=new M.$2i("multiSessionRepl",!1,{type:"boolean",description:D.localize(45,null)}),e.$bH=new M.$2i("multiSessionDebug",!1,{type:"boolean",description:D.localize(46,null)}),e.$cH=new M.$2i("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(47,null)}),e.$dH=new M.$2i("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(48,null)}),e.$eH=new M.$2i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(49,null)}),e.$fH=new M.$2i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(50,null)});const L=p=>D.localize(51,null,p);e.$gH=L,e.$hH="editor.contrib.debug",e.$iH="editor.contrib.breakpoint",e.$jH="debug",e.$kH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(52,null)};var R;(function(p){p[p.Inactive=0]="Inactive",p[p.Initializing=1]="Initializing",p[p.Stopped=2]="Stopped",p[p.Running=3]="Running"})(R||(e.State=R={}));function m(p){switch(p){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$lH=m;var k;(function(p){p[p.Valid=0]="Valid",p[p.Unreadable=1]="Unreadable",p[p.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$mH="vscode-debug-memory";var b;(function(p){p[p.Initial=1]="Initial",p[p.Dynamic=2]="Dynamic"})(b||(e.DebugConfigurationProviderTriggerKind=b={}));var P;(function(p){p.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$nH=(0,g.$Bh)("debugService");var I;(function(p){p[p.CONDITION=0]="CONDITION",p[p.HIT_COUNT=1]="HIT_COUNT",p[p.LOG_MESSAGE=2]="LOG_MESSAGE"})(I||(e.BreakpointWidgetContext=I={}))}),define(Se[271],De([1,0,15,2,16,23,17,34,21,19]),function($e,e,D,M,g,L,R,m,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=void 0;const P=/{([^}]+)}/g;function I(E,u,l){return E.replace(P,function(w,A){return u&&A.length>0&&A[0]!=="_"?w:l&&l.hasOwnProperty(A)?l[A]:w})}e.$iF=I;function p(E){const u={};for(const l of Object.keys(E))l.startsWith("!")||(u[l]=E[l]);return u}e.$jF=p;function S(E){return E.configuration.request==="attach"&&!C(E)&&(!E.parentSession||S(E.parentSession))}e.$kF=S;function C(E){let u=E.configuration.type;if(u)return u==="vslsShare"&&(u=E.configuration.adapterProxy.configuration.type),(0,D.$Me)(u,"extensionhost")||(0,D.$Me)(u,"pwa-extensionhost")?E:E.parentSession?C(E.parentSession):void 0}e.$lF=C;function v(E){return E.type&&(E.label||E.program||E.runtime)}e.$mF=v;function o(E,u,l){let w,A=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let O=null;for(;O=N.exec(E);){const F=O.index+1,j=F+O[0].length;if(F<=u&&j>=l){w=O[0],A=F;break}}if(w){const F=/\w+/g;let j=null;for(;(j=F.exec(w))&&!(j.index+1+A+j[0].length>=l););j&&(w=w.substring(0,F.lastIndex))}return w?{start:A,end:A+w.length-1}:{start:0,end:0}}e.$nF=o;async function s(E,u,l,w){if(E.evaluatableExpressionProvider.has(u)){const A=E.evaluatableExpressionProvider.ordered(u),N=(0,b.$Fb)(await Promise.all(A.map(async O=>{try{return await O.provideEvaluatableExpression(u,l,w??k.CancellationToken.None)}catch{return}})));if(N.length>0){let O=N[0].expression;const F=N[0].range;return O||(O=u.getLineContent(l.lineNumber).substring(F.startColumn-1,F.endColumn-1)),{range:F,matchingExpression:O}}}else{const A=u.getLineContent(l.lineNumber),{start:N,end:O}=o(A,l.column,l.column),F=A.substring(N-1,O);return{matchingExpression:F,range:new m.$ks(l.lineNumber,N,l.lineNumber,N+F.length)}}return null}e.$oF=s;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(E){return!!(E&&E.match(n))}e.$pF=h;function $(E){if(typeof E.path=="string"&&!(typeof E.sourceReference=="number"&&E.sourceReference>0)){if(h(E.path))return M.URI.parse(E.path);if((0,g.$8d)(E.path))return M.URI.file(E.path)}return E.path}function d(E){if(typeof E.path=="object"){const u=M.URI.revive(E.path);if(u)return u.scheme===R.Schemas.file?u.fsPath:u.toString()}return E.path}function t(E,u){const l=u?$:d,w=(0,L.$Vm)(E);return a(w,(A,N)=>{A&&N&&(N.path=l(N))}),w}e.$qF=t;function r(E,u){const l=u?$:d,w=(0,L.$Vm)(E);return a(w,(A,N)=>{!A&&N&&(N.path=l(N))}),w}e.$rF=r;function a(E,u){switch(E.type){case"event":{const l=E;switch(l.event){case"output":u(!1,l.body.source);break;case"loadedSource":u(!1,l.body.source);break;case"breakpoint":u(!1,l.body.breakpoint.source);break;default:break}break}case"request":{const l=E;switch(l.command){case"setBreakpoints":u(!0,l.arguments.source);break;case"breakpointLocations":u(!0,l.arguments.source);break;case"source":u(!0,l.arguments.source);break;case"gotoTargets":u(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(w=>u(!1,w));break;default:break}break}case"response":{const l=E;if(l.success&&l.body)switch(l.command){case"stackTrace":l.body.stackFrames.forEach(w=>u(!1,w.source));break;case"loadedSources":l.body.sources.forEach(w=>u(!1,w));break;case"scopes":l.body.scopes.forEach(w=>u(!1,w.source));break;case"setFunctionBreakpoints":l.body.breakpoints.forEach(w=>u(!1,w.source));break;case"setBreakpoints":l.body.breakpoints.forEach(w=>u(!1,w.source));break;case"disassemble":l.body?.instructions.forEach(A=>u(!1,A.location));break;default:break}break}}}function i(E){return E.filter(u=>!u.presentation?.hidden).sort((u,l)=>u.presentation?l.presentation?u.presentation.group?l.presentation.group?u.presentation.group!==l.presentation.group?u.presentation.group.localeCompare(l.presentation.group):c(u.presentation.order,l.presentation.order):-1:l.presentation.group?1:c(u.presentation.order,l.presentation.order):-1:l.presentation?1:0)}e.$sF=i;function c(E,u){return typeof E!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:E-u}async function f(E,u){const l=E.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(l!=="none"&&(await u.saveAll(),l==="allEditorsInActiveGroup")){const w=u.activeEditorPane;w&&w.input.resource?.scheme===R.Schemas.untitled&&await u.save({editor:w.input,groupId:w.group.id})}await E.reloadConfiguration()}e.$tF=f;const y=(E,u)=>!E||!u?E===u:E.name===u.name&&E.path===u.path&&E.sourceReference===u.sourceReference;e.$uF=y}),define(Se[272],De([1,0,48,61,23,16,12,15,29,220,140]),function($e,e,D,M,g,L,R,m,k,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=e.$gdc=e.$fdc=e.$edc=e.$ddc=void 0;class I extends P.$Ccb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(s,n){this.p=n,this.r=Buffer.allocUnsafe(0),this.t=-1,s.on("data",h=>this.w(h))}sendMessage(s){if(this.p){const n=JSON.stringify(s);this.p.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${I.a}${n}`,"utf8")}}w(s){for(this.r=Buffer.concat([this.r,s]);;){if(this.t>=0){if(this.r.length>=this.t){const n=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(h){this.m.fire(new Error((h.message||h)+`
`+n))}continue}}else{const n=this.r.indexOf(I.a);if(n!==-1){const $=this.r.toString("utf8",0,n).split(I.b);for(const d of $){const t=d.split(I.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(n+I.a.length);continue}}break}}}e.$ddc=I;class p extends I{startSession(){return new Promise((s,n)=>{let h=!1;this.x=this.y(()=>{this.v(this.x,this.x),s(),h=!0}),this.x.on("close",()=>{h?this.m.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.x.on("error",$=>{h?this.m.fire($):n($)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$edc=p;class S extends p{constructor(s){super(),this.z=s}y(s){return M.createConnection(this.z.port,this.z.host||"127.0.0.1",s)}}e.$fdc=S;class C extends p{constructor(s){super(),this.z=s}y(s){return M.createConnection(this.z.path,s)}}e.$gdc=C;class v extends I{constructor(s,n){super(),this.y=s,this.z=n}async startSession(){const s=this.y.command,n=this.y.args,h=this.y.options||{};try{if(s)if(L.$8d(s)){if(!await k.Promises.exists(s))throw new Error(b.localize(0,null,s))}else s.indexOf("/")<0&&s.indexOf("\\")<0;else throw new Error(b.localize(1,null,this.z));let $=process.env;if(h.env&&Object.keys(h.env).length>0&&($=g.$Ym(g.$Vm(process.env),h.env)),s==="node")if(Array.isArray(n)&&n.length>0){const d=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:$,execArgv:d?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};h.cwd&&(t.cwd=h.cwd);const r=D.fork(n[0],n.slice(1),t);if(!r.pid)throw new Error(b.localize(2,null,n[0]));this.x=r}else throw new Error(b.localize(3,null));else{const d={env:$};h.cwd&&(d.cwd=h.cwd),this.x=D.spawn(s,n,d)}this.x.on("error",d=>{this.m.fire(d)}),this.x.on("exit",(d,t)=>{this.n.fire(d)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",d=>{this.m.fire(d)}),this.x.stdin.on("error",d=>{this.m.fire(d)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch($){this.m.fire($)}}async stopSession(){return this.x?(await this.u(),R.$i?new Promise((s,n)=>{const h=D.exec(`taskkill /F /T /PID ${this.x.pid}`,function($,d,t){if($)return n($)});h.on("exit",s),h.on("error",n)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(s,n){if(!s)return;const h=Object.create(null);s.runtime&&(s.runtime.indexOf("./")===0?h.runtime=L.$9d(n,s.runtime):h.runtime=s.runtime),s.runtimeArgs&&(h.runtimeArgs=s.runtimeArgs),s.program&&(L.$8d(s.program)?h.program=s.program:h.program=L.$9d(n,s.program)),s.args&&(h.args=s.args);const $=s;return $.win&&(h.win=v.A($.win,n)),$.winx86&&(h.winx86=v.A($.winx86,n)),$.windows&&(h.windows=v.A($.windows,n)),$.osx&&(h.osx=v.A($.osx,n)),$.linux&&(h.linux=v.A($.linux,n)),h}static platformAdapterExecutable(s,n){let h=Object.create(null);n=n.toLowerCase();for(const i of s)if(i.contributes){const c=i.contributes.debuggers;c&&c.length>0&&c.filter(f=>typeof f.type=="string"&&m.$Me(f.type,n)).forEach(f=>{const y=v.A(f,i.extensionLocation.fsPath);h=g.$Ym(h,y,i.isBuiltin)})}let $;R.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?$=h.winx86||h.win||h.windows:R.$i?$=h.win||h.windows:R.$j?$=h.osx:R.$k&&($=h.linux),$=$||h;const d=$.program||h.program,t=$.args||h.args,r=$.runtime||h.runtime,a=$.runtimeArgs||h.runtimeArgs;if(r)return{type:"executable",command:r,args:(a||[]).concat(typeof d=="string"?[d]:[]).concat(t||[])};if(d)return{type:"executable",command:d,args:t||[]}}}e.$hdc=v}),define(Se[273],De([1,0,48,32,12]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=e.$idc=void 0;function L(b,P){return new Promise((I,p)=>{let S="";const C=D.spawn(b,P);C.pid&&C.stdout.on("data",v=>{S+=v.toString()}),C.on("error",v=>{p(v)}),C.on("close",v=>{I(S)})})}async function R(b){if(b)if(g.$i){const P=await new Promise((I,p)=>{$e(["@vscode/windows-process-tree"],I,p)});return new Promise(I=>{P.getProcessTree(b,p=>{I(!!p&&p.children.length>0)})})}else return L("/usr/bin/pgrep",["-lP",String(b)]).then(P=>{const I=P.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},P=>!0);return Promise.resolve(!0)}e.$idc=R;var m;(function(b){b[b.cmd=0]="cmd",b[b.powershell=1]="powershell",b[b.bash=2]="bash"})(m||(m={}));function k(b,P,I,p,S){b=b.trim().toLowerCase();let C;b.indexOf("powershell")>=0||b.indexOf("pwsh")>=0?C=1:b.indexOf("cmd.exe")>=0?C=0:b.indexOf("bash")>=0?C=2:g.$i?C=0:C=2;let v,o=" ";switch(C){case 1:if(v=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),p){const s=(0,M.$Nf)(p);s&&(o+=`${s}:; `),o+=`cd ${v(p)}; `}if(S)for(const s in S){const n=S[s];n===null?o+=`Remove-Item env:${s}; `:o+=`\${env:${s}}='${n}'; `}if(P.length>0){const s=P.shift(),n=I?s:v(s);o+=n[0]==="'"?`& ${n} `:`${n} `;for(const h of P)o+=h==="<"||h===">"||I?h:v(h),o+=" "}break;case 0:if(v=s=>(s=s.replace(/\"/g,'""'),s=s.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(n=>s.includes(n))||s.length===0?`"${s}"`:s),p){const s=(0,M.$Nf)(p);s&&(o+=`${s}: && `),o+=`cd ${v(p)} && `}if(S){o+='cmd /C "';for(const s in S){let n=S[s];n===null?o+=`set "${s}=" && `:(n=n.replace(/[&^|<>]/g,h=>`^${h}`),o+=`set "${s}=${n}" && `)}}for(const s of P)o+=s==="<"||s===">"||I?s:v(s),o+=" ";S&&(o+='"');break;case 2:{v=n=>(n=n.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),n.length===0?'""':n);const s=n=>/[^\w@%\/+=,.:^-]/.test(n)?`'${n.replace(/'/g,"'\\''")}'`:n;if(p&&(o+=`cd ${v(p)} ; `),S){o+="/usr/bin/env";for(const n in S){const h=S[n];h===null?o+=` -u ${s(n)}`:o+=` ${s(`${n}=${h}`)}`}o+=" "}for(const n of P)o+=n==="<"||n===">"||I?n:v(n),o+=" ";break}}return o}e.$jdc=k}),define(Se[108],De([1,0,22,35,50,98,17,16,12,41]),function($e,e,D,M,g,L,R,m,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$H=e.$0H=e.$9H=e.$8H=e.CellStatusbarAlignment=e.$7H=e.$6H=e.$5H=e.NotebookEditorPriority=e.$4H=e.$3H=e.$2H=e.$1H=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$ZH=e.$YH=e.$XH=e.$WH=e.CellKind=e.$VH=e.$UH=e.$TH=void 0,e.$TH="workbench.editor.notebook",e.$UH="workbench.editor.notebookTextDiffEditor",e.$VH="workbench.editor.interactive";var P;(function(T){T[T.Markup=1]="Markup",T[T.Code=2]="Code"})(P||(e.CellKind=P={})),e.$WH=["application/json","application/javascript","text/html","image/svg+xml",L.$Hr.latex,L.$Hr.markdown,"image/png","image/jpeg",L.$Hr.text],e.$XH=[L.$Hr.latex,L.$Hr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$Hr.text],e.$YH=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$ZH="_notAvailable";var I;(function(T){T[T.Running=1]="Running",T[T.Idle=2]="Idle"})(I||(e.NotebookRunState=I={}));var p;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(p||(e.NotebookCellExecutionState=p={}));var S;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(S||(e.NotebookExecutionState=S={}));var C;(function(T){T[T.WithHardKernelDependency=0]="WithHardKernelDependency",T[T.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",T[T.Pure=2]="Pure",T[T.Never=3]="Never"})(C||(e.NotebookRendererMatch=C={}));var v;(function(T){T.Always="always",T.Never="never",T.Optional="optional"})(v||(e.RendererMessagingSpec=v={}));var o;(function(T){T[T.ModelChange=1]="ModelChange",T[T.Move=2]="Move",T[T.ChangeCellLanguage=5]="ChangeCellLanguage",T[T.Initialize=6]="Initialize",T[T.ChangeCellMetadata=7]="ChangeCellMetadata",T[T.Output=8]="Output",T[T.OutputItem=9]="OutputItem",T[T.ChangeCellContent=10]="ChangeCellContent",T[T.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",T[T.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",T[T.ChangeCellMime=13]="ChangeCellMime",T[T.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var s;(function(T){T[T.Handle=0]="Handle",T[T.Index=1]="Index"})(s||(e.SelectionStateType=s={}));var n;(function(T){T[T.Replace=1]="Replace",T[T.Output=2]="Output",T[T.Metadata=3]="Metadata",T[T.CellLanguage=4]="CellLanguage",T[T.DocumentMetadata=5]="DocumentMetadata",T[T.Move=6]="Move",T[T.OutputItems=7]="OutputItems",T[T.PartialMetadata=8]="PartialMetadata",T[T.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var h;(function(T){T.scheme=R.Schemas.vscodeNotebookCell;const H=["W","X","Y","Z","a","b","c","d","e","f"],q=new RegExp(`^[${H.join("")}]+`),me=7;function X(we,G){const U=G.toString(me),fe=`${U.length<H.length?H[U.length-1]:"z"}${U}s${(0,D.$Zd)(D.$Fd.fromString(we.scheme),!0,!0)}`;return we.with({scheme:T.scheme,fragment:fe})}T.generate=X;function Z(we){if(we.scheme!==T.scheme)return;const G=we.fragment.indexOf("s");if(G<0)return;const U=parseInt(we.fragment.substring(0,G).replace(q,""),me),K=(0,D.$Yd)(we.fragment.substring(G+1)).toString();if(!isNaN(U))return{handle:U,notebook:we.with({scheme:K,fragment:null})}}T.parse=Z;function V(we,G){return we.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${G??""},${we.scheme!==R.Schemas.file?we.scheme:""}`})}T.generateCellOutputUri=V;function x(we){if(we.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const G=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(we.fragment);if(!G)return;const U=G[1]&&G[1]!==""?G[1]:void 0,K=G[2];return{outputId:U,notebook:we.with({scheme:K||R.Schemas.file,fragment:null})}}T.parseCellOutputUri=x;function ge(we,G,U){return T.generate(we,G).with({scheme:U})}T.generateCellPropertyUri=ge;function ue(we,G){if(we.scheme===G)return T.parse(we.with({scheme:T.scheme}))}T.parseCellPropertyUri=ue})(h||(e.CellUri=h={}));const $=T=>k.$i?T.replace(/\//g,"\\"):T;class d{constructor(H=[],q=e.$WH){this.e=q,this.d=[...new Set(H)].map(me=>({pattern:me,matches:M.$rj($(me))}))}sort(H){const q=new Map(g.Iterable.map(H,X=>[X,$(X)]));let me=[];for(const{matches:X}of this.d)for(const[Z,V]of q)if(X(V)){me.push(Z),q.delete(Z);break}return q.size&&(me=me.concat([...q.keys()].sort((X,Z)=>this.e.indexOf(X)-this.e.indexOf(Z)))),me}prioritize(H,q){const me=this.f(H);if(me===-1){this.d.unshift({pattern:H,matches:M.$rj($(H))});return}const X=new Set(q.map(V=>this.f(V,me)));X.delete(-1);const Z=Array.from(X).sort();this.d.splice(me+1,0,...Z.map(V=>this.d[V]));for(let V=Z.length-1;V>=0;V--)this.d.splice(Z[V],1)}toArray(){return this.d.map(H=>H.pattern)}f(H,q=this.d.length){const me=$(H);for(let X=0;X<q;X++)if(this.d[X].matches(me))return X;return-1}}e.$1H=d;function t(T,H,q,me=(X,Z)=>X===Z){const X=[];function Z(ge,ue,we){if(ue===0&&we.length===0)return;const G=X[X.length-1];G&&G.start+G.deleteCount===ge?(G.deleteCount+=ue,G.toInsert.push(...we)):X.push({start:ge,deleteCount:ue,toInsert:we})}let V=0,x=0;for(;;){if(V===T.length){Z(V,0,H.slice(x));break}if(x===H.length){Z(V,T.length-V,[]);break}const ge=T[V],ue=H[x];if(me(ge,ue)){V+=1,x+=1;continue}q(ue)?(Z(V,1,[]),V+=1):(Z(V,0,[ue]),x+=1)}return X}e.$2H=t,e.$3H=new b.$2i("notebookEditorCursorAtBoundary","none"),e.$4H=new b.$2i("notebookEditorCursorAtLineBoundary","none");var r;(function(T){T.default="default",T.option="option"})(r||(e.NotebookEditorPriority=r={}));function a(T){const H=T;return!!((typeof H.include=="string"||M.$sj(H.include))&&(typeof H.exclude=="string"||M.$sj(H.exclude)))}e.$5H=a;function i(T,H,q){if(Array.isArray(T.viewType)&&T.viewType.indexOf(H)>=0||T.viewType===H)return!0;if(T.filenamePattern){const me=a(T.filenamePattern)?T.filenamePattern.include:T.filenamePattern,X=a(T.filenamePattern)?T.filenamePattern.exclude:void 0;if(M.$qj(me,(0,m.$ae)(q.fsPath).toLowerCase()))return!(X&&M.$qj(X,(0,m.$ae)(q.fsPath).toLowerCase()))}return!1}e.$6H=i,e.$7H={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",cellExecutionScroll:"notebook.revealNextOnExecuteBehavior"};var c;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(c||(e.CellStatusbarAlignment=c={}));class f{static{this.d="notebook/"}static create(H){return`${f.d}${H}`}static parse(H){if(H.startsWith(f.d))return H.substring(f.d.length)}}e.$8H=f;function y(T){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(T)}e.$9H=y;const E=new TextDecoder;function u(T){const H=[];let q=!1;for(const V of T)(H.length===0||q)&&(H.push(V),q=!0);let me=A(H);const X=D.$Fd.concat(H.map(V=>D.$Fd.wrap(V))),Z=z(X);return me=me||Z.byteLength!==X.byteLength,{data:Z,didCompression:me}}e.$0H=u,e.$$H=`${String.fromCharCode(27)}[A`;const l=e.$$H.split("").map(T=>T.charCodeAt(0)),w=10;function A(T){let H=!1;return T.forEach((q,me)=>{if(me===0||q.length<e.$$H.length)return;const X=T[me-1],Z=q.subarray(0,e.$$H.length);if(Z[0]===l[0]&&Z[1]===l[1]&&Z[2]===l[2]){const V=X.lastIndexOf(w);if(V===-1)return;H=!0,T[me-1]=X.subarray(0,V),T[me]=q.subarray(e.$$H.length)}}),H}function N(T){let H=T;do T=H,H=T.replace(/[^\n]\x08/gm,"");while(H.length<T.length);return T}function O(T){for(T=T.replace(/\r+\n/gm,`
`);T.search(/\r[^$]/g)>-1;){const H=T.match(/^(.*)\r+/m)[1];let q=T.match(/\r+(.*)$/m)[1];q=q+H.slice(q.length,H.length),T=T.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,q)}return T}const F="\b".charCodeAt(0),j="\r".charCodeAt(0);function z(T){return!T.buffer.includes(F)&&!T.buffer.includes(j)?T:D.$Fd.fromString(O(N(E.decode(T.buffer))))}}),define(Se[7],De([1,0,19,8,80,28,98,15,18,2,31,25,30,66,108]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C){"use strict";var v,o,s,n,h,$,d,t,r,a,i,c,f,y,E,u,l,w;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$QL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.TestRunProfileKind=e.TestResultState=e.$xL=e.$wL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$vL=e.$uL=e.$tL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$sL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.ColorThemeKind=e.$mL=e.$lL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$kL=e.DebugConsoleMode=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$eL=e.$dL=e.FileChangeType=e.$cL=e.$bL=e.$aL=e.$_K=e.InlineCompletionTriggerKind=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.ConfigurationTarget=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$OK=e.ViewBadge=e.ProgressLocation=e.$NK=e.$MK=e.TaskScope=e.ShellQuoting=e.$LK=e.$KK=e.$JK=e.TaskPanelKind=e.TaskRevealKind=e.$IK=e.TerminalLocation=e.$HK=e.$GK=e.$FK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$EK=e.$DK=e.$CK=e.$BK=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$AK=e.StatusBarAlignment=e.ViewColumn=e.$zK=e.$yK=e.$xK=e.$wK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$vK=e.$uK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.LanguageStatusSeverity=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.CodeActionTriggerKind=e.$hK=e.$gK=e.SymbolTag=e.SymbolKind=e.$fK=e.DocumentHighlightKind=e.$eK=e.$dK=e.$cK=e.$bK=e.DiagnosticSeverity=e.DiagnosticTag=e.$aK=e.$_J=e.FileEditType=e.$$J=e.$0J=e.$9J=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function A(J){return Object.assign(J,{apply:function(...ve){if(ve.length===0)return Reflect.construct(J,[]);{const Re=ve.length===1?[]:ve[1];return Reflect.construct(J,Re,ve[0].constructor)}},call:function(...ve){if(ve.length===0)return Reflect.construct(J,[]);{const[Re,...Qe]=ve;return Reflect.construct(J,Qe,Re.constructor)}}})}var N;(function(J){J[J.Top=0]="Top",J[J.Bottom=1]="Bottom"})(N||(e.TerminalOutputAnchor=N={}));var O;(function(J){J[J.TerminalCommand=0]="TerminalCommand",J[J.Opener=1]="Opener",J[J.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let F=v=class{static from(...W){let ve=W;return new v(function(){if(ve){for(const Re of ve)Re&&typeof Re.dispose=="function"&&Re.dispose();ve=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$2J=F,e.$2J=F=v=Ke([A],F);let j=o=class{static Min(...W){if(W.length===0)throw new TypeError;let ve=W[0];for(let Re=1;Re<W.length;Re++){const Qe=W[Re];Qe.isBefore(ve)&&(ve=Qe)}return ve}static Max(...W){if(W.length===0)throw new TypeError;let ve=W[0];for(let Re=1;Re<W.length;Re++){const Qe=W[Re];Qe.isAfter(ve)&&(ve=Qe)}return ve}static isPosition(W){if(!W)return!1;if(W instanceof o)return!0;const{line:ve,character:Re}=W;return typeof ve=="number"&&typeof Re=="number"}static of(W){if(W instanceof o)return W;if(this.isPosition(W))return new o(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,ve){if(W<0)throw(0,M.$5)("line must be non-negative");if(ve<0)throw(0,M.$5)("character must be non-negative");this.c=W,this.e=ve}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,ve=0){if(W===null||ve===null)throw(0,M.$5)();let Re;return typeof W>"u"?Re=0:typeof W=="number"?Re=W:(Re=typeof W.lineDelta=="number"?W.lineDelta:0,ve=typeof W.characterDelta=="number"?W.characterDelta:0),Re===0&&ve===0?this:new o(this.line+Re,this.character+ve)}with(W,ve=this.character){if(W===null||ve===null)throw(0,M.$5)();let Re;return typeof W>"u"?Re=this.line:typeof W=="number"?Re=W:(Re=typeof W.line=="number"?W.line:this.line,ve=typeof W.character=="number"?W.character:this.character),Re===this.line&&ve===this.character?this:new o(Re,ve)}toJSON(){return{line:this.line,character:this.character}}};e.$3J=j,e.$3J=j=o=Ke([A],j);let z=s=class{static isRange(W){return W instanceof s?!0:W?j.isPosition(W.start)&&j.isPosition(W.end):!1}static of(W){if(W instanceof s)return W;if(this.isRange(W))return new s(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,ve,Re,Qe){let tt,ct;if(typeof W=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Qe=="number"?(tt=new j(W,ve),ct=new j(Re,Qe)):j.isPosition(W)&&j.isPosition(ve)&&(tt=j.of(W),ct=j.of(ve)),!tt||!ct)throw new Error("Invalid arguments");tt.isBefore(ct)?(this.c=tt,this.e=ct):(this.c=ct,this.e=tt)}contains(W){return s.isRange(W)?this.contains(W.start)&&this.contains(W.end):j.isPosition(W)?!(j.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const ve=j.Max(W.start,this.c),Re=j.Min(W.end,this.e);if(!ve.isAfter(Re))return new s(ve,Re)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ve=j.Min(W.start,this.c),Re=j.Max(W.end,this.end);return new s(ve,Re)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,ve=this.end){if(W===null||ve===null)throw(0,M.$5)();let Re;return W?j.isPosition(W)?Re=W:(Re=W.start||this.start,ve=W.end||this.end):Re=this.start,Re.isEqual(this.c)&&ve.isEqual(this.end)?this:new s(Re,ve)}toJSON(){return[this.start,this.end]}};e.$4J=z,e.$4J=z=s=Ke([A],z);let T=n=class extends z{static isSelection(W){return W instanceof n?!0:W?z.isRange(W)&&j.isPosition(W.anchor)&&j.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,ve,Re,Qe){let tt,ct;if(typeof W=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Qe=="number"?(tt=new j(W,ve),ct=new j(Re,Qe)):j.isPosition(W)&&j.isPosition(ve)&&(tt=j.of(W),ct=j.of(ve)),!tt||!ct)throw new Error("Invalid arguments");super(tt,ct),this.f=tt,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$5J=T,e.$5J=T=n=Ke([A],T);const H=J=>{if(typeof J!="string"||J.length===0||!/^[0-9A-Za-z_\-]+$/.test(J))throw(0,M.$5)("connectionToken")};class q{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ve,Re){if(typeof W!="string"||W.length===0)throw(0,M.$5)("host");if(typeof ve!="number"||ve===0||Math.round(ve)!==ve)throw(0,M.$5)("port");typeof Re<"u"&&H(Re),this.host=W,this.port=Math.round(ve),this.connectionToken=Re}}e.$6J=q;class me{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ve){this.makeConnection=W,this.connectionToken=ve,typeof ve<"u"&&H(ve)}}e.$7J=me;class X extends Error{static NotAvailable(W,ve){return new X(W,S.RemoteAuthorityResolverErrorCode.NotAvailable,ve)}static TemporarilyNotAvailable(W){return new X(W,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,ve=S.RemoteAuthorityResolverErrorCode.Unknown,Re){super(W),this._message=W,this._code=ve,this._detail=Re,Object.setPrototypeOf(this,X.prototype)}}e.$8J=X;var Z;(function(J){J[J.LF=1]="LF",J[J.CRLF=2]="CRLF"})(Z||(e.EndOfLine=Z={}));var V;(function(J){J[J.Replace=1]="Replace",J[J.Append=2]="Append",J[J.Prepend=3]="Prepend"})(V||(e.EnvironmentVariableMutatorType=V={}));let x=h=class{static isTextEdit(W){return W instanceof h?!0:W?z.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ve){return new h(W,ve)}static insert(W,ve){return h.replace(new z(W,W),ve)}static delete(W){return h.replace(W,"")}static setEndOfLine(W){const ve=new h(new z(new j(0,0),new j(0,0)),"");return ve.newEol=W,ve}get range(){return this.c}set range(W){if(W&&!z.isRange(W))throw(0,M.$5)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,M.$5)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,M.$5)("newEol");this.f=W}constructor(W,ve){this.c=W,this.e=ve}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$9J=x,e.$9J=x=h=Ke([A],x);let ge=$=class{static isNotebookCellEdit(W){return W instanceof $?!0:W?_t.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,ve){return new $(W,ve)}static insertCells(W,ve){return new $(new _t(W,W),ve)}static deleteCells(W){return new $(W,[])}static updateCellMetadata(W,ve){const Re=new $(new _t(W,W),[]);return Re.newCellMetadata=ve,Re}static updateNotebookMetadata(W){const ve=new $(new _t(0,0),[]);return ve.newNotebookMetadata=W,ve}constructor(W,ve){this.range=W,this.newCells=ve}};e.$0J=ge,e.$0J=ge=$=Ke([A],ge);class ue{static isSnippetTextEdit(W){return W instanceof ue?!0:W?z.isRange(W.range)&&U.isSnippetString(W.snippet):!1}static replace(W,ve){return new ue(W,ve)}static insert(W,ve){return ue.replace(new z(W,W),ve)}constructor(W,ve){this.range=W,this.snippet=ve}}e.$$J=ue;var we;(function(J){J[J.File=1]="File",J[J.Text=2]="Text",J[J.Cell=3]="Cell",J[J.CellReplace=5]="CellReplace",J[J.Snippet=6]="Snippet"})(we||(e.FileEditType=we={}));let G=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,ve,Re,Qe){this.c.push({_type:1,from:W,to:ve,options:Re,metadata:Qe})}createFile(W,ve,Re){this.c.push({_type:1,from:void 0,to:W,options:ve,metadata:Re})}deleteFile(W,ve,Re){this.c.push({_type:1,from:W,to:void 0,options:ve,metadata:Re})}e(W,ve,Re){this.c.push({_type:3,metadata:Re,uri:W,edit:{editType:5,metadata:ve},notebookMetadata:ve})}f(W,ve,Re,Qe){const tt=ve.start,ct=ve.end;(tt!==ct||Re.length>0)&&this.c.push({_type:5,uri:W,index:tt,count:ct-tt,cells:Re,metadata:Qe})}g(W,ve,Re,Qe){this.c.push({_type:3,metadata:Qe,uri:W,edit:{editType:3,index:ve,metadata:Re}})}replace(W,ve,Re,Qe){this.c.push({_type:2,uri:W,edit:new x(ve,Re),metadata:Qe})}insert(W,ve,Re,Qe){this.replace(W,new z(ve,ve),Re,Qe)}delete(W,ve,Re){this.replace(W,ve,"",Re)}has(W){return this.c.some(ve=>ve._type===2&&ve.uri.toString()===W.toString())}set(W,ve){if(ve)for(const Re of ve){if(!Re)continue;let Qe,tt;Array.isArray(Re)?(Qe=Re[0],tt=Re[1]):Qe=Re,ge.isNotebookCellEdit(Qe)?Qe.newCellMetadata?this.g(W,Qe.range.start,Qe.newCellMetadata,tt):Qe.newNotebookMetadata?this.e(W,Qe.newNotebookMetadata,tt):this.f(W,Qe.range,Qe.newCells,tt):ue.isSnippetTextEdit(Qe)?this.c.push({_type:6,uri:W,range:Qe.range,edit:Qe.snippet,metadata:tt}):this.c.push({_type:2,uri:W,edit:Qe,metadata:tt})}else{for(let Re=0;Re<this.c.length;Re++){const Qe=this.c[Re];switch(Qe._type){case 2:case 6:case 3:case 5:Qe.uri.toString()===W.toString()&&(this.c[Re]=void 0);break}}(0,D.$Gb)(this.c)}}get(W){const ve=[];for(const Re of this.c)Re._type===2&&Re.uri.toString()===W.toString()&&ve.push(Re.edit);return ve}entries(){const W=new L.$zi;for(const ve of this.c)if(ve._type===2){let Re=W.get(ve.uri);Re||(Re=[ve.uri,[]],W.set(ve.uri,Re)),Re[1].push(ve.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$_J=G,e.$_J=G=Ke([A],G);let U=d=class{static isSnippetString(W){return W instanceof d?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=d.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ve=this.e++){if(typeof W=="function"){const Re=new d;Re.e=this.e,W(Re),this.e=Re.e,W=Re.value}else W=d.c(W);return this.value+="${",this.value+=ve,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ve=this.e++){const Re=W.map(Qe=>Qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ve,this.value+="|",this.value+=Re,this.value+="|}",this}appendVariable(W,ve){if(typeof ve=="function"){const Re=new d;Re.e=this.e,ve(Re),this.e=Re.e,ve=Re.value}else typeof ve=="string"&&(ve=ve.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ve&&(this.value+=":",this.value+=ve),this.value+="}",this}};e.$aK=U,e.$aK=U=d=Ke([A],U);var K;(function(J){J[J.Unnecessary=1]="Unnecessary",J[J.Deprecated=2]="Deprecated"})(K||(e.DiagnosticTag=K={}));var fe;(function(J){J[J.Hint=3]="Hint",J[J.Information=2]="Information",J[J.Warning=1]="Warning",J[J.Error=0]="Error"})(fe||(e.DiagnosticSeverity=fe={}));let te=t=class{static isLocation(W){return W instanceof t?!0:W?z.isRange(W.range)&&b.URI.isUri(W.uri):!1}constructor(W,ve){if(this.uri=W,ve)if(z.isRange(ve))this.range=z.of(ve);else if(j.isPosition(ve))this.range=new z(ve,ve);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$bK=te,e.$bK=te=t=Ke([A],te);let re=class{static is(W){return W?typeof W.message=="string"&&W.location&&z.isRange(W.location.range)&&b.URI.isUri(W.location.uri):!1}constructor(W,ve){this.location=W,this.message=ve}static isEqual(W,ve){return W===ve?!0:!W||!ve?!1:W.message===ve.message&&W.location.range.isEqual(ve.location.range)&&W.location.uri.toString()===ve.location.uri.toString()}};e.$cK=re,e.$cK=re=Ke([A],re);let ne=class{constructor(W,ve,Re=fe.Error){if(!z.isRange(W))throw new TypeError("range must be set");if(!ve)throw new TypeError("message must be set");this.range=W,this.message=ve,this.severity=Re}toJSON(){return{severity:fe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ve){return W===ve?!0:!W||!ve?!1:W.message===ve.message&&W.severity===ve.severity&&W.code===ve.code&&W.severity===ve.severity&&W.source===ve.source&&W.range.isEqual(ve.range)&&(0,D.$sb)(W.tags,ve.tags)&&(0,D.$sb)(W.relatedInformation,ve.relatedInformation,re.isEqual)}};e.$dK=ne,e.$dK=ne=Ke([A],ne);let Ee=class{constructor(W,ve){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=ve}};e.$eK=Ee,e.$eK=Ee=Ke([A],Ee);var oe;(function(J){J[J.Text=0]="Text",J[J.Read=1]="Read",J[J.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let he=class{constructor(W,ve=oe.Text){this.range=W,this.kind=ve}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.$fK=he,e.$fK=he=Ke([A],he);var ee;(function(J){J[J.File=0]="File",J[J.Module=1]="Module",J[J.Namespace=2]="Namespace",J[J.Package=3]="Package",J[J.Class=4]="Class",J[J.Method=5]="Method",J[J.Property=6]="Property",J[J.Field=7]="Field",J[J.Constructor=8]="Constructor",J[J.Enum=9]="Enum",J[J.Interface=10]="Interface",J[J.Function=11]="Function",J[J.Variable=12]="Variable",J[J.Constant=13]="Constant",J[J.String=14]="String",J[J.Number=15]="Number",J[J.Boolean=16]="Boolean",J[J.Array=17]="Array",J[J.Object=18]="Object",J[J.Key=19]="Key",J[J.Null=20]="Null",J[J.EnumMember=21]="EnumMember",J[J.Struct=22]="Struct",J[J.Event=23]="Event",J[J.Operator=24]="Operator",J[J.TypeParameter=25]="TypeParameter"})(ee||(e.SymbolKind=ee={}));var le;(function(J){J[J.Deprecated=1]="Deprecated"})(le||(e.SymbolTag=le={}));let be=r=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,ve,Re,Qe,tt){this.name=W,this.kind=ve,this.containerName=tt,typeof Re=="string"&&(this.containerName=Re),Qe instanceof te?this.location=Qe:Re instanceof z&&(this.location=new te(Qe,Re)),r.validate(this)}toJSON(){return{name:this.name,kind:ee[this.kind],location:this.location,containerName:this.containerName}}};e.$gK=be,e.$gK=be=r=Ke([A],be);let Ie=a=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(a.validate)}constructor(W,ve,Re,Qe,tt){this.name=W,this.detail=ve,this.kind=Re,this.range=Qe,this.selectionRange=tt,this.children=[],a.validate(this)}};e.$hK=Ie,e.$hK=Ie=a=Ke([A],Ie);var B;(function(J){J[J.Invoke=1]="Invoke",J[J.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let Q=class{constructor(W,ve){this.title=W,this.kind=ve}};e.$iK=Q,e.$iK=Q=Ke([A],Q);let ie=class{static{i=this}static{this.c="."}constructor(W){this.value=W}append(W){return new i(this.value?this.value+i.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+i.c)}};e.$jK=ie,e.$jK=ie=i=Ke([A],ie);class se extends ie{constructor(W){super(W),this.value=W}}e.$kK=se,ie.Empty=new ie(""),ie.QuickFix=ie.Empty.append("quickfix"),ie.Refactor=ie.Empty.append("refactor"),ie.RefactorExtract=ie.Refactor.append("extract"),ie.RefactorInline=ie.Refactor.append("inline"),ie.RefactorMove=ie.Refactor.append("move"),ie.RefactorRewrite=ie.Refactor.append("rewrite"),ie.Source=ie.Empty.append("source"),ie.SourceOrganizeImports=ie.Source.append("organizeImports"),ie.SourceFixAll=ie.Source.append("fixAll"),ie.Notebook=ie.Empty.append("notebook");let Y=class{constructor(W,ve){if(this.range=W,this.parent=ve,ve&&!ve.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$lK=Y,e.$lK=Y=Ke([A],Y);class de{constructor(W,ve,Re,Qe,tt,ct){this.kind=W,this.name=ve,this.detail=Re,this.uri=Qe,this.range=tt,this.selectionRange=ct}}e.$mK=de;class ye{constructor(W,ve){this.fromRanges=ve,this.from=W}}e.$nK=ye;class je{constructor(W,ve){this.fromRanges=ve,this.to=W}}e.$oK=je;var We;(function(J){J[J.Information=0]="Information",J[J.Warning=1]="Warning",J[J.Error=2]="Error"})(We||(e.LanguageStatusSeverity=We={}));let _e=class{constructor(W,ve){this.range=W,this.command=ve}get isResolved(){return!!this.command}};e.$pK=_e,e.$pK=_e=Ke([A],_e);let Ye=c=class{#e;static isMarkdownString(W){return W instanceof c?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,ve=!1){this.#e=new g.$Xj(W,{supportThemeIcons:ve})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,ve){return this.#e.appendCodeblock(ve??"",W),this}};e.$qK=Ye,e.$qK=Ye=c=Ke([A],Ye);let it=class{constructor(W,ve){this.label=W,this.documentation=ve}};e.$rK=it,e.$rK=it=Ke([A],it);let et=class{constructor(W,ve){this.label=W,this.documentation=ve,this.parameters=[]}};e.$sK=et,e.$sK=et=Ke([A],et);let Ae=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$tK=Ae,e.$tK=Ae=Ke([A],Ae);var Oe;(function(J){J[J.Invoke=1]="Invoke",J[J.TriggerCharacter=2]="TriggerCharacter",J[J.ContentChange=3]="ContentChange"})(Oe||(e.SignatureHelpTriggerKind=Oe={}));var Ve;(function(J){J[J.Type=1]="Type",J[J.Parameter=2]="Parameter"})(Ve||(e.InlayHintKind=Ve={}));let Le=class{constructor(W){this.value=W}};e.$uK=Le,e.$uK=Le=Ke([A],Le);let Ze=class{constructor(W,ve,Re){this.position=W,this.label=ve,this.kind=Re}};e.$vK=Ze,e.$vK=Ze=Ke([A],Ze);var ce;(function(J){J[J.Invoke=0]="Invoke",J[J.TriggerCharacter=1]="TriggerCharacter",J[J.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ce||(e.CompletionTriggerKind=ce={}));var ae;(function(J){J[J.Text=0]="Text",J[J.Method=1]="Method",J[J.Function=2]="Function",J[J.Constructor=3]="Constructor",J[J.Field=4]="Field",J[J.Variable=5]="Variable",J[J.Class=6]="Class",J[J.Interface=7]="Interface",J[J.Module=8]="Module",J[J.Property=9]="Property",J[J.Unit=10]="Unit",J[J.Value=11]="Value",J[J.Enum=12]="Enum",J[J.Keyword=13]="Keyword",J[J.Snippet=14]="Snippet",J[J.Color=15]="Color",J[J.File=16]="File",J[J.Reference=17]="Reference",J[J.Folder=18]="Folder",J[J.EnumMember=19]="EnumMember",J[J.Constant=20]="Constant",J[J.Struct=21]="Struct",J[J.Event=22]="Event",J[J.Operator=23]="Operator",J[J.TypeParameter=24]="TypeParameter",J[J.User=25]="User",J[J.Issue=26]="Issue"})(ae||(e.CompletionItemKind=ae={}));var Ce;(function(J){J[J.Deprecated=1]="Deprecated"})(Ce||(e.CompletionItemTag=Ce={}));let qe=class{constructor(W,ve){this.label=W,this.kind=ve}toJSON(){return{label:this.label,kind:this.kind&&ae[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$wK=qe,e.$wK=qe=Ke([A],qe);let Ue=class{constructor(W=[],ve=!1){this.items=W,this.isIncomplete=ve}};e.$xK=Ue,e.$xK=Ue=Ke([A],Ue);let Xe=class{constructor(W,ve,Re){this.insertText=W,this.range=ve,this.command=Re}};e.$yK=Xe,e.$yK=Xe=Ke([A],Xe);let rt=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$zK=rt,e.$zK=rt=Ke([A],rt);var at;(function(J){J[J.Active=-1]="Active",J[J.Beside=-2]="Beside",J[J.One=1]="One",J[J.Two=2]="Two",J[J.Three=3]="Three",J[J.Four=4]="Four",J[J.Five=5]="Five",J[J.Six=6]="Six",J[J.Seven=7]="Seven",J[J.Eight=8]="Eight",J[J.Nine=9]="Nine"})(at||(e.ViewColumn=at={}));var $t;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})($t||(e.StatusBarAlignment=$t={}));function St(J,W){return`${I.$Vl.toKey(J)}.${W}`}e.$AK=St;var Zt;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative"})(Zt||(e.TextEditorLineNumbersStyle=Zt={}));var qt;(function(J){J[J.Manual=1]="Manual",J[J.AfterDelay=2]="AfterDelay",J[J.FocusOut=3]="FocusOut"})(qt||(e.TextDocumentSaveReason=qt={}));var vt;(function(J){J[J.Default=0]="Default",J[J.InCenter=1]="InCenter",J[J.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",J[J.AtTop=3]="AtTop"})(vt||(e.TextEditorRevealType=vt={}));var Nt;(function(J){J[J.Keyboard=1]="Keyboard",J[J.Mouse=2]="Mouse",J[J.Command=3]="Command"})(Nt||(e.TextEditorSelectionChangeKind=Nt={}));var jt;(function(J){J[J.Undo=1]="Undo",J[J.Redo=2]="Redo"})(jt||(e.TextDocumentChangeReason=jt={}));var Jt;(function(J){J[J.OpenOpen=0]="OpenOpen",J[J.ClosedClosed=1]="ClosedClosed",J[J.OpenClosed=2]="OpenClosed",J[J.ClosedOpen=3]="ClosedOpen"})(Jt||(e.DecorationRangeBehavior=Jt={})),function(J){function W(ve){switch(ve){case"keyboard":return J.Keyboard;case"mouse":return J.Mouse;case"api":return J.Command}}J.fromValue=W}(Nt||(e.TextEditorSelectionChangeKind=Nt={}));let At=class{constructor(W,ve){if(ve&&!b.URI.isUri(ve))throw(0,M.$5)("target");if(!z.isRange(W)||W.isEmpty)throw(0,M.$5)("range");this.range=W,this.target=ve}};e.$BK=At,e.$BK=At=Ke([A],At);let Rt=class{constructor(W,ve,Re,Qe){this.red=W,this.green=ve,this.blue=Re,this.alpha=Qe}};e.$CK=Rt,e.$CK=Rt=Ke([A],Rt);let zt=class{constructor(W,ve){if(ve&&!(ve instanceof Rt))throw(0,M.$5)("color");if(!z.isRange(W)||W.isEmpty)throw(0,M.$5)("range");this.range=W,this.color=ve}};e.$DK=zt,e.$DK=zt=Ke([A],zt);let Bt=class{constructor(W){if(!W||typeof W!="string")throw(0,M.$5)("label");this.label=W}};e.$EK=Bt,e.$EK=Bt=Ke([A],Bt);var Ht;(function(J){J[J.RGB=0]="RGB",J[J.HEX=1]="HEX",J[J.HSL=2]="HSL"})(Ht||(e.ColorFormat=Ht={}));var Wt;(function(J){J[J.Error=0]="Error",J[J.Warning=1]="Warning",J[J.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var Vt;(function(J){J[J.Unknown=0]="Unknown",J[J.Shutdown=1]="Shutdown",J[J.Process=2]="Process",J[J.User=3]="User",J[J.Extension=4]="Extension"})(Vt||(e.TerminalExitReason=Vt={}));class ot{constructor(W,ve,Re){if(this.startIndex=W,this.length=ve,this.tooltip=Re,typeof W!="number"||W<0)throw(0,M.$5)("startIndex");if(typeof ve!="number"||ve<1)throw(0,M.$5)("length");if(Re!==void 0&&typeof Re!="string")throw(0,M.$5)("tooltip")}}e.$FK=ot;class ft{constructor(W){this.uri=W}}e.$GK=ft;class Lt{constructor(W){this.terminalCommand=W}}e.$HK=Lt;var Ft;(function(J){J[J.Panel=1]="Panel",J[J.Editor=2]="Editor"})(Ft||(e.TerminalLocation=Ft={}));class It{constructor(W){if(this.options=W,typeof W!="object")throw(0,M.$5)("options")}}e.$IK=It;var dt;(function(J){J[J.Always=1]="Always",J[J.Silent=2]="Silent",J[J.Never=3]="Never"})(dt||(e.TaskRevealKind=dt={}));var kt;(function(J){J[J.Shared=1]="Shared",J[J.Dedicated=2]="Dedicated",J[J.New=3]="New"})(kt||(e.TaskPanelKind=kt={}));let Dt=class{static{f=this}static{this.Clean=new f("clean","Clean")}static{this.Build=new f("build","Build")}static{this.Rebuild=new f("rebuild","Rebuild")}static{this.Test=new f("test","Test")}static from(W){switch(W){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}constructor(W,ve){if(this.label=ve,typeof W!="string"||typeof ve!="string")throw(0,M.$5)("name");this.c=W}get id(){return this.c}};e.$JK=Dt,e.$JK=Dt=f=Ke([A],Dt);function Mt(J){let W="";for(let ve=0;ve<J.length;ve++)W+=J[ve].replace(/,/g,",,")+",";return W}let Ge=class{constructor(W,ve,Re){if(typeof W!="string")throw(0,M.$5)("process");this.e=[],this.c=W,ve!==void 0&&(Array.isArray(ve)?(this.e=ve,this.f=Re):this.f=ve)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,M.$5)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const ve of this.e)W.push(ve);return Mt(W)}};e.$KK=Ge,e.$KK=Ge=Ke([A],Ge);let Fe=class{constructor(W,ve,Re){if(this.f=[],Array.isArray(ve)){if(!W)throw(0,M.$5)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,M.$5)("command");this.e=W,this.f=ve,this.g=Re}else{if(typeof W!="string")throw(0,M.$5)("commandLine");this.c=W,this.g=ve}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,M.$5)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,M.$5)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ve of this.f)W.push(typeof ve=="string"?ve:ve.value);return Mt(W)}};e.$LK=Fe,e.$LK=Fe=Ke([A],Fe);var Me;(function(J){J[J.Escape=1]="Escape",J[J.Strong=2]="Strong",J[J.Weak=3]="Weak"})(Me||(e.ShellQuoting=Me={}));var Pe;(function(J){J[J.Global=1]="Global",J[J.Workspace=2]="Workspace"})(Pe||(e.TaskScope=Pe={}));class _{constructor(W){this.c=W}computeId(){return"customExecution"+(0,P.$4f)()}set callback(W){this.c=W}get callback(){return this.c}}e.$MK=_;let Te=class{static{y=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,ve,Re,Qe,tt,ct){this.j=!1,this.k=this.definition=W;let ht;typeof ve=="string"?(this.m=this.name=ve,this.t=this.source=Re,this.execution=Qe,ht=tt,this.j=!0):ve===Pe.Global||ve===Pe.Workspace?(this.target=ve,this.m=this.name=Re,this.t=this.source=Qe,this.execution=tt,ht=ct):(this.target=ve,this.m=this.name=Re,this.t=this.source=Qe,this.execution=tt,ht=ct),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof Ge?this.k={type:y.e,id:this.n.computeId()}:this.n instanceof Fe?this.k={type:y.f,id:this.n.computeId()}:this.n instanceof _?this.k={type:y.c,id:this.n.computeId()}:this.k={type:y.g,id:(0,P.$4f)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,M.$5)("Kind can't be undefined or null");this.y(),this.k=W}get scope(){return this.l}set target(W){this.y(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,M.$5)("name");this.y(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.y(),this.n=W;const ve=this.k.type;(y.g===ve||y.e===ve||y.f===ve||y.c===ve)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.y(),this.o=W,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.y(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,M.$5)("source must be a string of length > 0");this.y(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.y(),this.u=W}get detail(){return this.x}set detail(W){W===null&&(W=void 0),this.x=W}get presentationOptions(){return this.v}set presentationOptions(W){W==null&&(W=Object.create(null)),this.y(),this.v=W}get runOptions(){return this.w}set runOptions(W){W==null&&(W=Object.create(null)),this.y(),this.w=W}};e.$NK=Te,e.$NK=Te=y=Ke([A],Te);var He;(function(J){J[J.SourceControl=1]="SourceControl",J[J.Window=10]="Window",J[J.Notification=15]="Notification"})(He||(e.ProgressLocation=He={}));var xe;(function(J){function W(ve){const Re=ve;return(0,k.$nf)(Re.value)?Re.tooltip&&!(0,k.$jf)(Re.tooltip)?(console.log("INVALID view badge, invalid tooltip",Re.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Re.value),!1)}J.isViewBadge=W})(xe||(e.ViewBadge=xe={}));let Je=E=class{static isTreeItem(W,ve){const Re=W;if(Re.checkboxState!==void 0){const Qe=(0,k.$nf)(Re.checkboxState)?Re.checkboxState:(0,k.$lf)(Re.checkboxState)&&(0,k.$nf)(Re.checkboxState.state)?Re.checkboxState.state:void 0,tt=!(0,k.$nf)(Re.checkboxState)&&(0,k.$lf)(Re.checkboxState)?Re.checkboxState.tooltip:void 0;if(Qe===void 0||Qe!==bt.Checked&&Qe!==bt.Unchecked||tt!==void 0&&!(0,k.$jf)(tt))return console.log("INVALID tree item, invalid checkboxState",Re.checkboxState),!1}if(W instanceof E)return!0;if(Re.label!==void 0&&!(0,k.$jf)(Re.label)&&!Re.label?.label)return console.log("INVALID tree item, invalid label",Re.label),!1;if(Re.id!==void 0&&!(0,k.$jf)(Re.id))return console.log("INVALID tree item, invalid id",Re.id),!1;if(Re.iconPath!==void 0&&!(0,k.$jf)(Re.iconPath)&&!b.URI.isUri(Re.iconPath)&&(!Re.iconPath||!(0,k.$jf)(Re.iconPath.id))){const Qe=Re.iconPath;if(!Qe||!(0,k.$jf)(Qe.light)&&!b.URI.isUri(Qe.light)&&!(0,k.$jf)(Qe.dark)&&!b.URI.isUri(Qe.dark))return console.log("INVALID tree item, invalid iconPath",Re.iconPath),!1}return Re.description!==void 0&&!(0,k.$jf)(Re.description)&&typeof Re.description!="boolean"?(console.log("INVALID tree item, invalid description",Re.description),!1):Re.resourceUri!==void 0&&!b.URI.isUri(Re.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Re.resourceUri),!1):Re.tooltip!==void 0&&!(0,k.$jf)(Re.tooltip)&&!(Re.tooltip instanceof Ye)?(console.log("INVALID tree item, invalid tooltip",Re.tooltip),!1):Re.command!==void 0&&!Re.command.command?(console.log("INVALID tree item, invalid command",Re.command),!1):Re.collapsibleState!==void 0&&Re.collapsibleState<nt.None&&Re.collapsibleState>nt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Re.collapsibleState),!1):Re.contextValue!==void 0&&!(0,k.$jf)(Re.contextValue)?(console.log("INVALID tree item, invalid contextValue",Re.contextValue),!1):Re.accessibilityInformation!==void 0&&!Re.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Re.accessibilityInformation),!1):!0}constructor(W,ve=nt.None){this.collapsibleState=ve,b.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$OK=Je,e.$OK=Je=E=Ke([A],Je);var nt;(function(J){J[J.None=0]="None",J[J.Collapsed=1]="Collapsed",J[J.Expanded=2]="Expanded"})(nt||(e.TreeItemCollapsibleState=nt={}));var bt;(function(J){J[J.Unchecked=0]="Unchecked",J[J.Checked=1]="Checked"})(bt||(e.TreeItemCheckboxState=bt={}));let Pt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$PK=Pt,e.$PK=Pt=Ke([A],Pt);class wt extends Pt{}e.$QK=wt;class lt extends wt{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$RK=lt;class mt{constructor(W,ve,Re,Qe){this.name=W,this.uri=ve,this._itemId=Re,this.c=Qe}data(){return this.c()}}e.$SK=mt;let yt=class{#e=new Map;constructor(W){for(const[ve,Re]of W??[]){const Qe=this.#e.get(this.#t(ve));Qe?Qe.push(Re):this.#e.set(this.#t(ve),[Re])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,ve){this.#e.set(this.#t(W),[ve])}forEach(W,ve){for(const[Re,Qe]of this.#e)for(const tt of Qe)W.call(ve,tt,Re,this)}*[Symbol.iterator](){for(const[W,ve]of this.#e)for(const Re of ve)yield[W,Re]}#t(W){return W.toLowerCase()}};e.$TK=yt,e.$TK=yt=Ke([A],yt);let gi=class{constructor(W){this.insertText=W}};e.$UK=gi,e.$UK=gi=Ke([A],gi);let Kt=class{constructor(W,ve){this.label=ve,this.insertText=W}};e.$VK=Kt,e.$VK=Kt=Ke([A],Kt);let Yt=class{constructor(W,ve){this.id=W,this.color=ve}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$WK=Yt,e.$WK=Yt=Ke([A],Yt),Yt.File=new Yt("file"),Yt.Folder=new Yt("folder");let si=class{constructor(W){this.id=W}};e.$XK=si,e.$XK=si=Ke([A],si);var ki;(function(J){J[J.Global=1]="Global",J[J.Workspace=2]="Workspace",J[J.WorkspaceFolder=3]="WorkspaceFolder"})(ki||(e.ConfigurationTarget=ki={}));let Ct=class{get base(){return this.c}set base(W){this.c=W,this.e=b.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,ve){if(typeof W!="string"&&(!W||!b.URI.isUri(W)&&!b.URI.isUri(W.uri)))throw(0,M.$5)("base");if(typeof ve!="string")throw(0,M.$5)("pattern");typeof W=="string"?this.baseUri=b.URI.file(W):b.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=ve}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$YK=Ct,e.$YK=Ct=Ke([A],Ct);const Yi=new WeakMap;function un(J,W){Yi.set(J,W)}e.$ZK=un;let pt=class{constructor(W,ve,Re,Qe){this.enabled=typeof W=="boolean"?W:!0,typeof ve=="string"&&(this.condition=ve),typeof Re=="string"&&(this.hitCondition=Re),typeof Qe=="string"&&(this.logMessage=Qe)}get id(){return this.c||(this.c=Yi.get(this)??(0,P.$4f)()),this.c}};e.$1K=pt,e.$1K=pt=Ke([A],pt);let mi=class extends pt{constructor(W,ve,Re,Qe,tt){if(super(ve,Re,Qe,tt),W===null)throw(0,M.$5)("location");this.location=W}};e.$2K=mi,e.$2K=mi=Ke([A],mi);let $i=class extends pt{constructor(W,ve,Re,Qe,tt){super(ve,Re,Qe,tt),this.functionName=W}};e.$3K=$i,e.$3K=$i=Ke([A],$i);let oi=class extends pt{constructor(W,ve,Re,Qe,tt,ct,ht){if(super(Qe,tt,ct,ht),!ve)throw(0,M.$5)("dataId");this.label=W,this.dataId=ve,this.canPersist=Re}};e.$4K=oi,e.$4K=oi=Ke([A],oi);let Si=class{constructor(W,ve,Re){this.command=W,this.args=ve||[],this.options=Re}};e.$5K=Si,e.$5K=Si=Ke([A],Si);let Di=class{constructor(W,ve){this.port=W,this.host=ve}};e.$6K=Di,e.$6K=Di=Ke([A],Di);let Tt=class{constructor(W){this.path=W}};e.$7K=Tt,e.$7K=Tt=Ke([A],Tt);let bi=class{constructor(W){this.implementation=W}};e.$8K=bi,e.$8K=bi=Ke([A],bi);let Ci=class{constructor(W,ve,Re){this.session=W,this.threadId=ve,this.frameId=Re}};e.$9K=Ci,e.$9K=Ci=Ke([A],Ci);let ai=class{constructor(W,ve){this.session=W,this.threadId=ve}};e.$0K=ai,e.$0K=ai=Ke([A],ai);let ci=class{constructor(W,ve){this.range=W,this.expression=ve}};e.$$K=ci,e.$$K=ci=Ke([A],ci);var ut;(function(J){J[J.Invoke=0]="Invoke",J[J.Automatic=1]="Automatic"})(ut||(e.InlineCompletionTriggerKind=ut={}));let Ii=class{constructor(W,ve){this.range=W,this.text=ve}};e.$_K=Ii,e.$_K=Ii=Ke([A],Ii);let Xt=class{constructor(W,ve,Re=!0){this.range=W,this.variableName=ve,this.caseSensitiveLookup=Re}};e.$aL=Xt,e.$aL=Xt=Ke([A],Xt);let ii=class{constructor(W,ve){this.range=W,this.expression=ve}};e.$bL=ii,e.$bL=ii=Ke([A],ii);let pi=class{constructor(W,ve){this.frameId=W,this.stoppedLocation=ve}};e.$cL=pi,e.$cL=pi=Ke([A],pi);var Xi;(function(J){J[J.Changed=1]="Changed",J[J.Created=2]="Created",J[J.Deleted=3]="Deleted"})(Xi||(e.FileChangeType=Xi={}));let Pi=u=class extends Error{static FileExists(W){return new u(W,p.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(W){return new u(W,p.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(W){return new u(W,p.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(W){return new u(W,p.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(W){return new u(W,p.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(W){return new u(W,p.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}constructor(W,ve=p.FileSystemProviderErrorCode.Unknown,Re){super(b.URI.isUri(W)?W.toString(!0):W),this.code=Re?.name??"Unknown",(0,p.$hk)(this,ve),Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof Re=="function"&&Error.captureStackTrace(this,Re)}};e.$dL=Pi,e.$dL=Pi=u=Ke([A],Pi);let Ai=class{constructor(W,ve,Re){this.start=W,this.end=ve,this.kind=Re}};e.$eL=Ai,e.$eL=Ai=Ke([A],Ai);var Ri;(function(J){J[J.Comment=1]="Comment",J[J.Imports=2]="Imports",J[J.Region=3]="Region"})(Ri||(e.FoldingRangeKind=Ri={}));var xi;(function(J){J[J.Collapsed=0]="Collapsed",J[J.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var Li;(function(J){J[J.Editing=0]="Editing",J[J.Preview=1]="Preview"})(Li||(e.CommentMode=Li={}));var ui;(function(J){J[J.Published=0]="Published",J[J.Draft=1]="Draft"})(ui||(e.CommentState=ui={}));var _i;(function(J){J[J.Unresolved=0]="Unresolved",J[J.Resolved=1]="Resolved"})(_i||(e.CommentThreadState=_i={}));class Fi{constructor(W,ve=[]){this.tokenTypes=W,this.tokenModifiers=ve}}e.$fL=Fi;function Mi(J){return typeof J>"u"||(0,k.$kf)(J)}class Ti{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let ve=0,Re=W.tokenTypes.length;ve<Re;ve++)this.j.set(W.tokenTypes[ve],ve);for(let ve=0,Re=W.tokenModifiers.length;ve<Re;ve++)this.k.set(W.tokenModifiers[ve],ve)}}push(W,ve,Re,Qe,tt){if(typeof W=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Qe=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.n(W,ve,Re,Qe,tt);if(z.isRange(W)&&typeof ve=="string"&&Mi(Re))return this.m(W,ve,Re);throw(0,M.$5)()}m(W,ve,Re){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ve))throw new Error("`tokenType` is not in the provided legend");const Qe=W.start.line,tt=W.start.character,ct=W.end.character-W.start.character,ht=this.j.get(ve);let Ut=0;if(Re)for(const Qt of Re){if(!this.k.has(Qt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this.k.get(Qt);Ut|=1<<xt>>>0}this.n(Qe,tt,ct,ht,Ut)}n(W,ve,Re,Qe,tt){if(this.f&&(W<this.c||W===this.c&&ve<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Qt=0,xt=0;for(let ti=0;ti<Ut;ti++){let ri=this.g[5*ti],Qi=this.g[5*ti+1];ri===0?(ri=Qt,Qi+=xt):ri+=Qt,this.g[5*ti]=ri,this.g[5*ti+1]=Qi,Qt=ri,xt=Qi}}let ct=W,ht=ve;this.f&&this.h>0&&(ct-=this.c,ct===0&&(ht-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=ht,this.g[this.h++]=Re,this.g[this.h++]=Qe,this.g[this.h++]=tt,this.c=W,this.e=ve}static o(W){const ve=[],Re=W.length/5|0;for(let ht=0;ht<Re;ht++)ve[ht]=ht;ve.sort((ht,Ut)=>{const Qt=W[5*ht],xt=W[5*Ut];if(Qt===xt){const ti=W[5*ht+1],ri=W[5*Ut+1];return ti-ri}return Qt-xt});const Qe=new Uint32Array(W.length);let tt=0,ct=0;for(let ht=0;ht<Re;ht++){const Ut=5*ve[ht],Qt=W[Ut+0],xt=W[Ut+1],ti=W[Ut+2],ri=W[Ut+3],Qi=W[Ut+4],En=Qt-tt,Ln=En===0?xt-ct:xt,Zi=5*ht;Qe[Zi+0]=En,Qe[Zi+1]=Ln,Qe[Zi+2]=ti,Qe[Zi+3]=ri,Qe[Zi+4]=Qi,tt=Qt,ct=xt}return Qe}build(W){return this.f?new Oi(new Uint32Array(this.g),W):new Oi(Ti.o(this.g),W)}}e.$gL=Ti;class Oi{constructor(W,ve){this.resultId=ve,this.data=W}}e.$hL=Oi;class hi{constructor(W,ve,Re){this.start=W,this.deleteCount=ve,this.data=Re}}e.$iL=hi;class ln{constructor(W,ve){this.resultId=ve,this.edits=W}}e.$jL=ln;var en;(function(J){J[J.Separate=0]="Separate",J[J.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));let Ni=class{static{this.Back={iconPath:new Yt("arrow-left")}}constructor(){}};e.$kL=Ni,e.$kL=Ni=Ke([A],Ni);var di;(function(J){J[J.Separator=-1]="Separator",J[J.Default=0]="Default"})(di||(e.QuickPickItemKind=di={}));var tn;(function(J){J[J.Info=1]="Info",J[J.Warning=2]="Warning",J[J.Error=3]="Error"})(tn||(e.InputBoxValidationSeverity=tn={}));var nn;(function(J){J[J.UI=1]="UI",J[J.Workspace=2]="Workspace"})(nn||(e.ExtensionKind=nn={}));class hn{static validate(W){if(typeof W.badge=="string"){let ve=(0,m.$We)(W.badge,0);if(ve<W.badge.length&&(ve+=(0,m.$We)(W.badge,ve)),W.badge.length>ve)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Yt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,ve,Re){this.badge=W,this.tooltip=ve,this.color=Re}}e.$lL=hn;let ni=class{constructor(W){this.kind=W}};e.$mL=ni,e.$mL=ni=Ke([A],ni);var ji;(function(J){J[J.Light=1]="Light",J[J.Dark=2]="Dark",J[J.HighContrast=3]="HighContrast",J[J.HighContrastLight=4]="HighContrastLight"})(ji||(e.ColorThemeKind=ji={}));class _t{static isNotebookRange(W){return W instanceof _t?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,ve){if(W<0)throw(0,M.$5)("start must be positive");if(ve<0)throw(0,M.$5)("end must be positive");W<=ve?(this.c=W,this.e=ve):(this.c=ve,this.e=W)}with(W){let ve=this.c,Re=this.e;return W.start!==void 0&&(ve=W.start),W.end!==void 0&&(Re=W.end),ve===this.c&&Re===this.e?this:new _t(ve,Re)}}e.$nL=_t;class wi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(ve=>wi.isNotebookCellData(ve))}static isNotebookCellData(W){return!0}constructor(W,ve,Re,Qe,tt,ct,ht){this.kind=W,this.value=ve,this.languageId=Re,this.mime=Qe,this.outputs=tt??[],this.metadata=ct,this.executionSummary=ht,wi.validate(this)}}e.$oL=wi;class rn{constructor(W){this.cells=W}}e.$pL=rn;class Gt{static isNotebookCellOutputItem(W){return W instanceof Gt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const ve={name:W.name,message:W.message,stack:W.stack};return Gt.json(ve,"application/vnd.code.notebook.error")}static stdout(W){return Gt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Gt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,ve="application/octet-stream"){return new Gt(W,ve)}static#e=new TextEncoder;static text(W,ve=R.$Hr.text){const Re=Gt.#e.encode(String(W));return new Gt(Re,ve)}static json(W,ve="text/x-json"){const Re=JSON.stringify(W,void 0,"	");return Gt.text(Re,ve)}constructor(W,ve){this.data=W,this.mime=ve;const Re=(0,R.$Lr)(ve,!0);if(!Re)throw new Error(`INVALID mime type: ${ve}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Re}}e.$qL=Gt;class vi{static isNotebookCellOutput(W){return W instanceof vi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,ve=!1){const Re=new Set,Qe=new Set;for(let tt=0;tt<W.length;tt++){const ct=W[tt],ht=(0,R.$Lr)(ct.mime);if(!Re.has(ht)||(0,C.$9H)(ht)){Re.add(ht);continue}Qe.add(tt),ve&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Qe.size===0?W:W.filter((tt,ct)=>!Qe.has(ct))}constructor(W,ve,Re){this.items=vi.ensureUniqueMimeTypes(W,!0),typeof ve=="string"?(this.id=ve,this.metadata=Re):(this.id=(0,P.$4f)(),this.metadata=ve??Re)}}e.$rL=vi;var sn;(function(J){J[J.Markup=1]="Markup",J[J.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var yi;(function(J){J[J.Idle=1]="Idle",J[J.Pending=2]="Pending",J[J.Executing=3]="Executing"})(yi||(e.NotebookCellExecutionState=yi={}));var zi;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})(zi||(e.NotebookCellStatusBarAlignment=zi={}));var ze;(function(J){J[J.Default=0]="Default",J[J.InCenter=1]="InCenter",J[J.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",J[J.AtTop=3]="AtTop"})(ze||(e.NotebookEditorRevealType=ze={}));class ei{constructor(W,ve){this.text=W,this.alignment=ve}}e.$sL=ei;var Ui;(function(J){J[J.Default=1]="Default",J[J.Preferred=2]="Preferred"})(Ui||(e.NotebookControllerAffinity=Ui={}));var gt;(function(J){J[J.Default=1]="Default",J[J.Preferred=2]="Preferred",J[J.Hidden=-1]="Hidden"})(gt||(e.NotebookControllerAffinity2=gt={}));class dn{constructor(W,ve=[]){this.uri=W,this.provides=(0,D.$1b)(ve)}}e.$tL=dn;class fn{constructor(W){this.label=W}}e.$uL=fn;let Ei=class{constructor(W,ve){this.label=W,this.timestamp=ve}};e.$vL=Ei,e.$vL=Ei=Ke([A],Ei);var on;(function(J){J[J.Production=1]="Production",J[J.Development=2]="Development",J[J.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var fi;(function(J){J[J.Node=1]="Node",J[J.Webworker=2]="Webworker"})(fi||(e.ExtensionRuntime=fi={}));var an;(function(J){J[J.Other=0]="Other",J[J.Comment=1]="Comment",J[J.String=2]="String",J[J.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class gn{constructor(W,ve){this.ranges=W,this.wordPattern=ve}}e.$wL=gn;class mn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$xL=mn;var Bi;(function(J){J[J.Queued=1]="Queued",J[J.Running=2]="Running",J[J.Passed=3]="Passed",J[J.Failed=4]="Failed",J[J.Skipped=5]="Skipped",J[J.Errored=6]="Errored"})(Bi||(e.TestResultState=Bi={}));var cn;(function(J){J[J.Run=1]="Run",J[J.Debug=2]="Debug",J[J.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let Wi=class{constructor(W=void 0,ve=void 0,Re=void 0,Qe=!1){this.include=W,this.exclude=ve,this.profile=Re,this.continuous=Qe}};e.$yL=Wi,e.$yL=Wi=Ke([A],Wi);let Vi=l=class{static diff(W,ve,Re){const Qe=new l(W);return Qe.expectedOutput=ve,Qe.actualOutput=Re,Qe}constructor(W){this.message=W}};e.$zL=Vi,e.$zL=Vi=l=Ke([A],Vi);let qi=class{constructor(W){this.id=W}};e.$AL=qi,e.$AL=qi=Ke([A],qi);let li=class{constructor(W,ve){this.covered=W,this.total=ve}};e.$BL=li,e.$BL=li=Ke([A],li);let Hi=w=class{static fromDetails(W,ve){const Re=new li(0,0),Qe=new li(0,0),tt=new li(0,0);for(const ht of ve)if("branches"in ht){Re.total+=1,Re.covered+=ht.executionCount>0?1:0;for(const Ut of ht.branches)Qe.total+=1,Qe.covered+=Ut.executionCount>0?1:0}else tt.total+=1,tt.covered+=ht.executionCount>0?1:0;const ct=new w(W,Re,Qe.total>0?Qe:void 0,tt.total>0?tt:void 0);return ct.detailedCoverage=ve,ct}constructor(W,ve,Re,Qe){this.uri=W,this.statementCoverage=ve,this.branchCoverage=Re,this.functionCoverage=Qe}};e.$CL=Hi,e.$CL=Hi=w=Ke([A],Hi);let Ki=class{constructor(W,ve,Re=[]){this.executionCount=W,this.location=ve,this.branches=Re}};e.$DL=Ki,e.$DL=Ki=Ke([A],Ki);let Ji=class{constructor(W,ve){this.executionCount=W,this.location=ve}};e.$EL=Ji,e.$EL=Ji=Ke([A],Ji);let Gi=class{constructor(W,ve){this.executionCount=W,this.location=ve}};e.$FL=Gi,e.$FL=Gi=Ke([A],Gi);var pe;(function(J){J[J.None=0]="None",J[J.Option=1]="Option",J[J.Default=2]="Default",J[J.Preferred=3]="Preferred"})(pe||(e.ExternalUriOpenerPriority=pe={}));var ke;(function(J){J[J.Untrusted=0]="Untrusted",J[J.Trusted=1]="Trusted",J[J.Unspecified=2]="Unspecified"})(ke||(e.WorkspaceTrustState=ke={}));var Ne;(function(J){J[J.Notify=1]="Notify",J[J.OpenBrowser=2]="OpenBrowser",J[J.OpenPreview=3]="OpenPreview",J[J.Silent=4]="Silent",J[J.Ignore=5]="Ignore",J[J.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ne||(e.PortAutoForwardAction=Ne={}));class st{constructor(W,ve,Re,Qe,tt,ct){this.kind=W,this.name=ve,this.detail=Re,this.uri=Qe,this.range=tt,this.selectionRange=ct}}e.$GL=st;class Et{constructor(W){this.uri=W}}e.$HL=Et;class Ot{constructor(W,ve){this.original=W,this.modified=ve}}e.$IL=Ot;class kn{constructor(W,ve,Re,Qe){this.base=W,this.input1=ve,this.input2=Re,this.result=Qe}}e.$JL=kn;class Sn{constructor(W,ve){this.uri=W,this.viewType=ve}}e.$KL=Sn;class Dn{constructor(W){this.viewType=W}}e.$LL=Dn;class Cn{constructor(W,ve){this.uri=W,this.notebookType=ve}}e.$ML=Cn;class In{constructor(W,ve,Re){this.original=W,this.modified=ve,this.notebookType=Re}}e.$NL=In;class Pn{constructor(){}}e.$OL=Pn;class An{constructor(W,ve){this.uri=W,this.inputBoxUri=ve}}e.$PL=An;var $n;(function(J){J[J.Up=1]="Up",J[J.Down=2]="Down"})($n||(e.InteractiveSessionVoteDirection=$n={}));var bn;(function(J){J[J.Action=1]="Action",J[J.Toolbar=2]="Toolbar"})(bn||(e.InteractiveSessionCopyKind=bn={}));var pn;(function(J){J[J.Unhelpful=0]="Unhelpful",J[J.Helpful=1]="Helpful",J[J.Undone=2]="Undone",J[J.Accepted=3]="Accepted"})(pn||(e.InteractiveEditorResponseFeedbackKind=pn={}));var wn;(function(J){J[J.System=0]="System",J[J.User=1]="User",J[J.Assistant=2]="Assistant",J[J.Function=3]="Function"})(wn||(e.ChatMessageRole=wn={}));var vn;(function(J){J[J.Short=1]="Short",J[J.Medium=2]="Medium",J[J.Full=3]="Full"})(vn||(e.ChatVariableLevel=vn={}));class Rn{constructor(W,ve){this.role=W,this.content=ve}}e.$QL=Rn;var yn;(function(J){J[J.SymbolInformation=1]="SymbolInformation",J[J.CommandInformation=2]="CommandInformation",J[J.SearchInformation=3]="SearchInformation",J[J.SettingInformation=4]="SettingInformation"})(yn||(e.RelatedInformationType=yn={}))}),define(Se[141],De([1,0,58,17,15,171,124,7,19]),function($e,e,D,M,g,L,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.$5L=e.$4L=void 0;const b=new Map;function P(C,v){v?b.set(C,v):b.delete(C)}e.$4L=P;function I(C){return b.get(C)}class p extends L.$Mu{constructor(v,o,s,n,h,$,d,t){super(o,s,n,h),this.c=v,this.m=$,this.q=d,this.notebook=t,this.b=!1}dispose(){(0,D.ok)(!this.b),this.b=!0,this.q=!1}equalLines(v){return(0,k.$sb)(this.f,v)}get document(){if(!this.a){const v=this;this.a={get uri(){return v.d},get fileName(){return v.d.fsPath},get isUntitled(){return v.d.scheme===M.Schemas.untitled},get languageId(){return v.m},get version(){return v.h},get isClosed(){return v.b},get isDirty(){return v.q},save(){return v.r()},getText(o){return o?v.s(o):v.getText()},get eol(){return v.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return v.f.length},lineAt(o){return v.t(o)},offsetAt(o){return v.u(o)},positionAt(o){return v.v(o)},validateRange(o){return v.w(o)},validatePosition(o){return v.x(o)},getWordRangeAtPosition(o,s){return v.y(o,s)}}}return Object.freeze(this.a)}_acceptLanguageId(v){(0,D.ok)(!this.b),this.m=v}_acceptIsDirty(v){(0,D.ok)(!this.b),this.q=v}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(v){const o=this.w(v);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const s=this.g,n=o.start.line,h=o.end.line,$=[];$.push(this.f[n].substring(o.start.character));for(let d=n+1;d<h;d++)$.push(this.f[d]);return $.push(this.f[h].substring(0,o.end.character)),$.join(s)}t(v){let o;if(v instanceof m.$3J?o=v.line:typeof v=="number"&&(o=v),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new S(o,this.f[o],o===this.f.length-1)}u(v){return v=this.x(v),this.l(),this.j.getPrefixSum(v.line-1)+v.character}v(v){v=Math.floor(v),v=Math.max(0,v),this.l();const o=this.j.getIndexOf(v),s=this.f[o.index].length;return new m.$3J(o.index,Math.min(o.remainder,s))}w(v){if(!(v instanceof m.$4J))throw new Error("Invalid argument");const o=this.x(v.start),s=this.x(v.end);return o===v.start&&s===v.end?v:new m.$4J(o.line,o.character,s.line,s.character)}x(v){if(!(v instanceof m.$3J))throw new Error("Invalid argument");if(this.f.length===0)return v.with(0,0);let{line:o,character:s}=v,n=!1;if(o<0)o=0,s=0,n=!0;else if(o>=this.f.length)o=this.f.length-1,s=this.f[o].length,n=!0;else{const h=this.f[o].length;s<0?(s=0,n=!0):s>h&&(s=h,n=!0)}return n?new m.$3J(o,s):v}y(v,o){const s=this.x(v);if(!o)o=I(this.m);else if((0,g.$ze)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const n=(0,R.$Zr)(s.character+1,(0,R.$Xr)(o),this.f[s.line],0);if(n)return new m.$4J(s.line,n.startColumn-1,s.line,n.endColumn-1)}}e.$5L=p;class S{constructor(v,o,s){this.a=v,this.b=o,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$4J(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$4J(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$6L=S}),define(Se[274],De([1,0,7,20,4]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=void 0;let L=class{constructor(m){this.a=new D.$mL(D.ColorThemeKind.Dark),this.b=new g.$fd}get activeColorTheme(){return this.a}$onColorThemeChange(m){let k;switch(m){case"light":k=D.ColorThemeKind.Light;break;case"hcDark":k=D.ColorThemeKind.HighContrast;break;case"hcLight":k=D.ColorThemeKind.HighContrastLight;break;default:k=D.ColorThemeKind.Dark}this.a=new D.$mL(k),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Acc=L,e.$Acc=L=Ke([Be(0,M.$2L)],L)}),define(Se[275],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aI=e.CellExecutionUpdateType=void 0;var M;(function(g){g[g.Output=1]="Output",g[g.OutputItems=2]="OutputItems",g[g.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$aI=(0,D.$Bh)("INotebookExecutionService")}),define(Se[69],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OI=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(L){L.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var M;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class g{static fromExtHostTestItem(R,m,k=R.parent){if(R._isRoot)return new g([m]);const b=[R.id];for(let P=k;P&&P.id!==m;P=P.parent)b.push(P.id);return b.push(m),new g(b.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const m=R.indexOf("\0");return m===-1?R:R.slice(0,m)}static fromString(R){return new g(R.split("\0"))}static join(R,m){return new g([...R.path,m])}static joinToString(R,m){return R.toString()+"\0"+m}static parentId(R){const m=R.lastIndexOf("\0");return m===-1?void 0:R.slice(0,m)}static localId(R){const m=R.lastIndexOf("\0");return m===-1?R:R.slice(m+1)}static isChild(R,m){return m.startsWith(R)&&m[R.length]==="\0"}static compare(R,m){return R===m?0:g.isChild(R,m)?2:g.isChild(m,R)?3:1}constructor(R,m=R.length){if(this.path=R,this.d=m,R.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new g(this.path,1)}get parentId(){return this.d>1?new g(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new g(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new g(this.path,R)}compare(R){if(typeof R=="string")return g.compare(this.toString(),R);for(let m=0;m<R.d&&m<this.d;m++)if(R.path[m]!==this.path[m])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$OI=g}),define(Se[88],De([1,0,2,34,69]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VI=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$UI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$TI=e.$SI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$RI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$QI=e.$PI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(E){E[E.Unset=0]="Unset",E[E.Queued=1]="Queued",E[E.Running=2]="Running",E[E.Passed=3]="Passed",E[E.Failed=4]="Failed",E[E.Skipped=5]="Skipped",E[E.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var R;(function(E){E[E.Run=1]="Run",E[E.Debug=2]="Debug",E[E.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var m;(function(E){E[E.Run=2]="Run",E[E.Debug=4]="Debug",E[E.Coverage=8]="Coverage",E[E.HasNonDefaultProfile=16]="HasNonDefaultProfile",E[E.HasConfigurable=32]="HasConfigurable",E[E.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.$PI=[2,4,8,16,32,64];const k=E=>"runId"in E;e.$QI=k;var b;(function(E){E.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),E.deserialize=u=>({range:M.$ks.lift(u.range),uri:D.URI.revive(u.uri)})})(b||(e.IRichLocation=b={}));var P;(function(E){E[E.Error=0]="Error",E[E.Output=1]="Output"})(P||(e.TestMessageType=P={}));var I;(function(E){E.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&b.serialize(u.location)}),E.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&b.deserialize(u.location)})})(I||(e.ITestErrorMessage=I={}));const p=(E,u)=>`${u?"s":"e"}${E}`;e.$RI=p;var S;(function(E){E.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&b.serialize(u.location)}),E.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&b.deserialize(u.location)})})(S||(e.ITestOutputMessage=S={}));var C;(function(E){E.serialize=u=>u.type===0?I.serialize(u):S.serialize(u),E.deserialize=u=>u.type===0?I.deserialize(u):S.deserialize(u)})(C||(e.ITestMessage=C={}));var v;(function(E){E.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),E.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(C.serialize)}),E.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(C.deserialize)})})(v||(e.ITestTaskState=v={}));const o="\0",s=(E,u)=>E+o+u;e.$SI=s;const n=E=>{const u=E.indexOf(o);return{ctrlId:E.slice(0,u),tagId:E.slice(u+1)}};e.$TI=n;var h;(function(E){E.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),E.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?D.URI.revive(u.uri):void 0,range:u.range?M.$ks.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})(h||(e.ITestItem=h={}));var $;(function(E){E[E.NotExpandable=0]="NotExpandable",E[E.Expandable=1]="Expandable",E[E.BusyExpanding=2]="BusyExpanding",E[E.Expanded=3]="Expanded"})($||(e.TestItemExpandState=$={}));var d;(function(E){E.serialize=u=>({expand:u.expand,item:h.serialize(u.item)}),E.deserialize=u=>({controllerId:g.$OI.root(u.item.extId),expand:u.expand,item:h.deserialize(u.item)})})(d||(e.InternalTestItem=d={}));var t;(function(E){E.serialize=u=>{let l;return u.item&&(l={},u.item.label!==void 0&&(l.label=u.item.label),u.item.tags!==void 0&&(l.tags=u.item.tags),u.item.busy!==void 0&&(l.busy=u.item.busy),u.item.uri!==void 0&&(l.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(l.range=u.item.range?.toJSON()),u.item.description!==void 0&&(l.description=u.item.description),u.item.error!==void 0&&(l.error=u.item.error),u.item.sortText!==void 0&&(l.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:l}},E.deserialize=u=>{let l;return u.item&&(l={},u.item.label!==void 0&&(l.label=u.item.label),u.item.tags!==void 0&&(l.tags=u.item.tags),u.item.busy!==void 0&&(l.busy=u.item.busy),u.item.range!==void 0&&(l.range=u.item.range?M.$ks.lift(u.item.range):null),u.item.description!==void 0&&(l.description=u.item.description),u.item.error!==void 0&&(l.error=u.item.error),u.item.sortText!==void 0&&(l.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:l}}})(t||(e.ITestItemUpdate=t={}));const r=(E,u)=>{u.expand!==void 0&&(E.expand=u.expand),u.item!==void 0&&(E.item=E.item?Object.assign(E.item,u.item):u.item)};e.$UI=r;var a;(function(E){E.serializeWithoutMessages=u=>({...d.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(v.serializeWithoutMessages)}),E.serialize=u=>({...d.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(v.serialize)}),E.deserialize=u=>({...d.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(v.deserialize),retired:!0})})(a||(e.TestResultItem=a={}));var i;(function(E){E[E.Function=0]="Function",E[E.Statement=1]="Statement"})(i||(e.DetailType=i={}));var c;(function(E){E[E.Add=0]="Add",E[E.Update=1]="Update",E[E.DocumentSynced=2]="DocumentSynced",E[E.Remove=3]="Remove",E[E.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",E[E.Retire=5]="Retire",E[E.AddTag=6]="AddTag",E[E.RemoveTag=7]="RemoveTag"})(c||(e.TestDiffOpType=c={}));var f;(function(E){E.deserialize=u=>u.op===0?{op:u.op,item:d.deserialize(u.item)}:u.op===1?{op:u.op,item:t.deserialize(u.item)}:u.op===2?{op:u.op,uri:D.URI.revive(u.uri),docv:u.docv}:u,E.serialize=u=>u.op===0?{op:u.op,item:d.serialize(u.item)}:u.op===1?{op:u.op,item:t.serialize(u.item)}:u})(f||(e.TestsDiffOp=f={}));class y{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(u){const l=this.p();for(const w of u)switch(w.op){case 0:this.k(d.deserialize(w.item),l);break;case 1:this.l(t.deserialize(w.item),l);break;case 3:this.m(w.itemId,l);break;case 5:this.o(w.itemId);break;case 4:this.updatePendingRoots(w.amount);break;case 6:this.d.set(w.tag.id,w.tag);break;case 7:this.d.delete(w.id);break}l.complete?.()}k(u,l){const w=g.$OI.parentId(u.item.extId)?.toString();let A;if(!w)A=this.q(u),this.g.add(A),this.f.set(u.item.extId,A);else if(this.f.has(w)){const N=this.f.get(w);N.children.add(u.item.extId),A=this.q(u,N),this.f.set(u.item.extId,A)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return l.add?.(A),u.expand===2&&this.h++,A}l(u,l){const w=this.f.get(u.extId);if(w)return u.expand!==void 0&&(w.expand===2&&this.h--,u.expand===2&&this.h++),(0,e.$UI)(w,u),l.update?.(w),w}m(u,l){const w=this.f.get(u);if(!w)return;const A=g.$OI.parentId(w.item.extId)?.toString();A?this.f.get(A).children.delete(w.item.extId):this.g.delete(w);const N=[[u]];for(;N.length;)for(const O of N.pop()){const F=this.f.get(O);F&&(N.push(F.children),this.f.delete(O),l.remove?.(F,F!==w),F.expand===2&&this.h--)}}o(u){}updatePendingRoots(u){this.j+=u}p(){return{}}}e.$VI=y}),define(Se[109],De([1,0,9,4,3,58,88,69]),function($e,e,D,M,g,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.TestItemEventOp=void 0;var k;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(k||(e.TestItemEventOp=k={}));const b=(n,h)=>n===h,I=Object.entries({range:(n,h)=>n===h?!0:!n||!h?!1:n.equalsRange(h),busy:b,label:b,description:b,error:b,sortText:b,tags:(n,h)=>!(n.length!==h.length||n.some($=>!h.includes($)))}),p=(n,h)=>{let $;for(const[d,t]of I)t(n[d],h[d])||($?$[d]=h[d]:$={[d]:h[d]});return $};class S extends g.$kc{get root(){return this.s.root}constructor(h){super(),this.s=h,this.f=this.B(new D.$Sg(()=>this.flushDiff(),200)),this.g=this.B(new M.$fd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(h){this.h=h;for(const $ of this.tree.values())this.I($)}get resolveHandler(){return this.h}collectDiff(){const h=this.m;return this.m=[],h}pushDiff(h){switch(h.op){case 2:{for(const $ of this.m)if($.op===2&&$.uri===h.uri){$.docv=h.docv;return}break}case 1:{const $=this.m[this.m.length-1];if($){if($.op===1&&$.item.extId===h.item.extId){(0,R.$UI)($.item,h.item);return}if($.op===0&&$.item.item.extId===h.item.extId){(0,R.$UI)($.item,h.item);return}}break}}this.m.push(h),this.f.isScheduled()||this.f.schedule()}expand(h,$){const d=this.tree.get(h);if(d){if((d.expandLevels===void 0||$>d.expandLevels)&&(d.expandLevels=$),d.expand===1){const t=this.L(d);return t.isOpen()?this.J(d,$-1):t.wait().then(()=>this.J(d,$-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.J(d,$-1)):this.J(d,$-1)}}dispose(){for(const h of this.tree.values())this.s.getApiFor(h.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(h,$){switch($.op){case 3:this.N(m.$OI.joinToString(h.fullId,$.id));break;case 0:this.y($.item,h);break;case 5:for(const d of $.ops)this.u(h,d);break;case 1:this.z($.new,$.old,h.fullId.toString());break;case 2:this.I(h);break;case 4:this.pushDiff({op:1,item:{extId:h.fullId.toString(),item:$.update}});break;case 6:this.w(h.actual.uri);break;default:(0,L.$vc)($)}}w(h){h&&this.pushDiff({op:2,uri:h,docv:this.s.getDocumentVersion(h)})}y(h,$){const d=m.$OI.fromExtHostTestItem(h,this.root.id,$?.actual),t=this.s.getApiFor(h);t.parent&&t.parent!==$?.actual&&this.s.getChildren(t.parent).delete(h.id);let r=this.tree.get(d.toString());if(!r){r={fullId:d,actual:h,expandLevels:$?.expandLevels?$.expandLevels-1:void 0,expand:0},h.tags.forEach(this.C,this),this.tree.set(r.fullId.toString(),r),this.F(h,$),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(h)}}),this.H(h,r,$);return}if(r.actual===h){this.G(h,r,$);return}if(r.actual.uri?.toString()!==h.uri?.toString())return this.N(d.toString()),this.y(h,$);const a=this.s.getChildren(r.actual),i=r.actual,c=p(this.s.toITestItem(i),this.s.toITestItem(h));this.s.getApiFor(i).listener=void 0,r.actual=h,r.expand=0,c&&(c.hasOwnProperty("tags")&&(this.z(h.tags,i.tags,d.toString()),delete c.tags),this.u(r,{op:4,update:c})),this.H(h,r,$);for(const[f,y]of a)this.s.getChildren(h).get(y.id)||this.N(m.$OI.joinToString(d,y.id));this.w(r.actual.uri)}z(h,$,d){const t=new Set($.map(r=>r.id));for(const r of h)t.delete(r.id)||this.C(r);this.pushDiff({op:1,item:{extId:d,item:{tags:h.map(r=>(0,R.$SI)(this.s.controllerId,r.id))}}}),t.forEach(this.D,this)}C(h){const $=this.j.get(h.id);$?$.refCount++:(this.j.set(h.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$SI)(this.s.controllerId,h.id)}}))}D(h){const $=this.j.get(h);$&&!--$.refCount&&(this.j.delete(h),this.pushDiff({op:7,id:(0,R.$SI)(this.s.controllerId,h)}))}F(h,$){this.s.getApiFor(h).parent=$&&$.actual!==this.root?$.actual:void 0}G(h,$,d){this.F(h,d);const t=this.s.getApiFor(h);t.parent=d?.actual,t.listener=r=>this.u($,r),this.I($)}H(h,$,d){this.G(h,$,d);for(const[t,r]of this.s.getChildren(h))this.y(r,$)}I(h){let $;this.h?h.resolveBarrier?$=h.resolveBarrier.isOpen()?3:2:$=h.actual.canResolveChildren?1:0:$=0,$!==h.expand&&(h.expand=$,this.pushDiff({op:1,item:{extId:h.fullId.toString(),expand:$}}),$===1&&h.expandLevels!==void 0&&this.L(h))}J(h,$){if($<0)return;const d=[];for(const[t,r]of this.s.getChildren(h.actual)){const a=this.expand(m.$OI.joinToString(h.fullId,r.id),$);(0,D.$tg)(a)&&d.push(a)}if(d.length)return Promise.all(d).then(()=>{})}L(h){if(h.resolveBarrier)return h.resolveBarrier;if(!this.h){const r=new D.$Fg;return r.open(),r}h.expand=2,this.M(h);const $=h.resolveBarrier=new D.$Fg,d=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let t;try{t=this.h(h.actual===this.root?void 0:h.actual)}catch(r){d(r)}return(0,D.$tg)(t)?t.catch(d).then(()=>{$.open(),this.I(h)}):($.open(),this.I(h)),h.resolveBarrier}M(h){this.pushDiff({op:1,item:{extId:h.fullId.toString(),expand:h.expand}})}N(h){const $=this.tree.get(h);if(!$)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:h});const d=[$];for(;d.length;){const t=d.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const r of t.actual.tags)this.D(r.id);this.tree.delete(t.fullId.toString());for(const[r,a]of this.s.getChildren(t.actual))d.push(this.tree.get(m.$OI.joinToString(t.fullId,a.id)))}}}flushDiff(){const h=this.collectDiff();h.length&&this.g.fire(h)}}e.$RL=S;class C extends Error{constructor(h){super(`Attempted to insert a duplicate test item ID ${h}`)}}e.$SL=C;class v extends Error{constructor(h){super(`TestItem with ID "${h}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$TL=v;class o extends Error{constructor(h,$,d){super(`TestItem with ID "${h}" is from controller "${$}" and cannot be added as a child of an item from controller "${d}".`)}}e.$UL=o;const s=(n,h,$)=>{let d=new Map;return{get size(){return d.size},forEach(t,r){for(const a of d.values())t.call(r,a,this)},[Symbol.iterator](){return d.entries()},replace(t){const r=new Map,a=new Set(d.keys()),i={op:5,ops:[]};for(const c of t){if(!(c instanceof $))throw new v(c.id);const f=h(c).controllerId;if(f!==n.controllerId)throw new o(c.id,f,n.controllerId);if(r.has(c.id))throw new C(c.id);r.set(c.id,c),a.delete(c.id),i.ops.push({op:0,item:c})}for(const c of a.keys())i.ops.push({op:3,id:c});n.listener?.(i),d=r},add(t){if(!(t instanceof $))throw new v(t.id);d.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){d.delete(t)&&n.listener?.({op:3,id:t})},get(t){return d.get(t)},toJSON(){return Array.from(d.values())}}};e.$VL=s}),define(Se[142],De([1,0,109]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XL=e.$WL=void 0;const M=new WeakMap,g=(R,m)=>{const k={controllerId:m};return M.set(R,k),k};e.$WL=g;const L=R=>{const m=M.get(R);if(!m)throw new D.$TL(R?.id||"<unknown>");return m};e.$XL=L}),define(Se[110],De([1,0,17,2]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zob=e.$Yob=e.$Xob=e.$Wob=e.$Vob=void 0,e.$Vob="vscode-cdn.net",e.$Wob=`vscode-resource.${e.$Vob}`,e.$Xob=`'self' https://*.${e.$Vob}`;function g(m,k){return m.scheme===D.Schemas.http||m.scheme===D.Schemas.https?m:(k&&k.authority&&k.isRemote&&m.scheme===D.Schemas.file&&(m=M.URI.from({scheme:D.Schemas.vscodeRemote,authority:k.authority,path:m.path})),M.URI.from({scheme:D.Schemas.https,authority:`${m.scheme}+${L(m.authority)}.${e.$Wob}`,path:m.path,fragment:m.fragment,query:m.query}))}e.$Yob=g;function L(m){return m.replace(/./g,k=>{const b=k.charCodeAt(0);return b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57?k:"-"+b.toString(16).padStart(4,"0")})}function R(m){return m.replace(/-([0-9a-f]{4})/g,(k,b)=>String.fromCharCode(parseInt(b,16)))}e.$Zob=R}),define(Se[276],De([1,0,4,3,110]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=void 0;class L{constructor(m,k,b){this.d=m,this.e=k,this.f=b,this.a=0,this.b=new M.$jc,this.c=new Map,this.b.add(k.onDidChangeVisibleTextEditors(()=>{const P=k.getVisibleTextEditors();for(const I of this.c.values())P.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,k,b,P,I){let p;for(const h of this.e.getVisibleTextEditors(!0))if(h.value===m){p=h;break}if(!p)throw new Error("not a visible editor");const S=this,C=this.a++,v=new D.$fd,o=new D.$fd,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(h){return(0,g.$Yob)(h,S.f)}get cspSource(){return g.$Xob}set options(h){this.b=h,S.d.$setOptions(C,h)}get options(){return this.b}set html(h){this.a=h,S.d.$setHtml(C,h)}get html(){return this.a}get onDidReceiveMessage(){return v.event}postMessage(h){return S.d.$postMessage(C,h)}},n=new class{constructor(){this.editor=m,this.line=k,this.height=b,this.webview=s,this.onDidDispose=o.event}dispose(){S.c.has(C)&&(S.c.delete(C),S.d.$disposeEditorInset(C),o.fire(),o.dispose(),v.dispose())}};return this.d.$createEditorInset(C,p.id,p.value.document.uri,k+1,b,P||{},I.identifier,I.extensionLocation),this.c.set(C,{editor:m,inset:n,onDidReceiveMessage:v}),n}$onDidDispose(m){const k=this.c.get(m);k&&k.inset.dispose()}$onDidReceiveMessage(m,k){this.c.get(m)?.onDidReceiveMessage.fire(k)}}e.$$bc=L}),define(Se[277],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=e.VariableKind=e.$NM=void 0,e.$NM=(0,D.$Bh)("configurationResolverService");var M;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(M||(e.VariableKind=M={}));class g extends Error{constructor(R,m){super(m),this.variable=R}}e.$OM=g}),define(Se[278],De([1,0,16,47,18,23,12,100,223,277,15]),function($e,e,D,M,g,L,R,m,k,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3M=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,C,v,o){this.h=new Map,this.a=S,this.b=C,this.g=v,o&&(this.c=o.then(s=>this.i(s)))}i(S){if(R.$i){const C=Object.create(null);return Object.keys(S).forEach(v=>{C[v.toLowerCase()]=S[v]}),C}return S}resolveWithEnvironment(S,C,v){return this.l({env:this.i(S),userHome:void 0},C?C.uri:void 0,v)}async resolveAsync(S,C){const v={env:await this.c,userHome:await this.g};return this.l(v,S?S.uri:void 0,C)}async j(S,C,v,o){const s=L.$Vm(C);R.$i&&s.windows?Object.keys(s.windows).forEach(h=>s[h]=s.windows[h]):R.$j&&s.osx?Object.keys(s.osx).forEach(h=>s[h]=s.osx[h]):R.$k&&s.linux&&Object.keys(s.linux).forEach(h=>s[h]=s.linux[h]),delete s.windows,delete s.osx,delete s.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,S?S.uri:void 0,s,v,o)}async resolveAnyAsync(S,C,v){return this.j(S,C,v)}async resolveAnyMap(S,C,v){const o=new Map;return{newConfig:await this.j(S,C,v,o),resolvedVariables:o}}resolveWithInteractionReplace(S,C,v,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,C,v,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,C){if(this.h.has(S))throw new Error("Variable "+S+" is contributed twice.");this.h.set(S,C)}async l(S,C,v,o,s){if(g.$jf(v))return this.m(S,C,v,o,s);if(Array.isArray(v))return Promise.all(v.map(n=>this.l(S,C,n,o,s)));if(g.$lf(v)){const n=Object.create(null),h=await Promise.all(Object.keys(v).map(async $=>[await this.m(S,C,$,o,s),await this.l(S,C,v[$],o,s)]));for(const[$,d]of h)n[$]=d;return n}return v}m(S,C,v,o,s){return(0,P.$Ee)(v,I.VARIABLE_REGEXP,async(n,h)=>{if(h.includes(I.VARIABLE_LHS))return n;let $=await this.o(S,n,h,C,o);return s?.set(h,$),$!==n&&g.$jf($)&&$.match(I.VARIABLE_REGEXP)&&($=await this.m(S,C,$,o,s)),$})}n(S){return this.b?this.b.getUriLabel(S,{noPrefix:!0}):S.fsPath}async o(S,C,v,o,s){let n;const h=v.split(":");h.length>1&&(v=h[0],n=h[1]);const $=r=>{const a=this.a.getFilePath();if(a)return(0,m.$fA)(a);throw new b.$OM(r,(0,k.localize)(0,null,C))},d=r=>{const a=$(r);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,m.$fA)(i)}throw new b.$OM(r,(0,k.localize)(1,null,C,D.$ae(a)))},t=r=>{if(n){const a=this.a.getFolderUri(n);if(a)return a;throw new b.$OM(r,(0,k.localize)(2,null,C,n))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new b.$OM(r,(0,k.localize)(3,null,C)):new b.$OM(r,(0,k.localize)(4,null,C))};switch(v){case"env":if(n){if(S.env){const r=S.env[R.$i?n.toLowerCase():n];if(g.$jf(r))return r}return""}throw new b.$OM(b.VariableKind.Env,(0,k.localize)(5,null,C));case"config":if(n){const r=this.a.getConfigurationValue(o,n);if(g.$sf(r))throw new b.$OM(b.VariableKind.Config,(0,k.localize)(6,null,C,n));if(g.$lf(r))throw new b.$OM(b.VariableKind.Config,(0,k.localize)(7,null,C,n));return r}throw new b.$OM(b.VariableKind.Config,(0,k.localize)(8,null,C));case"command":return this.p(b.VariableKind.Command,C,n,s,"command");case"input":return this.p(b.VariableKind.Input,C,n,s,"input");case"extensionInstallFolder":if(n){const r=await this.a.getExtension(n);if(!r)throw new b.$OM(b.VariableKind.ExtensionInstallFolder,(0,k.localize)(9,null,C,n));return this.n(r.extensionLocation)}throw new b.$OM(b.VariableKind.ExtensionInstallFolder,(0,k.localize)(10,null,C));default:switch(v){case"workspaceRoot":case"workspaceFolder":return(0,m.$fA)(this.n(t(b.VariableKind.WorkspaceFolder)));case"cwd":return o||n?(0,m.$fA)(this.n(t(b.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$fA)(D.$ae(this.n(t(b.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new b.$OM(b.VariableKind.UserHome,(0,k.localize)(11,null,C))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new b.$OM(b.VariableKind.LineNumber,(0,k.localize)(12,null,C))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new b.$OM(b.VariableKind.SelectedText,(0,k.localize)(13,null,C))}case"file":return $(b.VariableKind.File);case"fileWorkspaceFolder":return d(b.VariableKind.FileWorkspaceFolder);case"relativeFile":return o||n?D.$$d(this.n(t(b.VariableKind.RelativeFile)),$(b.VariableKind.RelativeFile)):$(b.VariableKind.RelativeFile);case"relativeFileDirname":{const r=D.$_d($(b.VariableKind.RelativeFileDirname));if(o||n){const a=D.$$d(this.n(t(b.VariableKind.RelativeFileDirname)),r);return a.length===0?".":a}return r}case"fileDirname":return D.$_d($(b.VariableKind.FileDirname));case"fileExtname":return D.$be($(b.VariableKind.FileExtname));case"fileBasename":return D.$ae($(b.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=D.$ae($(b.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-D.$be(r).length)}case"fileDirnameBasename":return D.$ae(D.$_d($(b.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||C}case"execInstallFolder":{const r=this.a.getAppRoot();return r||C}case"pathSeparator":return D.sep;default:try{const r=n?`${v}:${n}`:v;return this.p(b.VariableKind.Unknown,C,r,s,void 0)}catch{return C}}}}p(S,C,v,o,s){if(v&&o){const n=s===void 0?o[v]:o[s+":"+v];if(typeof n=="string")return n;throw new b.$OM(S,(0,k.localize)(14,null,C))}return C}}e.$3M=I}),define(Se[143],De([1,0,5,139]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8C=e.$7C=e.OpenEditorContext=e.GroupsOrder=e.$6C=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$5C=void 0,e.$5C=(0,D.$Bh)("editorGroupsService");var g;(function(C){C[C.UP=0]="UP",C[C.DOWN=1]="DOWN",C[C.LEFT=2]="LEFT",C[C.RIGHT=3]="RIGHT"})(g||(e.GroupDirection=g={}));var L;(function(C){C[C.HORIZONTAL=0]="HORIZONTAL",C[C.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var R;(function(C){C[C.FIRST=0]="FIRST",C[C.LAST=1]="LAST",C[C.NEXT=2]="NEXT",C[C.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var m;(function(C){C[C.MAXIMIZE=0]="MAXIMIZE",C[C.EVEN=1]="EVEN",C[C.TOGGLE=2]="TOGGLE"})(m||(e.GroupsArrangement=m={}));var k;(function(C){C[C.COPY_EDITORS=0]="COPY_EDITORS",C[C.MOVE_EDITORS=1]="MOVE_EDITORS"})(k||(e.MergeGroupMode=k={}));function b(C){const v=C;return(0,M.$UE)(v?.editor)&&(0,M.$UE)(v?.replacement)}e.$6C=b;var P;(function(C){C[C.CREATION_TIME=0]="CREATION_TIME",C[C.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",C[C.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var I;(function(C){C[C.NEW_EDITOR=1]="NEW_EDITOR",C[C.MOVE_EDITOR=2]="MOVE_EDITOR",C[C.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function p(C){const v=C;return!!v&&typeof v.id=="number"&&Array.isArray(v.editors)}e.$7C=p;function S(C){return C.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$8C=S}),define(Se[279],De([1,0,5,143]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_C=e.$$C=e.$0C=e.$9C=void 0,e.$9C=(0,D.$Bh)("editorService"),e.$0C=-1,e.$$C=-2;function g(L){const R=L;return typeof L=="number"||(0,M.$7C)(R)}e.$_C=g}),define(Se[13],De([1,0,19,22,162,75,80,28,158,63,98,23,18,2,34,83,133,142,139,108,69,88,279,7]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o,s,n,h,$,d,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$1L=e.$ZL=e.MarkdownString=e.$YL=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(Fe){function Me(_){const{selectionStartLineNumber:Te,selectionStartColumn:He,positionLineNumber:xe,positionColumn:Je}=_,nt=new r.$3J(Te-1,He-1),bt=new r.$3J(xe-1,Je-1);return new r.$5J(nt,bt)}Fe.to=Me;function Pe(_){const{anchor:Te,active:He}=_;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Fe.from=Pe})(a||(e.Selection=a={}));var i;(function(Fe){function Me(_){if(!_)return;const{start:Te,end:He}=_;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Fe.from=Me;function Pe(_){if(!_)return;const{startLineNumber:Te,startColumn:He,endLineNumber:xe,endColumn:Je}=_;return new r.$4J(Te-1,He-1,xe-1,Je-1)}Fe.to=Pe})(i||(e.Range=i={}));var c;(function(Fe){function Me(Pe){switch(Pe){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Fe.to=Me})(c||(e.TokenType=c={}));var f;(function(Fe){function Me(_){return new r.$3J(_.lineNumber-1,_.column-1)}Fe.to=Me;function Pe(_){return{lineNumber:_.line+1,column:_.character+1}}Fe.from=Pe})(f||(e.Position=f={}));var y;(function(Fe){function Me(Te,He,xe){return(0,D.$Fb)((0,D.$1b)(Te).map(Je=>Pe(Je,He,xe)))}Fe.from=Me;function Pe(Te,He,xe){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:xe?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:_(Te.scheme,He),pattern:Ze.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:xe?.isBuiltin}}function _(Te,He){return He&&typeof Te=="string"?He.transformOutgoingScheme(Te):Te}})(y||(e.DocumentSelector=y={}));var E;(function(Fe){function Me(_){switch(_){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Fe.from=Me;function Pe(_){switch(_){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Fe.to=Pe})(E||(e.DiagnosticTag=E={}));var u;(function(Fe){function Me(_){let Te;return _.code&&((0,p.$jf)(_.code)||(0,p.$nf)(_.code)?Te=String(_.code):Te={value:String(_.code.value),target:_.code.target}),{...i.from(_.range),message:_.message,source:_.source,code:Te,severity:w.from(_.severity),relatedInformation:_.relatedInformation&&_.relatedInformation.map(l.from),tags:Array.isArray(_.tags)?(0,D.$Fb)(_.tags.map(E.from)):void 0}}Fe.from=Me;function Pe(_){const Te=new r.$dK(i.to(_),_.message,w.to(_.severity));return Te.source=_.source,Te.code=(0,p.$jf)(_.code)?_.code:_.code?.value,Te.relatedInformation=_.relatedInformation&&_.relatedInformation.map(l.to),Te.tags=_.tags&&(0,D.$Fb)(_.tags.map(E.to)),Te}Fe.to=Pe})(u||(e.Diagnostic=u={}));var l;(function(Fe){function Me(_){return{...i.from(_.location.range),message:_.message,resource:_.location.uri}}Fe.from=Me;function Pe(_){return new r.$cK(new r.$bK(_.resource,i.to(_)),_.message)}Fe.to=Pe})(l||(e.DiagnosticRelatedInformation=l={}));var w;(function(Fe){function Me(_){switch(_){case r.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Fe.from=Me;function Pe(_){switch(_){case o.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Fe.to=Pe})(w||(e.DiagnosticSeverity=w={}));var A;(function(Fe){function Me(_){return typeof _=="number"&&_>=r.ViewColumn.One?_-1:_===r.ViewColumn.Beside?t.$$C:t.$0C}Fe.from=Me;function Pe(_){if(typeof _=="number"&&_>=0)return _+1;throw new Error("invalid 'EditorGroupColumn'")}Fe.to=Pe})(A||(e.ViewColumn=A={}));function N(Fe){return typeof Fe.range<"u"}function O(Fe){return Fe.length===0?!0:!!N(Fe[0])}e.$YL=O;var F;(function(Fe){function Me(Je){return Je.map(Fe.from)}Fe.fromMany=Me;function Pe(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function _(Je){let nt;if(Pe(Je)){const{language:lt,value:mt}=Je;nt={value:"```"+lt+`
`+mt+"\n```\n"}}else r.$qK.isMarkdownString(Je)?nt={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?nt={value:Je}:nt={value:""};const bt=Object.create(null);nt.uris=bt;const Pt=lt=>{try{let mt=S.URI.parse(lt,!0);mt=mt.with({query:Te(mt.query,bt)}),bt[lt]=mt}catch{}return""},wt=new k.marked.Renderer;return wt.link=Pt,wt.image=lt=>typeof lt=="string"?Pt(R.$5j(lt).href):"",(0,k.marked)(nt.value,{renderer:wt}),nt}Fe.from=_;function Te(Je,nt){if(!Je)return Je;let bt;try{bt=(0,b.$0g)(Je)}catch{}if(!bt)return Je;let Pt=!1;return bt=(0,I.$Xm)(bt,wt=>{if(S.URI.isUri(wt)){const lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return nt[lt]=wt,Pt=!0,lt}else return}),Pt?JSON.stringify(bt):Je}function He(Je){const nt=new r.$qK(Je.value,Je.supportThemeIcons);return nt.isTrusted=Je.isTrusted,nt.supportHtml=Je.supportHtml,nt.baseUri=Je.baseUri?S.URI.from(Je.baseUri):void 0,nt}Fe.to=He;function xe(Je){if(Je)return typeof Je=="string"?Je:Fe.from(Je)}Fe.fromStrict=xe})(F||(e.MarkdownString=F={}));function j(Fe){return O(Fe)?Fe.map(Me=>({range:i.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?F.fromMany(Me.hoverMessage):Me.hoverMessage?F.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Fe.map(Me=>({range:i.from(Me)}))}e.$ZL=j;function z(Fe){return typeof Fe>"u"?Fe:typeof Fe=="string"?S.URI.file(Fe):Fe}e.$1L=z;var T;(function(Fe){function Me(Pe){return typeof Pe>"u"?Pe:{contentText:Pe.contentText,contentIconPath:Pe.contentIconPath?z(Pe.contentIconPath):void 0,border:Pe.border,borderColor:Pe.borderColor,fontStyle:Pe.fontStyle,fontWeight:Pe.fontWeight,textDecoration:Pe.textDecoration,color:Pe.color,backgroundColor:Pe.backgroundColor,margin:Pe.margin,width:Pe.width,height:Pe.height}}Fe.from=Me})(T||(e.ThemableDecorationAttachmentRenderOptions=T={}));var H;(function(Fe){function Me(Pe){return typeof Pe>"u"?Pe:{backgroundColor:Pe.backgroundColor,outline:Pe.outline,outlineColor:Pe.outlineColor,outlineStyle:Pe.outlineStyle,outlineWidth:Pe.outlineWidth,border:Pe.border,borderColor:Pe.borderColor,borderRadius:Pe.borderRadius,borderSpacing:Pe.borderSpacing,borderStyle:Pe.borderStyle,borderWidth:Pe.borderWidth,fontStyle:Pe.fontStyle,fontWeight:Pe.fontWeight,textDecoration:Pe.textDecoration,cursor:Pe.cursor,color:Pe.color,opacity:Pe.opacity,letterSpacing:Pe.letterSpacing,gutterIconPath:Pe.gutterIconPath?z(Pe.gutterIconPath):void 0,gutterIconSize:Pe.gutterIconSize,overviewRulerColor:Pe.overviewRulerColor,before:Pe.before?T.from(Pe.before):void 0,after:Pe.after?T.from(Pe.after):void 0}}Fe.from=Me})(H||(e.ThemableDecorationRenderOptions=H={}));var q;(function(Fe){function Me(Pe){if(typeof Pe>"u")return Pe;switch(Pe){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Fe.from=Me})(q||(e.DecorationRangeBehavior=q={}));var me;(function(Fe){function Me(Pe){return{isWholeLine:Pe.isWholeLine,rangeBehavior:Pe.rangeBehavior?q.from(Pe.rangeBehavior):void 0,overviewRulerLane:Pe.overviewRulerLane,light:Pe.light?H.from(Pe.light):void 0,dark:Pe.dark?H.from(Pe.dark):void 0,backgroundColor:Pe.backgroundColor,outline:Pe.outline,outlineColor:Pe.outlineColor,outlineStyle:Pe.outlineStyle,outlineWidth:Pe.outlineWidth,border:Pe.border,borderColor:Pe.borderColor,borderRadius:Pe.borderRadius,borderSpacing:Pe.borderSpacing,borderStyle:Pe.borderStyle,borderWidth:Pe.borderWidth,fontStyle:Pe.fontStyle,fontWeight:Pe.fontWeight,textDecoration:Pe.textDecoration,cursor:Pe.cursor,color:Pe.color,opacity:Pe.opacity,letterSpacing:Pe.letterSpacing,gutterIconPath:Pe.gutterIconPath?z(Pe.gutterIconPath):void 0,gutterIconSize:Pe.gutterIconSize,overviewRulerColor:Pe.overviewRulerColor,before:Pe.before?T.from(Pe.before):void 0,after:Pe.after?T.from(Pe.after):void 0}}Fe.from=Me})(me||(e.DecorationRenderOptions=me={}));var X;(function(Fe){function Me(_){return{text:_.newText,eol:_.newEol&&et.from(_.newEol),range:i.from(_.range)}}Fe.from=Me;function Pe(_){const Te=new r.$9J(i.to(_.range),_.text);return Te.newEol=typeof _.eol>"u"?void 0:et.to(_.eol),Te}Fe.to=Pe})(X||(e.TextEdit=X={}));var Z;(function(Fe){function Me(_,Te){const He={edits:[]};if(_ instanceof r.$_J){const xe=new m.$Ai;for(const Je of _._allEntries())Je._type===1&&S.URI.isUri(Je.to)&&Je.from===void 0&&xe.add(Je.to);for(const Je of _._allEntries())if(Je._type===1){let nt;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?nt={type:"base64",value:(0,M.$Zd)(M.$Fd.wrap(Je.options.contents))}:nt={type:"dataTransferItem",id:Je.options.contents._itemId}),He.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:nt},metadata:Je.metadata})}else Je._type===2?He.edits.push({resource:Je.uri,textEdit:X.from(Je.edit),versionId:xe.has(Je.uri)?void 0:Te?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?He.edits.push({resource:Je.uri,textEdit:{range:i.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:xe.has(Je.uri)?void 0:Te?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?He.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&He.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(at.from)}})}return He}Fe.from=Me;function Pe(_){const Te=new r.$_J,He=new m.$zi;for(const xe of _.edits)if(xe.textEdit){const Je=xe,nt=S.URI.revive(Je.resource),bt=i.to(Je.textEdit.range),Pt=Je.textEdit.text,wt=Je.textEdit.insertAsSnippet;let lt;wt?lt=r.$$J.replace(bt,new r.$aK(Pt)):lt=r.$9J.replace(bt,Pt);const mt=He.get(nt);mt?mt.push(lt):He.set(nt,[lt])}else Te.renameFile(S.URI.revive(xe.oldResource),S.URI.revive(xe.newResource),xe.options);for(const[xe,Je]of He)Te.set(xe,Je);return Te}Fe.to=Pe})(Z||(e.WorkspaceEdit=Z={}));var V;(function(Fe){const Me=Object.create(null);Me[r.SymbolKind.File]=0,Me[r.SymbolKind.Module]=1,Me[r.SymbolKind.Namespace]=2,Me[r.SymbolKind.Package]=3,Me[r.SymbolKind.Class]=4,Me[r.SymbolKind.Method]=5,Me[r.SymbolKind.Property]=6,Me[r.SymbolKind.Field]=7,Me[r.SymbolKind.Constructor]=8,Me[r.SymbolKind.Enum]=9,Me[r.SymbolKind.Interface]=10,Me[r.SymbolKind.Function]=11,Me[r.SymbolKind.Variable]=12,Me[r.SymbolKind.Constant]=13,Me[r.SymbolKind.String]=14,Me[r.SymbolKind.Number]=15,Me[r.SymbolKind.Boolean]=16,Me[r.SymbolKind.Array]=17,Me[r.SymbolKind.Object]=18,Me[r.SymbolKind.Key]=19,Me[r.SymbolKind.Null]=20,Me[r.SymbolKind.EnumMember]=21,Me[r.SymbolKind.Struct]=22,Me[r.SymbolKind.Event]=23,Me[r.SymbolKind.Operator]=24,Me[r.SymbolKind.TypeParameter]=25;function Pe(Te){return typeof Me[Te]=="number"?Me[Te]:6}Fe.from=Pe;function _(Te){for(const He in Me)if(Me[He]===Te)return Number(He);return r.SymbolKind.Property}Fe.to=_})(V||(e.SymbolKind=V={}));var x;(function(Fe){function Me(_){switch(_){case r.SymbolTag.Deprecated:return 1}}Fe.from=Me;function Pe(_){switch(_){case 1:return r.SymbolTag.Deprecated}}Fe.to=Pe})(x||(e.SymbolTag=x={}));var ge;(function(Fe){function Me(_){return{name:_.name,kind:V.from(_.kind),tags:_.tags&&_.tags.map(x.from),containerName:_.containerName,location:K.from(_.location)}}Fe.from=Me;function Pe(_){const Te=new r.$gK(_.name,V.to(_.kind),_.containerName,K.to(_.location));return Te.tags=_.tags&&_.tags.map(x.to),Te}Fe.to=Pe})(ge||(e.WorkspaceSymbol=ge={}));var ue;(function(Fe){function Me(_){const Te={name:_.name||"!!MISSING: name!!",detail:_.detail,range:i.from(_.range),selectionRange:i.from(_.selectionRange),kind:V.from(_.kind),tags:_.tags?.map(x.from)??[]};return _.children&&(Te.children=_.children.map(Me)),Te}Fe.from=Me;function Pe(_){const Te=new r.$hK(_.name,_.detail,V.to(_.kind),i.to(_.range),i.to(_.selectionRange));return(0,D.$Jb)(_.tags)&&(Te.tags=_.tags.map(x.to)),_.children&&(Te.children=_.children.map(Pe)),Te}Fe.to=Pe})(ue||(e.DocumentSymbol=ue={}));var we;(function(Fe){function Me(_){const Te=new r.$mK(V.to(_.kind),_.name,_.detail||"",S.URI.revive(_.uri),i.to(_.range),i.to(_.selectionRange));return Te._sessionId=_._sessionId,Te._itemId=_._itemId,Te}Fe.to=Me;function Pe(_,Te,He){if(Te=Te??_._sessionId,He=He??_._itemId,Te===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:He,name:_.name,detail:_.detail,kind:V.from(_.kind),uri:_.uri,range:i.from(_.range),selectionRange:i.from(_.selectionRange),tags:_.tags?.map(x.from)}}Fe.from=Pe})(we||(e.CallHierarchyItem=we={}));var G;(function(Fe){function Me(Pe){return new r.$nK(we.to(Pe.from),Pe.fromRanges.map(_=>i.to(_)))}Fe.to=Me})(G||(e.CallHierarchyIncomingCall=G={}));var U;(function(Fe){function Me(Pe){return new r.$oK(we.to(Pe.to),Pe.fromRanges.map(_=>i.to(_)))}Fe.to=Me})(U||(e.CallHierarchyOutgoingCall=U={}));var K;(function(Fe){function Me(_){return{range:_.range&&i.from(_.range),uri:_.uri}}Fe.from=Me;function Pe(_){return new r.$bK(S.URI.revive(_.uri),i.to(_.range))}Fe.to=Pe})(K||(e.location=K={}));var fe;(function(Fe){function Me(_){const Te=_,He=_;return{originSelectionRange:Te.originSelectionRange?i.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:He.uri,range:i.from(Te.targetRange?Te.targetRange:He.range),targetSelectionRange:Te.targetSelectionRange?i.from(Te.targetSelectionRange):void 0}}Fe.from=Me;function Pe(_){return{targetUri:S.URI.revive(_.uri),targetRange:i.to(_.range),targetSelectionRange:_.targetSelectionRange?i.to(_.targetSelectionRange):void 0,originSelectionRange:_.originSelectionRange?i.to(_.originSelectionRange):void 0}}Fe.to=Pe})(fe||(e.DefinitionLink=fe={}));var te;(function(Fe){function Me(_){return{range:i.from(_.range),contents:F.fromMany(_.contents)}}Fe.from=Me;function Pe(_){return new r.$eK(_.contents.map(F.to),i.to(_.range))}Fe.to=Pe})(te||(e.Hover=te={}));var re;(function(Fe){function Me(_){return{range:i.from(_.range),expression:_.expression}}Fe.from=Me;function Pe(_){return new r.$$K(i.to(_.range),_.expression)}Fe.to=Pe})(re||(e.EvaluatableExpression=re={}));var ne;(function(Fe){function Me(_){if(_ instanceof r.$_K)return{type:"text",range:i.from(_.range),text:_.text};if(_ instanceof r.$aL)return{type:"variable",range:i.from(_.range),variableName:_.variableName,caseSensitiveLookup:_.caseSensitiveLookup};if(_ instanceof r.$bL)return{type:"expression",range:i.from(_.range),expression:_.expression};throw new Error("Unknown 'InlineValue' type")}Fe.from=Me;function Pe(_){switch(_.type){case"text":return{range:i.to(_.range),text:_.text};case"variable":return{range:i.to(_.range),variableName:_.variableName,caseSensitiveLookup:_.caseSensitiveLookup};case"expression":return{range:i.to(_.range),expression:_.expression}}}Fe.to=Pe})(ne||(e.InlineValue=ne={}));var Ee;(function(Fe){function Me(_){return{frameId:_.frameId,stoppedLocation:i.from(_.stoppedLocation)}}Fe.from=Me;function Pe(_){return new r.$cL(_.frameId,i.to(_.stoppedLocation))}Fe.to=Pe})(Ee||(e.InlineValueContext=Ee={}));var oe;(function(Fe){function Me(_){return{range:i.from(_.range),kind:_.kind}}Fe.from=Me;function Pe(_){return new r.$fK(i.to(_.range),_.kind)}Fe.to=Pe})(oe||(e.DocumentHighlight=oe={}));var he;(function(Fe){function Me(Pe){switch(Pe){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Fe.to=Me})(he||(e.CompletionTriggerKind=he={}));var ee;(function(Fe){function Me(Pe){return{triggerKind:he.to(Pe.triggerKind),triggerCharacter:Pe.triggerCharacter}}Fe.to=Me})(ee||(e.CompletionContext=ee={}));var le;(function(Fe){function Me(_){switch(_){case r.CompletionItemTag.Deprecated:return 1}}Fe.from=Me;function Pe(_){switch(_){case 1:return r.CompletionItemTag.Deprecated}}Fe.to=Pe})(le||(e.CompletionItemTag=le={}));var be;(function(Fe){const Me=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function Pe(He){return Me.get(He)??9}Fe.from=Pe;const _=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Te(He){return _.get(He)??r.CompletionItemKind.Property}Fe.to=Te})(be||(e.CompletionItemKind=be={}));var Ie;(function(Fe){function Me(Pe,_){const Te=new r.$wK(Pe.label);return Te.insertText=Pe.insertText,Te.kind=be.to(Pe.kind),Te.tags=Pe.tags?.map(le.to),Te.detail=Pe.detail,Te.documentation=R.$Zj(Pe.documentation)?F.to(Pe.documentation):Pe.documentation,Te.sortText=Pe.sortText,Te.filterText=Pe.filterText,Te.preselect=Pe.preselect,Te.commitCharacters=Pe.commitCharacters,C.$ks.isIRange(Pe.range)?Te.range=i.to(Pe.range):typeof Pe.range=="object"&&(Te.range={inserting:i.to(Pe.range.insert),replacing:i.to(Pe.range.replace)}),Te.keepWhitespace=typeof Pe.insertTextRules>"u"?!1:!!(Pe.insertTextRules&1),typeof Pe.insertTextRules<"u"&&Pe.insertTextRules&4?Te.insertText=new r.$aK(Pe.insertText):(Te.insertText=Pe.insertText,Te.textEdit=Te.range instanceof r.$4J?new r.$9J(Te.range,Te.insertText):void 0),Pe.additionalTextEdits&&Pe.additionalTextEdits.length>0&&(Te.additionalTextEdits=Pe.additionalTextEdits.map(He=>X.to(He))),Te.command=_&&Pe.command?_.fromInternal(Pe.command):void 0,Te}Fe.to=Me})(Ie||(e.CompletionItem=Ie={}));var B;(function(Fe){function Me(_){if(typeof _.label!="string"&&!Array.isArray(_.label))throw new TypeError("Invalid label");return{label:_.label,documentation:F.fromStrict(_.documentation)}}Fe.from=Me;function Pe(_){return{label:_.label,documentation:R.$Zj(_.documentation)?F.to(_.documentation):_.documentation}}Fe.to=Pe})(B||(e.ParameterInformation=B={}));var Q;(function(Fe){function Me(_){return{label:_.label,documentation:F.fromStrict(_.documentation),parameters:Array.isArray(_.parameters)?_.parameters.map(B.from):[],activeParameter:_.activeParameter}}Fe.from=Me;function Pe(_){return{label:_.label,documentation:R.$Zj(_.documentation)?F.to(_.documentation):_.documentation,parameters:Array.isArray(_.parameters)?_.parameters.map(B.to):[],activeParameter:_.activeParameter}}Fe.to=Pe})(Q||(e.SignatureInformation=Q={}));var ie;(function(Fe){function Me(_){return{activeSignature:_.activeSignature,activeParameter:_.activeParameter,signatures:Array.isArray(_.signatures)?_.signatures.map(Q.from):[]}}Fe.from=Me;function Pe(_){return{activeSignature:_.activeSignature,activeParameter:_.activeParameter,signatures:Array.isArray(_.signatures)?_.signatures.map(Q.to):[]}}Fe.to=Pe})(ie||(e.SignatureHelp=ie={}));var se;(function(Fe){function Me(Pe,_){const Te=new r.$vK(f.to(_.position),typeof _.label=="string"?_.label:_.label.map(Y.to.bind(void 0,Pe)),_.kind&&de.to(_.kind));return Te.textEdits=_.textEdits&&_.textEdits.map(X.to),Te.tooltip=R.$Zj(_.tooltip)?F.to(_.tooltip):_.tooltip,Te.paddingLeft=_.paddingLeft,Te.paddingRight=_.paddingRight,Te}Fe.to=Me})(se||(e.InlayHint=se={}));var Y;(function(Fe){function Me(Pe,_){const Te=new r.$uK(_.label);return Te.tooltip=R.$Zj(_.tooltip)?F.to(_.tooltip):_.tooltip,v.Command.is(_.command)&&(Te.command=Pe.fromInternal(_.command)),_.location&&(Te.location=K.to(_.location)),Te}Fe.to=Me})(Y||(e.InlayHintLabelPart=Y={}));var de;(function(Fe){function Me(_){return _}Fe.from=Me;function Pe(_){return _}Fe.to=Pe})(de||(e.InlayHintKind=de={}));var ye;(function(Fe){function Me(_){return{range:i.from(_.range),url:_.target,tooltip:_.tooltip}}Fe.from=Me;function Pe(_){let Te;if(_.url)try{Te=typeof _.url=="string"?S.URI.parse(_.url,!0):S.URI.revive(_.url)}catch{}return new r.$BK(i.to(_.range),Te)}Fe.to=Pe})(ye||(e.DocumentLink=ye={}));var je;(function(Fe){function Me(_){const Te=new r.$EK(_.label);return _.textEdit&&(Te.textEdit=X.to(_.textEdit)),_.additionalTextEdits&&(Te.additionalTextEdits=_.additionalTextEdits.map(He=>X.to(He))),Te}Fe.to=Me;function Pe(_){return{label:_.label,textEdit:_.textEdit?X.from(_.textEdit):void 0,additionalTextEdits:_.additionalTextEdits?_.additionalTextEdits.map(Te=>X.from(Te)):void 0}}Fe.from=Pe})(je||(e.ColorPresentation=je={}));var We;(function(Fe){function Me(_){return new r.$CK(_[0],_[1],_[2],_[3])}Fe.to=Me;function Pe(_){return[_.red,_.green,_.blue,_.alpha]}Fe.from=Pe})(We||(e.Color=We={}));var _e;(function(Fe){function Me(_){return{range:i.from(_.range)}}Fe.from=Me;function Pe(_){return new r.$lK(i.to(_.range))}Fe.to=Pe})(_e||(e.SelectionRange=_e={}));var Ye;(function(Fe){function Me(Pe){switch(Pe){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Fe.to=Me})(Ye||(e.TextDocumentSaveReason=Ye={}));var it;(function(Fe){function Me(_){switch(_){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Fe.from=Me;function Pe(_){switch(_){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Fe.to=Pe})(it||(e.TextEditorLineNumbersStyle=it={}));var et;(function(Fe){function Me(_){if(_===r.EndOfLine.CRLF)return 1;if(_===r.EndOfLine.LF)return 0}Fe.from=Me;function Pe(_){if(_===1)return r.EndOfLine.CRLF;if(_===0)return r.EndOfLine.LF}Fe.to=Pe})(et||(e.EndOfLine=et={}));var Ae;(function(Fe){function Me(Pe){if(typeof Pe=="object")return Pe.viewId;switch(Pe){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Fe.from=Me})(Ae||(e.ProgressLocation=Ae={}));var Oe;(function(Fe){function Me(_){const Te={start:_.start+1,end:_.end+1};return _.kind&&(Te.kind=Ve.from(_.kind)),Te}Fe.from=Me;function Pe(_){const Te={start:_.start-1,end:_.end-1};return _.kind&&(Te.kind=Ve.to(_.kind)),Te}Fe.to=Pe})(Oe||(e.FoldingRange=Oe={}));var Ve;(function(Fe){function Me(_){if(_)switch(_){case r.FoldingRangeKind.Comment:return v.$_s.Comment;case r.FoldingRangeKind.Imports:return v.$_s.Imports;case r.FoldingRangeKind.Region:return v.$_s.Region}}Fe.from=Me;function Pe(_){if(_)switch(_.value){case v.$_s.Comment.value:return r.FoldingRangeKind.Comment;case v.$_s.Imports.value:return r.FoldingRangeKind.Imports;case v.$_s.Region.value:return r.FoldingRangeKind.Region}}Fe.to=Pe})(Ve||(e.FoldingRangeKind=Ve={}));var Le;(function(Fe){function Me(Pe){if(Pe)return{pinned:typeof Pe.preview=="boolean"?!Pe.preview:void 0,inactive:Pe.background,preserveFocus:Pe.preserveFocus,selection:typeof Pe.selection=="object"?i.from(Pe.selection):void 0,override:typeof Pe.override=="boolean"?n.$HE.id:void 0}}Fe.from=Me})(Le||(e.TextEditorOpenOptions=Le={}));var Ze;(function(Fe){function Me(He){return He instanceof r.$YK?He.toJSON():typeof He=="string"?He:Pe(He)||_(He)?new r.$YK(He.baseUri??He.base,He.pattern).toJSON():He}Fe.from=Me;function Pe(He){const xe=He;return xe?S.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function _(He){const xe=He;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Te(He){return typeof He=="string"?He:new r.$YK(S.URI.revive(He.baseUri),He.pattern)}Fe.to=Te})(Ze||(e.GlobPattern=Ze={}));var ce;(function(Fe){function Me(Pe){if(Pe){if(Array.isArray(Pe))return Pe.map(Me);if(typeof Pe=="string")return Pe;{const _=Pe;return{language:_.language,scheme:_.scheme,pattern:Ze.from(_.pattern),exclusive:_.exclusive,notebookType:_.notebookType}}}else return}Fe.from=Me})(ce||(e.LanguageSelector=ce={}));var ae;(function(Fe){function Me(_){return!!_&&typeof _=="object"&&"selections"in _&&Array.isArray(_.selections)&&_.selections.every(Te=>Te instanceof r.$5J)&&"related"in _&&Array.isArray(_.related)&&_.related.every(Te=>Te&&typeof Te=="object"&&S.URI.isUri(Te.uri)&&Te.range instanceof r.$4J)}Fe.is=Me;function Pe(_){return{selections:_.selections.map(Te=>a.from(Te)),related:_.related.map(Te=>({uri:S.URI.from(Te.uri),range:i.from(Te.range)}))}}Fe.from=Pe})(ae||(e.MappedEditsContext=ae={}));var Ce;(function(Fe){function Me(_){return{start:_.start,end:_.end}}Fe.from=Me;function Pe(_){return new r.$nL(_.start,_.end)}Fe.to=Pe})(Ce||(e.NotebookRange=Ce={}));var qe;(function(Fe){function Me(_){return{timing:typeof _.runStartTime=="number"&&typeof _.runEndTime=="number"?{startTime:_.runStartTime,endTime:_.runEndTime}:void 0,executionOrder:_.executionOrder,success:_.lastRunSuccess}}Fe.to=Me;function Pe(_){return{lastRunSuccess:_.success,runStartTime:_.timing?.startTime,runEndTime:_.timing?.endTime,executionOrder:_.executionOrder}}Fe.from=Pe})(qe||(e.NotebookCellExecutionSummary=qe={}));var Ue;(function(Fe){function Me(Pe){if(Pe===h.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(Pe===h.NotebookCellExecutionState.Pending)return;if(Pe===h.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Pe}`)}Fe.to=Me})(Ue||(e.NotebookCellExecutionState=Ue={}));var Xe;(function(Fe){function Me(_){switch(_){case r.NotebookCellKind.Markup:return h.CellKind.Markup;case r.NotebookCellKind.Code:default:return h.CellKind.Code}}Fe.from=Me;function Pe(_){switch(_){case h.CellKind.Markup:return r.NotebookCellKind.Markup;case h.CellKind.Code:default:return r.NotebookCellKind.Code}}Fe.to=Pe})(Xe||(e.NotebookCellKind=Xe={}));var rt;(function(Fe){function Me(_){const Te={metadata:_.metadata??Object.create(null),cells:[]};for(const He of _.cells)r.$oL.validate(He),Te.cells.push(at.from(He));return Te}Fe.from=Me;function Pe(_){const Te=new r.$pL(_.cells.map(at.to));return(0,p.$wf)(_.metadata)||(Te.metadata=_.metadata),Te}Fe.to=Pe})(rt||(e.NotebookData=rt={}));var at;(function(Fe){function Me(_){return{cellKind:Xe.from(_.kind),language:_.languageId,mime:_.mime,source:_.value,metadata:_.metadata,internalMetadata:qe.from(_.executionSummary??{}),outputs:_.outputs?_.outputs.map(St.from):[]}}Fe.from=Me;function Pe(_){return new r.$oL(Xe.to(_.cellKind),_.source,_.language,_.mime,_.outputs?_.outputs.map(St.to):void 0,_.metadata,_.internalMetadata?qe.to(_.internalMetadata):void 0)}Fe.to=Pe})(at||(e.NotebookCellData=at={}));var $t;(function(Fe){function Me(_){return{mime:_.mime,valueBytes:M.$Fd.wrap(_.data)}}Fe.from=Me;function Pe(_){return new r.$qL(_.valueBytes.buffer,_.mime)}Fe.to=Pe})($t||(e.NotebookCellOutputItem=$t={}));var St;(function(Fe){function Me(_){return{outputId:_.id,items:_.items.map($t.from),metadata:_.metadata}}Fe.from=Me;function Pe(_){const Te=_.items.map($t.to);return new r.$rL(Te,_.outputId,_.metadata)}Fe.to=Pe})(St||(e.NotebookCellOutput=St={}));var Zt;(function(Fe){function Me(Te){return _(Te)?{include:Ze.from(Te.include)??void 0,exclude:Ze.from(Te.exclude)??void 0}:Ze.from(Te)??void 0}Fe.from=Me;function Pe(Te){return _(Te)?{include:Ze.to(Te.include),exclude:Ze.to(Te.exclude)}:Ze.to(Te)}Fe.to=Pe;function _(Te){const He=Te;return He?!(0,p.$sf)(He.include)&&!(0,p.$sf)(He.exclude):!1}})(Zt||(e.NotebookExclusiveDocumentPattern=Zt={}));var qt;(function(Fe){function Me(Pe,_,Te){const He=typeof Pe.command=="string"?{title:"",command:Pe.command}:Pe.command;return{alignment:Pe.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:_.toInternal(He,Te),text:Pe.text,tooltip:Pe.tooltip,accessibilityInformation:Pe.accessibilityInformation,priority:Pe.priority}}Fe.from=Me})(qt||(e.NotebookStatusBarItem=qt={}));var vt;(function(Fe){function Me(Pe,_,Te){const He=typeof Pe.command=="string"?{title:"",command:Pe.command}:Pe.command;return{command:_.toInternal(He,Te),label:Pe.label,description:Pe.description,detail:Pe.detail,documentation:Pe.documentation}}Fe.from=Me})(vt||(e.NotebookKernelSourceAction=vt={}));var Nt;(function(Fe){function Me(Pe){return{transientOutputs:Pe?.transientOutputs??!1,transientCellMetadata:Pe?.transientCellMetadata??{},transientDocumentMetadata:Pe?.transientDocumentMetadata??{},cellContentMetadata:Pe?.cellContentMetadata??{}}}Fe.from=Me})(Nt||(e.NotebookDocumentContentOptions=Nt={}));var jt;(function(Fe){function Me(_){return{uri:_.uri,provides:_.provides}}Fe.from=Me;function Pe(_){return new r.$tL(S.URI.revive(_.uri),_.provides)}Fe.to=Pe})(jt||(e.NotebookRendererScript=jt={}));var Jt;(function(Fe){function Me(_){return{message:F.fromStrict(_.message)||"",type:0,expected:_.expectedOutput,actual:_.actualOutput,contextValue:_.contextValue,location:_.location&&{range:i.from(_.location.range),uri:_.location.uri}}}Fe.from=Me;function Pe(_){const Te=new r.$zL(typeof _.message=="string"?_.message:F.to(_.message));return Te.actualOutput=_.actual,Te.expectedOutput=_.expected,Te.contextValue=_.contextValue,Te.location=_.location?K.to(_.location):void 0,Te}Fe.to=Pe})(Jt||(e.TestMessage=Jt={}));var At;(function(Fe){Fe.namespace=d.$SI,Fe.denamespace=d.$TI})(At||(e.TestTag=At={}));var Rt;(function(Fe){function Me(_){const Te=(0,s.$XL)(_).controllerId;return{extId:$.$OI.fromExtHostTestItem(_,Te).toString(),label:_.label,uri:S.URI.revive(_.uri),busy:_.busy,tags:_.tags.map(He=>At.namespace(Te,He.id)),range:C.$ks.lift(i.from(_.range)),description:_.description||null,sortText:_.sortText||null,error:_.error&&F.fromStrict(_.error)||null}}Fe.from=Me;function Pe(_){return{parent:void 0,error:void 0,id:$.$OI.fromString(_.extId).localId,label:_.label,uri:S.URI.revive(_.uri),tags:(_.tags||[]).map(Te=>{const{tagId:He}=At.denamespace(Te);return new r.$AL(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(_.range||void 0),canResolveChildren:!1,busy:_.busy,description:_.description||void 0,sortText:_.sortText||void 0}}Fe.toPlain=Pe})(Rt||(e.TestItem=Rt={})),function(Fe){function Me(_){return{id:_.id}}Fe.from=Me;function Pe(_){return new r.$AL(_.id)}Fe.to=Pe}(At||(e.TestTag=At={}));var zt;(function(Fe){const Me=(_,Te)=>{const He=[];for(const[Je,nt]of Te)$.$OI.compare(nt.item.extId,Je)===2&&(Te.delete(Je),He.push(nt));const xe={...Rt.toPlain(_.item),parent:void 0,taskStates:_.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(nt=>nt.type===0).map(Jt.to)})),children:He.map(Je=>Me(Je,Te))};for(const Je of xe.children)Je.parent=xe;return xe};function Pe(_){const Te=[],He=new Map;for(const xe of _.items){He.set(xe.item.extId,xe);const Je=$.$OI.root(xe.item.extId);_.request.targets.some(nt=>nt.controllerId===Je&&nt.testIds.includes(xe.item.extId))&&Te.push(xe)}return{completedAt:_.completedAt,results:Te.map(xe=>Me(xe,He))}}Fe.to=Pe})(zt||(e.TestResults=zt={}));var Bt;(function(Fe){function Me(He){return{covered:He.covered,total:He.covered}}function Pe(He){return"line"in He?f.from(He):i.from(He)}function _(He){return"branches"in He?{count:He.executionCount,location:Pe(He.location),type:1,branches:He.branches.length?He.branches.map(xe=>({count:xe.executionCount,location:xe.location&&Pe(xe.location)})):void 0}:{type:0,count:He.executionCount,location:Pe(He.location)}}Fe.fromDetailed=_;function Te(He){return{uri:He.uri,statement:Me(He.statementCoverage),branch:He.branchCoverage&&Me(He.branchCoverage),function:He.functionCoverage&&Me(He.functionCoverage),details:He.detailedCoverage?.map(_)}}Fe.fromFile=Te})(Bt||(e.TestCoverage=Bt={}));var Ht;(function(Fe){function Me(Pe){switch(Pe){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Fe.to=Me})(Ht||(e.CodeActionTriggerKind=Ht={}));var Wt;(function(Fe){function Me(_){const Te=new r.$GL(V.to(_.kind),_.name,_.detail||"",S.URI.revive(_.uri),i.to(_.range),i.to(_.selectionRange));return Te._sessionId=_._sessionId,Te._itemId=_._itemId,Te}Fe.to=Me;function Pe(_,Te,He){if(Te=Te??_._sessionId,He=He??_._itemId,Te===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:He,kind:V.from(_.kind),name:_.name,detail:_.detail??"",uri:_.uri,range:i.from(_.range),selectionRange:i.from(_.selectionRange),tags:_.tags?.map(x.from)}}Fe.from=Pe})(Wt||(e.TypeHierarchyItem=Wt={}));var Vt;(function(Fe){function Me(Pe){if(Pe)return{value:Pe.value,tooltip:Pe.tooltip}}Fe.from=Me})(Vt||(e.ViewBadge=Vt={}));var ot;(function(Fe){function Me(He,xe,Je){const nt=xe.fileData;return nt?new r.$RK(new r.$SK(nt.name,S.URI.revive(nt.uri),nt.id,(0,L.$bb)(()=>Je(nt.id)))):He===P.$Hr.uriList&&xe.uriListData?new r.$QK(Te(xe.uriListData)):new r.$QK(xe.asString)}Fe.to=Me;async function Pe(He,xe){const Je=await xe.asString();if(He===P.$Hr.uriList)return{asString:Je,fileData:void 0,uriListData:_(Je)};const nt=xe.asFile();return{asString:Je,fileData:nt?{name:nt.name,uri:nt.uri,id:nt._itemId??nt.id}:void 0}}Fe.from=Pe;function _(He){return g.$Ts.split(He).map(xe=>{if(xe.startsWith("#"))return xe;try{return S.URI.parse(xe)}catch{}return xe})}function Te(He){return g.$Ts.create(He.map(xe=>typeof xe=="string"?xe:S.URI.revive(xe)))}})(ot||(e.DataTransferItem=ot={}));var ft;(function(Fe){function Me(_,Te){const He=_.items.map(([xe,Je])=>[xe,ot.to(xe,Je,Te)]);return new r.$TK(He)}Fe.toDataTransfer=Me;async function Pe(_){const Te={items:[]},He=[];for(const[xe,Je]of _)He.push((async()=>{Te.items.push([xe,await ot.from(xe,Je)])})());return await Promise.all(He),Te}Fe.from=Pe})(ft||(e.DataTransfer=ft={}));var Lt;(function(Fe){function Me(_){return{message:_.message,metadata:_.metadata,title:_.title,tooltip:_.tooltip}}Fe.to=Me;function Pe(_){return{kind:"reply",message:_.message,metadata:_.metadata,title:_.title,tooltip:_.tooltip}}Fe.from=Pe})(Lt||(e.ChatReplyFollowup=Lt={}));var Ft;(function(Fe){function Me(Pe){return typeof Pe=="string"?{title:Pe,message:Pe,kind:"reply"}:"commandId"in Pe?{kind:"command",title:Pe.title??"",commandId:Pe.commandId??"",when:Pe.when??"",args:Pe.args}:Lt.from(Pe)}Fe.from=Me})(Ft||(e.ChatFollowup=Ft={}));var It;(function(Fe){function Me(_){const Te=new r.$QL(dt.to(_.role),_.content);return Te.name=_.name,Te}Fe.to=Me;function Pe(_){return{role:dt.from(_.role),content:_.content,name:_.name}}Fe.from=Pe})(It||(e.ChatMessage=It={}));var dt;(function(Fe){function Me(_){switch(_){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Fe.to=Me;function Pe(_){switch(_){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Fe.from=Pe})(dt||(e.ChatMessageRole=dt={}));var kt;(function(Fe){function Me(_){return{level:Dt.to(_.level),value:_.value,description:_.description}}Fe.to=Me;function Pe(_){return{level:Dt.from(_.level),value:_.value,description:_.description}}Fe.from=Pe})(kt||(e.ChatVariable=kt={}));var Dt;(function(Fe){function Me(_){switch(_){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Fe.to=Me;function Pe(_){switch(_){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Fe.from=Pe})(Dt||(e.ChatVariableLevel=Dt={}));var Mt;(function(Fe){function Me(Pe){switch(Pe){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted}}Fe.to=Me})(Mt||(e.InteractiveEditorResponseFeedbackKind=Mt={}));var Ge;(function(Fe){function Me(Pe,_,Te){return"terminalCommand"in Pe?{terminalCommand:Pe.terminalCommand}:"uri"in Pe?{uri:Pe.uri}:_.toInternal(Pe,Te)}Fe.from=Me})(Ge||(e.TerminalQuickFix=Ge={}))}),define(Se[280],De([1,0,2,8,7,13,76]),function($e,e,D,M,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jbc=void 0;class m{constructor(b,P,I,p={timeout:1500,errors:3}){this.c=b,this.d=P,this.f=I,this.g=p,this.a=new R.$tc,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(b){return(P,I,p)=>{const C={dispose:this.a.push([P,I,b])};return Array.isArray(p)&&p.push(C),C}}async $participateInSave(b,P){const I=D.URI.revive(b);let p=!1;const S=setTimeout(()=>p=!0,this.g.timeout),C=[];try{for(const v of[...this.a]){if(p)break;const o=this.d.getDocument(I),s=await this.h(v,{document:o,reason:L.TextDocumentSaveReason.to(P)});C.push(s)}}finally{clearTimeout(S)}return C}h([b,P,I],p){const S=this.b.get(b);return typeof S=="number"&&S>this.g.errors?Promise.resolve(!1):this.i(I,b,P,p).then(()=>!0,C=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(C),!(C instanceof Error)||C.message!=="concurrent_edits"){const v=this.b.get(b);this.b.set(b,v?v+1:1),typeof v=="number"&&v>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(b,P,I,p){const S=[],C=Date.now(),{document:v,reason:o}=p,{version:s}=v,n=Object.freeze({document:v,reason:o,waitUntil(h){if(Object.isFrozen(S))throw(0,M.$6)("waitUntil can not be called async");S.push(Promise.resolve(h))}});try{P.apply(I,[n])}catch(h){return Promise.reject(h)}return Object.freeze(S),new Promise((h,$)=>{const d=setTimeout(()=>$(new Error("timeout")),this.g.timeout);return Promise.all(S).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' finished after ${Date.now()-C}ms`),clearTimeout(d),h(t)}).catch(t=>{clearTimeout(d),$(t)})}).then(h=>{const $={edits:[]};for(const d of h)if(Array.isArray(d)&&d.every(t=>t instanceof g.$9J))for(const{newText:t,newEol:r,range:a}of d)$.edits.push({resource:v.uri,versionId:void 0,textEdit:{range:a&&L.Range.from(a),text:t,eol:r&&L.EndOfLine.from(r)}});if($.edits.length!==0)return s===v.version?this.f.$tryApplyWorkspaceEdit($):Promise.reject(new Error("concurrent_edits"))})}}e.$jbc=m}),define(Se[281],De([1,0,17,2,13,7,108]),function($e,e,D,M,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=e.$wcc=void 0;class m{constructor(I,p,S,C){this.start=I,this.deletedCount=p,this.deletedItems=S,this.items=C}asApiEvent(){return{range:new L.$nL(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class k{static asModelAddData(I,p){return{EOL:p.eol,lines:p.source,languageId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,p,S){this.notebook=I,this.h=p,this.j=S,this.handle=S.handle,this.uri=M.URI.revive(S.uri),this.cellKind=S.cellKind,this.a=S.outputs.map(g.NotebookCellOutput.to),this.e=S.internalMetadata??{},this.b=Object.freeze(S.metadata??{}),this.d=Object.freeze(g.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,p=this.h.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:g.NotebookCellKind.to(this.j.cellKind),document:p.document,get mime(){return I.g},set mime(C){I.g=C},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(S)}return this.f}setOutputs(I){this.a=I.map(g.NotebookCellOutput.to)}setOutputItems(I,p,S){const C=S.map(g.NotebookCellOutputItem.to),v=this.a.find(o=>o.id===I);if(v&&(p||(v.items.length=0),v.items.push(...C),v.items.length>1&&v.items.every(o=>R.$9H(o.mime)))){const o=new Map,s=[];v.items.forEach(n=>{let h;o.has(n.mime)?h=o.get(n.mime):(h=[],o.set(n.mime,h),s.push(n.mime)),h.push(n.data)}),v.items.length=0,s.forEach(n=>{const h=R.$0H(o.get(n));v.items.push({mime:n,data:h.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(g.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$wcc=k;class b{static{this.a=0}constructor(I,p,S,C,v){this.k=I,this.l=p,this.m=S,this.uri=C,this.handle=b.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=v.viewType,this.f=Object.freeze(v.metadata??Object.create(null)),this.r([[0,0,v.cells]],!0,void 0),this.g=v.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,p={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===D.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(S){return S=I.n(S),I.b[S].apiCell},getCells(S){return(S?I.p(S):I.b).map(v=>v.apiCell)},save(){return I.q()}};this.e=Object.freeze(p)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,p,S){this.g=I.versionId,this.h=p,this.acceptDocumentPropertiesChanged({metadata:S});const C={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},v=[];for(const s of I.rawEvents)s.kind===R.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,C.contentChanges):s.kind===R.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,C.contentChanges):s.kind===R.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),v.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),v.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),v.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===R.NotebookCellsChangeType.ChangeCellContent?v.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),v.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),v.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const o=new Map;for(let s=0;s<v.length;s++){const n=v[s],h=o.get(n.cell);if(h===void 0){const $=C.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});o.set(n.cell,$-1)}else C.cellChanges[h]={...C.cellChanges[h],...n}}return Object.freeze(C),Object.freeze(C.cellChanges),Object.freeze(C.contentChanges),C}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let p=I.start|0,S=I.end|0;return p<0&&(p=0),S>this.b.length&&(S=this.b.length),I.with({start:p,end:S})}p(I){I=this.o(I);const p=[];for(let S=I.start;S<I.end;S++)p.push(this.b[S]);return p}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,p,S){if(this.j)return;const C=[],v=[],o=[];if(I.reverse().forEach(s=>{const h=s[2].map(t=>{const r=new k(this,this.l,t);return p||v.push(k.asModelAddData(this.apiNotebook,t)),r}),$=new m(s[0],s[1],[],h),d=this.b.splice(s[0],s[1],...h);for(const t of d)o.push(t.uri),$.deletedItems.push(t.apiCell);C.push($)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:o}),S)for(const s of C)S.push(s.asApiEvent())}s(I,p,S,C){const v=this.b.splice(I,p);this.b.splice(S,0,...v);const o=[new m(I,p,v.map(s=>s.apiCell),[]),new m(S,0,[],v)];for(const s of o)C.push(s.asApiEvent())}t(I,p){this.b[I].setOutputs(p)}u(I,p,S,C){this.b[I].setOutputItems(p,S,C)}v(I,p){const S=this.b[I];S.apiCell.document.languageId!==p&&this.m.$acceptModelLanguageChanged(S.uri,p)}w(I,p){const S=this.b[I];S.apiCell.mime=p}x(I,p){this.b[I].setMetadata(p)}y(I,p){this.b[I].setInternalMetadata(p)}getCellFromApiCell(I){return this.b.find(p=>p.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(p=>p.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$xcc=b}),define(Se[282],De([1,0,4,2,13,7]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=void 0;class R{constructor(k,b,P,I={timeout:1500,errors:3}){this.b=k,this.c=b,this.d=P,this.f=I,this.a=new D.$hd}dispose(){}getOnWillSaveNotebookDocumentEvent(k){return(b,P,I)=>{const p=function(C){b.call(P,C)};return p.extension=k,this.a.event(p,void 0,I)}}async $participateInSave(k,b,P){const I=M.URI.revive(k),p=this.c.getNotebookDocument(I);if(!p)throw new Error("Unable to resolve notebook document");const S=[];if(await this.a.fireAsync({notebook:p.apiNotebook,reason:g.TextDocumentSaveReason.to(b)},P,async(v,o)=>{const s=Date.now(),n=await await Promise.resolve(v);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!P.isCancellationRequested&&n&&(n instanceof L.$_J?S.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(S.length===0)return!0;const C={edits:[]};for(const v of S){const{edits:o}=g.WorkspaceEdit.from(v);C.edits=C.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(C)}}e.$Xcc=R}),define(Se[144],De([1,0,8,13,7]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,k,b,P,I,p){this.id=m,this.f=k,this.notebookData=b,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=P,this.c=p}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(k){this.selections=[k]},get selections(){return m.a},set selections(k){if(!Array.isArray(k)||!k.every(g.$nL.isNotebookRange))throw(0,D.$5)("selections");m.a=k,m.g(k)},get visibleRanges(){return m.b},revealRange(k,b){m.f.$tryRevealRange(m.id,M.NotebookRange.from(k),b??g.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(M.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$ycc=L}),define(Se[283],De([1,0,8,4,14,13]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=void 0;let R=class{constructor(k,b){this.c=k,this.d=b,this.a=new M.$fd({onListenerError:D.$Z}),this.b=new M.$fd({onListenerError:D.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(k,b){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",k,b);const P=this.d.getEditorById(k);b.visibleRanges&&P._acceptVisibleRanges(b.visibleRanges.ranges.map(L.NotebookRange.to)),b.selections&&P._acceptSelections(b.selections.selections.map(L.NotebookRange.to)),b.visibleRanges&&this.b.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),b.selections&&this.a.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(k){for(const b in k)this.d.getEditorById(b)._acceptViewColumn(L.ViewColumn.to(k[b]))}};e.$Qcc=R,e.$Qcc=R=Ke([Be(0,g.$5i)],R)}),define(Se[284],De([1,0,13,65,208,21,57,8]),function($e,e,D,M,g,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=void 0;class k{constructor(p){this.b=0,this.c=new Map,this.a=p}async withProgress(p,S,C){const v=this.b++,{title:o,location:s,cancellable:n}=S,h={label:(0,g.localize)(0,null,p.displayName||p.name),id:p.identifier.value};return this.a.$startProgress(v,{location:D.ProgressLocation.from(s),title:o,source:h,cancellable:n},p.isUnderDevelopment?void 0:p.identifier.value).catch(m.$Z),this.d(v,C,!!n)}d(p,S,C){let v;C&&(v=new L.$pd,this.c.set(p,v));const o=n=>{this.a.$progressEnd(n),this.c.delete(n),v?.dispose()};let s;try{s=S(new P(this.a,p),C&&v?v.token:L.CancellationToken.None)}catch(n){throw o(p),n}return s.then(n=>o(p),n=>o(p)),s}$acceptProgressCanceled(p){const S=this.c.get(p);S&&(S.cancel(),this.c.delete(p))}}e.$Ubc=k;function b(I,p){return I.message=p.message,typeof p.increment=="number"&&(typeof I.increment=="number"?I.increment+=p.increment:I.increment=p.increment),I}class P extends M.$4u{constructor(p,S){super(C=>this.throttledReport(C)),this.f=p,this.g=S}throttledReport(p){this.f.$progressReport(this.g,p)}}Ke([(0,R.$8g)(100,(I,p)=>b(I,p),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(Se[145],De([1,0,34,142,69,109,88,13,2]),function($e,e,D,M,g,L,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eM=e.$dM=e.$cM=e.$bM=void 0;const b=(h,$,d,t)=>{let r=$;return{enumerable:!0,configurable:!1,get(){return r},set(a){if(!d(r,a)){const i=r;r=a,h.listener?.(t(a,i))}}}},P=(h,$)=>h===$,I={range:(h,$)=>h===$?!0:!h||!$?!1:h.isEqual($),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(h,$)=>!(h.length!==$.length||h.some(d=>!$.find(t=>d.id===t.id)))},p=h=>$=>({op:4,update:h($)}),S=(h,$)=>({range:(()=>{let d;const t=p(r=>({range:D.$ks.lift(m.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return d},set(r){h.listener?.({op:6}),I.range(d,r)||(d=r,h.listener?.(t(r)))}}})(),label:b(h,$,I.label,p(d=>({label:d}))),description:b(h,void 0,I.description,p(d=>({description:d}))),sortText:b(h,void 0,I.sortText,p(d=>({sortText:d}))),canResolveChildren:b(h,!1,I.canResolveChildren,d=>({op:2,state:d})),busy:b(h,!1,I.busy,p(d=>({busy:d}))),error:b(h,void 0,I.error,p(d=>({error:m.MarkdownString.fromStrict(d)||null}))),tags:b(h,[],I.tags,(d,t)=>({op:1,new:d.map(m.TestTag.from),old:t.map(m.TestTag.from)}))}),C=h=>{const $=g.$OI.fromString(h.extId),d=new o($.controllerId,$.localId,h.label,k.URI.revive(h.uri)||void 0);return d.range=m.Range.to(h.range||void 0),d.description=h.description||void 0,d.sortText=h.sortText||void 0,d.tags=h.tags.map(t=>m.TestTag.to({id:(0,R.$TI)(t).tagId})),d},v=h=>{let $;for(const d of h.tests){const t=C(d.item);(0,M.$XL)(t).parent=$,$=t}return $};e.$bM=v;class o{constructor($,d,t,r){if(d.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(d)} symbol`);const a=(0,M.$WL)(this,$);Object.defineProperties(this,{id:{value:d,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof s?void 0:a.parent}},children:{value:(0,L.$VL)(a,M.$XL,o),enumerable:!0,writable:!1},...S(a,t)})}}e.$cM=o;class s extends o{constructor($,d){super($,$,d,void 0),this._isRoot=!0}}e.$dM=s;class n extends L.$RL{constructor($,d,t){super({controllerId:$,getDocumentVersion:r=>r&&t.getDocument(r)?.version,getApiFor:M.$XL,getChildren:r=>r.children,root:new s($,d),toITestItem:m.TestItem.from})}}e.$eM=n}),define(Se[146],De([1,0,58,8,119,13,7]),function($e,e,D,M,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=e.$0L=e.$9L=void 0;class m{static{this.c=new g.$7L("TextEditorDecorationType")}constructor(p,S,C){const v=m.c.nextId();p.$registerTextEditorDecorationType(S.identifier,v,L.DecorationRenderOptions.from(C)),this.value=Object.freeze({key:v,dispose(){p.$removeTextEditorDecorationType(v)}})}}e.$9L=m;class k{constructor(p,S){this.g=[],this.h=void 0,this.j=!1,this.c=p,this.d=p.version,this.e=S.undoStopBefore,this.f=S.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(p,S){this.k();let C=null;if(p instanceof R.$3J)C=new R.$4J(p,p);else if(p instanceof R.$4J)C=p;else throw new Error("Unrecognized location");this.l(C,S,!1)}insert(p,S){this.k(),this.l(new R.$4J(p,p),S,!0)}delete(p){this.k();let S=null;if(p instanceof R.$4J)S=p;else throw new Error("Unrecognized location");this.l(S,null,!0)}l(p,S,C){const v=this.c.validateRange(p);this.g.push({range:v,text:S,forceMoveMarkers:C})}setEndOfLine(p){if(this.k(),p!==R.EndOfLine.LF&&p!==R.EndOfLine.CRLF)throw(0,M.$5)("endOfLine");this.h=p}}class b{constructor(p,S,C,v){this.c=p,this.d=S,this._accept(C),this.e=v;const o=this;this.value={get tabSize(){return o.f},set tabSize(s){o.m(s)},get indentSize(){return o.g},set indentSize(s){o.o(s)},get insertSpaces(){return o.h},set insertSpaces(s){o.q(s)},get cursorStyle(){return o.j},set cursorStyle(s){o.s(s)},get lineNumbers(){return o.k},set lineNumbers(s){o.t(s)}}}_accept(p){this.f=p.tabSize,this.g=p.indentSize,this.h=p.insertSpaces,this.j=p.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(p.lineNumbers)}l(p){if(p==="auto")return"auto";if(typeof p=="number"){const S=Math.floor(p);return S>0?S:null}if(typeof p=="string"){const S=parseInt(p,10);return isNaN(S)?null:S>0?S:null}return null}m(p){const S=this.l(p);if(S!==null){if(typeof S=="number"){if(this.f===S)return;this.f=S}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:S}))}}n(p){if(p==="tabSize")return"tabSize";if(typeof p=="number"){const S=Math.floor(p);return S>0?S:null}if(typeof p=="string"){const S=parseInt(p,10);return isNaN(S)?null:S>0?S:null}return null}o(p){const S=this.n(p);if(S!==null){if(typeof S=="number"){if(this.g===S)return;this.g=S}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:S}))}}p(p){return p==="auto"?"auto":p==="false"?!1:!!p}q(p){const S=this.p(p);if(typeof S=="boolean"){if(this.h===S)return;this.h=S}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:S}))}s(p){this.j!==p&&(this.j=p,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:p})))}t(p){this.k!==p&&(this.k=p,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(p)})))}assign(p){const S={};let C=!1;if(typeof p.tabSize<"u"){const v=this.l(p.tabSize);v==="auto"?(C=!0,S.tabSize=v):typeof v=="number"&&this.f!==v&&(this.f=v,C=!0,S.tabSize=v)}if(typeof p.indentSize<"u"){const v=this.n(p.indentSize);v==="tabSize"?(C=!0,S.indentSize=v):typeof v=="number"&&this.g!==v&&(this.g=v,C=!0,S.indentSize=v)}if(typeof p.insertSpaces<"u"){const v=this.p(p.insertSpaces);v==="auto"?(C=!0,S.insertSpaces=v):this.h!==v&&(this.h=v,C=!0,S.insertSpaces=v)}typeof p.cursorStyle<"u"&&this.j!==p.cursorStyle&&(this.j=p.cursorStyle,C=!0,S.cursorStyle=p.cursorStyle),typeof p.lineNumbers<"u"&&this.k!==p.lineNumbers&&(this.k=p.lineNumbers,C=!0,S.lineNumbers=L.TextEditorLineNumbersStyle.from(p.lineNumbers)),C&&this.u("setOptions",this.c.$trySetOptions(this.d,S))}u(p,S){S.catch(C=>{this.e.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this.e.warn(C)})}}e.$0L=b;class P{constructor(p,S,C,v,o,s,n,h){this.id=p,this.j=S,this.k=C,this.g=!1,this.h=new Set,this.c=o,this.d=new b(this.j,this.id,s,C),this.e=n,this.f=h;const $=this;this.value=Object.freeze({get document(){return v.value},set document(d){throw new M.$7("document")},get selection(){return $.c&&$.c[0]},set selection(d){if(!(d instanceof R.$5J))throw(0,M.$5)("selection");$.c=[d],$.l()},get selections(){return $.c},set selections(d){if(!Array.isArray(d)||d.some(t=>!(t instanceof R.$5J)))throw(0,M.$5)("selections");$.c=d,$.l()},get visibleRanges(){return $.e},set visibleRanges(d){throw new M.$7("visibleRanges")},get options(){return $.d.value},set options(d){$.g||$.d.assign(d)},get viewColumn(){return $.f},set viewColumn(d){throw new M.$7("viewColumn")},edit(d,t={undoStopBefore:!0,undoStopAfter:!0}){if($.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new k(v.value,t);return d(r),$.m(r)},insertSnippet(d,t,r={undoStopBefore:!0,undoStopAfter:!0}){if($.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=$.c.map(i=>L.Range.from(i));else if(t instanceof R.$3J){const{lineNumber:i,column:c}=L.Position.from(t);a=[{startLineNumber:i,startColumn:c,endLineNumber:i,endColumn:c}]}else if(t instanceof R.$4J)a=[L.Range.from(t)];else{a=[];for(const i of t)if(i instanceof R.$4J)a.push(L.Range.from(i));else{const{lineNumber:c,column:f}=L.Position.from(i);a.push({startLineNumber:c,startColumn:f,endLineNumber:c,endColumn:f})}}return S.$tryInsertSnippet(p,v.value.version,d.value,a,r)},setDecorations(d,t){const r=t.length===0;r&&!$.h.has(d.key)||(r?$.h.delete(d.key):$.h.add(d.key),$.n(()=>{if(L.$YL(t))return S.$trySetDecorations(p,d.key,L.$ZL(t));{const a=new Array(4*t.length);for(let i=0,c=t.length;i<c;i++){const f=t[i];a[4*i]=f.start.line+1,a[4*i+1]=f.start.character+1,a[4*i+2]=f.end.line+1,a[4*i+3]=f.end.character+1}return S.$trySetDecorationsFast(p,d.key,a)}}))},revealRange(d,t){$.n(()=>S.$tryRevealRange(p,L.Range.from(d),t||R.TextEditorRevealType.Default))},show(d){S.$tryShowEditor(p,L.ViewColumn.from(d))},hide(){S.$tryHideEditor(p)}})}dispose(){(0,D.ok)(!this.g),this.g=!0}_acceptOptions(p){(0,D.ok)(!this.g),this.d._accept(p)}_acceptVisibleRanges(p){(0,D.ok)(!this.g),this.e=p}_acceptViewColumn(p){(0,D.ok)(!this.g),this.f=p}_acceptSelections(p){(0,D.ok)(!this.g),this.c=p}async l(){const p=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,p)),this.value}m(p){const S=p.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const C=S.edits.map(o=>o.range);C.sort((o,s)=>o.end.line===s.end.line?o.end.character===s.end.character?o.start.line===s.start.line?o.start.character-s.start.character:o.start.line-s.start.line:o.end.character-s.end.character:o.end.line-s.end.line);for(let o=0,s=C.length-1;o<s;o++){const n=C[o].end;if(C[o+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=S.edits.map(o=>({range:L.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,S.documentVersionId,v,{setEndOfLine:typeof S.setEndOfLine=="number"?L.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}n(p){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this.k.warn(S),null))}}e.$$L=P}),define(Se[147],De([1,0,5,131]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gJ=void 0,e.$gJ=(0,D.$Ch)(M.$Ih)}),define(Se[148],De([1,0,25,4,16,3]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x3b=e.$w3b=e.$v3b=e.$u3b=e.$t3b=e.$s3b=void 0;class R{constructor(s,n){this.versionId=s,this.removedDueToLooping=n}}e.$s3b=R;class m{static isHostExtension(s,n,h){if(n.getExtensionDescription(s))return!1;const $=h.getExtensionDescription(s);return $?!!(($.main||$.browser)&&$.api==="none"):!1}constructor(s,n){this.j=s,this.c=new M.$fd,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(C),this.f=new D.$Xl,this.g=[],this.h=new Map;for(const s of this.e){if(this.f.has(s.identifier)){console.error("Extension `"+s.identifier.value+"` is already registered");continue}this.f.set(s.identifier,s),this.g.push(s);const n=this.j.readActivationEvents(s);if(Array.isArray(n))for(let h of n)h==="onUri"&&(h=`onUri:${D.$Vl.toKey(s.identifier)}`),this.h.has(h)||this.h.set(h,[]),this.h.get(h).push(s)}}set(s){return this.e=s,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(s,n){this.e=v(this.e,n),this.e=this.e.concat(s);const h=m.l(this.e);return this.e=v(this.e,h.map($=>$.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,h)}static l(s){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,a){this.addNode(r),this.addNode(a),this.c.has(r)?this.c.get(r).push(a):this.c.set(r,[a])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,a){const i=n.getArcs(r);for(let c=0;c<i.length;c++)if(!a.has(i[c]))return!1;return!0}getNodes(){return this.e}},h=new D.$Xl;for(const r of s)if(h.set(r.identifier,r),r.extensionDependencies)for(const a of r.extensionDependencies)n.addArc(D.$Vl.toKey(r.identifier),D.$Vl.toKey(a));const $=new Set;n.getNodes().filter(r=>n.getArcs(r).length===0).forEach(r=>$.add(r));const d=n.getNodes().filter(r=>!$.has(r));let t;do{t=!1;for(let r=0;r<d.length;r++){const a=d[r];n.hasOnlyGoodArcs(a,$)&&(d.splice(r,1),r--,$.add(a),t=!0)}}while(t);return d.map(r=>h.get(r))}containsActivationEvent(s){return this.h.has(s)}containsExtension(s){return this.f.has(s)}getExtensionDescriptionsForActivationEvent(s){const n=this.h.get(s);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(s){const n=this.f.get(s);return n||void 0}getExtensionDescriptionByUUID(s){for(const n of this.g)if(n.uuid===s)return n}getExtensionDescriptionByIdOrUUID(s,n){return this.getExtensionDescription(s)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$t3b=m;class k{constructor(s,n){this.versionId=s,this.extensions=n}}e.$u3b=k,e.$v3b={readActivationEvents:o=>o.activationEvents};class b{constructor(s){this.d=new p,this.c=new m(s,[])}async acquireLock(s){const n=await this.d.acquire(s);return new P(this,n)}deltaExtensions(s,n,h){if(!s.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,h)}containsActivationEvent(s){return this.c.containsActivationEvent(s)}containsExtension(s){return this.c.containsExtension(s)}getExtensionDescriptionsForActivationEvent(s){return this.c.getExtensionDescriptionsForActivationEvent(s)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(s){return this.c.getExtensionDescription(s)}getExtensionDescriptionByUUID(s){return this.c.getExtensionDescriptionByUUID(s)}getExtensionDescriptionByIdOrUUID(s,n){return this.c.getExtensionDescriptionByIdOrUUID(s,n)}}e.$w3b=b;class P extends L.$kc{constructor(s,n){super(),this.f=s,this.c=!1,this.B(n)}isAcquiredFor(s){return!this.c&&this.f===s}}e.$x3b=P;class I{constructor(s){this.name=s,this.promise=new Promise((n,h)=>{this.c=n})}resolve(s){this.c(s)}}class p{constructor(){this.c=[],this.d=!1}async acquire(s){const n=new I(s);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const s=this.c.shift();this.d=!0;let n=!0;const h=setTimeout(()=>{n&&console.warn(`The customer named ${s.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),$=()=>{n&&(clearTimeout(h),n=!1,this.d=!1,this.e())};s.resolve((0,L.$ic)($))}}var S;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(S||(S={}));function C(o,s){const n=o.isBuiltin?0:o.isUnderDevelopment?2:1,h=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(n!==h)return n-h;const $=g.$6d.basename(o.extensionLocation.path),d=g.$6d.basename(s.extensionLocation.path);return $<d?-1:$>d?1:0}function v(o,s){const n=new D.$Wl(s);return o.filter(h=>!n.has(h.identifier))}}),define(Se[285],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.ExtHostConnectionType=void 0;var D;(function(P){P[P.IPC=1]="IPC",P[P.Socket=2]="Socket",P[P.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class M{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[M.ENV_KEY]=this.pipeName}}e.$nm=M;class g{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[g.ENV_KEY]="1"}}e.$om=g;class L{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[L.ENV_KEY]="1"}}e.$pm=L;function R(P){delete P[M.ENV_KEY],delete P[g.ENV_KEY],delete P[L.ENV_KEY]}function m(P,I){R(I),P.serialize(I)}e.$qm=m;function k(P){if(P[M.ENV_KEY])return b(P,new M(P[M.ENV_KEY]));if(P[g.ENV_KEY])return b(P,new g);if(P[L.ENV_KEY])return b(P,new L);throw new Error("No connection information defined in environment!")}e.$rm=k;function b(P,I){return R(P),I}}),define(Se[111],De([1,0,22]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$5l=e.$4l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function(b){b[b.Desktop=1]="Desktop",b[b.Web=2]="Web"})(M||(e.UIKind=M={}));var g;(function(b){b[b.VersionMismatch=55]="VersionMismatch",b[b.UnexpectedError=81]="UnexpectedError"})(g||(e.ExtensionHostExitCode=g={}));var L;(function(b){b[b.Initialized=0]="Initialized",b[b.Ready=1]="Ready",b[b.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function R(b){const P=D.$Fd.alloc(1);switch(b){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.$4l=R;function m(b,P){if(b.byteLength!==1)return!1;switch(b.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.$5l=m;var k;(function(b){b.Start="START_NATIVE_LOG",b.End="END_NATIVE_LOG"})(k||(e.NativeLogMarkers=k={}))}),define(Se[89],De([1,0,5,4,14,26,111,67,85,23,2,3,210]),function($e,e,D,M,g,L,R,m,k,b,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jM=e.$iM=e.$hM=e.$gM=void 0;let S=class extends I.$kc{constructor(s,n){super(),this.s=s,this.t=n,this.a=this.B(new M.$fd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$fd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=P.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:k.$eo,name:(0,p.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(n.onDidChangeLogLevel(h=>{(0,g.$7i)(h)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===g.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,n,h){const $=this.getTelemetryDetails(),d=new C(n,h,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:$.isUsageEnabled,isErrorsEnabled:$.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,d]),d.apiTelemetryLogger}$initializeTelemetryLevel(s,n,h){this.f=s,this.g=n,this.c=h??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const n=Object.create(null);switch(n["common.extname"]=`${s.publisher}.${s.name}`,n["common.extversion"]=s.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=v(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,m.$Pk)((0,k.$lo)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const n=this.getTelemetryDetails();this.r.forEach((h,$)=>{const d=h.filter(t=>!t.isDisposed);d.length===0?this.r.delete($):this.r.set($,d)}),this.r.forEach(h=>{for(const $ of h)$.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,n){const $=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!$)return this.r.delete(s.value),!1;let d=!1;for(const t of $)t.ignoreUnhandledExtHostErrors||(t.logError(n),d=!0);return d}};e.$gM=S,e.$gM=S=Ke([Be(0,L.$fM),Be(1,g.$6i)],S);class C{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,n,h,$,d,t,r){this.g=h,this.h=$,this.i=d,this.j=t,this.a=new M.$fd,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(s,n){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let n="properties"in s?s.properties??{}:s;return n=(0,k.$oo)(n,[]),this.c&&(n=(0,b.$Ym)(n,this.c)),this.b||(n=(0,b.$Ym)(n,this.j)),"properties"in s?s.properties=n:s=n,s}k(s,n){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(s,n),this.h.trace(s,n))}logUsage(s,n){this.d.isUsageEnabled&&this.k(s,n)}logError(s,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,n);else{const h={name:s.name,message:s.message,stack:s.stack,cause:s.cause},$=(0,k.$oo)(h,[]),d=new Error($.message,{cause:$.cause});d.stack=$.stack,d.name=$.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(d,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const s=this,n={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$hM=C;function v(o){const s=Date.now()-new Date(o).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$iM=v,e.$jM=(0,D.$Bh)("IExtHostTelemetry")}),define(Se[27],De([1,0,4,2,252,137,25,5]),function($e,e,D,M,g,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VF=e.$UF=e.$TF=e.ActivationKind=e.$SF=e.$RF=e.$QF=e.$PF=e.$OF=e.ExtensionHostStartup=e.$NF=e.$MF=e.$LF=e.$KF=void 0,e.$KF=Object.freeze({identifier:new R.$Vl("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$LF="extensions.webWorker",e.$MF=(0,m.$Bh)("extensionService");class k{constructor(d){this.dependency=d}}e.$NF=k;var b;(function($){$[$.EagerAutoStart=1]="EagerAutoStart",$[$.EagerManualStart=2]="EagerManualStart",$[$.Lazy=3]="Lazy"})(b||(e.ExtensionHostStartup=b={}));class P{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(d,t,r){this.c=d,this.d=t.slice(0),this.e=r.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$BF.createActivationEventsMap(this.d)}}set(d,t,r){if(this.c>d)throw new Error(`ExtensionHostExtensions: invalid versionId ${d} (current: ${this.c})`);const a=[],i=[],c=[],f=[],y=I(this.d),E=I(t),u=(O,F)=>O.extensionLocation.toString()===F.extensionLocation.toString()||O.isBuiltin===F.isBuiltin||O.isUserBuiltin===F.isUserBuiltin||O.isUnderDevelopment===F.isUnderDevelopment;for(const O of this.d){const F=E.get(O.identifier);if(!F){a.push(O.identifier),y.delete(O.identifier);continue}if(!u(O,F)){a.push(O.identifier),y.delete(O.identifier);continue}}for(const O of t){const F=y.get(O.identifier);if(!F){i.push(O);continue}if(!u(F,O)){a.push(F.identifier),y.delete(F.identifier);continue}}const l=new R.$Wl(this.e),w=new R.$Wl(r);for(const O of this.e)w.has(O)||c.push(O);for(const O of r)l.has(O)||f.push(O);const A=L.$BF.createActivationEventsMap(i),N={versionId:d,toRemove:a,toAdd:i,addActivationEvents:A,myToRemove:c,myToAdd:f};return this.delta(N),N}delta(d){if(this.c>=d.versionId)return null;const{toRemove:t,toAdd:r,myToRemove:a,myToAdd:i}=d,c=new R.$Wl(t),f=new R.$Wl(a);for(let y=0;y<this.d.length;y++)c.has(this.d[y].identifier)&&(this.d.splice(y,1),y--);for(let y=0;y<this.e.length;y++)f.has(this.e[y])&&(this.e.splice(y,1),y--);for(const y of r)this.d.push(y);for(const y of i)this.e.push(y);return d}containsExtension(d){for(const t of this.e)if(R.$Vl.equals(t,d))return!0;return!1}}e.$OF=P;function I($){const d=new R.$Xl;for(const t of $)d.set(t.identifier,t);return d}function p($,d){return $.enabledApiProposals?$.enabledApiProposals.includes(d):!1}e.$PF=p;function S($,d){if(!p($,d))throw new Error(`Extension '${$.identifier.value}' CANNOT use API proposal: ${d}.
Its package.json#enabledApiProposals-property declares: ${$.enabledApiProposals?.join(", ")??"[]"} but NOT ${d}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${$.identifier.value}`)}e.$QF=S;class C{constructor(d,t,r,a){this.codeLoadingTime=d,this.activateCallTime=t,this.activateResolvedTime=r,this.activationReason=a}}e.$RF=C;class v{constructor(d,t){this.description=d,this.value=t}}e.$SF=v;var o;(function($){$[$.Normal=0]="Normal",$[$.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function s($){return{type:$.isBuiltin?0:1,isBuiltin:$.isBuiltin||$.isUserBuiltin,identifier:{id:(0,g.$uo)($.publisher,$.name),uuid:$.uuid},manifest:$,location:$.extensionLocation,targetPlatform:$.targetPlatform,validations:[],isValid:!0}}e.$TF=s;function n($,d){return{identifier:new R.$Vl((0,g.$so)($.manifest.publisher,$.manifest.name)),isBuiltin:$.type===0,isUserBuiltin:$.type===1&&$.isBuiltin,isUnderDevelopment:!!d,extensionLocation:$.location,...$.manifest,uuid:$.identifier.uuid,targetPlatform:$.targetPlatform}}e.$UF=n;class h{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(d){return Promise.resolve(void 0)}activationEventIsDone(d){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(d){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(d,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(d){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$VF=h}),define(Se[286],De([1,0,8,148,25,27,14,9]),function($e,e,D,M,g,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pbc=e.$obc=e.$nbc=e.$mbc=e.$lbc=e.$kbc=void 0;class k{static{this.NONE=new k(!1,-1,-1,-1)}constructor(s,n,h,$){this.startup=s,this.codeLoadingTime=n,this.activateCallTime=h,this.activateResolvedTime=$}}e.$kbc=k;class b{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,n){return s===-1||n===-1?-1:n-s}build(){return new k(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$lbc=b;class P{constructor(s,n,h,$,d,t){this.activationFailed=s,this.activationFailedError=n,this.activationTimes=h,this.module=$,this.exports=d,this.subscriptions=t}}e.$mbc=P;class I extends P{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$nbc=I;class p extends P{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$obc=p;class S extends P{constructor(s){super(!0,s,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let C=class{constructor(s,n,h,$){this.g=$,this.a=s,this.b=n,this.c=h,this.d=new g.$Xl,this.f=Object.create(null)}dispose(){for(const[s,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const s=[];for(const[n,h]of this.d)s.push(h.wait());await Promise.all(s)}isActivated(s){const n=this.d.get(s);return!!(n&&n.value)}getActivatedExtension(s){const n=this.d.get(s);if(!n||!n.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return n.value}async activateByEvent(s,n){if(this.f[s])return;const h=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(h.map($=>({id:$.identifier,reason:{startup:n,extensionId:$.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,n){const h=this.a.getExtensionDescription(s);if(!h)throw new Error(`Extension '${s}' is not known`);return this.h([{id:h.identifier,reason:n}])}async h(s){const n=s.filter(h=>!this.isActivated(h.id)).map(h=>this.j(h));await Promise.all(n.map(h=>h.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const n=this.a.getExtensionDescription(s.id);if(!n){const d=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new S(d));return this.c.onExtensionActivationError(s.id,d,new L.$NF(s.id.value)),t}const h=[],$=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const d of $){if(this.m(d))continue;const t=this.d.get(d);if(t){h.push(t);continue}if(this.l(d)){h.push(this.j({id:this.b.getExtensionDescription(d).identifier,reason:s.reason}));continue}const r=this.a.getExtensionDescription(d);if(r){if(!r.main&&!r.browser)continue;h.push(this.j({id:r.identifier,reason:s.reason}));continue}const a=n.displayName||n.identifier.value,i=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${d}'`),c=this.k(s,n.displayName,[],new S(i));return this.c.onExtensionActivationError(n.identifier,i,new L.$NF(d)),c}return this.k(s,n.displayName,h,null)}k(s,n,h,$){const d=new v(s.id,n,s.reason,h,$,this.c,this.g);return this.d.set(s.id,d),d}l(s){return M.$t3b.isHostExtension(s,this.a,this.b)}m(s){const n=this.b.getExtensionDescription(s);return n?!n.main&&!n.browser:!1}};e.$pbc=C,e.$pbc=C=Ke([Be(3,R.$5i)],C);let v=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,n,h,$,d,t,r){this.c=s,this.d=n,this.f=h,this.g=$,this.h=d,this.j=t,this.k=r,this.a=new m.$Fg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const n=this.g[s];if(n.value&&!n.value.activationFailed){this.g.splice(s,1),s--;continue}if(n.value&&n.value.activationFailed){const h=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);h.detail=n.value.activationFailedError,this.h=new S(h),this.j.onExtensionActivationError(this.c,h,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const n=new Error;if(s&&s.name&&(n.name=s.name),s&&s.message?n.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(n.stack=s.stack),this.h=new S(n),this.b&&D.$2(s))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};v=Ke([Be(6,R.$5i)],v)}),define(Se[287],De([1,0,212,24,2,4,3,269,9,7,18,19,13,80,21,173,27]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=void 0;function s($,d){if((0,P.$jf)($))return{label:$};if($&&typeof $=="object"&&typeof $.label=="string"){let t;return Array.isArray($.highlights)&&(t=$.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),t=t.length?t:void 0),{label:$.label,highlights:t}}}class n extends R.$kc{constructor(d,t,r){super(),this.f=d,this.g=t,this.h=r,this.a=new Map,this.b=new v.$j7;function a(i){return i&&i.$treeViewId&&(i.$treeItemHandle||i.$selectedTreeItems||i.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:i=>a(i)?this.r(i):Array.isArray(i)&&i.length>0?i.map(c=>a(c)?this.r(c):c):i})}registerTreeDataProvider(d,t,r){const a=this.createTreeView(d,{treeDataProvider:t},r);return{dispose:()=>a.dispose()}}createTreeView(d,t,r){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=t.dragAndDropController?.dropMimeTypes??[],i=t.dragAndDropController?.dragMimeTypes??[],c=!!t.dragAndDropController?.handleDrag,f=!!t.dragAndDropController?.handleDrop,y=this.m(d,t,r),E={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:a,dragMimeTypes:i,hasHandleDrag:c,hasHandleDrop:f,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},u=this.f.$registerTreeViewDataProvider(d,E),l={get onDidCollapseElement(){return y.onDidCollapseElement},get onDidExpandElement(){return y.onDidExpandElement},get selection(){return y.selectedElements},get onDidChangeSelection(){return y.onDidChangeSelection},get activeItem(){return(0,o.$QF)(r,"treeViewActiveItem"),y.focusedElement},get onDidChangeActiveItem(){return(0,o.$QF)(r,"treeViewActiveItem"),y.onDidChangeActiveItem},get visible(){return y.visible},get onDidChangeVisibility(){return y.onDidChangeVisibility},get onDidChangeCheckboxState(){return y.onDidChangeCheckboxState},get message(){return y.message},set message(w){(0,S.$Zj)(w)&&(0,o.$QF)(r,"treeViewMarkdownMessage"),y.message=w},get title(){return y.title},set title(w){y.title=w},get description(){return y.description},set description(w){y.description=w},get badge(){return y.badge},set badge(w){w!==void 0&&b.ViewBadge.isViewBadge(w)?y.badge={value:Math.floor(Math.abs(w.value)),tooltip:w.tooltip}:w===void 0&&(y.badge=void 0)},reveal:(w,A)=>y.reveal(w,A),dispose:async()=>{await u,this.a.delete(d),y.dispose()}};return this.B(l),l}$getChildren(d,t){const r=this.a.get(d);return r?r.getChildren(t):Promise.reject(new m.$bF(d))}async $handleDrop(d,t,r,a,i,c,f,y){const E=this.a.get(d);if(!E)return Promise.reject(new m.$bF(d));const u=p.DataTransfer.toDataTransfer(r,async l=>(await this.f.$resolveDropFileData(d,t,l)).buffer);return f===d&&y&&await this.j(u,E,y,i,c),E.onDrop(u,a,i)}async j(d,t,r,a,i){const c=this.b.removeDragOperationTransfer(i);if(c)(await c)?.forEach((f,y)=>{f&&d.set(y,f)});else if(i&&t.handleDrag){const f=t.handleDrag(r,d,a);this.b.addDragOperationTransfer(i,f),await f}return d}async $handleDrag(d,t,r,a){const i=this.a.get(d);if(!i)return Promise.reject(new m.$bF(d));const c=await this.j(new b.$TK,i,t,a,r);if(!(!c||a.isCancellationRequested))return p.DataTransfer.from(c)}async $hasResolve(d){const t=this.a.get(d);if(!t)throw new m.$bF(d);return t.hasResolve}$resolve(d,t,r){const a=this.a.get(d);if(!a)throw new m.$bF(d);return a.resolveTreeItem(t,r)}$setExpanded(d,t,r){const a=this.a.get(d);if(!a)throw new m.$bF(d);a.setExpanded(t,r)}$setSelectionAndFocus(d,t,r){const a=this.a.get(d);if(!a)throw new m.$bF(d);a.setSelectionAndFocus(t,r)}$setVisible(d,t){const r=this.a.get(d);if(!r){if(!t)return;throw new m.$bF(d)}r.setVisible(t)}$changeCheckboxState(d,t){const r=this.a.get(d);if(!r)throw new m.$bF(d);r.setCheckboxState(t)}m(d,t,r){const a=this.B(new h(d,t,this.f,this.g.converter,this.h,r));return this.a.set(d,a),a}r(d){const t=this.a.get(d.$treeViewId);return t&&"$treeItemHandle"in d?t.getExtensionElement(d.$treeItemHandle):t&&"$focusedTreeItem"in d&&d.$focusedTreeItem?t.focusedElement:null}}e.$2bc=n;class h extends R.$kc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(d=>this.getExtensionElement(d)).filter(d=>!(0,P.$sf)(d))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(d,t,r,a,i,c){if(super(),this.I=d,this.J=r,this.L=a,this.M=i,this.N=c,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$fd),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$fd),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$fd),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$fd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$fd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$fd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$fd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new C.$pd,c.contributes&&c.contributes.views)for(const u in c.contributes.views)for(const l of c.contributes.views[u])l.id===d&&(this.P=l.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(u=>this.F.fire({message:!1,element:u})));let f,y;const E=L.Event.debounce(this.F.event,(u,l)=>(u||(u={message:!1,elements:[]}),l.element!==!1&&(f||(f=new Promise(w=>y=w),this.G=this.G.then(()=>f)),Array.isArray(l.element)?u.elements.push(...l.element):u.elements.push(l.element)),l.message&&(u.message=!0),u),200,!0);this.B(E(({message:u,elements:l})=>{l.length&&(this.H=this.H.then(()=>{const w=y;return f=null,this.$(l).then(()=>w())})),u&&this.J.$setMessage(this.I,p.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(d){const t=d?this.getExtensionElement(d):void 0;if(d&&!t)return this.M.error(`No tree item with id '${d}' found.`),Promise.resolve([]);let r=this.X(d);return r||(r=await this.Y(t)),r?r.map(a=>a.item):void 0}getExtensionElement(d){return this.j.get(d)}reveal(d,t){t=t||{select:!0,focus:!1};const r=(0,P.$sf)(t.select)?!0:t.select,a=(0,P.$sf)(t.focus)?!1:t.focus,i=(0,P.$sf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):d?this.G.then(()=>this.S(d)).then(c=>this.W(d,c[c.length-1]).then(f=>this.J.$reveal(this.I,{item:f.item,parentChain:c.map(y=>y.item)},{select:r,focus:a,expand:i})),c=>this.M.error(c)):this.J.$reveal(this.I,void 0,{select:r,focus:a,expand:i})}get message(){return this.O}set message(d){this.O=d,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(d){this.P=d,this.J.$setTitle(this.I,d,this.Q)}get description(){return this.Q}set description(d){this.Q=d,this.J.$setTitle(this.I,this.P,d)}get badge(){return this.R}set badge(d){this.R?.value===d?.value&&this.R?.tooltip===d?.tooltip||(this.R=p.ViewBadge.from(d),this.J.$setBadge(this.I,d))}setExpanded(d,t){const r=this.getExtensionElement(d);r&&(t?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(d,t){const r=!(0,I.$sb)(this.s,d);this.s=d;const a=this.t!==t;this.t=t,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(d){d!==this.r&&(this.r=d,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(d){const t=(await Promise.all(d.map(async r=>{const a=this.getExtensionElement(r.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:r.newState?b.TreeItemCheckboxState.Checked:b.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);t.forEach(r=>{r.treeItem.checkboxState=r.newState?b.TreeItemCheckboxState.Checked:b.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(r=>[r.extensionItem,r.newState])})}async handleDrag(d,t,r){const a=[];for(const i of d){const c=this.getExtensionElement(i);c&&a.push(c)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,t,r),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(d,t,r){const a=t?this.getExtensionElement(t):void 0;if(!(!a&&t||!this.g?.handleDrop))return(0,k.$zg)(()=>this.g?.handleDrop?this.g.handleDrop(a,d,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(d,t){if(!this.f.resolveTreeItem)return;const r=this.j.get(d);if(r){const a=this.m.get(r);if(a){const i=await this.f.resolveTreeItem(a.extensionItem,r,t)??a.extensionItem;return this.hb(i),a.item.tooltip=this.eb(i.tooltip),a.item.command=this.fb(a.disposableStore,i.command),a.item}}}S(d){return this.U(d).then(t=>t?this.S(t).then(r=>this.W(t,r[r.length-1]).then(a=>(r.push(a),r))):Promise.resolve([]))}U(d){const t=this.m.get(d);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,k.$zg)(()=>this.f.getParent(d))}W(d,t){const r=this.m.get(d);return r?Promise.resolve(r):(0,k.$zg)(()=>this.f.getTreeItem(d)).then(a=>this.kb(d,a,t,!0)).then(a=>this.getChildren(t?t.item.handle:void 0).then(()=>{const i=this.getExtensionElement(a);if(i){const c=this.m.get(i);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(d){if(d){let t;if(typeof d=="string"){const r=this.getExtensionElement(d);t=r?this.m.get(r):void 0}else t=d;return t&&t.children||void 0}return this.h}async Y(d){this.rb(d);const t=new C.$pd(this.Z.token);try{const r=d?this.m.get(d):void 0,a=await this.f.getChildren(d);if(t.token.isCancellationRequested)return;const i=await Promise.all((0,I.$Fb)(a||[]).map(async c=>{const f=await this.f.getTreeItem(c);return f&&!t.token.isCancellationRequested?this.db(c,f,r):null}));return t.token.isCancellationRequested?void 0:(0,I.$Fb)(i)}finally{t.dispose()}}$(d){if(d.some(r=>!r))return this.Z.dispose(!0),this.Z=new C.$pd,this.tb(),this.J.$refresh(this.I);{const r=this.ab(d);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(d){const t=new Set,r=d.map(i=>this.m.get(i));for(const i of r)if(i&&!t.has(i.item.handle)){let c=i;for(;c&&c.parent&&r.findIndex(f=>c&&c.parent&&f&&f.item.handle===c.parent.item.handle)===-1;){const f=this.j.get(c.parent.item.handle);c=f?this.m.get(f):void 0}c&&!c.parent&&t.add(i.item.handle)}const a=[];return t.forEach(i=>{const c=this.j.get(i);if(c){const f=this.m.get(c);f&&(!f.parent||!t.has(f.parent.item.handle))&&a.push(i)}}),a}bb(d){const t={};return Promise.all(d.map(r=>this.cb(r).then(a=>{a&&(t[r]=a.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(d){const t=this.getExtensionElement(d);if(t){const r=this.m.get(t);if(r)return this.rb(t),(0,k.$zg)(()=>this.f.getTreeItem(t)).then(a=>{if(a){const i=this.ib(t,a,r.parent);return this.pb(t,i,r,r.parent),r.dispose(),i}return null})}return Promise.resolve(null)}db(d,t,r){const a=this.ib(d,t,r);if(t.id&&this.j.has(a.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.ob(d,a),this.qb(a,r),a}eb(d){return b.$qK.isMarkdownString(d)?p.MarkdownString.from(d):d}fb(d,t){return t?{...this.L.toInternal(t,d),originalId:t.command}:void 0}gb(d){if(d.checkboxState===void 0)return;let t,r,a;return typeof d.checkboxState=="number"?t=d.checkboxState:(t=d.checkboxState.state,r=d.checkboxState.tooltip,a=d.checkboxState.accessibilityInformation),{isChecked:t===b.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:a}}hb(d){if(!b.$OK.isTreeItem(d,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(d,t,r){this.hb(t);const a=this.B(new R.$jc),i=this.kb(d,t,r),c=this.lb(t);return{item:{handle:i,parentHandle:r?r.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(a,t.command),contextValue:t.contextValue,icon:c,iconDark:this.mb(t)||c,themeIcon:this.jb(t),collapsibleState:(0,P.$sf)(t.collapsibleState)?b.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:r,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(d){return d.iconPath instanceof b.$WK?d.iconPath:void 0}kb(d,{id:t,label:r,resourceUri:a},i,c){if(t)return`${h.b}/${t}`;const f=s(r,this.N),y=i?i.item.handle:h.a;let E=f?f.label:a?(0,M.$fg)(a):"";E=E.indexOf("/")!==-1?E.replace("/","//"):E;const u=this.m.has(d)?this.m.get(d).item.handle:void 0,l=this.X(i)||[];let w,A=0;do{if(w=`${y}/${A}:${E}`,c||!this.j.has(w)||u===w)break;A++}while(A<=l.length);return w}lb(d){if(d.iconPath&&!(d.iconPath instanceof b.$WK))return typeof d.iconPath=="string"||g.URI.isUri(d.iconPath)?this.nb(d.iconPath):this.nb(d.iconPath.light)}mb(d){if(d.iconPath&&!(d.iconPath instanceof b.$WK)&&d.iconPath.dark)return this.nb(d.iconPath.dark)}nb(d){return g.URI.isUri(d)?d:g.URI.file(d)}ob(d,t){this.j.set(t.item.handle,d),this.m.set(d,t)}pb(d,t,r,a){this.j.delete(t.item.handle),this.m.delete(d),t.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(d,t);const i=this.X(a)||[],c=i.filter(f=>f.item.handle===r.item.handle)[0];c&&i.splice(i.indexOf(c),1,t)}qb(d,t){t?(t.children||(t.children=[]),t.children.push(d)):(this.h||(this.h=[]),this.h.push(d))}rb(d){if(d){const t=this.m.get(d);if(t){if(t.children)for(const r of t.children){const a=this.j.get(r.item.handle);a&&this.sb(a)}t.children=void 0}}else this.tb()}sb(d){const t=this.m.get(d);if(t){if(t.children)for(const r of t.children){const a=this.j.get(r.item.handle);a&&this.sb(a)}this.m.delete(d),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(d=>d.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Se[288],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatSlashCommands.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageConfigurationAutoClosingPairs:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageConfigurationAutoClosingPairs.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[289],De([1,0,224,8,38,132,106,42,25,288,135,137]),function($e,e,D,M,g,L,R,m,k,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=void 0;const p=m.$8m.as(R.$9m.JSONContribution);class S{constructor(d,t,r){this.a=d,this.b=t,this.c=r}d(d,t){this.a({type:d,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(d){this.d(g.default.Error,d)}warn(d){this.d(g.default.Warning,d)}info(d){this.d(g.default.Info,d)}}e.$WF=S;class C{static a(d){const t=new k.$Wl;for(let r=0,a=d.length;r<a;r++)t.add(d[r].description.identifier);return t}static compute(d,t){if(!d||!d.length)return new C(t,[]);if(!t||!t.length)return new C([],d);const r=this.a(d),a=this.a(t),i=t.filter(f=>!r.has(f.description.identifier)),c=d.filter(f=>!a.has(f.description.identifier));return new C(i,c)}constructor(d,t){this.added=d,this.removed=t}}e.$XF=C;class v{constructor(d,t){this.name=d,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(d){if(this.a!==null)throw new Error("Handler already set!");this.a=d,this.d()}acceptUsers(d){this.c=C.compute(this.b,d),this.b=d,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(d){(0,M.$Y)(d)}}}e.$YF=v;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$ZF={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:k.$Ul},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"*",description:D.localize(42,null),body:"*"}]}},badges:{type:"array",description:D.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(44,null)},href:{type:"string",description:D.localize(45,null)},description:{type:"string",description:D.localize(46,null)}}}},markdown:{type:"string",description:D.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Mn}},extensionPack:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Mn}},extensionKind:{description:D.localize(51,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(52,null)},{body:["workspace"],description:D.localize(53,null)},{body:["ui","workspace"],description:D.localize(54,null)},{body:["workspace","ui"],description:D.localize(55,null)},{body:[],description:D.localize(56,null)}]},capabilities:{description:D.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(60,null),D.localize(61,null),D.localize(62,null)]},description:{type:"string",markdownDescription:D.localize(63,null)}}},untrustedWorkspaces:{description:D.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(66,null),D.localize(67,null),D.localize(68,null)]},restrictedConfigurations:{description:D.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(70,null)}}}}},sponsor:{description:D.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(73,null),type:"string"},"vscode:uninstall":{description:D.localize(74,null),type:"string"}}},icon:{type:"string",description:D.localize(75,null)},l10n:{type:"string",description:D.localize(76,null)},pricing:{type:"string",markdownDescription:D.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(d){if(this.a.has(d.extensionPoint))throw new Error("Duplicate extension point: "+d.extensionPoint);const t=new v(d.extensionPoint,d.defaultExtensionKind);return this.a.set(d.extensionPoint,t),d.activationEventsGenerator&&I.$BF.register(d.extensionPoint,d.activationEventsGenerator),e.$ZF.properties.contributes.properties[d.extensionPoint]=d.jsonSchema,p.registerSchema(s,e.$ZF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$1F=n;const h={ExtensionsRegistry:"ExtensionsRegistry"};m.$8m.add(h.ExtensionsRegistry,new n),e.$2F=m.$8m.as(h.ExtensionsRegistry),p.registerSchema(s,e.$ZF),p.registerSchema(P.$lj,{properties:{extensionEnabledApiProposals:{description:D.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals)}}]}}}})}),define(Se[290],De([1,0,221,18,23,289,41,4]),function($e,e,D,M,g,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$F=void 0;const k={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var b;(function(p){function S(C,v,o){if(!C)return;const s=M.$jf(C.type)?C.type:void 0;if(!s||s.length===0){o.error(D.localize(3,null));return}const n=[];if(Array.isArray(C.required))for(const h of C.required)M.$jf(h)&&n.push(h);return{extensionId:v.value,taskType:s,required:n,properties:C.properties?g.$Vm(C.properties):{},when:C.when?R.$Ii.deserialize(C.when):void 0}}p.from=S})(b||(b={}));const P=L.$2F.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(p,S)=>{for(const C of p)C.type&&S.push(`onTaskType:${C.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:k}});class I{constructor(){this.d=new m.$fd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((S,C)=>{P.setHandler((v,o)=>{this.c=void 0;try{for(const s of o.removed){const n=s.value;for(const h of n)this.a&&h.type&&this.a[h.type]&&delete this.a[h.type]}for(const s of o.added){const n=s.value;for(const h of n){const $=b.from(h,s.description.identifier,s.collector);$&&(this.a[$.taskType]=$)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}S(void 0)})})}onReady(){return this.b}get(S){return this.a[S]}all(){return Object.keys(this.a).map(S=>this.a[S])}getJsonSchema(){if(this.c===void 0){const S=[];for(const C of this.all()){const v={type:"object",additionalProperties:!1};C.required.length>0&&(v.required=C.required.slice(0)),C.properties!==void 0?v.properties=g.$Vm(C.properties):v.properties=Object.create(null),v.properties.type={type:"string",enum:[C.taskType]},S.push(v)}this.c={oneOf:S}}return this.c}}e.$$F=new I}),define(Se[291],De([1,0,222,18,24,23,41,290]),function($e,e,D,M,g,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$iG=e.JsonSchemaVersion=e.ExecutionEngine=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$cG=e.ShellQuoting=e.$bG=e.$aG=e.$_F=void 0,e.$_F="settings",e.$aG=new R.$2i("taskRunning",!1,D.localize(0,null)),e.$bG={value:D.localize(1,null),original:"Tasks"};var k;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(k||(e.ShellQuoting=k={})),e.$cG="$customized",function(z){function T(H){if(!H)return z.Strong;switch(H.toLowerCase()){case"escape":return z.Escape;case"strong":return z.Strong;case"weak":return z.Weak;default:return z.Strong}}z.from=T}(k||(e.ShellQuoting=k={}));var b;(function(z){z.defaults={cwd:"${workspaceFolder}"}})(b||(e.CommandOptions=b={}));var P;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(P||(e.RevealKind=P={})),function(z){function T(H){switch(H.toLowerCase()){case"always":return z.Always;case"silent":return z.Silent;case"never":return z.Never;default:return z.Always}}z.fromString=T}(P||(e.RevealKind=P={}));var I;(function(z){z[z.Never=1]="Never",z[z.OnProblem=2]="OnProblem",z[z.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(z){function T(H){switch(H.toLowerCase()){case"always":return z.Always;case"never":return z.Never;case"onproblem":return z.OnProblem;default:return z.OnProblem}}z.fromString=T}(I||(e.RevealProblemKind=I={}));var p;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(p||(e.PanelKind=p={})),function(z){function T(H){switch(H.toLowerCase()){case"shared":return z.Shared;case"dedicated":return z.Dedicated;case"new":return z.New;default:return z.Shared}}z.fromString=T}(p||(e.PanelKind=p={}));var S;(function(z){z.defaults={echo:!0,reveal:P.Always,revealProblems:I.Never,focus:!1,panel:p.Shared,showReuseMessage:!0,clear:!1}})(S||(e.PresentationOptions=S={}));var C;(function(z){z[z.Shell=1]="Shell",z[z.Process=2]="Process",z[z.CustomExecution=3]="CustomExecution"})(C||(e.RuntimeType=C={})),function(z){function T(q){switch(q.toLowerCase()){case"shell":return z.Shell;case"process":return z.Process;case"customExecution":return z.CustomExecution;default:return z.Process}}z.fromString=T;function H(q){switch(q){case z.Shell:return"shell";case z.Process:return"process";case z.CustomExecution:return"customExecution";default:return"process"}}z.toString=H}(C||(e.RuntimeType=C={}));var v;(function(z){function T(H){return M.$jf(H)?H:H.value}z.value=T})(v||(e.CommandString=v={}));var o;(function(z){z.Clean={_id:"clean",isDefault:!1},z.Build={_id:"build",isDefault:!1},z.Rebuild={_id:"rebuild",isDefault:!1},z.Test={_id:"test",isDefault:!1};function T(q){return q===z.Clean._id||q===z.Build._id||q===z.Rebuild._id||q===z.Test._id}z.is=T;function H(q){if(q!==void 0)return M.$jf(q)?T(q)?{_id:q,isDefault:!1}:void 0:q}z.from=H})(o||(e.TaskGroup=o={}));var s;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var n;(function(z){z.Workspace="workspace",z.Extension="extension",z.InMemory="inMemory",z.WorkspaceFile="workspaceFile",z.User="user";function T(H){switch(H){case z.User:return 2;case z.WorkspaceFile:return 5;default:return 6}}z.toConfigurationTarget=T})(n||(e.TaskSourceKind=n={}));var h;(function(z){z.parallel="parallel",z.sequence="sequence"})(h||(e.DependsOrder=h={}));var $;(function(z){z[z.default=1]="default",z[z.folderOpen=2]="folderOpen"})($||(e.RunOnOptions=$={}));var d;(function(z){z.defaults={reevaluateOnRerun:!0,runOn:$.default,instanceLimit:1}})(d||(e.RunOptions=d={}));class t{constructor(T,H,q,me,X,Z){this._label="",this._id=T,H&&(this._label=H),q&&(this.type=q),this.runOptions=me,this.configurationProperties=X,this._source=Z}getDefinition(T){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const T={folder:this.d(),id:this._id};return JSON.stringify(T)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(T,H=!1){if(T===void 0)return!1;if(M.$jf(T))return T===this._label||T===this.configurationProperties.identifier||H&&T===this._id;const q=this.getDefinition(!0);return q!==void 0&&q._key===T._key}getQualifiedLabel(){const T=this.getWorkspaceFolder();return T?`${this._label} (${T.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(T){this.c===void 0&&(this.c=[]),T&&(this.c=this.c.concat(T))}get taskLoadMessages(){return this.c}}e.$dG=t;class r extends t{constructor(T,H,q,me,X,Z,V,x){super(T,q,void 0,V,x,H),this.command={},this._source=H,this.hasDefinedMatchers=Z,X&&(this.command=X)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(T=!1){if(T&&this._source.customizes!==void 0)return this._source.customizes;{let H;switch(this.command?this.command.runtime:void 0){case C.Shell:H="shell";break;case C.Process:H="process";break;case C.CustomExecution:H="customExecution";break;case void 0:H="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:H,_key:this._id,id:this._id}}}static is(T){return T instanceof r}getMapKey(){const T=this._source.config.workspaceFolder;return T?`${T.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$_F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const T=this.d();if(!T)return;let H=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(H+=this._source.kind);const q={type:e.$cG,folder:T,id:H};return JSON.stringify(q)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$fg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(T){return new r(T._id,T._source,T._label,T.type,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$eG=r;class a extends t{constructor(T,H,q,me,X,Z,V){super(T,q,me,Z,V,H),this._source=H,this.configures=X}static is(T){return T instanceof a}f(T){return T}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$fg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$_F:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const T=this.d();if(!T)return;let H=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(H+=this._source.kind);const q={type:e.$cG,folder:T,id:H};return JSON.stringify(q)}}e.$fG=a;class i extends t{constructor(T,H,q,me,X,Z,V,x,ge){super(T,q,me,x,ge,H),this.defines=X,this.hasDefinedMatchers=V,this.command=Z,this.icon=ge.icon,this.hide=ge.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(T){return T instanceof i}getMapKey(){const T=this._source.workspaceFolder;return T?`${this._source.scope.toString()}|${T.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const T={type:"contributed",scope:this._source.scope,id:this._id};return T.folder=this.d(),JSON.stringify(T)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(T){return new i(T._id,T._source,T._label,T.type,T.defines,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$gG=i;class c extends t{constructor(T,H,q,me,X,Z){super(T,q,me,X,Z,H),this._source=H}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(T){return T instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(T){return new c(T._id,T._source,T._label,T.type,T.runOptions,T.configurationProperties)}}e.$hG=c;var f;(function(z){z[z.Process=1]="Process",z[z.Terminal=2]="Terminal"})(f||(e.ExecutionEngine=f={})),function(z){z._default=z.Terminal}(f||(e.ExecutionEngine=f={}));var y;(function(z){z[z.V0_1_0=1]="V0_1_0",z[z.V2_0_0=2]="V2_0_0"})(y||(e.JsonSchemaVersion=y={}));class E{constructor(T){this.c=new Map;for(let H=0;H<T.length;H++)this.c.set(T[H].uri.toString(),H)}compare(T,H){const q=T.getWorkspaceFolder(),me=H.getWorkspaceFolder();if(q&&me){let X=this.c.get(q.uri.toString());X=X===void 0?0:X+1;let Z=this.c.get(me.uri.toString());return Z=Z===void 0?0:Z+1,X===Z?T._label.localeCompare(H._label):X-Z}else return!q&&me?-1:q&&!me?1:0}}e.$iG=E;var u;(function(z){z.DependsOnStarted="dependsOnStarted",z.AcquiredInput="acquiredInput",z.Start="start",z.ProcessStarted="processStarted",z.Active="active",z.Inactive="inactive",z.Changed="changed",z.Terminated="terminated",z.ProcessEnded="processEnded",z.End="end"})(u||(e.TaskEventKind=u={}));var l;(function(z){z.SingleRun="singleRun",z.Background="background"})(l||(e.TaskRunType=l={}));var w;(function(z){z[z.System=0]="System",z[z.User=1]="User",z[z.FolderOpen=2]="FolderOpen",z[z.ConfigurationChange=3]="ConfigurationChange",z[z.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var A;(function(z){function T(x){return{taskId:x._id,taskName:x.configurationProperties.name,runType:x.configurationProperties.isBackground?"background":"singleRun",group:x.configurationProperties.group,__task:x}}function H(x,ge,ue){return{...T(x),kind:"start",terminalId:ge,resolvedVariables:ue}}z.start=H;function q(x,ge,ue){return{...T(x),kind:"processStarted",terminalId:ge,processId:ue}}z.processStarted=q;function me(x,ge,ue){return{...T(x),kind:"processEnded",terminalId:ge,exitCode:ue}}z.processEnded=me;function X(x,ge,ue){return{...T(x),kind:"terminated",exitReason:ue,terminalId:ge}}z.terminated=X;function Z(x,ge,ue){return{...T(ge),kind:x,terminalId:ue}}z.general=Z;function V(){return{kind:"changed"}}z.changed=V})(A||(e.TaskEvent=A={}));var N;(function(z){function T(q){const me=Object.keys(q).sort();let X="";for(const Z of me){let V=q[Z];V instanceof Object?V=T(V):typeof V=="string"&&(V=V.replace(/,/g,",,")),X+=Z+","+V+","}return X}function H(q){const X={_key:T(q),type:q.taskType};return Object.assign(X,q),X}z.create=H})(N||(e.KeyedTaskIdentifier=N={}));var O;(function(z){z.AutoDetect="task.autoDetect",z.SaveBeforeRun="task.saveBeforeRun",z.ShowDecorations="task.showDecorations",z.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",z.SlowProviderWarning="task.slowProviderWarning",z.QuickOpenHistory="task.quickOpen.history",z.QuickOpenDetail="task.quickOpen.detail",z.QuickOpenSkip="task.quickOpen.skip",z.QuickOpenShowAll="task.quickOpen.showAll",z.AllowAutomaticTasks="task.allowAutomaticTasks",z.Reconnection="task.reconnection"})(O||(e.TaskSettingId=O={}));var F;(function(z){z.Tasks="tasks",z.SuppressTaskName="tasks.suppressTaskName",z.Windows="tasks.windows",z.Osx="tasks.osx",z.Linux="tasks.linux",z.ShowOutput="tasks.showOutput",z.IsShellCommand="tasks.isShellCommand",z.ServiceTestSetting="tasks.service.testSetting"})(F||(e.TasksSchemaProperties=F={}));var j;(function(z){function T(H,q){const me=m.$$F.get(H.type);if(me===void 0){const x=L.$Vm(H);return delete x._key,N.create(x)}const X=Object.create(null);X.type=me.taskType;const Z=new Set;me.required.forEach(x=>Z.add(x));const V=me.properties;for(const x of Object.keys(V)){const ge=H[x];if(ge!=null)X[x]=ge;else if(Z.has(x)){const ue=V[x];if(ue.default!==void 0)X[x]=L.$Vm(ue.default);else switch(ue.type){case"boolean":X[x]=!1;break;case"number":case"integer":X[x]=0;break;case"string":X[x]="";break;default:q.error(D.localize(2,null,JSON.stringify(H,void 0,0),x));return}}}return N.create(X)}z.createTaskIdentifier=T})(j||(e.TaskDefinition=j={}))}),define(Se[292],De([1,0,8]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z3b=e.$y3b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,m)=>{this.b=R,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,D.$Y)(R))}then(R,m){return this.j().then(R,m)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$y3b=M;class g extends M{constructor(){super(),this.h=!0,this.i=new D.$3}}e.$z3b=g}),define(Se[70],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dA=e.$cA=e.$bA=e.$aA=void 0;class D{static{this.count=0}constructor(k){this._proxyIdentifierBrand=void 0,this.sid=k,this.nid=++D.count}}e.$aA=D;const M=[];function g(m){const k=new D(m);return M[k.nid]=k,k}e.$bA=g;function L(m){return M[m].sid}e.$cA=L;class R{constructor(k){this.value=k}}e.$dA=R}),define(Se[6],De([1,0,70]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1J=e.$ZJ=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$YJ=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(v){v[v.Default=0]="Default",v[v.InCenter=1]="InCenter",v[v.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",v[v.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var g;(function(v){v[v.UnknownInput=0]="UnknownInput",v[v.TextInput=1]="TextInput",v[v.TextDiffInput=2]="TextDiffInput",v[v.TextMergeInput=3]="TextMergeInput",v[v.NotebookInput=4]="NotebookInput",v[v.NotebookDiffInput=5]="NotebookDiffInput",v[v.CustomEditorInput=6]="CustomEditorInput",v[v.WebviewEditorInput=7]="WebviewEditorInput",v[v.TerminalEditorInput=8]="TerminalEditorInput",v[v.InteractiveEditorInput=9]="InteractiveEditorInput"})(g||(e.TabInputKind=g={}));var L;(function(v){v[v.TAB_OPEN=0]="TAB_OPEN",v[v.TAB_CLOSE=1]="TAB_CLOSE",v[v.TAB_UPDATE=2]="TAB_UPDATE",v[v.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var R;(function(v){v[v.Editable=0]="Editable",v[v.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var m;(function(v){v[v.Int8Array=1]="Int8Array",v[v.Uint8Array=2]="Uint8Array",v[v.Uint8ClampedArray=3]="Uint8ClampedArray",v[v.Int16Array=4]="Int16Array",v[v.Uint16Array=5]="Uint16Array",v[v.Int32Array=6]="Int32Array",v[v.Uint32Array=7]="Uint32Array",v[v.Float32Array=8]="Float32Array",v[v.Float64Array=9]="Float64Array",v[v.BigInt64Array=10]="BigInt64Array",v[v.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var k;(function(v){v[v.Text=1]="Text",v[v.Error=2]="Error",v[v.Rich=3]="Rich"})(k||(e.CellOutputKind=k={}));var b;(function(v){v[v.Default=0]="Default",v[v.InCenter=1]="InCenter",v[v.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",v[v.AtTop=3]="AtTop"})(b||(e.NotebookEditorRevealType=b={}));var P;(function(v){v[v.None=0]="None",v[v.Process=1]="Process",v[v.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class I{static{this.a=0}static mixin(o){return o._id=I.a++,o}}e.$YJ=I;var p;(function(v){v.label="a",v.kind="b",v.detail="c",v.documentation="d",v.sortText="e",v.filterText="f",v.preselect="g",v.insertText="h",v.insertTextRules="i",v.range="j",v.commitCharacters="k",v.additionalTextEdits="l",v.kindModifier="m",v.commandIdent="n",v.commandId="o",v.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var S;(function(v){v.defaultRanges="a",v.completions="b",v.isIncomplete="c",v.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var C;(function(v){v[v.Workspace=0]="Workspace",v[v.TextDocument=1]="TextDocument"})(C||(e.ExtHostTestingResource=C={})),e.$ZJ={MainThreadAuthentication:(0,D.$bA)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$bA)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$bA)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,D.$bA)("MainThreadChatSlashCommands"),MainThreadChatAgents:(0,D.$bA)("MainThreadChatAgents"),MainThreadChatVariables:(0,D.$bA)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$bA)("MainThreadClipboard"),MainThreadCommands:(0,D.$bA)("MainThreadCommands"),MainThreadComments:(0,D.$bA)("MainThreadComments"),MainThreadConfiguration:(0,D.$bA)("MainThreadConfiguration"),MainThreadConsole:(0,D.$bA)("MainThreadConsole"),MainThreadDebugService:(0,D.$bA)("MainThreadDebugService"),MainThreadDecorations:(0,D.$bA)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$bA)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$bA)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$bA)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$bA)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$bA)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$bA)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$bA)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$bA)("MainThreadErrors"),MainThreadTreeViews:(0,D.$bA)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$bA)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$bA)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$bA)("MainThreadLanguages"),MainThreadLogger:(0,D.$bA)("MainThreadLogger"),MainThreadMessageService:(0,D.$bA)("MainThreadMessageService"),MainThreadOutputService:(0,D.$bA)("MainThreadOutputService"),MainThreadProgress:(0,D.$bA)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$bA)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$bA)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$bA)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$bA)("MainThreadSecretState"),MainThreadStorage:(0,D.$bA)("MainThreadStorage"),MainThreadTelemetry:(0,D.$bA)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$bA)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$bA)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$bA)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$bA)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$bA)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$bA)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$bA)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$bA)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$bA)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$bA)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.$bA)("MainThreadExtensionService"),MainThreadSCM:(0,D.$bA)("MainThreadSCM"),MainThreadSearch:(0,D.$bA)("MainThreadSearch"),MainThreadShare:(0,D.$bA)("MainThreadShare"),MainThreadTask:(0,D.$bA)("MainThreadTask"),MainThreadWindow:(0,D.$bA)("MainThreadWindow"),MainThreadLabelService:(0,D.$bA)("MainThreadLabelService"),MainThreadNotebook:(0,D.$bA)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$bA)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$bA)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$bA)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$bA)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$bA)("MainThreadInteractive"),MainThreadChat:(0,D.$bA)("MainThreadChat"),MainThreadInlineChat:(0,D.$bA)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$bA)("MainThreadTheming"),MainThreadTunnelService:(0,D.$bA)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$bA)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$bA)("MainThreadTimeline"),MainThreadTesting:(0,D.$bA)("MainThreadTesting"),MainThreadLocalization:(0,D.$bA)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$bA)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$bA)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$bA)("MainThreadIssueReporter")},e.$1J={ExtHostCommands:(0,D.$bA)("ExtHostCommands"),ExtHostConfiguration:(0,D.$bA)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$bA)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$bA)("ExtHostDebugService"),ExtHostDecorations:(0,D.$bA)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$bA)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$bA)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$bA)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$bA)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$bA)("ExtHostEditors"),ExtHostTreeViews:(0,D.$bA)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$bA)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$bA)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$bA)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$bA)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$bA)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$bA)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$bA)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$bA)("ExtHostStatusBar"),ExtHostShare:(0,D.$bA)("ExtHostShare"),ExtHostExtensionService:(0,D.$bA)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$bA)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$bA)("ExtHostTerminalService"),ExtHostSCM:(0,D.$bA)("ExtHostSCM"),ExtHostSearch:(0,D.$bA)("ExtHostSearch"),ExtHostTask:(0,D.$bA)("ExtHostTask"),ExtHostWorkspace:(0,D.$bA)("ExtHostWorkspace"),ExtHostWindow:(0,D.$bA)("ExtHostWindow"),ExtHostWebviews:(0,D.$bA)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$bA)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$bA)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$bA)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$bA)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$bA)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$bA)("ExtHostProgress"),ExtHostComments:(0,D.$bA)("ExtHostComments"),ExtHostSecretState:(0,D.$bA)("ExtHostSecretState"),ExtHostStorage:(0,D.$bA)("ExtHostStorage"),ExtHostUrls:(0,D.$bA)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$bA)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$bA)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$bA)("ExtHostOutputService"),ExtHosLabelService:(0,D.$bA)("ExtHostLabelService"),ExtHostNotebook:(0,D.$bA)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$bA)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$bA)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$bA)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$bA)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$bA)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$bA)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$bA)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$bA)("ExtHostChat"),ExtHostChatSlashCommands:(0,D.$bA)("ExtHostChatSlashCommands"),ExtHostChatAgents:(0,D.$bA)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$bA)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$bA)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,D.$bA)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$bA)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$bA)("ExtHostTheming"),ExtHostTunnelService:(0,D.$bA)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$bA)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$bA)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$bA)("ExtHostTimeline"),ExtHostTesting:(0,D.$bA)("ExtHostTesting"),ExtHostTelemetry:(0,D.$bA)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$bA)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$bA)("ExtHostIssueReporter")}}),define(Se[293],De([1,0,6,7]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=void 0;class g{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(D.$ZJ.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,m,k){if(this.a.size===0)throw new Error("No related information providers registered");const b=this.a.get(R);if(!b)throw new Error("related information provider not found");return await b.provideRelatedInformation(m,k)??[]}getRelatedInformation(R,m,k){return this.c.$getAiRelatedInformation(m,k)}registerRelatedInformationProvider(R,m,k){const b=this.b;return this.b++,this.a.set(b,k),this.c.$registerAiRelatedInformationProvider(b,m),new M.$2J(()=>{this.c.$unregisterAiRelatedInformationProvider(b),this.a.delete(b)})}}e.$4cc=g}),define(Se[90],De([1,0,5,14,6,20]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ac=e.$7ac=e.$6ac=void 0,e.$6ac=(0,D.$Bh)("IExtHostApiDeprecationService");let R=class{constructor(k,b){this.c=b,this.a=new Set,this.b=k.getProxy(g.$ZJ.MainThreadTelemetry)}report(k,b,P){const I=this.d(k,b);this.a.has(I)||(this.a.add(I),b.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${k}' is deprecated. ${P}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:b.identifier.value,apiId:k}))}d(k,b){return`${k}-${b.identifier.value}`}};e.$7ac=R,e.$7ac=R=Ke([Be(0,L.$2L),Be(1,M.$5i)],R),e.$8ac=Object.freeze(new class{report(m,k,b){}})}),define(Se[294],De([1,0,4,6,7,25]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0;class R{constructor(b){this.b=new Map,this.c=[],this.d=new D.$fd,this.onDidChangeSessions=this.d.event,this.f=new m,this.g=new m,this.a=b.getProxy(M.$ZJ.MainThreadAuthentication)}$setProviders(b){return this.c=b,Promise.resolve()}async getSession(b,P,I,p={}){const S=L.$Vl.toKey(b.identifier),C=[...I].sort().join(" ");return await this.f.getOrCreate(`${S} ${P} ${C}`,async()=>{await this.a.$ensureProvider(P);const v=b.displayName||b.name;return this.a.$getSession(P,I,S,v,p)})}async getSessions(b,P,I){const p=L.$Vl.toKey(b.identifier),S=[...I].sort().join(" ");return await this.g.getOrCreate(`${p} ${S}`,async()=>{await this.a.$ensureProvider(P);const C=b.displayName||b.name;return this.a.$getSessions(P,I,p,C)})}async removeSession(b,P){const I=this.b.get(b);return I?I.provider.removeSession(P):this.a.$removeSession(b,P)}registerAuthenticationProvider(b,P,I,p){if(this.b.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this.b.set(b,{label:P,provider:I,options:p??{supportsMultipleAccounts:!1}}),this.c.find(C=>C.id===b)||this.c.push({id:b,label:P});const S=I.onDidChangeSessions(C=>{this.a.$sendDidChangeSessions(b,{added:C.added??[],changed:C.changed??[],removed:C.removed??[]})});return this.a.$registerAuthenticationProvider(b,P,p?.supportsMultipleAccounts??!1),new g.$2J(()=>{S.dispose(),this.b.delete(b);const C=this.c.findIndex(v=>v.id===b);C>-1&&this.c.splice(C),this.a.$unregisterAuthenticationProvider(b)})}$createSession(b,P,I){const p=this.b.get(b);if(p)return Promise.resolve(p.provider.createSession(P,I));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,P){const I=this.b.get(b);if(I)return Promise.resolve(I.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,P){const I=this.b.get(b);if(I)return Promise.resolve(I.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,P){return this.d.fire({provider:{id:b,label:P}}),Promise.resolve()}}e.$Bcc=R;class m{constructor(){this.a=new Map}getOrCreate(b,P){const I=this.a.get(b);if(I)return I;const p=P().finally(()=>this.a.delete(b));return this.a.set(b,p),p}}}),define(Se[295],De([1,0,6,20,13]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=void 0;let L=class{constructor(m,k){this.a=m.getProxy(D.$ZJ.MainThreadBulkEdits),this.b={getTextDocumentVersion:b=>k.getDocument(b)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,k,b){const P=g.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(P,void 0,b?.isRefactoring??!1)}};e.$Hcc=L,e.$Hcc=L=Ke([Be(0,M.$2L)],L)}),define(Se[296],De([1,0,9,4,50,3,37,202,6,13]),function($e,e,D,M,g,L,R,m,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=void 0;class P{static{this.a=0}constructor(S,C){this.extension=S,this.provider=C,this.handle=P.a++}}class I{static{this.a=0}constructor(S,C){this.h=C,this.b=new Map,this.d=new Map,this.e=new M.$fd,this.onDidPerformUserAction=this.e.event,this.g=S.getProxy(k.$ZJ.MainThreadChat)}registerChatProvider(S,C,v){const o=new P(S,v);return this.b.set(o.handle,o),this.g.$registerChatProvider(o.handle,C),(0,L.$ic)(()=>{this.g.$unregisterChatProvider(o.handle),this.b.delete(o.handle)})}transferChatSession(S,C){const v=g.Iterable.find(this.d.keys(),o=>this.d.get(o)===S)??0;typeof v=="number"&&this.g.$transferChatSession(v,C)}addChatRequest(S){this.g.$addRequest(S)}sendInteractiveRequestToProvider(S,C){this.g.$sendRequestToProvider(S,C)}async $prepareChat(S,C,v){const o=this.b.get(S);if(!o)return;const s=await o.provider.prepareSession(C,v);if(!s)return;const n=I.a++;return this.d.set(n,s),{id:n,requesterUsername:s.requester?.name,requesterAvatarIconUri:s.requester?.icon,responderUsername:s.responder?.name,responderAvatarIconUri:s.responder?.icon,inputPlaceholder:s.inputPlaceholder}}async $resolveRequest(S,C,v,o){const s=this.b.get(S);if(!s)return;const n=this.d.get(C);if(!n||!s.provider.resolveRequest)return;const h=await s.provider.resolveRequest(n,v,o);if(h)return{message:typeof h.message=="string"?h.message:b.ChatReplyFollowup.from(h.message)}}async $provideWelcomeMessage(S,C){const v=this.b.get(S);if(!v||!v.provider.provideWelcomeMessage)return;const o=await v.provider.provideWelcomeMessage(C);if(o)return o.map(s=>typeof s=="string"?s:s.map(n=>b.ChatReplyFollowup.from(n)))}async $provideFollowups(S,C,v){const o=this.b.get(S);if(!o)return;const s=this.d.get(C);return!s||!o.provider.provideFollowups?void 0:(await o.provider.provideFollowups(s,v))?.map(h=>b.ChatFollowup.from(h))}$removeRequest(S,C,v){const o=this.b.get(S);if(!o)return;const s=this.d.get(C);s&&o.provider.removeRequest&&o.provider.removeRequest(s,v)}async $provideReply(S,C,v,o){const s=this.b.get(S);if(!s)return;const n=this.d.get(C);if(!n)return;const h={session:n,message:typeof v.message=="string"?v.message:b.ChatReplyFollowup.to(v.message),variables:{}};if(v.variables)for(const i of Object.keys(v.variables))h.variables[i]=v.variables[i].map(b.ChatVariable.to);const $=R.$bd.create(!1);let d;const t={report:i=>{if(!o.isCancellationRequested)if(typeof d>"u"&&(d=$.elapsed()),"responseId"in i)this.g.$acceptResponseProgress(S,C,{requestId:i.responseId});else if("placeholder"in i&&"resolvedContent"in i){const c=Promise.all([this.g.$acceptResponseProgress(S,C,{placeholder:i.placeholder}),i.resolvedContent]);(0,D.$vg)(c,o).then(f=>{if(!f)return;const[y,E]=f;this.g.$acceptResponseProgress(S,C,E,y??void 0)})}else"content"in i?this.g.$acceptResponseProgress(S,C,{content:typeof i.content=="string"?i.content:b.MarkdownString.from(i.content)}):this.g.$acceptResponseProgress(S,C,i)}};let r;try{r=await s.provider.provideResponseWithProgress(h,t,o),r||(r={errorDetails:{message:(0,m.localize)(0,null)}})}catch(i){r={errorDetails:{message:(0,m.localize)(1,null,i.message),responseIsIncomplete:!0}},this.h.error(i)}try{if(n.saveState&&this.d.has(C)){const i=n.saveState();this.g.$acceptChatState(C,i)}}catch(i){this.h.warn(i)}const a={firstProgress:d??0,totalElapsed:$.elapsed()};return{errorDetails:r.errorDetails,timings:a}}async $provideSlashCommands(S,C,v){const o=this.b.get(S);if(!o)return;const s=this.d.get(C);return!s||!o.provider.provideSlashCommands?void 0:(await o.provider.provideSlashCommands(s,v))?.map(h=>({...h,kind:b.CompletionItemKind.from(h.kind)}))}$releaseSession(S){this.d.delete(S)}async $onDidPerformUserAction(S){this.e.fire(S)}}e.$Vcc=I}),define(Se[297],De([1,0,9,3,65,6,13,7]),function($e,e,D,M,g,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=void 0;class k{static{this.a=0}constructor(I,p,S){this.d=p,this.e=S,this.b=new Map,this.c=I.getProxy(L.$ZJ.MainThreadChatAgents)}registerAgent(I,p,S,C){const v=k.a++;return this.b.set(v,{extension:I,agent:S}),this.c.$registerAgent(v,p,C),(0,M.$ic)(()=>{this.c.$unregisterAgent(v),this.b.delete(v)})}async $invokeAgent(I,p,S,C,v){const o=this.b.get(I);if(!o){this.e.warn(`[CHAT](${I}) CANNOT invoke agent because the agent is not registered`);return}let s=!1;function n(){if(s)throw new Error("Only valid while executing the command")}const h=new D.$2g;v.onCancellationRequested(()=>h.complete()),setTimeout(()=>h.complete(),3*1e3),this.d.allowListExtensionWhile(o.extension,h.p);const $=o.agent({role:m.ChatMessageRole.User,content:S},{history:C.history.map(R.ChatMessage.to)},new g.$4u(d=>{n(),this.c.$handleProgressChunk(p,{content:b(d.message)?d.message:d.message.value})}),v);try{return await(0,D.$vg)(Promise.resolve($).then(d=>{if(d&&"followUp"in d)return{followUp:d?.followUp?.map(r=>R.ChatFollowup.from(r))}}),v)}finally{s=!0,h.complete()}}}e.$6cc=k;function b(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(Se[298],De([1,0,3,6,13,65,25]),function($e,e,D,M,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=void 0;class m{static{this.a=1}constructor(b,P){this.d=P,this.c=new Map,this.e=new Map,this.f=new R.$Xl,this.b=b.getProxy(M.$ZJ.MainThreadChatProvider)}registerProvider(b,P,I,p){const S=m.a++;return this.c.set(S,{extension:b,provider:I}),this.b.$registerProvider(S,P,{extension:b,displayName:p.name??b.value}),(0,D.$ic)(()=>{this.b.$unregisterProvider(S),this.c.delete(S)})}async $provideChatResponse(b,P,I,p,S){const C=this.c.get(b);if(!C)return;const v=new L.$4u(async o=>{if(S.isCancellationRequested){this.d.warn(`[CHAT](${C.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(P,{index:o.index,part:o.part})},{async:!0});return C.provider.provideChatResponse(I.map(g.ChatMessage.to),p,v,S)}allowListExtensionWhile(b,P){this.f.set(b,P),P.finally(()=>this.f.delete(b))}async requestChatResponseProvider(b,P){if(!this.f.has(b))throw new Error("Extension is NOT allowed to make chat requests");const I=this;return{get isRevoked(){return!I.f.has(b)},async makeRequest(p,S,C,v){if(!I.f.has(b))throw new Error("Access to chat has been revoked");const o=Math.random()*1e6|0;I.e.set(o,C);try{await I.b.$fetchResponse(b,P,o,p.map(g.ChatMessage.from),S,v)}finally{I.e.delete(o)}}}}async $handleResponseFragment(b,P){this.e.get(b)?.report(P)}}e.$1cc=m}),define(Se[299],De([1,0,3,6,7,13,65,9]),function($e,e,D,M,g,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=void 0;class k{static{this.a=0}constructor(I,p,S){this.d=p,this.e=S,this.b=new Map,this.c=I.getProxy(M.$ZJ.MainThreadChatSlashCommands)}registerCommand(I,p,S,C){const v=k.a++;return this.b.set(v,{extension:I,command:S}),this.c.$registerCommand(v,p,C.description),(0,D.$ic)(()=>{this.c.$unregisterCommand(v),this.b.delete(v)})}async $executeCommand(I,p,S,C,v){const o=this.b.get(I);if(!o){this.e.warn(`[CHAT](${I}) CANNOT execute command because the command is not registered`);return}let s=!1;function n(){if(s)throw new Error("Only valid while executing the command")}const h=new m.$2g;v.onCancellationRequested(()=>h.complete()),setTimeout(()=>h.complete(),3*1e3),this.d.allowListExtensionWhile(o.extension,h.p);const $=o.command({role:g.ChatMessageRole.User,content:S},{history:C.history.map(L.ChatMessage.to)},new R.$4u(d=>{n(),this.c.$handleProgressChunk(p,{content:b(d.message)?d.message:d.message.value})}),v);try{return await(0,m.$vg)(Promise.resolve($).then(d=>{if(d&&"followUp"in d)return{followUp:d?.followUp?.map(r=>L.ChatFollowup.from(r))}}),v)}finally{s=!0,h.complete()}}}e.$2cc=k;function b(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(Se[300],De([1,0,3,6,8,13]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=void 0;class R{static{this.a=0}constructor(k){this.b=new Map,this.c=k.getProxy(M.$ZJ.MainThreadChatVariables)}async $resolveVariable(k,b,P){const I=this.b.get(k);if(I)try{const p=await I.resolver.resolve(I.data.name,{message:b},P);if(p)return p.map(L.ChatVariable.from)}catch(p){(0,g.$Z)(p)}}registerVariableResolver(k,b,P,I){const p=R.a++;return this.b.set(p,{extension:k.identifier,data:{name:b,description:P},resolver:I}),this.c.$registerVariable(p,{name:b,description:P}),(0,D.$ic)(()=>{this.b.delete(p),this.c.$unregisterVariable(p)})}}e.$3cc=R}),define(Se[301],De([1,0,6]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ac=void 0;class M{constructor(L){const R=L.getProxy(D.$ZJ.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(m){return R.$writeText(m)}})}}e.$$ac=M}),define(Se[33],De([1,0,18,7,13,23,6,19,14,63,34,62,2,3,5,20,145,22,70,46,37,85,89]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o,s,n,h,$,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=void 0;let r=class{#e;#t;#i;constructor(E,u,l){this.b=new Map,this.c=new Map,this.#e=E.getProxy(R.$ZJ.MainThreadCommands),this.d=u,this.#i=l,this.#t=E.getProxy(R.$ZJ.MainThreadTelemetry),this.converter=new a(this,w=>{const A=this.c.get(w);return A?.result===c.Void?A:void 0},u),this.f=[{processArgument(w){return(0,b.$$g)(w)}},{processArgument(w){return(0,L.$Xm)(w,function(A){if(P.$ks.isIRange(A))return g.Range.to(A);if(I.$js.isIPosition(A))return g.Position.to(A);if(P.$ks.isIRange(A.range)&&p.URI.isUri(A.uri))return g.location.to(A);if(A instanceof s.$Fd)return A.buffer.buffer;if(!Array.isArray(A))return A})}}]}registerArgumentProcessor(E){this.f.push(E)}registerApiCommand(E){const u=this.registerCommand(!1,E.id,async(...l)=>{const w=E.args.map((N,O)=>{if(!N.validate(l[O]))throw new Error(`Invalid argument '${N.name}' when running '${E.id}', received: ${l[O]}`);return N.convert(l[O])}),A=await this.executeCommand(E.internalId,...w);return E.result.convert(A,l,this.converter)},void 0,{description:E.description,args:E.args,returns:E.result.description});return this.c.set(E.id,E),new M.$2J(()=>{u.dispose(),this.c.delete(E.id)})}registerCommand(E,u,l,w,A,N){if(this.d.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this.b.has(u))throw new Error(`command '${u}' already exists`);return this.b.set(u,{callback:l,thisArg:w,description:A,extension:N}),E&&this.#e.$registerCommand(u),new M.$2J(()=>{this.b.delete(u)&&E&&this.#e.$unregisterCommand(u)})}executeCommand(E,...u){return this.d.trace("ExtHostCommands#executeCommand",E),this.g(E,u,!0)}async g(E,u,l){if(this.b.has(E))return this.#e.$fireCommandActivationEvent(E),this.h(E,u,!1);{let w=!1;const A=(0,L.$Xm)(u,function(N){if(N instanceof M.$3J)return g.Position.from(N);if(N instanceof M.$4J)return g.Range.from(N);if(N instanceof M.$bK)return g.location.from(N);if(M.$nL.isNotebookRange(N))return g.NotebookRange.from(N);if(N instanceof ArrayBuffer)return w=!0,s.$Fd.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return w=!0,s.$Fd.wrap(N);if(N instanceof s.$Fd)return w=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(E,w?new n.$dA(A):A,l);return(0,b.$$g)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(E,u,!1);throw N}}}async h(E,u,l){const w=this.b.get(E);if(!w)throw new Error("Unknown command");const{callback:A,thisArg:N,description:O}=w;if(O)for(let j=0;j<O.args.length;j++)try{(0,D.$Af)(u[j],O.args[j].constraint)}catch{throw new Error(`Running the contributed command: '${E}' failed. Illegal argument '${O.args[j].name}' - ${O.args[j].description}`)}const F=$.$bd.create();try{return await A.apply(N,u)}catch(j){if(E===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...u);z&&(E=z.command)}if(this.d.error(j,E,w.extension?.identifier),!l)throw j;if(w.extension?.identifier){const z=this.#i.onExtensionError(w.extension.identifier,j);this.d.trace("forwarded error to extension?",z,w.extension?.identifier)}throw new class extends Error{constructor(){super((0,h.$mi)(j)),this.id=E,this.source=w.extension?.displayName??w.extension?.name}}}finally{this.j(w,E,F.elapsed())}}j(E,u,l){E.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:E.extension.identifier.value,id:new d.$_n(u),duration:l})}$executeContributedCommand(E,...u){this.d.trace("ExtHostCommands#$executeContributedCommand",E);const l=this.b.get(E);return l?(u=u.map(w=>this.f.reduce((A,N)=>N.processArgument(A,l.extension?.identifier),w)),this.h(E,u,!0)):Promise.reject(new Error(`Contributed command '${E}' does not exist.`))}getCommands(E=!1){return this.d.trace("ExtHostCommands#getCommands",E),this.#e.$getCommands().then(u=>(E&&(u=u.filter(l=>l[0]!=="_")),u))}$getContributedCommandHandlerDescriptions(){const E=Object.create(null);for(const[u,l]of this.b){const{description:w}=l;w&&(E[u]=w)}return Promise.resolve(E)}};e.$kM=r,e.$kM=r=Ke([Be(0,v.$2L),Be(1,k.$5i),Be(2,t.$jM)],r),e.$lM=(0,C.$Bh)("IExtHostCommands");class a{constructor(E,u,l){this.d=E,this.f=u,this.g=l,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(E,u){if(!E)return;const l={$ident:void 0,id:E.command,title:E.title,tooltip:E.tooltip};if(!E.command)return l;const w=this.f(E.command);if(w)l.id=w.internalId,l.arguments=w.args.map((A,N)=>A.convert(E.arguments&&E.arguments[N]));else if((0,m.$Jb)(E.arguments)){const A=`${E.command}/${++this.c}`;this.b.set(A,E),u.add((0,S.$ic)(()=>{this.b.delete(A),this.g.trace("CommandsConverter#DISPOSE",A)})),l.$ident=A,l.id=this.delegatingCommandId,l.arguments=[A],this.g.trace("CommandsConverter#CREATE",E.command,A)}return l}fromInternal(E){return typeof E.$ident=="string"?this.b.get(E.$ident):{command:E.id,title:E.title,arguments:E.arguments}}getActualCommand(...E){return this.b.get(E[0])}h(...E){const u=this.getActualCommand(...E);return this.g.trace("CommandsConverter#EXECUTE",E[0],u?u.command:"MISSING"),u?this.d.executeCommand(u.command,...u.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${E[0]}`)}}e.$mM=a;class i{static{this.Uri=new i("uri","Uri of a text document",E=>p.URI.isUri(E),E=>E)}static{this.Position=new i("position","A position in a text document",E=>M.$3J.isPosition(E),g.Position.from)}static{this.Range=new i("range","A range in a text document",E=>M.$4J.isRange(E),g.Range.from)}static{this.Selection=new i("selection","A selection in a text document",E=>M.$5J.isSelection(E),g.Selection.from)}static{this.Number=new i("number","",E=>typeof E=="number",E=>E)}static{this.String=new i("string","",E=>typeof E=="string",E=>E)}static{this.StringArray=i.Arr(i.String)}static Arr(E){return new i(`${E.name}_array`,`Array of ${E.name}, ${E.description}`,u=>Array.isArray(u)&&u.every(l=>E.validate(l)),u=>u.map(l=>E.convert(l)))}static{this.CallHierarchyItem=new i("item","A call hierarchy item",E=>E instanceof M.$mK,g.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new i("item","A type hierarchy item",E=>E instanceof M.$GL,g.TypeHierarchyItem.from)}static{this.TestItem=new i("testItem","A VS Code TestItem",E=>E instanceof o.$cM,g.TestItem.from)}constructor(E,u,l,w){this.name=E,this.description=u,this.validate=l,this.convert=w}optional(){return new i(this.name,`(optional) ${this.description}`,E=>E==null||this.validate(E),E=>E===void 0?void 0:E===null?null:this.convert(E))}with(E,u){return new i(E??this.name,u??this.description,this.validate,this.convert)}}e.$nM=i;class c{static{this.Void=new c("no result",E=>E)}constructor(E,u){this.description=E,this.convert=u}}e.$oM=c;class f{constructor(E,u,l,w,A){this.id=E,this.internalId=u,this.description=l,this.args=w,this.result=A}}e.$pM=f}),define(Se[302],De([1,0,19,17,2,83,129,41,134,33,13,7]),function($e,e,D,M,g,L,R,m,k,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ac=void 0;const p=[new b.$pM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[b.$nM.Uri,b.$nM.Position],new b.$oM("A promise that resolves to an array of DocumentHighlight-instances.",C(P.DocumentHighlight.to))),new b.$pM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[b.$nM.Uri],new b.$oM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(o,s)=>{if((0,D.$Ib)(o))return;class n extends I.$gK{static to($){const d=new n($.name,P.SymbolKind.to($.kind),$.containerName||"",new I.$bK(s[0],P.Range.to($.range)));return d.detail=$.detail,d.range=d.location.range,d.selectionRange=P.Range.to($.selectionRange),d.children=$.children?$.children.map(n.to):[],d}}return o.map(n.to)})),new b.$pM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[b.$nM.Uri,new b.$nM("options","Formatting options",o=>!0,o=>o)],new b.$oM("A promise that resolves to an array of TextEdits.",C(P.TextEdit.to))),new b.$pM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[b.$nM.Uri,b.$nM.Range,new b.$nM("options","Formatting options",o=>!0,o=>o)],new b.$oM("A promise that resolves to an array of TextEdits.",C(P.TextEdit.to))),new b.$pM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[b.$nM.Uri,b.$nM.Position,new b.$nM("ch","Trigger character",o=>typeof o=="string",o=>o),new b.$nM("options","Formatting options",o=>!0,o=>o)],new b.$oM("A promise that resolves to an array of TextEdits.",C(P.TextEdit.to))),new b.$pM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[b.$nM.Uri,b.$nM.Position],new b.$oM("A promise that resolves to an array of Location or LocationLink instances.",v)),new b.$pM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[b.$nM.Uri,b.$nM.Position],new b.$oM("A promise that resolves to an array of Location or LocationLink instances.",v)),new b.$pM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[b.$nM.Uri,b.$nM.Position],new b.$oM("A promise that resolves to an array of Location or LocationLink instances.",v)),new b.$pM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[b.$nM.Uri,b.$nM.Position],new b.$oM("A promise that resolves to an array of Location or LocationLink instances.",v)),new b.$pM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[b.$nM.Uri,b.$nM.Position],new b.$oM("A promise that resolves to an array of Location-instances.",C(P.location.to))),new b.$pM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[b.$nM.Uri,b.$nM.Position],new b.$oM("A promise that resolves to an array of Hover-instances.",C(P.Hover.to))),new b.$pM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[b.$nM.Uri,new b.$nM("position","A position in a text document",o=>Array.isArray(o)&&o.every(s=>I.$3J.isPosition(s)),o=>o.map(P.Position.from))],new b.$oM("A promise that resolves to an array of ranges.",o=>o.map(s=>{let n;for(const h of s.reverse())n=new I.$lK(P.Range.to(h),n);return n}))),new b.$pM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[b.$nM.String.with("query","Search string")],new b.$oM("A promise that resolves to an array of SymbolInformation-instances.",o=>o.map(P.WorkspaceSymbol.to))),new b.$pM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[b.$nM.Uri,b.$nM.Position],new b.$oM("A promise that resolves to an array of CallHierarchyItem-instances",o=>o.map(P.CallHierarchyItem.to))),new b.$pM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[b.$nM.CallHierarchyItem],new b.$oM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",o=>o.map(P.CallHierarchyIncomingCall.to))),new b.$pM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[b.$nM.CallHierarchyItem],new b.$oM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",o=>o.map(P.CallHierarchyOutgoingCall.to))),new b.$pM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[b.$nM.Uri,b.$nM.Position],new b.$oM("A promise that resolves to a range and placeholder text.",o=>{if(o)return{range:P.Range.to(o.range),placeholder:o.text}})),new b.$pM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[b.$nM.Uri,b.$nM.Position,b.$nM.String.with("newName","The new symbol name")],new b.$oM("A promise that resolves to a WorkspaceEdit.",o=>{if(o){if(o.rejectReason)throw new Error(o.rejectReason);return P.WorkspaceEdit.to(o)}})),new b.$pM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[b.$nM.Uri,b.$nM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new b.$oM("A promise that resolves to an array of DocumentLink-instances.",o=>o.map(P.DocumentLink.to))),new b.$pM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[b.$nM.Uri],new b.$oM("A promise that resolves to SemanticTokensLegend.",o=>{if(o)return new I.$fL(o.tokenTypes,o.tokenModifiers)})),new b.$pM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[b.$nM.Uri],new b.$oM("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const s=(0,R.$u0)(o);if(s.type==="full")return new I.$hL(s.data,void 0)})),new b.$pM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[b.$nM.Uri,b.$nM.Range.optional()],new b.$oM("A promise that resolves to SemanticTokensLegend.",o=>{if(o)return new I.$fL(o.tokenTypes,o.tokenModifiers)})),new b.$pM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[b.$nM.Uri,b.$nM.Range],new b.$oM("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const s=(0,R.$u0)(o);if(s.type==="full")return new I.$hL(s.data,void 0)})),new b.$pM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[b.$nM.Uri,b.$nM.Position,b.$nM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),b.$nM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new b.$oM("A promise that resolves to a CompletionList-instance.",(o,s,n)=>{if(!o)return new I.$xK([]);const h=o.suggestions.map($=>P.CompletionItem.to($,n));return new I.$xK(h,o.incomplete)})),new b.$pM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[b.$nM.Uri,b.$nM.Position,b.$nM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new b.$oM("A promise that resolves to SignatureHelp.",o=>{if(o)return P.SignatureHelp.to(o)})),new b.$pM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[b.$nM.Uri,b.$nM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new b.$oM("A promise that resolves to an array of CodeLens-instances.",(o,s,n)=>C(h=>new I.$pK(P.Range.to(h.range),h.command&&n.fromInternal(h.command)))(o))),new b.$pM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[b.$nM.Uri,new b.$nM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",o=>I.$4J.isRange(o),o=>I.$5J.isSelection(o)?P.Selection.from(o):P.Range.from(o)),b.$nM.String.with("kind","Code action kind to return code actions for").optional(),b.$nM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new b.$oM("A promise that resolves to an array of Command-instances.",(o,s,n)=>C(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return n.fromInternal(h.command)}else{const $=new I.$iK(h.title,h.kind?new I.$jK(h.kind):void 0);return h.edit&&($.edit=P.WorkspaceEdit.to(h.edit)),h.command&&($.command=n.fromInternal(h.command)),$.isPreferred=h.isPreferred,$}})(o))),new b.$pM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[b.$nM.Uri],new b.$oM("A promise that resolves to an array of ColorInformation objects.",o=>o?o.map(s=>new I.$DK(P.Range.to(s.range),P.Color.to(s.color))):[])),new b.$pM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new b.$nM("color","The color to show and insert",o=>o instanceof I.$CK,P.Color.from),new b.$nM("context","Context object with uri and range",o=>!0,o=>({uri:o.uri,range:P.Range.from(o.range)}))],new b.$oM("A promise that resolves to an array of ColorPresentation objects.",o=>o?o.map(P.ColorPresentation.to):[])),new b.$pM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[b.$nM.Uri,b.$nM.Range],new b.$oM("A promise that resolves to an array of Inlay objects",(o,s,n)=>o.map(P.InlayHint.to.bind(void 0,n)))),new b.$pM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[b.$nM.Uri],new b.$oM("A promise that resolves to an array of FoldingRange objects",(o,s)=>{if(o)return o.map(P.FoldingRange.to)})),new b.$pM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new b.$oM("A promise that resolves to an array of NotebookContentProvider static info objects.",C(o=>({viewType:o.viewType,displayName:o.displayName,options:{transientOutputs:o.options.transientOutputs,transientCellMetadata:o.options.transientCellMetadata,transientDocumentMetadata:o.options.transientDocumentMetadata},filenamePattern:o.filenamePattern.map(s=>P.NotebookExclusiveDocumentPattern.to(s))})))),new b.$pM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[b.$nM.Uri,b.$nM.Range,new b.$nM("context","An InlineValueContext",o=>o&&typeof o.frameId=="number"&&o.stoppedLocation instanceof I.$4J,o=>P.InlineValueContext.from(o))],new b.$oM("A promise that resolves to an array of InlineValue objects",o=>o.map(P.InlineValue.to))),new b.$pM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new b.$nM("uriOrString","Uri-instance or string (only http/https)",o=>g.URI.isUri(o)||typeof o=="string"&&(0,k.$NT)(o,M.Schemas.http,M.Schemas.https),o=>o),new b.$nM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[P.ViewColumn.from(o),void 0]:[P.ViewColumn.from(o.viewColumn),P.TextEditorOpenOptions.from(o)])).optional(),b.$nM.String.with("label","").optional()],b.$oM.Void),new b.$pM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[b.$nM.Uri.with("resource","Resource to open"),b.$nM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new b.$nM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[P.ViewColumn.from(o),void 0]:[P.ViewColumn.from(o.viewColumn),P.TextEditorOpenOptions.from(o)])).optional()],b.$oM.Void),new b.$pM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[b.$nM.Uri.with("left","Left-hand side resource of the diff editor"),b.$nM.Uri.with("right","Right-hand side resource of the diff editor"),b.$nM.String.with("title","Human readable title for the diff editor").optional(),new b.$nM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="object",o=>o&&[P.ViewColumn.from(o.viewColumn),P.TextEditorOpenOptions.from(o)]).optional()],b.$oM.Void),new b.$pM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[b.$nM.Uri,b.$nM.Position],new b.$oM("A promise that resolves to an array of TypeHierarchyItem-instances",o=>o.map(P.TypeHierarchyItem.to))),new b.$pM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[b.$nM.TypeHierarchyItem],new b.$oM("A promise that resolves to an array of TypeHierarchyItem-instances",o=>o.map(P.TypeHierarchyItem.to))),new b.$pM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[b.$nM.TypeHierarchyItem],new b.$oM("A promise that resolves to an array of TypeHierarchyItem-instances",o=>o.map(P.TypeHierarchyItem.to))),new b.$pM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[b.$nM.TestItem],b.$oM.Void),new b.$pM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[b.$nM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],b.$oM.Void),new b.$pM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[b.$nM.String.with("name","The context key name"),new b.$nM("value","The context key value",()=>!0,o=>o)],b.$oM.Void),new b.$pM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[b.$nM.Uri,b.$nM.StringArray,new b.$nM("MappedEditsContext","Mapped Edits Context",o=>P.MappedEditsContext.is(o),o=>P.MappedEditsContext.from(o))],new b.$oM("A promise that resolves to a workspace edit or null",o=>o?P.WorkspaceEdit.to(o):null))];class S{static register(s){p.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",m.$Ji)}}e.$0ac=S;function C(o){return s=>{if(Array.isArray(s))return s.map(o)}}function v(o){if(!Array.isArray(o))return;const s=[];for(const n of o)L.$8s(n)?s.push(P.DefinitionLink.to(n)):s.push(P.location.to(n));return s}}),define(Se[303],De([1,0,9,57,4,3,2,83,25,13,7,6,27]),function($e,e,D,M,g,L,R,m,k,b,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ac=void 0;function S(C,v,o){const s=C.getProxy(I.$ZJ.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new k.$Xl,v.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const y=this.b.get(f.handle);return y?y.value:f}else if(f&&f.$mid===7){const y=this.b.get(f.commentControlHandle);if(!y)return f;const E=y.getCommentThread(f.commentThreadHandle);return E?E.value:f}else if(f&&(f.$mid===9||f.$mid===8)){const y=this.b.get(f.thread.commentControlHandle);if(!y)return f;const E=y.getCommentThread(f.thread.commentThreadHandle);return E?f.$mid===8?E.value:{thread:E.value,text:f.text}:f}else if(f&&f.$mid===10){const y=this.b.get(f.thread.commentControlHandle);if(!y)return f;const E=y.getCommentThread(f.thread.commentThreadHandle);if(!E)return f;const u=f.commentUniqueId,l=E.getCommentByUniqueId(u);return l||f}else if(f&&f.$mid===11){const y=this.b.get(f.thread.commentControlHandle);if(!y)return f;const E=y.getCommentThread(f.thread.commentThreadHandle);if(!E)return f;const u=f.text,l=f.commentUniqueId,w=E.getCommentByUniqueId(l);return w?(typeof w.body=="string"?w.body=u:w.body=new P.$qK(u),w):f}return f}})}createCommentController(f,y,E){const u=n.a++,l=new $(f,u,y,E);this.b.set(l.handle,l);const w=this.c.get(f.identifier)||[];return w.push(l),this.c.set(f.identifier,w),l.value}$createCommentThreadTemplate(f,y,E){const u=this.b.get(f);u&&u.$createCommentThreadTemplate(y,E)}async $updateCommentThreadTemplate(f,y,E){const u=this.b.get(f);u&&u.$updateCommentThreadTemplate(y,E)}$deleteCommentThread(f,y){this.b.get(f)?.$deleteCommentThread(y)}$provideCommentingRanges(f,y,E){const u=this.b.get(f);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const l=o.getDocument(R.URI.revive(y));return(0,D.$zg)(async()=>{const w=await u.commentingRangeProvider.provideCommentingRanges(l,E);let A;return Array.isArray(w)?A={ranges:w,fileComments:!1}:w?A={ranges:w.ranges||[],fileComments:w.fileComments||!1}:A=w??void 0,A}).then(w=>{let A;return w&&(A={ranges:w.ranges.map(N=>b.Range.from(N)),fileComments:w.fileComments}),A})}$toggleReaction(f,y,E,u,l){const w=this.b.get(f);return!w||!w.reactionHandler?Promise.resolve(void 0):(0,D.$zg)(()=>{const A=w.getCommentThread(y);if(A){const N=A.getCommentByUniqueId(u.uniqueIdInThread);if(w!==void 0&&N&&w.reactionHandler)return w.reactionHandler(N,r(l))}return Promise.resolve(void 0)})}}class h{static{this.a=0}set threadId(f){this.n=f}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(f){(f===void 0!=(this.p===void 0)||!f||!this.p||!f.isEqual(this.p))&&(this.p=f,this.b.range=f,this.c.fire())}get range(){return this.p}set canReply(f){this.d!==f&&(this.d=f,this.b.canReply=f,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(f){this.e=f,this.b.label=f,this.c.fire()}get contextValue(){return this.f}set contextValue(f){this.f=f,this.b.contextValue=f,this.c.fire()}get comments(){return this.q}set comments(f){this.q=f,this.b.comments=f,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(f){this.g=f,this.b.collapsibleState=f,this.c.fire()}get state(){return this.h}set state(f){this.h=f,this.b.state=f,this.c.fire()}get isDisposed(){return this.j}constructor(f,y,E,u,l,w,A,N){this.m=y,this.n=E,this.o=u,this.p=l,this.q=w,this.extensionDescription=A,this.r=N,this.handle=h.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new g.$fd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$lc,this.l.value=new L.$jc,this.n===void 0&&(this.n=`${f}.${this.handle}`),s.$createCommentThread(y,this.handle,this.n,this.o,b.Range.from(this.p),A.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=w,this.i.push({dispose:()=>{s.$deleteCommentThread(y,this.handle)}});const O=this;this.value={get uri(){return O.uri},get range(){return O.range},set range(F){O.range=F},get comments(){return O.comments},set comments(F){O.comments=F},get collapsibleState(){return O.collapsibleState},set collapsibleState(F){O.collapsibleState=F},get canReply(){return O.canReply},set canReply(F){O.canReply=F},get contextValue(){return O.contextValue},set contextValue(F){O.contextValue=F},get label(){return O.label},set label(F){O.label=F},get state(){return O.state},set state(F){O.state=F},dispose:()=>{O.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$jc);const f=E=>Object.prototype.hasOwnProperty.call(this.b,E),y={};f("range")&&(y.range=b.Range.from(this.p)),f("label")&&(y.label=this.label),f("contextValue")&&(y.contextValue=this.contextValue??null),f("comments")&&(y.comments=this.q.map(E=>d(this,E,this.k,this.extensionDescription))),f("collapsibleState")&&(y.collapseState=a(this.g)),f("canReply")&&(y.canReply=this.canReply),f("state")&&(y.state=i(this.h)),f("isTemplate")&&(y.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,y)}getCommentByUniqueId(f){for(const y of this.k){const E=y[0],u=y[1];if(f===u)return E}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(f=>f.dispose())}}Ke([(0,M.$7g)(100)],h.prototype,"eventuallyUpdateCommentThread",null);class ${get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(f){this.b=f,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(f){this.c=f,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this.d}set options(f){this.d=f,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(f,y,E,u){this.f=f,this.g=y,this.h=E,this.i=u,this.a=new Map,s.$registerCommentController(this.handle,E,u,this.f.identifier.value);const l=this;this.value=Object.freeze({id:l.id,label:l.label,get options(){return l.options},set options(w){l.options=w},get commentingRangeProvider(){return l.commentingRangeProvider},set commentingRangeProvider(w){l.commentingRangeProvider=w},get reactionHandler(){return l.reactionHandler},set reactionHandler(w){l.reactionHandler=w},createCommentThread(w,A,N){return l.createCommentThread(w,A,N).value},dispose:()=>{l.dispose()}}),this.e=[],this.e.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(f,y,E){y===void 0&&(0,p.$QF)(this.f,"fileComments");const u=new h(this.id,this.handle,void 0,f,y,E,this.f,!1);return this.a.set(u.handle,u),u}$createCommentThreadTemplate(f,y){const E=new h(this.id,this.handle,void 0,R.URI.revive(f),b.Range.to(y),[],this.f,!0);return E.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(E.handle,E),E}$updateCommentThreadTemplate(f,y){const E=this.a.get(f);E&&(E.range=b.Range.to(y))}$deleteCommentThread(f){this.a.get(f)?.dispose(),this.a.delete(f)}getCommentThread(f){return this.a.get(f)}dispose(){this.a.forEach(f=>{f.dispose()}),this.e.forEach(f=>f.dispose())}}function d(c,f,y,E){let u=y.get(f);return u||(u=++c.commentHandle,y.set(f,u)),f.state!==void 0&&(0,p.$QF)(E,"commentsDraftState"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:u,body:typeof f.body=="string"?f.body:b.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(l=>t(l)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function t(c){return{label:c.label,iconPath:c.iconPath?b.$1L(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function r(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?R.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function a(c){if(c!==void 0)switch(c){case P.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function i(c){if(c!==void 0)switch(c){case P.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new n}e.$_ac=S}),define(Se[304],De([1,0,23,6,26,20]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=void 0;let R=class{constructor(P,I){this.a=P.getProxy(M.$ZJ.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(P,I){const p=this,S=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){p.e(P,I,S,arguments)}})}e(P,I,p,S){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:k(S,this.b)}),this.c&&this.f(P,p,S)}};e.$9cc=R,e.$9cc=R=Ke([Be(0,L.$2L),Be(1,g.$fM)],R);const m=1e5;function k(b,P){const I=[];if(b.length)for(let p=0;p<b.length;p++){let S=b[p];if(typeof S>"u")S="undefined";else if(S instanceof Error){const C=S;C.stack?S=C.stack:S=C.toString()}I.push(S)}if(P){const p=new Error().stack;p&&I.push({__$stack:p.split(`
`).slice(3).join(`
`)})}try{const p=(0,D.$1m)(I);return p.length>m?"Output omitted for a large object that exceeds the limits":p}catch(p){return`Output omitted for an object that cannot be inspected ('${p.toString()}')`}}}),define(Se[149],De([1,0,2,6,7,5,20,14,19,15,16,27]),function($e,e,D,M,g,L,R,m,k,b,P,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=e.$acc=void 0;let S=class{static{p=this}static{this.c=0}static{this.d=250}constructor(v,o){this.h=o,this.f=new Map,this.g=v.getProxy(M.$ZJ.MainThreadDecorations)}registerFileDecorationProvider(v,o){const s=p.c++;this.f.set(s,{provider:v,extensionDescription:o}),this.g.$registerDecorationProvider(s,o.identifier.value);const n=v.onDidChangeFileDecorations&&v.onDidChangeFileDecorations(h=>{if(!h){this.g.$onDidChange(s,null);return}const $=(0,k.$1b)(h);if($.length<=p.d){this.g.$onDidChange(s,$);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,$.length);const d=$.map(a=>({uri:a,rank:(0,b.$re)(a.path,"/")})),t=(0,k.$xb)(d,(a,i)=>a.rank-i.rank||(0,b.$Fe)(a.uri.path,i.uri.path)),r=[];e:for(const a of t){let i;for(const c of a){const f=(0,P.$_d)(c.uri.path);if(i!==f&&(i=f,r.push(c.uri)>=p.d))break e}}this.g.$onDidChange(s,r)});return new g.$2J(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(v,o,s){if(!this.f.has(v))return Object.create(null);const n=Object.create(null),{provider:h,extensionDescription:$}=this.f.get(v);return await Promise.all(o.map(async d=>{try{const{uri:t,id:r}=d,a=await Promise.resolve(h.provideFileDecoration(D.URI.revive(t),s));if(!a)return;try{g.$lL.validate(a),a.badge&&typeof a.badge!="string"&&(0,I.$QF)($,"codiconDecoration"),n[r]=[a.propagate,a.tooltip,a.badge,a.color]}catch(i){this.h.warn(`INVALID decoration from extension '${$.identifier.value}': ${i}`)}}catch(t){this.h.error(t)}})),n}};e.$acc=S,e.$acc=S=p=Ke([Be(0,R.$2L),Be(1,m.$5i)],S),e.$bcc=(0,L.$Bh)("IExtHostDecorations")}),define(Se[305],De([1,0,203,133,2,6,7,13,4,14,28,54]),function($e,e,D,M,g,L,R,m,k,b,P,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$5ac=e.$4ac=void 0;class S{#e;#t;#i;constructor(o,s,n,h,$,d,t,r){this.d=o,this.e=s,this.f=n,this.g=h,this.h=$,this.c=!1,this.f=Math.max(h,n),this.#i=new P.$zi(a=>d.getComparisonKey(a)),this.#e=t,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,s){if(!o){this.clear();return}this.j();let n=[];if(g.URI.isUri(o)){if(!s){this.delete(o);return}this.#i.set(o,s.slice()),n=[o]}else if(Array.isArray(o)){n=[];let d;o=[...o].sort(S.k);for(const t of o){const[r,a]=t;if((!d||r.toString()!==d.toString())&&(d&&this.#i.get(d).length===0&&this.#i.delete(d),d=r,n.push(r),this.#i.set(r,[])),a)this.#i.get(r)?.push(...a);else{const i=this.#i.get(r);i&&(i.length=0)}}}if(this.#t.fire(n),!this.#e)return;const h=[];let $=0;for(const d of n){let t=[];const r=this.#i.get(d);if(r)if(r.length>this.g){t=[];const a=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(const c of r)if(c.severity===a[i]&&t.push({...m.Diagnostic.from(c),modelVersionId:this.h(d)})===this.g)break e;t.push({severity:M.MarkerSeverity.Info,message:(0,D.localize)(0,null,r.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=r.map(a=>({...m.Diagnostic.from(a),modelVersionId:this.h(d)}));if(h.push([d,t]),$+=t.length,$>this.f)break}this.#e.$changeMany(this.e,h)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,s){this.j();for(const[n,h]of this)o.call(s,n,h,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const s=this.#i.get(o);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,s){return o[0].toString()<s[0].toString()?-1:o[0].toString()>s[0].toString()?1:0}}e.$4ac=S;let C=class{static{p=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*p.d}static _mapper(o){const s=new P.$zi;for(const n of o)s.set(n,n);return{uris:Object.freeze(Array.from(s.values()))}}constructor(o,s,n,h){this.j=s,this.k=n,this.l=h,this.g=new Map,this.h=new k.$jd({merge:$=>$.flat(),delay:50}),this.onDidChangeDiagnostics=k.Event.map(this.h.event,p._mapper),this.f=o.getProxy(L.$ZJ.MainThreadDiagnostics)}createDiagnosticCollection(o,s){const{g:n,f:h,h:$,j:d,k:t,l:r}=this,a=new class{$changeMany(f,y){h.$changeMany(f,y),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,f,y.length===0?"CLEARING":y)}$clear(f){h.$clear(f),d.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,f)}dispose(){h.dispose()}};let i;if(!s)s="_generated_diagnostic_collection_name_#"+p.c++,i=s;else if(!n.has(s))i=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do i=s+p.c++;while(n.has(i))}return new class extends S{constructor(){super(s,i,p.e,p.d,f=>r.getDocument(f)?.version,t.extUri,a,$),n.set(i,this)}dispose(){super.dispose(),n.delete(i)}}}getDiagnostics(o){if(o)return this.m(o);{const s=new Map,n=[];for(const h of this.g.values())h.forEach(($,d)=>{let t=s.get($.toString());typeof t>"u"&&(t=n.length,s.set($.toString(),t),n.push([$,[]])),n[t][1]=n[t][1].concat(...d)});return n}}m(o){let s=[];for(const n of this.g.values())n.has(o)&&(s=s.concat(n.get(o)));return s}$acceptMarkersChange(o){if(!this.n){const s="_generated_mirror",n=new S(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,h=>{},this.k.extUri,void 0,this.h);this.g.set(s,n),this.n=n}for(const[s,n]of o)this.n.set(g.URI.revive(s),n.map(m.Diagnostic.to))}};e.$5ac=C,e.$5ac=C=p=Ke([Be(1,b.$5i),Be(2,I.$3ac)],C)}),define(Se[306],De([1,0,2,6,27]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hbc=void 0;class L{constructor(m){this.a=m.getProxy(M.$ZJ.MainThreadDialogs)}showOpenDialog(m,k){return k?.allowUIResources&&(0,g.$QF)(m,"showLocal"),this.a.$showOpenDialog(k).then(b=>b?b.map(P=>D.URI.revive(P)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(k=>k?D.URI.revive(k):void 0)}}e.$hbc=L}),define(Se[307],De([1,0,8,2,7,6,17,21,15]),function($e,e,D,M,g,L,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ibc=void 0;class b{static{this.a=0}constructor(I,p,S){this.d=p,this.e=S,this.b=new Map,this.c=I.getProxy(L.$ZJ.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,p){if(Object.keys(R.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const S=b.a++;this.b.set(S,p),this.c.$registerTextContentProvider(S,I);let C;return typeof p.onDidChange=="function"&&(C=p.onDidChange(v=>{if(v.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this.d.getDocument(v)&&this.$provideTextDocumentContent(S,v).then(o=>{if(!o&&typeof o!="string")return;const s=this.d.getDocument(v);if(!s)return;const n=(0,k.$Ae)(o);if(!s.equalLines(n))return this.c.$onVirtualDocumentChange(v,o)},D.$Y)})),new g.$2J(()=>{this.b.delete(S)&&this.c.$unregisterTextContentProvider(S),C&&(C.dispose(),C=void 0)})}$provideTextDocumentContent(I,p){const S=this.b.get(I);return S?Promise.resolve(S.provideTextDocumentContent(M.URI.revive(p),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.$ibc=b}),define(Se[308],De([1,0,4,3,2,6,141,13,18,23,7,8]),function($e,e,D,M,g,L,R,m,k,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ac=void 0;class p{constructor(C,v){this.a=new D.$fd({onListenerError:I.$Z}),this.b=new D.$fd({onListenerError:I.$Z}),this.c=new D.$fd({onListenerError:I.$Z}),this.d=new D.$fd({onListenerError:I.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$jc,this.h=new Map,this.f=C.getProxy(L.$ZJ.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(o=>{for(const s of o)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(o=>{for(const s of o)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(C){if(!C)return;const v=this.g.getDocument(C);if(v)return v}getDocument(C){const v=this.getDocumentData(C);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${C}'`);return v.document}ensureDocumentData(C){const v=this.g.getDocument(C);if(v)return Promise.resolve(v);let o=this.h.get(C.toString());return o||(o=this.f.$tryOpenDocument(C).then(s=>{this.h.delete(C.toString());const n=g.URI.revive(s);return(0,k.$uf)(this.g.getDocument(n))},s=>(this.h.delete(C.toString()),Promise.reject(s))),this.h.set(C.toString(),o)),o}createDocumentData(C){return this.f.$tryCreateDocument(C).then(v=>g.URI.revive(v))}$acceptModelLanguageChanged(C,v){const o=g.URI.revive(C),s=this.g.getDocument(o);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(v),this.a.fire(s.document)}$acceptModelSaved(C){const v=g.URI.revive(C),o=this.g.getDocument(v);if(!o)throw new Error("unknown document");this.$acceptDirtyStateChanged(C,!1),this.d.fire(o.document)}$acceptDirtyStateChanged(C,v){const o=g.URI.revive(C),s=this.g.getDocument(o);if(!s)throw new Error("unknown document");s._acceptIsDirty(v),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(C,v,o){const s=g.URI.revive(C),n=this.g.getDocument(s);if(!n)throw new Error("unknown document");n._acceptIsDirty(o),n.onEvents(v);let h;v.isUndoing?h=P.TextDocumentChangeReason.Undo:v.isRedoing&&(h=P.TextDocumentChangeReason.Redo),this.c.fire((0,b.$Wm)({document:n.document,contentChanges:v.changes.map($=>({range:m.Range.to($.range),rangeOffset:$.rangeOffset,rangeLength:$.rangeLength,text:$.text})),reason:h}))}setWordDefinitionFor(C,v){(0,R.$4L)(C,v)}}e.$1ac=p}),define(Se[71],De([1,0,58,4,3,2,5,6,141,20,146,13,14,28,17,50,59]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aM=e.$_L=void 0;class s{constructor($){this.value=$,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor($,d){this.h=$,this.i=d,this.a=null,this.b=new Map,this.c=new S.$zi,this.d=new M.$fd,this.e=new M.$fd,this.f=new M.$fd,this.g=new M.$fd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta($){this.acceptDocumentsAndEditorsDelta($)}acceptDocumentsAndEditorsDelta($){const d=[],t=[],r=[];if($.removedDocuments)for(const a of $.removedDocuments){const i=L.URI.revive(a),c=this.c.get(i);c?.unref()&&(this.c.delete(i),d.push(c.value))}if($.addedDocuments)for(const a of $.addedDocuments){const i=L.URI.revive(a.uri);let c=this.c.get(i);if(c&&i.scheme!==C.Schemas.vscodeNotebookCell&&i.scheme!==C.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);c||(c=new s(new k.$5L(this.h.getProxy(m.$ZJ.MainThreadDocuments),i,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this.c.set(i,c),t.push(c.value)),c.ref()}if($.removedEditors)for(const a of $.removedEditors){const i=this.b.get(a);this.b.delete(a),i&&r.push(i)}if($.addedEditors)for(const a of $.addedEditors){const i=L.URI.revive(a.documentUri);D.ok(this.c.has(i),`document '${i}' does not exist`),D.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const c=this.c.get(i).value,f=new P.$$L(a.id,this.h.getProxy(m.$ZJ.MainThreadTextEditors),this.i,new o.$T(()=>c.document),a.selections.map(I.Selection.to),a.options,a.visibleRanges.map(y=>I.Range.to(y)),typeof a.editorPosition=="number"?I.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,f)}$.newActiveEditor!==void 0&&(D.ok($.newActiveEditor===null||this.b.has($.newActiveEditor),`active editor '${$.newActiveEditor}' does not exist`),this.a=$.newActiveEditor),(0,g.$fc)(d),(0,g.$fc)(r),$.removedDocuments&&this.e.fire(d),$.addedDocuments&&this.d.fire(t),($.removedEditors||$.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),$.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument($){return this.c.get($)?.value}allDocuments(){return v.Iterable.map(this.c.values(),$=>$.value)}getEditor($){return this.b.get($)}activeEditor($){if(!this.a)return;const d=this.b.get(this.a);return $?d:d?.value}allEditors(){return[...this.b.values()]}};e.$_L=n,e.$_L=n=Ke([Be(0,b.$2L),Be(1,p.$5i)],n),e.$aM=(0,R.$Bh)("IExtHostDocumentsAndEditors")}),define(Se[72],De([1,0,13,6,2,4,5,7,20,18,56]),function($e,e,D,M,g,L,R,m,k,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=e.$fcc=void 0,e.$fcc=(0,R.$Bh)("IExtHostEditorTabs");class I{constructor(o,s,n){this.e=n,this.d=s,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new m.$HL(g.URI.revive(this.b.input.uri));case 2:return new m.$IL(g.URI.revive(this.b.input.original),g.URI.revive(this.b.input.modified));case 3:return new m.$JL(g.URI.revive(this.b.input.base),g.URI.revive(this.b.input.input1),g.URI.revive(this.b.input.input2),g.URI.revive(this.b.input.result));case 6:return new m.$KL(g.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new m.$LL(this.b.input.viewType);case 4:return new m.$ML(g.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new m.$NL(g.URI.revive(this.b.input.original),g.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new m.$OL;case 9:return new m.$PL(g.URI.revive(this.b.input.uri),g.URI.revive(this.b.input.inputBoxUri));default:return}}}class p{constructor(o,s){this.c=[],this.d="",this.b=o,this.e=s;for(const n of o.tabs)n.isActive&&(this.d=n.id),this.c.push(new I(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return D.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(n=>n.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(n=>n.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const n=new I(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,n),o.tabDto.isActive&&(this.d=n.tabId),n}else if(o.kind===1){const n=this.c.splice(o.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(o.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,n),n}const s=this.c.find(n=>n.tabId===o.tabDto.id);if(!s)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(o.tabDto),s}activeTabId(){return this.d}}let S=class{constructor(o){this.b=new L.$fd,this.c=new L.$fd,this.e=[],this.a=o.getProxy(M.$ZJ.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,s={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(n=>n.apiObject))},get activeTabGroup(){const n=o.d;return(0,b.$uf)(o.e.find($=>$.groupId===n)?.apiObject)},close:async(n,h)=>{const $=Array.isArray(n)?n:[n];return $.length?C($[0])?this.j($,h):this.i($,h):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(o){const s=new Set(this.e.map(a=>a.groupId)),n=new Set(o.map(a=>a.groupId)),h=(0,P.$J)(s,n),$=this.e.filter(a=>h.removed.includes(a.groupId)).map(a=>a.apiObject),d=[],t=[];this.e=o.map(a=>{const i=new p(a,()=>this.d);return h.added.includes(i.groupId)?d.push(i.apiObject):t.push(i.apiObject),i});const r=(0,b.$uf)(o.find(a=>a.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:d,closed:$,changed:t}))}$acceptTabGroupUpdate(o){const s=this.e.find(n=>n.groupId===o.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const s=this.e.find(h=>h.groupId===o.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const n=s.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(o){for(const s of this.e)for(const n of s.tabs)if(n.apiObject===o)return n}h(o){return this.e.find(s=>s.apiObject===o)}async i(o,s){const n=[];for(const h of o){const $=this.g(h);if(!$)throw new Error("Tab close: Invalid tab not found!");n.push($.tabId)}return this.a.$closeTab(n,s)}async j(o,s){const n=[];for(const h of o){const $=this.h(h);if(!$)throw new Error("Group close: Invalid group not found!");n.push($.groupId)}return this.a.$closeGroup(n,s)}};e.$gcc=S,e.$gcc=S=Ke([Be(0,k.$2L)],S);function C(v){return v.tabs!==void 0}}),define(Se[309],De([1,0,6,7]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=void 0;class g{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(D.$ZJ.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,m,k){if(this.a.size===0)throw new Error("No embedding vector providers registered");const b=this.a.get(R);if(!b)throw new Error("Embedding vector provider not found");const P=await b.provideEmbeddingVector(m,k);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(R,m,k){const b=this.b;return this.b++,this.a.set(b,k),this.c.$registerAiEmbeddingVectorProvider(m,b),new M.$2J(()=>{this.c.$unregisterAiEmbeddingVectorProvider(b),this.a.delete(b)})}}e.$5cc=g}),define(Se[310],De([1,0,2,6,3,7,13,169,15,22,27,80]),function($e,e,D,M,g,L,R,m,k,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=void 0;class p{constructor(){this.a=[]}add(v){this.b=void 0,this.a.push(v)}delete(v){const o=this.a.indexOf(v);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const v=this.a.sort(),o=[];let s,n,h=14,$=14;for(const d of v){let t=s?(0,k.$Oe)(s,d):0;for(t===0?n=1:n=$;t<d.length;t++)t+1===d.length?(h=$,$=9):$+=1,o.push([n,d.toUpperCase().charCodeAt(t),$]),o.push([n,d.toLowerCase().charCodeAt(t),$]),n=$;s=d,$=h}o.push([9,58,10]),o.push([10,47,12]),this.b=new m.$wY(o)}}provideDocumentLinks(v){this.c();const o=[],s=m.$xY.computeLinks({getLineContent(n){return v.lineAt(n-1).text},getLineCount(){return v.lineCount}},this.b);for(const n of s){const h=R.DocumentLink.to(n);h.target&&o.push(h)}return o}}class S{constructor(v,o){this.i=o,this.b=new p,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=v.getProxy(M.$ZJ.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(v,o,s,n={}){if(S.j(s),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(v,"*",this.b));const h=this.h++;this.b.add(o),this.d.add(o),this.c.set(h,s);let $=2;n.isCaseSensitive&&($+=1024),n.isReadonly&&($+=2048),typeof s.copy=="function"&&($+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,P.$QF)(v,"fsChunks"),$+=4);let d;n.isReadonly&&(0,I.$Zj)(n.isReadonly)&&((0,P.$QF)(v,"readonlyMessage"),d={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(h,o,$,d).catch(r=>{console.error(`FAILED to register filesystem provider of ${v.identifier.value}-extension for the scheme ${o}`),console.error(r)});const t=s.onDidChangeFile(r=>{const a=[];for(const i of r){const{uri:c,type:f}=i;if(c.scheme!==o)continue;let y;switch(f){case L.FileChangeType.Changed:y=0;break;case L.FileChangeType.Created:y=1;break;case L.FileChangeType.Deleted:y=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:c,type:y})}this.a.$onFileSystemChange(h,a)});return(0,g.$ic)(()=>{t.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(h),this.a.$unregisterProvider(h)})}static j(v){if(!v)throw new Error("MISSING provider");if(typeof v.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof v.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof v.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof v.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof v.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof v.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof v.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof v.rename!="function")throw new Error("Provider does NOT implement rename")}static k(v){const{type:o,ctime:s,mtime:n,size:h,permissions:$}=v;return{type:o,ctime:s,mtime:n,size:h,permissions:$}}$stat(v,o){return Promise.resolve(this.l(v).stat(D.URI.revive(o))).then(s=>S.k(s))}$readdir(v,o){return Promise.resolve(this.l(v).readDirectory(D.URI.revive(o)))}$readFile(v,o){return Promise.resolve(this.l(v).readFile(D.URI.revive(o))).then(s=>b.$Fd.wrap(s))}$writeFile(v,o,s,n){return Promise.resolve(this.l(v).writeFile(D.URI.revive(o),s.buffer,n))}$delete(v,o,s){return Promise.resolve(this.l(v).delete(D.URI.revive(o),s))}$rename(v,o,s,n){return Promise.resolve(this.l(v).rename(D.URI.revive(o),D.URI.revive(s),n))}$copy(v,o,s,n){const h=this.l(v);if(!h.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(h.copy(D.URI.revive(o),D.URI.revive(s),n))}$mkdir(v,o){return Promise.resolve(this.l(v).createDirectory(D.URI.revive(o)))}$watch(v,o,s,n){const h=this.l(v).watch(D.URI.revive(s),n);this.f.set(o,h)}$unwatch(v,o){const s=this.f.get(o);s&&(s.dispose(),this.f.delete(o))}$open(v,o,s){const n=this.l(v);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(D.URI.revive(o),s))}$close(v,o){const s=this.l(v);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(o))}$read(v,o,s,n){const h=this.l(v);if(!h.read)throw new Error('FileSystemProvider does not implement "read"');const $=b.$Fd.alloc(n);return Promise.resolve(h.read(o,s,$.buffer,0,n)).then(d=>$.slice(0,d))}$write(v,o,s,n){const h=this.l(v);if(!h.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(h.write(o,s,n.buffer,0,n.byteLength))}l(v){const o=this.c.get(v);if(!o){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return o}}e.$Obc=S}),define(Se[73],De([1,0,6,30,7,22,5,20,54,3,9,24,17]),function($e,e,D,M,g,L,R,m,k,b,P,I,p){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$vbc=e.$ubc=void 0;let C=S=class{constructor(o,s){this.b=new Map,this.c=new P.$Pg,this.a=o.getProxy(D.$ZJ.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(h){try{let $;const d=n.b.get(h.scheme);return d?(await n.a.$ensureActivation(h.scheme),$=await d.impl.stat(h)):$=await n.a.$stat(h),{type:$.type,ctime:$.ctime,mtime:$.mtime,size:$.size,permissions:$.permissions===M.FilePermission.Readonly?1:void 0}}catch($){S.e($)}},async readDirectory(h){try{const $=n.b.get(h.scheme);return $?(await n.a.$ensureActivation(h.scheme),(await $.impl.readDirectory(h)).slice()):await n.a.$readdir(h)}catch($){return S.e($)}},async createDirectory(h){try{const $=n.b.get(h.scheme);return $&&!$.isReadonly?(await n.a.$ensureActivation(h.scheme),await n.d($.impl,$.extUri,h)):await n.a.$mkdir(h)}catch($){return S.e($)}},async readFile(h){try{const $=n.b.get(h.scheme);return $?(await n.a.$ensureActivation(h.scheme),(await $.impl.readFile(h)).slice()):(await n.a.$readFile(h)).buffer}catch($){return S.e($)}},async writeFile(h,$){try{const d=n.b.get(h.scheme);return d&&!d.isReadonly?(await n.a.$ensureActivation(h.scheme),await n.d(d.impl,d.extUri,d.extUri.dirname(h)),await n.c.queueFor(h).queue(()=>Promise.resolve(d.impl.writeFile(h,$,{create:!0,overwrite:!0})))):await n.a.$writeFile(h,L.$Fd.wrap($))}catch(d){return S.e(d)}},async delete(h,$){try{const d=n.b.get(h.scheme);return d&&!d.isReadonly?(await n.a.$ensureActivation(h.scheme),await d.impl.delete(h,{recursive:!1,...$})):await n.a.$delete(h,{recursive:!1,useTrash:!1,atomic:!1,...$})}catch(d){return S.e(d)}},async rename(h,$,d){try{return await n.a.$rename(h,$,{overwrite:!1,...d})}catch(t){return S.e(t)}},async copy(h,$,d){try{return await n.a.$copy(h,$,{overwrite:!1,...d})}catch(t){return S.e(t)}},isWritableFileSystem(h){const $=s.getCapabilities(h);if(typeof $=="number")return!($&2048)}})}async d(o,s,n){const h=[];for(;!s.isEqual(n,s.dirname(n));)try{if(!((await o.stat(n)).type&M.FileType.Directory))throw g.$dL.FileExists(`Unable to create folder '${n.scheme===p.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch($){if(M.$ik($)!==M.FileSystemProviderErrorCode.FileNotFound)throw $;h.push(s.basename(n)),n=s.dirname(n)}for(let $=h.length-1;$>=0;$--){n=s.joinPath(n,h[$]);try{await o.createDirectory(n)}catch(d){if(M.$ik(d)!==M.FileSystemProviderErrorCode.FileExists)throw d}}}static e(o){if(o instanceof g.$dL)throw o;if(o instanceof M.$ek)switch(o.code){case M.FileSystemProviderErrorCode.FileExists:throw g.$dL.FileExists(o.message);case M.FileSystemProviderErrorCode.FileNotFound:throw g.$dL.FileNotFound(o.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw g.$dL.FileNotADirectory(o.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw g.$dL.FileIsADirectory(o.message);case M.FileSystemProviderErrorCode.NoPermissions:throw g.$dL.NoPermissions(o.message);case M.FileSystemProviderErrorCode.Unavailable:throw g.$dL.Unavailable(o.message);default:throw new g.$dL(o.message,o.name)}if(!(o instanceof Error))throw new g.$dL(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw g.$dL.Unavailable(o.message);switch(o.name){case M.FileSystemProviderErrorCode.FileExists:throw g.$dL.FileExists(o.message);case M.FileSystemProviderErrorCode.FileNotFound:throw g.$dL.FileNotFound(o.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw g.$dL.FileNotADirectory(o.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw g.$dL.FileIsADirectory(o.message);case M.FileSystemProviderErrorCode.NoPermissions:throw g.$dL.NoPermissions(o.message);case M.FileSystemProviderErrorCode.Unavailable:throw g.$dL.Unavailable(o.message);default:throw new g.$dL(o.message,o.name)}}addFileSystemProvider(o,s,n){return this.b.set(o,{impl:s,extUri:n?.isCaseSensitive?I.$$f:I.$ag,isReadonly:!!n?.isReadonly}),(0,b.$ic)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??I.$$f}};e.$ubc=C,e.$ubc=C=S=Ke([Be(0,m.$2L),Be(1,k.$3ac)],C),e.$vbc=(0,R.$Bh)("IExtHostConsumerFileSystem")}),define(Se[311],De([1,0,4,35,2,6,13,7]),function($e,e,D,M,g,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pbc=void 0;class k{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(I,p,S,C,v,o,s,n){this.a=new D.$fd,this.b=new D.$fd,this.c=new D.$fd;const h=this.h(I,S,v);this.g=0,o&&(this.g+=1),s&&(this.g+=2),n&&(this.g+=4);const $=(0,M.$rj)(v),d=typeof v=="string",t=C(r=>{if(!o)for(const a of r.created){const i=g.URI.revive(a);$(i.fsPath)&&(!d||p.getWorkspaceFolder(i))&&this.a.fire(i)}if(!s)for(const a of r.changed){const i=g.URI.revive(a);$(i.fsPath)&&(!d||p.getWorkspaceFolder(i))&&this.b.fire(i)}if(!n)for(const a of r.deleted){const i=g.URI.revive(a);$(i.fsPath)&&(!d||p.getWorkspaceFolder(i))&&this.c.fire(i)}});this.d=m.$2J.from(h,this.a,this.b,this.c,t)}h(I,p,S){const C=m.$2J.from();if(typeof S=="string")return C;const v=I.getProxy(L.$ZJ.MainThreadFileSystem);let o=!1;(S.pattern.includes(M.$nj)||S.pattern.includes(M.$oj))&&(o=!0);const s=Math.random();return v.$watch(p.identifier.value,s,S.baseUri,{recursive:o,excludes:[]}),m.$2J.from({dispose:()=>v.$unwatch(s)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class b{constructor(I,p,S){this.j=I,this.k=p,this.l=S,this.a=new D.$fd,this.b=new D.$fd,this.c=new D.$fd,this.d=new D.$fd,this.g=new D.$hd,this.h=new D.$hd,this.i=new D.$hd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(I,p,S,C,v,o){return new k(this.j,I,p,this.a.event,R.GlobPattern.from(S),C,v,o)}$onFileEvent(I){this.a.fire(I)}$onDidRunFileOperation(I,p){switch(I){case 2:this.b.fire(Object.freeze({files:p.map(S=>({oldUri:g.URI.revive(S.source),newUri:g.URI.revive(S.target)}))}));break;case 1:this.d.fire(Object.freeze({files:p.map(S=>g.URI.revive(S.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:p.map(S=>g.URI.revive(S.target))}));break;default:}}getOnWillRenameFileEvent(I){return this.m(I,this.g)}getOnWillCreateFileEvent(I){return this.m(I,this.h)}getOnWillDeleteFileEvent(I){return this.m(I,this.i)}m(I,p){return(S,C,v)=>{const o=function(n){S.call(C,n)};return o.extension=I,p.event(o,void 0,v)}}async $onWillRunFileOperation(I,p,S,C){switch(I){case 2:return await this.n(this.g,{files:p.map(v=>({oldUri:g.URI.revive(v.source),newUri:g.URI.revive(v.target)}))},S,C);case 1:return await this.n(this.i,{files:p.map(v=>g.URI.revive(v.target))},S,C);case 0:case 3:return await this.n(this.h,{files:p.map(v=>g.URI.revive(v.target))},S,C)}}async n(I,p,S,C){const v=new Set,o=[];if(await I.fireAsync(p,C,async(n,h)=>{const $=Date.now(),d=await Promise.resolve(n);d instanceof m.$_J&&(o.push([h.extension,d]),v.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-$>S&&this.k.warn("SLOW file-participant",h.extension.identifier)}),C.isCancellationRequested||o.length===0)return;const s={edits:[]};for(const[,n]of o){const{edits:h}=R.WorkspaceEdit.from(n,{getTextDocumentVersion:$=>this.l.getDocument($)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(h)}return{edit:s,extensionNames:Array.from(v)}}}e.$Pbc=b}),define(Se[312],De([1,0,3,2,6,13,7,33]),function($e,e,D,M,g,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=void 0;class k{static{this.a=0}constructor(p,S){this.extension=p,this.provider=S,this.handle=k.a++}}class b{constructor(p){this.session=p,this.responses=[]}}class P{static{this.a=0}constructor(p,S,C,v){this.f=C,this.g=v,this.b=new Map,this.d=new Map,this.e=p.getProxy(g.$ZJ.MainThreadInlineChat),S.registerApiCommand(new m.$pM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$nM("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?L.Range.from(o.initialRange):void 0,initialSelection:o.initialSelection?L.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?L.Position.from(o.position):void 0}})],m.$oM.Void))}registerProvider(p,S,C){const v=new k(p,S);return this.b.set(v.handle,v),this.e.$registerInteractiveEditorProvider(v.handle,C.label,p.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function"),(0,D.$ic)(()=>{this.e.$unregisterInteractiveEditorProvider(v.handle),this.b.delete(v.handle)})}async $prepareSession(p,S,C,v){const o=this.b.get(p);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const s=this.f.getDocument(M.URI.revive(S)),n=L.Selection.to(C),h=await o.provider.prepareInteractiveEditorSession({document:s,selection:n},v);if(!h)return;if(h.wholeRange&&!h.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const $=P.a++;return this.d.set($,new b(h)),{id:$,placeholder:h.placeholder,slashCommands:h.slashCommands?.map(d=>({command:d.command,detail:d.detail,refer:d.refer,executeImmediately:d.executeImmediately})),wholeRange:L.Range.from(h.wholeRange),message:h.message}}async $provideResponse(p,S,C,v){const o=this.b.get(p);if(!o)return;const s=this.d.get(S.id);if(!s)return;const n={prompt:C.prompt,selection:L.Selection.to(C.selection),wholeRange:L.Range.to(C.wholeRange),attempt:C.attempt,live:C.live};let h=!1;const $={report:r=>{if(!C.live)throw new Error("Progress reporting is only supported for live sessions");h||v.isCancellationRequested||!r.message&&!r.edits||this.e.$handleProgressChunk(C.requestId,{message:r.message,edits:r.edits?.map(L.TextEdit.from)})}},d=o.provider.provideInteractiveEditorResponse(s.session,n,$,v);Promise.resolve(d).finally(()=>h=!0);const t=await d;if(t){const r=s.responses.push(t)-1,a={wholeRange:L.Range.from(t.wholeRange),placeholder:t.placeholder};if(P.h(t))return{...a,id:r,type:"message",message:L.MarkdownString.from(t.contents)};const{edits:i}=t;if(i instanceof R.$_J)return{...a,id:r,type:"bulkEdit",edits:L.WorkspaceEdit.from(i)};if(Array.isArray(i))return{...a,id:r,type:"editorEdit",edits:i.map(L.TextEdit.from)}}}$handleFeedback(p,S,C,v){const o=this.b.get(p),s=this.d.get(S),n=s?.responses[C];if(o&&n){const h=L.InteractiveEditorResponseFeedbackKind.to(v);o.provider.handleInteractiveEditorResponseFeedback?.(s.session,n,h)}}$releaseSession(p,S){}static h(p){return typeof p=="object"&&typeof p.contents=="object"}}e.$Wcc=P}),define(Se[313],De([1,0,2,33]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=void 0;class g{constructor(R,m,k,b,P){this.a=m,this.b=k,this.c=b;const I=new M.$pM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$nM("showOptions","Show Options",p=>!0,p=>p),new M.$nM("resource","Interactive resource Uri",p=>!0,p=>p),new M.$nM("controllerId","Notebook controller Id",p=>!0,p=>p),new M.$nM("title","Interactive editor title",p=>!0,p=>p)],new M.$oM("Notebook and input URI",p=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",p.notebookEditorId),p.notebookEditorId!==void 0){const S=this.a.getEditorById(p.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:D.URI.revive(p.notebookUri),inputUri:D.URI.revive(p.inputUri),notebookEditor:S.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",p.notebookUri,p.inputUri),{notebookUri:D.URI.revive(p.notebookUri),inputUri:D.URI.revive(p.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(R,m,k,b){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:k,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(D.URI.revive(b))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$Scc=g}),define(Se[314],De([1,0,6,7]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=void 0;class g{constructor(R){this.a=new Map,this.b=R.getProxy(D.$ZJ.MainThreadIssueReporter)}async $getIssueReporterUri(R,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const k=this.a.get(R);if(!k)throw new Error("Issue request handler not found");const b=await k.handleIssueUrlRequest();if(!b)throw new Error("Issue request handler returned no result");return b}registerIssueUriRequestHandler(R,m){const k=R.identifier.value;return this.a.set(k,m),this.b.$registerIssueUriRequestHandler(k),new M.$2J(()=>{this.b.$unregisterIssueUriRequestHandler(k),this.a.delete(k)})}}e.$Ycc=g}),define(Se[315],De([1,0,3,6]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=void 0;class g{constructor(R){this.b=0,this.a=R.getProxy(M.$ZJ.MainThreadLabelService)}$registerResourceLabelFormatter(R){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,R),(0,D.$ic)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$_bc=g}),define(Se[316],De([1,0,2,23,13,7,83,6,15,34,19,18,165,21,25,3,129,119,87,37,8,9,27,205]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o,s,n,h,$,d,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ac=void 0;class a{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentSymbols(B,Q){const ie=this.d.getDocument(B),se=await this.e.provideDocumentSymbols(ie,Q);if(!(0,P.$Ib)(se))return se[0]instanceof L.$hK?se.map(g.DocumentSymbol.from):a.f(se)}static f(B){B=B.slice(0).sort((se,Y)=>{let de=se.location.range.start.compareTo(Y.location.range.start);return de===0&&(de=Y.location.range.end.compareTo(se.location.range.end)),de});const Q=[],ie=[];for(const se of B){const Y={name:se.name||"!!MISSING: name!!",kind:g.SymbolKind.from(se.kind),tags:se.tags?.map(g.SymbolTag.from)||[],detail:"",containerName:se.containerName,range:g.Range.from(se.location.range),selectionRange:g.Range.from(se.location.range),children:[]};for(;;){if(ie.length===0){ie.push(Y),Q.push(Y);break}const de=ie[ie.length-1];if(b.$ks.containsRange(de.range,Y.range)&&!b.$ks.equalsRange(de.range,Y.range)){de.children?.push(Y),ie.push(Y);break}ie.pop()}}return Q}}class i{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(B,Q,ie){this.g=B,this.h=Q,this.j=ie,this.e=new n.$Zac("CodeLens"),this.f=new Map}async provideCodeLenses(B,Q){const ie=this.g.getDocument(B),se=await this.j.provideCodeLenses(ie,Q);if(!se||Q.isCancellationRequested)return;const Y=this.e.add(se),de=new v.$jc;this.f.set(Y,de);const ye={cacheId:Y,lenses:[]};for(let je=0;je<se.length;je++)ye.lenses.push({cacheId:[Y,je],range:g.Range.from(se[je].range),command:this.h.toInternal(se[je].command,de)});return ye}async resolveCodeLens(B,Q){const ie=B.cacheId&&this.e.get(...B.cacheId);if(!ie)return;let se;if(typeof this.j.resolveCodeLens!="function"||ie.isResolved?se=ie:se=await this.j.resolveCodeLens(ie,Q),se||(se=ie),Q.isCancellationRequested)return;const Y=B.cacheId&&this.f.get(B.cacheId[0]);if(Y)return B.command=this.h.toInternal(se.command??i.d,Y),B}releaseCodeLenses(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}}function c(Ie){return Array.isArray(Ie)?Ie.map(g.DefinitionLink.from):Ie?[g.DefinitionLink.from(Ie)]:[]}class f{constructor(B,Q){this.d=B,this.e=Q}async provideDefinition(B,Q,ie){const se=this.d.getDocument(B),Y=g.Position.to(Q),de=await this.e.provideDefinition(se,Y,ie);return c(de)}}class y{constructor(B,Q){this.d=B,this.e=Q}async provideDeclaration(B,Q,ie){const se=this.d.getDocument(B),Y=g.Position.to(Q),de=await this.e.provideDeclaration(se,Y,ie);return c(de)}}class E{constructor(B,Q){this.d=B,this.e=Q}async provideImplementation(B,Q,ie){const se=this.d.getDocument(B),Y=g.Position.to(Q),de=await this.e.provideImplementation(se,Y,ie);return c(de)}}class u{constructor(B,Q){this.d=B,this.e=Q}async provideTypeDefinition(B,Q,ie){const se=this.d.getDocument(B),Y=g.Position.to(Q),de=await this.e.provideTypeDefinition(se,Y,ie);return c(de)}}class l{constructor(B,Q){this.d=B,this.e=Q}async provideHover(B,Q,ie){const se=this.d.getDocument(B),Y=g.Position.to(Q),de=await this.e.provideHover(se,Y,ie);if(!(!de||(0,P.$Ib)(de.contents)))return de.range||(de.range=se.getWordRangeAtPosition(Y)),de.range||(de.range=new L.$4J(Y,Y)),g.Hover.from(de)}}class w{constructor(B,Q){this.d=B,this.e=Q}async provideEvaluatableExpression(B,Q,ie){const se=this.d.getDocument(B),Y=g.Position.to(Q),de=await this.e.provideEvaluatableExpression(se,Y,ie);if(de)return g.EvaluatableExpression.from(de)}}class A{constructor(B,Q){this.d=B,this.e=Q}async provideInlineValues(B,Q,ie,se){const Y=this.d.getDocument(B),de=await this.e.provideInlineValues(Y,g.Range.to(Q),g.InlineValueContext.to(ie),se);if(Array.isArray(de))return de.map(ye=>g.InlineValue.from(ye))}}class N{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentHighlights(B,Q,ie){const se=this.d.getDocument(B),Y=g.Position.to(Q),de=await this.e.provideDocumentHighlights(se,Y,ie);if(Array.isArray(de))return de.map(g.DocumentHighlight.from)}}class O{constructor(B,Q){this.d=B,this.e=Q}async provideLinkedEditingRanges(B,Q,ie){const se=this.d.getDocument(B),Y=g.Position.to(Q),de=await this.e.provideLinkedEditingRanges(se,Y,ie);if(de&&Array.isArray(de.ranges))return{ranges:(0,P.$Fb)(de.ranges.map(g.Range.from)),wordPattern:de.wordPattern}}}class F{constructor(B,Q){this.d=B,this.e=Q}async provideReferences(B,Q,ie,se){const Y=this.d.getDocument(B),de=g.Position.to(Q),ye=await this.e.provideReferences(Y,de,ie,se);if(Array.isArray(ye))return ye.map(g.location.from)}}class j{static{this.d=1e3}constructor(B,Q,ie,se,Y,de,ye){this.h=B,this.j=Q,this.k=ie,this.l=se,this.m=Y,this.n=de,this.o=ye,this.e=new n.$Zac("CodeAction"),this.f=new Map,this.g=new L.$jK("notebook")}async provideCodeActions(B,Q,ie,se){const Y=this.h.getDocument(B),de=p.$ms.isISelection(Q)?g.Selection.to(Q):g.Range.to(Q),ye=[];for(const et of this.k.getDiagnostics(B))if(de.intersection(et.range)&&ye.push(et)>j.d)break;const je={diagnostics:ye,only:ie.only?new L.$jK(ie.only):void 0,triggerKind:g.CodeActionTriggerKind.to(ie.trigger)},We=await this.l.provideCodeActions(Y,de,je,se);if(!(0,P.$Jb)(We)||se.isCancellationRequested)return;const _e=this.e.add(We),Ye=new v.$jc;this.f.set(_e,Ye);const it=[];for(let et=0;et<We.length;et++){const Ae=We[et];if(Ae)if(j.p(Ae))this.o.report("CodeActionProvider.provideCodeActions - return commands",this.n,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Ae.title,command:this.j.toInternal(Ae,Ye)});else{if(je.triggerKind!==L.CodeActionTriggerKind.Invoke&&Ae.kind&&this.g.contains(Ae.kind))continue;je.only&&(Ae.kind?je.only.contains(Ae.kind)||this.m.warn(`${this.n.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.m.warn(`${this.n.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[_e,et],title:Ae.title,command:Ae.command&&this.j.toInternal(Ae.command,Ye),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(g.Diagnostic.from),edit:Ae.edit&&g.WorkspaceEdit.from(Ae.edit,void 0),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,disabled:Ae.disabled?.reason})}}return{cacheId:_e,actions:it}}async resolveCodeAction(B,Q){const[ie,se]=B,Y=this.e.get(ie,se);if(!Y||j.p(Y))return{};if(!this.l.resolveCodeAction)return{};const de=await this.l.resolveCodeAction(Y,Q)??Y;let ye;de.edit&&(ye=g.WorkspaceEdit.from(de.edit,void 0));let je;if(de.command){const We=this.f.get(ie);We&&(je=this.j.toInternal(de.command,We))}return{edit:ye,command:je}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static p(B){return typeof B.command=="string"&&typeof B.title=="string"}}class z{static toInternalProviderId(B,Q){return B+"."+Q}constructor(B,Q,ie,se,Y){this.d=B,this.e=Q,this.f=ie,this.g=se,this.h=Y}async prepareDocumentPaste(B,Q,ie,se){if(!this.f.prepareDocumentPaste)return;const Y=this.e.getDocument(B),de=Q.map(We=>g.Range.to(We)),ye=g.DataTransfer.toDataTransfer(ie,()=>{throw new $.$9});if(await this.f.prepareDocumentPaste(Y,de,ye,se),se.isCancellationRequested)return;const je=Array.from(ye).filter(([,We])=>!(We instanceof L.$QK));return g.DataTransfer.from(je)}async providePasteEdits(B,Q,ie,se,Y){if(!this.f.provideDocumentPasteEdits)return;const de=this.e.getDocument(Q),ye=ie.map(_e=>g.Range.to(_e)),je=g.DataTransfer.toDataTransfer(se,async _e=>(await this.d.$resolvePasteFileData(this.g,B,_e)).buffer),We=await this.f.provideDocumentPasteEdits(de,ye,je,Y);if(We)return{label:We.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:z.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?g.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class T{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentFormattingEdits(B,Q,ie){const se=this.d.getDocument(B),Y=await this.e.provideDocumentFormattingEdits(se,Q,ie);if(Array.isArray(Y))return Y.map(g.TextEdit.from)}}class H{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentRangeFormattingEdits(B,Q,ie,se){const Y=this.d.getDocument(B),de=g.Range.to(Q),ye=await this.e.provideDocumentRangeFormattingEdits(Y,de,ie,se);if(Array.isArray(ye))return ye.map(g.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,Q,ie,se){(0,I.$tf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Y=this.d.getDocument(B),de=Q.map(g.Range.to),ye=await this.e.provideDocumentRangesFormattingEdits(Y,de,ie,se);if(Array.isArray(ye))return ye.map(g.TextEdit.from)}}class q{constructor(B,Q){this.d=B,this.e=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,Q,ie,se,Y){const de=this.d.getDocument(B),ye=g.Position.to(Q),je=await this.e.provideOnTypeFormattingEdits(de,ye,ie,se,Y);if(Array.isArray(je))return je.map(g.TextEdit.from)}}class me{constructor(B,Q){this.e=B,this.f=Q,this.d=new n.$Zac("WorkspaceSymbols")}async provideWorkspaceSymbols(B,Q){const ie=await this.e.provideWorkspaceSymbols(B,Q);if(!(0,P.$Jb)(ie))return{symbols:[]};const se=this.d.add(ie),Y={cacheId:se,symbols:[]};for(let de=0;de<ie.length;de++){const ye=ie[de];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}Y.symbols.push({...g.WorkspaceSymbol.from(ye),cacheId:[se,de]})}return Y}async resolveWorkspaceSymbol(B,Q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const ie=this.d.get(...B.cacheId);if(ie){const se=await this.e.resolveWorkspaceSymbol(ie,Q);return se&&(0,M.$Ym)(B,g.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class X{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,Q,ie){this.d=B,this.e=Q,this.f=ie}async provideRenameEdits(B,Q,ie,se){const Y=this.d.getDocument(B),de=g.Position.to(Q);try{const ye=await this.e.provideRenameEdits(Y,de,ie,se);return ye?g.WorkspaceEdit.from(ye):void 0}catch(ye){const je=X.g(ye);return je?{rejectReason:je,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(B,Q,ie){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const se=this.d.getDocument(B),Y=g.Position.to(Q);try{const de=await this.e.prepareRename(se,Y,ie);let ye,je;if(L.$4J.isRange(de)?(ye=de,je=se.getText(de)):(0,I.$lf)(de)&&(ye=de.range,je=de.placeholder),!ye||!je)return;if(ye.start.line>Y.line||ye.end.line<Y.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:g.Range.from(ye),text:je}}catch(de){const ye=X.g(de);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(de)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class Z{constructor(B,Q){this.resultId=B,this.tokens=Q}}class V{constructor(B,Q){this.f=B,this.g=Q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,Q,ie){const se=this.f.getDocument(B),Y=Q!==0?this.d.get(Q):null;let de=typeof Y?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(se,Y.resultId,ie):await this.g.provideDocumentSemanticTokens(se,ie);return Y&&this.d.delete(Q),de?(de=V.h(de),this.o(V.n(Y,de),de)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return V.j(B)?V.k(B)?B:new L.$hL(new Uint32Array(B.data),B.resultId):V.l(B)?V.m(B)?B:new L.$jL(B.edits.map(Q=>new L.$iL(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const Q of B.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static n(B,Q){if(!V.j(Q)||!B||!B.tokens)return Q;const ie=B.tokens,se=ie.length,Y=Q.data,de=Y.length;let ye=0;const je=Math.min(se,de);for(;ye<je&&ie[ye]===Y[ye];)ye++;if(ye===se&&ye===de)return new L.$jL([],Q.resultId);let We=0;const _e=je-ye;for(;We<_e&&ie[se-We-1]===Y[de-We-1];)We++;return new L.$jL([{start:ye,deleteCount:se-ye-We,data:Y.subarray(ye,de-We)}],Q.resultId)}o(B,Q){if(V.j(B)){const ie=this.e++;return this.d.set(ie,new Z(B.resultId,B.data)),(0,o.$t0)({id:ie,type:"full",data:B.data})}if(V.l(B)){const ie=this.e++;return V.j(Q)?this.d.set(ie,new Z(Q.resultId,Q.data)):this.d.set(ie,new Z(B.resultId)),(0,o.$t0)({id:ie,type:"delta",deltas:(B.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}class x{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentRangeSemanticTokens(B,Q,ie){const se=this.d.getDocument(B),Y=await this.e.provideDocumentRangeSemanticTokens(se,g.Range.to(Q),ie);return Y?this.f(Y):null}f(B){return(0,o.$t0)({id:0,type:"full",data:B.data})}}class ge{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,Q,ie,se,Y){this.f=B,this.g=Q,this.h=ie,this.j=se,this.k=Y,this.d=new n.$Zac("CompletionItem"),this.e=new Map}async provideCompletionItems(B,Q,ie,se){const Y=this.f.getDocument(B),de=g.Position.to(Q),ye=Y.getWordRangeAtPosition(de)||new L.$4J(de,de),je=ye.with({end:de}),We=new h.$bd,_e=await this.h.provideCompletionItems(Y,de,se,g.CompletionContext.to(ie));if(!_e||se.isCancellationRequested)return;const Ye=Array.isArray(_e)?new L.$xK(_e):_e,it=ge.supportsResolving(this.h)?this.d.add(Ye.items):this.d.add([]),et=new v.$jc;this.e.set(it,et);const Ae=[],Oe={x:it,b:Ae,a:{replace:g.Range.from(ye),insert:g.Range.from(je)},c:Ye.isIncomplete||void 0,d:We.elapsed()};for(let Ve=0;Ve<Ye.items.length;Ve++){const Le=Ye.items[Ve],Ze=this.l(Le,[it,Ve],je,ye);Ae.push(Ze)}return Oe}async resolveCompletionItem(B,Q){if(typeof this.h.resolveCompletionItem!="function")return;const ie=this.d.get(...B);if(!ie)return;const se=this.l(ie,B),Y=await this.h.resolveCompletionItem(ie,Q);if(!Y)return;const de=this.l(Y,B);return(se.h!==de.h||se.i!==de.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(se.n!==de.n||se.o!==de.o||!(0,M.$Zm)(se.p,de.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...se,d:de.d,c:de.c,l:de.l,h:de.h,i:de.i,n:de.n,o:de.o,p:de.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Q,ie,se){const Y=this.e.get(Q[0]);if(!Y)throw Error("DisposableStore is missing...");const de=this.g.toInternal(B.command,Y),ye={x:Q,a:B.label,b:B.kind!==void 0?g.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(g.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:g.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(g.TextEdit.from),n:de?.$ident,o:de?.id,p:de?.$ident?void 0:de?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=B.textEdit.newText):typeof B.insertText=="string"?ye.h=B.insertText:B.insertText instanceof L.$aK&&(ye.h=B.insertText.value,ye.i|=4);let je;return B.textEdit?je=B.textEdit.range:B.range&&(je=B.range),L.$4J.isRange(je)?ye.j=g.Range.from(je):je&&(!ie?.isEqual(je.inserting)||!se?.isEqual(je.replacing))&&(ye.j={insert:g.Range.from(je.inserting),replace:g.Range.from(je.replacing)}),ye}}class ue{async provideInlineCompletions(B,Q,ie,se){}disposeCompletions(B){}handleDidShowCompletionItem(B,Q,ie){}handlePartialAccept(B,Q,ie){}}class we extends ue{constructor(B,Q,ie,se){super(),this.f=B,this.g=Q,this.h=ie,this.j=se,this.d=new G,this.e=(0,t.$PF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$PF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,Q,ie,se){const Y=this.g.getDocument(B),de=g.Position.to(Q),ye=await this.h.provideInlineCompletionItems(Y,de,{selectedCompletionInfo:ie.selectedSuggestionInfo?{range:g.Range.to(ie.selectedSuggestionInfo.range),text:ie.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[ie.triggerKind]},se);if(!ye||se.isCancellationRequested)return;const je=Array.isArray(ye)?ye:ye.items,We=this.e?Array.isArray(ye)?[]:ye.commands||[]:[],_e=this.e&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let Ye;return{pid:this.d.createReferenceId({dispose(){Ye?.dispose()},items:je}),items:je.map((et,Ae)=>{let Oe;et.command&&(Ye||(Ye=new v.$jc),Oe=this.j.toInternal(et.command,Ye));const Ve=et.insertText;return{insertText:typeof Ve=="string"?Ve:{snippet:Ve.value},filterText:et.filterText,range:et.range?g.Range.from(et.range):void 0,command:Oe,idx:Ae,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:We.map(et=>(Ye||(Ye=new v.$jc),this.j.toInternal(et,Ye))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,Q,ie){const se=this.d.get(B)?.items[Q];se&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(se,ie)}handlePartialAccept(B,Q,ie){const se=this.d.get(B)?.items[Q];se&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(se,ie)}}class G{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const Q=this.e++;return this.d.set(Q,B),Q}disposeReferenceId(B){const Q=this.d.get(B);return this.d.delete(B),Q}get(B){return this.d.get(B)}}class U{constructor(B,Q){this.e=B,this.f=Q,this.d=new n.$Zac("SignatureHelp")}async provideSignatureHelp(B,Q,ie,se){const Y=this.e.getDocument(B),de=g.Position.to(Q),ye=this.g(ie),je=await this.f.provideSignatureHelp(Y,de,se,ye);if(je){const We=this.d.add([je]);return{...g.SignatureHelp.from(je),id:We}}}g(B){let Q;if(B.activeSignatureHelp){const ie=g.SignatureHelp.to(B.activeSignatureHelp),se=this.d.get(B.activeSignatureHelp.id,0);se?(Q=se,Q.activeSignature=ie.activeSignature,Q.activeParameter=ie.activeParameter):Q=ie}return{...B,activeSignatureHelp:Q}}releaseSignatureHelp(B){this.d.delete(B)}}class K{constructor(B,Q,ie,se,Y){this.f=B,this.g=Q,this.h=ie,this.j=se,this.k=Y,this.d=new n.$Zac("InlayHints"),this.e=new Map}async provideInlayHints(B,Q,ie){const se=this.f.getDocument(B),Y=g.Range.to(Q),de=await this.h.provideInlayHints(se,Y,ie);if(!Array.isArray(de)||de.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${Q}`);return}if(ie.isCancellationRequested)return;const ye=this.d.add(de);this.e.set(ye,new v.$jc);const je={hints:[],cacheId:ye};for(let We=0;We<de.length;We++)this.l(de[We],Y)&&je.hints.push(this.m(de[We],[ye,We]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for ${Q}`),je}async resolveInlayHint(B,Q){if(typeof this.h.resolveInlayHint!="function")return;const ie=this.d.get(...B);if(!ie)return;const se=await this.h.resolveInlayHint(ie,Q);if(se&&this.l(se))return this.m(se,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Q){return B.label.length===0||Array.isArray(B.label)&&B.label.every(ie=>ie.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(Q&&!Q.contains(B.position))}m(B,Q){const ie=this.e.get(Q[0]);if(!ie)throw Error("DisposableStore is missing...");const se={label:"",cacheId:Q,tooltip:g.MarkdownString.fromStrict(B.tooltip),position:g.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(g.TextEdit.from),kind:B.kind&&g.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?se.label=B.label:se.label=B.label.map(Y=>{const de={label:Y.value};return de.tooltip=g.MarkdownString.fromStrict(Y.tooltip),L.$bK.isLocation(Y.location)&&(de.location=g.location.from(Y.location)),Y.command&&(de.command=this.g.toInternal(Y.command,ie)),de}),se}}class fe{constructor(B,Q){this.e=B,this.f=Q,this.d=new n.$Zac("DocumentLink")}async provideLinks(B,Q){const ie=this.e.getDocument(B),se=await this.f.provideDocumentLinks(ie,Q);if(!(!Array.isArray(se)||se.length===0)&&!Q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:se.filter(fe.g).map(g.DocumentLink.from)};{const Y=this.d.add(se),de={links:[],cacheId:Y};for(let ye=0;ye<se.length;ye++){if(!fe.g(se[ye]))continue;const je=g.DocumentLink.from(se[ye]);je.cacheId=[Y,ye],de.links.push(je)}return de}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,Q){if(typeof this.f.resolveDocumentLink!="function")return;const ie=this.d.get(...B);if(!ie)return;const se=await this.f.resolveDocumentLink(ie,Q);if(!(!se||!fe.g(se)))return g.DocumentLink.from(se)}releaseLinks(B){this.d.delete(B)}}class te{constructor(B,Q){this.d=B,this.e=Q}async provideColors(B,Q){const ie=this.d.getDocument(B),se=await this.e.provideDocumentColors(ie,Q);return Array.isArray(se)?se.map(de=>({color:g.Color.from(de.color),range:g.Range.from(de.range)})):[]}async provideColorPresentations(B,Q,ie){const se=this.d.getDocument(B),Y=g.Range.to(Q.range),de=g.Color.to(Q.color),ye=await this.e.provideColorPresentations(de,{document:se,range:Y},ie);if(Array.isArray(ye))return ye.map(g.ColorPresentation.from)}}class re{constructor(B,Q){this.d=B,this.e=Q}async provideFoldingRanges(B,Q,ie){const se=this.d.getDocument(B),Y=await this.e.provideFoldingRanges(se,Q,ie);if(Array.isArray(Y))return Y.map(g.FoldingRange.from)}}class ne{constructor(B,Q,ie){this.d=B,this.e=Q,this.f=ie}async provideSelectionRanges(B,Q,ie){const se=this.d.getDocument(B),Y=Q.map(g.Position.to),de=await this.e.provideSelectionRanges(se,Y,ie);if(!(0,P.$Jb)(de))return[];if(de.length!==Y.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let je=0;je<Y.length;je++){const We=[];ye.push(We);let _e=Y[je],Ye=de[je];for(;;){if(!Ye.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(We.push(g.SelectionRange.from(Ye)),!Ye.parent)break;_e=Ye.range,Ye=Ye.parent}}return ye}}class Ee{constructor(B,Q){this.f=B,this.g=Q,this.d=new s.$7L(""),this.e=new Map}async prepareSession(B,Q,ie){const se=this.f.getDocument(B),Y=g.Position.to(Q),de=await this.g.prepareCallHierarchy(se,Y,ie);if(!de)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(de)?de.map(je=>this.h(ye,je)):[this.h(ye,de)]}async provideCallsTo(B,Q,ie){const se=this.j(B,Q);if(!se)throw new Error("missing call hierarchy item");const Y=await this.g.provideCallHierarchyIncomingCalls(se,ie);if(Y)return Y.map(de=>({from:this.h(B,de.from),fromRanges:de.fromRanges.map(ye=>g.Range.from(ye))}))}async provideCallsFrom(B,Q,ie){const se=this.j(B,Q);if(!se)throw new Error("missing call hierarchy item");const Y=await this.g.provideCallHierarchyOutgoingCalls(se,ie);if(Y)return Y.map(de=>({to:this.h(B,de.to),fromRanges:de.fromRanges.map(ye=>g.Range.from(ye))}))}releaseSession(B){this.e.delete(B)}h(B,Q){const ie=this.e.get(B),se=g.CallHierarchyItem.from(Q,B,ie.size.toString(36));return ie.set(se._itemId,Q),se}j(B,Q){return this.e.get(B)?.get(Q)}}class oe{constructor(B,Q){this.f=B,this.g=Q,this.d=new s.$7L(""),this.e=new Map}async prepareSession(B,Q,ie){const se=this.f.getDocument(B),Y=g.Position.to(Q),de=await this.g.prepareTypeHierarchy(se,Y,ie);if(!de)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(de)?de.map(je=>this.h(ye,je)):[this.h(ye,de)]}async provideSupertypes(B,Q,ie){const se=this.j(B,Q);if(!se)throw new Error("missing type hierarchy item");const Y=await this.g.provideTypeHierarchySupertypes(se,ie);if(Y)return Y.map(de=>this.h(B,de))}async provideSubtypes(B,Q,ie){const se=this.j(B,Q);if(!se)throw new Error("missing type hierarchy item");const Y=await this.g.provideTypeHierarchySubtypes(se,ie);if(Y)return Y.map(de=>this.h(B,de))}releaseSession(B){this.e.delete(B)}h(B,Q){const ie=this.e.get(B),se=g.TypeHierarchyItem.from(Q,B,ie.size.toString(36));return ie.set(se._itemId,Q),se}j(B,Q){return this.e.get(B)?.get(Q)}}class he{static toInternalProviderId(B,Q){return B+"."+Q}constructor(B,Q,ie,se,Y){this.d=B,this.e=Q,this.f=ie,this.g=se,this.h=Y}async provideDocumentOnDropEdits(B,Q,ie,se,Y){const de=this.e.getDocument(Q),ye=g.Position.to(ie),je=g.DataTransfer.toDataTransfer(se,async _e=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,_e)).buffer),We=await this.f.provideDocumentDropEdits(de,ye,je,Y);if(We)return{label:We.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:he.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?g.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class ee{constructor(B,Q){this.d=B,this.e=Q}async provideMappedEdits(B,Q,ie,se){const Y=D.URI.revive(B),de=this.d.getDocument(Y),ye={selections:ie.selections.map(We=>g.Selection.to(We)),related:ie.related.map(We=>({uri:D.URI.revive(We.uri),range:g.Range.to(We.range)}))},je=await this.e.provideMappedEdits(de,Q,ye,se);return je?g.WorkspaceEdit.from(je):null}}class le{constructor(B,Q){this.adapter=B,this.extension=Q}}class be{static{this.d=0}constructor(B,Q,ie,se,Y,de,ye,je){this.g=Q,this.h=ie,this.j=se,this.k=Y,this.l=de,this.m=ye,this.n=je,this.f=new Map,this.e=B.getProxy(m.$ZJ.MainThreadLanguageFeatures)}o(B,Q){return g.DocumentSelector.from(B,this.g,Q)}p(B){return new L.$2J(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return be.d++}async t(B,Q,ie,se,Y,de=!1){const ye=this.f.get(B);if(!ye||!(ye.adapter instanceof Q))return se;const je=Date.now();de||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${ie.toString().replace(/[\r\n]/g,"")}'`);const We=ie(ye.adapter,ye.extension);return Promise.resolve(We).catch(_e=>{(0,$.$2)(_e)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(ye.extension.identifier,_e))}).finally(()=>{de||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),S.CancellationToken.isCancellationToken(Y)?(0,d.$wg)(We,Y):We}u(B,Q){const ie=this.q();return this.f.set(ie,new le(B,Q)),ie}static w(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,Q,ie,se){const Y=this.u(new a(this.h,ie),B),de=se&&se.label||be.w(B);return this.e.$registerDocumentSymbolProvider(Y,this.o(Q,B),de),this.p(Y)}$provideDocumentSymbols(B,Q,ie){return this.t(B,a,se=>se.provideDocumentSymbols(D.URI.revive(Q),ie),void 0,ie)}registerCodeLensProvider(B,Q,ie){const se=this.q(),Y=typeof ie.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(se,new le(new i(this.h,this.j.converter,ie),B)),this.e.$registerCodeLensSupport(se,this.o(Q,B),Y);let de=this.p(se);if(Y!==void 0){const ye=ie.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(Y));de=L.$2J.from(de,ye)}return de}$provideCodeLenses(B,Q,ie){return this.t(B,i,se=>se.provideCodeLenses(D.URI.revive(Q),ie),void 0,ie)}$resolveCodeLens(B,Q,ie){return this.t(B,i,se=>se.resolveCodeLens(Q,ie),void 0,void 0)}$releaseCodeLenses(B,Q){this.t(B,i,ie=>Promise.resolve(ie.releaseCodeLenses(Q)),void 0,void 0)}registerDefinitionProvider(B,Q,ie){const se=this.u(new f(this.h,ie),B);return this.e.$registerDefinitionSupport(se,this.o(Q,B)),this.p(se)}$provideDefinition(B,Q,ie,se){return this.t(B,f,Y=>Y.provideDefinition(D.URI.revive(Q),ie,se),[],se)}registerDeclarationProvider(B,Q,ie){const se=this.u(new y(this.h,ie),B);return this.e.$registerDeclarationSupport(se,this.o(Q,B)),this.p(se)}$provideDeclaration(B,Q,ie,se){return this.t(B,y,Y=>Y.provideDeclaration(D.URI.revive(Q),ie,se),[],se)}registerImplementationProvider(B,Q,ie){const se=this.u(new E(this.h,ie),B);return this.e.$registerImplementationSupport(se,this.o(Q,B)),this.p(se)}$provideImplementation(B,Q,ie,se){return this.t(B,E,Y=>Y.provideImplementation(D.URI.revive(Q),ie,se),[],se)}registerTypeDefinitionProvider(B,Q,ie){const se=this.u(new u(this.h,ie),B);return this.e.$registerTypeDefinitionSupport(se,this.o(Q,B)),this.p(se)}$provideTypeDefinition(B,Q,ie,se){return this.t(B,u,Y=>Y.provideTypeDefinition(D.URI.revive(Q),ie,se),[],se)}registerHoverProvider(B,Q,ie,se){const Y=this.u(new l(this.h,ie),B);return this.e.$registerHoverProvider(Y,this.o(Q,B)),this.p(Y)}$provideHover(B,Q,ie,se){return this.t(B,l,Y=>Y.provideHover(D.URI.revive(Q),ie,se),void 0,se)}registerEvaluatableExpressionProvider(B,Q,ie,se){const Y=this.u(new w(this.h,ie),B);return this.e.$registerEvaluatableExpressionProvider(Y,this.o(Q,B)),this.p(Y)}$provideEvaluatableExpression(B,Q,ie,se){return this.t(B,w,Y=>Y.provideEvaluatableExpression(D.URI.revive(Q),ie,se),void 0,se)}registerInlineValuesProvider(B,Q,ie,se){const Y=typeof ie.onDidChangeInlineValues=="function"?this.q():void 0,de=this.u(new A(this.h,ie),B);this.e.$registerInlineValuesProvider(de,this.o(Q,B),Y);let ye=this.p(de);if(Y!==void 0){const je=ie.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(Y));ye=L.$2J.from(ye,je)}return ye}$provideInlineValues(B,Q,ie,se,Y){return this.t(B,A,de=>de.provideInlineValues(D.URI.revive(Q),ie,se,Y),void 0,Y)}registerDocumentHighlightProvider(B,Q,ie){const se=this.u(new N(this.h,ie),B);return this.e.$registerDocumentHighlightProvider(se,this.o(Q,B)),this.p(se)}$provideDocumentHighlights(B,Q,ie,se){return this.t(B,N,Y=>Y.provideDocumentHighlights(D.URI.revive(Q),ie,se),void 0,se)}registerLinkedEditingRangeProvider(B,Q,ie){const se=this.u(new O(this.h,ie),B);return this.e.$registerLinkedEditingRangeProvider(se,this.o(Q,B)),this.p(se)}$provideLinkedEditingRanges(B,Q,ie,se){return this.t(B,O,async Y=>{const de=await Y.provideLinkedEditingRanges(D.URI.revive(Q),ie,se);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?be.y(de.wordPattern):void 0}},void 0,se)}registerReferenceProvider(B,Q,ie){const se=this.u(new F(this.h,ie),B);return this.e.$registerReferenceSupport(se,this.o(Q,B)),this.p(se)}$provideReferences(B,Q,ie,se,Y){return this.t(B,F,de=>de.provideReferences(D.URI.revive(Q),ie,se,Y),void 0,Y)}registerCodeActionProvider(B,Q,ie,se){const Y=new v.$jc,de=this.u(new j(this.h,this.j.converter,this.k,ie,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(de,this.o(Q,B),{providedKinds:se?.providedCodeActionKinds?.map(ye=>ye.value),documentation:se?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,Y)}))},be.w(B),!!ie.resolveCodeAction),Y.add(this.p(de)),Y}$provideCodeActions(B,Q,ie,se,Y){return this.t(B,j,de=>de.provideCodeActions(D.URI.revive(Q),ie,se,Y),void 0,Y)}$resolveCodeAction(B,Q,ie){return this.t(B,j,se=>se.resolveCodeAction(Q,ie),{},void 0)}$releaseCodeActions(B,Q){this.t(B,j,ie=>Promise.resolve(ie.releaseCodeActions(Q)),void 0,void 0)}registerDocumentFormattingEditProvider(B,Q,ie){const se=this.u(new T(this.h,ie),B);return this.e.$registerDocumentFormattingSupport(se,this.o(Q,B),B.identifier,B.displayName||B.name),this.p(se)}$provideDocumentFormattingEdits(B,Q,ie,se){return this.t(B,T,Y=>Y.provideDocumentFormattingEdits(D.URI.revive(Q),ie,se),void 0,se)}registerDocumentRangeFormattingEditProvider(B,Q,ie){const se=typeof ie.provideDocumentRangesFormattingEdits=="function",Y=this.u(new H(this.h,ie),B);return this.e.$registerRangeFormattingSupport(Y,this.o(Q,B),B.identifier,B.displayName||B.name,se),this.p(Y)}$provideDocumentRangeFormattingEdits(B,Q,ie,se,Y){return this.t(B,H,de=>de.provideDocumentRangeFormattingEdits(D.URI.revive(Q),ie,se,Y),void 0,Y)}$provideDocumentRangesFormattingEdits(B,Q,ie,se,Y){return this.t(B,H,de=>de.provideDocumentRangesFormattingEdits(D.URI.revive(Q),ie,se,Y),void 0,Y)}registerOnTypeFormattingEditProvider(B,Q,ie,se){const Y=this.u(new q(this.h,ie),B);return this.e.$registerOnTypeFormattingSupport(Y,this.o(Q,B),se,B.identifier),this.p(Y)}$provideOnTypeFormattingEdits(B,Q,ie,se,Y,de){return this.t(B,q,ye=>ye.provideOnTypeFormattingEdits(D.URI.revive(Q),ie,se,Y,de),void 0,de)}registerWorkspaceSymbolProvider(B,Q){const ie=this.u(new me(Q,this.l),B);return this.e.$registerNavigateTypeSupport(ie,typeof Q.resolveWorkspaceSymbol=="function"),this.p(ie)}$provideWorkspaceSymbols(B,Q,ie){return this.t(B,me,se=>se.provideWorkspaceSymbols(Q,ie),{symbols:[]},ie)}$resolveWorkspaceSymbol(B,Q,ie){return this.t(B,me,se=>se.resolveWorkspaceSymbol(Q,ie),void 0,void 0)}$releaseWorkspaceSymbols(B,Q){this.t(B,me,ie=>ie.releaseWorkspaceSymbols(Q),void 0,void 0)}registerRenameProvider(B,Q,ie){const se=this.u(new X(this.h,ie,this.l),B);return this.e.$registerRenameSupport(se,this.o(Q,B),X.supportsResolving(ie)),this.p(se)}$provideRenameEdits(B,Q,ie,se,Y){return this.t(B,X,de=>de.provideRenameEdits(D.URI.revive(Q),ie,se,Y),void 0,Y)}$resolveRenameLocation(B,Q,ie,se){return this.t(B,X,Y=>Y.resolveRenameLocation(D.URI.revive(Q),ie,se),void 0,se)}registerDocumentSemanticTokensProvider(B,Q,ie,se){const Y=this.u(new V(this.h,ie),B),de=typeof ie.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Y,this.o(Q,B),se,de);let ye=this.p(Y);if(de){const je=ie.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(de));ye=L.$2J.from(ye,je)}return ye}$provideDocumentSemanticTokens(B,Q,ie,se){return this.t(B,V,Y=>Y.provideDocumentSemanticTokens(D.URI.revive(Q),ie,se),null,se)}$releaseDocumentSemanticTokens(B,Q){this.t(B,V,ie=>ie.releaseDocumentSemanticColoring(Q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,Q,ie,se){const Y=this.u(new x(this.h,ie),B);return this.e.$registerDocumentRangeSemanticTokensProvider(Y,this.o(Q,B),se),this.p(Y)}$provideDocumentRangeSemanticTokens(B,Q,ie,se){return this.t(B,x,Y=>Y.provideDocumentRangeSemanticTokens(D.URI.revive(Q),ie,se),null,se)}registerCompletionItemProvider(B,Q,ie,se){const Y=this.u(new ge(this.h,this.j.converter,ie,this.m,B),B);return this.e.$registerCompletionsProvider(Y,this.o(Q,B),se,ge.supportsResolving(ie),B.identifier),this.p(Y)}$provideCompletionItems(B,Q,ie,se,Y){return this.t(B,ge,de=>de.provideCompletionItems(D.URI.revive(Q),ie,se,Y),void 0,Y)}$resolveCompletionItem(B,Q,ie){return this.t(B,ge,se=>se.resolveCompletionItem(Q,ie),void 0,ie)}$releaseCompletionItems(B,Q){this.t(B,ge,ie=>ie.releaseCompletionItems(Q),void 0,void 0)}registerInlineCompletionsProvider(B,Q,ie,se){const Y=new we(B,this.h,ie,this.j.converter),de=this.u(Y,B);return this.e.$registerInlineCompletionsSupport(de,this.o(Q,B),Y.supportsHandleEvents,C.$Vl.toKey(B.identifier.value),se?.yieldTo?.map(ye=>C.$Vl.toKey(ye))||[]),this.p(de)}$provideInlineCompletions(B,Q,ie,se,Y){return this.t(B,ue,de=>de.provideInlineCompletions(D.URI.revive(Q),ie,se,Y),void 0,Y)}$handleInlineCompletionDidShow(B,Q,ie,se){this.t(B,ue,async Y=>{Y.handleDidShowCompletionItem(Q,ie,se)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,Q,ie,se){this.t(B,ue,async Y=>{Y.handlePartialAccept(Q,ie,se)},void 0,void 0)}$freeInlineCompletionsList(B,Q){this.t(B,ue,async ie=>{ie.disposeCompletions(Q)},void 0,void 0)}registerSignatureHelpProvider(B,Q,ie,se){const Y=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,de=this.u(new U(this.h,ie),B);return this.e.$registerSignatureHelpProvider(de,this.o(Q,B),Y),this.p(de)}$provideSignatureHelp(B,Q,ie,se,Y){return this.t(B,U,de=>de.provideSignatureHelp(D.URI.revive(Q),ie,se,Y),void 0,Y)}$releaseSignatureHelp(B,Q){this.t(B,U,ie=>ie.releaseSignatureHelp(Q),void 0,void 0)}registerInlayHintsProvider(B,Q,ie){const se=typeof ie.onDidChangeInlayHints=="function"?this.q():void 0,Y=this.u(new K(this.h,this.j.converter,ie,this.l,B),B);this.e.$registerInlayHintsProvider(Y,this.o(Q,B),typeof ie.resolveInlayHint=="function",se,be.w(B));let de=this.p(Y);if(se!==void 0){const ye=ie.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(se));de=L.$2J.from(de,ye)}return de}$provideInlayHints(B,Q,ie,se){return this.t(B,K,Y=>Y.provideInlayHints(D.URI.revive(Q),ie,se),void 0,se)}$resolveInlayHint(B,Q,ie){return this.t(B,K,se=>se.resolveInlayHint(Q,ie),void 0,ie)}$releaseInlayHints(B,Q){this.t(B,K,ie=>ie.releaseHints(Q),void 0,void 0)}registerDocumentLinkProvider(B,Q,ie){const se=this.u(new fe(this.h,ie),B);return this.e.$registerDocumentLinkProvider(se,this.o(Q,B),typeof ie.resolveDocumentLink=="function"),this.p(se)}$provideDocumentLinks(B,Q,ie){return this.t(B,fe,se=>se.provideLinks(D.URI.revive(Q),ie),void 0,ie,Q.scheme==="output")}$resolveDocumentLink(B,Q,ie){return this.t(B,fe,se=>se.resolveLink(Q,ie),void 0,void 0,!0)}$releaseDocumentLinks(B,Q){this.t(B,fe,ie=>ie.releaseLinks(Q),void 0,void 0,!0)}registerColorProvider(B,Q,ie){const se=this.u(new te(this.h,ie),B);return this.e.$registerDocumentColorProvider(se,this.o(Q,B)),this.p(se)}$provideDocumentColors(B,Q,ie){return this.t(B,te,se=>se.provideColors(D.URI.revive(Q),ie),[],ie)}$provideColorPresentations(B,Q,ie,se){return this.t(B,te,Y=>Y.provideColorPresentations(D.URI.revive(Q),ie,se),void 0,se)}registerFoldingRangeProvider(B,Q,ie){const se=this.q(),Y=typeof ie.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(se,new le(new re(this.h,ie),B)),this.e.$registerFoldingRangeProvider(se,this.o(Q,B),B.identifier,Y);let de=this.p(se);if(Y!==void 0){const ye=ie.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Y));de=L.$2J.from(de,ye)}return de}$provideFoldingRanges(B,Q,ie,se){return this.t(B,re,Y=>Y.provideFoldingRanges(D.URI.revive(Q),ie,se),void 0,se)}registerSelectionRangeProvider(B,Q,ie){const se=this.u(new ne(this.h,ie,this.l),B);return this.e.$registerSelectionRangeProvider(se,this.o(Q,B)),this.p(se)}$provideSelectionRanges(B,Q,ie,se){return this.t(B,ne,Y=>Y.provideSelectionRanges(D.URI.revive(Q),ie,se),[],se)}registerCallHierarchyProvider(B,Q,ie){const se=this.u(new Ee(this.h,ie),B);return this.e.$registerCallHierarchyProvider(se,this.o(Q,B)),this.p(se)}$prepareCallHierarchy(B,Q,ie,se){return this.t(B,Ee,Y=>Promise.resolve(Y.prepareSession(D.URI.revive(Q),ie,se)),void 0,se)}$provideCallHierarchyIncomingCalls(B,Q,ie,se){return this.t(B,Ee,Y=>Y.provideCallsTo(Q,ie,se),void 0,se)}$provideCallHierarchyOutgoingCalls(B,Q,ie,se){return this.t(B,Ee,Y=>Y.provideCallsFrom(Q,ie,se),void 0,se)}$releaseCallHierarchy(B,Q){this.t(B,Ee,ie=>Promise.resolve(ie.releaseSession(Q)),void 0,void 0)}registerTypeHierarchyProvider(B,Q,ie){const se=this.u(new oe(this.h,ie),B);return this.e.$registerTypeHierarchyProvider(se,this.o(Q,B)),this.p(se)}$prepareTypeHierarchy(B,Q,ie,se){return this.t(B,oe,Y=>Promise.resolve(Y.prepareSession(D.URI.revive(Q),ie,se)),void 0,se)}$provideTypeHierarchySupertypes(B,Q,ie,se){return this.t(B,oe,Y=>Y.provideSupertypes(Q,ie,se),void 0,se)}$provideTypeHierarchySubtypes(B,Q,ie,se){return this.t(B,oe,Y=>Y.provideSubtypes(Q,ie,se),void 0,se)}$releaseTypeHierarchy(B,Q){this.t(B,oe,ie=>Promise.resolve(ie.releaseSession(Q)),void 0,void 0)}registerDocumentOnDropEditProvider(B,Q,ie,se){const Y=this.q();this.f.set(Y,new le(new he(this.e,this.h,ie,Y,B),B));const de=(0,t.$PF)(B,"dropMetadata")&&se?he.toInternalProviderId(B.identifier.value,se.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Y,this.o(Q,B),de,(0,t.$PF)(B,"dropMetadata")?se:void 0),this.p(Y)}$provideDocumentOnDropEdits(B,Q,ie,se,Y,de){return this.t(B,he,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(Q,D.URI.revive(ie),se,Y,de)),void 0,void 0)}registerMappedEditsProvider(B,Q,ie){const se=this.u(new ee(this.h,ie),B);return this.e.$registerMappedEditsProvider(se,this.o(Q,B)),this.p(se)}$provideMappedEdits(B,Q,ie,se,Y){return this.t(B,ee,de=>Promise.resolve(de.provideMappedEdits(Q,ie,se,Y)),null,Y)}registerDocumentPasteEditProvider(B,Q,ie,se){const Y=this.q();this.f.set(Y,new le(new z(this.e,this.h,ie,Y,B),B));const de=z.toInternalProviderId(B.identifier.value,se.id);return this.e.$registerPasteEditProvider(Y,this.o(Q,B),de,{supportsCopy:!!ie.prepareDocumentPaste,supportsPaste:!!ie.provideDocumentPasteEdits,copyMimeTypes:se.copyMimeTypes,pasteMimeTypes:se.pasteMimeTypes}),this.p(Y)}$prepareDocumentPaste(B,Q,ie,se,Y){return this.t(B,z,de=>de.prepareDocumentPaste(D.URI.revive(Q),ie,se,Y),void 0,Y)}$providePasteEdits(B,Q,ie,se,Y,de){return this.t(B,z,ye=>ye.providePasteEdits(Q,D.URI.revive(ie),se,Y,de),void 0,de)}static y(B){return{pattern:B.source,flags:B.flags}}static z(B){return{decreaseIndentPattern:be.y(B.decreaseIndentPattern),increaseIndentPattern:be.y(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?be.y(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?be.y(B.unIndentedLinePattern):void 0}}static B(B){return{beforeText:be.y(B.beforeText),afterText:B.afterText?be.y(B.afterText):void 0,previousLineText:B.previousLineText?be.y(B.previousLineText):void 0,action:B.action}}static C(B){return B.map(be.B)}setLanguageConfiguration(B,Q,ie){const{wordPattern:se}=ie;if(se&&(0,k.$ze)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this.h.setWordDefinitionFor(Q,se):this.h.setWordDefinitionFor(Q,void 0),ie.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),ie.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use."),ie.autoClosingPairs&&(0,t.$QF)(B,"languageConfigurationAutoClosingPairs");const Y=this.q(),de={comments:ie.comments,brackets:ie.brackets,wordPattern:ie.wordPattern?be.y(ie.wordPattern):void 0,indentationRules:ie.indentationRules?be.z(ie.indentationRules):void 0,onEnterRules:ie.onEnterRules?be.C(ie.onEnterRules):void 0,__electricCharacterSupport:ie.__electricCharacterSupport,__characterPairSupport:ie.__characterPairSupport,autoClosingPairs:ie.autoClosingPairs};return this.e.$setLanguageConfiguration(Y,Q,de),this.p(Y)}$setWordDefinitions(B){for(const Q of B)this.h.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.$9ac=be}),define(Se[317],De([1,0,6,13,7,38,9,3]),function($e,e,D,M,g,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=void 0;class k{constructor(P,I,p,S){this.c=I,this.d=p,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(D.$ZJ.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,I){await this.a.$changeLanguage(P,I);const p=this.c.getDocumentData(P);if(!p)throw new Error(`document '${P.toString()}' NOT found`);return p.document}async tokenAtPosition(P,I){const p=P.version,S=M.Position.from(I),C=await this.a.$tokensAtPosition(P.uri,S),v={type:g.StandardTokenType.Other,range:P.getWordRangeAtPosition(I)??new g.$4J(I.line,I.character,I.line,I.character)};if(!C)return v;const o={range:M.Range.to(C.range),type:M.TokenType.to(C.type)};return!o.range.contains(I)||p!==P.version?v:o}createLanguageStatusItem(P,I,p){const S=this.f++,C=this.a,v=this.g,o=`${P.identifier.value}/${I}`;if(v.has(o))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);v.add(o);const s={selector:p,id:I,name:P.displayName??P.name,severity:g.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const h=new m.$jc,$=()=>{if(n?.dispose(),!v.has(o)){console.warn(`LanguageStatusItem (${I}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,R.$Ig)(()=>{h.clear(),this.a.$setLanguageStatus(S,{id:o,name:s.name??P.displayName??P.name,source:P.displayName??P.name,selector:M.DocumentSelector.from(s.selector,this.e),label:s.text,detail:s.detail??"",severity:s.severity===g.LanguageStatusSeverity.Error?L.default.Error:s.severity===g.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:s.command&&this.d.toInternal(s.command,h),accessibilityInfo:s.accessibilityInformation,busy:s.busy})},0)},d={dispose(){h.dispose(),n?.dispose(),C.$removeLanguageStatus(S),v.delete(o)},get id(){return s.id},get name(){return s.name},set name(t){s.name=t,$()},get selector(){return s.selector},set selector(t){s.selector=t,$()},get text(){return s.text},set text(t){s.text=t,$()},get detail(){return s.detail},set detail(t){s.detail=t,$()},get severity(){return s.severity},set severity(t){s.severity=t,$()},get accessibilityInformation(){return s.accessibilityInformation},set accessibilityInformation(t){s.accessibilityInformation=t,$()},get command(){return s.command},set command(t){s.command=t,$()},get busy(){return s.busy},set busy(t){s.busy=t,$()}};return $(),d}}e.$Qbc=k}),define(Se[112],De([1,0,12,15,2,5,14,6,26,20]),function($e,e,D,M,g,L,R,m,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gbc=e.$Fbc=void 0;let P=class{constructor(p,S,C){this.f=C,this.d=new Map,this.a=S.getProxy(m.$ZJ.MainThreadLocalization),this.b=p.environment.appLanguage,this.c=this.b===D.$f}getMessage(p,S){const{message:C,args:v,comment:o}=S;if(this.c)return(0,M.$oe)(C,v??{});let s=C;o&&o.length>0&&(s+=`/${Array.isArray(o)?o.join(""):o}`);const n=this.d.get(p)?.contents[s];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,M.$oe)(n??C,v??{})}getBundle(p){return this.d.get(p)?.contents}getBundleUri(p){return this.d.get(p)?.uri}async initializeLocalizedMessages(p){if(this.c||!p.l10n&&!p.isBuiltin||this.d.has(p.identifier.value))return;let S;const C=await this.g(p);if(!C){this.f.error(`No bundle location found for extension ${p.identifier.value}`);return}try{const v=await this.a.$fetchBundleContents(C),o=JSON.parse(v);S=p.isBuiltin?o.contents?.bundle:o}catch(v){this.f.error(`Failed to load translations for ${p.identifier.value} from ${C}: ${v.message}`);return}S&&this.d.set(p.identifier.value,{contents:S,uri:C})}async g(p){if(p.isBuiltin){const S=await this.a.$fetchBuiltInBundleUri(p.identifier.value,this.b);return g.URI.revive(S)}return p.l10n?g.URI.joinPath(p.extensionLocation,p.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Fbc=P,e.$Fbc=P=Ke([Be(0,k.$fM),Be(1,b.$2L),Be(2,R.$5i)],P),e.$Gbc=(0,L.$Bh)("IExtHostLocalizationService")}),define(Se[150],De([1,0,14,6,26,20,2,63]),function($e,e,D,M,g,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=void 0;let k=class extends D.$dj{constructor(I,p){super(p.logLevel,p.logsLocation,p.loggers.map(S=>(0,m.$$g)(S))),this.r=I.getProxy(M.$ZJ.MainThreadLogger)}$setLogLevel(I,p){p?this.setLogLevel(R.URI.revive(p),I):this.setLogLevel(I)}setVisibility(I,p){super.setVisibility(I,p),this.r.$setVisibility(I,p)}s(I,p,S){return new b(this.r,I,p,S)}};e.$8cc=k,e.$8cc=k=Ke([Be(0,L.$2L),Be(1,g.$fM)],k);class b extends D.$$i{constructor(I,p,S,C){super(C?.logLevel==="always"),this.r=I,this.s=p,this.m=!1,this.n=[],this.setLevel(S),this.r.$createLogger(p,C).then(()=>{this.u(this.n),this.m=!0})}g(I,p){const S=[[I,p]];this.m?this.u(S):this.n.push(...S)}u(I){this.r.$log(this.s,I)}flush(){this.r.$flush(this.s)}}}),define(Se[113],De([1,0,6,5,3,20,22]),function($e,e,D,M,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=e.$Hbc=void 0,e.$Hbc=(0,M.$Bh)("IExtHostManagedSockets");let m=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(D.$ZJ.MainThreadManagedSockets)}setFactory(I,p){for(const S of this.d.values())S.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new k(I,p),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const p=++this.b,S=await this.c.makeConnection(),C=new g.$jc;return this.d.set(p,new b(p,S,C)),C.add((0,g.$ic)(()=>this.d.delete(p))),C.add(S.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(p),C.dispose()})),C.add(S.onDidClose(v=>{this.a.$onDidManagedSocketClose(p,v?.stack??v?.message),C.dispose()})),C.add(S.onDidReceiveMessage(v=>this.a.$onDidManagedSocketHaveData(p,R.$Fd.wrap(v)))),p}$remoteSocketWrite(I,p){this.d.get(I)?.actual.send(p.buffer)}$remoteSocketEnd(I){const p=this.d.get(I);p&&(p.actual.end(),p.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$Ibc=m,e.$Ibc=m=Ke([Be(0,L.$2L)],m);class k{constructor(I,p){this.socketFactoryId=I,this.makeConnection=p}}class b extends g.$kc{constructor(I,p,S){super(),this.socketId=I,this.actual=p,this.B(S)}}}),define(Se[318],De([1,0,6,14,27]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=void 0;function L(m){return m&&m.title}let R=class{constructor(k,b){this.b=b,this.a=k.getProxy(D.$ZJ.MainThreadMessageService)}showMessage(k,b,P,I,p){const S={source:{identifier:k.identifier,label:k.displayName||k.name}};let C;typeof I=="string"||L(I)?C=[I,...p]:(S.modal=I?.modal,S.useCustom=I?.useCustom,S.detail=I?.detail,C=p),S.useCustom&&(0,g.$QF)(k,"resolvers");const v=[];for(let o=0;o<C.length;o++){const s=C[o];if(typeof s=="string")v.push({title:s,handle:o,isCloseAffordance:!1});else if(typeof s=="object"){const{title:n,isCloseAffordance:h}=s;v.push({title:n,isCloseAffordance:!!h,handle:o})}else this.b.warn("Invalid message item:",s)}return this.a.$showMessage(b,P,S,v).then(o=>{if(typeof o=="number")return C[o]})}};e.$Rbc=R,e.$Rbc=R=Ke([Be(1,M.$5i)],R)}),define(Se[319],De([1,0,207,22,4,3,28,15,18,2,30,87,6,33,13,7,70,281,144,8,23,17]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o,s,n,h,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0;class t{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(a=>a.apiEditor)}constructor(a,i,c,f,y){this.q=c,this.r=f,this.s=y,this.f=new Map,this.g=new R.$zi,this.h=new Map,this.j=new g.$fd({onListenerError:h.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new g.$fd({onListenerError:h.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new g.$fd({onListenerError:h.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new g.$fd({onListenerError:h.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$Zac("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=a.getProxy(p.$ZJ.MainThreadNotebook),this.c=a.getProxy(p.$ZJ.MainThreadNotebookDocuments),this.d=a.getProxy(p.$ZJ.MainThreadNotebookEditors),this.i=i.converter,i.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===13){const u=E.notebookEditor?.notebookUri,l=E.cell.handle,A=this.g.get(u)?.getCell(l);if(A)return A.apiCell}if(E&&E.$mid===14){const u=E.uri,l=this.g.get(u);if(l)return l.apiNotebook}return E}}),t.A(i)}getEditorById(a){const i=this.h.get(a);if(!i)throw new Error(`unknown text editor: ${a}. known editors: ${[...this.h.keys()]} `);return i}getIdByEditor(a){for(const[i,c]of this.h)if(c.apiEditor===a)return i}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(a,i){const c=this.g.get(a);if(!c&&!i)throw new Error(`NO notebook document for '${a}'`);return c}static t(a,i){if(!i)return;const c=i.filenamePattern.map(f=>C.NotebookExclusiveDocumentPattern.from(f)).filter(f=>f!==void 0);if(i.filenamePattern&&!c){console.warn(`Notebook content provider view options file name pattern is invalid ${i.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:i.displayName,filenamePattern:c,exclusive:i.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,i,c){const f=t.a++,y=typeof c.onDidChangeCellStatusBarItems=="function"?t.a++:void 0;this.f.set(f,c),this.b.$registerNotebookCellStatusBarItemProvider(f,y,i);let E;return y!==void 0&&(E=c.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(y))),new v.$2J(()=>{this.f.delete(f),this.b.$unregisterNotebookCellStatusBarItemProvider(f,y),E?.dispose()})}async createNotebookDocument(a){const i=await this.c.$tryCreateNotebook({viewType:a.viewType,content:a.content&&C.NotebookData.from(a.content)});return b.URI.revive(i)}async openNotebookDocument(a){const i=this.g.get(a);if(i)return i.apiNotebook;const c=await this.c.$tryOpenNotebook(a),f=this.g.get(b.URI.revive(c));return(0,k.$uf)(f?.apiNotebook)}async showNotebookDocument(a,i){b.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let c;typeof i=="object"?c={position:C.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus,selections:i.selections&&i.selections.map(C.NotebookRange.from),pinned:typeof i.preview=="boolean"?!i.preview:void 0}:c={preserveFocus:!1};const f=await this.d.$tryShowNotebookDocument(a.uri,a.notebookType,c),y=f&&this.h.get(f)?.apiEditor;if(y)return y;throw f?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,i,c,f){const y=this.f.get(a),E=b.URI.revive(i),u=this.g.get(E);if(!u||!y)return;const l=u.getCellFromIndex(c);if(!l)return;const w=await y.provideCellStatusBarItems(l.apiCell,f);if(!w)return;const A=new L.$jc,N=this.p.add([A]),F=(Array.isArray(w)?w:[w]).map(j=>C.NotebookStatusBarItem.from(j,this.i,A));return{cacheId:N,items:F}}$releaseNotebookCellStatusBarItems(a){this.p.delete(a)}registerNotebookSerializer(a,i,c,f,y){if((0,m.$me)(i))throw new Error("viewType cannot be empty or just whitespace");const E=this.u++;return this.w.set(E,{viewType:i,serializer:c,options:f}),this.b.$registerNotebookSerializer(E,{id:a.identifier,location:a.extensionLocation},i,C.NotebookDocumentContentOptions.from(f),t.t(a,y)),(0,L.$ic)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook(a,i,c){const f=this.w.get(a);if(!f)throw new Error("NO serializer found");const y=await f.serializer.deserializeNotebook(i.buffer,c);return new o.$dA(C.NotebookData.from(y))}async $notebookToData(a,i,c){const f=this.w.get(a);if(!f)throw new Error("NO serializer found");const y=await f.serializer.serializeNotebook(C.NotebookData.to(i.value),c);return M.$Fd.wrap(y)}async $saveNotebook(a,i,c,f,y){const E=b.URI.revive(i),u=this.w.get(a);if(!u)throw new Error("NO serializer found");const l=this.g.get(E);if(!l)throw new Error("Document NOT found");if(l.versionId!==c)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new P.$nk((0,D.localize)(0,null,this.y(E)),6);await this.x(E,f);const w={metadata:(0,$.$4m)(l.apiNotebook.metadata,j=>!(u.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of l.apiNotebook.getCells()){const z=new v.$oL(j.kind,j.document.getText(),j.document.languageId,j.mime,u.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);z.metadata=(0,$.$4m)(j.metadata,T=>!(u.options?.transientCellMetadata??{})[T]),w.cells.push(z)}const A=await u.serializer.serializeNotebook(w,y);await this.s.value.writeFile(E,A);const N=this.s.getFileSystemProviderExtUri(E.scheme),O=await this.s.value.stat(E);return{name:N.basename(E),isFile:(O.type&P.FileType.File)!==0,isDirectory:(O.type&P.FileType.Directory)!==0,isSymbolicLink:(O.type&P.FileType.SymbolicLink)!==0,mtime:O.mtime,ctime:O.ctime,size:O.size,readonly:!!((O.permissions??0)&P.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((O.permissions??0)&P.FilePermission.Locked),etag:P.$yk({mtime:O.mtime,size:O.size}),children:void 0}}async x(a,i){const c=await this.s.value.stat(a);if(typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==P.$xk&&typeof c.mtime=="number"&&typeof c.size=="number"&&i.mtime<c.mtime&&i.etag!==P.$yk({mtime:i.mtime,size:c.size}))throw new P.$nk((0,D.localize)(1,null),3,i)}y(a){return a.scheme===d.Schemas.file?a.fsPath:a.toString()}z(a,i,c){if(this.h.has(i))throw new Error(`editor with id ALREADY EXSIST: ${i}`);const f=new n.$ycc(i,this.d,a,c.visibleRanges.map(C.NotebookRange.to),c.selections.map(C.NotebookRange.to),typeof c.viewColumn=="number"?C.ViewColumn.to(c.viewColumn):void 0);this.h.set(i,f)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const c of a.value.removedDocuments){const f=b.URI.revive(c),y=this.g.get(f);y&&(y.dispose(),this.g.delete(f),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:y.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(y.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===f.toString()&&this.h.delete(E.id)}if(a.value.addedDocuments){const c=[];for(const f of a.value.addedDocuments){const y=b.URI.revive(f.uri);if(this.g.has(y))throw new Error(`adding EXISTING notebook ${y} `);const E=new s.$xcc(this.c,this.q,this.r,y,f);c.push(...f.cells.map(u=>s.$wcc.asModelAddData(E.apiNotebook,u))),this.g.get(y)?.dispose(),this.g.set(y,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:c}),this.m.fire(E.apiNotebook)}}if(a.value.addedEditors)for(const c of a.value.addedEditors){if(this.h.has(c.id))return;const f=b.URI.revive(c.documentUri),y=this.g.get(f);y&&this.z(y,c.id,c)}const i=[];if(a.value.removedEditors)for(const c of a.value.removedEditors){const f=this.h.get(c);f&&(this.h.delete(c),this.k?.id===f.id&&(this.k=void 0),i.push(f))}if(a.value.visibleEditors){this.l=a.value.visibleEditors.map(f=>this.h.get(f)).filter(f=>!!f);const c=new Set;this.l.forEach(f=>c.add(f.id));for(const f of this.h.values()){const y=c.has(f.id);f._acceptVisibility(y)}this.l=[...this.h.values()].map(f=>f).filter(f=>f.visible),this.o.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this.k=void 0:a.value.newActiveEditor&&(this.h.get(a.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${a.value.newActiveEditor}`),this.k=this.h.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(a){const i=S.$nM.String.with("notebookType","A notebook type"),c=new S.$pM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[i,new S.$nM("data","Bytes to convert to data",y=>y instanceof Uint8Array,y=>M.$Fd.wrap(y))],new S.$oM("Notebook Data",y=>C.NotebookData.to(y.value))),f=new S.$pM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[i,new S.$nM("NotebookData","Notebook data to convert to bytes",y=>!0,y=>new o.$dA(C.NotebookData.from(y)))],new S.$oM("Bytes",y=>y.buffer));a.registerApiCommand(c),a.registerApiCommand(f)}}e.$zcc=t}),define(Se[320],De([1,0,19,9,21,4,3,28,2,25,14,87,6,33,13,7,110,275,27,70]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o,s,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=e.$Ncc=void 0;let $=class{constructor(y,E,u,l,w){this.m=E,this.n=u,this.o=l,this.q=w,this.b=new m.$zi,this.c=new m.$zi,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new I.$Zac("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new L.$fd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=y.getProxy(p.$ZJ.MainThreadNotebookKernels);const A=new S.$pM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new S.$nM("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const O=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:O}}else if(N&&"notebookEditor"in N){const O=this.n.getIdByEditor(N.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return N})],S.$oM.Void);this.o.registerApiCommand(A)}createNotebookController(y,E,u,l,w,A){for(const ge of this.j.values())if(ge.controller.id===E&&b.$Vl.equals(y.identifier,ge.extensionId))throw new Error(`notebook controller with id '${E}' ALREADY exist`);const N=this.k++,O=this;this.q.trace(`NotebookController[${N}], CREATED by ${y.identifier.value}, ${E}`);const F=()=>console.warn(`NO execute handler from notebook controller '${H.id}' of extension: '${y.identifier}'`);let j=!1;const z=new L.$fd,T=new L.$fd,H={id:c(y.identifier,E),notebookType:u,extensionId:y.identifier,extensionLocation:y.extensionLocation,label:l||y.identifier.value,preloads:A?A.map(C.NotebookRendererScript.from):[]};let q=w??F,me;this.a.$addKernel(N,H).catch(ge=>{console.log(ge),j=!0});let X=0;const Z=()=>{if(j)return;const ge=++X;Promise.resolve().then(()=>{ge===X&&this.a.$updateKernel(N,H)})},V=new m.$zi,x={get id(){return E},get notebookType(){return H.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return H.label},set label(ge){H.label=ge??y.displayName??y.name,Z()},get detail(){return H.detail??""},set detail(ge){H.detail=ge,Z()},get description(){return H.description??""},set description(ge){H.description=ge,Z()},get supportedLanguages(){return H.supportedLanguages},set supportedLanguages(ge){H.supportedLanguages=ge,Z()},get supportsExecutionOrder(){return H.supportsExecutionOrder??!1},set supportsExecutionOrder(ge){H.supportsExecutionOrder=ge,Z()},get rendererScripts(){return H.preloads?H.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return q},set executeHandler(ge){q=ge??F},get interruptHandler(){return me},set interruptHandler(ge){me=ge,H.supportsInterrupt=!!ge,Z()},createNotebookCellExecution(ge){if(j)throw new Error("notebook controller is DISPOSED");if(!V.has(ge.notebook.uri))throw O.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${ge.notebook.uri.toString()}`);return O._createNotebookCellExecution(ge,c(y.identifier,this.id))},createNotebookExecution(ge){if((0,n.$QF)(y,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!V.has(ge.uri))throw O.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${ge.uri.toString()}`);return O._createNotebookExecution(ge,c(y.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${N}], DISPOSED`),j=!0,this.j.delete(N),z.dispose(),T.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(ge,ue){ue===v.NotebookControllerAffinity2.Hidden&&(0,n.$QF)(y,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(N,ge.uri,ue)},onDidReceiveMessage:T.event,postMessage(ge,ue){return(0,n.$QF)(y,"notebookMessaging"),O.a.$postMessage(N,ue&&O.n.getIdByEditor(ue),ge)},asWebviewUri(ge){return(0,n.$QF)(y,"notebookMessaging"),(0,o.$Yob)(ge,O.m.remote)}};return this.j.set(N,{extensionId:y.identifier,controller:x,onDidReceiveMessage:T,onDidChangeSelection:z,associatedNotebooks:V}),x}getIdByController(y){for(const[E,u]of this.j)if(u.controller===y)return c(u.extensionId,y.id);return null}createNotebookControllerDetectionTask(y,E){const u=this.f++,l=this;this.q.trace(`NotebookControllerDetectionTask[${u}], CREATED by ${y.identifier.value}`),this.a.$addKernelDetectionTask(u,E);const w={dispose:()=>{this.e.delete(u),l.a.$removeKernelDetectionTask(u)}};return this.e.set(u,w),w}registerKernelSourceActionProvider(y,E,u){const l=this.h++,w=typeof u.onDidChangeNotebookKernelSourceActions=="function"?l:void 0,A=this;this.g.set(l,u),this.q.trace(`NotebookKernelSourceActionProvider[${l}], CREATED by ${y.identifier.value}`),this.a.$addKernelSourceActionProvider(l,l,E);let N;return w!==void 0&&(N=u.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.g.delete(l),A.a.$removeKernelSourceActionProvider(l,l),N?.dispose()}}}async $provideKernelSourceActions(y,E){const u=this.g.get(y);if(u){const l=new R.$jc;return this.i.add([l]),(await u.provideNotebookKernelSourceActions(E)??[]).map(A=>C.NotebookKernelSourceAction.from(A,this.o.converter,l))}return[]}$acceptNotebookAssociation(y,E,u){const l=this.j.get(y);if(l){const w=this.n.getNotebookDocument(k.URI.revive(E));u?l.associatedNotebooks.set(w.uri,!0):l.associatedNotebooks.delete(w.uri),this.q.trace(`NotebookController[${y}] ASSOCIATE notebook`,w.uri.toString(),u),l.onDidChangeSelection.fire({selected:u,notebook:w.apiNotebook})}}async $executeCells(y,E,u){const l=this.j.get(y);if(!l)return;const w=this.n.getNotebookDocument(k.URI.revive(E)),A=[];for(const N of u){const O=w.getCell(N);O&&A.push(O.apiCell)}try{this.q.trace(`NotebookController[${y}] EXECUTE cells`,w.uri.toString(),A.length),await l.controller.executeHandler.call(l.controller,A,w.apiNotebook,l.controller)}catch(N){this.q.error(`NotebookController[${y}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(y,E,u){const l=this.j.get(y);if(!l)return;const w=this.n.getNotebookDocument(k.URI.revive(E));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,w.apiNotebook);else for(const A of u){const N=w.getCell(A);N&&this.b.get(N.uri)?.cancel()}if(l.controller.interruptHandler){const A=this.c.get(w.uri);u.length&&Array.isArray(A)&&A.length&&A.forEach(N=>N.dispose())}}$acceptKernelMessageFromRenderer(y,E,u){const l=this.j.get(y);if(!l)return;const w=this.n.getEditorById(E);l.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:u}))}$cellExecutionChanged(y,E,u){const w=this.n.getNotebookDocument(k.URI.revive(y)).getCell(E);if(w){const A=u?C.NotebookCellExecutionState.to(u):v.NotebookCellExecutionState.Idle;A!==void 0&&this.l.fire({cell:w.apiCell,state:A})}}_createNotebookCellExecution(y,E){if(y.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this.n.getNotebookDocument(y.notebook.uri).getCellFromApiCell(y);if(!l)throw new Error("invalid cell");if(this.b.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const w=new t(E,l,this.a);this.b.set(l.uri,w);const A=w.onDidChangeState(()=>{w.state===d.Resolved&&(w.dispose(),A.dispose(),this.b.delete(l.uri))});return w.asApiObject()}_createNotebookExecution(y,E){const u=this.n.getNotebookDocument(y.uri),l=y.getCells().find(N=>{const O=u.getCellFromApiCell(N);return O&&this.b.has(O.uri)});if(l)throw new Error(`duplicate cell execution for ${l.document.uri}`);if(this.c.has(u.uri))throw new Error(`duplicate notebook execution for ${u.uri}`);const w=new a(E,u,this.a),A=w.onDidChangeState(()=>{w.state===r.Resolved&&(w.dispose(),A.dispose(),this.c.delete(u.uri))});return this.c.set(u.uri,[w,A]),w.asApiObject()}};e.$Ncc=$,e.$Ncc=$=Ke([Be(4,P.$5i)],$);var d;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(d||(d={}));class t extends R.$kc{static{this.a=0}get state(){return this.f}constructor(y,E,u){super(),this.m=E,this.n=u,this.b=t.a++,this.c=new L.$fd,this.onDidChangeState=this.c.event,this.f=d.Init,this.g=this.B(new g.$pd),this.h=new i(10,l=>this.s(l)),this.j=E.internalMetadata.executionOrder,this.n.$createExecution(this.b,y,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(y){await this.h.addItem(y)}async s(y){const E=Array.isArray(y)?y:[y];return this.n.$updateExecution(this.b,new h.$dA(E))}t(){if(this.f===d.Init)throw new Error("Must call start before modifying cell output");if(this.f===d.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(y){let E=this.m;if(y&&(E=this.m.notebook.getCellFromApiCell(y)),!E)throw new Error("INVALID cell");return E.handle}y(y){return y.map(E=>{const u=v.$rL.ensureUniqueMimeTypes(E.items,!0);return u===E.items?C.NotebookCellOutput.from(E):C.NotebookCellOutput.from({items:u,id:E.id,metadata:E.metadata})})}async z(y,E,u){const l=this.w(E),w=this.y((0,D.$1b)(y));return this.r({editType:s.CellExecutionUpdateType.Output,cellHandle:l,append:u,outputs:w})}async C(y,E,u){return y=v.$rL.ensureUniqueMimeTypes((0,D.$1b)(y),!0),this.r({editType:s.CellExecutionUpdateType.OutputItems,items:y.map(C.NotebookCellOutputItem.from),outputId:E.id,append:u})}asApiObject(){const y=this;return Object.freeze({get token(){return y.g.token},get cell(){return y.m.apiCell},get executionOrder(){return y.j},set executionOrder(u){y.j=u,y.s([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:y.j}])},start(u){if(y.f===d.Resolved||y.f===d.Started)throw new Error("Cannot call start again");y.f=d.Started,y.c.fire(),y.s({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:u})},end(u,l){if(y.f===d.Resolved)throw new Error("Cannot call resolve twice");y.f=d.Resolved,y.c.fire(),y.h.flush(),y.n.$completeExecution(y.b,new h.$dA({runEndTime:l,lastRunSuccess:u}))},clearOutput(u){return y.t(),y.z([],u,!1)},appendOutput(u,l){return y.t(),y.z(u,l,!0)},replaceOutput(u,l){return y.t(),y.z(u,l,!1)},appendOutputItems(u,l){return y.t(),y.C(u,l,!0)},replaceOutputItems(u,l){return y.t(),y.C(u,l,!1)}})}}var r;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(r||(r={}));class a extends R.$kc{static{this.a=0}get state(){return this.f}constructor(y,E,u){super(),this.h=E,this.j=u,this.b=a.a++,this.c=new L.$fd,this.onDidChangeState=this.c.event,this.f=r.Init,this.g=this.B(new g.$pd),this.j.$createNotebookExecution(this.b,y,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===r.Resolved||this.f===r.Started)throw new Error("Cannot call start again");this.f=r.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===r.Resolved)throw new Error("Cannot call resolve twice");this.f=r.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class i{constructor(y,E){this.e=y,this.f=E,this.a=[],this.b=Date.now()}addItem(y){return this.a.push(y),this.c||(this.c=new M.$2g,this.b=Date.now(),(0,M.$Hg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const y=this.c;this.c=void 0;const E=this.a;return this.a=[],this.f(E).finally(()=>y.complete())}}function c(f,y){return`${f.value}/${y}`}e.$Occ=c}),define(Se[321],De([1,0,4,6,144]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=void 0;class L{constructor(m,k){this.c=k,this.a=new Map,this.b=m.getProxy(M.$ZJ.MainThreadNotebookRenderers)}$postRendererMessage(m,k,b){const P=this.c.getEditorById(m);this.a.get(k)?.fire({editor:P.apiEditor,message:b})}createRendererMessaging(m,k){if(!m.contributes?.notebookRenderer?.some(P=>P.id===k))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${k})`);return{onDidReceiveMessage:(P,I,p)=>this.d(k).event(P,I,p),postMessage:(P,I)=>{g.$ycc.apiEditorsToExtHost.has(P)&&([P,I]=[I,P]);const p=I&&g.$ycc.apiEditorsToExtHost.get(I);return this.b.$postMessage(p?.id,k,P)}}}d(m){let k=this.a.get(m);return k||(k=new D.$fd({onDidRemoveLastListener:()=>{k?.dispose(),this.a.delete(m)}}),this.a.set(m,k),k)}}e.$Pcc=L}),define(Se[322],De([1,0,3,18,2,27,6]),function($e,e,D,M,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=void 0;class m{constructor(b){this.b=new Map,this.a=b.getProxy(R.$ZJ.MainThreadProfileContentHandlers)}registrProfileContentHandler(b,P,I){if((0,L.$QF)(b,"profileContentHandlers"),this.b.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.b.set(P,I),this.a.$registerProfileContentHandler(P,I.name,I.description,b.identifier.value),(0,D.$ic)(()=>{this.b.delete(P),this.a.$unregisterProfileContentHandler(P)})}async $saveProfile(b,P,I,p){const S=this.b.get(b);if(!S)throw new Error(`Unknown handler with id: ${b}`);return S.saveProfile(P,I,p)}async $readProfile(b,P,I){const p=this.b.get(b);if(!p)throw new Error(`Unknown handler with id: ${b}`);return p.readProfile((0,M.$jf)(P)?P:g.URI.revive(P),I)}}e.$Tcc=m}),define(Se[323],De([1,0,2,6,9,13]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=void 0;class R{static{this.a=0}constructor(k,b){this.d=b,this.c=new Map,this.b=k.getProxy(M.$ZJ.MainThreadQuickDiff)}$provideOriginalResource(k,b,P){const I=D.URI.revive(b),p=this.c.get(k);return p?(0,g.$zg)(()=>p.provideOriginalResource(I,P)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider(k,b,P,I){const p=R.a++;return this.c.set(p,b),this.b.$registerQuickDiffProvider(p,L.DocumentSelector.from(k,this.d),P,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider(p),this.c.delete(p)}}}}e.$Ucc=R}),define(Se[324],De([1,0,21,4,3,6,2,7,8,19,38,60,27,13]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vbc=void 0;function C(v,o,s){const n=v.getProxy(L.$ZJ.MainThreadQuickOpen);class h{constructor(y,E){this.e=new Map,this.f=0,this.a=y,this.b=E}showQuickPick(y,E,u,l=D.CancellationToken.None){this.c=void 0;const w=Promise.resolve(E),A=++this.f,N=n.$show(A,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},l),O={},F=N.then(()=>O);return Promise.race([F,w]).then(j=>{if(j===O)return;const z=(0,p.$PF)(y,"quickPickItemTooltip");return w.then(T=>{const H=[];for(let q=0;q<T.length;q++){const me=T[q];if(typeof me=="string")H.push({label:me,handle:q});else if(me.kind===m.QuickPickItemKind.Separator)H.push({type:"separator",label:me.label});else{me.tooltip&&!z&&console.warn(`Extension '${y.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${y.identifier.value}`);const X=me.iconPath?a(me.iconPath):void 0;H.push({label:me.label,iconPath:X?.iconPath,iconClass:X?.iconClass,description:me.description,detail:me.detail,picked:me.picked,alwaysShow:me.alwaysShow,tooltip:z?S.MarkdownString.fromStrict(me.tooltip):void 0,handle:q})}}return u&&typeof u.onDidSelectItem=="function"&&(this.c=q=>{u.onDidSelectItem(T[q])}),n.$setItems(A,H),N.then(q=>{if(typeof q=="number")return T[q];if(Array.isArray(q))return q.map(me=>T[me])})})}).then(void 0,j=>{if(!(0,k.$2)(j))return n.$setError(A,j),Promise.reject(j)})}$onItemSelected(y){this.c?.(y)}showInput(y,E=D.CancellationToken.None){return this.d=y?.validateInput,n.$input(y,typeof this.d=="function",E).then(void 0,u=>{if(!(0,k.$2)(u))return Promise.reject(u)})}async $validateInput(y){if(!this.d)return;const E=await this.d(y);if(!E||typeof E=="string")return E;let u;switch(E.severity){case m.InputBoxValidationSeverity.Info:u=P.default.Info;break;case m.InputBoxValidationSeverity.Warning:u=P.default.Warning;break;case m.InputBoxValidationSeverity.Error:u=P.default.Error;break;default:u=E.message?P.default.Error:P.default.Ignore;break}return{content:E.message,severity:u}}async showWorkspaceFolderPick(y,E=D.CancellationToken.None){const u=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[y]);if(!u)return;const l=await this.a.getWorkspaceFolders2();if(l)return l.find(w=>w.uri.toString()===u.uri.toString())}createQuickPick(y){const E=new i(y,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}createInputBox(y){const E=new c(y,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}$onDidChangeValue(y,E){this.e.get(y)?._fireDidChangeValue(E)}$onDidAccept(y){this.e.get(y)?._fireDidAccept()}$onDidChangeActive(y,E){const u=this.e.get(y);u instanceof i&&u._fireDidChangeActive(E)}$onDidChangeSelection(y,E){const u=this.e.get(y);u instanceof i&&u._fireDidChangeSelection(E)}$onDidTriggerButton(y,E){this.e.get(y)?._fireDidTriggerButton(E)}$onDidTriggerItemButton(y,E,u){const l=this.e.get(y);l instanceof i&&l._fireDidTriggerItemButton(E,u)}$onDidHide(y){this.e.get(y)?._fireDidHide()}}class ${static{this.a=1}constructor(y,E){this.x=y,this.y=E,this._id=i.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$fd,this.q=new M.$fd,this.r=new M.$fd,this.s=new M.$fd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(y){this.b=y,this.z({title:y})}get step(){return this.c}set step(y){this.c=y,this.z({step:y})}get totalSteps(){return this.d}set totalSteps(y){this.d=y,this.z({totalSteps:y})}get enabled(){return this.g}set enabled(y){this.g=y,this.z({enabled:y})}get busy(){return this.j}set busy(y){this.j=y,this.z({busy:y})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(y){this.k=y,this.z({ignoreFocusOut:y})}get value(){return this.l}set value(y){this.l=y,this.z({value:y})}get placeholder(){return this.m}set placeholder(y){this.m=y,this.z({placeholder:y})}get buttons(){return this.n}set buttons(y){this.n=y.slice(),this.o.clear(),y.forEach((E,u)=>{const l=E===m.$kL.Back?-1:u;this.o.set(l,E)}),this.z({buttons:y.map((E,u)=>({...a(E.iconPath),tooltip:E.tooltip,handle:E===m.$kL.Back?-1:u}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(y){this.l=y,this.q.fire(y)}_fireDidTriggerButton(y){const E=this.o.get(y);E&&this.r.fire(E)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,g.$fc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(y){if(!this.v){for(const E of Object.keys(y)){const u=y[E];this.u[E]=u===void 0?null:u}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function d(f){if(f instanceof m.$WK)return{id:f.id};const y=r(f),E=t(f);return{dark:typeof y=="string"?R.URI.file(y):y,light:typeof E=="string"?R.URI.file(E):E}}function t(f){return typeof f=="object"&&"light"in f?f.light:f}function r(f){return typeof f=="object"&&"dark"in f?f.dark:f}function a(f){const y=d(f);let E,u;return"id"in y?u=I.ThemeIcon.asClassName(y):E=y,{iconPath:E,iconClass:u}}class i extends ${constructor(y,E){super(y.identifier,E),this.O=y,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$fd,this.L=[],this.M=new M.$fd,this.N=new M.$fd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(y){this.B=y.slice(),this.C.clear(),this.D.clear(),y.forEach((l,w)=>{this.C.set(w,l),this.D.set(l,w)});const E=(0,p.$PF)(this.O,"quickPickItemTooltip"),u=[];for(let l=0;l<y.length;l++){const w=y[l];if(w.kind===m.QuickPickItemKind.Separator)u.push({type:"separator",label:w.label});else{w.tooltip&&!E&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const A=w.iconPath?a(w.iconPath):void 0;u.push({handle:l,label:w.label,iconPath:A?.iconPath,iconClass:A?.iconClass,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:E?S.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((N,O)=>({...a(N.iconPath),tooltip:N.tooltip,handle:O}))})}}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(y){this.E=y,this.z({canSelectMany:y})}get matchOnDescription(){return this.F}set matchOnDescription(y){this.F=y,this.z({matchOnDescription:y})}get matchOnDetail(){return this.G}set matchOnDetail(y){this.G=y,this.z({matchOnDetail:y})}get sortByLabel(){return this.H}set sortByLabel(y){this.H=y,this.z({sortByLabel:y})}get keepScrollPosition(){return this.I}set keepScrollPosition(y){this.I=y,this.z({keepScrollPosition:y})}get activeItems(){return this.J}set activeItems(y){this.J=y.filter(E=>this.D.has(E)),this.z({activeItems:this.J.map(E=>this.D.get(E))})}get selectedItems(){return this.L}set selectedItems(y){this.L=y.filter(E=>this.D.has(E)),this.z({selectedItems:this.L.map(E=>this.D.get(E))})}_fireDidChangeActive(y){const E=(0,b.$Fb)(y.map(u=>this.C.get(u)));this.J=E,this.K.fire(E)}_fireDidChangeSelection(y){const E=(0,b.$Fb)(y.map(u=>this.C.get(u)));this.L=E,this.M.fire(E)}_fireDidTriggerItemButton(y,E){const u=this.C.get(y);if(!u||!u.buttons||!u.buttons.length)return;const l=u.buttons[E];l&&this.N.fire({button:l,item:u})}}class c extends ${constructor(y,E){super(y.identifier,E),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(y){this.B=y,this.z({password:y})}get prompt(){return this.C}set prompt(y){this.C=y,this.z({prompt:y})}get valueSelection(){return this.D}set valueSelection(y){this.D=y,this.z({valueSelection:y})}get validationMessage(){return this.E}set validationMessage(y){this.E=y,y?typeof y=="string"?this.z({validationMessage:y,severity:P.default.Error}):this.z({validationMessage:y.message,severity:y.severity??P.default.Error}):this.z({validationMessage:void 0,severity:P.default.Ignore})}}return new h(o,s)}e.$Vbc=C}),define(Se[325],De([1,0,2,4,57,3,9,6,19,126,14,25,60,13,27,17]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbc=e.$Wbc=void 0;function s(E){if(E)return typeof E.iconPath=="string"?D.URI.file(E.iconPath):D.URI.isUri(E.iconPath)||p.ThemeIcon.isThemeIcon(E.iconPath)?E.iconPath:void 0}function n(E,u){if(!E.iconPath&&!u.iconPath)return 0;if(E.iconPath){if(!u.iconPath)return 1}else return-1;const l=typeof E.iconPath=="string"?E.iconPath:D.URI.isUri(E.iconPath)?E.iconPath.fsPath:E.iconPath.id,w=typeof u.iconPath=="string"?u.iconPath:D.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id;return(0,b.$hq)(l,w)}function h(E,u){let l=0;if(E.strikeThrough!==u.strikeThrough)return E.strikeThrough?1:-1;if(E.faded!==u.faded)return E.faded?1:-1;if(E.tooltip!==u.tooltip)return(E.tooltip||"").localeCompare(u.tooltip||"");if(l=n(E,u),l!==0)return l;if(E.light&&u.light)l=n(E.light,u.light);else{if(E.light)return 1;if(u.light)return-1}if(l!==0)return l;if(E.dark&&u.dark)l=n(E.dark,u.dark);else{if(E.dark)return 1;if(u.dark)return-1}return l}function $(E,u){if(E.command!==u.command)return E.command<u.command?-1:1;if(E.title!==u.title)return E.title<u.title?-1:1;if(E.tooltip!==u.tooltip){if(E.tooltip!==void 0&&u.tooltip!==void 0)return E.tooltip<u.tooltip?-1:1;if(E.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(E.arguments===u.arguments)return 0;if(E.arguments)if(u.arguments){if(E.arguments.length!==u.arguments.length)return E.arguments.length-u.arguments.length}else return 1;else return-1;for(let l=0;l<E.arguments.length;l++){const w=E.arguments[l],A=u.arguments[l];if(w!==A)return w<A?-1:1}return 0}function d(E,u){let l=(0,b.$hq)(E.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(l!==0)return l;if(E.command&&u.command)l=$(E.command,u.command);else{if(E.command)return 1;if(u.command)return-1}if(l!==0)return l;if(E.decorations&&u.decorations)l=h(E.decorations,u.decorations);else{if(E.decorations)return 1;if(u.decorations)return-1}return l}function t(E,u){for(let l=0;l<E.length;l++)if(E[l]!==u[l])return!1;return!0}function r(E,u){return E.command===u.command&&E.title===u.title&&E.tooltip===u.tooltip&&(E.arguments&&u.arguments?t(E.arguments,u.arguments):E.arguments===u.arguments)}function a(E,u){return(0,k.$sb)(E,u,r)}class i{#e;#t;get value(){return this.d}set value(u){u=u??"",this.#e.$setInputBoxValue(this.l,u),this.n(u)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(u){this.#e.$setInputBoxPlaceholder(this.l,u),this.f=u}get validateInput(){return(0,C.$QF)(this.k,"scmValidation"),this.g}set validateInput(u){if((0,C.$QF)(this.k,"scmValidation"),u&&typeof u!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=u,this.#e.$setValidationProviderIsEnabled(this.l,!!u)}get enabled(){return this.h}set enabled(u){u=!!u,this.h!==u&&(this.h=u,this.#e.$setInputBoxEnablement(this.l,u))}get visible(){return this.j}set visible(u){u=!!u,this.j!==u&&(this.j=u,this.#e.$setInputBoxVisibility(this.l,u))}get document(){return(0,C.$QF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(u,l,w,A,N){this.k=u,this.l=A,this.m=N,this.d="",this.e=new M.$fd,this.f="",this.h=!0,this.j=!0,this.#t=l,this.#e=w}showValidationMessage(u,l){(0,C.$QF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,u,l)}$onInputBoxValueChange(u){this.n(u)}n(u){this.d=u,this.e.fire(u)}}e.$Wbc=i;class c{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(u){this.v=u,this.q.$updateGroupLabel(this.t,this.handle,u)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(u){this.p=u,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(u){this.f=[...u],this.k.fire()}constructor(u,l,w,A,N){this.q=u,this.s=l,this.t=w,this.u=A,this.v=N,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$fd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$fd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=c.d++}getResourceState(u){return this.g.get(u)}$executeResourceCommand(u,l){const w=this.h.get(u);return w?(0,R.$zg)(()=>this.s.executeCommand(w.command,...w.arguments||[],l)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const u=[...this.f].sort(d),w=(0,k.$Bb)(this.o,u,d).map(O=>{const F=O.toInsert.map(j=>{const z=this.e++;this.g.set(z,j);const T=j.resourceUri;let H;if(j.command)if(j.command.command==="vscode.open"||j.command.command==="vscode.diff"){const G=new L.$jc;H=this.s.converter.toInternal(j.command,G),this.j.set(z,G)}else this.h.set(z,j.command);const q=s(j.decorations),me=j.decorations&&s(j.decorations.light)||q,X=j.decorations&&s(j.decorations.dark)||q,Z=[me,X],V=j.decorations&&j.decorations.tooltip||"",x=j.decorations&&!!j.decorations.strikeThrough,ge=j.decorations&&!!j.decorations.faded,ue=j.contextValue||"";return{rawResource:[z,T,Z,V,x,ge,ue,H],handle:z}});return{start:O.start,deleteCount:O.deleteCount,toInsert:F}}),A=w.map(({start:O,deleteCount:F,toInsert:j})=>[O,F,j.map(z=>z.rawResource)]),N=w.reverse();for(const{start:O,deleteCount:F,toInsert:j}of N){const z=j.map(H=>H.handle),T=this.n.splice(O,F,...z);for(const H of T)this.g.delete(H),this.h.delete(H),this.j.get(H)?.dispose(),this.j.delete(H)}return this.o=u,A}dispose(){this.l=!0,this.m.fire()}}class f{static{this.d=0}#e;get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(u){this.g!==u&&(this.g=u,this.#e.$updateSourceControl(this.t,{count:u}))}get quickDiffProvider(){return this.h}set quickDiffProvider(u){this.h=u;let l;(0,C.$PF)(this.u,"quickDiffProvider")&&(l=u?.label),this.#e.$updateSourceControl(this.t,{hasQuickDiffProvider:!!u,quickDiffLabel:l})}get commitTemplate(){return this.j}set commitTemplate(u){u!==this.j&&(this.j=u,this.#e.$updateSourceControl(this.t,{commitTemplate:u}))}get acceptInputCommand(){return this.l}set acceptInputCommand(u){this.k.value=new L.$jc,this.l=u;const l=this.v.converter.toInternal(u,this.k.value);this.#e.$updateSourceControl(this.t,{acceptInputCommand:l})}get actionButton(){return(0,C.$QF)(this.u,"scmActionButton"),this.n}set actionButton(u){(0,C.$QF)(this.u,"scmActionButton"),this.m.value=new L.$jc,this.n=u;const l=u!==void 0?{command:this.v.converter.toInternal(u.command,this.m.value),secondaryCommands:u.secondaryCommands?.map(w=>w.map(A=>this.v.converter.toInternal(A,this.m.value))),description:u.description,enabled:u.enabled}:void 0;this.#e.$updateSourceControl(this.t,{actionButton:l??null})}get statusBarCommands(){return this.p}set statusBarCommands(u){if(this.p&&u&&a(this.p,u))return;this.o.value=new L.$jc,this.p=u;const l=(u||[]).map(w=>this.v.converter.toInternal(w,this.o.value));this.#e.$updateSourceControl(this.t,{statusBarCommands:l})}get selected(){return this.q}constructor(u,l,w,A,N,O,F){this.u=u,this.v=A,this.w=N,this.x=O,this.y=F,this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new L.$lc,this.l=void 0,this.m=new L.$lc,this.o=new L.$lc,this.p=void 0,this.q=!1,this.s=new M.$fd,this.onDidChangeSelection=this.s.event,this.t=f.d++,this.z=new Map,this.A=new Set,this.#e=w;const j=D.URI.from({scheme:v.Schemas.vscodeSourceControl,path:`${N}/scm${this.t}/input`,query:F?`rootUri=${encodeURIComponent(F.toString())}`:void 0});this.f=new i(u,l,this.#e,this.t,j),this.#e.$registerSourceControl(this.t,N,O,F,j)}createResourceGroup(u,l){const w=new c(this.#e,this.v,this.t,u,l),A=M.Event.once(w.onDidDispose)(()=>this.z.delete(w));return this.z.set(w,A),this.eventuallyAddResourceGroups(),w}eventuallyAddResourceGroups(){const u=[],l=[];for(const[w,A]of this.z){A.dispose();const N=w.onDidUpdateResourceStates(()=>{this.A.add(w),this.eventuallyUpdateResourceStates()});M.Event.once(w.onDidDispose)(()=>{this.A.delete(w),N.dispose(),this.e.delete(w.handle),this.#e.$unregisterGroup(this.t,w.handle)}),u.push([w.handle,w.id,w.label,w.features]);const O=w._takeResourceStateSnapshot();O.length>0&&l.push([w.handle,O]),this.e.set(w.handle,w)}this.#e.$registerGroups(this.t,u,l),this.z.clear()}eventuallyUpdateResourceStates(){const u=[];this.A.forEach(l=>{const w=l._takeResourceStateSnapshot();w.length!==0&&u.push([l.handle,w])}),u.length>0&&this.#e.$spliceResourceStates(this.t,u),this.A.clear()}getResourceGroup(u){return this.e.get(u)}setSelectionState(u){this.q=u,this.s.fire(u)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(u=>u.dispose()),this.#e.$unregisterSourceControl(this.t)}}Ke([(0,g.$7g)(100)],f.prototype,"eventuallyAddResourceGroups",null),Ke([(0,g.$7g)(100)],f.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(u,l,w,A){this.l=l,this.m=w,this.n=A,this.g=new Map,this.h=new I.$Xl,this.j=new M.$fd,this.e=u.getProxy(m.$ZJ.MainThreadSCM),this.f=u.getProxy(m.$ZJ.MainThreadTelemetry),l.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===3){const O=this.g.get(N.sourceControlHandle);if(!O)return N;const F=O.getResourceGroup(N.groupHandle);return F?F.getResourceState(N.handle):N}else if(N&&N.$mid===4){const O=this.g.get(N.sourceControlHandle);return O?O.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===5){const O=this.g.get(N.handle);return O||N}return N}})}createSourceControl(u,l,w,A){this.n.trace("ExtHostSCM#createSourceControl",u.identifier.value,l,w,A),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const N=o.d++,O=new f(u,this.m,this.e,this.l,l,w,A);this.g.set(N,O);const F=this.h.get(u.identifier)||[];return F.push(O),this.h.set(u.identifier,F),O}getLastInputBox(u){this.n.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const l=this.h.get(u.identifier),w=l&&l[l.length-1];return w&&w.inputBox}$provideOriginalResource(u,l,w){const A=D.URI.revive(l);this.n.trace("ExtHostSCM#$provideOriginalResource",u,A.toString());const N=this.g.get(u);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$zg)(()=>N.quickDiffProvider.provideOriginalResource(A,w)).then(O=>O||null)}$onInputBoxValueChange(u,l){this.n.trace("ExtHostSCM#$onInputBoxValueChange",u);const w=this.g.get(u);return w&&w.inputBox.$onInputBoxValueChange(l),Promise.resolve(void 0)}$executeResourceCommand(u,l,w,A){this.n.trace("ExtHostSCM#$executeResourceCommand",u,l,w);const N=this.g.get(u);if(!N)return Promise.resolve(void 0);const O=N.getResourceGroup(l);return O?O.$executeResourceCommand(w,A):Promise.resolve(void 0)}$validateInput(u,l,w){this.n.trace("ExtHostSCM#$validateInput",u);const A=this.g.get(u);return!A||!A.inputBox.validateInput?Promise.resolve(void 0):(0,R.$zg)(()=>A.inputBox.validateInput(l,w)).then(N=>{if(!N)return Promise.resolve(void 0);const O=S.MarkdownString.fromStrict(N.message);return O?Promise.resolve([O,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(u){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&this.g.get(u)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=u,Promise.resolve(void 0)}};e.$Xbc=y,e.$Xbc=y=o=Ke([Be(3,P.$5i)],y)}),define(Se[114],De([1,0,6,4,5]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dbc=e.$Cbc=void 0;class L{constructor(m){this.b=new M.$fd,this.onDidChangePassword=this.b.event,this.a=m.getProxy(D.$ZJ.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,k){return this.a.$getPassword(m,k)}store(m,k,b){return this.a.$setPassword(m,k,b)}delete(m,k){return this.a.$deletePassword(m,k)}}e.$Cbc=L,e.$Dbc=(0,g.$Bh)("IExtHostSecretState")}),define(Se[326],De([1,0,6,13,2]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=void 0;class L{static{this.a=0}constructor(m,k){this.d=k,this.c=new Map,this.b=m.getProxy(D.$ZJ.MainThreadShare)}async $provideShare(m,k,b){return await this.c.get(m)?.provideShare({selection:M.Range.to(k.selection),resourceUri:g.URI.revive(k.resourceUri)},b)??void 0}registerShareProvider(m,k){const b=L.a++;return this.c.set(b,k),this.b.$registerShareProvider(b,M.DocumentSelector.from(m,this.d),k.id,k.label,k.priority),{dispose:()=>{this.b.$unregisterShareProvider(b),this.c.delete(b)}}}}e.$Zcc=L}),define(Se[327],De([1,0,7,6,209,3,13,18]),function($e,e,D,M,g,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=e.$Ybc=void 0;class k{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new D.$XK("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.$XK("statusBarItem.warningForeground")]])}#e;#t;constructor(p,S,C,v,o,s=D.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new L.$jc,this.#e=p,this.#t=S,o&&v){this.c=(0,D.$AK)(v.identifier,o);const h=C.get(this.c);h&&(s=h.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,n=h.priority,this.j=!0,this.name=h.name,this.text=h.text,this.tooltip=h.tooltip,this.command=h.command,this.accessibilityInformation=h.accessibilityInformation)}else this.c=String(k.a++);this.e=v,this.f=o,this.g=s,this.h=this.u(n)}u(p){if((0,m.$nf)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(p){this.k=p,this.v()}set name(p){this.m=p,this.v()}set tooltip(p){this.l=p,this.v()}set color(p){this.n=p,this.v()}set backgroundColor(p){p&&!k.b.has(p.id)&&(p=void 0),this.o=p,this.v()}set command(p){this.r?.fromApi!==p&&(this.p&&this.q.add(this.p),this.p=new L.$jc,typeof p=="string"?this.r={fromApi:p,internal:this.#t.toInternal({title:"",command:p},this.p)}:p?this.r={fromApi:p,internal:this.#t.toInternal(p,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(p){this.t=p,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let p;this.e?this.f?p=`${this.e.identifier.value}.${this.f}`:p=this.e.identifier.value:p=this.f;let S;this.m?S=this.m:S=(0,g.localize)(0,null,this.e.displayName||this.e.name);let C=this.n;this.o&&(C=k.b.get(this.o.id));const v=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,p,this.e?.identifier.value,S,this.k,v,this.r?.internal,C,this.o,this.g===D.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Ybc=k;class b{constructor(p){this.b=[],this.a=p.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,g.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(p){const S={message:p};return this.b.unshift(S),this.c(),new D.$2J(()=>{const C=this.b.indexOf(S);C>=0&&(this.b.splice(C,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class P{constructor(p,S){this.e=new Map,this.a=p.getProxy(M.$ZJ.MainThreadStatusBar),this.b=S,this.c=new b(this)}$acceptStaticEntries(p){for(const S of p)this.e.set(S.entryId,S)}createStatusBarEntry(p,S,C,v){return new k(this.a,this.b,this.e,p,S,C,v)}setStatusBarMessage(p,S){const C=this.c.setMessage(p);let v;return typeof S=="number"?v=setTimeout(()=>C.dispose(),S):typeof S<"u"&&S.then(()=>C.dispose(),()=>C.dispose()),new D.$2J(()=>{C.dispose(),clearTimeout(v)})}}e.$Zbc=P}),define(Se[115],De([1,0,6,4,5]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rbc=e.$qbc=void 0;class L{constructor(m,k){this.c=k,this.b=new M.$fd,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(D.$ZJ.MainThreadStorage)}registerExtensionStorageKeysToSync(m,k){this.a.$registerExtensionStorageKeysToSync(m,k)}async initializeExtensionStorage(m,k,b){const P=await this.a.$initializeExtensionStorage(m,k);let I;return P&&(I=this.d(m,k,P)),I||b}setValue(m,k,b){return this.a.$setValue(m,k,b)}$acceptValue(m,k,b){const P=this.d(m,k,b);P&&this.b.fire({shared:m,key:k,value:P})}d(m,k,b){try{return JSON.parse(b)}catch(P){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${k}, global: ${m}): ${P}`)}}}e.$qbc=L,e.$rbc=(0,g.$Bh)("IExtHostStorage")}),define(Se[91],De([1,0,5,26,14,73,2]),function($e,e,D,M,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xbc=e.$wbc=void 0,e.$wbc=(0,D.$Bh)("IExtensionStoragePaths");let m=class{constructor(b,P,I){this.d=P,this.f=I,this.a=b.workspace??void 0,this.b=b.environment,this.whenReady=this.h().then(p=>this.c=p)}async g(b){return R.URI.joinPath(this.b.workspaceStorageHome,b)}async h(){if(!this.a)return Promise.resolve(void 0);const b=this.a.id,P=await this.g(b);try{return await this.f.value.stat(P),this.d.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",P),await this.f.value.createDirectory(P),await this.f.value.writeFile(R.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),P}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(b){if(this.c)return R.URI.joinPath(this.c,b.identifier.value)}globalValue(b){return R.URI.joinPath(this.b.globalStorageHome,b.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$xbc=m,e.$xbc=m=Ke([Be(0,M.$fM),Be(1,g.$5i),Be(2,L.$vbc)],m)}),define(Se[44],De([1,0,4,6,5,2,20,3,7,211,8,253,21,31,254,60,9,13,33]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bbc=e.$Abc=e.$zbc=e.$ybc=void 0,e.$ybc=(0,g.$Bh)("IExtHostTerminalService");class h{constructor(u,l,w,A){this.l=u,this._id=l,this.m=w,this.n=A,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(O=>this.f=O);const N=this;this.value={get name(){return N.n||""},get processId(){return N.b},get creationOptions(){return N.m},get exitStatus(){return N.h},get state(){return N.j},get selection(){return N.k},sendText(O,F=!0){N.q(),N.l.$sendText(N._id,O,F)},show(O){N.q(),N.l.$show(N._id,O)},hide(){N.q(),N.l.$hide(N._id)},dispose(){N.a||(N.a=!0,N.l.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create(u,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:u.name,shellPath:u.shellPath??void 0,shellArgs:u.shellArgs??void 0,cwd:u.cwd??void 0,env:u.env??void 0,icon:c(u.iconPath)??void 0,color:v.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:u.message??void 0,strictEnv:u.strictEnv??void 0,hideFromUser:u.hideFromUser??void 0,isFeatureTerminal:l?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:l?.useShellEnvironment??void 0,location:l?.location||this.o(u.location,l?.resolvedExtHostIdentifier),isTransient:u.isTransient??void 0})}async createExtensionTerminal(u,l,w,A){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:w,color:v.ThemeColor.isThemeColor(A)?A.id:void 0,location:this.o(u,l),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(u,l){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in u?{viewColumn:s.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus}:void 0:u}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(u){this.n=u}setExitStatus(u,l){this.h=Object.freeze({code:u,reason:l})}setDimensions(u,l){return u===this.d&&l===this.g||u===0||l===0?!1:(this.d=u,this.g=l,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(u){this.k=u}_setProcessId(u){this.f?(this.f(u),this.f=void 0):this.b.then(l=>{l!==u&&(this.b=Promise.resolve(u))})}}e.$zbc=h;class ${get onProcessReady(){return this.b.event}constructor(u){this.g=u,this.id=0,this.shouldPersist=!1,this.a=new D.$fd,this.onProcessData=this.a.event,this.b=new D.$fd,this.d=new D.$fd,this.onDidChangeProperty=this.d.event,this.f=new D.$fd,this.onProcessExit=this.f.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,l){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${l}`)}async start(){}shutdown(){this.g.close()}input(u){this.g.handleInput?.(u)}resize(u,l){this.g.setDimensions?.({columns:u,rows:l})}clearBuffer(){}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(u){this.g.onDidWrite(l=>this.a.fire(l)),this.g.onDidClose?.((l=void 0)=>{this.f.fire(l===void 0?void 0:l)}),this.g.onDidOverrideDimensions?.(l=>{l&&this.d.fire({type:"overrideDimensions",value:{cols:l.columns,rows:l.rows}})}),this.g.onDidChangeName?.(l=>{this.d.fire({type:"title",value:l})}),this.g.open(u||void 0),u&&this.g.setDimensions?.(u),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let d=1,t=class extends m.$kc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(u=>u.value)}constructor(u,l,w){super(),this.Q=l,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$lc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new D.$fd,this.onDidCloseTerminal=this.H.event,this.I=new D.$fd,this.onDidOpenTerminal=this.I.event,this.J=new D.$fd,this.onDidChangeActiveTerminal=this.J.event,this.L=new D.$fd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new D.$fd,this.onDidChangeTerminalState=this.M.event,this.N=new D.$fd,this.onDidChangeShell=this.N.event,this.O=new D.$fd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new D.$fd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=w.getProxy(M.$ZJ.MainThreadTerminalService),this.y=new C.$Qkb(this.a.$sendProcessData),this.a.$registerProcessSupport(u),this.Q.registerArgumentProcessor({processArgument:A=>{const N=O=>{const F=O;return this.W(F.instanceId)?.value};switch(A?.$mid){case 15:return N(A);default:{if(Array.isArray(A))for(let O=0;O<A.length&&A[O].$mid===15;O++)A[O]=N(A[O]);return A}}}}),this.B({dispose:()=>{for(const[A,N]of this.g)N.shutdown(!0)}})}getDefaultShell(u){return(u?this.u:this.s)?.path||""}getDefaultShellArgs(u){return(u?this.u:this.s)?.args||[]}createExtensionTerminal(u,l){const w=new h(this.a,(0,S.$4f)(),u,u.name),A=new $(u.pty);return w.createExtensionTerminal(u.location,this.R(u,l).resolvedExtHostIdentifier,c(u.iconPath),f(u.color)).then(N=>{const O=this.S(N,A);this.h[N]=O}),this.f.push(w),w.value}R(u,l){if(l=l||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const w=u.location.parentTerminal;if(w){const A=this.f.find(N=>N.value===w);A&&(l.resolvedExtHostIdentifier=A._id)}}else u.location&&typeof u.location!="object"?l.location=u.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(u,l){if(!this.W(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const A=new $(l),N=this.S(u,A);this.h[u]=N}async $acceptActiveTerminalChanged(u){const l=this.b;if(u===null){this.b=void 0,l!==this.b&&this.J.fire(this.b);return}const w=this.W(u);w&&(this.b=w,l!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(u,l){const w=this.W(u);w&&this.O.fire({terminal:w.value,data:l})}async $acceptTerminalDimensions(u,l,w){const A=this.W(u);A&&A.setDimensions(l,w)&&this.L.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptDidExecuteCommand(u,l){const w=this.W(u);w&&this.P.fire({terminal:w.value,...l})}async $acceptTerminalMaximumDimensions(u,l,w){this.g.get(u)?.resize(l,w)}async $acceptTerminalTitleChange(u,l){const w=this.W(u);w&&(w.name=l)}async $acceptTerminalClosed(u,l,w){const A=this.Y(this.f,u);if(A!==null){const N=this.f.splice(A,1)[0];N.setExitStatus(l,w),this.H.fire(N.value)}}$acceptTerminalOpened(u,l,w,A){if(l){const F=this.Y(this.f,l);if(F!==null){this.f[F]._id=u,this.I.fire(this.terminals[F]),this.f[F].isOpen=!0;return}}const N={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:L.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},O=new h(this.a,u,N,w);this.f.push(O),this.I.fire(O.value),O.isOpen=!0}async $acceptTerminalProcessId(u,l){this.W(u)?._setProcessId(l)}async $startExtensionTerminal(u,l){const w=this.W(u);if(!w)return{message:(0,b.localize)(0,null,u)};w.isOpen||await new Promise(N=>{const O=this.onDidOpenTerminal(async F=>{F===w.value&&(O.dispose(),N())})});const A=this.g.get(u);A?A.startSendingEvents(l):this.j[u]={initialDimensions:l}}S(u,l){const w=new m.$jc;w.add(l.onProcessReady(N=>this.a.$sendProcessReady(u,N.pid,N.cwd,N.windowsPty))),w.add(l.onDidChangeProperty(N=>this.a.$sendProcessProperty(u,N))),this.y.startBuffering(u,l.onProcessData),w.add(l.onProcessExit(N=>this.U(u,N))),this.g.set(u,l);const A=this.j[u];return A&&l instanceof $&&(l.startSendingEvents(A.initialDimensions),delete this.j[u]),w}$acceptProcessAckDataEvent(u,l){this.g.get(u)?.acknowledgeDataEvent(l)}$acceptProcessInput(u,l){this.g.get(u)?.input(l)}$acceptTerminalInteraction(u){const l=this.W(u);l?.setInteractedWith()&&this.M.fire(l.value)}$acceptTerminalSelection(u,l){this.W(u)?.setSelection(l)}$acceptProcessResize(u,l,w){try{this.g.get(u)?.resize(l,w)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown(u,l){this.g.get(u)?.shutdown(l)}$acceptProcessRequestInitialCwd(u){this.g.get(u)?.getInitialCwd().then(l=>this.a.$sendProcessProperty(u,{type:"initialCwd",value:l}))}$acceptProcessRequestCwd(u){this.g.get(u)?.getCwd().then(l=>this.a.$sendProcessProperty(u,{type:"cwd",value:l}))}$acceptProcessRequestLatency(u){return Promise.resolve(u)}registerLinkProvider(u){return this.z.add(u),this.z.size===1&&this.a.$startLinkProvider(),new k.$2J(()=>{this.z.delete(u),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(u,l,w){if(this.C.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this.C.set(l,w),this.a.$registerProfileProvider(l,u.identifier.value),new k.$2J(()=>{this.C.delete(l),this.a.$unregisterProfileProvider(l)})}registerTerminalQuickFixProvider(u,l,w){if(this.D.has(u))throw new Error(`Terminal quick fix provider "${u}" is already registered`);return this.D.set(u,w),this.a.$registerQuickFixProvider(u,l),new k.$2J(()=>{this.D.delete(u),this.a.$unregisterQuickFixProvider(u)})}async $provideTerminalQuickFixes(u,l){const w=new p.$pd().token;if(w.isCancellationRequested)return;const A=this.D.get(u);if(!A)return;const N=await A.provideTerminalQuickFixes(l,w);if(N===null||Array.isArray(N)&&N.length===0)return;const O=new m.$jc;if(this.w.value=O,!Array.isArray(N))return N?s.TerminalQuickFix.from(N,this.Q.converter,O):void 0;const F=[];for(const j of N){const z=s.TerminalQuickFix.from(j,this.Q.converter,O);z&&F.push(z)}return F}async $createContributedProfileTerminal(u,l){const w=new p.$pd().token;let A=await this.C.get(u)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,l);return}this.createTerminalFromOptions(A.options,l)}}async $provideLinks(u,l){const w=this.W(u);if(!w)return[];this.F.delete(u),this.G.get(u)?.dispose(!0);const N=new p.$pd;this.G.set(u,N);const O=[],F={terminal:w.value,line:l},j=[];for(const H of this.z)j.push(o.Promises.withAsyncBody(async q=>{N.token.onCancellationRequested(()=>q({provider:H,links:[]}));const me=await H.provideTerminalLinks(F,N.token)||[];N.token.isCancellationRequested||q({provider:H,links:me})}));const z=await Promise.all(j);if(N.token.isCancellationRequested)return[];const T=new Map;for(const H of z)H&&H.links.length>0&&O.push(...H.links.map(q=>{const me={id:d++,startIndex:q.startIndex,length:q.length,label:q.tooltip};return T.set(me.id,{provider:H.provider,link:q}),me}));return this.F.set(u,T),O}$activateLink(u,l){const w=this.F.get(u)?.get(l);w&&w.provider.handleTerminalLink(w.link)}U(u,l){this.y.stopBuffering(u),this.g.delete(u),delete this.j[u];const w=this.h[u];w&&(w.dispose(),delete this.h[u]),this.a.$sendProcessExit(u,l)}W(u){return this.X(this.f,u)}X(u,l){const w=this.Y(u,l);return w!==null?u[w]:null}Y(u,l){const w=u.findIndex(A=>A._id===l);return w===-1?null:w}getEnvironmentVariableCollection(u){let l=this.n.get(u.identifier.value);return l||(l=new r,this.$(u.identifier.value,l)),l.getScopedEnvironmentVariableCollection(void 0)}Z(u,l){const w=(0,I.$ar)(l.map),A=(0,I.$br)(l.descriptionMap);this.a.$setEnvironmentVariableCollection(u,l.persistent,w.length===0?void 0:w,A)}$initEnvironmentVariableCollections(u){u.forEach(l=>{const w=l[0],A=new r(l[1]);this.$(w,A)})}$acceptDefaultProfile(u,l){const w=this.s;this.s=u,this.u=l,w?.path!==u.path&&this.N.fire(u.path)}$(u,l){this.n.set(u,l),l.onDidChangeCollection(()=>{this.Z(u,l)})}};e.$Abc=t,e.$Abc=t=Ke([Be(1,n.$lM),Be(2,R.$2L)],t);class r{get persistent(){return this.b}set persistent(u){this.b=u,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(u){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new D.$fd,this.map=new Map(u)}getScopedEnvironmentVariableCollection(u){const l=this.h(u);let w=this.a.get(l);return w||(w=new a(this,u),this.a.set(l,w),w.onDidChangeCollection(()=>this.d.fire())),w}replace(u,l,w,A){this.f(u,{value:l,type:k.EnvironmentVariableMutatorType.Replace,options:w??{applyAtProcessCreation:!0},scope:A})}append(u,l,w,A){this.f(u,{value:l,type:k.EnvironmentVariableMutatorType.Append,options:w??{applyAtProcessCreation:!0},scope:A})}prepend(u,l,w,A){this.f(u,{value:l,type:k.EnvironmentVariableMutatorType.Prepend,options:w??{applyAtProcessCreation:!0},scope:A})}f(u,l){if(l.options&&l.options.applyAtProcessCreation===!1&&!l.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const w=this.g(u,l.scope),A=this.map.get(w),N=l.options?{applyAtProcessCreation:l.options.applyAtProcessCreation??!1,applyAtShellIntegration:l.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!A||A.value!==l.value||A.type!==l.type||A.options?.applyAtProcessCreation!==N.applyAtProcessCreation||A.options?.applyAtShellIntegration!==N.applyAtShellIntegration||A.scope?.workspaceFolder?.index!==l.scope?.workspaceFolder?.index){const O=this.g(u,l.scope),F={variable:u,...l,options:N};this.map.set(O,F),this.d.fire()}}get(u,l){const w=this.g(u,l),A=this.map.get(w);return A?y(A):void 0}g(u,l){const w=this.h(l);return w.length?`${u}:::${w}`:u}h(u){return this.j(u?.workspaceFolder)??""}j(u){return u?u.uri.toString():void 0}getVariableMap(u){const l=new Map;for(const[w,A]of this.map)this.h(A.scope)===this.h(u)&&l.set(A.variable,y(A));return l}delete(u,l){const w=this.g(u,l);this.map.delete(w),this.d.fire()}clear(u){if(u?.workspaceFolder){for(const[l,w]of this.map)w.scope?.workspaceFolder?.index===u.workspaceFolder.index&&this.map.delete(l);this.k(u)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(u,l){const w=this.h(l),A=this.descriptionMap.get(w);if(!A||A.description!==u){let N;typeof u=="string"?N=u:N=u?.value.split(`

`)[0];const O={description:N,scope:l};this.descriptionMap.set(w,O),this.d.fire()}}getDescription(u){const l=this.h(u);return this.descriptionMap.get(l)?.description}k(u){const l=this.h(u);this.descriptionMap.delete(l)}}class a{get persistent(){return this.b.persistent}set persistent(u){this.b.persistent=u}get onDidChangeCollection(){return this.a&&this.a.event}constructor(u,l){this.b=u,this.d=l,this.a=new D.$fd}getScoped(u){return this.b.getScopedEnvironmentVariableCollection(u)}replace(u,l,w){this.b.replace(u,l,w,this.d)}append(u,l,w){this.b.append(u,l,w,this.d)}prepend(u,l,w){this.b.prepend(u,l,w,this.d)}get(u){return this.b.get(u,this.d)}forEach(u,l){this.b.getVariableMap(this.d).forEach((w,A)=>u.call(l,A,w,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(u){this.b.delete(u,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(u){this.b.setDescription(u,this.d)}get description(){return this.b.getDescription(this.d)}}let i=class extends t{constructor(u,l){super(!1,u,l)}createTerminal(u,l,w){throw new P.$0}createTerminalFromOptions(u,l){throw new P.$0}};e.$Bbc=i,e.$Bbc=i=Ke([Be(0,n.$lM),Be(1,R.$2L)],i);function c(E){if(!(!E||typeof E=="string"))return"id"in E?{id:E.id,color:E.color}:E}function f(E){return v.ThemeColor.isThemeColor(E)?E:void 0}function y(E){const u={...E};return delete u.scope,u.options=u.options??void 0,delete u.variable,u}}),define(Se[328],De([1,0,118,9,22,21,4,75,51,3,23,18,31,6,20,145,13,7,69,109,88,27]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o,s,n,h,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=e.$Kcc=e.$Jcc=e.$Icc=void 0;let t=class{constructor(F,j,z){this.k=z,this.d=new R.$fd,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=F.getProxy(S.$ZJ.MainThreadTesting),this.j=new w(this.g),this.h=new c(this.g),j.registerArgumentProcessor({processArgument:T=>{switch(T?.$mid){case 16:{const H=T,q=H.tests[H.tests.length-1].item.extId;return this.f.get(n.$OI.root(q))?.collection.tree.get(q)?.actual??(0,v.$bM)(T)}case 18:{const{extId:H,message:q}=T;return{test:this.f.get(n.$OI.root(H))?.collection.tree.get(H)?.actual,message:o.TestMessage.to(q)}}default:return T}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const T=await j.executeCommand("_testing.getExplorerSelection"),H=q=>{const me=this.f.get(n.$OI.root(q));if(me)return n.$OI.isRoot(q)?me.controller:me.collection.tree.get(q)?.actual};return{include:T?.include.map(H).filter(I.$rf)||[],exclude:T?.exclude.map(H).filter(I.$rf)||[]}})}createTestController(F,j,z,T){if(this.f.has(j))throw new Error(`Attempt to insert a duplicate controller with ID "${j}"`);const H=new b.$jc,q=H.add(new v.$eM(j,z,this.k));q.root.label=z;const me=new Map,X=this.g,Z={items:q.root.children,get label(){return z},set label(x){z=x,q.root.label=x,X.$updateController(j,{label:z})},get refreshHandler(){return T},set refreshHandler(x){T=x,X.$updateController(j,{canRefresh:!!x})},get id(){return j},createRunProfile:(x,ge,ue,we,G,U)=>{let K=(0,k.$pi)(x);for(;me.has(K);)K++;return new A(this.g,me,j,K,x,ge,ue,we,G,U)},createTestItem(x,ge,ue){return new v.$cM(j,x,ge,ue)},createTestRun:(x,ge,ue=!0)=>this.h.createTestRun(F,j,q,x,ge,ue),invalidateTestResults:x=>{if(x===void 0)this.g.$markTestRetired(void 0);else{const ge=x instanceof Array?x:[x];this.g.$markTestRetired(ge.map(ue=>n.$OI.fromExtHostTestItem(ue,j).toString()))}},set resolveHandler(x){q.resolveHandler=x},get resolveHandler(){return q.resolveHandler},dispose:()=>{H.dispose()}};X.$registerTestController(j,z,!!T),H.add((0,b.$ic)(()=>X.$unregisterTestController(j)));const V={controller:Z,collection:q,profiles:me,extension:F};return this.f.set(j,V),H.add((0,b.$ic)(()=>this.f.delete(j))),H.add(q.onDidGenerateDiff(x=>X.$publishDiff(j,x.map($.TestsDiffOp.serialize)))),Z}createTestObserver(){return this.j.checkout()}async runTests(F,j=L.CancellationToken.None){const z=f(F);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const T=this.f.get(z.controllerId);if(!T)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:F.include?.map(H=>n.$OI.fromExtHostTestItem(H,T.collection.root.id).toString())??[T.collection.root.id],profileGroup:N[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:F.exclude?.map(H=>H.id)},j)}$syncTests(){for(const{collection:F}of this.f.values())F.flushDiff();return Promise.resolve()}$provideFileCoverage(F,j,z){return(0,D.$pb)(this.h.trackers,H=>H.id===F?H.getCoverage(j):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(F,j,z,T){return(0,D.$pb)(this.h.trackers,q=>q.id===F?q.getCoverage(j):void 0)?.resolveFileCoverage(z,T)??Promise.resolve([])}$configureRunProfile(F,j){this.f.get(F)?.profiles.get(j)?.configureHandler?.()}async $refreshTests(F,j){await this.f.get(F)?.controller.refreshHandler?.(j)}$publishTestResults(F){this.results=Object.freeze(F.map(j=>(0,P.$Wm)(o.TestResults.to(j))).concat(this.results).sort((j,z)=>z.completedAt-j.completedAt).slice(0,32)),this.d.fire()}async $expandTest(F,j){const z=this.f.get(n.$OI.fromString(F).controllerId)?.collection;z&&(await z.expand(F,j<0?1/0:j),z.flushDiff())}$acceptDiff(F){this.j.applyDiff(F.map($.TestsDiffOp.deserialize))}async $runControllerTests(F,j){return Promise.all(F.map(z=>this.l(z,!1,j)))}async $startContinuousRun(F,j){const z=new L.$pd(j),T=await Promise.all(F.map(H=>this.l(H,!0,z.token)));return!j.isCancellationRequested&&!T.some(H=>H.error)&&await new Promise(H=>j.onCancellationRequested(H)),z.dispose(!0),T}async l(F,j,z){const T=this.f.get(F.controllerId);if(!T)return{};const{collection:H,profiles:q,extension:me}=T,X=q.get(F.profileId);if(!X)return{};const Z=F.testIds.map(ue=>H.tree.get(ue)).filter(I.$rf),V=F.excludeExtIds.map(ue=>T.collection.tree.get(ue)).filter(I.$rf).filter(ue=>Z.some(we=>we.fullId.compare(ue.fullId)===2));if(!Z.length)return{};const x=new s.$yL(Z.some(ue=>ue.actual instanceof v.$dM)?void 0:Z.map(ue=>ue.actual),V.map(ue=>ue.actual),X,j),ge=(0,$.$QI)(F)&&this.h.prepareForMainThreadTestRun(x,y.fromInternal(F,T.collection),me,z);try{return await X.runHandler(x,z),{}}catch(ue){return{error:String(ue)}}finally{ge&&(ge.hasRunningTasks&&!z.isCancellationRequested&&await R.Event.toPromise(ge.onEnd),ge.dispose())}}$cancelExtensionTestRun(F){F===void 0?this.h.cancelAllRuns():this.h.cancelRunById(F)}};e.$Icc=t,e.$Icc=t=Ke([Be(0,C.$2L)],t);const r=1e4;var a;(function(O){O[O.Running=0]="Running",O[O.Cancelling=1]="Cancelling",O[O.Ended=2]="Ended"})(a||(a={}));class i extends b.$kc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(F,j,z,T){super(),this.s=F,this.u=j,this.w=z,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$fd),this.onEnd=this.m.event,this.j=this.B(new L.$pd(T));const H=this.B(new M.$Sg(()=>this.y(),r));this.B(this.j.token.onCancellationRequested(()=>H.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(F){return this.g.get(F)?.coverage}createRun(F){const j=this.s.id,z=this.s.controllerId,T=(0,p.$4f)(),H=new E(this.u,j,T),q=V=>(x,...ge)=>{if(X){console.warn(`Setting the state of test "${x.id}" is a no-op after the run ends.`);return}this.s.isIncluded(x)&&(this.C(x),V(x,...ge))},me=(V,x)=>{const ge=x instanceof Array?x.map(o.TestMessage.from):[o.TestMessage.from(x)];if(ge.some(ue=>ue.contextValue!==void 0)&&(0,d.$QF)(this.w,"testMessageContextValue"),V.uri&&V.range){const ue={range:o.Range.from(V.range),uri:V.uri};for(const we of ge)we.location=we.location||ue}this.u.$appendTestMessagesInRun(j,T,n.$OI.fromExtHostTestItem(V,z).toString(),ge)};let X=!1;const Z={isPersisted:this.s.isPersisted,token:this.j.token,name:F,get coverageProvider(){return H.coverageProvider},set coverageProvider(V){H.coverageProvider=V},enqueued:q(V=>{this.u.$updateTestStateInRun(j,T,n.$OI.fromExtHostTestItem(V,z).toString(),1)}),skipped:q(V=>{this.u.$updateTestStateInRun(j,T,n.$OI.fromExtHostTestItem(V,z).toString(),5)}),started:q(V=>{this.u.$updateTestStateInRun(j,T,n.$OI.fromExtHostTestItem(V,z).toString(),2)}),errored:q((V,x,ge)=>{me(V,x),this.u.$updateTestStateInRun(j,T,n.$OI.fromExtHostTestItem(V,z).toString(),6,ge)}),failed:q((V,x,ge)=>{me(V,x),this.u.$updateTestStateInRun(j,T,n.$OI.fromExtHostTestItem(V,z).toString(),4,ge)}),passed:q((V,x)=>{this.u.$updateTestStateInRun(j,T,n.$OI.fromExtHostTestItem(V,this.s.controllerId).toString(),3,x)}),appendOutput:(V,x,ge)=>{X||(ge&&(this.s.isIncluded(ge)?this.C(ge):ge=void 0),this.u.$appendOutputToRun(j,T,g.$Fd.fromString(V),x&&o.location.from(x),ge&&n.$OI.fromExtHostTestItem(ge,z).toString()))},end:()=>{X||(X=!0,this.u.$finishedTestRunTask(j,T),this.g.delete(T),this.g.size||this.z())}};return this.g.set(T,{run:Z,coverage:H}),this.u.$startedTestRunTask(j,{id:T,name:F,running:!0}),Z}y(){for(const{run:F}of this.g.values())F.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(F){if(!(F instanceof v.$cM))throw new h.$TL(F.id);if(this.h.has(n.$OI.fromExtHostTestItem(F,this.s.controllerId).toString()))return;const j=[],z=this.s.colllection.root;for(;;){const T=o.TestItem.from(F);if(j.unshift(T),this.h.has(T.extId)||(this.h.add(T.extId),F===z))break;F=F.parent||z}this.u.$addTestsToRun(this.s.controllerId,this.s.id,j)}dispose(){this.z(),super.dispose()}}class c{get trackers(){return this.d.values()}constructor(F){this.f=F,this.d=new Map}prepareForMainThreadTestRun(F,j,z,T){return this.g(F,j,z,T)}cancelRunById(F){for(const j of this.d.values())if(j.id===F){j.cancel();return}}cancelAllRuns(){for(const F of this.d.values())F.cancel()}createTestRun(F,j,z,T,H,q){const me=this.d.get(T);if(me)return me.createRun(H);const X=y.fromPublic(j,z,T,q),Z=f(T);this.f.$startedExtensionTestRun({controllerId:j,continuous:!!T.continuous,profile:Z&&{group:N[Z.kind],id:Z.profileId},exclude:T.exclude?.map(x=>n.$OI.fromExtHostTestItem(x,z.root.id).toString())??[],id:X.id,include:T.include?.map(x=>n.$OI.fromExtHostTestItem(x,z.root.id).toString())??[z.root.id],persist:q});const V=this.g(T,X,F);return R.Event.once(V.onEnd)(()=>{this.f.$finishedExtensionTestRun(X.id),V.dispose()}),V.createRun(H)}g(F,j,z,T){const H=new i(j,this.f,z,T);return this.d.set(F,H),R.Event.once(H.onEnd)(()=>this.d.delete(F)),H}}e.$Jcc=c;const f=O=>{if(O.profile){if(!(O.profile instanceof A))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return O.profile}};class y{static fromPublic(F,j,z,T){return new y(F,(0,p.$4f)(),z.include?.map(H=>n.$OI.fromExtHostTestItem(H,F).toString())??[F],z.exclude?.map(H=>n.$OI.fromExtHostTestItem(H,F).toString())??[],T,j)}static fromInternal(F,j){return new y(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,j)}constructor(F,j,z,T,H,q){this.controllerId=F,this.id=j,this.isPersisted=H,this.colllection=q,this.d=z.map(me=>me+"\0"),this.f=T.map(me=>me+"\0")}isIncluded(F){const j=n.$OI.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const z of this.f)if(j===z||j.startsWith(z))return!1;for(const z of this.d)if(j===z||j.startsWith(z))return!0;return!1}}e.$Kcc=y;class E{set coverageProvider(F){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");F&&(this.d=F,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(F,j,z){this.g=F,this.h=j,this.j=z}async provideFileCoverage(F){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(F))());try{return(await this.f)?.map(o.TestCoverage.fromFile)??[]}catch(j){throw this.f=void 0,j}}async resolveFileCoverage(F,j){const z=await this.f;let T=z?.[F];return!this.d||!z||!T?[]:(T.detailedCoverage||(T=z[F]=await this.d.resolveFileCoverage?.(T,j)??T),T.detailedCoverage?.map(o.TestCoverage.fromDetailed)??[])}}class u{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(F){this.j=F,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(F){this.d.add(F)}update(F){Object.assign(F.revived,o.TestItem.toPlain(F.item)),this.d.has(F)||this.f.add(F)}remove(F){if(this.d.has(F)){this.d.delete(F);return}this.f.delete(F);const j=n.$OI.parentId(F.item.extId);if(j&&this.h.has(j.toString())){this.h.add(F.item.extId);return}this.g.add(F)}getChangeEvent(){const{d:F,f:j,g:z}=this;return{get added(){return[...F].map(T=>T.revived)},get updated(){return[...j].map(T=>T.revived)},get removed(){return[...z].map(T=>T.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class l extends $.$VI{constructor(){super(...arguments),this.s=new R.$fd,this.onDidChangeTests=this.s.event}get rootTests(){return super.g}getMirroredTestDataById(F){return this.f.get(F)}getMirroredTestDataByReference(F){return this.f.get(F.id)}q(F,j){return{...F,revived:o.TestItem.toPlain(F.item),depth:j?j.depth+1:0,children:new Set}}p(){return new u(this.s)}}class w{constructor(F){this.f=F}checkout(){this.d||(this.d=this.g());const F=this.d;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(j=>j.revived)},dispose:(0,m.$bb)(()=>{--F.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(F){return this.d?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.d?.tests.apply(F)}g(){const F=new l;return this.f.$subscribeToDiffs(),{observers:0,tests:F}}}class A{#e;#t;get label(){return this.f}set label(F){F!==this.f&&(this.f=F,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:F}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(F){F!==this.h&&(this.h=F,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:F}))}get isDefault(){return this.g}set isDefault(F){F!==this.g&&(this.g=F,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:F?o.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this.d}set configureHandler(F){F!==this.d&&(this.d=F,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!F}))}constructor(F,j,z,T,H,q,me,X=!1,Z=void 0,V=!1){this.controllerId=z,this.profileId=T,this.f=H,this.kind=q,this.runHandler=me,this.g=X,this._tag=Z,this.h=V,this.#e=F,this.#t=j,j.set(T,this);const x=N[q];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${q}`);this.#e.$publishTestRunProfile({profileId:T,controllerId:z,tag:Z?o.TestTag.namespace(this.controllerId,Z.id):null,label:H,group:x,isDefault:X,hasConfigurationHandler:!1,supportsContinuousRun:V})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Lcc=A;const N={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(Se[329],De([1,0,19,8,4,6,146,13,7]),function($e,e,D,M,g,L,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1bc=void 0;class b{constructor(I,p){this.i=p,this.a=new g.$fd({onListenerError:M.$Z}),this.b=new g.$fd({onListenerError:M.$Z}),this.c=new g.$fd({onListenerError:M.$Z}),this.d=new g.$fd({onListenerError:M.$Z}),this.f=new g.$fd({onListenerError:M.$Z}),this.g=new g.$fd({onListenerError:M.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=I.getProxy(L.$ZJ.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(S=>this.g.fire(S)),this.i.onDidChangeActiveTextEditor(S=>this.f.fire(S))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(I){const p=this.i.allEditors();return I?p:p.map(S=>S.value)}async showTextDocument(I,p,S){let C;typeof p=="number"?C={position:m.ViewColumn.from(p),preserveFocus:S}:typeof p=="object"?C={position:m.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selection:typeof p.selection=="object"?m.Range.from(p.selection):void 0,pinned:typeof p.preview=="boolean"?!p.preview:void 0}:C={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(I.uri,C),o=v&&this.i.getEditor(v);if(o)return o.value;throw v?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,p){return new R.$9L(this.h,I,p).value}$acceptEditorPropertiesChanged(I,p){const S=this.i.getEditor(I);if(!S)throw new Error("unknown text editor");if(p.options&&S._acceptOptions(p.options),p.selections){const C=p.selections.selections.map(m.Selection.to);S._acceptSelections(C)}if(p.visibleRanges){const C=D.$Fb(p.visibleRanges.map(m.Range.to));S._acceptVisibleRanges(C)}if(p.options&&this.b.fire({textEditor:S.value,options:{...p.options,lineNumbers:m.TextEditorLineNumbersStyle.to(p.options.lineNumbers)}}),p.selections){const C=k.TextEditorSelectionChangeKind.fromValue(p.selections.source),v=p.selections.selections.map(m.Selection.to);this.a.fire({textEditor:S.value,selections:v,kind:C})}if(p.visibleRanges){const C=D.$Fb(p.visibleRanges.map(m.Range.to));this.c.fire({textEditor:S.value,visibleRanges:C})}}$acceptEditorPositionData(I){for(const p in I){const S=this.i.getEditor(p);if(!S)throw new Error("Unknown text editor");const C=m.ViewColumn.to(I[p]);S.value.viewColumn!==C&&(S._acceptViewColumn(C),this.d.fire({textEditor:S.value,viewColumn:C}))}}getDiffInformation(I){return Promise.resolve(this.h.$getDiffInformation(I))}}e.$1bc=b}),define(Se[330],De([1,0,2,5,6,3,7,13,25,18]),function($e,e,D,M,g,L,R,m,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=e.$Ccc=void 0,e.$Ccc=(0,M.$Bh)("IExtHostTimeline");class P{constructor(S,C){this.b=new Map,this.c=new Map,this.a=S.getProxy(g.$ZJ.MainThreadTimeline),C.registerArgumentProcessor({processArgument:(v,o)=>{if(v&&v.$mid===12)if(this.b.get(v.source)&&k.$Vl.equals(o,this.b.get(v.source)?.extension)){const s=v.uri===void 0?void 0:D.URI.revive(v.uri);return this.c.get(v.source)?.get(I(s))?.get(v.handle)}else return;return v}})}async $getTimeline(S,C,v,o){return this.b.get(S)?.provider.provideTimeline(D.URI.revive(C),v,o)}registerTimelineProvider(S,C,v,o){const s=new L.$jc,n=this.d(C.id,o,s).bind(this);let h;C.onDidChange&&(h=C.onDidChange(d=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...d,id:C.id}),this));const $=this.c;return this.f({...C,scheme:S,onDidChange:void 0,async provideTimeline(d,t,r){t?.resetCache&&(s.clear(),$.get(C.id)?.clear());const a=await C.provideTimeline(d,t,r);if(a==null)return;const i=n(d,t);return{...a,source:C.id,items:a.items.map(i)}},dispose(){for(const d of $.values())d.get(C.id)?.clear();h?.dispose(),s.dispose()}},v)}d(S,C,v){return(o,s)=>{let n;if(s?.cacheResults){let h=this.c.get(S);h===void 0&&(h=new Map,this.c.set(S,h));const $=I(o);n=h.get($),n===void 0&&(n=new Map,h.set($,n))}return h=>{const{iconPath:$,...d}=h,t=`${S}|${h.id??h.timestamp}`;n?.set(t,h);let r,a,i;h.iconPath&&($ instanceof R.$WK?i={id:$.id,color:$.color}:D.URI.isUri($)?(r=$,a=$):{light:r,dark:a}=$);let c;return R.$qK.isMarkdownString(d.tooltip)?c=m.MarkdownString.from(d.tooltip):(0,b.$jf)(d.tooltip)?c=d.tooltip:R.$qK.isMarkdownString(d.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=m.MarkdownString.from(d.detail)):(0,b.$jf)(d.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=d.detail),{...d,id:d.id??void 0,handle:t,source:S,command:h.command?C.toInternal(h.command,v):void 0,icon:r,iconDark:a,themeIcon:i,tooltip:c,accessibilityInformation:h.accessibilityInformation}}}}f(S,C){if(this.b.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this.a.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this.b.set(S.id,{provider:S,extension:C}),(0,L.$ic)(()=>{for(const o of this.c.values())o.get(S.id)?.clear();this.b.delete(S.id),this.a.$unregisterTimelineProvider(S.id),S.dispose()})}}e.$Dcc=P;function I(p){return p?.toString()}}),define(Se[74],De([1,0,21,4,3,213,5,14,86,6,26,20,7]),function($e,e,D,M,g,L,R,m,k,b,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ssb=e.$rsb=e.TunnelDtoConverter=void 0;class S extends k.$6z{}var C;(function(o){function s(h){return{remoteAddress:h.remoteAddress,localAddress:h.localAddress,public:!!h.public,privacy:h.privacy??(h.public?k.TunnelPrivacyId.Public:k.TunnelPrivacyId.Private),protocol:h.protocol}}o.fromApiTunnel=s;function n(h){return{remoteAddress:{host:h.tunnelRemoteHost,port:h.tunnelRemotePort},localAddress:h.localAddress,public:h.privacy!==k.TunnelPrivacyId.ConstantPrivate&&h.privacy!==k.TunnelPrivacyId.ConstantPrivate,privacy:h.privacy,protocol:h.protocol}}o.fromServiceTunnel=n})(C||(e.TunnelDtoConverter=C={})),e.$rsb=(0,R.$Bh)("IExtHostTunnelService");let v=class extends g.$kc{constructor(s,n,h){super(),this.s=h,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$fd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(b.$ZJ.MainThreadTunnelService)}async openTunnel(s,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const h=await this.a.$openTunnel(n,s.displayName);if(h){const $=new S(h.remoteAddress,h.localAddress,()=>this.a.$closeTunnel(h.remoteAddress));return this.B($),$}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,n){const h=this.u();return this.r.set(h,{selector:s,provider:n}),this.a.$registerPortsAttributesProvider(s,h),new p.$2J(()=>{this.r.delete(h),this.a.$unregisterPortsAttributesProvider(h)})}async $providePortAttributes(s,n,h,$,d){const t=[];for(const a of s){const i=this.r.get(a);if(!i)return[];t.push(...await Promise.all(n.map(async c=>{let f;try{f=await i.provider.providePortAttributes({port:c,pid:h,commandLine:$},d)}catch{f=await i.provider.providePortAttributes(c,h,$,d)}return{providedAttributes:f,port:c}})))}const r=t.filter(a=>!!a.providedAttributes);return r.length>0?r.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async($,d)=>await s.provideTunnel($,d,new D.$pd().token)??void 0;const h=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(h),Promise.resolve((0,g.$ic)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,n){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const h=s.tunnelFactory??(n?this.w(n):void 0);if(h){this.b=h;let $=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&$.length===0&&($=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const d=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:$}:void 0;this.a.$setTunnelProvider(d)}}else this.b=void 0;return(0,g.$ic)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,n){if(this.g.has(s.host)){const h=this.g.get(s.host);h.has(s.port)&&(n&&h.get(s.port).disposeListener.dispose(),await h.get(s.port).tunnel.dispose(),h.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const h=this.b(s,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),h!==void 0){const $=await h;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),$===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const d=this.B($.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel($.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:$,disposeListener:d}),C.fromApiTunnel($)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(h){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),h instanceof Error)return h.message}}async $applyCandidateFilter(s){const n=await Promise.all(s.map($=>this.f($.host,$.port,$.detail??""))),h=s.filter(($,d)=>n[d]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map($=>$.port).join(", ")} to ${h.map($=>$.port).join(", ")}`),h}};e.$ssb=v,e.$ssb=v=Ke([Be(0,I.$2L),Be(1,P.$fM),Be(2,m.$5i)],v)}),define(Se[331],De([1,0,3,17,2,6]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;class R{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor(k){this.c=new Map,this.b=k.getProxy(L.$ZJ.MainThreadUriOpeners)}registerExternalUriOpener(k,b,P,I){if(this.c.has(b))throw new Error(`Opener with id '${b}' already registered`);const p=I.schemes.find(S=>!R.a.has(S));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this.c.set(b,P),this.b.$registerUriOpener(b,I.schemes,k,I.label),(0,D.$ic)(()=>{this.c.delete(b),this.b.$unregisterUriOpener(b)})}async $canOpenUri(k,b,P){const I=this.c.get(k);if(!I)throw new Error(`Unknown opener with id: ${k}`);const p=g.URI.revive(b);return I.canOpenExternalUri(p,P)}async $openUri(k,b,P){const I=this.c.get(k);if(!I)throw new Error(`Unknown opener id: '${k}'`);return I.openExternalUri(g.URI.revive(b.resolvedUri),{sourceUri:g.URI.revive(b.sourceUri)},P)}}e.$Mcc=R}),define(Se[332],De([1,0,6,2,3,8,25]),function($e,e,D,M,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=void 0;class m{static{this.a=0}constructor(b){this.c=new R.$Wl,this.d=new Map,this.b=b.getProxy(D.$ZJ.MainThreadUrls)}registerUriHandler(b,P){const I=b.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const p=m.a++;return this.c.add(I),this.d.set(p,P),this.b.$registerUriHandler(p,I,b.displayName||b.name),(0,g.$ic)(()=>{this.c.delete(I),this.d.delete(p),this.b.$unregisterUriHandler(p)})}$handleExternalUri(b,P){const I=this.d.get(b);if(!I)return Promise.resolve(void 0);try{I.handleUri(M.URI.revive(P))}catch(p){(0,L.$Y)(p)}return Promise.resolve(void 0)}async createAppUri(b){return M.URI.revive(await this.b.$createAppUri(b))}}e.$3bc=m}),define(Se[92],De([1,0,4,3,17,23,2,228,265,110,6]),function($e,e,D,M,g,L,R,m,k,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=e.$7bc=e.$6bc=e.$5bc=e.$4bc=void 0;class I{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor($,d,t,r,a,i,c){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new D.$fd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new D.$fd,this._onDidDispose=this.#h.event,this.#e=$,this.#t=d,this.#r=t,this.#l=r,this.#u=a,this.#n=i,this.#c=p(i),this.#d=S(i),this.#i=c}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri($){return this.#a=!0,(0,b.$Yob)($,this.#l)}get cspSource(){const $=this.#n.extensionLocation;if($.scheme===g.Schemas.https||$.scheme===g.Schemas.http){let d=$.toString();return d.endsWith("/")||(d+="/"),d+" "+b.$Xob}return b.$Xob}get html(){return this.a(),this.#s}set html($){this.a(),this.#s!==$&&(this.#s=$,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test($)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b($)))}get options(){return this.a(),this.#r}set options($){this.a(),L.$Zm(this.#r,$)||this.#t.$setOptions(this.#e,o(this.#n,this.#u,$)),this.#r=$}async postMessage($){if(this.#o)return!1;const d=(0,k.$9bb)($,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,d.message,...d.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b($){if(!this.#d)return $;const d=this.#n.extensionLocation?.scheme===g.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===g.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return $.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,a,i,c,f,y)=>{const E=R.URI.from({scheme:c||"file",path:decodeURIComponent(f)}),u=(0,b.$Yob)(E,{isRemote:d,authority:t}).toString();return`${a}${u}${y}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,a,i,c,f,y)=>{const E=R.URI.from({scheme:c||"file",path:decodeURIComponent(f)}),u=(0,b.$Yob)(E,{isRemote:d,authority:t}).toString();return`${a}${u}${y}`})}}e.$4bc=I;function p(h){try{const $=(0,m.$Do)((0,m.$Co)(h.engines.vscode));return!!$&&$.majorBase>=1&&$.minorBase>=57}catch{return!1}}e.$5bc=p;function S(h){try{const $=(0,m.$Do)((0,m.$Co)(h.engines.vscode));return $?$.majorBase<1||$.majorBase===1&&$.minorBase<60:!1}catch{return!1}}class C extends M.$kc{constructor($,d,t,r,a){super(),this.c=d,this.f=t,this.g=r,this.h=a,this.b=new Map,this.a=$.getProxy(P.$ZJ.MainThreadWebviews)}dispose(){super.dispose();for(const $ of this.b.values())$.dispose();this.b.clear()}$onMessage($,d,t){const r=this.j($);if(r){const{message:a}=(0,k.$0bb)(d,t.value);r._onMessageEmitter.fire(a)}}$onMissingCsp($,d){this.g.warn(`${d} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview($,d,t){const r=new I($,this.a,s(d),this.c,this.f,t,this.h);this.b.set($,r);const a=r._onDidDispose(()=>{a.dispose(),this.deleteWebview($)});return r}deleteWebview($){this.b.delete($)}j($){return this.b.get($)}}e.$6bc=C;function v(h){return{id:h.identifier,location:h.extensionLocation}}e.$7bc=v;function o(h,$,d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots||n(h,$)}}e.$8bc=o;function s(h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots?.map($=>R.URI.from($))}}function n(h,$){return[...($?.getWorkspaceFolders()||[]).map(d=>d.uri),h.extensionLocation]}}),define(Se[333],De([1,0,21,51,3,17,24,2,13,92,87,6,7]),function($e,e,D,M,g,L,R,m,k,b,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcc=void 0;class S{constructor(r,a){this.document=r,this.b=a,this.a=1,this.c=new P.$Zac("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,a){await this.f(r).undo(),a||this.disposeBackup()}async redo(r,a){await this.f(r).redo(),a||this.disposeBackup()}disposeEdits(r){for(const a of r)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=d(this.document.uri)+this.a++;return(0,R.$ig)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const a=this.c.get(r,0);if(!a)throw new Error("No edit found");return a}}class C{constructor(){this.a=new Map}get(r,a){return this.a.get(this.b(r,a))}add(r,a,i){const c=this.b(r,a.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${r} resource:${a.uri}`);const f=new S(a,i);return this.a.set(c,f),f}delete(r,a){const i=this.b(r,a.uri);this.a.delete(i)}b(r,a){return`${r}@@@${a}`}}var v;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(v||(v={}));class o{constructor(){this.a=new Map}addTextProvider(r,a,i){return this.b(0,r,a,i)}addCustomProvider(r,a,i){return this.b(1,r,a,i)}get(r){return this.a.get(r)}b(r,a,i,c){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:r,extension:i,provider:c}),new p.$2J(()=>this.a.delete(a))}}class s{constructor(r,a,i,c,f){this.d=a,this.f=i,this.g=c,this.h=f,this.b=new o,this.c=new C,this.a=r.getProxy(I.$ZJ.MainThreadCustomEditors)}registerCustomEditorProvider(r,a,i,c){const f=new g.$jc;return h(i)?(f.add(this.b.addTextProvider(a,r,i)),this.a.$registerTextEditorProvider((0,b.$7bc)(r),a,c.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,b.$5bc)(r))):(f.add(this.b.addCustomProvider(a,r,i)),n(i)&&f.add(i.onDidChangeCustomDocument(y=>{const E=this.i(a,y.document.uri);if($(y)){const u=E.addEdit(y);this.a.$onDidEdit(y.document.uri,a,u,y.label)}else this.a.$onContentChange(y.document.uri,a)})),this.a.$registerCustomEditorProvider((0,b.$7bc)(r),a,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,b.$5bc)(r))),p.$2J.from(f,new p.$2J(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(r,a,i,c,f){const y=this.b.get(a);if(!y)throw new Error(`No provider found for '${a}'`);if(y.type!==1)throw new Error(`Invalid provide type for '${a}'`);const E=m.URI.revive(r),u=await y.provider.openCustomDocument(E,{backupId:i,untitledDocumentData:c?.buffer},f);let l;return n(y.provider)&&this.f&&(l=this.f.workspaceValue(y.extension)??this.f.globalValue(y.extension)),this.c.add(a,u,l),{editable:n(y.provider)}}async $disposeCustomDocument(r,a){const i=this.b.get(a);if(!i)throw new Error(`No provider found for '${a}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${a}'`);const c=m.URI.revive(r),{document:f}=this.i(a,c);this.c.delete(a,f),f.dispose()}async $resolveCustomEditor(r,a,i,c,f,y){const E=this.b.get(i);if(!E)throw new Error(`No provider found for '${i}'`);const u=k.ViewColumn.to(f),l=this.g.createNewWebview(a,c.contentOptions,E.extension),w=this.h.createNewWebviewPanel(a,i,c.title,u,c.options,l,c.active),A=m.URI.revive(r);switch(E.type){case 1:{const{document:N}=this.i(i,A);return E.provider.resolveCustomEditor(N,w,y)}case 0:{const N=this.d.getDocument(A);return E.provider.resolveCustomTextEditor(N,w,y)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,a,i){this.i(a,r).disposeEdits(i)}async $onMoveCustomEditor(r,a,i){const c=this.b.get(i);if(!c)throw new Error(`No provider found for '${i}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const f=this.h.getWebviewPanel(r);if(!f)throw new Error("No webview found");const y=m.URI.revive(a),E=this.d.getDocument(y);await c.provider.moveCustomTextEditor(E,f,D.CancellationToken.None)}async $undo(r,a,i,c){return this.i(a,r).undo(i,c)}async $redo(r,a,i,c){return this.i(a,r).redo(i,c)}async $revert(r,a,i){const c=this.i(a,r);await this.j(a).revertCustomDocument(c.document,i),c.disposeBackup()}async $onSave(r,a,i){const c=this.i(a,r);await this.j(a).saveCustomDocument(c.document,i),c.disposeBackup()}async $onSaveAs(r,a,i,c){const f=this.i(a,r);return this.j(a).saveCustomDocumentAs(f.document,m.URI.revive(i),c)}async $backup(r,a,i){const c=this.i(a,r),y=await this.j(a).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},i);return c.updateBackup(y),y.id}i(r,a){const i=this.c.get(r,m.URI.revive(a));if(!i)throw new Error("No custom document found");return i}j(r){const i=this.b.get(r)?.provider;if(!i||!n(i))throw new Error("Custom document is not editable");return i}}e.$Gcc=s;function n(t){return!!t.onDidChangeCustomDocument}function h(t){return typeof t.resolveCustomTextEditor=="function"}function $(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function d(t){const r=t.scheme===L.Schemas.file||t.scheme===L.Schemas.untitled?t.fsPath:t.toString();return(0,M.$pi)(r)+""}}),define(Se[334],De([1,0,4,3,2,31,13,92,6,7]),function($e,e,D,M,g,L,R,m,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=void 0;class P extends M.$kc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(C,v,o,s){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new D.$fd),this.onDidDispose=this.#d.event,this.#h=this.B(new D.$fd),this.onDidChangeViewState=this.#h.event,this.#e=C,this.#t=v,this.#l=o,this.#i=s.viewType,this.#u=s.panelOptions,this.#r=s.viewColumn,this.#n=s.title,this.#a=s.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(C){this.c(),this.#n!==C&&(this.#n=C,this.#t.$setTitle(this.#e,C))}get iconPath(){return this.c(),this.#s}set iconPath(C){this.c(),this.#s!==C&&(this.#s=C,this.#t.$setIconPath(this.#e,g.URI.isUri(C)?{light:C,dark:C}:C))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(C){this.#c||(this.active!==C.active||this.visible!==C.visible||this.viewColumn!==C.viewColumn)&&(this.#a=C.active,this.#o=C.visible,this.#r=C.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(C,v){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof C>"u"?void 0:R.ViewColumn.from(C),preserveFocus:!!v})}c(){if(this.#c)throw new Error("Webview is disposed")}}class I extends M.$kc{static c(){return(0,L.$4f)()}constructor(C,v,o){super(),this.j=v,this.m=o,this.g=new Map,this.h=new Map,this.f=C.getProxy(k.$ZJ.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(C=>C.dispose()),this.g.clear()}createWebviewPanel(C,v,o,s,n={}){const h=typeof s=="object"?s.viewColumn:s,$={viewColumn:R.ViewColumn.from(h),preserveFocus:typeof s=="object"&&!!s.preserveFocus},d=(0,m.$5bc)(C),t=I.c();this.f.$createWebviewPanel((0,m.$7bc)(C),t,v,{title:o,panelOptions:p(n),webviewOptions:(0,m.$8bc)(C,this.m,n),serializeBuffersForPostMessage:d},$);const r=this.j.createNewWebview(t,n,C);return this.createNewWebviewPanel(t,v,o,h,n,r,!0)}$onDidChangeWebviewPanelViewStates(C){const v=Object.keys(C);v.sort((o,s)=>{const n=C[o],h=C[s];return n.active?1:h.active?-1:+n.visible-+h.visible});for(const o of v){const s=this.getWebviewPanel(o);if(!s)continue;const n=C[o];s._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(C){this.getWebviewPanel(C)?.dispose(),this.g.delete(C),this.j.deleteWebview(C)}registerWebviewPanelSerializer(C,v,o){if(this.h.has(v))throw new Error(`Serializer for '${v}' already registered`);return this.h.set(v,{serializer:o,extension:C}),this.f.$registerSerializer(v,{serializeBuffersForPostMessage:(0,m.$5bc)(C)}),new b.$2J(()=>{this.h.delete(v),this.f.$unregisterSerializer(v)})}async $deserializeWebviewPanel(C,v,o,s){const n=this.h.get(v);if(!n)throw new Error(`No serializer found for '${v}'`);const{serializer:h,extension:$}=n,d=this.j.createNewWebview(C,o.webviewOptions,$),t=this.createNewWebviewPanel(C,v,o.title,s,o.panelOptions,d,o.active);await h.deserializeWebviewPanel(t,o.state)}createNewWebviewPanel(C,v,o,s,n,h,$){const d=new P(C,this.f,h,{viewType:v,title:o,viewColumn:s,panelOptions:n,active:$});return this.g.set(C,d),d}getWebviewPanel(C){return this.g.get(C)}}e.$Fcc=I;function p(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(Se[335],De([1,0,4,3,92,13,6,7]),function($e,e,D,M,g,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=void 0;class k extends M.$kc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(I,p,S,C,v,o){super(),this.#u=!1,this.#a=this.B(new D.$fd),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new D.$fd),this.onDidDispose=this.#c.event,this.#i=S,this.#s=C,this.#e=I,this.#t=p,this.#l=v,this.#n=o}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(I){this.a(),this.#s!==I&&(this.#s=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#r}set description(I){this.a(),this.#r!==I&&(this.#r=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(I){I===this.#n||this.#u||(this.#n=I,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(I){this.a(),!(I?.value===this.#o?.value&&I?.tooltip===this.#o?.tooltip)&&(this.#o=L.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#u)throw new Error("Webview is disposed")}}class b{constructor(I,p){this.d=p,this.b=new Map,this.c=new Map,this.a=I.getProxy(R.$ZJ.MainThreadWebviewViews)}registerWebviewViewProvider(I,p,S,C){if(this.b.has(p))throw new Error(`View provider for '${p}' already registered`);return this.b.set(p,{provider:S,extension:I}),this.a.$registerWebviewViewProvider((0,g.$7bc)(I),p,{retainContextWhenHidden:C?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,g.$5bc)(I)}),new m.$2J(()=>{this.b.delete(p),this.a.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(I,p,S,C,v){const o=this.b.get(p);if(!o)throw new Error(`No view provider found for '${p}'`);const{provider:s,extension:n}=o,h=this.d.createNewWebview(I,{},n),$=new k(I,this.a,p,S,h,!0);this.c.set(I,$),await s.resolveWebviewView($,{state:C},v)}async $onDidChangeWebviewViewVisibility(I,p){this.e(I)._setVisible(p)}async $disposeWebviewView(I){const p=this.e(I);this.c.delete(I),p.dispose(),this.d.deleteWebview(I)}e(I){const p=this.c.get(I);if(!p)throw new Error("No webview found");return p}}e.$Ecc=b}),define(Se[151],De([1,0,4,6,2,17,15,5,20,27]),function($e,e,D,M,g,L,R,m,k,b){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=e.$9bc=void 0;let I=class{static{P=this}static{this.a={focused:!0,active:!0}}getState(S){const C=this.d;return{get focused(){return C.focused},get active(){return(0,b.$QF)(S,"windowActivity"),C.active}}}constructor(S){this.c=new D.$fd,this.onDidChangeWindowState=this.c.event,this.d=P.a,this.b=S.getProxy(M.$ZJ.MainThreadWindow),this.b.$getInitialState().then(({isFocused:C,isActive:v})=>{this.onDidChangeWindowProperty("focused",C),this.onDidChangeWindowProperty("active",v)})}$onDidChangeWindowFocus(S){this.onDidChangeWindowProperty("focused",S)}$onDidChangeWindowActive(S){this.onDidChangeWindowProperty("active",S)}onDidChangeWindowProperty(S,C){C!==this.d[S]&&(this.d={...this.d,[S]:C},this.c.fire(this.d))}openUri(S,C){let v;if(typeof S=="string"){v=S;try{S=g.URI.parse(S)}catch{return Promise.reject(`Invalid uri - '${S}'`)}}return(0,R.$me)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this.b.$openUri(S,v,C)}async asExternalUri(S,C){if((0,R.$me)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const v=await this.b.$asExternalUri(S,C);return g.URI.from(v)}};e.$9bc=I,e.$9bc=I=P=Ke([Be(0,k.$2L)],I),e.$0bc=(0,m.$Bh)("IExtHostWindow")}),define(Se[336],De([1,0,304,26,20]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;const L=1024*1024;let R=class extends D.$9cc{constructor(k,b){super(k,b),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(k,b,P){const I=k==="error"||k==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),b.apply(console,P),I.write(`
END_NATIVE_LOG
`),this.g=!1}j(k,b){const P=process[k],I=P.write;let p="";Object.defineProperty(P,"write",{set:()=>{},get:()=>(S,C,v)=>{if(!this.g){p+=S.toString(C);const o=p.length>L?p.length:p.lastIndexOf(`
`);o!==-1&&(console[b](p.slice(0,o)),p=p.slice(o+1))}I.call(P,S,C,v)}})}};e.$Hdc=R,e.$Hdc=R=Ke([Be(0,g.$2L),Be(1,M.$fM)],R)}),define(Se[337],De([1,0,73,17,14,240,30,12]),function($e,e,D,M,g,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;let k=class{constructor(I,p){I.addFileSystemProvider(M.Schemas.file,new b(p),{isCaseSensitive:m.$k})}};e.$Idc=k,e.$Idc=k=Ke([Be(0,D.$vbc),Be(1,g.$5i)],k);class b{constructor(I){this.b=I,this.a=new L.$3p(this.b)}async stat(I){const p=await this.a.stat(I);return{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,p,S){return this.a.writeFile(I,p,{...S,unlock:!1,atomic:!1})}delete(I,p){return this.a.delete(I,{...p,useTrash:!1,atomic:!1})}rename(I,p,S){return this.a.rename(I,p,S)}copy(I,p,S){return this.a.copy(I,p,S)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,p){throw new Error("Method not implemented.")}}}),define(Se[338],De([1,0,16,64,31,33,3,6,2,20]),function($e,e,D,M,g,L,R,m,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=void 0;let P=class extends R.$kc{constructor(p,S){super();const C=p.getProxy(m.$ZJ.MainThreadDownloadService);S.registerCommand(!1,"_workbench.downloadResource",async v=>{const o=k.URI.file((0,D.$9d)((0,M.tmpdir)(),(0,g.$4f)()));return await C.$download(v,o),o})}};e.$Gdc=P,e.$Gdc=P=Ke([Be(0,b.$2L),Be(1,L.$lM)],P)}),define(Se[339],De([1,0,150,17,242,31]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;class R extends D.$8cc{s(k,b,P){return k.scheme===M.Schemas.file?new g.$bN(P?.name||(0,L.$4f)(),k.fsPath,!P?.donotRotate,!!P?.donotUseFormatters,b):super.s(k,b,P)}registerLogger(k){super.registerLogger(k),this.r.$registerLogger(k)}deregisterLogger(k){super.deregisterLogger(k),this.r.$deregisterLogger(k)}}e.$Tdc=R}),define(Se[340],De([1,0,52,16,2,91,3,17,9,29]),function($e,e,D,M,g,L,R,m,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;class P extends L.$xbc{constructor(){super(...arguments),this.i=null}async g(t){const r=await super.g(t);if(r.scheme!==m.Schemas.file)return r;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${r.fsPath}.`),r;const a=r.fsPath;let i=0;do{let c;i===0?c=a:c=/[/\\]$/.test(a)?`${a.substr(0,a.length-1)}-${i}`:`${a}-${i}`,await I(c);const f=M.$9d(c,"vscode.lock"),y=await v(this.d,f,!1);if(y)return this.i=y,process.on("exit",()=>{y.dispose()}),g.URI.file(c);i++}while(i<10);return r}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Sdc=P;async function I(d){try{await b.Promises.stat(d);return}catch{}try{await b.Promises.mkdir(d,{recursive:!0})}catch{}}const p=1e3,S=10*60*1e3;class C extends R.$kc{constructor(t,r){super(),this.b=t,this.c=r,this.a=this.B(new k.$Rg),this.a.cancelAndSet(async()=>{const a=await o(t,r);(!a||a.pid!==process.pid)&&(t.info(`Lock '${r}': The lock was lost unexpectedly.`),this.a.cancel());try{await b.Promises.utimes(r,new Date,new Date)}catch(i){t.error(i),t.info(`Lock '${r}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{D.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const r={pid:process.pid,willReleaseAt:Date.now()+t};await b.Promises.writeFile(this.c,JSON.stringify(r),{flag:"w"})}catch(r){this.b.error(r)}}}async function v(d,t,r){try{const i={pid:process.pid,willReleaseAt:0};await b.Promises.writeFile(t,JSON.stringify(i),{flag:"wx"})}catch(i){d.error(i)}const a=await o(d,t);return!a||a.pid!==process.pid?r?(d.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(d.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),h(d,t)):(d.info(`Lock '${t}': Lock acquired.`),new C(d,t))}async function o(d,t){let r;try{r=await b.Promises.readFile(t)}catch(a){return d.error(a),null}try{return JSON.parse(String(r))}catch(a){return d.error(a),null}}async function s(d,t){let r;try{r=await b.Promises.stat(t)}catch(a){return d.error(a),0}return r.mtime.getTime()}function n(d){try{return process.kill(d,0),!0}catch{return!1}}async function h(d,t){const r=await o(d,t);if(!r)return d.info(`Lock '${t}': Could not read pid of lock holder.`),$(d,t);if(r.willReleaseAt){let y=r.willReleaseAt-Date.now();if(y<5e3){for(y>0?d.info(`Lock '${t}': The lockfile is scheduled to be released in ${y} ms.`):d.info(`Lock '${t}': The lockfile is scheduled to have been released.`);y>0;){if(await(0,k.$Hg)(Math.min(100,y)),await s(d,t)===0)return $(d,t);y=r.willReleaseAt-Date.now()}return $(d,t)}}if(!n(r.pid))return d.info(`Lock '${t}': The pid ${r.pid} appears to be gone.`),$(d,t);const a=await s(d,t),i=Date.now()-a;if(i<=S)return d.info(`Lock '${t}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;d.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,k.$Hg)(2e3);const c=await s(d,t),f=Date.now()-c;return f<=S?(d.info(`Lock '${t}': The lock does not look stale, elapsed: ${f} ms, giving up.`),null):(d.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),$(d,t))}async function $(d,t){d.info(`Lock '${t}': Deleting a stale lock.`);try{await b.Promises.unlink(t)}catch{}return v(d,t,!0)}}),define(Se[341],De([1,0,31,20,44,33]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=void 0;let R=class extends g.$Abc{constructor(k,b){super(!0,k,b)}createTerminal(k,b,P){return this.createTerminalFromOptions({name:k,shellPath:b,shellArgs:P})}createTerminalFromOptions(k,b){const P=new g.$zbc(this.a,(0,D.$4f)(),k,k.name);return this.f.push(P),P.create(k,this.R(k,b)),P.value}};e.$bdc=R,e.$bdc=R=Ke([Be(0,L.$lM),Be(1,M.$2L)],R)}),define(Se[342],De([1,0,9,22,21,8,4,3,128,292,70]),function($e,e,D,M,g,L,R,m,k,b,P){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$C3b=e.ResponsiveState=e.RequestInitiator=e.$B3b=e.$A3b=void 0;function p(w,A){try{return JSON.stringify(w,A)}catch{return"null"}}const S="$$ref$$",C={[S]:-1};class v{constructor(A,N){this.jsonString=A,this.referencedBuffers=N}}function o(w,A=null,N=!1){const O=[];return{jsonString:(N?p:JSON.stringify)(w,(j,z)=>{if(typeof z>"u")return C;if(typeof z=="object"){if(z instanceof M.$Fd){const T=O.push(z)-1;return{[S]:T}}if(A)return A(j,z)}return z}),referencedBuffers:O}}e.$A3b=o;function s(w,A,N){return JSON.parse(w,(O,F)=>{if(F){const j=F[S];if(typeof j=="number")return A[j];if(N&&F.$mid===1)return N.transformIncoming(F)}return F})}e.$B3b=s;function n(w,A){return JSON.stringify(w,A)}function h(w){return w?(A,N)=>N&&N.$mid===1?w.transformOutgoing(N):N:null}var $;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})($||(e.RequestInitiator=$={}));var d;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(d||(e.ResponsiveState=d={}));const t=()=>{},r=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class i extends m.$kc{static{I=r}static{this.a=3*1e3}constructor(A,N=null,O=null){super(),this[I]=!0,this.b=this.B(new R.$fd),this.onDidChangeResponsiveState=this.b.event,this.c=A,this.f=N,this.g=O,this.h=h(this.g),this.j=!1,this.m=[],this.s=[];for(let F=0,j=P.$aA.count;F<j;F++)this.m[F]=null,this.s[F]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new D.$Sg(()=>this.H(),1e3)),this.c.onMessage(F=>this.L(F))}dispose(){this.j=!0,Object.keys(this.w).forEach(A=>{const N=this.w[A];delete this.w[A],N.resolveErr(L.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(A){this.z===0&&(this.C=Date.now()+i.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(A){this.C=Date.now()+i.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(A){this.y!==A&&(this.y=A,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(A){return this.g?(0,k.$Em)(A,this.g):A}getProxy(A){const{nid:N,sid:O}=A;return this.s[N]||(this.s[N]=this.J(N,O)),this.s[N]}J(A,N){const O={get:(F,j)=>(typeof j=="string"&&!F[j]&&j.charCodeAt(0)===36&&(F[j]=(...z)=>this.U(A,j,z)),j===a?N:F[j])};return new Proxy(Object.create(null),O)}set(A,N){return this.m[A.nid]=N,N}assertRegistered(A){for(let N=0,O=A.length;N<O;N++){const F=A[N];if(!this.m[F.nid])throw new Error(`Missing proxy instance ${F.sid}`)}}L(A){if(this.j)return;const N=A.byteLength,O=f.read(A,0),F=O.readUInt8(),j=O.readUInt32();switch(F){case 1:case 2:{let{rpcId:z,method:T,args:H}=E.deserializeRequestJSONArgs(O);this.g&&(H=(0,k.$Em)(H,this.g)),this.M(N,j,z,T,H,F===2);break}case 3:case 4:{let{rpcId:z,method:T,args:H}=E.deserializeRequestMixedArgs(O);this.g&&(H=(0,k.$Em)(H,this.g)),this.M(N,j,z,T,H,F===4);break}case 5:{this.f?.logIncoming(N,j,0,"ack"),this.G(j);break}case 6:{this.N(N,j);break}case 7:{this.O(N,j,void 0);break}case 9:{let z=E.deserializeReplyOKJSON(O);this.g&&(z=(0,k.$Em)(z,this.g)),this.O(N,j,z);break}case 10:{const z=E.deserializeReplyOKJSONWithBuffers(O,this.g);this.O(N,j,z);break}case 8:{const z=E.deserializeReplyOKVSBuffer(O);this.O(N,j,z);break}case 11:{let z=E.deserializeReplyErrError(O);this.g&&(z=(0,k.$Em)(z,this.g)),this.P(N,j,z);break}case 12:{this.P(N,j,void 0);break}default:console.error("received unexpected message"),console.error(A)}}M(A,N,O,F,j,z){this.f?.logIncoming(A,N,1,`receiveRequest ${(0,P.$cA)(O)}.${F}(`,j);const T=String(N);let H,q;if(z){const X=new g.$pd;j.push(X.token),H=this.Q(O,F,j),q=()=>X.cancel()}else H=this.Q(O,F,j),q=t;this.u[T]=q;const me=E.serializeAcknowledged(N);this.f?.logOutgoing(me.byteLength,N,1,"ack"),this.c.send(me),H.then(X=>{delete this.u[T];const Z=E.serializeReplyOK(N,X,this.h);this.f?.logOutgoing(Z.byteLength,N,1,"reply:",X),this.c.send(Z)},X=>{delete this.u[T];const Z=E.serializeReplyErr(N,X);this.f?.logOutgoing(Z.byteLength,N,1,"replyErr:",X),this.c.send(Z)})}N(A,N){this.f?.logIncoming(A,N,1,"receiveCancel");const O=String(N);this.u[O]?.()}O(A,N,O){this.f?.logIncoming(A,N,0,"receiveReply:",O);const F=String(N);if(!this.w.hasOwnProperty(F))return;const j=this.w[F];delete this.w[F],j.resolveOk(O)}P(A,N,O){this.f?.logIncoming(A,N,0,"receiveReplyErr:",O);const F=String(N);if(!this.w.hasOwnProperty(F))return;const j=this.w[F];delete this.w[F];let z;O&&(O.$isError?(z=new Error,z.name=O.name,z.message=O.message,z.stack=O.stack):z=O),j.resolveErr(z)}Q(A,N,O){try{return Promise.resolve(this.S(A,N,O))}catch(F){return Promise.reject(F)}}S(A,N,O){const F=this.m[A];if(!F)throw new Error("Unknown actor "+(0,P.$cA)(A));const j=F[N];if(typeof j!="function")throw new Error("Unknown method "+N+" on actor "+(0,P.$cA)(A));return j.apply(F,O)}U(A,N,O){if(this.j)return new b.$z3b;let F=null;if(O.length>0&&g.CancellationToken.isCancellationToken(O[O.length-1])&&(F=O.pop()),F&&F.isCancellationRequested)return Promise.reject(L.$4());const j=E.serializeRequestArguments(O,this.h),z=++this.t,T=String(z),H=new b.$y3b,q=new m.$jc;F&&q.add(F.onCancellationRequested(()=>{const X=E.serializeCancel(z);this.f?.logOutgoing(X.byteLength,z,0,"cancel"),this.c.send(E.serializeCancel(z))})),this.w[T]=new c(H,q),this.F(z);const me=E.serializeRequest(z,A,N,j,!!F);return this.f?.logOutgoing(me.byteLength,z,0,`request: ${(0,P.$cA)(A)}.${N}(`,O),this.c.send(me),H}}e.$C3b=i;class c{constructor(A,N){this.a=A,this.b=N}resolveOk(A){this.a.resolveOk(A),this.b.dispose()}resolveErr(A){this.a.resolveErr(A),this.b.dispose()}}class f{static alloc(A,N,O){const F=new f(M.$Fd.alloc(O+1+4),0);return F.writeUInt8(A),F.writeUInt32(N),F}static read(A,N){return new f(A,N)}get buffer(){return this.a}constructor(A,N){this.a=A,this.b=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(A){this.a.writeUInt8(A,this.b),this.b+=1}readUInt8(){const A=this.a.readUInt8(this.b);return this.b+=1,A}writeUInt32(A){this.a.writeUInt32BE(A,this.b),this.b+=4}readUInt32(){const A=this.a.readUInt32BE(this.b);return this.b+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this.a.writeUInt8(A.byteLength,this.b),this.b+=1,this.a.set(A,this.b),this.b+=A.byteLength}readShortString(){const A=this.a.readUInt8(this.b);this.b+=1;const O=this.a.slice(this.b,this.b+A).toString();return this.b+=A,O}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readLongString(){const A=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+A).toString();return this.b+=A,O}writeBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readVSBuffer(){const A=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+A);return this.b+=A,N}static sizeMixedArray(A){let N=0;N+=1;for(let O=0,F=A.length;O<F;O++){const j=A[O];switch(N+=1,j.type){case 1:N+=this.sizeLongString(j.value);break;case 2:N+=this.sizeVSBuffer(j.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(j.value);for(let z=0;z<j.buffers.length;++z)N+=this.sizeVSBuffer(j.buffers[z]);break;case 4:break}}return N}writeMixedArray(A){this.a.writeUInt8(A.length,this.b),this.b+=1;for(let N=0,O=A.length;N<O;N++){const F=A[N];switch(F.type){case 1:this.writeUInt8(1),this.writeLongString(F.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(F.value);break;case 3:this.writeUInt8(3),this.writeUInt32(F.buffers.length),this.writeLongString(F.value);for(let j=0;j<F.buffers.length;++j)this.writeBuffer(F.buffers[j]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this.a.readUInt8(this.b);this.b+=1;const N=new Array(A);for(let O=0;O<A;O++)switch(this.readUInt8()){case 1:N[O]=this.readLongString();break;case 2:N[O]=this.readVSBuffer();break;case 3:{const j=this.readUInt32(),z=this.readLongString(),T=[];for(let H=0;H<j;++H)T.push(this.readVSBuffer());N[O]=new P.$dA(s(z,T,null));break}case 4:N[O]=void 0;break}return N}}var y;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(y||(y={}));class E{static a(A){for(let N=0,O=A.length;N<O;N++)if(A[N]instanceof M.$Fd||A[N]instanceof P.$dA||typeof A[N]>"u")return!0;return!1}static serializeRequestArguments(A,N){if(this.a(A)){const O=[];for(let F=0,j=A.length;F<j;F++){const z=A[F];if(z instanceof M.$Fd)O[F]={type:2,value:z};else if(typeof z>"u")O[F]={type:4};else if(z instanceof P.$dA){const{jsonString:T,referencedBuffers:H}=o(z.value,N);O[F]={type:3,value:M.$Fd.fromString(T),buffers:H}}else O[F]={type:1,value:M.$Fd.fromString(n(z,N))}}return{type:1,args:O}}return{type:0,args:n(A,N)}}static serializeRequest(A,N,O,F,j){switch(F.type){case 0:return this.b(A,N,O,F.args,j);case 1:return this.c(A,N,O,F.args,j)}}static b(A,N,O,F,j){const z=M.$Fd.fromString(O),T=M.$Fd.fromString(F);let H=0;H+=f.sizeUInt8(),H+=f.sizeShortString(z),H+=f.sizeLongString(T);const q=f.alloc(j?2:1,A,H);return q.writeUInt8(N),q.writeShortString(z),q.writeLongString(T),q.buffer}static deserializeRequestJSONArgs(A){const N=A.readUInt8(),O=A.readShortString(),F=A.readLongString();return{rpcId:N,method:O,args:JSON.parse(F)}}static c(A,N,O,F,j){const z=M.$Fd.fromString(O);let T=0;T+=f.sizeUInt8(),T+=f.sizeShortString(z),T+=f.sizeMixedArray(F);const H=f.alloc(j?4:3,A,T);return H.writeUInt8(N),H.writeShortString(z),H.writeMixedArray(F),H.buffer}static deserializeRequestMixedArgs(A){const N=A.readUInt8(),O=A.readShortString(),F=A.readMixedArray(),j=new Array(F.length);for(let z=0,T=F.length;z<T;z++){const H=F[z];typeof H=="string"?j[z]=JSON.parse(H):j[z]=H}return{rpcId:N,method:O,args:j}}static serializeAcknowledged(A){return f.alloc(5,A,0).buffer}static serializeCancel(A){return f.alloc(6,A,0).buffer}static serializeReplyOK(A,N,O){if(typeof N>"u")return this.d(A);if(N instanceof M.$Fd)return this.e(A,N);if(N instanceof P.$dA){const{jsonString:F,referencedBuffers:j}=o(N.value,O,!0);return this.g(A,F,j)}else return this.f(A,p(N,O))}static d(A){return f.alloc(7,A,0).buffer}static e(A,N){let O=0;O+=f.sizeVSBuffer(N);const F=f.alloc(8,A,O);return F.writeVSBuffer(N),F.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static f(A,N){const O=M.$Fd.fromString(N);let F=0;F+=f.sizeLongString(O);const j=f.alloc(9,A,F);return j.writeLongString(O),j.buffer}static g(A,N,O){const F=M.$Fd.fromString(N);let j=0;j+=f.sizeUInt32,j+=f.sizeLongString(F);for(const T of O)j+=f.sizeVSBuffer(T);const z=f.alloc(10,A,j);z.writeUInt32(O.length),z.writeLongString(F);for(const T of O)z.writeBuffer(T);return z.buffer}static deserializeReplyOKJSON(A){const N=A.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(A,N){const O=A.readUInt32(),F=A.readLongString(),j=[];for(let z=0;z<O;++z)j.push(A.readVSBuffer());return new P.$dA(s(F,j,N))}static serializeReplyErr(A,N){const O=N?p(L.$1(N),null):void 0;if(typeof O!="string")return this.h(A);const F=M.$Fd.fromString(O);let j=0;j+=f.sizeLongString(F);const z=f.alloc(11,A,j);return z.writeLongString(F),z.buffer}static deserializeReplyErrError(A){const N=A.readLongString();return JSON.parse(N)}static h(A){return f.alloc(12,A,0).buffer}}var u;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var l;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(l||(l={}))}),define(Se[343],De([1,0,4,42,41,5]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fJ=e.$eJ=e.OutputChannelUpdateMode=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=void 0,e.$6I="text/x-code-output",e.$7I="output",e.$8I="Log",e.$9I="text/x-code-log-output",e.$0I="log",e.$$I="log",e.$_I="workbench.panel.output",e.$aJ=new g.$2i("inOutput",!1),e.$bJ=new g.$2i("activeLogOutput",!1),e.$cJ=new g.$2i("outputView.scrollLock",!1),e.$dJ=(0,L.$Bh)("outputService");var R;(function(k){k[k.Append=1]="Append",k[k.Replace=2]="Replace",k[k.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$eJ={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new D.$fd,this.onDidRegisterChannel=this.b.event,this.c=new D.$fd,this.onDidRemoveChannel=this.c.event}registerChannel(b){this.a.has(b.id)||(this.a.set(b.id,b),this.b.fire(b.id))}getChannels(){const b=[];return this.a.forEach(P=>b.push(P)),b}getChannel(b){return this.a.get(b)}removeChannel(b){this.a.delete(b),this.c.fire(b)}}M.$8m.add(e.$eJ.OutputChannels,new m),e.$fJ=new g.$2i("activeOutputChannel","")}),define(Se[152],De([1,0,6,5,20,25,14,343,73,26,54,178,22,18,30,4,3]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=e.$Sbc=void 0;class s extends R.$$i{get disposed(){return this.n}constructor(d,t,r,a,i){super(),this.id=d,this.name=t,this.r=r,this.s=a,this.extension=i,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(d){this.append(d+`
`)}append(d){this.info(d)}clear(){const d=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,d)}replace(d){const t=this.m;this.info(d),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(d,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof d=="boolean"?d:t))}hide(){this.s.$close(this.id)}g(d,t){this.m+=p.$Fd.fromString(t).byteLength,(0,R.log)(this.r,d,t),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends s{appendLine(d){this.append(d)}}let h=class{constructor(d,t,r,a,i,c){this.i=t,this.j=r,this.k=a,this.l=i,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=d.getProxy(D.$ZJ.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$7l)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(d){this.h=d;for(const[t,r]of this.g)r.visible=t===this.h}createOutputChannel(d,t,r){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");const a=typeof t=="object"&&t.log,i=(0,S.$jf)(t)?t:void 0;if((0,S.$jf)(i)&&!i.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const f=this.i.environment.extensionLogLevel?.find(([E])=>L.$Vl.equals(r.identifier,E))?.[1];f&&(c=(0,R.$ij)(f));const y=a?this.o(d,c,r):this.n(d,i,r);return y.then(E=>{this.g.set(E.id,E),E.visible=E.id===this.h}),a?this.r(d,c??this.m.getLevel(),y):this.q(d,y)}async n(d,t,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,i=this.k.extUri.joinPath(a,`${this.f++}-${d.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(i,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),f=await this.a.$register(d,i,t,r.identifier.value);return new s(f,d,c,this.a,r)}async o(d,t,r){const a=await this.p(r),i=d.replace(/[\\/:\*\?"<>\|]/g,""),c=this.k.extUri.joinPath(a,`${i}.log`),f=`${r.identifier.value}.${i}`,y=this.l.createLogger(c,{id:f,name:d,logLevel:t,extensionId:r.identifier.value});return new n(f,d,y,this.a,r)}p(d){let t=this.d.get(d.identifier.value);if(!t){const r=this.k.extUri.joinPath(this.i.logsLocation,d.identifier.value);this.d.set(d.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(r)}catch(a){if((0,C.$ik)(a)!==C.FileSystemProviderErrorCode.FileExists)throw a}return r})())}return t}q(d,t){let r=!1;const a=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return d},append(i){a(),t.then(c=>c.append(i))},appendLine(i){a(),t.then(c=>c.appendLine(i))},clear(){a(),t.then(i=>i.clear())},replace(i){a(),t.then(c=>c.replace(i))},show(i,c){a(),t.then(f=>f.show(i,c))},hide(){a(),t.then(i=>i.hide())},dispose(){r=!0,t.then(i=>i.dispose())}}}r(d,t,r){const a=new o.$jc,i=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},c=a.add(new v.$fd);function f(y){t=y,c.fire(y)}return r.then(y=>{a.add(y),y.logLevel!==t&&f(y.logLevel),a.add(y.onDidChangeLogLevel(E=>f(E)))}),{...this.q(d,r),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(y,...E){i(),r.then(u=>u.trace(y,...E))},debug(y,...E){i(),r.then(u=>u.debug(y,...E))},info(y,...E){i(),r.then(u=>u.info(y,...E))},warn(y,...E){i(),r.then(u=>u.warn(y,...E))},error(y,...E){i(),r.then(u=>u.error(y,...E))},dispose(){a.dispose()}}}};e.$Sbc=h,e.$Sbc=h=Ke([Be(0,g.$2L),Be(1,b.$fM),Be(2,k.$vbc),Be(3,P.$3ac),Be(4,R.$6i),Be(5,R.$5i)],h),e.$Tbc=(0,M.$Bh)("IExtHostOutputService")}),define(Se[344],De([1,0,5,9]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=void 0,e.$jm=(0,D.$Bh)("remoteAgentService"),e.$km=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(g){let L=1/0;for(let m=0;m<this.maxSampleCount;m++){const k=await g.getRoundTripTime();if(k===void 0)return;L=Math.min(L,k/2),await(0,M.$Hg)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(L):R=this.initial.reduce((m,k)=>m+k,0)/this.initial.length,this.lastMeasurement={initial:R,current:L,average:this.average.reduce((m,k)=>m+k,0)/this.average.length,high:(()=>typeof R>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Se[345],De([1,0,32,17,16,12,24,2,5,258,43,147,344]),function($e,e,D,M,g,L,R,m,k,b,P,I,p){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$yJ=e.$xJ=void 0,e.$xJ=(0,k.$Bh)("pathService");let C=S=class{constructor(o,s,n,h){this.d=o,this.e=s,this.f=n,this.g=h,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const $=await this.e.getEnvironment();return this.c=$?.userHome??o})()}hasValidBasename(o,s,n){return typeof s=="string"||typeof s>"u"?this.a.then(h=>this.h(o,h,s)):this.h(o,s,n)}h(o,s,n){return o.scheme===M.Schemas.file||o.scheme===M.Schemas.vscodeRemote?(0,D.$Gf)(n??(0,R.$fg)(o),s===1):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,s){if(o.remoteAuthority)return M.Schemas.vscodeRemote;const n=(0,b.$uJ)(s.getWorkspace());if(n)return n;const h=s.getWorkspace().folders[0];if(h)return h.uri.scheme;const $=s.getWorkspace().configuration;return $?$.scheme:M.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?g.$5d:g.$6d)}async fileURI(o){let s="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const h=o.indexOf("/",2);h===-1?(s=o.substring(2),o="/"):(s=o.substring(2,h),o=o.substring(h)||"/")}return m.URI.from({scheme:M.Schemas.file,authority:s,path:o,query:"",fragment:""})}};e.$yJ=C,e.$yJ=C=S=Ke([Be(1,p.$jm),Be(2,I.$gJ),Be(3,P.$Kh)],C)}),define(Se[346],De([1,0,225,19,57,4,51,3,2,49,230,14,66,260,86,43,147,27,21,18,23,41]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o,s,n,h,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rJ=e.$qJ=e.$pJ=e.OnPortForward=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.TunnelSource=e.TunnelCloseReason=e.$jJ=e.$iJ=e.$hJ=void 0;const t=10*1e3,r="remote.tunnels.toRestore";e.$hJ="onTunnel",e.$iJ=new d.$2i("forwardedPortsViewEnabled",!1,D.localize(0,null));function a(N){const O=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(O)return{host:O[1]?.substring(0,O[1].length-1)||"localhost",port:Number(O[2])}}e.$jJ=a;var i;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(i||(e.TunnelCloseReason=i={}));var c;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(c||(e.TunnelSource=c={})),e.$kJ={source:c.User,description:D.localize(1,null)},e.$lJ={source:c.Auto,description:D.localize(2,null)};function f(N,O,F){const j=N.get(E(O,F));if(j)return j;if((0,C.$2z)(O))for(const z of C.$1z){const T=E(z,F);if(N.has(T))return N.get(T)}else if((0,C.$4z)(O))for(const z of C.$3z){const T=E(z,F);if(N.has(T))return N.get(T)}}e.$mJ=f;function y(N,O,F){const j=f(N,O,F);if(j)return j;const z=(0,C.$4z)(O)?"localhost":(0,C.$2z)(O)?"0.0.0.0":void 0;if(z)return f(N,z,F)}e.$nJ=y;function E(N,O){return N+":"+O}e.$oJ=E;var u;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})(u||(e.OnPortForward=u={}));function l(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}e.$pJ=l;class w extends m.$kc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(O){super(),this.r=O,this.j=[],this.n=new L.$fd,this.onDidChangeAttributes=this.n.event,this.B(O.onDidChangeConfiguration(F=>{(F.affectsConfiguration(w.c)||F.affectsConfiguration(w.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(O,F,j){let z=this.w(O,F,j,this.j,0);const T={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;z>=0;){const H=this.j[z];H.key===O?(T.onAutoForward=H.onAutoForward??T.onAutoForward,T.elevateIfNeeded=H.elevateIfNeeded!==void 0?H.elevateIfNeeded:T.elevateIfNeeded,T.label=H.label??T.label,T.requireLocalPort=H.requireLocalPort,T.protocol=H.protocol):(T.onAutoForward=T.onAutoForward??H.onAutoForward,T.elevateIfNeeded=T.elevateIfNeeded!==void 0?T.elevateIfNeeded:H.elevateIfNeeded,T.label=T.label??H.label,T.requireLocalPort=T.requireLocalPort!==void 0?T.requireLocalPort:void 0,T.protocol=T.protocol??H.protocol),z=this.w(O,F,j,this.j,z+1)}return T.onAutoForward!==void 0||T.elevateIfNeeded!==void 0||T.label!==void 0||T.requireLocalPort!==void 0||T.protocol!==void 0?T:this.C()}t(O){return O.start!==void 0&&O.end!==void 0}u(O){return O.host!==void 0&&O.port!==void 0&&(0,h.$jf)(O.host)&&(0,h.$nf)(O.port)}w(O,F,j,z,T){if(T>=z.length)return-1;const H=!(0,C.$2z)(F)&&!(0,C.$4z)(F),me=z.slice(T).findIndex(X=>(0,h.$nf)(X.key)?H?!1:X.key===O:this.t(X.key)?H?!1:O>=X.key.start&&O<=X.key.end:this.u(X.key)?O===X.key.port&&F===X.key.host:j?X.key.test(j):!1);return me>=0?me+T:-1}y(){const O=this.r.getValue(w.c);if(!O||!(0,h.$lf)(O))return[];const F=[];for(const z in O){if(z===void 0)continue;const T=O[z];let H;if(Number(z))H=Number(z);else if((0,h.$jf)(z))if(w.g.test(z)){const q=z.match(w.g);H={start:Number(q[1]),end:Number(q[2])}}else if(w.h.test(z)){const q=z.match(w.h);H={host:q[1],port:Number(q[2])}}else{let q;try{q=RegExp(z)}catch{}q&&(H=q)}H&&F.push({key:H,elevateIfNeeded:T.elevateIfNeeded,onAutoForward:T.onAutoForward,label:T.label,requireLocalPort:T.requireLocalPort,protocol:T.protocol})}const j=this.r.getValue(w.f);return j&&(this.m={elevateIfNeeded:j.elevateIfNeeded,label:j.label,onAutoForward:j.onAutoForward,requireLocalPort:j.requireLocalPort,protocol:j.protocol}),this.z(F)}z(O){function F(j,z){return(0,h.$nf)(j.key)?j.key:z.t(j.key)?j.key.start:z.u(j.key)?j.key.port:Number.MAX_VALUE}return O.sort((j,z)=>F(j,this)-F(z,this))}C(){return this.m}static providedActionToAction(O){switch(O){case C.ProvidedOnAutoForward.Notify:return u.Notify;case C.ProvidedOnAutoForward.OpenBrowser:return u.OpenBrowser;case C.ProvidedOnAutoForward.OpenBrowserOnce:return u.OpenBrowserOnce;case C.ProvidedOnAutoForward.OpenPreview:return u.OpenPreview;case C.ProvidedOnAutoForward.Silent:return u.Silent;case C.ProvidedOnAutoForward.Ignore:return u.Ignore;default:return}}async addAttributes(O,F,j){const T=this.r.inspect(w.c).userRemoteValue;let H;!T||!(0,h.$lf)(T)?H={}:H=(0,$.$Vm)(T),H[`${O}`]||(H[`${O}`]={});for(const q in F)H[`${O}`][q]=F[q];return this.r.updateValue(w.c,H,j)}}e.$qJ=w;let A=class extends m.$kc{constructor(O,F,j,z,T,H,q,me,X,Z){super(),this.H=O,this.I=F,this.J=j,this.L=z,this.M=T,this.N=H,this.O=q,this.P=me,this.Q=X,this.R=Z,this.c=new Map,this.g=new L.$fd,this.onForwardPort=this.g.event,this.h=new L.$fd,this.onClosePort=this.h.event,this.j=new L.$fd,this.onPortName=this.j.event,this.n=new L.$fd,this.onCandidatesChanged=this.n.event,this.t=new L.$fd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new L.$fd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new w(j),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async V=>{const x=await this.getAttributes(V.map(ge=>({port:ge.tunnelRemotePort,host:ge.tunnelRemoteHost})));for(const ge of V)if(ge.localAddress){const ue=E(ge.tunnelRemoteHost,ge.tunnelRemotePort),we=y(this.m??new Map,ge.tunnelRemoteHost,ge.tunnelRemotePort);this.forwarded.set(ue,{remotePort:ge.tunnelRemotePort,remoteHost:ge.tunnelRemoteHost,localAddress:ge.localAddress,protocol:x?.get(ge.tunnelRemotePort)?.protocol??C.TunnelProtocol.Http,localUri:await this.X(ge.localAddress,x?.get(ge.tunnelRemotePort)),localPort:ge.tunnelLocalPort,runningProcess:we?.detail,hasRunningProcess:!!we,pid:we?.pid,privacy:ge.privacy,source:e.$kJ}),this.f.set(ue,ge)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async V=>{const x=E(V.tunnelRemoteHost,V.tunnelRemotePort);if(!y(this.forwarded,V.tunnelRemoteHost,V.tunnelRemotePort)&&!y(this.detected,V.tunnelRemoteHost,V.tunnelRemotePort)&&!y(this.c,V.tunnelRemoteHost,V.tunnelRemotePort)&&V.localAddress){const ge=y(this.m??new Map,V.tunnelRemoteHost,V.tunnelRemotePort),ue=(await this.getAttributes([{port:V.tunnelRemotePort,host:V.tunnelRemoteHost}]))?.get(V.tunnelRemotePort);this.forwarded.set(x,{remoteHost:V.tunnelRemoteHost,remotePort:V.tunnelRemotePort,localAddress:V.localAddress,protocol:ue?.protocol??C.TunnelProtocol.Http,localUri:await this.X(V.localAddress,ue),localPort:V.tunnelLocalPort,closeable:!0,runningProcess:ge?.detail,hasRunningProcess:!!ge,pid:ge?.pid,privacy:V.privacy,source:e.$kJ})}await this.$(),this.f.set(x,V),this.g.fire(this.forwarded.get(x))})),this.B(this.H.onTunnelClosed(V=>this.W(V,i.Other))),this.U()}S(){return this.Q.extensions.find(O=>O.activationEvents?.includes(e.$hJ))?(this.R.createKey(e.$iJ.key,!0),!0):!1}U(){if(this.S())return;const O=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&O.dispose()}))}async W(O,F){const j=E(O.host,O.port);this.forwarded.has(j)&&(this.forwarded.delete(j),await this.$(),this.h.fire(O))}X(O,F){if(O.startsWith("http"))return k.URI.parse(O);const j=F?.protocol??"http";return k.URI.parse(`${j}://${O}`)}async Y(){const O=this.N.getWorkspace(),F=O.configuration?(0,R.$pi)(O.configuration.path):O.folders.length>0?(0,R.$pi)(O.folders[0].uri.path):void 0;if(F===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${r}.${this.L.remoteAuthority}.${F}`}async Z(){const O=this.I.get(r,1);if(O)return this.I.remove(r,1),await this.$(),O;const F=await this.Y();if(F)return this.I.get(F,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const O=await this.s;if(O&&O!==this.y){const F=JSON.parse(O)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${F.map(j=>j.remotePort).join(", ")}`);for(const j of F){const z=y(this.detected,j.remoteHost,j.remotePort);j.source.source!==c.Extension&&!z||j.source.source===c.Extension&&z?await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,privacy:j.privacy,elevateIfNeeded:!0,source:j.source}):j.source.source===c.Extension&&!z&&this.D.set(E(j.remoteHost,j.remotePort),j)}}}if(this.z=!0,this.C.fire(),!this.w){const O=await this.Y();this.w=this.B(new m.$jc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async F=>{F.key===O&&(this.s=Promise.resolve(this.I.get(O,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const O=JSON.stringify(Array.from(this.forwarded.values()));if(O!==this.y){this.y=O;const F=await this.Y();F&&this.I.store(F,this.y,0,0)}}}async bb(O,F,j){if(!O.tunnelLocalPort||!j?.requireLocalPort||O.tunnelLocalPort===F)return;const z=new Date;if(this.ab.getTime()+t>z.getTime())return;this.ab=z;const T=D.localize(3,null,F,O.tunnelRemotePort,O.tunnelLocalPort);return this.P.info(T)}async forward(O,F){return!this.z&&this.L.remoteAuthority&&await L.Event.toPromise(this.C.event),this.cb(O,F)}async cb(O,F){await this.Q.activateByEvent(e.$hJ);const j=y(this.forwarded,O.remote.host,O.remote.port);F=F??(F!==null?(await this.getAttributes([O.remote]))?.get(O.remote.port):void 0);const z=O.local!==void 0?O.local:O.remote.port;let T;if(j)return this.eb(j,O,F);{const H=this.L.remoteAuthority,q=H?{getAddress:async()=>(await this.M.resolveAuthority(H)).authority}:void 0,me=E(O.remote.host,O.remote.port);this.c.set(me,!0),O=this.db(me,O);const X=await this.H.openTunnel(q,O.remote.host,O.remote.port,void 0,z,O.elevateIfNeeded?O.elevateIfNeeded:F?.elevateIfNeeded,O.privacy,F?.protocol);if(typeof X=="string")T=X;else if(X&&X.localAddress){const Z=y(this.m??new Map,O.remote.host,O.remote.port),V=X.protocol?X.protocol===C.TunnelProtocol.Https?C.TunnelProtocol.Https:C.TunnelProtocol.Http:F?.protocol??C.TunnelProtocol.Http,x={remoteHost:X.tunnelRemoteHost,remotePort:X.tunnelRemotePort,localPort:X.tunnelLocalPort,name:F?.label??O.name,closeable:!0,localAddress:X.localAddress,protocol:V,localUri:await this.X(X.localAddress,F),runningProcess:Z?.detail,hasRunningProcess:!!Z,pid:Z?.pid,source:O.source??e.$kJ,privacy:X.privacy};return this.forwarded.set(me,x),this.f.set(me,X),this.c.delete(me),await this.$(),await this.bb(X,z,F),this.g.fire(x),X}this.c.delete(me)}return T}db(O,F){const j=this.D.has(O)?this.D:this.F.has(O)?this.F:void 0;if(j){const z=j.get(O);j.delete(O),z&&(F.name=z.name??F.name,F.local=("local"in z?z.local:"localPort"in z?z.localPort:void 0)??F.local,F.privacy=z.privacy??F.privacy)}return F}async eb(O,F,j){const z=j?.label??F.name;let T;(function(q){q[q.None=0]="None",q[q.Fire=1]="Fire",q[q.Reopen=2]="Reopen"})(T||(T={}));let H=T.None;switch(z!==O.name&&(O.name=z,H=T.Fire),(j?.protocol||O.protocol!==C.TunnelProtocol.Http)&&j?.protocol!==O.protocol&&(F.source=O.source,H=T.Reopen),F.privacy&&O.privacy!==F.privacy&&(H=T.Reopen),H){case T.Fire:{this.g.fire();break}case T.Reopen:await this.close(O.remoteHost,O.remotePort,i.User),await this.cb(F,j)}return y(this.f,F.remote.host,F.remote.port)}async name(O,F,j){const z=y(this.forwarded,O,F),T=E(O,F);if(z){z.name=j,await this.$(),this.j.fire({host:O,port:F});return}else this.detected.has(T)&&(this.detected.get(T).name=j,this.j.fire({host:O,port:F}))}async close(O,F,j){const z=E(O,F),T=this.forwarded.get(z);return j===i.AutoForwardEnd&&T&&T.source.source===c.Auto&&this.F.set(z,{local:T.localPort,name:T.name,privacy:T.privacy}),await this.H.closeTunnel(O,F),this.W({host:O,port:F},j)}address(O,F){const j=E(O,F);return(this.forwarded.get(j)||this.detected.get(j))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(O){if(O)for(const F of O){const j=y(this.m??new Map,F.remoteAddress.host,F.remoteAddress.port),z=typeof F.localAddress=="string"?F.localAddress:E(F.localAddress.host,F.localAddress.port);this.detected.set(E(F.remoteAddress.host,F.remoteAddress.port),{remoteHost:F.remoteAddress.host,remotePort:F.remoteAddress.port,localAddress:z,protocol:C.TunnelProtocol.Http,localUri:this.X(z),closeable:!1,runningProcess:j?.detail,hasRunningProcess:!!j,pid:j?.pid,privacy:C.TunnelPrivacyId.ConstantPrivate,source:{source:c.Extension,description:D.localize(4,null)}}),this.H.setEnvironmentTunnel(F.remoteAddress.host,F.remoteAddress.port,z,C.TunnelPrivacyId.ConstantPrivate,C.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(O){this.r=O}async setCandidates(O){let F=O;this.r&&(F=await this.r(O));const j=this.fb(F);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(j.values()).map(z=>z.port).join(", ")}`),this.n.fire(j)}fb(O){const F=this.m??new Map,j=new Map;return this.m=j,O.forEach(z=>{const T=E(z.host,z.port);j.set(T,{host:z.host,port:z.port,detail:z.detail,pid:z.pid}),F.has(T)&&F.delete(T);const H=y(this.forwarded,z.host,z.port);H&&(H.runningProcess=z.detail,H.hasRunningProcess=!0,H.pid=z.pid)}),F.forEach((z,T)=>{const H=a(T);if(!H)return;const q=y(this.forwarded,H.host,H.port);q&&(q.runningProcess=void 0,q.hasRunningProcess=!1,q.pid=void 0);const me=y(this.detected,H.host,H.port);me&&(me.runningProcess=void 0,me.hasRunningProcess=!1,me.pid=void 0)}),F}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const O=Array.from(this.forwarded.values()),F=await this.getAttributes(O.map(j=>({port:j.remotePort,host:j.remoteHost})),!1);if(F)for(const j of O){const z=F.get(j.remotePort);(z?.protocol||j.protocol!==C.TunnelProtocol.Http)&&z?.protocol!==j.protocol&&await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,source:j.source},z),z&&z.label&&z.label!==j.name&&await this.name(j.remoteHost,j.remotePort,z.label)}}async getAttributes(O,F=!0){const j=new Map,z=new Map;O.forEach(X=>{const Z=y(this.m??new Map,C.$1z[0],X.port)??X;if(Z){j.set(X.port,Z);const V=l(Z)?Z.pid:void 0;z.has(V)||z.set(V,[]),z.get(V)?.push(X.port)}});const T=new Map;if(O.forEach(X=>{const Z=this.configPortsAttributes.getAttributes(X.port,X.host,j.get(X.port)?.detail);Z&&T.set(X.port,Z)}),this.G.length===0||!F)return T.size>0?T:void 0;const H=await Promise.all((0,M.$Pb)(this.G.map(X=>Array.from(z.entries()).map(Z=>{const V=Z[1],x=j.get(V[0]);return X.providePortAttributes(V,x?.pid,x?.detail,new n.$pd().token)})))),q=new Map;if(H.forEach(X=>X.forEach(Z=>{Z&&q.set(Z.port,Z)})),!T&&!q)return;const me=new Map;return O.forEach(X=>{const Z=T.get(X.port),V=q.get(X.port);me.set(X.port,{elevateIfNeeded:Z?.elevateIfNeeded,label:Z?.label,onAutoForward:Z?.onAutoForward??w.providedActionToAction(V?.autoForwardAction),requireLocalPort:Z?.requireLocalPort,protocol:Z?.protocol})}),me}addAttributesProvider(O){this.G.push(O)}};e.$rJ=A,Ke([(0,g.$7g)(1e3)],A.prototype,"$",null),e.$rJ=A=Ke([Be(0,C.$Wz),Be(1,S.$Vo),Be(2,b.$8h),Be(3,o.$gJ),Be(4,p.$Jk),Be(5,v.$Kh),Be(6,I.$5i),Be(7,P.$oA),Be(8,s.$MF),Be(9,d.$3i)],A)}),define(Se[93],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$hI=e.$gI=void 0;class D{constructor(R,m){this.line=R,this.character=m}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,m){return new D(0,0)}with(R){return new D(0,0)}}e.$gI=D;class M{constructor(R,m,k,b){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(R,m),this.end=new D(k,b)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new M(0,0,0,0)}with(R){return new M(0,0,0,0)}}e.$hI=M;var g;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(g||(e.TextSearchCompleteMessageType=g={}))}),define(Se[36],De([1,0,19,35,23,32,15,5,16,8,93,9]),function($e,e,D,M,g,L,R,m,k,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.SearchErrorCode=e.$wI=e.$vI=e.SearchSortOrder=e.ViewMode=e.$uI=e.$tI=e.$sI=e.$rI=e.SearchCompletionExitCode=e.$qI=e.$pI=e.$oI=e.QueryType=e.SearchProviderType=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.$iI="workbench.view.search",e.$jI="workbench.panel.search",e.$kI="workbench.view.search",e.$lI="search-result",e.$mI="search.exclude";const p="\u27EA ",S=" characters skipped \u27EB",C=(p.length+S.length+5)*2;e.$nI=(0,m.$Bh)("searchService");var v;(function(V){V[V.file=0]="file",V[V.text=1]="text"})(v||(e.SearchProviderType=v={}));var o;(function(V){V[V.File=1]="File",V[V.Text=2]="Text"})(o||(e.QueryType=o={}));function s(V){return!!V.preview}e.$oI=s;function n(V){return!!V.resource}e.$pI=n;function h(V){return!!V.message}e.$qI=h;var $;(function(V){V[V.Normal=0]="Normal",V[V.NewSearchStarted=1]="NewSearchStarted"})($||(e.SearchCompletionExitCode=$={}));class d{constructor(x){this.resource=x,this.results=[]}}e.$rI=d;class t{constructor(x,ge,ue,we){this.ranges=ge,this.webviewIndex=we;const G=Array.isArray(ge)?ge:[ge];if(ue&&ue.matchLines===1&&r(G)){x=(0,R.$cf)(x,ue.matchLines);let U="",K=0,fe=0;const te=Math.floor(ue.charsPerLine/5),re=[];for(const ne of G){const Ee=Math.max(ne.startColumn-te,0),oe=ne.startColumn+ue.charsPerLine;if(Ee>fe+te+C){const he=p+(Ee-fe)+S;U+=he+x.slice(Ee,oe),K+=Ee-(fe+he.length)}else U+=x.slice(fe,oe);re.push(new i(0,ne.startColumn-K,ne.endColumn-K)),fe=oe}this.preview={text:U,matches:Array.isArray(this.ranges)?re:re[0]}}else{const U=Array.isArray(ge)?ge[0].startLineNumber:ge.startLineNumber;this.preview={text:x,matches:(0,D.$Zb)(ge,K=>new a(K.startLineNumber-U,K.startColumn,K.endLineNumber-U,K.endColumn))}}}}e.$sI=t;function r(V){const x=V[0].startLineNumber;for(const ge of V)if(ge.startLineNumber!==x||ge.endLineNumber!==x)return!1;return!0}class a{constructor(x,ge,ue,we){this.startLineNumber=x,this.startColumn=ge,this.endLineNumber=ue,this.endColumn=we}}e.$tI=a;class i extends a{constructor(x,ge,ue){super(x,ge,x,ue)}}e.$uI=i;var c;(function(V){V.List="list",V.Tree="tree"})(c||(e.ViewMode=c={}));var f;(function(V){V.Default="default",V.FileNames="fileNames",V.Type="type",V.Modified="modified",V.CountDescending="countDescending",V.CountAscending="countAscending"})(f||(e.SearchSortOrder=f={}));function y(V,x=!0){const ge=V&&V.files&&V.files.exclude,ue=x&&V&&V.search&&V.search.exclude;if(!ge&&!ue)return;if(!ge||!ue)return ge||ue;let we=Object.create(null);return we=g.$Ym(we,g.$Vm(ge)),we=g.$Ym(we,g.$Vm(ue),!0),we}e.$vI=y;function E(V,x){return V.excludePattern&&M.$qj(V.excludePattern,x)?!1:V.includePattern||V.usingSearchPaths?V.includePattern&&M.$qj(V.includePattern,x)?!0:V.usingSearchPaths?!!V.folderQueries&&V.folderQueries.some(ge=>{const ue=ge.folder.fsPath;if(L.$If(x,ue)){const we=k.$$d(ue,x);return!ge.includePattern||!!M.$qj(ge.includePattern,we)}else return!1}):!1:!0}e.$wI=E;var u;(function(V){V[V.unknownEncoding=1]="unknownEncoding",V[V.regexParseError=2]="regexParseError",V[V.globParseError=3]="globParseError",V[V.invalidLiteral=4]="invalidLiteral",V[V.rgProcessError=5]="rgProcessError",V[V.other=6]="other",V[V.canceled=7]="canceled"})(u||(e.SearchErrorCode=u={}));class l extends Error{constructor(x,ge){super(x),this.code=ge}}e.$xI=l;function w(V){const x=V.message;if((0,b.$2)(V))return new l(x,u.canceled);try{const ge=JSON.parse(x);return new l(ge.message,ge.code)}catch{return new l(x,u.other)}}e.$yI=w;function A(V){const x={message:V.message,code:V.code};return new Error(JSON.stringify(x))}e.$zI=A;function N(V){return V.type==="error"?!0:V.type==="success"}e.$AI=N;function O(V){return V.type==="success"}e.$BI=O;function F(V){return!!V.path}e.$CI=F;function j(V,x){const ge=V.searchPath?V.searchPath:V.relativePath;return(0,R.$_e)(ge,x)}e.$DI=j;class z{constructor(x){this.path=x,this.results=[]}addMatch(x){this.results.push(x)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$EI=z;function T(V,x){const ge={...V||{},...x||{}};return Object.keys(ge).filter(ue=>{const we=ge[ue];return typeof we=="boolean"&&we})}e.$FI=T;class H{constructor(x,ge){this.c=null,this.a={...x.excludePattern||{},...ge.excludePattern||{}},this.b=M.$rj(this.a);let ue=x.includePattern;ge.includePattern&&(ue?ue={...ue,...ge.includePattern}:ue=ge.includePattern),ue&&(this.c=M.$rj(ue))}matchesExcludesSync(x,ge,ue){return!!(this.b&&this.b(x,ge,ue))}includedInQuerySync(x,ge,ue){return!(this.b&&this.b(x,ge,ue)||this.c&&!this.c(x,ge,ue))}includedInQuery(x,ge,ue){const we=this.b(x,ge,ue),G=()=>this.c?!!this.c(x,ge,ue):!0;return(0,I.$tg)(we)?we.then(U=>U?!1:G()):G()}hasSiblingExcludeClauses(){return q(this.a)}}e.$GI=H;function q(V){for(const x in V)if(typeof V[x]!="boolean")return!0;return!1}function me(V){if(!V)return;let x;return ge=>(x||(x=(V()||Promise.resolve([])).then(ue=>ue?Z(ue):{})),x.then(ue=>!!ue[ge]))}e.$HI=me;function X(V){if(!V)return;let x;return ge=>{if(!x){const ue=V();x=ue?Z(ue):{}}return!!x[ge]}}e.$II=X;function Z(V){const x={};for(const ge of V)x[ge]=!0;return x}}),define(Se[39],De([1,0,19,9,21,4,3,78,17,120,24,15,2,214,5,14,243,43,54,26,20,13,7,68,36,6]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o,s,n,h,$,d,t,r,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dbc=e.$cbc=void 0;function c(N,O,F){return new P.$0f(j=>u(j,F)).isEqual(N,O)}function f(N,O,F){return c(N.uri,O.uri,F)?0:(0,I.$Fe)(N.uri.toString(),O.uri.toString())}function y(N,O,F){return N.index!==O.index?N.index<O.index?-1:1:c(N.uri,O.uri,F)?(0,I.$Fe)(N.name,O.name):(0,I.$Fe)(N.uri.toString(),O.uri.toString())}function E(N,O,F,j){const z=N.slice(0).sort((H,q)=>F(H,q,j)),T=O.slice(0).sort((H,q)=>F(H,q,j));return(0,D.$Cb)(z,T,(H,q)=>F(H,q,j))}function u(N,O){const F=O.getCapabilities(N.scheme);return!(F&&F&1024)}class l extends s.$Uh{static toExtHostWorkspace(O,F,j,z){if(!O)return{workspace:null,added:[],removed:[]};const{id:T,name:H,folders:q,configuration:me,transient:X,isUntitled:Z}=O,V=[],x=F;F?q.forEach((G,U)=>{const K=p.URI.revive(G.uri),fe=l.o(j||F,K,z);fe?(fe.name=G.name,fe.index=G.index,V.push(fe)):V.push({uri:K,name:G.name,index:U})}):V.push(...q.map(({uri:G,name:U,index:K})=>({uri:p.URI.revive(G),name:U,index:K}))),V.sort((G,U)=>G.index<U.index?-1:1);const ge=new l(T,H,V,!!X,me?p.URI.revive(me):null,!!Z,G=>u(G,z)),{added:ue,removed:we}=E(x?x.workspaceFolders:[],ge.workspaceFolders,f,z);return{workspace:ge,added:ue,removed:we}}static o(O,F,j){for(let z=0;z<O.folders.length;z++){const T=O.workspaceFolders[z];if(c(T.uri,F,j))return T}}constructor(O,F,j,z,T,H,q){super(O,j.map(me=>new s.$Vh(me)),z,T,q),this.t=F,this.u=H,this.q=[],this.s=m.$Hh.forUris(q),j.forEach(me=>{this.q.push(me),this.s.set(me.uri,me)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(O,F){return F&&this.s.get(O)&&(O=(0,P.$hg)(O)),this.s.findSubstr(O)}resolveWorkspaceFolder(O){return this.s.get(O)}}let w=class{constructor(O,F,j,z,T){this.c=new L.$fd,this.onDidChangeWorkspace=this.c.event,this.g=new L.$fd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$hd,this.B=new Map,this.h=z,this.s=j,this.t=T,this.j=new b.$Jl,this.k=new M.$Fg,this.o=O.getProxy(i.$ZJ.MainThreadWorkspace),this.q=O.getProxy(i.$ZJ.MainThreadMessageService);const H=F.workspace;this.l=H?new l(H.id,H.name,[],!!H.transient,H.configuration?p.URI.revive(H.configuration):null,!!H.isUntitled,q=>u(q,j)):void 0}$initializeWorkspace(O,F){this.v=F,this.$acceptWorkspaceData(O),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?p.URI.from({scheme:k.Schemas.untitled,path:(0,P.$fg)((0,P.$hg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(O,F,j,...z){const T=[];if(Array.isArray(z)&&z.forEach(Z=>{p.URI.isUri(Z.uri)&&!T.some(V=>c(V.uri,Z.uri,this.s))&&T.push({uri:Z.uri,name:Z.name||(0,P.$eg)(Z.uri)})}),this.n||[F,j].some(Z=>typeof Z!="number"||Z<0)||j===0&&T.length===0)return!1;const H=this.x?this.x.workspaceFolders:[];if(F+j>H.length)return!1;const q=H.slice(0);q.splice(F,j,...T.map(Z=>({uri:Z.uri,name:Z.name||(0,P.$eg)(Z.uri),index:void 0})));for(let Z=0;Z<q.length;Z++){const V=q[Z];if(q.some((x,ge)=>ge!==Z&&c(V.uri,x.uri,this.s)))return!1}q.forEach((Z,V)=>Z.index=V);const{added:me,removed:X}=E(H,q,y,this.s);if(me.length===0&&X.length===0)return!1;if(this.o){const Z=O.displayName||O.name;this.o.$updateWorkspaceFolders(Z,F,j,T).then(void 0,V=>{this.n=void 0;const x={source:{identifier:O.identifier,label:O.displayName||O.name}};this.q.$showMessage(o.Severity.Error,(0,S.localize)(0,null,Z,V.toString()),x,[])})}return this.y(q),!0}getWorkspaceFolder(O,F){if(this.x)return this.x.getWorkspaceFolder(O,F)}async getWorkspaceFolder2(O,F){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(O,F)}async resolveWorkspaceFolder(O){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(O)}getPath(){if(!this.x)return;const{folders:O}=this.x;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,F){let j,z="";if(typeof O=="string"?(j=p.URI.file(O),z=O):typeof O<"u"&&(j=O,z=O.fsPath),!j)return z;const T=this.getWorkspaceFolder(j,!0);if(!T)return z;typeof F>"u"&&this.x&&(F=this.x.folders.length>1);let H=(0,P.$kg)(T.uri,j);return F&&T.name&&(H=`${T.name}/${H}`),H}y(O){this.x&&(this.n=l.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:O,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:F,added:j,removed:z}=l.toExtHostWorkspace(O,this.l,this.n,this.s);this.l=F||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:z}))}findFiles(O,F,j,z,T=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let H;if(F===null?H=!1:F&&(typeof F=="string"?H=F:H=F.pattern),T&&T.isCancellationRequested)return Promise.resolve([]);const{includePattern:q,folder:me}=A(d.GlobPattern.from(O));return this.o.$startFileSearch(q??null,me??null,H??null,j??null,T).then(X=>Array.isArray(X)?X.map(Z=>p.URI.revive(Z)):[])}async findTextInFiles(O,F,j,z,T=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const H=this.j.getNext(),q=typeof F.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:me,folder:X}=A(d.GlobPattern.from(F.include)),Z=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,V={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:q,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:me,excludePattern:Z},x=!1;if(this.u[H]=ge=>{if(x)return;const ue=p.URI.revive(ge.resource);ge.results.forEach(we=>{(0,a.$oI)(we)?j({uri:ue,preview:{text:we.preview.text,matches:(0,D.$Zb)(we.preview.matches,G=>new t.$4J(G.startLineNumber,G.startColumn,G.endLineNumber,G.endColumn))},ranges:(0,D.$Zb)(we.ranges,G=>new t.$4J(G.startLineNumber,G.startColumn,G.endLineNumber,G.endColumn))}):j({uri:ue,text:we.text,lineNumber:we.lineNumber})})},T.isCancellationRequested)return{};try{const ge=await this.o.$startTextSearch(O,X??null,V,H,T);return delete this.u[H],ge||{}}catch(ge){throw delete this.u[H],ge}}$handleTextSearchResult(O,F){this.u[F]?.(O)}async save(O){const F=await this.o.$save(O,{saveAs:!1});return p.URI.revive(F)}async saveAs(O){const F=await this.o.$save(O,{saveAs:!0});return p.URI.revive(F)}saveAll(O){return this.o.$saveAll(O)}resolveProxy(O){return this.o.$resolveProxy(O)}get trusted(){return this.v}requestWorkspaceTrust(O){return this.o.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(O,F){if(this.w.has(O))throw new Error(`A provider has already been registered for scheme ${O}`);this.w.set(O,F);const j=this.t.transformOutgoingScheme(O),z=this.z++;return this.o.$registerEditSessionIdentityProvider(z,j),(0,R.$ic)(()=>{this.w.delete(O),this.o.$unregisterEditSessionIdentityProvider(z)})}async $getEditSessionIdentifier(O,F){this.h.info("Getting edit session identifier for workspaceFolder",O);const j=await this.resolveWorkspaceFolder(p.URI.revive(O));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const z=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!z),!z)return;const T=await z.provideEditSessionIdentity(j,F);if(this.h.info("Provider returned edit session identifier: ",T),!!T)return T}async $provideEditSessionIdentityMatch(O,F,j,z){this.h.info("Getting edit session identifier for workspaceFolder",O);const T=await this.resolveWorkspaceFolder(p.URI.revive(O));if(!T){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",T);const H=this.w.get(T.uri.scheme);if(this.h.info(`Provider for scheme ${T.uri.scheme} is defined: `,!!H),!H)return;const q=await H.provideEditSessionIdentityMatch?.(F,j,z);if(this.h.info("Provider returned edit session identifier match result: ",q),!!q)return q}getOnWillCreateEditSessionIdentityEvent(O){return(F,j,z)=>{const T=function(q){F.call(j,q)};return T.extension=O,this.A.event(T,void 0,z)}}async $onWillCreateEditSessionIdentity(O,F,j){const z=await this.resolveWorkspaceFolder(p.URI.revive(O));if(z===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:z},F,async(T,H)=>{const q=Date.now();await Promise.resolve(T),Date.now()-q>j&&this.h.warn("SLOW edit session create-participant",H.extension.identifier)}),F.isCancellationRequested}registerCanonicalUriProvider(O,F){if(this.B.has(O))throw new Error(`A provider has already been registered for scheme ${O}`);this.B.set(O,F);const j=this.t.transformOutgoingScheme(O),z=this.z++;return this.o.$registerCanonicalUriProvider(z,j),(0,R.$ic)(()=>{this.B.delete(O),this.o.$unregisterCanonicalUriProvider(z)})}async provideCanonicalUri(O,F,j){const z=this.B.get(O.scheme);if(!z)return;const T=await z.provideCanonicalUri?.(p.URI.revive(O),F,j);if(T)return T}async $provideCanonicalUri(O,F,j){return this.provideCanonicalUri(p.URI.revive(O),{targetScheme:F},j)}};e.$cbc=w,e.$cbc=w=Ke([Be(0,$.$2L),Be(1,h.$fM),Be(2,n.$3ac),Be(3,v.$5i),Be(4,r.$abc)],w),e.$dbc=(0,C.$Bh)("IExtHostWorkspace");function A(N){let O,F;return N&&(typeof N=="string"?O=N:(O=N.pattern,F=p.URI.revive(N.baseUri))),{includePattern:O,folder:F}}}),define(Se[40],De([1,0,23,4,39,6,7,245,136,18,9,5,20,14,2]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gbc=e.$fbc=e.$ebc=void 0;function v(r,a){if(a){const i=a.split(".");let c=r;for(let f=0;c&&f<i.length;f++)c=c[i[f]];return c}}function o(r){return r instanceof C.URI}function s(r){return r&&r.uri instanceof C.URI&&r.languageId&&typeof r.languageId=="string"}function n(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function h(r){return r&&r.uri instanceof C.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function $(r){if(o(r))return{resource:r};if(s(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(n(r))return{overrideIdentifier:r.languageId};if(h(r))return{resource:r.uri};if(r===null)return{resource:null}}let d=class{constructor(a,i,c){this.a=a.getProxy(L.$ZJ.MainThreadConfiguration),this.c=i,this.b=c,this.d=new P.$Fg,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new t(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,i){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(a,i))}};e.$ebc=d,e.$ebc=d=Ke([Be(0,p.$2L),Be(1,g.$dbc),Be(2,S.$5i)],d);class t{constructor(a,i,c,f){this.a=new M.$fd,this.b=a,this.f=f,this.c=i,this.e=m.$tn.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,i){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$tn.parse(a),this.d=this.k(a.configurationScopes),this.a.fire(this.j(i,c))}getConfiguration(a,i,c){const f=$(i)||{},y=this.g(a?v(this.e.getValue(void 0,f,this.c.workspace),a):this.e.getValue(void 0,f,this.c.workspace));a&&this.h(a,f,c?.identifier);function E(l){if(l==null)return null;if(typeof l=="boolean")return l?2:5;switch(l){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const u={has(l){return typeof v(y,l)<"u"},get:(l,w)=>{this.h(a?`${a}.${l}`:l,f,c?.identifier);let A=v(y,l);if(typeof A>"u")A=w;else{let N;const O=(F,j)=>{if((0,b.$lf)(F)){let z;const T=()=>{N=N||(0,D.$Vm)(y),z=z||v(N,j)};return new Proxy(F,{get:(H,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return T(),()=>z;if(N)return z=z||v(N,j),z[q];const me=H[q];return typeof q=="string"?O(me,`${j}.${q}`):me},set:(H,q,me)=>(T(),z&&(z[q]=me),!0),deleteProperty:(H,q)=>(T(),z&&delete z[q],!0),defineProperty:(H,q,me)=>(T(),z&&Object.defineProperty(z,q,me),!0)})}return Array.isArray(F)?(0,D.$Vm)(F):F};A=O(A,l)}return A},update:(l,w,A,N)=>{l=a?`${a}.${l}`:l;const O=E(A);return w!==void 0?this.b.$updateConfigurationOption(O,l,w,f,N):this.b.$removeConfigurationOption(O,l,f,N)},inspect:l=>{l=a?`${a}.${l}`:l;const w=this.e.inspect(l,f,this.c.workspace);if(w)return{key:l,defaultValue:(0,D.$Vm)(w.policy?.value??w.default?.value),globalValue:(0,D.$Vm)(w.user?.value??w.application?.value),workspaceValue:(0,D.$Vm)(w.workspace?.value),workspaceFolderValue:(0,D.$Vm)(w.workspaceFolder?.value),defaultLanguageValue:(0,D.$Vm)(w.default?.override),globalLanguageValue:(0,D.$Vm)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,D.$Vm)(w.workspace?.override),workspaceFolderLanguageValue:(0,D.$Vm)(w.workspaceFolder?.override),languageIds:(0,D.$Vm)(w.overrideIdentifiers)}}};return typeof y=="object"&&(0,D.$Ym)(u,y,!1),Object.freeze(u)}g(a){const i=c=>(0,b.$lf)(c)?new Proxy(c,{get:(f,y)=>i(f[y]),set:(f,y,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(y)}' of object`)},deleteProperty:(f,y)=>{throw new Error(`TypeError: Cannot delete read only property '${String(y)}' of object`)},defineProperty:(f,y)=>{throw new Error(`TypeError: Cannot define property '${String(y)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return i(a)}h(a,i,c){const f=k.$kn.test(a)?4:this.d.get(a),y=c?`[${c.value}] `:"";if(f===4){typeof i?.resource>"u"&&this.f.warn(`${y}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){i?.resource&&this.f.warn(`${y}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,i){const c=new m.$vn(a,i,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(f,y)=>c.affectsConfiguration(f,$(y))})}k(a){return a.reduce((i,c)=>(i.set(c[0],c[1]),i),new Map)}}e.$fbc=t,e.$gbc=(0,I.$Bh)("IExtHostConfiguration")}),define(Se[94],De([1,0,2,9,4,6,7,39,71,40,21,44,20,26,5,17,12,14,90,291,8]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o,s,n,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=e.$dcc=e.$ccc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var d;(function(O){function F(z){if(z!=null)return z}O.from=F;function j(z){if(z!=null)return z}O.to=j})(d||(d={}));var t;(function(O){function F(z){if(z!=null)return z}O.from=F;function j(z){if(z!=null)return z}O.to=j})(t||(t={}));var r;(function(O){function F(z){if(z!=null)return z}O.from=F;function j(z){if(z!=null)return z}O.to=j})(r||(r={}));var a;(function(O){function F(T){if(T){const H=T;return H&&!!H.process}else return!1}O.is=F;function j(T){if(T==null)return;const H={process:T.process,args:T.args};return T.options&&(H.options=r.from(T.options)),H}O.from=j;function z(T){if(T!=null)return new R.$KK(T.process,T.args,T.options)}O.to=z})(a||(a={}));var i;(function(O){function F(z){if(z!=null)return z}O.from=F;function j(z){if(z!=null)return z}O.to=j})(i||(i={}));var c;(function(O){function F(T){if(T){const H=T;return H&&(!!H.commandLine||!!H.command)}else return!1}O.is=F;function j(T){if(T==null)return;const H={};return T.commandLine!==void 0?H.commandLine=T.commandLine:(H.command=T.command,H.args=T.args),T.options&&(H.options=i.from(T.options)),H}O.from=j;function z(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new R.$LK(T.commandLine,T.options):new R.$LK(T.command,T.args?T.args:[],T.options)}O.to=z})(c||(c={}));var f;(function(O){function F(T){if(T){const H=T;return H&&H.customExecution==="customExecution"}else return!1}O.is=F;function j(T){return{customExecution:"customExecution"}}O.from=j;function z(T,H){return H.get(T)}O.to=z})(f||(e.CustomExecutionDTO=f={}));var y;(function(O){function F(j,z){let T;return j.scope!==void 0&&typeof j.scope!="number"?T=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===R.TaskScope.Workspace&&z&&z.workspaceFile?T=z.workspaceFile:T=h.$_F),{id:j._id,workspaceFolder:T}}O.from=F})(y||(e.TaskHandleDTO=y={}));var E;(function(O){function F(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}O.from=F})(E||(E={}));var u;(function(O){function F(T,H){if(T==null)return[];const q=[];for(const me of T){const X=j(me,H);X&&q.push(X)}return q}O.fromMany=F;function j(T,H){if(T==null)return;let q;T.execution instanceof R.$KK?q=a.from(T.execution):T.execution instanceof R.$LK?q=c.from(T.execution):T.execution&&T.execution instanceof R.$MK&&(q=f.from(T.execution));const me=d.from(T.definition);let X;return T.scope?typeof T.scope=="number"?X=T.scope:X=T.scope.uri:X=R.TaskScope.Workspace,!me||!X?void 0:{_id:T._id,definition:me,name:T.name,source:{extensionId:H.identifier.value,label:T.source,scope:X},execution:q,isBackground:T.isBackground,group:E.from(T.group),presentationOptions:t.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}O.from=j;async function z(T,H,q){if(T==null)return;let me;a.is(T.execution)?me=a.to(T.execution):c.is(T.execution)?me=c.to(T.execution):f.is(T.execution)&&(me=f.to(T._id,q));const X=d.to(T.definition);let Z;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?Z=T.source.scope:Z=await H.resolveWorkspaceFolder(D.URI.revive(T.source.scope)):Z=R.TaskScope.Workspace),!X||!Z)return;const V=new R.$NK(X,Z,T.name,T.source.label,me,T.problemMatchers);return T.isBackground!==void 0&&(V.isBackground=T.isBackground),T.group!==void 0&&(V.group=R.$JK.from(T.group._id),V.group&&T.group.isDefault&&(V.group=new R.$JK(V.group.id,V.group.label),T.group.isDefault===!0&&(V.group.isDefault=T.group.isDefault))),T.presentationOptions&&(V.presentationOptions=t.to(T.presentationOptions)),T._id&&(V._id=T._id),T.detail&&(V.detail=T.detail),V}O.to=z})(u||(e.TaskDTO=u={}));var l;(function(O){function F(z){return z}O.from=F;function j(z){if(z)return Object.assign(Object.create(null),z)}O.to=j})(l||(l={}));class w{#e;constructor(F,j,z){this._id=j,this.a=z,this.#e=F}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}let A=class{constructor(F,j,z,T,H,q,me,X){this.q=new g.$fd,this.r=new g.$fd,this.s=new g.$fd,this.t=new g.$fd,this.a=F.getProxy(L.$ZJ.MainThreadTask),this.b=z,this.c=T,this.d=H,this.e=q,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=me,this.g=X,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(F,j,z){if(!z)return new R.$2J(()=>{});const T=this.w();return this.j.set(T,{type:j,provider:z,extension:F}),this.a.$registerTaskProvider(T,j),new R.$2J(()=>{this.j.delete(T),this.a.$unregisterTaskProvider(T)})}registerTaskSystem(F,j){this.a.$registerTaskSystem(F,j)}fetchTasks(F){return this.a.$fetchTasks(l.from(F)).then(async j=>{const z=[];for(const T of j){const H=await u.to(T,this.b,this.m);H&&z.push(H)}return z})}get taskExecutions(){const F=[];return this.k.forEach(j=>F.push(j)),F}terminateTask(F){if(!(F instanceof w))throw new Error("No valid task execution provided");return this.a.$terminateTask(F._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(F,j,z){const T=this.m.get(F.id);T&&(this.o.set(F.id,T),this.e.attachPtyToTerminal(j,await T.callback(z))),this.p=F.id,this.q.fire({execution:await this.y(F)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(F){const j=await this.y(F);this.l.delete(F.id),this.k.delete(F.id),this.A(F),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(F){const j=await this.y(F.id);this.s.fire({execution:j,processId:F.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(F){const j=await this.y(F.id);this.t.fire({execution:j,exitCode:F.exitCode})}$provideTasks(F,j){const z=this.j.get(F);if(!z)return Promise.reject(new Error("no handler found"));const T=[],H=(0,M.$zg)(()=>z.provider.provideTasks(P.CancellationToken.None)).then(q=>this.u(j,T,z,q));return new Promise(q=>{H.then(me=>{Promise.all(T).then(()=>{q(me)})})})}async $resolveTask(F,j){const z=this.j.get(F);if(!z)return Promise.reject(new Error("no handler found"));if(j.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${z.type}].`);const T=await u.to(j,this.b,this.m);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const H=await z.provider.resolveTask(T,P.CancellationToken.None);if(!H)return;this.z(H,z);const q=u.from(H,z.extension);if(!q)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(q.execution)&&await this.x(q,H,!0),await this.v(q)}w(){return this.h++}async x(F,j,z){const T=await this.a.$createTaskId(F);!z&&!this.m.has(T)&&(this.n.add(T),this.o.set(T,j.execution)),this.m.set(T,j.execution)}async y(F,j){if(typeof F=="string"){const H=this.l.get(F);if(!H)throw new $.$_("Unexpected: The specified task is missing an execution");return H}const z=this.l.get(F.id);if(z)return z;const T=new Promise((H,q)=>{function me(X,Z,V){V?H(new w(X,Z.id,V)):q("Unexpected: Task does not exist.")}j?me(this,F,j):u.to(F.task,this.b,this.m).then(X=>me(this,F,X))});return this.l.set(F.id,T),T.then(H=>(this.k.set(F.id,H),H),H=>Promise.reject(H))}z(F,j){F._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}A(F){this.o.get(F.id)&&this.o.delete(F.id),this.n.has(F.id)&&this.p!==F.id&&(this.m.delete(F.id),this.n.delete(F.id));const z=this.n.values();let T=z.next();for(;!T.done;)!this.o.has(T.value)&&this.p!==T.value&&(this.m.delete(T.value),this.n.delete(T.value)),T=z.next()}};e.$ccc=A,e.$ccc=A=Ke([Be(0,p.$2L),Be(1,S.$fM),Be(2,m.$dbc),Be(3,k.$aM),Be(4,b.$gbc),Be(5,I.$ybc),Be(6,s.$5i),Be(7,n.$6ac)],A);let N=class extends A{constructor(F,j,z,T,H,q,me,X){super(F,j,z,T,H,q,me,X),this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(F,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const z=u.from(j,F);if(z===void 0)throw new Error("Task is not valid");if(f.is(z.execution))await this.x(z,j,!1);else throw new $.$0;const T=await this.y(await this.a.$getTaskExecution(z),j);return this.a.$executeTask(z).catch(H=>{throw new Error(H)}),T}u(F,j,z,T){const H=[];if(T)for(const q of T){this.z(q,z),(!q.definition||!F[q.definition.type])&&this.f.warn(`The task [${q.source}, ${q.name}] uses an undefined task type. The task will be ignored in the future.`);const me=u.from(q,z.extension);me&&f.is(me.execution)?(H.push(me),j.push(this.x(me,q,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:H,extension:z.extension}}async v(F){if(f.is(F.execution))return F;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(F,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,j,z){}};e.$dcc=N,e.$dcc=N=Ke([Be(0,p.$2L),Be(1,S.$fM),Be(2,m.$dbc),Be(3,k.$aM),Be(4,b.$gbc),Be(5,I.$ybc),Be(6,s.$5i),Be(7,n.$6ac)],N),e.$ecc=(0,C.$Bh)("IExtHostTask")}),define(Se[347],De([1,0,16,21,46,35,24,37,36]),function($e,e,D,M,g,L,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=void 0;class b{constructor(p,S,C){this.k=p,this.l=S,this.o=C,this.e=!1,this.f=0,this.g=!1,this.a=p.filePattern,this.b=p.includePattern&&L.$rj(p.includePattern),this.c=p.maxResults||void 0,this.d=p.exists,this.h=new Set,this.j=p.excludePattern&&L.$rj(p.excludePattern)}cancel(){this.g=!0,this.h.forEach(p=>p.cancel()),this.h=new Set}search(p){const S=this.k.folderQueries||[];return new Promise((C,v)=>{const o=s=>{this.f++,p(s)};if(this.g)return C({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const n=s.toString(),h=D.$ae(n);this.j&&this.j(n,h)||this.v(o,{base:s,basename:h})}),Promise.all(S.map(s=>this.p(s,o))).then(s=>{C({limitHit:this.e,stats:s[0]||void 0})},s=>{v(new Error((0,g.$mi)(s)))})})}async p(p,S){const C=new M.$pd,v=this.q(p),o=this.r(),s=new k.$GI(this.k,p),n=!s.hasSiblingExcludeClauses();let h;try{this.h.add(C),h=m.$bd.create();const $=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},v,C.token),d=h.elapsed(),t=m.$bd.create();return this.g&&!this.e||($&&$.forEach(r=>{const a=D.$6d.relative(p.folder.path,r.path);if(n){const i=D.$ae(r.path);this.v(S,{base:p.folder,relativePath:a,basename:i});return}this.s(o,p.folder,a,S)}),this.g&&!this.e)?null:(this.u(o,s,S),{providerTime:d,postProcessTime:t.elapsed()})}finally{C.dispose(),this.h.delete(C)}}q(p){const S=(0,k.$FI)(this.k.includePattern,p.includePattern),C=(0,k.$FI)(this.k.excludePattern,p.excludePattern);return{folder:p.folder,excludes:C,includes:S,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}s({pathToEntries:p},S,C,v){if(C===this.a){const s=D.$ae(this.a);this.v(v,{base:S,relativePath:this.a,basename:s})}function o(s){const n=D.$ae(s),h=D.$_d(s);let $=p[h];$||($=p[h]=[],o(h)),$.push({base:S,relativePath:s,basename:n})}o(C)}u({rootEntries:p,pathToEntries:S},C,v){const o=this,s=this.a;function n(h){const $=(0,k.$II)(()=>h.map(d=>d.basename));for(let d=0,t=h.length;d<t;d++){const r=h[d],{relativePath:a,basename:i}=r;if(C.matchesExcludesSync(a,i,s!==i?$:void 0))continue;const c=S[a];if(c)n(c);else{if(a===s)continue;o.v(v,r)}if(o.e)break}}n(p)}v(p,S){(!this.b||S.relativePath&&this.b(S.relativePath,S.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||p(S))}}class P{constructor(){this.b=new Map}static{this.a=512}fileSearch(p,S,C,v){const o=this.c(p.cacheKey),s=new b(p,S,o&&o.token);let n=0;const h=$=>{n+=$.length,C($.map(d=>this.d(d)))};return this.e(s,P.a,h,v).then($=>({limitHit:$.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:$.stats}}))}clearCache(p){this.c(p)?.cancel()}c(p){if(p)return this.b.has(p)||this.b.set(p,new M.$pd),this.b.get(p)}d(p){return p.relativePath?{resource:R.$ig(p.base,p.relativePath)}:{resource:p.base}}e(p,S,C,v){const o=v.onCancellationRequested(()=>{p.cancel()}),s=h=>{h&&(n.push(h),S>0&&n.length>=S&&(C(n),n=[]))};let n=[];return p.search(s).then(h=>(n.length&&C(n),o.dispose(),h),h=>(n.length&&C(n),o.dispose(),Promise.reject(h)))}}e.$occ=P}),define(Se[348],De([1,0,19,56,35,100,28,17,16,24,15,18,2,172,226,49,14,43,143,345,36]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o,s,n,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AJ=e.$zJ=void 0;let d=class{constructor(l,w,A,N,O){this.a=l,this.b=w,this.c=A,this.d=N,this.e=O}text(l,w,A={}){l=this.f(l,A);const N=this.a.getValue(),O=w&&w.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(w?.map(s.$Wh),A),type:2,contentPattern:l,previewOptions:A.previewOptions,maxFileSize:A.maxFileSize,usePCRE2:N.search.usePCRE2||O||!1,beforeContext:A.beforeContext,afterContext:A.afterContext,userDisabledExcludesAndIgnoreFiles:A.disregardExcludeSettings&&A.disregardIgnoreFiles}}f(l,w){const A=this.a.getValue();l.isRegExp&&(l.pattern=l.pattern.replace(/\r?\n/g,"\\n"));const N={...l,wordSeparators:A.editor.wordSeparators};return this.j(l,w)&&(N.isCaseSensitive=!0),this.k(l)&&(N.isMultiline=!0),w.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=w.notebookSearchConfig.includeMarkupInput),w.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=w.notebookSearchConfig.includeMarkupPreview),w.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=w.notebookSearchConfig.includeCodeInput),w.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=w.notebookSearchConfig.includeOutput),N}file(l,w={}){return{...this.h(l,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}g(l,w){return l?(l=Array.isArray(l)?l.map(c):c(l),w?this.parseSearchPaths(l):{pattern:r(...Array.isArray(l)?l:[l])}):{}}h(l=[],w={}){const A=this.g(w.includePattern,w.expandPatterns),N=this.g(w.excludePattern,w.expandPatterns),O=l.length>1,F=(A.searchPaths&&A.searchPaths.length?A.searchPaths.map(T=>this.q(T,w,N)):l.map(T=>this.r(T,w,N,O))).filter(T=>!!T),j={_reason:w._reason,folderQueries:F,usingSearchPaths:!!(A.searchPaths&&A.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:N.pattern,includePattern:A.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const T=D.$Fb(D.$Pb(this.c.groups.map(me=>me.editors.map(X=>X.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const H=T.filter(me=>(0,$.$wI)(j,me.fsPath)),q=this.i(H);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(q)),{...j,...q}}const z=w.extraFileResources&&w.extraFileResources.filter(T=>(0,$.$wI)(j,T.fsPath));return j.extraFileResources=z&&z.length?z:void 0,j}i(l){const w=[],A=new R.$zi,N={};let O=!1;return l.forEach(F=>{if(F.scheme===m.Schemas.walkThrough)return;if((0,b.$mg)(F)){const z=this.b.getWorkspaceFolder(F)?.uri??F.with({path:k.$_d(F.fsPath)});let T=A.get(z);T||(O=!0,T={folder:z,includePattern:{}},w.push(T),A.set(z,T));const H=k.$$d(z.fsPath,F.fsPath);(0,I.$uf)(T.includePattern)[H.replace(/\\/g,"/")]=!0}else F.fsPath&&(O=!0,N[F.fsPath]=!0)}),{folderQueries:w,includePattern:N,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}j(l,w){if(w.isSmartCase){if(l.isRegExp){if(P.$af(l.pattern,!0))return!0}else if(P.$af(l.pattern))return!0}return!!l.isCaseSensitive}k(l){return l.isMultiline||l.isRegExp&&(0,S.$iC)(l.pattern)||l.pattern.indexOf(`
`)>=0?!0:!!l.isMultiline}parseSearchPaths(l){const w=q=>k.$8d(q)||/^\.\.?([\/\\]|$)/.test(q),N=(Array.isArray(l)?l:a(l)).map(q=>{const me=this.e.resolvedUserHome;return me?(0,L.$hA)(q,me.scheme===m.Schemas.file?me.fsPath:me.path):q}),O=M.$I(N,q=>w(q)?"searchPaths":"exprSegments"),F=(O.exprSegments||[]).map(q=>P.$ve(q,"/")).map(q=>P.$ve(q,"\\")).map(q=>(q[0]==="."&&(q="*"+q),i(q))),j={},z=this.m(O.searchPaths||[]);z&&z.length&&(j.searchPaths=z);const T=D.$Pb(F),H=r(...T);return H&&(j.pattern=H),j}l(l,w){return w.disregardExcludeSettings?void 0:(0,$.$vI)(l,!w.disregardSearchExcludeSettings)}m(l){if(!l||!l.length)return[];const w=l.flatMap(N=>{let{pathPortion:O,globPortion:F}=t(N);return F&&(F=f(F)),this.n(O).flatMap(z=>this.o(z,F))}),A=new Map;return w.forEach(N=>{const O=N.searchPath.toString(),F=A.get(O);F?N.pattern&&(F.pattern=F.pattern||{},F.pattern[N.pattern]=!0):A.set(O,{searchPath:N.searchPath,pattern:N.pattern?r(N.pattern):void 0})}),Array.from(A.values())}n(l){if(k.$8d(l)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==m.Schemas.file?[{searchPath:w[0].uri.with({path:l})}]:[{searchPath:p.URI.file(k.$7d(l))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(l=c(l),l.startsWith("../")||l===".."){const N=k.$6d.resolve(w.path,l);return[{searchPath:w.with({path:N})}]}const A=f(l);return[{searchPath:w,pattern:A}]}else{if(l==="./"||l===".\\")return[];{const w=l.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(O=>{const F=w.match(new RegExp(`^${P.$qe(O.name)}(?:/(.*)|$)`));return F?{match:F,folder:O}:null}).filter(I.$rf);if(N.length)return N.map(O=>{const F=O.match[1];return{searchPath:O.folder.uri,pattern:F&&f(F)}});{const O=l.match(/\.[\/\\](.+)[\/\\]?/),F=O?O[1]:l,j=C.localize(0,null,F);throw new Error(j)}}}}o(l,w){const A=l.pattern&&w?`${l.pattern}/${w}`:l.pattern||w,N=[{searchPath:l.searchPath,pattern:A}];return A&&!A.endsWith("**")&&N.push({searchPath:l.searchPath,pattern:A+"/**"}),N}q(l,w,A){const N=this.r((0,s.$Wh)(l.searchPath),w,A,!1);return N?{...N,includePattern:l.pattern}:null}r(l,w,A,N){let O;const F=p.URI.isUri(l)?l:l.uri;if(A.searchPaths){const q=A.searchPaths.filter(me=>(0,b.$bg)(me.searchPath,F))[0];if(q&&!q.pattern)return null;q&&(O=q.pattern)}const j=this.a.getValue({resource:F}),T={...this.l(j,w)||{},...O||{}},H=p.URI.isUri(l)?(0,b.$fg)(l):l.name;return{folder:F,folderName:N?H:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!j.search.followSymlinks}}};e.$zJ=d,e.$zJ=d=Ke([Be(0,v.$8h),Be(1,s.$Kh),Be(2,n.$5C),Be(3,o.$5i),Be(4,h.$xJ)],d);function t(u){const l=u.match(/[\*\{\}\(\)\[\]\?]/);if(l){const w=l.index,A=u.substr(0,w).match(/[/|\\][^/\\]*$/);if(A){let N=u.substr(0,A.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:u.substr((A.index||0)+1)}}}return{pathPortion:u}}function r(...u){return u.length?u.reduce((l,w)=>(l[w]=!0,l),Object.create(null)):void 0}function a(u){return g.$pj(u,",").map(l=>l.trim()).filter(l=>!!l.length)}function i(u){return[`**/${u}/**`,`**/${u}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function c(u){return u.replace(/\\/g,"/")}function f(u){return c(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function y(u){return u.replace(/([?*[\]])/g,"[$1]")}function E(u,l){u=D.$Kb(u,N=>N.toString());const w=[],A=l.getWorkspace();return u&&u.forEach(N=>{let O;if(l.getWorkbenchState()===2)O=(0,b.$kg)(A.folders[0].uri,N),O&&O!=="."&&(O="./"+O);else{const F=l.getWorkspaceFolder(N);if(F){const j=F.name;if(A.folders.filter(T=>T.name===j).length===1){const T=(0,b.$kg)(F.uri,N);T===""?O=`./${F.name}`:O=`./${F.name}/${T}`}else O=N.fsPath}}O&&w.push(y(O))}),w}e.$AJ=E}),define(Se[349],De([1,0,24,2,21,8,5,348,36,43]),function($e,e,D,M,g,L,R,m,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ylb=e.$xlb=void 0;const P=7e3;function I(v,o){const s=o.activationEvents;if(!s)return Promise.resolve(void 0);const n=[],h=[];for(const i of s)if(/^workspaceContains:/.test(i)){const c=i.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||v.forceUsingSearch?h.push(c):n.push(c)}if(n.length===0&&h.length===0)return Promise.resolve(void 0);let $;const d=new Promise((i,c)=>{$=i}),t=i=>$({activationEvent:i}),r=Promise.all(n.map(i=>p(v,i,t))).then(()=>{}),a=S(v,o.identifier,h,t);return Promise.all([r,a]).then(()=>{$(void 0)}),d}e.$xlb=I;async function p(v,o,s){for(const n of v.folders)if(await v.exists(D.$ig(M.URI.revive(n),o))){s(`workspaceContains:${o}`);return}}async function S(v,o,s,n){if(s.length===0)return Promise.resolve(void 0);const h=new g.$pd,$=v.checkExists(v.folders,s,h.token),d=setTimeout(async()=>{h.cancel(),v.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${s.join(",")}`)},P);let t=!1;try{t=await $}catch(r){L.$2(r)||L.$Y(r)}h.dispose(),clearTimeout(d),t&&n(`workspaceContains:${s.join(",")}`)}function C(v,o,s,n){const h=v.get(R.$Ah),$=v.get(k.$nI),t=h.createInstance(m.$zJ).file(o.map(r=>(0,b.$Wh)(M.URI.revive(r))),{_reason:"checkExists",includePattern:s,exists:!0});return $.fileSearch(t,n).then(r=>!!r.limitHit,r=>L.$2(r)?!1:Promise.reject(r))}e.$ylb=C}),define(Se[45],De([1,0,204,16,53,24,9,3,78,2,14,6,40,286,115,39,27,148,8,25,22,262,7,66,5,26,91,20,105,74,44,4,349,114,264,17,112,37,12,113]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o,s,n,h,$,d,t,r,a,i,c,f,y,E,u,l,w,A,N,O,F,j,z,T){"use strict";var H;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nbc=e.$Mbc=e.$Lbc=e.$Kbc=e.$Jbc=void 0,e.$Jbc=(0,a.$Bh)("IHostUtils");let q=H=class extends m.$kc{constructor(G,U,K,fe,te,re,ne,Ee,oe,he,ee,le){super(),this.X=le,this.a=this.B(new l.$fd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=U,this.g=K,this.f=ne,this.j=fe,this.m=te,this.s=re,this.t=oe,this.u=he,this.w=ee,this.y=this.g.getProxy(I.$ZJ.MainThreadWorkspace),this.z=this.g.getProxy(I.$ZJ.MainThreadTelemetry),this.C=this.g.getProxy(I.$ZJ.MainThreadExtensionService),this.D=new R.$Fg,this.F=new R.$Fg,this.G=new R.$Fg,this.H=new R.$Fg,this.I=new ue(this.f.extensions.activationEvents),this.L=new s.$t3b(this.I,this.f.extensions.allExtensions);const be=new h.$Wl(this.f.extensions.myExtensions);this.J=new s.$t3b(this.I,x(this.L,be)),z.$s&&(this.s.info(`Creating extension host with the following global extensions: ${Z(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Z(this.J)}`)),this.M=new C.$qbc(this.g,this.s),this.N=new A.$Cbc(this.g),this.O=Ee,this.h=G.createChild(new y.$zh([C.$rbc,this.M],[A.$Dbc,this.N])),this.P=this.B(new S.$pbc(this.J,this.L,{onExtensionActivationError:(Ie,B,Q)=>{this.C.$onExtensionActivationError(Ie,n.$1(B),Q)},actualActivateExtension:async(Ie,B)=>{if(s.$t3b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,B),new S.$obc;const Q=this.J.getExtensionDescription(Ie);return this.db(Q,B)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),g.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(G){n.$Y(G)}}async Y(){this.O.onWillDeactivateAll();let G=[];try{G=this.J.getAllExtensionDescriptions().map(te=>te.identifier).filter(te=>this.isActivated(te)).map(te=>this.cb(te))}catch{}await Promise.all(G)}terminate(G,U=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${G}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(fe=>{this.s.error(fe)}),this.g.dispose();const K=this.Y();Promise.race([(0,R.$Hg)(5e3),K]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${U}`):this.s.info(`Extension host exiting with code ${U}`),this.s.flush(),this.s.dispose(),this.c.exit(U)})}isActivated(G){return this.G.isOpen()?this.P.isActivated(G):!1}async getExtension(G){const U=await this.C.$getExtension(G);return U&&{...U,identifier:new h.$Vl(U.identifier.value),extensionLocation:b.URI.revive(U.extensionLocation)}}Z(G,U){return this.P.activateByEvent(G,U)}$(G,U){return this.P.activateById(G,U)}activateByIdWithErrors(G,U){return this.$(G,U).then(()=>{const K=this.P.getActivatedExtension(G);if(K.activationFailed)return Promise.reject(K.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(G=>this.J)}getExtensionExports(G){if(this.G.isOpen())return this.P.getActivatedExtension(G).exports;try{return this.P.getActivatedExtension(G).exports}catch{return null}}async ab(G){if(G.scheme===O.Schemas.file&&this.c.fsRealpath){const U=await this.c.fsRealpath(G.fsPath);return b.URI.file(U)}return G}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(G=>new ge(G))),this.Q}async bb(G){const U=k.$Hh.forUris(K=>L.$_f.ignorePathCasing(K));return await Promise.all(G.map(async K=>{if(this.ub(K)){const fe=await this.ab(K.extensionLocation);U.set(fe,K)}})),U}cb(G){let U=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(G))return U;const K=this.P.getActivatedExtension(G);if(!K)return U;try{typeof K.module.deactivate=="function"&&(U=Promise.resolve(K.module.deactivate()).then(void 0,fe=>(this.s.error(fe),Promise.resolve(void 0))))}catch(fe){this.s.error(`An error occurred when deactivating the extension '${G.value}':`),this.s.error(fe)}try{(0,m.$fc)(K.subscriptions)}catch(fe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${G.value}':`),this.s.error(fe)}return U}async db(G,U){return this.f.remote.isRemote?this.C.$onWillActivateExtension(G.identifier):await this.C.$onWillActivateExtension(G.identifier),this.fb(G,U).then(K=>{const fe=K.activationTimes;return this.C.$onDidActivateExtension(G.identifier,fe.codeLoadingTime,fe.activateCallTime,fe.activateResolvedTime,U),this.eb(G,U,"success",fe),K},K=>{throw this.eb(G,U,"failure"),K})}eb(G,U,K,fe){const te=X(G,U);this.z.$publicLog2("extensionActivationTimes",{...te,...fe||{},outcome:K})}fb(G,U){const K=X(G,U);this.z.$publicLog2("activatePlugin",K);const fe=this.ub(G);if(!fe)return Promise.resolve(new S.$nbc(S.$kbc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${G.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${G.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this.s.flush();const te=new S.$lbc(U.startup);return Promise.all([this.vb(G,(0,L.$ig)(G.extensionLocation,fe),te),this.gb(G)]).then(re=>(g.mark(`code/extHost/willActivateExtension/${G.identifier.value}`),H.hb(this.s,G.identifier,re[0],re[1],te))).then(re=>(g.mark(`code/extHost/didActivateExtension/${G.identifier.value}`),re))}gb(G){const U=new d.$tbc(G,this.M),K=new d.$sbc(G.identifier.value,!1,this.M),fe=new N.$Ebc(G,this.N),te=G.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,re=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${G.identifier.value}`),Promise.all([U.whenReady,K.whenReady,this.O.whenReady]).then(()=>{const ne=this;let Ee,oe;const he=(0,o.$PF)(G,"ipc")?this.f.messagePorts?.get(h.$Vl.toKey(G.identifier)):void 0;return Object.freeze({globalState:U,workspaceState:K,secrets:fe,subscriptions:[],get extensionUri(){return G.extensionLocation},get extensionPath(){return G.extensionLocation.fsPath},asAbsolutePath(ee){return M.$9d(G.extensionLocation.fsPath,ee)},get storagePath(){return ne.O.workspaceValue(G)?.fsPath},get globalStoragePath(){return ne.O.globalValue(G).fsPath},get logPath(){return M.$9d(ne.f.logsLocation.fsPath,G.identifier.value)},get logUri(){return b.URI.joinPath(ne.f.logsLocation,G.identifier.value)},get storageUri(){return ne.O.workspaceValue(G)},get globalStorageUri(){return ne.O.globalValue(G)},get extensionMode(){return te},get extension(){return Ee===void 0&&(Ee=new V(ne,G.identifier,G,re,!1)),Ee},get extensionRuntime(){return(0,o.$QF)(G,"extensionRuntime"),ne.extensionRuntime},get environmentVariableCollection(){return ne.u.getEnvironmentVariableCollection(G)},get messagePassingProtocol(){if(!oe){if(!he)return;const ee=l.Event.buffer(l.Event.fromDOMEventEmitter(he,"message",le=>le.data));he.start(),oe={onDidReceiveMessage:ee,postMessage:he.postMessage.bind(he)}}return oe}})})}static hb(G,U,K,fe,te){return K=K||{activate:void 0,deactivate:void 0},this.ib(G,U,K,fe,te).then(re=>new S.$mbc(!1,null,te.build(),K,re,fe.subscriptions))}static ib(G,U,K,fe,te){if(typeof K.activate=="function")try{te.activateCallStart(),G.trace(`ExtensionService#_callActivateOptional ${U.value}`);const re=typeof global=="object"?global:self,ne=K.activate.apply(re,[fe]);return te.activateCallStop(),te.activateResolveStart(),Promise.resolve(ne).then(Ee=>(te.activateResolveStop(),Ee))}catch(re){return Promise.reject(re)}else return Promise.resolve(K)}jb(G,U){this.$(G.identifier,{startup:!1,extensionId:G.identifier,activationEvent:U}).then(void 0,K=>{this.s.error(K)})}kb(G,U=0){const fe=Date.now();(0,z.$A)(()=>{for(let te=U;te<G.length;te+=1){const re=G[te];for(const ne of re.activationEvents??[])if(ne==="onStartupFinished")if(Date.now()-fe>50){this.kb(G,te);break}else this.jb(re,ne)}})}lb(){this.C.$setPerformanceMarks(g.getMarks()),this.m.getConfigProvider().then(G=>{const U=G.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),K=this.J.getAllExtensionDescriptions();if(U)this.kb(K);else for(const fe of K)if(fe.activationEvents)for(const te of fe.activationEvents)te==="onStartupFinished"&&this.jb(fe,te)})}mb(){const G=this.Z("*",!0).then(void 0,re=>{this.s.error(re)});this.B(this.j.onDidChangeWorkspace(re=>this.nb(re.added)));const U=this.j.workspace?this.j.workspace.folders:[],K=this.nb(U),fe=this.pb(),te=Promise.all([fe,G,K]).then(()=>{});return Promise.race([te,(0,R.$Hg)(1e4)]).then(()=>{this.lb()}),te}nb(G){return G.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(U=>this.ob(G,U))).then(()=>{})}async ob(G,U){if(this.isActivated(U.identifier))return;const K=!this.f.remote.isRemote&&!!this.f.remote.authority,fe={logService:this.s,folders:G.map(re=>re.uri),forceUsingSearch:K||!this.c.fsExists,exists:re=>this.c.fsExists(re.fsPath),checkExists:(re,ne,Ee)=>this.y.$checkExists(re,ne,Ee)},te=await(0,w.$xlb)(fe,U);if(te)return this.$(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:te.activationEvent}).then(void 0,re=>this.s.error(re))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(G){throw console.error(G),G}}async qb(){const{extensionDevelopmentLocationURI:G,extensionTestsLocationURI:U}=this.f.environment;if(!G||!U)throw new Error(D.localize(0,null));const K=await this.vb(null,U,new S.$lbc(!1));if(!K||typeof K.run!="function")throw new Error(D.localize(1,null,U.toString()));return new Promise((fe,te)=>{const re=(oe,he)=>{oe?(z.$s&&this.s.error("Test runner called back with error",oe),te(oe)):(z.$s&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),fe(typeof he=="number"&&he>0?1:0))},ne=(0,L.$9f)(U),Ee=K.run(ne,re);Ee&&Ee.then&&Ee.then(()=>{z.$s&&this.s.info("Test runner finished successfully."),fe(0)}).catch(oe=>{z.$s&&this.s.error("Test runner finished with error",oe),te(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Hg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(G,U){return this.R[G]=U,(0,m.$ic)(()=>{delete this.R[G]})}async getRemoteExecServer(G){const{resolver:U}=await this.sb(G);return U?.resolveExecServer?.(G,{resolveAttempt:0})}async sb(G){const U=G.indexOf("+");if(U===-1)throw new t.$8J("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const K=G.substr(0,U);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${K}`,!1),{authorityPrefix:K,resolver:this.R[K]}}async $resolveAuthority(G,U){const K=j.$bd.create(!1),fe=()=>`[resolveAuthority(${(0,r.$Nk)(G)},${U})][${K.elapsed()}ms] `,te=se=>this.s.info(`${fe()}${se}`),re=se=>this.s.warn(`${fe()}${se}`),ne=(se,Y=void 0)=>this.s.error(`${fe()}${se}`,Y),Ee=se=>{if(se instanceof t.$8J)return{type:"error",error:{code:se._code,message:se._message,detail:se._detail}};throw se},oe=async se=>{te(`activating resolver for ${se}...`);const{resolver:Y,authorityPrefix:de}=await this.sb(se);if(!Y)throw ne(`no resolver for ${de}`),new t.$8J(`No remote extension installed to resolve ${de}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Y,authorityPrefix:de,remoteAuthority:se}},he=G.split(/@|%40/g).reverse();te(`activating remote resolvers ${he.join(" -> ")}`);let ee;try{ee=await Promise.all(he.map(oe)).catch(async se=>{if(!(se instanceof t.$8J)||se._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw se;return re(`resolving nested authorities failed: ${se.message}`),[await oe(G)]})}catch(se){return Ee(se)}const le=new R.$Rg;le.cancelAndSet(()=>te("waiting..."),1e3);let be,Ie;for(const[se,{authorityPrefix:Y,resolver:de,remoteAuthority:ye}]of ee.entries())try{if(se===ee.length-1)te("invoking final resolve()..."),g.mark(`code/extHost/willResolveAuthority/${Y}`),be=await de.resolve(ye,{resolveAttempt:U,execServer:Ie}),g.mark(`code/extHost/didResolveAuthorityOK/${Y}`),te("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(de,t.$7J.isManagedResolvedAuthority(be)?be:void 0));else{if(te(`invoking resolveExecServer() for ${ye}`),g.mark(`code/extHost/willResolveExecServer/${Y}`),Ie=await de.resolveExecServer?.(ye,{resolveAttempt:U,execServer:Ie}),!Ie)throw new t.$8J(`Exec server was not available for ${ye}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);g.mark(`code/extHost/didResolveExecServerOK/${Y}`)}}catch(je){return g.mark(`code/extHost/didResolveAuthorityError/${Y}`),ne("returned an error",je),le.dispose(),Ee(je)}le.dispose();const B={environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures},Q={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};te(`returned ${t.$7J.isManagedResolvedAuthority(be)?"managed authority":`${be.host}:${be.port}`}`);let ie;if(t.$7J.isManagedResolvedAuthority(be)){const se=U;this.X.setFactory(se,be.makeConnection),ie={authority:G,connectTo:new r.$Kk(se),connectionToken:be.connectionToken}}else ie={authority:G,connectTo:new r.$Lk(be.host,be.port),connectionToken:be.connectionToken};return{type:"ok",value:{authority:ie,options:Q,tunnelInformation:B}}}async $getCanonicalURI(G,U){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$Nk)(G)})`);const{resolver:K}=await this.sb(G);if(!K)return null;const fe=b.URI.revive(U);if(typeof K.getCanonicalURI>"u")return fe;const te=await(0,R.$zg)(()=>K.getCanonicalURI(fe));return te||fe}$startExtensionHost(G){G.toAdd.forEach(fe=>fe.extensionLocation=b.URI.revive(fe.extensionLocation));const{globalRegistry:U,myExtensions:K}=me(this.I,this.L,this.J,G);return this.L.set(U.getAllExtensionDescriptions()),this.J.set(K),z.$s&&(this.s.info(`$startExtensionHost: global extensions: ${Z(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Z(this.J)}`)),this.rb()}$activateByEvent(G,U){return U===1?this.D.wait().then(K=>this.Z(G,!1)):this.G.wait().then(K=>this.Z(G,!1))}async $activate(G,U){return await this.G.wait(),this.J.getExtensionDescription(G)?(await this.$(G,U),!0):!1}async $deltaExtensions(G){G.toAdd.forEach(re=>re.extensionLocation=b.URI.revive(re.extensionLocation));const{globalRegistry:U,myExtensions:K}=me(this.I,this.L,this.J,G),fe=await this.bb(K);return(await this.getExtensionPathIndex()).setSearchTree(fe),this.L.set(U.getAllExtensionDescriptions()),this.J.set(K),z.$s&&(this.s.info(`$deltaExtensions: global extensions: ${Z(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Z(this.J)}`)),Promise.resolve(void 0)}async $test_latency(G){return G}async $test_up(G){return G.byteLength}async $test_down(G){const U=$.$Fd.alloc(G),K=Math.random()%256;for(let fe=0;fe<G;fe++)U.writeUInt8(K,fe);return U}async $updateRemoteConnectionData(G){this.W=G,this.a.fire()}};e.$Kbc=q,e.$Kbc=q=H=Ke([Be(0,a.$Ah),Be(1,e.$Jbc),Be(2,f.$2L),Be(3,v.$dbc),Be(4,p.$gbc),Be(5,P.$5i),Be(6,i.$fM),Be(7,c.$wbc),Be(8,E.$rsb),Be(9,u.$ybc),Be(10,F.$Gbc),Be(11,T.$Hbc)],q);function me(we,G,U,K){we.addActivationEvents(K.addActivationEvents);const fe=new s.$t3b(we,G.getAllExtensionDescriptions());fe.deltaExtensions(K.toAdd,K.toRemove);const te=new h.$Wl(U.getAllExtensionDescriptions().map(ne=>ne.identifier));for(const ne of K.myToRemove)te.delete(ne);for(const ne of K.myToAdd)te.add(ne);const re=x(fe,te);return{globalRegistry:fe,myExtensions:re}}function X(we,G){return{id:we.identifier.value,name:we.name,extensionVersion:we.version,publisherDisplayName:we.publisher,activationEvents:we.activationEvents?we.activationEvents.join(","):null,isBuiltin:we.isBuiltin,reason:G.activationEvent,reasonId:G.extensionId.value}}function Z(we){return we.getAllExtensionDescriptions().map(G=>G.identifier.value).join(",")}e.$Lbc=(0,a.$Bh)("IExtHostExtensionService");class V{#e;#t;#i;constructor(G,U,K,fe,te){this.#e=G,this.#t=U,this.#i=K.identifier,this.id=K.identifier.value,this.extensionUri=K.extensionLocation,this.extensionPath=M.$7d((0,L.$9f)(K.extensionLocation)),this.packageJSON=K,this.extensionKind=fe,this.isFromDifferentExtensionHost=te}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Mbc=V;function x(we,G){return we.getAllExtensionDescriptions().filter(U=>G.has(U.identifier))}class ge{constructor(G){this.a=G}setSearchTree(G){this.a=G}findSubstr(G){return this.a.findSubstr(G)}forEach(G){return this.a.forEach(G)}}e.$Nbc=ge;class ue{constructor(G){this.a=new h.$Xl,this.addActivationEvents(G)}readActivationEvents(G){return this.a.get(G.identifier)}addActivationEvents(G){for(const U of Object.keys(G))this.a.set(U,G[U])}}}),define(Se[350],De([1,0,53,2,6,40,27,25,20,26,5,45,14,15]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;let v=class{constructor($,d,t,r,a,i,c){this.c=$,this.d=d,this.e=t,this.f=r,this.g=a,this.h=i,this.i=c,this.a=new Map,this.b=[]}async install(){this.j(),D.mark("code/extHost/willWaitForConfig");const $=await this.f.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const d=await this.g.getExtensionPathIndex();this.register(new s(this.c,d,this.d,$,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,d,this.h.environment.appUriScheme))}register($){if("nodeModuleName"in $)if(Array.isArray($.nodeModuleName))for(const d of $.nodeModuleName)this.a.set(d,$);else this.a.set($.nodeModuleName,$);typeof $.alternativeModuleName=="function"&&this.b.push(d=>$.alternativeModuleName(d))}};e.$$cc=v,e.$$cc=v=Ke([Be(2,P.$Ah),Be(3,L.$gbc),Be(4,I.$Lbc),Be(5,b.$fM),Be(6,p.$5i)],v);let o=class{static{C=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor($){if($.environment.appRoot&&C.a.size){const d=(0,S.$qe)(this.c($.environment.appRoot.fsPath)),t="[a-z0-9_.-]",r=`@${t}+\\/${t}+|${t}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${d}/${a}\\/)(${r})(.*)$`,"i")}}alternativeModuleName($){if(!this.b)return;const d=this.b.exec(this.c($));if(!d)return;const[,t,r,a]=d,i=C.a.get(r);if(i!==void 0)return console.warn(`${r} as been renamed to ${i}, please update your imports`),t+i+a}c($){return $.replace(/\\/g,"/")}};o=C=Ke([Be(0,b.$fM)],o);class s{constructor($,d,t,r,a){this.c=$,this.d=d,this.e=t,this.f=r,this.g=a,this.nodeModuleName="vscode",this.a=new m.$Xl}load($,d){const t=this.d.findSubstr(d);if(t){let r=this.a.get(t.identifier);return r||(r=this.c(t,this.e,this.f),this.a.set(t.identifier,r)),r}if(!this.b){let r="";this.d.forEach((a,i)=>r+=`	${i} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${d}. These are the extension path mappings: 
${r}`),this.b=this.c(R.$KF,this.e,this.f)}return this.b}}let n=class{constructor($,d,t){this.e=$,this.f=d,this.nodeModuleName=["open","opn"],this.d=t.getProxy(g.$ZJ.MainThreadTelemetry);const r=t.getProxy(g.$ZJ.MainThreadWindow);this.c=(a,i)=>{const c=M.URI.parse(a);return i?this.g(a,i):c.scheme==="http"||c.scheme==="https"?r.$openUri(c,a,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this.f?r.$openUri(c,a,{}):this.g(a,i)}}load($,d,t){const r=this.e.findSubstr(d);return r&&(this.a=r.identifier.value,this.h()),this.b=t($),this.c}g($,d){return this.i(),this.b($,d)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Ke([Be(2,k.$2L)],n)}),define(Se[55],De([1,0,59,3,16,47,5,71,72,45,7,39,278,40]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=e.$hcc=void 0,e.$hcc=(0,R.$Bh)("IExtHostVariableResolverProvider");class C extends p.$3M{constructor(s,n,h,$,d,t,r){function a(){if(h){const i=h.activeEditor();if(i)return i.document.uri;const c=$.tabGroups.all.find(f=>f.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof P.$IL||c.input instanceof P.$NL)return c.input.modified;if(c.input instanceof P.$HL||c.input instanceof P.$ML||c.input instanceof P.$KL)return c.input.uri}}}super({getFolderUri:i=>{const c=t.folders.filter(f=>f.name===i);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(i,c)=>d.getConfiguration(void 0,i).get(c),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=a();if(i)return g.$7d(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const i=a();if(i){const c=n.getWorkspaceFolder(i);if(c)return g.$7d(c.uri.fsPath)}}},getSelectedText:()=>{if(h){const i=h.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(h){const i=h.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>s.getExtension(i)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(L.env))}}let v=class extends M.$kc{constructor(s,n,h,$,d){super(),this.b=s,this.c=n,this.g=h,this.h=$,this.j=d,this.a=new D.$T(async()=>{const t=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async i=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new C(this.b,this.c,this.g,this.j,t,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$icc=v,e.$icc=v=Ke([Be(0,b.$Lbc),Be(1,I.$dbc),Be(2,m.$aM),Be(3,S.$gbc),Be(4,k.$fcc)],v)}),define(Se[95],De([1,0,9,4,2,5,6,72,45,20,7,39,140,271,40,55]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=e.$mcc=e.$lcc=e.$kcc=e.$jcc=void 0,e.$jcc=(0,L.$Bh)("IExtHostDebugService");let o=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,a,i,c,f,y){this.E=a,this.F=i,this.G=c,this.H=f,this.I=y,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new M.$fd,this.n=new M.$fd,this.o=new M.$fd,this.u=new M.$fd,this.k=r.getProxy(R.$ZJ.MainThreadDebugService),this.y=new M.$fd,this.A=new M.$fd,this.v=new n(this.k),this.w=new Map,this.F.getExtensionRegistry().then(E=>{E.onDidChange(u=>{this.J(E)}),this.J(E)})}asDebugSourceUri(r,a){const i=r;if(typeof i.sourceReference=="number"&&i.sourceReference>0){let c=`debug:${encodeURIComponent(i.path||"")}`,f="?";return a&&(c+=`${f}session=${encodeURIComponent(a.id)}`,f="&"),c+=`${f}ref=${i.sourceReference}`,g.URI.parse(c)}else{if(i.path)return g.URI.file(i.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const a=[];for(const i of r.getAllExtensionDescriptions())if(i.contributes){const c=i.contributes.debuggers;if(c&&c.length>0)for(const f of c)(0,S.$mF)(f)&&a.push(f.type)}this.k.$registerDebugTypes(a)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(a=>r.push(a)),r}addBreakpoints(r){const a=r.filter(f=>{const y=f.id;return this.w.has(y)?!1:(this.w.set(y,f),!0)});this.U(a,[],[]);const i=[],c=new Map;for(const f of a)if(f instanceof P.$2K){let y=c.get(f.location.uri.toString());y||(y={type:"sourceMulti",uri:f.location.uri,lines:[]},c.set(f.location.uri.toString(),y),i.push(y)),y.lines.push({id:f.id,enabled:f.enabled,condition:f.condition,hitCondition:f.hitCondition,logMessage:f.logMessage,line:f.location.range.start.line,character:f.location.range.start.character})}else f instanceof P.$3K&&i.push({type:"function",id:f.id,enabled:f.enabled,hitCondition:f.hitCondition,logMessage:f.logMessage,condition:f.condition,functionName:f.functionName});return this.k.$registerBreakpoints(i)}removeBreakpoints(r){const a=r.filter(y=>this.w.delete(y.id));this.U([],a,[]);const i=a.filter(y=>y instanceof P.$2K).map(y=>y.id),c=a.filter(y=>y instanceof P.$3K).map(y=>y.id),f=a.filter(y=>y instanceof P.$4K).map(y=>y.id);return this.k.$unregisterBreakpoints(i,c,f)}startDebugging(r,a,i){return this.k.$startDebugging(r?r.uri:void 0,a,{parentSessionID:i.parentSession?i.parentSession.id:void 0,lifecycleManagedByParent:i.lifecycleManagedByParent,repl:i.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:i.noDebug,compact:i.compact,suppressSaveBeforeStart:i.suppressSaveBeforeStart,suppressDebugStatusbar:i.suppressDebugStatusbar??i.debugUI?.simple,suppressDebugToolbar:i.suppressDebugToolbar??i.debugUI?.simple,suppressDebugView:i.suppressDebugView??i.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,a,i){if(!a)return new P.$2J(()=>{});const c=this.d++;return this.f.push({type:r,handle:c,provider:a}),this.k.$registerDebugConfigurationProvider(r,i,!!a.provideDebugConfigurations,!!a.resolveDebugConfiguration,!!a.resolveDebugConfigurationWithSubstitutedVariables,c),new P.$2J(()=>{this.f=this.f.filter(f=>f.provider!==a),this.k.$unregisterDebugConfigurationProvider(c)})}registerDebugAdapterDescriptorFactory(r,a,i){if(!i)return new P.$2J(()=>{});if(!this.Q(r,a))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${a}' debugger.`);if(this.N(a))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const c=this.g++;return this.h.push({type:a,handle:c,factory:i}),this.k.$registerDebugAdapterDescriptorFactory(a,c),new P.$2J(()=>{this.h=this.h.filter(f=>f.factory!==i),this.k.$unregisterDebugAdapterDescriptorFactory(c)})}registerDebugAdapterTrackerFactory(r,a){if(!a)return new P.$2J(()=>{});const i=this.i++;return this.j.push({type:r,handle:i,factory:a}),new P.$2J(()=>{this.j=this.j.filter(c=>c.factory!==a)})}async $runInTerminal(r,a){return Promise.resolve(void 0)}async $substituteVariables(r,a){let i;const c=await this.W(r);return c&&(i={uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(i,a)}K(r,a){if(r.type==="implementation")return new $(r.implementation)}L(){}async $startDASession(r,a){const i=this,c=await this.V(a);return this.S(this.N(c.type),c).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}' (extension might have failed to activate)`);const y=this.M(f),E=this.K(y,c);if(!E)throw new Error(`Couldn't create a debug adapter for type '${c.type}'.`);const u=E;return this.B.set(r,u),this.R(c).then(l=>(l&&this.C.set(r,l),u.onMessage(async w=>{if(w.type==="request"&&w.command==="handshake"){const A=w,N={type:"response",seq:0,command:A.command,request_seq:A.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const O=await this.D.sign(A.arguments.value);N.body={signature:O},u.sendResponse(N)}else throw new Error("no signer")}catch(O){N.success=!1,N.message=O.message,u.sendResponse(N)}}else l&&l.onDidSendMessage&&l.onDidSendMessage(w),w=(0,S.$rF)(w,!0),i.k.$acceptDAMessage(r,w)}),u.onError(w=>{l&&l.onError&&l.onError(w),this.k.$acceptDAError(r,w.name,w.message,w.stack)}),u.onExit(w=>{l&&l.onExit&&l.onExit(w??void 0,void 0),this.k.$acceptDAExit(r,w??void 0,void 0)}),l&&l.onWillStartSession&&l.onWillStartSession(),u.startSession()))})}$sendDAMessage(r,a){a=(0,S.$qF)(a,!1);const i=this.C.get(r);i&&i.onWillReceiveMessage&&i.onWillReceiveMessage(a),this.B.get(r)?.sendMessage(a)}$stopDASession(r){const a=this.C.get(r);this.C.delete(r),a&&a.onWillStopSession&&a.onWillStopSession();const i=this.B.get(r);return this.B.delete(r),i?i.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const a=[],i=[],c=[];if(r.added)for(const f of r.added){const y=f.id;if(y&&!this.w.has(y)){let E;if(f.type==="function")E=new P.$3K(f.functionName,f.enabled,f.condition,f.hitCondition,f.logMessage);else if(f.type==="data")E=new P.$4K(f.label,f.dataId,f.canPersist,f.enabled,f.hitCondition,f.condition,f.logMessage);else{const u=g.URI.revive(f.uri);E=new P.$2K(new P.$bK(u,new P.$3J(f.line,f.character)),f.enabled,f.condition,f.hitCondition,f.logMessage)}(0,P.$ZK)(E,y),this.w.set(y,E),a.push(E)}}if(r.removed)for(const f of r.removed){const y=this.w.get(f);y&&(this.w.delete(f),i.push(y))}if(r.changed){for(const f of r.changed)if(f.id){const y=this.w.get(f.id);if(y){if(y instanceof P.$3K&&f.type==="function"){const E=y;E.enabled=f.enabled,E.condition=f.condition,E.hitCondition=f.hitCondition,E.logMessage=f.logMessage,E.functionName=f.functionName}else if(y instanceof P.$2K&&f.type==="source"){const E=y;E.enabled=f.enabled,E.condition=f.condition,E.hitCondition=f.hitCondition,E.logMessage=f.logMessage,E.location=new P.$bK(g.URI.revive(f.uri),new P.$3J(f.line,f.character))}c.push(y)}}}this.U(a,i,c)}async $acceptStackFrameFocus(r){let a;const i=r.sessionId?await this.V(r.sessionId):void 0;if(!i)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?a=new P.$0K(i,r.threadId):a=new P.$9K(i,r.threadId,r.frameId),this.z=a,this.A.fire(this.z)}$provideDebugConfigurations(r,a,i){return(0,D.$zg)(async()=>{const c=this.P(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const f=await this.W(a);return c.provideDebugConfigurations(f,i)}).then(c=>{if(!c)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return c})}$resolveDebugConfiguration(r,a,i,c){return(0,D.$zg)(async()=>{const f=this.P(r);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const y=await this.W(a);return f.resolveDebugConfiguration(y,i,c)})}$resolveDebugConfigurationWithSubstitutedVariables(r,a,i,c){return(0,D.$zg)(async()=>{const f=this.P(r);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const y=await this.W(a);return f.resolveDebugConfigurationWithSubstitutedVariables(y,i,c)})}async $provideDebugAdapter(r,a){const i=this.O(r);if(!i)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const c=await this.V(a);return this.S(i,c).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}'`);return this.M(f)})}async $acceptDebugSessionStarted(r){const a=await this.V(r);this.m.fire(a)}async $acceptDebugSessionTerminated(r){const a=await this.V(r);a&&(this.n.fire(a),this.l.delete(a.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,a){(await this.V(r))?._acceptNameChanged(a)}async $acceptDebugSessionCustomEvent(r,a){const c={session:await this.V(r),event:a.event,body:a.body};this.u.fire(c)}M(r){if(r instanceof P.$5K)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof P.$6K)return{type:"server",port:r.port,host:r.host};if(r instanceof P.$7K)return{type:"pipeServer",path:r.path};if(r instanceof P.$8K)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const a=this.h.filter(i=>i.type===r);if(a.length>0)return a[0].factory}O(r){const a=this.h.filter(i=>i.handle===r);if(a.length>0)return a[0].factory}P(r){const a=this.f.filter(i=>i.handle===r);if(a.length>0)return a[0].provider}Q(r,a){if(r.contributes){const i=r.contributes.debuggers;if(i&&i.length>0){for(const c of i)if(c.label&&c.type&&c.type===a)return!0}}return!1}R(r){const i=r.configuration.type,c=this.j.filter(f=>f.type===i||f.type==="*").map(f=>(0,D.$zg)(()=>f.factory.createDebugAdapterTracker(r)).then(y=>y,y=>null));return Promise.race([Promise.all(c).then(f=>{const y=f.filter(E=>!!E);if(y.length>0)return new h(y)}),new Promise(f=>setTimeout(()=>f(void 0),1e3))]).catch(f=>{})}async S(r,a){const i=a.configuration.debugServer;if(typeof i=="number")return Promise.resolve(new P.$6K(i));if(r){const f=await this.F.getExtensionRegistry();return(0,D.$zg)(()=>r.createDebugAdapterDescriptor(a,this.T(a,f))).then(y=>{if(y)return y})}const c=await this.F.getExtensionRegistry();return Promise.resolve(this.T(a,c))}T(r,a){}U(r,a,i){(r.length>0||a.length>0||i.length>0)&&this.y.fire(Object.freeze({added:r,removed:a,changed:i}))}async V(r){if(r)if(typeof r=="string"){const a=this.l.get(r);if(a)return a}else{let a=this.l.get(r.id);if(!a){const i=await this.W(r.folderUri),c=r.parent?this.l.get(r.parent):void 0;a=new s(this.k,r.id,r.type,r.name,i,r.configuration,c),this.l.set(a.id,a),this.k.$sessionCached(a.id)}return a}throw new Error("cannot find session")}W(r){if(r){const a=g.URI.revive(r);return this.E.resolveWorkspaceFolder(a)}return Promise.resolve(void 0)}};e.$kcc=o,e.$kcc=o=Ke([Be(0,b.$2L),Be(1,I.$dbc),Be(2,k.$Lbc),Be(3,C.$gbc),Be(4,m.$fcc),Be(5,v.$hcc)],o);class s{constructor(r,a,i,c,f,y,E){this.d=r,this.f=a,this.g=i,this.h=c,this.i=f,this.j=y,this.k=E}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,a){return this.d.$customDebugAdapterRequest(this.f,r,a)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$lcc=s;class n{constructor(r){this.value=Object.freeze({append(a){r.$appendDebugConsole(a)},appendLine(a){this.append(a+`
`)}})}}e.$mcc=n;class h{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(a=>a.onWillReceiveMessage?a.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(a=>a.onDidSendMessage?a.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(a=>a.onError?a.onError(r):void 0)}onExit(r,a){this.d.forEach(i=>i.onExit?i.onExit(r,a):void 0)}}class $ extends p.$Ccb{constructor(r){super(),this.h=r,r.onDidSendMessage(a=>{this.acceptMessage(a)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let d=class extends o{constructor(r,a,i,c,f,y){super(r,a,i,c,f,y)}};e.$ncc=d,e.$ncc=d=Ke([Be(0,b.$2L),Be(1,I.$dbc),Be(2,k.$Lbc),Be(3,C.$gbc),Be(4,m.$fcc),Be(5,v.$hcc)],d)}),define(Se[351],De([1,0,8,53,2,6,342,14,104,105,26,238,20,68,45,89]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=e.$_cc=void 0;class o{static async installEarlyHandler(h){Error.stackTraceLimit=100;const $=h.get(m.$5i),t=h.get(p.$2L).getProxy(L.$ZJ.MainThreadErrors);D.setUnexpectedErrorHandler(r=>{$.error(r);const a=D.$1(r);t.$onUnexpectedError(a)})}static async installFullHandler(h){const $=h.get(m.$5i),d=h.get(p.$2L),t=h.get(C.$Lbc),r=h.get(v.$jM),a=d.getProxy(L.$ZJ.MainThreadExtensionService),i=d.getProxy(L.$ZJ.MainThreadErrors),c=await t.getExtensionPathIndex(),f=new WeakMap;function y(l,w){if(f.has(l))return f.get(l).stack;let A="",N,O;for(const j of w)A+=`
	at ${j.toString()}`,O=j.getFileName(),!N&&O&&(N=c.findSubstr(g.URI.file(O)));const F=`${l.name||"Error"}: ${l.message||""}${A}`;return f.set(l,{extensionIdentifier:N?.identifier,stack:F}),F}const E=Symbol("prepareStackTrace wrapped");let u=y;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return u},set(l){if(l===y||!l||l[E]){u=l||y;return}u=function(w,A){return y(w,A),l.call(Error,w,A)},Object.assign(u,{[E]:!0})}}),D.setUnexpectedErrorHandler(l=>{$.error(l);const w=D.$1(l),A=f.get(l);if(!A?.extensionIdentifier){i.$onUnexpectedError(w);return}a.$onExtensionRuntimeError(A.extensionIdentifier,w);const N=r.onExtensionError(A.extensionIdentifier,l);$.trace("forwarded error to extension?",N,A)})}}e.$_cc=o;class s{constructor(h,$,d,t,r){this.a=d,this.b=new R.$C3b(h,null,t),$=s.e($,this.b);const a=new b.$zh(...(0,k.$nr)());a.set(P.$fM,{_serviceBrand:void 0,...$,messagePorts:r}),a.set(p.$2L,new p.$3L(this.b)),a.set(S.$abc,new S.$bbc(t)),a.set(C.$Jbc,d);const i=new I.$6p(a,!0);i.invokeFunction(o.installEarlyHandler),this.d=i.invokeFunction(c=>c.get(m.$5i)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",$),this.c=i.invokeFunction(c=>c.get(C.$Lbc)),this.c.initialize(),i.invokeFunction(o.installFullHandler)}async asBrowserUri(h){const $=this.b.getProxy(L.$ZJ.MainThreadExtensionService);return g.URI.revive(await $.$asBrowserUri(h))}terminate(h){this.c.terminate(h)}static e(h,$){h.extensions.allExtensions.forEach(t=>{t.extensionLocation=g.URI.revive($.transformIncomingURIs(t.extensionLocation))}),h.environment.appRoot=g.URI.revive($.transformIncomingURIs(h.environment.appRoot));const d=h.environment.extensionDevelopmentLocationURI;return d&&(h.environment.extensionDevelopmentLocationURI=d.map(t=>g.URI.revive($.transformIncomingURIs(t)))),h.environment.extensionTestsLocationURI=g.URI.revive($.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=g.URI.revive($.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=g.URI.revive($.transformIncomingURIs(h.environment.workspaceStorageHome)),h.environment.extensionTelemetryLogResource=g.URI.revive($.transformIncomingURIs(h.environment.extensionTelemetryLogResource)),h.nlsBaseUrl=g.URI.revive($.transformIncomingURIs(h.nlsBaseUrl)),h.logsLocation=g.URI.revive($.transformIncomingURIs(h.logsLocation)),h.workspace=$.transformIncomingURIs(h.workspace),h}}e.$adc=s}),define(Se[352],De([1,0,9,12,215,232,138,95,72,45,20,44,7,55,39,272,273,40]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=void 0;let n=class extends m.$kcc{constructor(r,a,i,c,f,y,E){super(r,a,i,c,y,E),this.Z=f,this.X=new d}K(r,a){switch(r.type){case"server":return new v.$fdc(r);case"pipeServer":return new v.$gdc(r);case"executable":return new v.$hdc(r,a.type)}return super.K(r,a)}T(r,a){const i=v.$hdc.platformAdapterExecutable(a.getAllExtensionDescriptions(),r.type);if(i)return new p.$5K(i.command,i.args,i.options)}L(){return new R.$e7b}async $runInTerminal(r,a){if(r.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(F=>{this.X.onTerminalClosed(F)}));const i=await this.G.getConfigProvider(),c=this.Z.getDefaultShell(!0),f=this.Z.getDefaultShellArgs(!0),y=r.title||g.localize(0,null),E=JSON.stringify({shell:c,shellArgs:f});let u=await this.X.checkout(E,y),l,w=!1;if(u)l=r.cwd;else{const F={shellPath:c,shellArgs:f,cwd:r.cwd,name:y,iconPath:new p.$WK("debug")};w=!0,u=this.Z.createTerminalFromOptions(F,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(u,E)}u.show(!0);const A=await u.processId;w?await new Promise(F=>setTimeout(F,1e3)):i.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0||c.indexOf("cmd.exe")>=0?u.sendText("cls"):c.indexOf("bash")>=0?u.sendText("clear"):M.$i?u.sendText("cls"):u.sendText("clear"));const N=(0,o.$jdc)(c,r.args,!!r.argsCanBeInterpretedByShell,l,r.env);u.sendText(N);const O=this.onDidTerminateDebugSession(F=>{F.id===a&&(this.X.free(u),O.dispose())});return A}else if(r.kind==="external")return $(r,await this.G.getConfigProvider());return super.$runInTerminal(r,a)}};e.$kdc=n,e.$kdc=n=Ke([Be(0,P.$2L),Be(1,C.$dbc),Be(2,b.$Lbc),Be(3,s.$gbc),Be(4,I.$ybc),Be(5,k.$fcc),Be(6,S.$hcc)],n);let h;function $(t,r){if(!h)if(M.$i)h=new L.$Z5b;else if(M.$j)h=new L.$15b;else if(M.$k)h=new L.$25b;else throw new Error("external terminals not supported on this platform");const a=r.getConfiguration("terminal");return h.runInTerminal(t.title,t.cwd,t.args,t.env||{},a.external||{})}class d{constructor(){this.b=new Map}static{this.a=1e3}async checkout(r,a){const c=[...this.b.entries()].map(([f,y])=>(0,D.$ug)(async E=>{if(f.name!==a||y.lastUsedAt!==-1&&await(0,o.$idc)(await f.processId))return null;const u=Date.now();return y.lastUsedAt+d.a>u||E.isCancellationRequested||y.config!==r?null:(y.lastUsedAt=u,f)}));return await(0,D.$Lg)(c,f=>!!f)}insert(r,a){this.b.set(r,{lastUsedAt:Date.now(),config:a})}free(r){const a=this.b.get(r);a&&(a.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}}),define(Se[353],De([1,0,16,2,102,39,71,40,43,44,20,26,94,17,14,90,24,64,55]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=void 0;let h=class extends p.$ccc{constructor(d,t,r,a,i,c,f,y,E){super(d,t,r,a,i,c,f,y),this.B=r,this.C=E,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(S.Schemas.vscodeRemote,{scheme:S.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(S.Schemas.file,{scheme:S.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(d,t){const r=t;if(!t.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const a=p.TaskHandleDTO.from(r,this.B),i=await this.a.$getTaskExecution(a);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.y(i,t);return this.a.$executeTask(a).catch(()=>{}),c}else{const a=p.TaskDTO.from(t,d);if(a===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(a.execution)&&await this.x(a,t,!1);const i=await this.y(await this.a.$getTaskExecution(a),t);return this.a.$executeTask(a).catch(()=>{}),i}}u(d,t,r,a){const i=[];if(a)for(const c of a){this.z(c,r),(!c.definition||!d[c.definition.type])&&this.f.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const f=p.TaskDTO.from(c,r.extension);f&&(i.push(f),p.CustomExecutionDTO.is(f.execution)&&t.push(this.x(f,c,!0)))}return{tasks:i,extension:r.extension}}async v(d){return d}async F(d){let t=d&&d.length>0?d[0]:void 0;if(!t){const r=M.URI.file((0,s.homedir)());t=new k.$Vh({uri:r,name:o.$fg(r),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(d,t){const r=M.URI.revive(d),a={process:void 0,variables:Object.create(null)},i=await this.b.resolveWorkspaceFolder(r),c=await this.b.getWorkspaceFolders2()??[],f=await this.C.getResolver(),y=i?{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(c);for(const E of t.variables)a.variables[E]=await f.resolveAsync(y,E);if(t.process!==void 0){let E;if(t.process.path!==void 0){E=t.process.path.split(D.$ge);for(let u=0;u<E.length;u++)E[u]=await f.resolveAsync(y,E[u])}a.process=await g.win32.findExecutable(await f.resolveAsync(y,t.process.name),t.process.cwd!==void 0?await f.resolveAsync(y,t.process.cwd):void 0,E)}return a}async $jsonTasksSupported(){return!0}async $findExecutable(d,t,r){return g.win32.findExecutable(d,t,r)}};e.$cdc=h,e.$cdc=h=Ke([Be(0,P.$2L),Be(1,I.$fM),Be(2,L.$dbc),Be(3,R.$aM),Be(4,m.$gbc),Be(5,b.$ybc),Be(6,C.$5i),Be(7,v.$6ac),Be(8,n.$hcc)],h)}),define(Se[354],De([1,0,64,55]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=void 0;class g extends M.$icc{m(){return(0,D.homedir)()}}e.$Udc=g}),define(Se[153],De([1,0,19,9,21,46,17,16,24,2,36]),function($e,e,D,M,g,L,R,m,k,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=e.$rcc=e.$qcc=e.$pcc=void 0;class I{constructor(n,h,$,d){this.d=n,this.e=h,this.f=$,this.g=d,this.a=null,this.b=!1,this.c=0}search(n,h){const $=this.d.folderQueries||[],d=new g.$pd(h);return new Promise((t,r)=>{this.a=new S(n);let a=!1;const i=(c,f)=>{if(!a&&!this.b){const y=this.h(c);v(c)&&typeof this.d.maxResults=="number"&&this.c+y>this.d.maxResults&&(this.b=!0,a=!0,d.cancel(),c=this.j(c,this.d.maxResults-this.c));const E=this.h(c);this.c+=E,(E>0||!v(c))&&this.a.add(c,f)}};Promise.all($.map((c,f)=>this.k(c,y=>i(y,f),d.token))).then(c=>{d.dispose(),this.a.flush();const f=c.some(y=>!!y&&!!y.limitHit);t({limitHit:this.b||f,messages:(0,D.$Pb)(c.map(y=>y?.message?Array.isArray(y.message)?y.message:[y.message]:[])),stats:{type:this.g}})},c=>{d.dispose();const f=(0,L.$mi)(c);r(new Error(f))})})}h(n){return v(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,h){const $=Array.isArray(n.ranges)?n.ranges:[n.ranges],d=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:$.slice(0,h),preview:{matches:d.slice(0,h),text:n.preview.text},uri:n.uri}}async k(n,h,$){const d=new P.$GI(this.d,n),t=[],r={report:c=>{if(!this.l(c))return;const f=n.folder.scheme===R.Schemas.file?(0,P.$HI)(()=>this.f.readdir(k.$hg(c.uri))):void 0,y=k.$kg(n.folder,c.uri);if(y){const E=d.includedInQuery(y,m.$ae(y),f);(0,M.$tg)(E)?t.push(E.then(u=>{u&&h(c)})):E&&h(c)}}},a=this.n(n),i=await this.e.provideTextSearchResults(p(this.d.contentPattern),a,r,$);return t.length&&await Promise.all(t),i}l(n){if(v(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const h=(0,P.$FI)(this.d.includePattern,n.includePattern),$=(0,P.$FI)(this.d.excludePattern,n.excludePattern),d={folder:b.URI.from(n.folder),excludes:$,includes:h,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.f.toCanonicalName(n.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return d.usePCRE2=this.d.usePCRE2,d}}e.$pcc=I;function p(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class S{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new o(512,h=>this.g(h))}add(n,h){this.d&&(this.b!==h||!k.$bg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=h,this.d={resource:n.uri,results:[]}),this.d.results.push(C(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$qcc=S;function C(s){return v(s)?{preview:{matches:(0,D.$Zb)(s.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:s.preview.text},ranges:(0,D.$Zb)(s.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function v(s){return!!s.preview}e.$rcc=v;class o{static{this.a=4e3}static{this.b=50}constructor(n,h){this.g=n,this.h=h,this.c=0,this.d=[],this.e=0}addItem(n,h){n&&this.j(n,h)}addItems(n,h){n&&this.k(n,h)}j(n,h){this.d.push(n),this.e+=h,this.l()}k(n,h){this.d=this.d.concat(n),this.e+=h,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$scc=o}),define(Se[96],De([1,0,3,6,5,347,20,68,14,2,153]),function($e,e,D,M,g,L,R,m,k,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=e.$ucc=e.$tcc=void 0,e.$tcc=(0,g.$Bh)("IExtHostSearch");let I=class{constructor(v,o,s){this.k=v,this.l=o,this.n=s,this.c=this.k.getProxy(M.$ZJ.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$occ}o(v){return this.l.transformOutgoingScheme(v)}registerTextSearchProvider(v,o){if(this.g.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this.g.add(v);const s=this.d++;return this.e.set(s,o),this.c.$registerTextSearchProvider(s,this.o(v)),(0,D.$ic)(()=>{this.g.delete(v),this.e.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(v,o){if(this.i.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this.i.add(v);const s=this.d++;return this.h.set(s,o),this.c.$registerFileSearchProvider(s,this.o(v)),(0,D.$ic)(()=>{this.i.delete(v),this.h.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(v,o,s,n){const h=p(s),$=this.h.get(v);if($)return this.j.fileSearch(h,$,d=>{this.c.$handleFileMatch(v,o,d.map(t=>t.resource))},n);throw new Error("unknown provider: "+v)}$clearCache(v){return this.j.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,o,s,n){const h=this.e.get(v);if(!h||!h.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const $=p(s);return this.q($,h).search(t=>this.c.$handleTextMatch(v,o,t),n)}$enableExtensionHostSearch(){}q(v,o){return new P.$pcc(v,o,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.$ucc=I,e.$ucc=I=Ke([Be(0,R.$2L),Be(1,m.$abc),Be(2,k.$5i)],I);function p(C){return{...C,folderQueries:C.folderQueries&&C.folderQueries.map(S),extraFileResources:C.extraFileResources&&C.extraFileResources.map(v=>b.URI.revive(v))}}e.$vcc=p;function S(C){return{...C,folder:b.URI.revive(C.folder)}}}),define(Se[355],De([1,0,21,8,4,38,2,130,125,168,185,30,6,111,302,301,33,303,40,305,306,307,280,308,71,45,310,311,316,317,318,152,284,324,325,327,115,44,329,287,13,7,85,332,92,151,39,25,276,315,67,149,94,95,96,14,68,20,26,319,274,74,90,294,330,91,73,335,333,334,295,54,328,331,114,72,89,320,93,321,17,134,283,263,313,3,27,270,112,257,322,323,296,312,282,314,113,326,298,299,300,293,309,297]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o,s,n,h,$,d,t,r,a,i,c,f,y,E,u,l,w,A,N,O,F,j,z,T,H,q,me,X,Z,V,x,ge,ue,we,G,U,K,fe,te,re,ne,Ee,oe,he,ee,le,be,Ie,B,Q,ie,se,Y,de,ye,je,We,_e,Ye,it,et,Ae,Oe,Ve,Le,Ze,ce,ae,Ce,qe,Ue,Xe,rt,at,$t,St,Zt,qt,vt,Nt,jt,Jt,At,Rt,zt,Bt,Ht,Wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7cc=void 0;function Vt(ot){const ft=ot.get(oe.$fM),Lt=ot.get(je.$3ac),Ft=ot.get(ie.$vbc),It=ot.get(i.$Lbc),dt=ot.get(x.$dbc),kt=ot.get(et.$jM),Dt=ot.get(n.$gbc),Mt=ot.get(ne.$abc),Ge=ot.get(Ee.$2L),Fe=ot.get(F.$rbc),Me=ot.get(Q.$wbc),Pe=ot.get(re.$6i),_=ot.get(re.$5i),Te=ot.get(le.$rsb),He=ot.get(be.$6ac),xe=ot.get(V.$0bc),Je=ot.get(Ye.$Dbc),nt=ot.get(it.$fcc),bt=ot.get(jt.$Hbc);Ge.set(p.$1J.ExtHostFileSystemInfo,Lt),Ge.set(p.$1J.ExtHostLogLevelServiceShape,Pe),Ge.set(p.$1J.ExtHostWorkspace,dt),Ge.set(p.$1J.ExtHostConfiguration,Dt),Ge.set(p.$1J.ExtHostExtensionService,It),Ge.set(p.$1J.ExtHostStorage,Fe),Ge.set(p.$1J.ExtHostTunnelService,Te),Ge.set(p.$1J.ExtHostWindow,xe),Ge.set(p.$1J.ExtHostSecretState,Je),Ge.set(p.$1J.ExtHostTelemetry,kt),Ge.set(p.$1J.ExtHostEditorTabs,nt),Ge.set(p.$1J.ExtHostManagedSockets,bt);const Pt=Ge.set(p.$1J.ExtHostDecorations,ot.get(U.$bcc)),wt=Ge.set(p.$1J.ExtHostDocumentsAndEditors,ot.get(a.$aM)),lt=Ge.set(p.$1J.ExtHostCommands,ot.get(o.$lM)),mt=Ge.set(p.$1J.ExtHostTerminalService,ot.get(j.$ybc)),yt=Ge.set(p.$1J.ExtHostDebugService,ot.get(fe.$jcc)),gi=Ge.set(p.$1J.ExtHostSearch,ot.get(te.$tcc)),Kt=Ge.set(p.$1J.ExtHostTask,ot.get(K.$ecc)),Yt=Ge.set(p.$1J.ExtHostOutputService,ot.get(l.$Tbc)),si=Ge.set(p.$1J.ExtHostLocalization,ot.get(rt.$Gbc)),ki=Ge.set(p.$1J.ExtHostUrls,new X.$3bc(Ge)),Ct=Ge.set(p.$1J.ExtHostDocuments,new r.$1ac(Ge,wt)),Yi=Ge.set(p.$1J.ExtHostDocumentContentProviders,new d.$ibc(Ge,wt,_)),un=Ge.set(p.$1J.ExtHostDocumentSaveParticipant,new t.$jbc(_,Ct,Ge.getProxy(p.$ZJ.MainThreadBulkEdits))),pt=Ge.set(p.$1J.ExtHostNotebook,new he.$zcc(Ge,lt,wt,Ct,Ft)),mi=Ge.set(p.$1J.ExtHostNotebookDocuments,new ae.$Rcc(pt)),$i=Ge.set(p.$1J.ExtHostNotebookEditors,new ce.$Qcc(_,pt)),oi=Ge.set(p.$1J.ExtHostNotebookKernels,new Ae.$Ncc(Ge,ft,pt,lt,_)),Si=Ge.set(p.$1J.ExtHostNotebookRenderers,new Ve.$Pcc(Ge,pt)),Di=Ge.set(p.$1J.ExtHostNotebookDocumentSaveParticipant,new vt.$Xcc(_,pt,Ge.getProxy(p.$ZJ.MainThreadBulkEdits))),Tt=Ge.set(p.$1J.ExtHostEditors,new z.$1bc(Ge,wt)),bi=Ge.set(p.$1J.ExtHostTreeViews,new T.$2bc(Ge.getProxy(p.$ZJ.MainThreadTreeViews),lt,_)),Ci=Ge.set(p.$1J.ExtHostEditorInsets,new ue.$$bc(Ge.getProxy(p.$ZJ.MainThreadEditorInsets),Tt,ft.remote)),ai=Ge.set(p.$1J.ExtHostDiagnostics,new h.$5ac(Ge,_,Lt,wt)),ci=Ge.set(p.$1J.ExtHostLanguages,new E.$Qbc(Ge,Ct,lt.converter,Mt)),ut=Ge.set(p.$1J.ExtHostLanguageFeatures,new y.$9ac(Ge,Mt,Ct,lt,ai,_,He,kt)),Ii=Ge.set(p.$1J.ExtHostFileSystem,new c.$Obc(Ge,ut)),Xt=Ge.set(p.$1J.ExtHostFileSystemEventService,new f.$Pbc(Ge,_,wt)),ii=Ge.set(p.$1J.ExtHostQuickOpen,(0,A.$Vbc)(Ge,dt,lt)),pi=Ge.set(p.$1J.ExtHostSCM,new N.$Xbc(Ge,lt,Ct,_)),Xi=Ge.set(p.$1J.ExtHostQuickDiff,new St.$Ucc(Ge,Mt)),Pi=Ge.set(p.$1J.ExtHostShare,new Jt.$Zcc(Ge,Mt)),Ai=Ge.set(p.$1J.ExtHostComments,(0,s.$_ac)(Ge,lt,Ct)),Ri=Ge.set(p.$1J.ExtHostProgress,new w.$Ubc(Ge.getProxy(p.$ZJ.MainThreadProgress))),xi=Ge.set(p.$1J.ExtHosLabelService,new we.$_bc(Ge)),Li=Ge.set(p.$1J.ExtHostTheming,new ee.$Acc(Ge)),ui=Ge.set(p.$1J.ExtHostAuthentication,new Ie.$Bcc(Ge)),_i=Ge.set(p.$1J.ExtHostTimeline,new B.$Dcc(Ge,lt)),Fi=Ge.set(p.$1J.ExtHostWebviews,new Z.$6bc(Ge,ft.remote,dt,_,He)),Mi=Ge.set(p.$1J.ExtHostWebviewPanels,new de.$Fcc(Ge,Fi,dt)),Ti=Ge.set(p.$1J.ExtHostCustomEditors,new Y.$Gcc(Ge,Ct,Me,Fi,Mi)),Oi=Ge.set(p.$1J.ExtHostWebviewViews,new se.$Ecc(Ge,Fi)),hi=Ge.set(p.$1J.ExtHostTesting,new We.$Icc(Ge,lt,wt)),ln=Ge.set(p.$1J.ExtHostUriOpeners,new _e.$Mcc(Ge)),en=Ge.set(p.$1J.ExtHostProfileContentHandlers,new $t.$Tcc(Ge));Ge.set(p.$1J.ExtHostInteractive,new Ce.$Scc(Ge,pt,wt,lt,_));const Ni=Ge.set(p.$1J.ExtHostInlineChat,new qt.$Wcc(Ge,lt,Ct,_)),di=Ge.set(p.$1J.ExtHostChatProvider,new At.$1cc(Ge,_)),tn=Ge.set(p.$1J.ExtHostChatSlashCommands,new Rt.$2cc(Ge,di,_)),nn=Ge.set(p.$1J.ExtHostChatAgents,new Wt.$6cc(Ge,di,_)),hn=Ge.set(p.$1J.ExtHostChatVariables,new zt.$3cc(Ge)),ni=Ge.set(p.$1J.ExtHostChat,new Zt.$Vcc(Ge,_)),ji=Ge.set(p.$1J.ExtHostAiRelatedInformation,new Bt.$4cc(Ge)),_t=Ge.set(p.$1J.ExtHostAiEmbeddingVector,new Ht.$5cc(Ge)),wi=Ge.set(p.$1J.ExtHostIssueReporter,new Nt.$Ycc(Ge)),rn=Ge.set(p.$1J.ExtHostStatusBar,new O.$Zbc(Ge,lt.converter)),Gt=Object.values(p.$1J);Ge.assertRegistered(Gt);const vi=new ye.$Hcc(Ge,wt),sn=new v.$$ac(Ge),yi=new u.$Rbc(Ge,_),zi=new $.$hbc(Ge);return C.$0ac.register(lt),function(ze,ei,Ui){const gt=function(){let pe=!ze.isUnderDevelopment;function ke(){pe||(_.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),pe=!0)}return function Ne(st){if(Array.isArray(st))st.forEach(Ne);else if(typeof st=="string")ke();else{const Et=st;typeof Et.scheme>"u"&&ke(),typeof Et.exclusive=="boolean"&&(0,Ue.$QF)(ze,"documentFiltersExclusive")}return st}}(),dn={getSession(pe,ke,Ne){return ui.getSession(ze,pe,ke,Ne)},getSessions(pe,ke){return(0,Ue.$QF)(ze,"authGetSessions"),ui.getSessions(ze,pe,ke)},async hasSession(pe,ke){return(0,Ue.$QF)(ze,"authSession"),!!await ui.getSession(ze,pe,ke,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(pe,ke,Ne,st){return ui.registerAuthenticationProvider(pe,ke,Ne,st)}},fn={registerCommand(pe,ke,Ne){return lt.registerCommand(!0,pe,ke,Ne,void 0,ze)},registerTextEditorCommand(pe,ke,Ne){return lt.registerCommand(!0,pe,(...st)=>{const Et=Tt.getActiveTextEditor();if(!Et){_.warn("Cannot execute "+pe+" because there is no active text editor.");return}return Et.edit(Ot=>{ke.apply(Ne,[Et,Ot,...st])}).then(Ot=>{Ot||_.warn("Edits from command "+pe+" were not applied.")},Ot=>{_.warn("An error occurred while running command "+pe,Ot)})},void 0,void 0,ze)},registerDiffInformationCommand:(pe,ke,Ne)=>((0,Ue.$QF)(ze,"diffCommand"),lt.registerCommand(!0,pe,async(...st)=>{const Et=wt.activeEditor(!0);if(!Et){_.warn("Cannot execute "+pe+" because there is no active text editor.");return}const Ot=await Tt.getDiffInformation(Et.id);ke.apply(Ne,[Ot,...st])},void 0,void 0,ze)),executeCommand(pe,...ke){return lt.executeCommand(pe,...ke)},getCommands(pe=!1){return lt.getCommands(pe)}},Ei={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return mt.getDefaultShell(!1)},get onDidChangeShell(){return mt.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ue.$QF)(ze,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ue.$QF)(ze,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.$iM)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(pe,ke){return et.$hM.validateSender(pe),kt.instantiateLogger(ze,pe,ke)},openExternal(pe,ke){return xe.openUri(pe,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(pe){if(pe.scheme===ft.environment.appUriScheme)return ki.createAppUri(pe);try{return await xe.asExternalUri(pe,{allowTunneling:!!ft.remote.authority})}catch(ke){if((0,Ze.$MT)(pe,Le.Schemas.http)||(0,Ze.$MT)(pe,Le.Schemas.https))return pe;throw ke}},get remoteName(){return(0,G.$Pk)(ft.remote.authority)},get remoteAuthority(){return(0,Ue.$QF)(ze,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return _.getLevel()},get onDidChangeLogLevel(){return _.onDidChangeLogLevel},registerIssueUriRequestHandler(pe){return(0,Ue.$QF)(ze,"handleIssueUri"),wi.registerIssueUriRequestHandler(ze,pe)},get appQuality(){return(0,Ue.$QF)(ze,"resolvers"),ft.quality},get appCommit(){return(0,Ue.$QF)(ze,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze(Ei);const on={createTestController(pe,ke,Ne){return hi.createTestController(ze,pe,ke,Ne)},createTestObserver(){return(0,Ue.$QF)(ze,"testObserver"),hi.createTestObserver()},runTests(pe){return(0,Ue.$QF)(ze,"testObserver"),hi.runTests(pe)},get onDidChangeTestResults(){return(0,Ue.$QF)(ze,"testObserver"),hi.onResultsChanged},get testResults(){return(0,Ue.$QF)(ze,"testObserver"),hi.results}},fi=ft.remote.isRemote?q.ExtensionKind.Workspace:q.ExtensionKind.UI,an={getExtension(pe,ke){(0,Ue.$PF)(ze,"extensionsAny")||(ke=!1);const Ne=ei.mine.getExtensionDescription(pe);if(Ne)return new i.$Mbc(It,ze.identifier,Ne,fi,!1);if(ke){const st=ei.all.getExtensionDescription(pe);if(st)return new i.$Mbc(It,ze.identifier,st,fi,!0)}},get all(){const pe=[];for(const ke of ei.mine.getAllExtensionDescriptions())pe.push(new i.$Mbc(It,ze.identifier,ke,fi,!1));return pe},get allAcrossExtensionHosts(){(0,Ue.$QF)(ze,"extensionsAny");const pe=new ge.$Wl(ei.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),ke=[];for(const Ne of ei.all.getAllExtensionDescriptions()){const st=!pe.has(Ne.identifier);ke.push(new i.$Mbc(It,ze.identifier,Ne,fi,st))}return ke},get onDidChange(){return(0,Ue.$PF)(ze,"extensionsAny")?g.Event.any(ei.mine.onDidChange,ei.all.onDidChange):ei.mine.onDidChange}},gn={createDiagnosticCollection(pe){return ai.createDiagnosticCollection(ze.identifier,pe)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:pe=>ai.getDiagnostics(pe),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(pe,ke){return ci.changeLanguage(pe.uri,ke)},match(pe,ke){const Ne=Ct.getDocumentData(ke.uri)?.notebook;return(0,P.$cF)(H.LanguageSelector.from(pe),ke.uri,ke.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(pe,ke,Ne){return ut.registerCodeActionProvider(ze,gt(pe),ke,Ne)},registerDocumentPasteEditProvider(pe,ke,Ne){return(0,Ue.$QF)(ze,"documentPaste"),ut.registerDocumentPasteEditProvider(ze,gt(pe),ke,Ne)},registerCodeLensProvider(pe,ke){return ut.registerCodeLensProvider(ze,gt(pe),ke)},registerDefinitionProvider(pe,ke){return ut.registerDefinitionProvider(ze,gt(pe),ke)},registerDeclarationProvider(pe,ke){return ut.registerDeclarationProvider(ze,gt(pe),ke)},registerImplementationProvider(pe,ke){return ut.registerImplementationProvider(ze,gt(pe),ke)},registerTypeDefinitionProvider(pe,ke){return ut.registerTypeDefinitionProvider(ze,gt(pe),ke)},registerHoverProvider(pe,ke){return ut.registerHoverProvider(ze,gt(pe),ke,ze.identifier)},registerEvaluatableExpressionProvider(pe,ke){return ut.registerEvaluatableExpressionProvider(ze,gt(pe),ke,ze.identifier)},registerInlineValuesProvider(pe,ke){return ut.registerInlineValuesProvider(ze,gt(pe),ke,ze.identifier)},registerDocumentHighlightProvider(pe,ke){return ut.registerDocumentHighlightProvider(ze,gt(pe),ke)},registerLinkedEditingRangeProvider(pe,ke){return ut.registerLinkedEditingRangeProvider(ze,gt(pe),ke)},registerReferenceProvider(pe,ke){return ut.registerReferenceProvider(ze,gt(pe),ke)},registerRenameProvider(pe,ke){return ut.registerRenameProvider(ze,gt(pe),ke)},registerDocumentSymbolProvider(pe,ke,Ne){return ut.registerDocumentSymbolProvider(ze,gt(pe),ke,Ne)},registerWorkspaceSymbolProvider(pe){return ut.registerWorkspaceSymbolProvider(ze,pe)},registerDocumentFormattingEditProvider(pe,ke){return ut.registerDocumentFormattingEditProvider(ze,gt(pe),ke)},registerDocumentRangeFormattingEditProvider(pe,ke){return ut.registerDocumentRangeFormattingEditProvider(ze,gt(pe),ke)},registerOnTypeFormattingEditProvider(pe,ke,Ne,...st){return ut.registerOnTypeFormattingEditProvider(ze,gt(pe),ke,[Ne].concat(st))},registerDocumentSemanticTokensProvider(pe,ke,Ne){return ut.registerDocumentSemanticTokensProvider(ze,gt(pe),ke,Ne)},registerDocumentRangeSemanticTokensProvider(pe,ke,Ne){return ut.registerDocumentRangeSemanticTokensProvider(ze,gt(pe),ke,Ne)},registerSignatureHelpProvider(pe,ke,Ne,...st){return typeof Ne=="object"?ut.registerSignatureHelpProvider(ze,gt(pe),ke,Ne):ut.registerSignatureHelpProvider(ze,gt(pe),ke,typeof Ne>"u"?[]:[Ne,...st])},registerCompletionItemProvider(pe,ke,...Ne){return ut.registerCompletionItemProvider(ze,gt(pe),ke,Ne)},registerInlineCompletionItemProvider(pe,ke,Ne){return ke.handleDidShowCompletionItem&&(0,Ue.$QF)(ze,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,Ue.$QF)(ze,"inlineCompletionsAdditions"),Ne&&(0,Ue.$QF)(ze,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(ze,gt(pe),ke,Ne)},registerDocumentLinkProvider(pe,ke){return ut.registerDocumentLinkProvider(ze,gt(pe),ke)},registerColorProvider(pe,ke){return ut.registerColorProvider(ze,gt(pe),ke)},registerFoldingRangeProvider(pe,ke){return ut.registerFoldingRangeProvider(ze,gt(pe),ke)},registerSelectionRangeProvider(pe,ke){return ut.registerSelectionRangeProvider(ze,pe,ke)},registerCallHierarchyProvider(pe,ke){return ut.registerCallHierarchyProvider(ze,pe,ke)},registerTypeHierarchyProvider(pe,ke){return ut.registerTypeHierarchyProvider(ze,pe,ke)},setLanguageConfiguration:(pe,ke)=>ut.setLanguageConfiguration(ze,pe,ke),getTokenInformationAtPosition(pe,ke){return(0,Ue.$QF)(ze,"tokenInformation"),ci.tokenAtPosition(pe,ke)},registerInlayHintsProvider(pe,ke){return ut.registerInlayHintsProvider(ze,pe,ke)},createLanguageStatusItem(pe,ke){return ci.createLanguageStatusItem(ze,pe,ke)},registerDocumentDropEditProvider(pe,ke,Ne){return ut.registerDocumentOnDropEditProvider(ze,pe,ke,(0,Ue.$PF)(ze,"dropMetadata")?Ne:void 0)}},mn={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return mt.activeTerminal},get terminals(){return mt.terminals},async showTextDocument(pe,ke,Ne){const st=await(R.URI.isUri(pe)?Promise.resolve(Bi.openTextDocument(pe)):Promise.resolve(pe));return Tt.showTextDocument(st,ke,Ne)},createTextEditorDecorationType(pe){return Tt.createTextEditorDecorationType(ze,pe)},onDidChangeActiveTextEditor(pe,ke,Ne){return Tt.onDidChangeActiveTextEditor(pe,ke,Ne)},onDidChangeVisibleTextEditors(pe,ke,Ne){return Tt.onDidChangeVisibleTextEditors(pe,ke,Ne)},onDidChangeTextEditorSelection(pe,ke,Ne){return Tt.onDidChangeTextEditorSelection(pe,ke,Ne)},onDidChangeTextEditorOptions(pe,ke,Ne){return Tt.onDidChangeTextEditorOptions(pe,ke,Ne)},onDidChangeTextEditorVisibleRanges(pe,ke,Ne){return Tt.onDidChangeTextEditorVisibleRanges(pe,ke,Ne)},onDidChangeTextEditorViewColumn(pe,ke,Ne){return Tt.onDidChangeTextEditorViewColumn(pe,ke,Ne)},onDidCloseTerminal(pe,ke,Ne){return mt.onDidCloseTerminal(pe,ke,Ne)},onDidOpenTerminal(pe,ke,Ne){return mt.onDidOpenTerminal(pe,ke,Ne)},onDidChangeActiveTerminal(pe,ke,Ne){return mt.onDidChangeActiveTerminal(pe,ke,Ne)},onDidChangeTerminalDimensions(pe,ke,Ne){return(0,Ue.$QF)(ze,"terminalDimensions"),mt.onDidChangeTerminalDimensions(pe,ke,Ne)},onDidChangeTerminalState(pe,ke,Ne){return mt.onDidChangeTerminalState(pe,ke,Ne)},onDidWriteTerminalData(pe,ke,Ne){return(0,Ue.$QF)(ze,"terminalDataWriteEvent"),mt.onDidWriteTerminalData(pe,ke,Ne)},onDidExecuteTerminalCommand(pe,ke,Ne){return(0,Ue.$QF)(ze,"terminalExecuteCommandEvent"),mt.onDidExecuteTerminalCommand(pe,ke,Ne)},get state(){return xe.getState(ze)},onDidChangeWindowState(pe,ke,Ne){return xe.onDidChangeWindowState(pe,ke,Ne)},showInformationMessage(pe,...ke){return yi.showMessage(ze,L.default.Info,pe,ke[0],ke.slice(1))},showWarningMessage(pe,...ke){return yi.showMessage(ze,L.default.Warning,pe,ke[0],ke.slice(1))},showErrorMessage(pe,...ke){return yi.showMessage(ze,L.default.Error,pe,ke[0],ke.slice(1))},showQuickPick(pe,ke,Ne){return ii.showQuickPick(ze,pe,ke,Ne)},showWorkspaceFolderPick(pe){return ii.showWorkspaceFolderPick(pe)},showInputBox(pe,ke){return ii.showInput(pe,ke)},showOpenDialog(pe){return zi.showOpenDialog(ze,pe)},showSaveDialog(pe){return zi.showSaveDialog(pe)},createStatusBarItem(pe,ke,Ne){let st,Et,Ot;return typeof pe=="string"?(st=pe,Et=ke,Ot=Ne):(Et=pe,Ot=ke),rn.createStatusBarEntry(ze,st,Et,Ot)},setStatusBarMessage(pe,ke){return rn.setStatusBarMessage(pe,ke)},withScmProgress(pe){return He.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Ri.withProgress(ze,{location:q.ProgressLocation.SourceControl},(ke,Ne)=>pe({report(st){}}))},withProgress(pe,ke){return Ri.withProgress(ze,pe,ke)},createOutputChannel(pe,ke){return Yt.createOutputChannel(pe,ke,ze)},createWebviewPanel(pe,ke,Ne,st){return Mi.createWebviewPanel(ze,pe,ke,Ne,st)},createWebviewTextEditorInset(pe,ke,Ne,st){return(0,Ue.$QF)(ze,"editorInsets"),Ci.createWebviewEditorInset(pe,ke,Ne,st,ze)},createTerminal(pe,ke,Ne){return typeof pe=="object"?"pty"in pe?mt.createExtensionTerminal(pe):mt.createTerminalFromOptions(pe):mt.createTerminal(pe,ke,Ne)},registerTerminalLinkProvider(pe){return mt.registerLinkProvider(pe)},registerTerminalProfileProvider(pe,ke){return mt.registerProfileProvider(ze,pe,ke)},registerTerminalQuickFixProvider(pe,ke){return(0,Ue.$QF)(ze,"terminalQuickFixProvider"),mt.registerTerminalQuickFixProvider(pe,ze.identifier.value,ke)},registerTreeDataProvider(pe,ke){return bi.registerTreeDataProvider(pe,ke,ze)},createTreeView(pe,ke){return bi.createTreeView(pe,ke,ze)},registerWebviewPanelSerializer:(pe,ke)=>Mi.registerWebviewPanelSerializer(ze,pe,ke),registerCustomEditorProvider:(pe,ke,Ne={})=>Ti.registerCustomEditorProvider(ze,pe,ke,Ne),registerFileDecorationProvider(pe){return Pt.registerFileDecorationProvider(pe,ze)},registerUriHandler(pe){return ki.registerUriHandler(ze,pe)},createQuickPick(){return ii.createQuickPick(ze)},createInputBox(){return ii.createInputBox(ze)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(pe,ke,Ne){return Li.onDidChangeActiveColorTheme(pe,ke,Ne)},registerWebviewViewProvider(pe,ke,Ne){return Oi.registerWebviewViewProvider(ze,pe,ke,Ne?.webviewOptions)},get activeNotebookEditor(){return pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(pe,ke,Ne){return pt.onDidChangeActiveNotebookEditor(pe,ke,Ne)},get visibleNotebookEditors(){return pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(pe,ke,Ne){return $i.onDidChangeNotebookEditorSelection(pe,ke,Ne)},onDidChangeNotebookEditorVisibleRanges(pe,ke,Ne){return $i.onDidChangeNotebookEditorVisibleRanges(pe,ke,Ne)},showNotebookDocument(pe,ke){return pt.showNotebookDocument(pe,ke)},registerExternalUriOpener(pe,ke,Ne){return(0,Ue.$QF)(ze,"externalUriOpener"),ln.registerExternalUriOpener(ze.identifier,pe,ke,Ne)},registerProfileContentHandler(pe,ke){return(0,Ue.$QF)(ze,"profileContentHandlers"),en.registrProfileContentHandler(ze,pe,ke)},registerQuickDiffProvider(pe,ke,Ne,st){return(0,Ue.$QF)(ze,"quickDiffProvider"),Xi.registerQuickDiffProvider(gt(pe),ke,Ne,st)},get tabGroups(){return nt.tabGroups},registerShareProvider(pe,ke){return(0,Ue.$QF)(ze,"shareProvider"),Pi.registerShareProvider(gt(pe),ke)}},Bi={get rootPath(){return He.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(pe){throw new M.$7("rootPath")},getWorkspaceFolder(pe){return dt.getWorkspaceFolder(pe)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(pe){throw new M.$7("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(pe){throw new M.$7("workspaceFile")},updateWorkspaceFolders:(pe,ke,...Ne)=>dt.updateWorkspaceFolders(ze,pe,ke||0,...Ne),onDidChangeWorkspaceFolders:function(pe,ke,Ne){return dt.onDidChangeWorkspace(pe,ke,Ne)},asRelativePath:(pe,ke)=>dt.getRelativePath(pe,ke),findFiles:(pe,ke,Ne,st)=>dt.findFiles(pe,ke,Ne,ze.identifier,st),findTextInFiles:(pe,ke,Ne,st)=>{(0,Ue.$QF)(ze,"findTextInFiles");let Et,Ot;return typeof ke=="object"?(Et=ke,Ot=Ne):(Et={},Ot=ke,st=Ne),dt.findTextInFiles(pe,Et||{},Ot,ze.identifier,st)},save:pe=>((0,Ue.$QF)(ze,"saveEditor"),dt.save(pe)),saveAs:pe=>((0,Ue.$QF)(ze,"saveEditor"),dt.saveAs(pe)),saveAll:pe=>dt.saveAll(pe),applyEdit(pe,ke){return vi.applyWorkspaceEdit(pe,ze,ke)},createFileSystemWatcher:(pe,ke,Ne,st)=>Xt.createFileSystemWatcher(dt,ze,pe,ke,Ne,st),get textDocuments(){return Ct.getAllDocumentData().map(pe=>pe.document)},set textDocuments(pe){throw new M.$7("textDocuments")},openTextDocument(pe){let ke;const Ne=pe;if(typeof pe=="string")ke=Promise.resolve(R.URI.file(pe));else if(R.URI.isUri(pe))ke=Promise.resolve(pe);else if(!Ne||typeof Ne=="object")ke=Ct.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(st=>Ct.ensureDocumentData(st).then(Et=>Et.document))},onDidOpenTextDocument:(pe,ke,Ne)=>Ct.onDidAddDocument(pe,ke,Ne),onDidCloseTextDocument:(pe,ke,Ne)=>Ct.onDidRemoveDocument(pe,ke,Ne),onDidChangeTextDocument:(pe,ke,Ne)=>Ct.onDidChangeDocument(pe,ke,Ne),onDidSaveTextDocument:(pe,ke,Ne)=>Ct.onDidSaveDocument(pe,ke,Ne),onWillSaveTextDocument:(pe,ke,Ne)=>un.getOnWillSaveTextDocumentEvent(ze)(pe,ke,Ne),get notebookDocuments(){return pt.notebookDocuments.map(pe=>pe.apiNotebook)},async openNotebookDocument(pe,ke){let Ne;if(R.URI.isUri(pe))Ne=pe,await pt.openNotebookDocument(pe);else if(typeof pe=="string")Ne=R.URI.revive(await pt.createNotebookDocument({viewType:pe,content:ke}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(pe,ke,Ne){return mi.onDidSaveNotebookDocument(pe,ke,Ne)},onDidChangeNotebookDocument(pe,ke,Ne){return mi.onDidChangeNotebookDocument(pe,ke,Ne)},onWillSaveNotebookDocument(pe,ke,Ne){return Di.getOnWillSaveNotebookDocumentEvent(ze)(pe,ke,Ne)},get onDidOpenNotebookDocument(){return pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return pt.onDidCloseNotebookDocument},registerNotebookSerializer(pe,ke,Ne,st){return pt.registerNotebookSerializer(ze,pe,ke,Ne,(0,Ue.$PF)(ze,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(pe,ke,Ne)=>Ui.onDidChangeConfiguration(pe,ke,Ne),getConfiguration(pe,ke){return ke=arguments.length===1?void 0:ke,Ui.getConfiguration(pe,ke,ze)},registerTextDocumentContentProvider(pe,ke){return Yi.registerTextDocumentContentProvider(pe,ke)},registerTaskProvider:(pe,ke)=>(He.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Kt.registerTaskProvider(ze,pe,ke)),registerFileSystemProvider(pe,ke,Ne){return(0,qe.$hc)(Ii.registerFileSystemProvider(ze,pe,ke,Ne),Ft.addFileSystemProvider(pe,ke,Ne))},get fs(){return Ft.value},registerFileSearchProvider:(pe,ke)=>((0,Ue.$QF)(ze,"fileSearchProvider"),gi.registerFileSearchProvider(pe,ke)),registerTextSearchProvider:(pe,ke)=>((0,Ue.$QF)(ze,"textSearchProvider"),gi.registerTextSearchProvider(pe,ke)),registerRemoteAuthorityResolver:(pe,ke)=>((0,Ue.$QF)(ze,"resolvers"),It.registerRemoteAuthorityResolver(pe,ke)),registerResourceLabelFormatter:pe=>((0,Ue.$QF)(ze,"resolvers"),xi.$registerResourceLabelFormatter(pe)),getRemoteExecServer:pe=>((0,Ue.$QF)(ze,"resolvers"),It.getRemoteExecServer(pe)),onDidCreateFiles:(pe,ke,Ne)=>Xt.onDidCreateFile(pe,ke,Ne),onDidDeleteFiles:(pe,ke,Ne)=>Xt.onDidDeleteFile(pe,ke,Ne),onDidRenameFiles:(pe,ke,Ne)=>Xt.onDidRenameFile(pe,ke,Ne),onWillCreateFiles:(pe,ke,Ne)=>Xt.getOnWillCreateFileEvent(ze)(pe,ke,Ne),onWillDeleteFiles:(pe,ke,Ne)=>Xt.getOnWillDeleteFileEvent(ze)(pe,ke,Ne),onWillRenameFiles:(pe,ke,Ne)=>Xt.getOnWillRenameFileEvent(ze)(pe,ke,Ne),openTunnel:pe=>((0,Ue.$QF)(ze,"tunnels"),Te.openTunnel(ze,pe).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,Ue.$QF)(ze,"tunnels"),Te.getTunnels()},onDidChangeTunnels:(pe,ke,Ne)=>((0,Ue.$QF)(ze,"tunnels"),Te.onDidChangeTunnels(pe,ke,Ne)),registerPortAttributesProvider:(pe,ke)=>((0,Ue.$QF)(ze,"portsAttributes"),Te.registerPortsAttributesProvider(pe,ke)),registerTunnelProvider:(pe,ke)=>((0,Ue.$QF)(ze,"tunnelFactory"),Te.registerTunnelProvider(pe,ke)),registerTimelineProvider:(pe,ke)=>((0,Ue.$QF)(ze,"timeline"),_i.registerTimelineProvider(pe,ke,ze.identifier,lt.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:pe=>((0,Ue.$QF)(ze,"workspaceTrust"),dt.requestWorkspaceTrust(pe)),onDidGrantWorkspaceTrust:(pe,ke,Ne)=>dt.onDidGrantWorkspaceTrust(pe,ke,Ne),registerEditSessionIdentityProvider:(pe,ke)=>((0,Ue.$QF)(ze,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(pe,ke)),onWillCreateEditSessionIdentity:(pe,ke,Ne)=>((0,Ue.$QF)(ze,"editSessionIdentityProvider"),dt.getOnWillCreateEditSessionIdentityEvent(ze)(pe,ke,Ne)),registerCanonicalUriProvider:(pe,ke)=>((0,Ue.$QF)(ze,"canonicalUriProvider"),dt.registerCanonicalUriProvider(pe,ke)),getCanonicalUri:(pe,ke,Ne)=>((0,Ue.$QF)(ze,"canonicalUriProvider"),dt.provideCanonicalUri(pe,ke,Ne))},cn={get inputBox(){return He.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),pi.getLastInputBox(ze)},createSourceControl(pe,ke,Ne){return pi.createSourceControl(ze,pe,ke,Ne)}},Wi={createCommentController(pe,ke){return Ai.createCommentController(ze,pe,ke)}},Vi={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},get stackFrameFocus(){return yt.stackFrameFocus},onDidStartDebugSession(pe,ke,Ne){return yt.onDidStartDebugSession(pe,ke,Ne)},onDidTerminateDebugSession(pe,ke,Ne){return yt.onDidTerminateDebugSession(pe,ke,Ne)},onDidChangeActiveDebugSession(pe,ke,Ne){return yt.onDidChangeActiveDebugSession(pe,ke,Ne)},onDidReceiveDebugSessionCustomEvent(pe,ke,Ne){return yt.onDidReceiveDebugSessionCustomEvent(pe,ke,Ne)},onDidChangeBreakpoints(pe,ke,Ne){return yt.onDidChangeBreakpoints(pe,ke,Ne)},onDidChangeStackFrameFocus(pe,ke,Ne){return(0,Ue.$QF)(ze,"debugFocus"),yt.onDidChangeStackFrameFocus(pe,ke,Ne)},registerDebugConfigurationProvider(pe,ke,Ne){return yt.registerDebugConfigurationProvider(pe,ke,Ne||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(pe,ke){return yt.registerDebugAdapterDescriptorFactory(ze,pe,ke)},registerDebugAdapterTrackerFactory(pe,ke){return yt.registerDebugAdapterTrackerFactory(pe,ke)},startDebugging(pe,ke,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?yt.startDebugging(pe,ke,{parentSession:Ne}):yt.startDebugging(pe,ke,Ne||{})},stopDebugging(pe){return yt.stopDebugging(pe)},addBreakpoints(pe){return yt.addBreakpoints(pe)},removeBreakpoints(pe){return yt.removeBreakpoints(pe)},asDebugSourceUri(pe,ke){return yt.asDebugSourceUri(pe,ke)}},qi={registerTaskProvider:(pe,ke)=>Kt.registerTaskProvider(ze,pe,ke),fetchTasks:pe=>Kt.fetchTasks(pe),executeTask:pe=>Kt.executeTask(ze,pe),get taskExecutions(){return Kt.taskExecutions},onDidStartTask:(pe,ke,Ne)=>Kt.onDidStartTask(pe,ke,Ne),onDidEndTask:(pe,ke,Ne)=>Kt.onDidEndTask(pe,ke,Ne),onDidStartTaskProcess:(pe,ke,Ne)=>Kt.onDidStartTaskProcess(pe,ke,Ne),onDidEndTaskProcess:(pe,ke,Ne)=>Kt.onDidEndTaskProcess(pe,ke,Ne)},li={createNotebookController(pe,ke,Ne,st,Et){return oi.createNotebookController(ze,pe,ke,Ne,st,(0,Ue.$PF)(ze,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(pe,ke)=>pt.registerNotebookCellStatusBarItemProvider(ze,pe,ke),createRendererMessaging(pe){return Si.createRendererMessaging(ze,pe)},createNotebookControllerDetectionTask(pe){return(0,Ue.$QF)(ze,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(ze,pe)},registerKernelSourceActionProvider(pe,ke){return(0,Ue.$QF)(ze,"notebookKernelSource"),oi.registerKernelSourceActionProvider(ze,pe,ke)},onDidChangeNotebookCellExecutionState(pe,ke,Ne){return(0,Ue.$QF)(ze,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(pe,ke,Ne)}},Hi={t(...pe){if(typeof pe[0]=="string"){const ke=pe.shift(),Ne=!pe||typeof pe[0]!="object"?pe:pe[0];return si.getMessage(ze.identifier.value,{message:ke,args:Ne})}return si.getMessage(ze.identifier.value,pe[0])},get bundle(){return si.getBundle(ze.identifier.value)},get uri(){return si.getBundleUri(ze.identifier.value)}},Ki={_version:1,registerInteractiveEditorSessionProvider(pe,ke){return(0,Ue.$QF)(ze,"interactive"),Ni.registerProvider(ze,pe,ke={label:ke?.label??ze.displayName??ze.name})},registerInteractiveSessionProvider(pe,ke){return(0,Ue.$QF)(ze,"interactive"),ni.registerChatProvider(ze,pe,ke)},addInteractiveRequest(pe){return(0,Ue.$QF)(ze,"interactive"),ni.addChatRequest(pe)},sendInteractiveRequestToProvider(pe,ke){return(0,Ue.$QF)(ze,"interactive"),ni.sendInteractiveRequestToProvider(pe,ke)},get onDidPerformUserAction(){return(0,Ue.$QF)(ze,"interactiveUserActions"),ni.onDidPerformUserAction},transferChatSession(pe,ke){return(0,Ue.$QF)(ze,"interactive"),ni.transferChatSession(pe,ke)}},Ji={getRelatedInformation(pe,ke){return(0,Ue.$QF)(ze,"aiRelatedInformation"),ji.getRelatedInformation(ze,pe,ke)},registerRelatedInformationProvider(pe,ke){return(0,Ue.$QF)(ze,"aiRelatedInformation"),ji.registerRelatedInformationProvider(ze,pe,ke)},registerEmbeddingVectorProvider(pe,ke){return(0,Ue.$QF)(ze,"aiRelatedInformation"),_t.registerEmbeddingVectorProvider(ze,pe,ke)}},Gi={registerChatResponseProvider(pe,ke,Ne){return(0,Ue.$QF)(ze,"chatProvider"),di.registerProvider(ze.identifier,pe,ke,Ne)},registerSlashCommand(pe,ke,Ne){return(0,Ue.$QF)(ze,"chatSlashCommands"),tn.registerCommand(ze.identifier,pe,ke,Ne??{description:""})},requestChatAccess(pe){return(0,Ue.$QF)(ze,"chatRequestAccess"),di.requestChatResponseProvider(ze.identifier,pe)},registerVariable(pe,ke,Ne){return(0,Ue.$QF)(ze,"chatVariables"),hn.registerVariableResolver(ze,pe,ke,Ne)},registerMappedEditsProvider(pe,ke){return(0,Ue.$QF)(ze,"mappedEditsProvider"),ut.registerMappedEditsProvider(ze,pe,ke)},registerAgent(pe,ke,Ne){return(0,Ue.$QF)(ze,"chatAgents"),nn.registerAgent(ze.identifier,pe,ke,Ne)}};return{version:ft.version,ai:Ji,authentication:dn,commands:fn,comments:Wi,chat:Gi,debug:Vi,env:Ei,extensions:an,interactive:Ki,l10n:Hi,languages:gn,notebooks:li,scm:cn,tasks:qi,tests:on,window:mn,workspace:Bi,Breakpoint:q.$1K,TerminalOutputAnchor:q.TerminalOutputAnchor,ChatMessage:q.$QL,ChatMessageRole:q.ChatMessageRole,ChatVariableLevel:q.ChatVariableLevel,CallHierarchyIncomingCall:q.$nK,CallHierarchyItem:q.$mK,CallHierarchyOutgoingCall:q.$oK,CancellationError:M.$3,CancellationTokenSource:D.$pd,CandidatePortSource:p.CandidatePortSource,CodeAction:q.$iK,CodeActionKind:q.$jK,CodeActionTriggerKind:q.CodeActionTriggerKind,CodeLens:q.$pK,Color:q.$CK,ColorInformation:q.$DK,ColorPresentation:q.$EK,ColorThemeKind:q.ColorThemeKind,CommentMode:q.CommentMode,CommentState:q.CommentState,CommentThreadCollapsibleState:q.CommentThreadCollapsibleState,CommentThreadState:q.CommentThreadState,CompletionItem:q.$wK,CompletionItemKind:q.CompletionItemKind,CompletionItemTag:q.CompletionItemTag,CompletionList:q.$xK,CompletionTriggerKind:q.CompletionTriggerKind,ConfigurationTarget:q.ConfigurationTarget,CustomExecution:q.$MK,DebugAdapterExecutable:q.$5K,DebugAdapterInlineImplementation:q.$8K,DebugAdapterNamedPipeServer:q.$7K,DebugAdapterServer:q.$6K,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:q.DebugConsoleMode,DecorationRangeBehavior:q.DecorationRangeBehavior,Diagnostic:q.$dK,DiagnosticRelatedInformation:q.$cK,DiagnosticSeverity:q.DiagnosticSeverity,DiagnosticTag:q.DiagnosticTag,Disposable:q.$2J,DocumentHighlight:q.$fK,DocumentHighlightKind:q.DocumentHighlightKind,DocumentLink:q.$BK,DocumentSymbol:q.$hK,EndOfLine:q.EndOfLine,EnvironmentVariableMutatorType:q.EnvironmentVariableMutatorType,EvaluatableExpression:q.$$K,InlineValueText:q.$_K,InlineValueVariableLookup:q.$aL,InlineValueEvaluatableExpression:q.$bL,InlineCompletionTriggerKind:q.InlineCompletionTriggerKind,EventEmitter:g.$fd,ExtensionKind:q.ExtensionKind,ExtensionMode:q.ExtensionMode,ExternalUriOpenerPriority:q.ExternalUriOpenerPriority,FileChangeType:q.FileChangeType,FileDecoration:q.$lL,FileDecoration2:q.$lL,FileSystemError:q.$dL,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:q.$eL,FoldingRangeKind:q.FoldingRangeKind,FunctionBreakpoint:q.$3K,InlineCompletionItem:q.$yK,InlineCompletionList:q.$zK,Hover:q.$eK,IndentAction:b.IndentAction,Location:q.$bK,MarkdownString:q.$qK,OverviewRulerLane:k.OverviewRulerLane,ParameterInformation:q.$rK,PortAutoForwardAction:q.PortAutoForwardAction,Position:q.$3J,ProcessExecution:q.$KK,ProgressLocation:q.ProgressLocation,QuickInputButtons:q.$kL,Range:q.$4J,RelativePattern:q.$YK,Selection:q.$5J,SelectionRange:q.$lK,SemanticTokens:q.$hL,SemanticTokensBuilder:q.$gL,SemanticTokensEdit:q.$iL,SemanticTokensEdits:q.$jL,SemanticTokensLegend:q.$fL,ShellExecution:q.$LK,ShellQuoting:q.ShellQuoting,SignatureHelp:q.$tK,SignatureHelpTriggerKind:q.SignatureHelpTriggerKind,SignatureInformation:q.$sK,SnippetString:q.$aK,SourceBreakpoint:q.$2K,StandardTokenType:q.StandardTokenType,StatusBarAlignment:q.StatusBarAlignment,SymbolInformation:q.$gK,SymbolKind:q.SymbolKind,SymbolTag:q.SymbolTag,Task:q.$NK,TaskGroup:q.$JK,TaskPanelKind:q.TaskPanelKind,TaskRevealKind:q.TaskRevealKind,TaskScope:q.TaskScope,TerminalLink:q.$FK,TerminalQuickFixExecuteTerminalCommand:q.$HK,TerminalQuickFixOpener:q.$GK,TerminalLocation:q.TerminalLocation,TerminalProfile:q.$IK,TerminalExitReason:q.TerminalExitReason,TextDocumentSaveReason:q.TextDocumentSaveReason,TextEdit:q.$9J,SnippetTextEdit:q.$$J,TextEditorCursorStyle:m.TextEditorCursorStyle,TextEditorLineNumbersStyle:q.TextEditorLineNumbersStyle,TextEditorRevealType:q.TextEditorRevealType,TextEditorSelectionChangeKind:q.TextEditorSelectionChangeKind,TextDocumentChangeReason:q.TextDocumentChangeReason,ThemeColor:q.$XK,ThemeIcon:q.$WK,TreeItem:q.$OK,TreeItemCheckboxState:q.TreeItemCheckboxState,TreeItemCollapsibleState:q.TreeItemCollapsibleState,TypeHierarchyItem:q.$GL,UIKind:S.UIKind,Uri:R.URI,ViewColumn:q.ViewColumn,WorkspaceEdit:q.$_J,DocumentDropEdit:q.$UK,DocumentPasteEdit:q.$VK,InlayHint:q.$vK,InlayHintLabelPart:q.$uK,InlayHintKind:q.InlayHintKind,RemoteAuthorityResolverError:q.$8J,ResolvedAuthority:q.$6J,ManagedResolvedAuthority:q.$7J,SourceControlInputBoxValidationType:q.SourceControlInputBoxValidationType,ExtensionRuntime:q.ExtensionRuntime,TimelineItem:q.$vL,NotebookRange:q.$nL,NotebookCellKind:q.NotebookCellKind,NotebookCellExecutionState:q.NotebookCellExecutionState,NotebookCellData:q.$oL,NotebookData:q.$pL,NotebookRendererScript:q.$tL,NotebookCellStatusBarAlignment:q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:q.NotebookEditorRevealType,NotebookCellOutput:q.$rL,NotebookCellOutputItem:q.$qL,NotebookCellStatusBarItem:q.$sL,NotebookControllerAffinity:q.NotebookControllerAffinity,NotebookControllerAffinity2:q.NotebookControllerAffinity2,NotebookEdit:q.$0J,NotebookKernelSourceAction:q.$uL,PortAttributes:q.$xL,LinkedEditingRanges:q.$wL,TestResultState:q.TestResultState,TestRunRequest:q.$yL,TestMessage:q.$zL,TestMessage2:q.$zL,TestTag:q.$AL,TestRunProfileKind:q.TestRunProfileKind,TextSearchCompleteMessageType:Oe.TextSearchCompleteMessageType,DataTransfer:q.$TK,DataTransferItem:q.$PK,CoveredCount:q.$BL,FileCoverage:q.$CL,StatementCoverage:q.$DL,BranchCoverage:q.$EL,FunctionCoverage:q.$FL,WorkspaceTrustState:q.WorkspaceTrustState,LanguageStatusSeverity:q.LanguageStatusSeverity,QuickPickItemKind:q.QuickPickItemKind,InputBoxValidationSeverity:q.InputBoxValidationSeverity,TabInputText:q.$HL,TabInputTextDiff:q.$IL,TabInputTextMerge:q.$JL,TabInputCustom:q.$KL,TabInputNotebook:q.$ML,TabInputNotebookDiff:q.$NL,TabInputWebview:q.$LL,TabInputTerminal:q.$OL,TabInputInteractiveWindow:q.$PL,TelemetryTrustedValue:me.$_n,LogLevel:re.LogLevel,EditSessionIdentityMatch:at.EditSessionIdentityMatch,InteractiveSessionVoteDirection:q.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:q.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:q.InteractiveEditorResponseFeedbackKind,StackFrameFocus:q.$9K,ThreadFocus:q.$0K,NotebookCodeActionKind:q.$kK,RelatedInformationType:q.RelatedInformationType}}}e.$7cc=Vt}),define(Se[356],De([1,0,104,152,39,149,40,33,71,44,94,95,96,115,74,90,151,73,54,114,89,72,150,14,55,112,113]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o,s,n,h,$,d,t,r,a,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$mr)(i.$Gbc,i.$Fbc,1),(0,D.$mr)(r.$6i,t.$8cc,1),(0,D.$mr)(v.$6ac,v.$7ac,1),(0,D.$mr)(m.$lM,m.$kM,0),(0,D.$mr)(R.$gbc,R.$ebc,0),(0,D.$mr)(s.$vbc,s.$ubc,0),(0,D.$mr)(I.$jcc,I.$ncc,0),(0,D.$mr)(L.$bcc,L.$acc,0),(0,D.$mr)(k.$aM,k.$_L,0),(0,D.$mr)(c.$Hbc,c.$Ibc,0),(0,D.$mr)(n.$3ac,n.$2ac,0),(0,D.$mr)(M.$Tbc,M.$Sbc,1),(0,D.$mr)(p.$tcc,p.$ucc,0),(0,D.$mr)(S.$rbc,S.$qbc,0),(0,D.$mr)(P.$ecc,P.$dcc,0),(0,D.$mr)(b.$ybc,b.$Bbc,0),(0,D.$mr)(C.$rsb,C.$ssb,0),(0,D.$mr)(o.$0bc,o.$9bc,0),(0,D.$mr)(g.$dbc,g.$cbc,0),(0,D.$mr)(h.$Dbc,h.$Cbc,0),(0,D.$mr)($.$jM,$.$gM,0),(0,D.$mr)(d.$fcc,d.$gcc,0),(0,D.$mr)(a.$hcc,a.$icc,0)}),define(Se[116],De([1,0,19,14,36,93]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=e.$mdc=e.$ldc=void 0;function R(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.$ldc=R;function m(I,p,S,C){const v=(0,D.$Zb)(S,k),o=new g.$sI(p,v,C),s=o.preview.matches;return{ranges:(0,D.$Zb)(v,b),uri:I,preview:{text:o.preview.text,matches:(0,D.$Zb)(s,b)}}}e.$mdc=m;function k(I){return new g.$tI(I.start.line,I.start.character,I.end.line,I.end.character)}function b(I){return new L.$hI(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let P=class{constructor(p,S){this.a=p,this.b=S}appendLine(p){this.b.debug(`${this.a}#search`,p)}};e.$ndc=P,e.$ndc=P=Ke([Be(1,M.$5i)],P)}),define(Se[357],De([1,0,48,16,77,32,12,15,116,358]),function($e,e,D,M,g,L,R,m,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=e.$pdc=e.$odc=void 0;const P=b.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(h,$,d,t){const r=p(h,$,d,t),a=$.folder.fsPath;return{cmd:D.spawn(P,r.args,{cwd:a}),rgDiskPath:P,siblingClauses:r.siblingClauses,rgArgs:r,cwd:a}}e.$odc=I;function p(h,$,d,t){const r=["--files","--hidden","--case-sensitive","--no-require-git"];C([$],d,!1).forEach(i=>{const c=(0,k.$ldc)(i);if(r.push("-g",c),R.$j){const f=(0,g.$il)(c);f!==c&&r.push("-g",f)}});const a=S([$],t,void 0,!1);return a.globArgs.forEach(i=>{const c=`!${(0,k.$ldc)(i)}`;if(r.push("-g",c),R.$j){const f=(0,g.$il)(c);f!==c&&r.push("-g",f)}}),$.disregardIgnoreFiles!==!1?r.push("--no-ignore"):$.disregardParentIgnoreFiles!==!1&&r.push("--no-ignore-parent"),$.ignoreSymlinks||r.push("--follow"),h.exists&&r.push("--quiet"),r.push("--no-config"),$.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:a.siblingClauses}}function S(h,$,d,t=!0){const r=[];let a={};return h.forEach(i=>{const c=Object.assign({},i.excludePattern||{},$||{}),f=v(c,t?i.folder.fsPath:void 0,d);r.push(...f.globArgs),f.siblingClauses&&(a=Object.assign(a,f.siblingClauses))}),{globArgs:r,siblingClauses:a}}function C(h,$,d=!0){const t=[];return h.forEach(r=>{const a=Object.assign({},$||{},r.includePattern||{}),i=v(a,d?r.folder.fsPath:void 0);t.push(...i.globArgs)}),t}function v(h,$,d){const t=[],r={};return Object.keys(h).forEach(a=>{if(d&&d.has(a)||!a)return;const i=h[a];a=s($?o($,a):a),a.startsWith("\\\\")?a="\\\\"+a.substr(2).replace(/\\/g,"/"):a=a.replace(/\\/g,"/"),typeof i=="boolean"&&i?(a.startsWith("\\\\")&&(a+="**"),t.push(n(a))):i&&i.when&&(r[a]=i)}),{globArgs:t,siblingClauses:r}}function o(h,$){return M.$8d($)?$:M.$9d(h,$)}e.$pdc=o;function s(h){return h=m.$ve(h,"\\"),m.$ve(h,"/")}function n(h){return L.$Ef(h).toLowerCase()==="c:/"?h.replace(/^c:[/\\]/i,"/"):h}e.$qdc=n}),define(Se[359],De([1,0,48,52,16,360,19,46,35,77,32,12,37,15,18,29,36,357,127]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=e.$rdc=void 0;const h=new Set;process.on("exit",()=>{h.forEach(a=>a())});class ${constructor(i){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=i,this.b=i.filePattern||"",this.d=i.includePattern&&k.$rj(i.includePattern),this.f=i.maxResults||null,this.g=!!i.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,n.$oq)(this.b).normalizedLowercase),this.u=i.excludePattern&&k.$rj(i.excludePattern),this.t=new Map,i.folderQueries.forEach(c=>{const f=Object.assign({},c.excludePattern||{},this.a.excludePattern||{}),y=c.folder.fsPath;i.folderQueries.map(E=>E.folder.fsPath).filter(E=>E!==y).forEach(E=>{(0,P.$If)(E,y)&&(f[g.$$d(y,E)]=!0)}),this.t.set(y,new t(f,y))})}cancel(){this.l=!0,h.forEach(i=>i())}walk(i,c,f,y,E){if(this.m=p.$bd.create(!1),this.l)return E(null,this.j);c.forEach(u=>{const l=g.$ae(u.fsPath);this.u&&this.u(u.fsPath,l)||this.J(f,{relativePath:u.fsPath,searchPath:void 0})}),this.r=p.$bd.create(!1),this.w(i,(u,l)=>{this.x(this.y,this,u,f,y,w=>{if(w){const A=(0,m.$mi)(w);console.error(A),this.q.push(A),l(w,void 0)}else l(null,void 0)})},(u,l)=>{this.m.stop();const w=u?R.$Fb(u)[0]:null;E(w,this.j)})}w(i,c,f){const y=new Array(i.length),E=new Array(i.length);let u=!1,l=0;if(i.length===0)return f(null,[]);i.forEach((w,A)=>{c(w,(N,O)=>{if(N?(u=!0,y[A]=null,E[A]=N):(y[A]=O,E[A]=null),++l===i.length)return f(u?E:null,y)})})}x(i,c,...f){try{i.apply(c,f)}catch(y){f[f.length-1](y)}}y(i,c,f,y){const E=i.folder.fsPath,u=I.$j,l=()=>F&&F.kill();h.add(l);let w=H=>{h.delete(l),w=()=>{},y(H)},A="";const N=this.D(),O=(0,s.$odc)(this.a,i,this.a.includePattern,this.t.get(i.folder.fsPath).expression),F=O.cmd,j=!Object.keys(O.siblingClauses).length,z=O.rgArgs.args.map(H=>H.match(/^-/)?H:`'${H}'`).join(" ");let T=`${O.rgDiskPath} ${z}
 - cwd: ${O.cwd}`;O.rgArgs.siblingClauses&&(T+=`
 - Sibling clauses: ${JSON.stringify(O.rgArgs.siblingClauses)}`),f({message:T}),this.s=0,this.z(F,"utf8",f,(H,q,me)=>{if(H){w(H);return}if(this.j){w();return}const Z=(A+(u?b.$hl(q||""):q)).split(`
`);if(me){const V=Z.length;Z[V-1]=Z[V-1].trim(),Z[V-1]||Z.pop()}else A=Z.pop()||"";if(Z.length&&Z[0].indexOf(`
`)!==-1){w(new Error("Splitting up files failed"));return}if(this.s+=Z.length,j){for(const V of Z)if(this.J(c,{base:E,relativePath:V,searchPath:this.N(i,V)}),this.j){l();break}(me||this.j)&&w();return}this.G(i,N,E,Z,c),me&&(this.H(N,E,c),w())})}spawnFindCmd(i){const c=this.t.get(i.folder.fsPath),f=c.getBasenameTerms(),y=c.getPathTerms(),E=["-L","."];if(f.length||y.length){E.push("-not","(","(");for(const u of f)E.push("-name",u),E.push("-o");for(const u of y)E.push("-path",u),E.push("-o");E.pop(),E.push(")","-prune",")")}return E.push("-type","f"),D.spawn("find",E,{cwd:i.folder.fsPath})}readStdout(i,c,f){let y="";this.z(i,c,()=>{},(E,u,l)=>{if(E){f(E);return}y+=u,l&&f(null,y)})}z(i,c,f,y){let E=(w,A,N)=>{(w||N)&&(E=()=>{},this.r?.stop()),y(w,A,N)},u=!1;i.stdout?(this.A(i.stdout,c,E),i.stdout.once("data",()=>u=!0)):f({message:"stdout is null"});let l;i.stderr?l=this.B(i.stderr):f({message:"stderr is null"}),i.on("error",w=>{E(w)}),i.on("close",w=>{let A;!u&&(A=this.C(l,c))&&r(A)?E(new Error(`command failed with error code ${w}: ${this.C(l,c)}`)):(this.g&&w===0&&(this.j=!0),E(null,"",!0))})}A(i,c,f){const y=new L.StringDecoder(c);return i.on("data",E=>{f(null,y.write(E))}),y}B(i){const c=[];return i.on("data",f=>{c.push(f)}),c}C(i,c){const f=new L.StringDecoder(c);return i.map(y=>f.write(y)).join("")}D(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}G(i,{pathToEntries:c},f,y,E){y.indexOf(this.b)!==-1&&this.J(E,{base:f,relativePath:this.b,searchPath:this.N(i,this.b)});const u=l=>{const w=g.$ae(l),A=g.$_d(l);let N=c[A];N||(N=c[A]=[],u(A)),N.push({base:f,relativePath:l,basename:w,searchPath:this.N(i,l)})};y.forEach(u)}H({rootEntries:i,pathToEntries:c},f,y){const E=this,u=this.t.get(f),l=this.b;function w(A){E.o++;const N=(0,o.$II)(()=>A.map(O=>O.basename));for(let O=0,F=A.length;O<F;O++){const j=A[O],{relativePath:z,basename:T}=j;if(u.test(z,T,l!==T?N:void 0))continue;const H=c[z];if(H)w(H);else{if(E.p++,z===l)continue;E.J(y,j)}if(E.j)break}}w(i)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(i,c,f,y,E){const u=i.folder,l=(0,o.$II)(()=>f);this.w(f,(w,A)=>{if(this.l||this.j)return A(null);const N=c?[c,w].join(g.sep):w;if(this.t.get(i.folder.fsPath).test(N,w,this.a.filePattern!==w?l:void 0))return A(null);const O=[u.fsPath,N].join(g.sep);M.lstat(O,(F,j)=>{if(F||this.l||this.j)return A(null);this.L(O,j,(z,T)=>z||this.l||this.j?A(null):T.isDirectory()?(this.o++,this.M(O,j,(H,q)=>H||this.l||this.j||(q=q||"",this.v[q])?A(null):(this.v[q]=!0,v.Promises.readdir(O).then(me=>{if(this.l||this.j)return A(null);this.I(i,N,me,y,X=>A(X||null))},me=>{A(null)})))):(this.p++,N===this.b||this.h&&C.$nf(T.size)&&T.size>this.h||this.J(y,{base:u.fsPath,relativePath:N,searchPath:this.N(i,N)}),A(null,void 0)))})},w=>{const A=w&&R.$Fb(w);return E(A&&A.length>0?A[0]:void 0)})}J(i,c){this.K(c)&&(!this.d||this.d(c.relativePath,g.$ae(c.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||i(c))}K(i){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,o.$DI)(i,this.c)}return!0}L(i,c,f){return c.isSymbolicLink()?M.stat(i,f):f(null,c)}M(i,c,f){return c.isSymbolicLink()?M.realpath(i,(y,E)=>y?f(y):f(null,E)):f(null,i)}N(i,c){return i.folderName?g.$9d(i.folderName,c):c}}e.$rdc=$;class d{constructor(i){this.a=i.folderQueries,this.b=i.extraFileResources||[],this.c=new $(i)}search(i,c,f){this.c.walk(this.a,this.b,i,c,(y,E)=>{f(y,{limitHit:E,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$sdc=d;class t{constructor(i,c){this.expression=i,this.c=c,this.d(i)}d(i){let c,f;Object.keys(i).filter(y=>i[y]).forEach(y=>{g.$8d(y)?(c=c||k.$mj(),c[y]=i[y]):(f=f||k.$mj(),f[y]=i[y])}),this.a=c&&k.$rj(c,{trimForExclusions:!0}),this.b=f&&k.$rj(f,{trimForExclusions:!0})}test(i,c,f){return this.b&&this.b(i,c,f)||this.a&&this.a(g.$9d(this.c,i),c,f)}getBasenameTerms(){const i=[];return this.a&&i.push(...k.$tj(this.a)),this.b&&i.push(...k.$tj(this.b)),i}getPathTerms(){const i=[];return this.a&&i.push(...k.$uj(this.a)),this.b&&i.push(...k.$uj(this.b)),i}}function r(a){const i=a.trim().split(`
`),c=i[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return S.$bf(i[i.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(Se[361],De([1,0,97,22,182,21]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rD=e.$qD=e.$pD=e.$oD=e.$nD=e.$mD=e.$lD=e.$kD=e.$jD=e.DecodeStreamErrorKind=e.$iD=e.$hD=e.$gD=e.$fD=e.$eD=e.$dD=e.$cD=e.$bD=void 0,e.$bD="utf8",e.$cD="utf8bom",e.$dD="utf16be",e.$eD="utf16le";function R(c){return[e.$bD,e.$cD,e.$dD,e.$eD].some(f=>f===c)}e.$fD=R,e.$gD=[254,255],e.$hD=[255,254],e.$iD=[239,187,191];const m=512,k=512,b=512*8,P=512*128;var I;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class p extends Error{constructor(f,y){super(f),this.decodeStreamErrorKind=y}}e.$jD=p;class S{static async create(f){let y;if(f!==e.$bD)y=(await(0,g.$aD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(s(f));else{const E=new TextDecoder;y={write(u){return E.decode(u,{stream:!0})},end(){return E.decode()}}}return new S(y)}constructor(f){this.a=f}write(f){return this.a.write(f)}end(){return this.a.end()}}function C(c,f){const y=f.minBytesRequiredForDetection??f.guessEncoding?b:k;return new Promise((E,u)=>{const l=(0,D.$td)(j=>j.join("")),w=[];let A=0,N;const O=new L.$pd,F=async()=>{try{const j=await i({buffer:M.$Fd.concat(w),bytesRead:A},f.guessEncoding);if(j.seemsBinary&&f.acceptTextOnly)throw new p("Stream is binary but only text is accepted for decoding",1);j.encoding=await f.overwriteEncoding(j.encoding),N=await S.create(j.encoding);const z=N.write(M.$Fd.concat(w).buffer);l.write(z),w.length=0,A=0,E({stream:l,detected:j})}catch(j){O.cancel(),l.destroy(),u(j)}};(0,D.$xd)(c,{onData:async j=>{N?l.write(N.write(j.buffer)):(w.push(j),A+=j.byteLength,A>=y&&(c.pause(),await F(),setTimeout(()=>c.resume())))},onError:j=>l.error(j),onEnd:async()=>{N||await F(),l.end(N?.end())}},O.token)})}e.$kD=C;async function v(c,f,y){const u=(await(0,g.$aD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(s(f),y);let l=!1,w=!1;return{read(){if(w)return null;const A=c.read();if(typeof A!="string"){if(w=!0,!l&&y?.addBOM)switch(f){case e.$bD:case e.$cD:return M.$Fd.wrap(Uint8Array.from(e.$iD));case e.$dD:return M.$Fd.wrap(Uint8Array.from(e.$gD));case e.$eD:return M.$Fd.wrap(Uint8Array.from(e.$hD))}const N=u.end();return N&&N.length>0?(l=!0,M.$Fd.wrap(N)):null}return l=!0,M.$Fd.wrap(u.write(A))}}}e.$lD=v;async function o(c){return(await(0,g.$aD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(s(c))}e.$mD=o;function s(c){return c===e.$cD||c===null?e.$bD:c}e.$nD=s;function n(c,f){if(!c||f<e.$gD.length)return null;const y=c.readUInt8(0),E=c.readUInt8(1);if(y===e.$gD[0]&&E===e.$gD[1])return e.$dD;if(y===e.$hD[0]&&E===e.$hD[1])return e.$eD;if(f<e.$iD.length)return null;const u=c.readUInt8(2);return y===e.$iD[0]&&E===e.$iD[1]&&u===e.$iD[2]?e.$cD:null}e.$oD=n;const h=["ascii","utf-16","utf-32"];async function $(c){const f=await(0,g.$aD)("jschardet","dist/jschardet.min.js"),y=c.slice(0,P),E=r(y.buffer),u=f.detect(E);if(!u||!u.encoding)return null;const l=u.encoding.toLowerCase();return 0<=h.indexOf(l)?null:t(u.encoding)}const d={ibm866:"cp866",big5:"cp950"};function t(c){const f=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return d[f]||f}function r(c){let f="";for(let y=0;y<c.length;y++)f+=String.fromCharCode(c[y]);return f}function a(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const f=c.match(/windows(\d+)/);return f?"windows-"+f[1]:c}}}e.$pD=a;function i({buffer:c,bytesRead:f},y){let E=n(c,f),u=!1;if(E!==e.$dD&&E!==e.$eD&&c){let l=!0,w=!0,A=!1;for(let N=0;N<f&&N<m;N++){const O=N%2===1,F=c.readUInt8(N)===0;if(F&&(A=!0),l&&(O&&!F||!O&&F)&&(l=!1),w&&(O&&F||!O&&!F)&&(w=!1),F&&!l&&!w)break}A&&(l?E=e.$eD:w?E=e.$dD:u=!0)}return y&&!u&&!E&&c?$(c.slice(0,f)).then(l=>({seemsBinary:!1,encoding:l})):{seemsBinary:u,encoding:E}}e.$qD=i,e.$rD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[154],De([1,0,361,29,153]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=void 0;class L extends g.$pcc{constructor(m,k,b=M,P="searchProcess"){super(m,k,{readdir:I=>b.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,D.$pD)(I)},P)}}e.$Adc=L}),define(Se[155],De([1,0,48,377,360,19,56,35,16,15,2,36,93,378,358,116]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=e.$ydc=e.$xdc=e.$wdc=e.$vdc=e.$udc=e.$tdc=void 0;const o=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class s{constructor(w){this.a=w}provideTextSearchResults(w,A,N,O){return this.a.appendLine(`provideTextSearchResults ${w.pattern}, ${JSON.stringify({...A,folder:A.folder.toString()})}`),new Promise((F,j)=>{O.onCancellationRequested(()=>V());const z=r(w,A),T=A.folder.fsPath,H=z.map(G=>G.match(/^-/)?G:`'${G}'`).join(" ");this.a.appendLine(`${o} ${H}
 - cwd: ${T}`);let q=D.spawn(o,z,{cwd:T});q.on("error",G=>{console.error(G),this.a.appendLine("Error: "+(G&&G.message)),j((0,I.$zI)(new I.$xI(G&&G.message,I.SearchErrorCode.rgProcessError)))});let me=!1;const X=new $(A.maxResults,T,A.previewOptions);X.on("result",G=>{me=!0,ge="",N.report(G)});let Z=!1;const V=()=>{Z=!0,q?.kill(),X?.cancel()};let x=!1;X.on("hitLimit",()=>{x=!0,V()});let ge="";q.stdout.on("data",G=>{X.handleData(G),me||(ge+=G)});let ue=!1;q.stdout.once("data",()=>ue=!0);let we="";q.stderr.on("data",G=>{const U=G.toString();this.a.appendLine(U),we.length+U.length<1e6&&(we+=U)}),q.on("close",()=>{if(this.a.appendLine(ue?"Got data from stdout":"No data from stdout"),this.a.appendLine(me?"Got result from parser":"No result from parser"),ge&&this.a.appendLine(`Got data without result: ${ge}`),this.a.appendLine(""),Z)F({limitHit:x});else{X.flush(),q=null;let G;we&&!ue&&(G=n(we))?j((0,I.$zI)(new I.$xI(G.message,G.code))):F({limitHit:x})}})})}}e.$tdc=s;function n(l){const w=l.split(`
`),A=w[0].trim();if(w.some(O=>O.startsWith("regex parse error")))return new I.$xI(h(w),I.SearchErrorCode.regexParseError);const N=A.match(/grep config error: unknown encoding: (.*)/);if(N)return new I.$xI(`Unknown encoding: ${N[1]}`,I.SearchErrorCode.unknownEncoding);if(A.startsWith("error parsing glob"))return new I.$xI(A.charAt(0).toUpperCase()+A.substr(1),I.SearchErrorCode.globParseError);if(A.startsWith("the literal"))return new I.$xI(A.charAt(0).toUpperCase()+A.substr(1),I.SearchErrorCode.invalidLiteral);if(A.startsWith("PCRE2: error compiling pattern"))return new I.$xI(A,I.SearchErrorCode.regexParseError)}function h(l){const w=["Regex parse error"],A=l.filter(N=>N.startsWith("PCRE2:"));if(A.length>=1){const N=A[0].replace("PCRE2:","");if(N.indexOf(":")!==-1&&N.split(":").length>=2){const O=N.split(":")[1];w.push(":"+O)}}return w.join("")}class $ extends M.EventEmitter{constructor(w,A,N){super(),this.g=w,this.h=A,this.j=N,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new g.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(w,A){return super.on(w,A),this}handleData(w){if(this.b)return;const A=typeof w=="string"?w:this.d.write(w);this.k(A)}k(w){let A=w.indexOf(`
`);const N=this.a+w;if(A>=0)A+=this.a.length;else{this.a=N;return}let O=0;for(;A>=0;)this.m(N.substring(O,A).trim()),O=A+1,A=N.indexOf(`
`,O);this.a=N.substring(O)}m(w){if(this.b||!w)return;let A;try{A=JSON.parse(w)}catch{throw new Error(`malformed line from rg: ${w}`)}if(A.type==="match"){const N=d(A.data.path),O=P.URI.file(k.$9d(this.h,N)),F=this.n(A.data,O);this.p(F),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(A.type==="context"){const N=d(A.data.path),O=P.URI.file(k.$9d(this.h,N));this.o(A.data,O).forEach(j=>this.p(j))}}n(w,A){const N=w.line_number-1,O=d(w.lines),F=Buffer.from(O);let j=0,z=0,T=N;w.submatches.length===0&&w.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const H=(0,L.$Fb)(w.submatches.map((q,me)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const X=d(q.match),Z=F.slice(j,q.start).toString(),V=t(Z),x=V.numLines>0?V.lastLineLength:V.lastLineLength+z,ge=t(X),ue=V.numLines+T,we=ge.numLines+ue,G=ge.numLines>0?ge.lastLineLength:ge.lastLineLength+x;return j=q.end,z=G,T=we,new p.$hI(ue,x,we,G)}));return(0,v.$mdc)(A,O,H,this.j)}o(w,A){const N=d(w.lines),O=w.line_number;return N.replace(/\r?\n$/,"").split(`
`).map((F,j)=>({text:F,uri:A,lineNumber:O+j}))}p(w){this.emit("result",w)}}e.$udc=$;function d(l){return l.bytes?Buffer.from(l.bytes,"base64").toString():l.text}function t(l){const w=/\n/g;let A=0,N=-1,O;for(;O=w.exec(l);)A++,N=O.index;const F=N>=0?l.length-N-1:l.length;return{numLines:A,lastLineLength:F}}function r(l,w){const A=["--hidden","--no-require-git"];A.push(l.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:N,otherIncludes:O}=(0,R.$I)(w.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const j=new Set;O.forEach(z=>{j.add(z)}),A.push("-g","!*"),j.forEach(z=>{a(z).map(v.$ldc).forEach(T=>{A.push("-g",T)})})}N&&N.length&&N.forEach(j=>{A.push("-g",j)}),w.excludes.map(v.$ldc).forEach(j=>A.push("-g",`!${j}`)),w.maxFileSize&&A.push("--max-filesize",w.maxFileSize+""),w.useIgnoreFiles?w.useParentIgnoreFiles||A.push("--no-ignore-parent"):A.push("--no-ignore"),w.followSymlinks&&A.push("--follow"),w.encoding&&w.encoding!=="utf8"&&A.push("--encoding",w.encoding),l.pattern==="--"&&(l.isRegExp=!0,l.pattern="\\-\\-"),l.isMultiline&&!l.isRegExp&&(l.pattern=(0,b.$qe)(l.pattern),l.isRegExp=!0),w.usePCRE2&&A.push("--pcre2"),A.push("--crlf"),l.isRegExp&&(l.pattern=i(l.pattern),A.push("--engine","auto"));let F;if(l.isWordMatch){const z=(0,b.$ye)(l.pattern,!!l.isRegExp,{wholeWord:l.isWordMatch}).source.replace(/\\\//g,"/");A.push("--regexp",z)}else if(l.isRegExp){let j=f(l.pattern);j=y(j),A.push("--regexp",j)}else F=l.pattern,A.push("--fixed-strings");return A.push("--no-config"),w.useGlobalIgnoreFiles||A.push("--no-ignore-global"),A.push("--json"),l.isMultiline&&A.push("--multiline"),w.beforeContext&&A.push("--before-context",w.beforeContext+""),w.afterContext&&A.push("--after-context",w.afterContext+""),A.push("--"),F&&A.push(F),A.push("."),A}e.$vdc=r;function a(l){return u(l).flatMap(A=>{const N=(0,m.$pj)(A,"/");return N.map((O,F)=>N.slice(0,F+1).join("/"))})}function i(l){const w=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;l.match(w);)l=l.replace(w,"$1\\x{$2}");const A=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;l.match(A);)l=l.replace(A,"$1\\x{$2}");return l}e.$wdc=i;const c=l=>l.type==="Assertion"&&l.kind==="lookbehind";function f(l){let w;try{w=new S.RegExpParser().parsePattern(l)}catch{return l}let A="",N=0;const O=(z,T,H)=>{A+=l.slice(N,z)+H,N=T},F=[];return new S.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const T=F[0];if(!T)O(z.start,z.end,"\\r?\\n");else if(!F.some(c))if(T.type==="CharacterClass")if(T.negate){const H=l.slice(T.start+2,z.start)+l.slice(z.end,T.end-1);T.parent?.type==="Quantifier"?O(T.start,T.end,H?`[^${H}]`:"."):O(T.start,T.end,"(?!\\r?\\n"+(H?`|[${H}]`:"")+")")}else{const H=l.slice(T.start+1,z.start)+l.slice(z.end,T.end-1);O(T.start,T.end,H===""?"\\r?\\n":`(?:[${H}]|\\r?\\n)`)}else T.type==="Quantifier"&&O(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){F.unshift(z)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(z){F.unshift(z)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(z){F.unshift(z)},onCharacterClassLeave(){F.shift()},onAssertionEnter(z){c(z)&&F.push(z)},onAssertionLeave(z){F[0]===z&&F.shift()}}).visit(w),A+=l.slice(N),A}e.$xdc=f;function y(l){return l.replace(/\n/g,"\\r?\\n")}e.$ydc=y;function E(l){let w=!1,A=!1,N="",O="";for(let F=0;F<l.length;F++){const j=l[F];switch(j){case"\\":A?(w?O+="\\"+j:N+="\\"+j,A=!1):A=!0;break;case"{":if(A)w?O+=j:N+=j,A=!1;else{if(w)return{strInBraces:N+"{"+O+"{"+l.substring(F+1)};w=!0}break;case"}":if(A)w?O+=j:N+=j,A=!1;else{if(w)return{fixedStart:N,strInBraces:O,fixedEnd:l.substring(F+1)};N+=j}break;default:w?O+=(A?"\\":"")+j:N+=(A?"\\":"")+j,A=!1;break}}return{strInBraces:N+(w?"{"+O:"")}}function u(l){const{fixedStart:w,strInBraces:A,fixedEnd:N}=E(l);if(w===void 0||N===void 0)return[A];let O=(0,m.$pj)(A,",");O.length||(O=[""]);const F=u(N);return O.flatMap(j=>{const z=w+j;return F.map(T=>z+T)})}e.$zdc=u}),define(Se[362],De([1,0,21,155,65,17]),function($e,e,D,M,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=void 0;class R{constructor(b){this.b=b,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(b,P,I,p){const S=new M.$tdc(this.b);if(P.folder.scheme===L.Schemas.vscodeUserData){const C={...P,folder:P.folder.with({scheme:L.Schemas.file})},v=new g.$4u(o=>I.report({...o,uri:o.uri.with({scheme:P.folder.scheme})}));return this.c(p,o=>S.provideTextSearchResults(b,C,v,o))}else return this.c(p,C=>S.provideTextSearchResults(b,P,I,C))}async c(b,P){const I=m(b);this.a.add(I);const p=await P(I.token);return this.a.delete(I),p}d(){this.a.forEach(b=>b.cancel())}}e.$Ddc=R;function m(k){const b=new D.$pd;return k.onCancellationRequested(()=>b.cancel()),b}}),define(Se[363],De([1,0,29,155,154]),function($e,e,D,M,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=void 0;class L{constructor(k){this.a=k}search(k,b,P){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(S){P({message:S})}},p=new g.$Adc(this.a,new M.$tdc(I),D);return new Promise((S,C)=>p.search(v=>{b(v.map(R))},k).then(v=>S({limitHit:v.limitHit,type:"success",stats:v.stats}),C))}}e.$Bdc=L;function R(m){return{path:m.resource&&m.resource.fsPath,results:m.results,numMatches:(m.results||[]).reduce((k,b)=>{if(b.ranges){const P=b;return k+(Array.isArray(P.ranges)?P.ranges.length:1)}else return k+1},0)}}}),define(Se[364],De([1,0,19,9,8,4,127,16,37,2,30,36,359,363]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=void 0;class C{static{this.a=512}constructor($="searchProcess"){this.d=$,this.b=Object.create(null)}fileSearch($){let d;const t=s($),r=new L.$fd({onDidAddFirstListener:()=>{d=(0,M.$ug)(a=>this.doFileSearchWithEngine(p.$sdc,t,i=>r.fire(i),a)),d.then(a=>r.fire(a),a=>r.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onDidRemoveLastListener:()=>{d.cancel()}});return r.event}textSearch($){let d;const t=s($),r=new L.$fd({onDidAddFirstListener:()=>{d=(0,M.$ug)(a=>this.f(t,i=>r.fire(i),a)),d.then(a=>r.fire(a),a=>r.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onDidRemoveLastListener:()=>{d.cancel()}});return r.event}f($,d,t){return $.maxFileSize=this.g().maxFileSize,new S.$Bdc($).search(t,d,d)}g(){return{maxFileSize:process.arch==="ia32"?300*P.$Ak.MB:16*P.$Ak.GB}}doFileSearch($,d,t){return this.doFileSearchWithEngine(p.$sdc,$,d,t)}doFileSearchWithEngine($,d,t,r,a=C.a){let i=0;const c=y=>{Array.isArray(y)?(i+=y.length,t(y.map(E=>this.h(E)))):y.relativePath?(i++,t(this.h(y))):t(y)};if(d.sortByScore){let y=this.l(d,c,r);if(!y){const E=d.maxResults?Object.assign({},d,{maxResults:null}):d,u=new $(E);y=this.j(u,d,t,c,r)}return new Promise((E,u)=>{y.then(([l,w])=>{const A=w.map(N=>this.h(N));this.o(A,t,a),E(l)},u)})}const f=new $(d);return this.r(f,c,a,r).then(y=>({limitHit:y.limitHit,type:"success",stats:{detailStats:y.stats,type:this.d,fromCache:!1,resultCount:i,sortingTime:void 0}}))}h($){return{path:$.base?(0,m.$9d)($.base,$.relativePath):$.relativePath}}j($,d,t,r,a){const i=new L.$fd;let c=(0,M.$ug)(y=>{let E=[];const u=l=>{Array.isArray(l)?E=l:(r(l),i.fire(l))};return this.r($,u,-1,y).then(l=>[l,E])}),f;if(d.cacheKey){f=this.k(d.cacheKey);const y={promise:c,event:i.event,resolved:!1};f.resultsToSearchCache[d.filePattern||""]=y,c.then(()=>{y.resolved=!0},E=>{delete f.resultsToSearchCache[d.filePattern||""]}),c=this.s(c)}return c.then(([y,E])=>{const u=f?f.scorerCache:Object.create(null),l=(typeof d.maxResults!="number"||d.maxResults>0)&&k.$bd.create(!1);return this.n(d,E,u,a).then(w=>{const A=l?l.elapsed():-1;return[{type:"success",stats:{detailStats:y.stats,sortingTime:A,fromCache:!1,type:this.d,workspaceFolderCount:d.folderQueries.length,resultCount:w.length},messages:y.messages,limitHit:y.limitHit||typeof d.maxResults=="number"&&E.length>d.maxResults},w]})})}k($){const d=this.b[$];return d||(this.b[$]=new v)}l($,d,t){const r=$.cacheKey&&this.b[$.cacheKey];if(!r)return;const a=this.q(r,$.filePattern||"",d,t);if(a)return a.then(([i,c,f])=>{const y=k.$bd.create(!1);return this.n($,c,r.scorerCache,t).then(E=>{const u=y.elapsed(),l={fromCache:!0,detailStats:f,type:this.d,resultCount:c.length,sortingTime:u};return[{type:"success",limitHit:i.limitHit||typeof $.maxResults=="number"&&c.length>$.maxResults,stats:l},E]})})}n($,d,t,r){const a=(0,R.$oq)($.filePattern||""),i=(f,y)=>(0,R.$nq)(f,y,a,!0,o,t),c=typeof $.maxResults=="number"?$.maxResults:Number.MAX_VALUE;return D.$Eb(d,i,c,1e4,r)}o($,d,t){if(t&&t>0)for(let r=0;r<$.length;r+=t)d($.slice(r,r+t));else d($)}q($,d,t,r){const a=k.$bd.create(!1),i=d.indexOf(m.sep)>=0;let c;for(const u in $.resultsToSearchCache)if(d.startsWith(u)){if(i&&u.indexOf(m.sep)<0&&u!=="")continue;const l=$.resultsToSearchCache[u];c={promise:this.s(l.promise),event:l.event,resolved:l.resolved};break}if(!c)return null;const f=a.elapsed(),y=k.$bd.create(!1),E=c.event(t);return r&&r.onCancellationRequested(()=>{E.dispose()}),c.promise.then(([u,l])=>{if(r&&r.isCancellationRequested)throw(0,g.$4)();const w=[],A=(0,R.$oq)(d).normalizedLowercase;for(const N of l)(0,I.$DI)(N,A)&&w.push(N);return[u,w,{cacheWasResolved:c.resolved,cacheLookupTime:f,cacheFilterTime:y.elapsed(),cacheEntryCount:l.length}]})}r($,d,t,r){return new Promise((a,i)=>{let c=[];r?.onCancellationRequested(()=>$.cancel()),$.search(f=>{f&&(t?(c.push(f),t>0&&c.length>=t&&(d(c),c=[])):d(f))},f=>{d(f)},(f,y)=>{c.length&&d(c),f?i(f):a(y)})})}clearCache($){return delete this.b[$],Promise.resolve(void 0)}s($){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(d,t){return $.then(d,t)}catch(d){return this.then(void 0,d)}finally(d){return $.finally(d)}}}}e.$Cdc=C;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const o=new class{getItemLabel(h){return(0,m.$ae)(h.relativePath)}getItemDescription(h){return(0,m.$_d)(h.relativePath)}getItemPath(h){return h.relativePath}};function s(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(n),extraFileResources:h.extraFileResources&&h.extraFileResources.map($=>b.URI.revive($))}}function n(h){return{...h,folder:b.URI.revive(h.folder)}}}),define(Se[365],De([1,0,3,17,2,29,14,26,20,96,68,36,364,362,116,154]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;let o=class extends b.$ucc{constructor(n,h,$,d){super(n,$,d),this.s=L,this.t=-1,this.v=null,this.w=!1,this.x=new D.$jc;const t=new C.$ndc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(M.Schemas.vscodeUserData,new S.$Ddc(t))),h.remote.isRemote&&h.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const n=new C.$ndc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(M.Schemas.file,new S.$Ddc(n))),this.x.add(this.z(M.Schemas.file,new p.$Cdc("fileSearchProvider")))}z(n,h){const $=this.d++;return this.v=h,this.t=$,this.c.$registerFileSearchProvider($,this.o(n)),(0,D.$ic)(()=>{this.v=null,this.c.$unregisterProvider($)})}$provideFileSearchResults(n,h,$,d){const t=(0,b.$vcc)($);return n===this.t?this.A(n,h,t,d):super.$provideFileSearchResults(n,h,$,d)}A(n,h,$,d){const t=r=>{if((0,I.$CI)(r)&&(r=[r]),Array.isArray(r)){this.c.$handleFileMatch(n,h,r.map(a=>g.URI.file(a.path)));return}r.message&&this.n.debug("ExtHostSearch",r.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch($,t,d)}$clearCache(n){return this.v?.clearCache(n),super.$clearCache(n)}q(n,h){return new v.$Adc(n,h,void 0,"textSearchProvider")}};e.$Edc=o,e.$Edc=o=Ke([Be(0,k.$2L),Be(1,m.$fM),Be(2,P.$abc),Be(3,R.$5i)],o)}),define(Se[117],De([1,0,379,61,64,380,22,8,4,3,16,12,31,81,82]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0;class v{traceSocketEvent(l,w){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,w)}constructor(l,w=""){this.f=!0,this.debugLabel=w,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,m.$Y)(A)}},this.socket.on("error",this.a),this.b=A=>{this.traceSocketEvent("close",{hadError:A}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(l){const w=A=>{this.traceSocketEvent("read",A),l(R.$Fd.wrap(A))};return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(l){const w=A=>{l({type:0,hadError:A,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(l){const w=()=>{l()};return this.socket.on("end",w),{dispose:()=>this.socket.off("end",w)}}write(l){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,m.$Y)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,m.$Y)(w)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,w)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.$qh=v;var o;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize",u[u.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(o||(o={}));var s;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(s||(s={}));class n extends b.$kc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(l,w){this.socket.traceSocketEvent(l,w)}constructor(l,w,A,N){super(),this.f=this.B(new k.$fd),this.g=this.B(new k.$fd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:w,inflateBytesLength:A?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new h(this,w,A,N,this.f,(O,F)=>this.m(O,F))),this.B(this.a.onError(O=>{console.error(O),(0,m.$Y)(O),this.g.fire({type:0,hadError:!0,error:O})})),this.b=new C.$lh,this.B(this.socket.onData(O=>this.n(O))),this.B(this.socket.onClose(async O=>{this.a.isProcessingReadQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(O)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this.f.event(l)}onClose(l){return this.g.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){let w=0;for(;w<l.byteLength;)this.a.writeMessage(l.slice(w,Math.min(w+262144,l.byteLength))),w+=262144}m(l,w){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let A=2;l.byteLength<126?A+=0:l.byteLength<2**16?A+=2:A+=8;const N=R.$Fd.alloc(A);if(w?N.writeUInt8(194,0):N.writeUInt8(130,0),l.byteLength<126)N.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){N.writeUInt8(126,1);let O=1;N.writeUInt8(l.byteLength>>>8&255,++O),N.writeUInt8(l.byteLength>>>0&255,++O)}else{N.writeUInt8(127,1);let O=1;N.writeUInt8(0,++O),N.writeUInt8(0,++O),N.writeUInt8(0,++O),N.writeUInt8(0,++O),N.writeUInt8(l.byteLength>>>24&255,++O),N.writeUInt8(l.byteLength>>>16&255,++O),N.writeUInt8(l.byteLength>>>8&255,++O),N.writeUInt8(l.byteLength>>>0&255,++O)}this.socket.write(R.$Fd.concat([N,l]))}end(){this.h=!0,this.socket.end()}n(l){if(l.byteLength!==0){for(this.b.acceptChunk(l);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const w=this.b.peek(this.j.readLen),A=w.readUInt8(0),N=(A&128)>>>7,O=(A&64)>>>6,F=w.readUInt8(1),j=(F&128)>>>7,z=F&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(z===126?2:0)+(z===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!O),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const w=this.b.read(this.j.readLen),A=w.readUInt8(1),N=(A&128)>>>7;let O=A&127,F=1;O===126?O=w.readUInt8(++F)*2**8+w.readUInt8(++F):O===127&&(O=w.readUInt8(++F)*0+w.readUInt8(++F)*0+w.readUInt8(++F)*0+w.readUInt8(++F)*0+w.readUInt8(++F)*2**24+w.readUInt8(++F)*2**16+w.readUInt8(++F)*2**8+w.readUInt8(++F));let j=0;N&&(j=w.readUInt8(++F)*2**24+w.readUInt8(++F)*2**16+w.readUInt8(++F)*2**8+w.readUInt8(++F)),this.j.state=3,this.j.readLen=O,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const w=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",w),t(w,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",w),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(w,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$rh=n;class h extends b.$kc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$Fd.alloc(0)}constructor(l,w,A,N,O,F){super(),this.n=l,this.r=O,this.s=F,this.a=this.B(new k.$fd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.$fd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new k.$fd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,w?(this.b=this.B(new $(this.n,N,A,{windowBits:15})),this.f=this.B(new d(this.n,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(l){this.g.push(l),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const l=this.g.shift();if(this.f){const w=await this.w(this.f,l);this.s(w,!0)}else this.s(l,!1)}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(l,w){return new Promise((A,N)=>{l.write(w),l.flush(O=>A(O))})}acceptFrame(l,w,A){this.h.push({data:l,isCompressed:w,isLastFrameOfMessage:A}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const l=this.h.shift();if(this.b&&l.isCompressed){const w=await this.C(this.b,l.data,l.isLastFrameOfMessage);this.r.fire(w)}else this.r.fire(l.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(l,w,A){return new Promise((N,O)=>{l.write(w),A&&l.write(R.$Fd.fromByteArray([0,0,255,255])),l.flush(F=>N(F))})}}class $ extends b.$kc{get recordedInflateBytes(){return this.j?R.$Fd.concat(this.f):R.$Fd.alloc(0)}constructor(l,w,A,N){super(),this.h=l,this.j=w,this.a=this.B(new k.$fd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(N),this.b.on("error",O=>{this.h.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent("zlibInflateData",O),this.g.push(R.$Fd.wrap(O))}),A&&(this.h.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this.b.write(A.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(l){this.j&&this.f.push(l.clone()),this.h.traceSocketEvent("zlibInflateWrite",l),this.b.write(l.buffer)}flush(l){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const w=R.$Fd.concat(this.g);this.g.length=0,l(w)})}}class d extends b.$kc{constructor(l,w){super(),this.g=l,this.a=this.B(new k.$fd),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",A=>{this.g.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this.a.fire(A)}),this.b.on("data",A=>{this.g.traceSocketEvent("zlibDeflateData",A),this.f.push(R.$Fd.wrap(A))})}write(l){this.g.traceSocketEvent("zlibDeflateWrite",l.buffer),this.b.write(l.buffer)}flush(l){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let w=R.$Fd.concat(this.f);this.f.length=0,w=w.slice(0,w.byteLength-4),l(w)})}}function t(u,l){if(l===0)return;const w=u.byteLength>>>2;for(let z=0;z<w;z++){const T=u.readUInt32BE(z*4);u.writeUInt32BE(T^l,z*4)}const A=w*4,N=u.byteLength-A,O=l>>>24&255,F=l>>>16&255,j=l>>>8&255;N>=1&&u.writeUInt8(u.readUInt8(A)^O,A),N>=2&&u.writeUInt8(u.readUInt8(A+1)^F,A+1),N>=3&&u.writeUInt8(u.readUInt8(A+2)^j,A+2)}e.$sh=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function a(){const u=(0,p.$4f)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;const l=process.platform!=="darwin"&&e.$sh?e.$sh:(0,g.tmpdir)(),w=(0,P.$9d)(l,`vscode-ipc-${u}.sock`);return c(w),w}e.$th=a;function i(u,l,w){const A=(0,D.createHash)("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${w}-${l}-sock`;const N=w.substr(0,4),O=l.substr(0,6),F=A.substr(0,8);let j;return process.platform!=="darwin"&&e.$sh&&!process.env.VSCODE_PORTABLE?j=(0,P.$9d)(e.$sh,`vscode-${F}-${N}-${O}.sock`):j=(0,P.$9d)(u,`${N}-${O}.sock`),c(j),j}e.$uh=i;function c(u){const l=r[I.$t];typeof l=="number"&&u.length>=l&&console.warn(`WARNING: IPC handle "${u}" is longer than ${l} chars, try a shorter --user-data-dir`)}class f extends S.$fh{static b(l){const w=k.Event.fromNodeEventEmitter(l,"connection");return k.Event.map(w,A=>({protocol:new C.$mh(new v(A,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(A,"close"))}))}constructor(l){super(f.b(l)),this.d=l}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$vh=f;function y(u){return new Promise((l,w)=>{const A=(0,M.createServer)();A.on("error",w),A.listen(u,()=>{A.removeListener("error",w),l(new f(A))})})}e.$wh=y;function E(u,l){return new Promise((w,A)=>{const N=(0,M.createConnection)(u,()=>{N.removeListener("error",A),w(C.$nh.fromSocket(new v(N,`ipc-client${l}`),l))});N.once("error",A)})}e.$xh=E}),define(Se[366],De([1,0,61,64,163,117,9,3,12,49,14,135,247,248,107,86,22]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c7b=e.$b7b=e.$a7b=e.$_6b=void 0;async function s(t,r,a,i,c){let f;for(let y=3;y&&(f?.dispose(),f=await new n(t,r,a,i,c).waitForReady(),!(c&&g.$7f[c]||!g.$7f[f.tunnelLocalPort]));y--);return f}class n extends m.$kc{constructor(r,a,i,c,f){super(),this.m=a,this.n=f,this.privacy=v.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=D.createServer(),this.c=new R.$Fg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=y=>this.r(y),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=c,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(a=>{a()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,a=(0,v.$4z)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,g.$8f)(r,2,1e3,a),c=null;return this.b.listen(i,this.m),await this.c.wait(),c=this.b.address(),c||(i=0,this.b.listen(i,this.m),await this.c.wait(),c=this.b.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async r(r){r.pause();const a=(0,v.$2z)(this.tunnelRemoteHost)||(0,v.$4z)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,p.$Zk)(this.a,a,this.tunnelRemotePort),c=i.getSocket(),f=i.readEntireBuffer();i.dispose(),f.byteLength>0&&r.write(f.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),c.end()}),r.on("close",()=>c.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),c instanceof L.$qh?c.socket.destroy():c.end()}),c instanceof L.$qh?this.t(r,c):this.s(r,c),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),c.end()})}s(r,a){a.onClose(()=>r.destroy()),a.onEnd(()=>r.end()),a.onData(i=>r.write(i.buffer)),r.on("data",i=>a.write(o.$Fd.wrap(i))),r.resume()}t(r,a){const i=a.socket;i.on("end",()=>r.end()),i.on("close",()=>r.end()),i.on("error",()=>{r.destroy()}),i.pipe(r),r.pipe(i)}}e.$_6b=n;let h=class extends v.$7z{constructor(r,a,i,c,f){super(a,f),this.u=r,this.v=i,this.w=c}isPortPrivileged(r){return(0,v.$5z)(r,this.l,k.OS,M.release())}s(r,a,i,c,f,y,E,u){const l=this.r(a,i);if(l)return++l.refcount,l.value;if((0,v.$Yz)(r))return this.t(r,a,i,f,y,E,u);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${i} on local port ${f}.`);const w={commit:this.w.commit,quality:this.w.quality,addressProvider:r,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},A=s(w,c,a,i,f);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(a,i,A),A}}};e.$a7b=h,e.$a7b=h=Ke([Be(0,S.$Tk),Be(1,P.$5i),Be(2,C.$Wk),Be(3,I.$kj),Be(4,b.$8h)],h);let $=class extends h{constructor(r,a,i,c,f){super(r,a,i,c,f)}};e.$b7b=$,e.$b7b=$=Ke([Be(0,S.$Tk),Be(1,P.$5i),Be(2,C.$Wk),Be(3,I.$kj),Be(4,b.$8h)],$);let d=class extends m.$kc{constructor(r,a,i,c,f){super(),this.b=r,this.c=a,this.f=i,this.g=c,this.h=f,this.a=new Map}async openTunnel(r,a,i,c,f,y,E,u,l){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${c} on local port ${y}.`),!this.a.has(r)){const w=new $(this.b,this.c,this.g,this.f,this.h);this.B(w),this.a.set(r,w),w.onTunnelClosed(async()=>{(await w.tunnels).length===0&&(w.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(a,i,c,f,y,E,u,l)}};e.$c7b=d,e.$c7b=d=Ke([Be(0,S.$Tk),Be(1,P.$5i),Be(2,I.$kj),Be(3,C.$Wk),Be(4,b.$8h)],d)}),define(Se[367],De([1,0,117,267,52,33,2,14,43]),function($e,e,D,M,g,L,R,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rM=e.$qM=void 0;class b{constructor(p,S,C){this.b=p,this.c=S,this.f=C,this.a=M.createServer((v,o)=>this.h(v,o)),this.g().catch(v=>(S.error(v),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",p=>this.c.error(p))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(p,S){const C=(o,s)=>{S.writeHead(o,{"content-type":"application/json"}),S.end(JSON.stringify(s||null),n=>n&&this.c.error(n))},v=[];p.setEncoding("utf8"),p.on("data",o=>v.push(o)),p.on("end",async()=>{try{const o=JSON.parse(v.join(""));let s;switch(o.type){case"open":s=await this.i(o);break;case"openExternal":s=await this.j(o);break;case"status":s=await this.l(o);break;case"extensionManagement":s=await this.k(o);break;default:C(404,`Unknown message type: ${o.type}`);break}C(200,s)}catch(o){const s=o instanceof Error?o.message:JSON.stringify(o);C(500,s),this.c.error("Error while processing pipe request",o)}})}async i(p){const{fileURIs:S,folderURIs:C,forceNewWindow:v,diffMode:o,mergeMode:s,addMode:n,forceReuseWindow:h,gotoLineMode:$,waitMarkerFilePath:d,remoteAuthority:t}=p,r=[];if(Array.isArray(C))for(const f of C)try{r.push({folderUri:R.URI.parse(f)})}catch{}if(Array.isArray(S))for(const f of S)try{(0,k.$7h)(f)?r.push({workspaceUri:R.URI.parse(f)}):r.push({fileUri:R.URI.parse(f)})}catch{}const a=d?R.URI.file(d):void 0,c={forceNewWindow:v,diffMode:o,mergeMode:s,addMode:n,gotoLineMode:$,forceReuseWindow:h,preferNewWindow:!h&&!a&&!n,waitMarkerFileURI:a,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",r,c)}async j(p){for(const S of p.uris){const C=R.URI.parse(S),v=C.scheme==="file"?C:S;await this.b.executeCommand("_remoteCLI.openExternal",v)}}async k(p){const S=v=>v?.map(o=>/\.vsix$/i.test(o)?R.URI.parse(o):o),C={list:p.list,install:S(p.install),uninstall:S(p.uninstall),force:p.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",C)}async l(p){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&g.existsSync(this.f)&&g.unlinkSync(this.f)}}e.$qM=b;let P=class extends b{constructor(p,S){super(p,S,(0,D.$th)())}};e.$rM=P,e.$rM=P=Ke([Be(0,L.$lM),Be(1,m.$5i)],P)}),define(Se[368],De([1,0,53,355,350,266,45,338,2,17,7,367,101,336,337]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=void 0;class v extends g.$$cc{j(){const n=this,h=globalThis._VSCODE_NODE_MODULES.module,$=h._load;h._load=function(a,i,c){return a=t(a),n.a.has(a)?n.a.get(a).load(a,k.URI.file((0,p.$Xp)(i.filename)),f=>$.apply(this,[f,i,c])):$.apply(this,arguments)};const d=h._resolveLookupPaths;h._resolveLookupPaths=(r,a)=>d.call(this,t(r),a);const t=r=>{for(const a of n.b){const i=a(r);if(i){r=i;break}}return r}}}class o extends R.$Kbc{constructor(){super(...arguments),this.extensionRuntime=P.ExtensionRuntime.Node}async tb(){this.h.createInstance(S.$Hdc);const n=this.h.invokeFunction(M.$7cc);if(this.h.createInstance(m.$Gdc),this.f.remote.isRemote&&this.f.remote.authority){const d=this.h.createInstance(I.$rM);process.env.VSCODE_IPC_HOOK_CLI=d.ipcHandlePath}this.h.createInstance(C.$Idc),await this.h.createInstance(v,n,{mine:this.J,all:this.L}).install(),D.mark("code/extHost/didInitAPI");const $=await this.m.getConfigProvider();await(0,L.$Fdc)(this.j,$,this,this.s,this.z,this.f),D.mark("code/extHost/didInitProxyResolver")}ub(n){return n.main}async vb(n,h,$){if(h.scheme!==b.Schemas.file)throw new Error(`Cannot load URI: '${h}', must be of file-scheme`);let d=null;$.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${h.toString(!0)}`),this.s.flush();const t=n?.identifier.value;n&&await this.w.initializeLocalizedMessages(n);try{t&&D.mark(`code/extHost/willLoadExtensionCode/${t}`),d=$e.__$__nodeRequire(h.fsPath)}finally{t&&D.mark(`code/extHost/didLoadExtensionCode/${t}`),$.codeLoadingStop()}return d}async $setRemoteEnvironment(n){if(this.f.remote.isRemote)for(const h in n){const $=n[h];$===null?delete process.env[h]:process.env[h]=$}}}e.$Jdc=o}),define(Se[369],De([1,0,48,22,4,3,120,12,24,2,29,14,246,66,107,86,366,26,20,74,346]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o,s,n,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=e.$Qdc=e.$Pdc=e.$Odc=e.$Ndc=e.$Mdc=e.$Ldc=e.$Kdc=void 0;function d(l){const w=l.trim().split(`
`),A=[];return w.forEach(O=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(O);F&&F.length>=3&&A.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),A.reduce((O,F)=>(O[F.socket]=F,O),{})}e.$Kdc=d;function t(...l){const w=[].concat(...l.map(a));return[...new Map(w.filter(A=>A.st==="0A").map(A=>{const N=A.local_address.split(":");return{socket:parseInt(A.inode,10),ip:r(N[0]),port:parseInt(N[1],16)}}).map(A=>[A.ip+":"+A.port,A])).values()]}e.$Ldc=t;function r(l){let w="";if(l.length===8)for(let A=l.length-2;A>=0;A-=2)w+=parseInt(l.substr(A,2),16),A!==0&&(w+=".");else for(let A=0;A<l.length;A+=8){const N=l.substring(A,A+8);let O="";for(let F=8;F>=2;F-=2)O+=N.substring(F-2,F),(F===6||F===2)&&(O=parseInt(O,16).toString(16),w+=`${O}`,O="",A+F!==l.length-6&&(w+=":"))}return w}e.$Mdc=r;function a(l){const w=l.trim().split(`
`),A=w.shift().trim().split(/\s+/).filter(O=>O!=="rx_queue"&&O!=="tm->when");return w.map(O=>O.trim().split(/\s+/).reduce((F,j,z)=>(F[A[z]||z]=j,F),{}))}e.$Ndc=a;function i(l){return!!l.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||l.indexOf("out/server-main.js")!==-1||l.indexOf("_productName=VSCode")!==-1}function c(l){const w=l.trim().split(`
`),A=[];return w.forEach(N=>{const O=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);O&&O.length>=4&&A.push({pid:parseInt(O[1],10),ppid:parseInt(O[2]),cmd:O[3]})}),A}e.$Odc=c;async function f(l,w,A){const N=A.reduce((F,j)=>(F[j.pid]=j,F),{}),O=[];return l.forEach(({socket:F,ip:j,port:z})=>{const T=w[F]?w[F].pid:void 0,H=T?N[T]?.cmd:void 0;T&&H&&!i(H)&&O.push({host:j,port:z,detail:H,pid:T})}),O}e.$Pdc=f;function y(l,w,A){const N=new Map,O=c(w);for(const F of l){const j=A.get(F.port);if(j){N.set(F.port,j);continue}const z=O.find(T=>T.cmd.includes(`${F.port}`));if(z){let T=z,H;do H=O.find(q=>q.ppid===T.pid),H&&(T=H);while(H);N.set(F.port,{host:F.ip,port:F.port,pid:T.pid,detail:T.cmd,ppid:T.ppid})}else N.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return N}e.$Qdc=y;let E=class extends h.$ssb{constructor(w,A,N,O){super(w,A,N),this.D=A,this.F=O,this.y=void 0,this.z=new Map,this.C=!1,m.$k&&A.remote.isRemote&&A.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(w){if(w&&this.C)return;this.C=w;let A;this.y&&(A=this.y,await this.a.$onFoundNewCandidates(this.y));const N=new R.$Kl;let O=0;for(;this.C;){const F=new Date().getTime(),j=(await this.I()).filter(H=>(0,v.$2z)(H.host)||(0,v.$4z)(H.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${j.map(H=>H.port).join(", ")}`);const z=new Date().getTime()-F;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${z} ms.`),O++>3&&N.update(z),(!A||JSON.stringify(A)!==JSON.stringify(j))&&(A=j,await this.a.$onFoundNewCandidates(A));const T=this.G(N.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${T} ms.`),await new Promise(H=>setTimeout(()=>H(),T))}}G(w){return Math.max(w*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(w=>w.port).join(", ")}`)}async I(){let w="",A="";try{w=await P.Promises.readFile("/proc/net/tcp","utf8"),A=await P.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=t(w,A),O=await new Promise(X=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Z,V,x)=>{X(V)})}),F=d(O),j=await P.Promises.readdir("/proc"),z=[];for(const X of j)try{const Z=Number(X),V=k.$ig(b.URI.file("/proc"),X);if((await P.Promises.stat(V.fsPath)).isDirectory()&&!isNaN(Z)){const ge=await P.Promises.readlink(k.$ig(V,"cwd").fsPath),ue=await P.Promises.readFile(k.$ig(V,"cmdline").fsPath,"utf8");z.push({pid:Z,cwd:ge,cmd:ue})}}catch{}const T=[],H=N.filter(X=>{const Z=F[X.socket];return Z||T.push(X),Z}),q=f(H,F,z);let me;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${T.length}`),T.length>0){const X=await new Promise(Z=>{(0,D.exec)("ps -F -A -l | grep root",(V,x,ge)=>{Z(x)})});this.z=y(T,X,this.z),me=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${me.map(Z=>Z.port).join(", ")}`)}return q.then(X=>me?X.concat(me):X)}w(w){return async A=>{const N=new o.$_6b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(F,j,z,T){const H=await w.makeConnection();return u.connect(H,j,z,T)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new S.$Kk(0),connectionToken:w.connectionToken})}},signService:this.F},"localhost",A.remoteAddress.host||"localhost",A.remoteAddress.port,A.localAddressPort);await N.waitForReady();const O=new g.$fd;return{localAddress:(0,$.$jJ)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:O.event,dispose:()=>{N.dispose(),O.fire(),O.dispose()}}}}};e.$Rdc=E,e.$Rdc=E=Ke([Be(0,n.$2L),Be(1,s.$fM),Be(2,I.$5i),Be(3,C.$Wk)],E);class u extends p.$Akb{static connect(w,A,N,O){const F=new L.$jc,j={onClose:F.add(new g.$fd),onData:F.add(new g.$fd),onEnd:F.add(new g.$fd)};F.add(w.onDidReceiveMessage(T=>j.onData.fire(M.$Fd.wrap(T)))),F.add(w.onDidEnd(()=>j.onEnd.fire())),F.add(w.onDidClose(T=>j.onClose.fire({type:0,error:T,hadError:!!T})));const z=new u(w,O,j);return z.B(F),(0,p.$zkb)(z,A,N,O,j)}constructor(w,A,N){super(A,N),this.n=w}write(w){this.n.send(w.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Se[370],De([1,0,104,341,353,352,365,368,369,95,45,96,94,44,74,91,340,339,14,354,55,261,103,107,138]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o,s,n,h,$,d,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$mr)(P.$Lbc,m.$Jdc,0),(0,D.$mr)(n.$6i,s.$Tdc,1),(0,D.$mr)(n.$5i,new t.$yh(d.$0cc,[!1],!0)),(0,D.$mr)(r.$Wk,a.$e7b,1),(0,D.$mr)(v.$wbc,o.$Sdc,0),(0,D.$mr)(b.$jcc,L.$kdc,0),(0,D.$mr)(I.$tcc,R.$Edc,0),(0,D.$mr)(p.$ecc,g.$cdc,0),(0,D.$mr)(S.$ybc,M.$bdc,0),(0,D.$mr)(C.$rsb,k.$Rdc,0),(0,D.$mr)($.$hcc,h.$Udc,0)}),define(Se[381],De([1,0,61,382,53,8,82,117,244,111,351,22,29,101,9,130,268,285,356,370]),function($e,e,D,M,g,L,R,m,k,b,P,I,p,S,C,v,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let f=0;f<process.execArgv.length;f++)process.execArgv[f]==="--inspect-port=0"&&(process.execArgv.splice(f,1),f--)}();const n=M(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const c=globalThis._VSCODE_NODE_MODULES.module,f=c._load;c._load=function(y){if(y==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return f.apply(this,arguments)}})();const h=process.exit.bind(process);function $(c){process.exit=function(f){if(c)h(f);else{const y=new Error("An extension called process.exit() and this was prevented.");console.warn(y.stack)}},process.crash=function(){const f=new Error("An extension called process.crash() and this was prevented.");console.warn(f.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let d=function(c){h()};function t(){const c=(0,s.$rm)(process.env);if(c.type===3)return new Promise((f,y)=>{const E=u=>{const l=u[0],w=new R.$oh;l.on("message",A=>w.fire(I.$Fd.wrap(A.data))),l.on("close",()=>{d("renderer closed the MessagePort")}),l.start(),f({onMessage:w.event,send:A=>l.postMessage(A.buffer)})};process.parentPort.on("message",u=>E(u.ports))});if(c.type===2)return new Promise((f,y)=>{let E=null;const u=setTimeout(()=>{d("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),l=108e5,w=3e5,A=new C.$Tg(()=>d("renderer disconnected for too long (1)"),l),N=new C.$Tg(()=>d("renderer disconnected for too long (2)"),w);process.on("message",(F,j)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){j.setNoDelay(!0);const z=I.$Fd.wrap(Buffer.from(F.initialDataChunk,"base64"));let T;if(F.skipWebSocketFrames)T=new m.$qh(j,"extHost-socket");else{const H=I.$Fd.wrap(Buffer.from(F.inflateBytes,"base64"));T=new m.$rh(new m.$qh(j,"extHost-socket"),F.permessageDeflate,H,!1)}E?(A.cancel(),N.cancel(),E.beginAcceptReconnection(T,z),E.endAcceptReconnection(),E.sendResume()):(clearTimeout(u),E=new R.$ph({socket:T,initialChunk:z}),E.sendResume(),E.onDidDispose(()=>d("renderer disconnected")),f(E),E.onSocketClose(()=>{A.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;A.isScheduled()&&N.schedule()}});const O={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(O)});{const f=c.pipeName;return new Promise((y,E)=>{const u=D.createConnection(f,()=>{u.removeListener("error",E);const l=new R.$ph({socket:new m.$qh(u,"extHost-renderer")});l.sendResume(),y(l)});u.once("error",E),u.on("close",()=>{d("renderer closed the socket")})})}}async function r(){const c=await t();return new class{constructor(){this.a=new R.$oh,this.onMessage=this.a.event,this.b=!1,c.onMessage(f=>{(0,b.$5l)(f,2)?(this.b=!0,d("received terminate message from renderer")):this.a.fire(f)})}send(f){this.b||c.send(f)}async drain(){if(c.drain)return c.drain()}}}function a(c){return new Promise(f=>{const y=c.onMessage(E=>{y.dispose();const u=JSON.parse(E.toString()),l=u.commit,w=k.default.commit;if(l&&w&&l!==w&&h(55),u.parentPid){let A=0;setInterval(function(){try{process.kill(u.parentPid,0),A=0}catch(O){O&&O.code==="EPERM"?(A++,A>=3&&d(`parent process ${u.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):d(`parent process ${u.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start(u.parentPid)}catch(O){(0,L.$Y)(O)}}c.send((0,b.$4l)(0)),f({protocol:c,initData:u})});c.send((0,b.$4l)(1))})}async function i(){const c=[];process.on("unhandledRejection",(A,N)=>{c.push(N),setTimeout(()=>{const O=c.indexOf(N);O>=0&&N.catch(F=>{c.splice(O,1),(0,L.$2)(F)||(console.warn(`rejected promise not handled within 1 second: ${F}`),F&&F.stack&&console.warn(`stack trace: ${F.stack}`),A&&(0,L.$Y)(A))})},1e3)}),process.on("rejectionHandled",A=>{const N=c.indexOf(A);N>=0&&c.splice(N,1)}),process.on("uncaughtException",function(A){(0,L.$X)(A)||(0,L.$Y)(A)}),g.mark("code/extHost/willConnectToRenderer");const f=await r();g.mark("code/extHost/didConnectToRenderer");const y=await a(f);g.mark("code/extHost/didWaitForInitData");const{initData:E}=y;$(!!E.environment.extensionTestsLocationURI),E.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,E.environment.skipWorkspaceStorageLock=(0,v.boolean)(n.skipWorkspaceStorageLock,!1);const u=new class{constructor(){this.pid=process.pid}exit(N){h(N)}fsExists(N){return p.Promises.exists(N)}fsRealpath(N){return(0,S.$Wp)(N)}};let l=null;E.remote.authority&&n.transformURIs&&(l=(0,o.$qr)(E.remote.authority));const w=new P.$adc(y.protocol,E,u,l);d=A=>w.terminate(A)}i().catch(c=>console.log(c))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/10765021158cf51eaf6785361598e1668f53e06e/core/vs/workbench/api/node/extensionHostProcess.js.map
