/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],K=function(z){for(var e=[],A=0,k=z.length;A<k;A++)e[A]=q[z[A]];return e};define(q[21],K([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class A{static get(){const v=new Map,T=new Map,r=new Map,l=new Map;function t(u,n){u.has(n.detail)||u.set(n.detail,-n.timestamp)}function a(u,n){const i=u.get(n.detail);i&&(i>=0||u.set(n.detail,i+n.timestamp))}let h=[];typeof z=="function"&&typeof z.getStats=="function"&&(h=z.getStats().slice(0).sort((u,n)=>u.timestamp-n.timestamp));for(const u of h)switch(u.type){case 10:t(v,u);break;case 11:case 12:a(v,u);break;case 21:t(T,u);break;case 22:a(T,u);break;case 33:t(r,u);break;case 34:a(r,u);break;case 31:t(l,u);break;case 32:a(l,u);break}let c=0;r.forEach(u=>c+=u);function g(u){const n=[];return u.forEach((i,s)=>n.push([s,i])),n}return{amdLoad:g(v),amdInvoke:g(T),nodeRequire:g(r),nodeEval:g(l),nodeRequireTotal:c}}static toMarkdownTable(v,T){let r="";const l=[];return v.forEach((t,a)=>{l[a]=t.length}),T.forEach(t=>{t.forEach((a,h)=>{typeof a>"u"&&(a=t[h]="-");const c=a.toString().length;l[h]=Math.max(c,l[h])})}),v.forEach((t,a)=>{r+=`| ${t+" ".repeat(l[a]-t.toString().length)} `}),r+=`|
`,v.forEach((t,a)=>{r+=`| ${"-".repeat(l[a])} `}),r+=`|
`,T.forEach(t=>{t.forEach((a,h)=>{typeof a<"u"&&(r+=`| ${a+" ".repeat(l[h]-a.toString().length)} `)}),r+=`|
`}),r}}e.$S=A}),define(q[4],K([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vc=e.$Uc=e.$Tc=void 0;let A;function k(i){A=i}e.$Tc=k;function v(){return A}e.$Uc=v;class T{constructor(){this.a=0,this.d=new WeakMap}b(s){return r([l(u("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[l(" "),a(h(s.oldValue,70),{color:"red",strikeThrough:!0}),l(" "),a(h(s.newValue,60),{color:"green"})]:[l(" (unchanged)")]:[l(" "),a(h(s.newValue,60),{color:"green"}),l(" (initial)")]}handleObservableChanged(s,d){console.log(...this.b([t("observable value changed"),a(s.debugName,{color:"BlueViolet"}),...this.c(d)]))}formatChanges(s){if(s.size!==0)return a(" (changed deps: "+[...s].map(d=>d.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const d=s.handleChange;this.d.set(s,new Set),s.handleChange=(w,N)=>(this.d.get(s).add(w),d.apply(s,[w,N]))}handleDerivedRecomputed(s,d){const w=this.d.get(s);console.log(...this.b([t("derived recomputed"),a(s.debugName,{color:"BlueViolet"}),...this.c(d),this.formatChanges(w),{data:[{fn:s._computeFn}]}])),w.clear()}handleFromEventObservableTriggered(s,d){console.log(...this.b([t("observable from event triggered"),a(s.debugName,{color:"BlueViolet"}),...this.c(d),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const d=s.handleChange;this.d.set(s,new Set),s.handleChange=(w,N)=>(this.d.get(s).add(w),d.apply(s,[w,N]))}handleAutorunTriggered(s){const d=this.d.get(s);console.log(...this.b([t("autorun"),a(s.debugName,{color:"BlueViolet"}),this.formatChanges(d),{data:[{fn:s._runFn}]}])),d.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let d=s.getDebugName();d===void 0&&(d=""),console.log(...this.b([t("transaction"),a(d,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Vc=T;function r(i){const s=new Array,d=[];let w="";function N(E){if("length"in E)for(const f of E)f&&N(f);else"text"in E?(w+=`%c${E.text}`,s.push(E.style),E.data&&d.push(...E.data)):"data"in E&&d.push(...E.data)}N(i);const P=[w,...s];return P.push(...d),P}function l(i){return a(i,{color:"black"})}function t(i){return a(n(`${i}: `,10),{color:"black",bold:!0})}function a(i,s={color:"black"}){function d(N){return Object.entries(N).reduce((P,[E,f])=>`${P}${E}:${f};`,"")}const w={color:s.color};return s.strikeThrough&&(w["text-decoration"]="line-through"),s.bold&&(w["font-weight"]="bold"),{text:i,style:d(w)}}function h(i,s){switch(typeof i){case"number":return""+i;case"string":return i.length+2<=s?`"${i}"`:`"${i.substr(0,s-7)}"+...`;case"boolean":return i?"true":"false";case"undefined":return"undefined";case"object":return i===null?"null":Array.isArray(i)?c(i,s):g(i,s);case"symbol":return i.toString();case"function":return`[[Function${i.name?" "+i.name:""}]]`;default:return""+i}}function c(i,s){let d="[ ",w=!0;for(const N of i){if(w||(d+=", "),d.length-5>s){d+="...";break}w=!1,d+=`${h(N,s-d.length)}`}return d+=" ]",d}function g(i,s){let d="{ ",w=!0;for(const[N,P]of Object.entries(i)){if(w||(d+=", "),d.length-5>s){d+="...";break}w=!1,d+=`${N}: ${h(P,s-d.length)}`}return d+=" }",d}function u(i,s){let d="";for(let w=1;w<=s;w++)d+=i;return d}function n(i,s){for(;i.length<s;)i+=" ";return i}}),define(q[5],K([0,1,4]),function(z,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.$5c=e.$4c=e.$3c=e.$2c=void 0;let k;function v(s){k=s}e.$2c=v;class T{get TChange(){return null}reportChanges(){this.get()}read(d){return d?d.readObservable(this):this.get()}map(d,w){const N=w===void 0?void 0:d,P=w===void 0?d:w;return k({owner:N,debugName:()=>{const E=c(P);if(E!==void 0)return E;const y=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(P.toString());if(y)return`${this.debugName}.${y[2]}`;if(!N)return`${this.debugName} (mapped)`}},E=>P(this.read(E),E))}}e.$3c=T;class r extends T{constructor(){super(...arguments),this.c=new Set}addObserver(d){const w=this.c.size;this.c.add(d),w===0&&this.f()}removeObserver(d){this.c.delete(d)&&this.c.size===0&&this.g()}f(){}g(){}}e.$4c=r;function l(s,d){const w=new a(s,d);try{s(w)}finally{w.finish()}}e.$5c=l;function t(s,d,w){s?d(s):l(d,w)}e.$6c=t;class a{constructor(d,w){this._fn=d,this.b=w,this.a=[],(0,A.$Uc)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():c(this._fn)}updateObserver(d,w){this.a.push({observer:d,observable:w}),d.beginUpdate(w)}finish(){const d=this.a;this.a=null;for(const{observer:w,observable:N}of d)w.endUpdate(N);(0,A.$Uc)()?.handleEndTransaction()}}e.$7c=a;function h(s,d,w,N){let P;if(s!==void 0)if(typeof s=="function"){if(P=s(),P!==void 0)return P}else return s;if(d!==void 0&&(P=c(d),P!==void 0))return P;if(w!==void 0){for(const E in w)if(w[E]===N)return E}}e.$8c=h;function c(s){const d=s.toString(),N=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(d);return(N?N[1]:void 0)?.trim()}e.$9c=c;function g(s,d){return typeof s=="string"?new u(void 0,s,d):new u(s,void 0,d)}e.$0c=g;class u extends r{get debugName(){return h(this.d,void 0,this.b,this)??"ObservableValue"}constructor(d,w,N){super(),this.b=d,this.d=w,this.a=N}get(){return this.a}set(d,w,N){if(this.a===d)return;let P;w||(w=P=new a(()=>{},()=>`Setting ${this.debugName}`));try{const E=this.a;this.e(d),(0,A.$Uc)()?.handleObservableChanged(this,{oldValue:E,newValue:d,change:N,didChange:!0,hadValue:!0});for(const f of this.c)w.updateObserver(f,this),f.handleChange(this,N)}finally{P&&P.finish()}}toString(){return`${this.debugName}: ${this.a}`}e(d){this.a=d}}e.$$c=u;function n(s,d){return typeof s=="string"?new i(void 0,s,d):new i(s,void 0,d)}e.$_c=n;class i extends u{e(d){this.a!==d&&(this.a&&this.a.dispose(),this.a=d)}dispose(){this.a?.dispose()}}e.$ad=i}),define(q[9],K([0,1,42,2,5,4]),function(z,e,A,k,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=void 0;function r(n,i){return new g(n.debugName,i,void 0,void 0)}e.$zc=r;function l(n){return new g(void 0,n,void 0,void 0)}e.$Ac=l;function t(n,i){return new g(n.debugName,i,n.createEmptyChangeSummary,n.handleChange)}e.$Bc=t;function a(n,i){const s=new k.$jc,d=t({debugName:n.debugName??(()=>(0,v.$9c)(i)),createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(w,N)=>{s.clear(),i(w,N,s)});return(0,k.$ic)(()=>{d.dispose(),s.dispose()})}e.$Cc=a;function h(n){const i=new k.$jc,s=r({debugName:()=>(0,v.$9c)(n)||"(anonymous)"},d=>{i.clear(),n(d,i)});return(0,k.$ic)(()=>{s.dispose(),i.dispose()})}e.$Dc=h;var c;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(c||(c={}));class g{get debugName(){if(typeof this.h=="string")return this.h;if(typeof this.h=="function"){const s=this.h();if(s!==void 0)return s}const i=(0,v.$9c)(this._runFn);return i!==void 0?i:"(anonymous)"}constructor(i,s,d,w){this.h=i,this._runFn=s,this.i=d,this.j=w,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,T.$Uc)()?.handleAutorunCreated(this),this.k(),(0,k.$bc)(this)}dispose(){this.c=!0;for(const i of this.e)i.removeObserver(this);this.e.clear(),(0,k.$cc)(this)}k(){if(this.a===3)return;const i=this.f;this.f=this.e,this.e=i,this.a=3;try{if(!this.c){(0,T.$Uc)()?.handleAutorunTriggered(this);const s=this.g;this.g=this.i?.(),this._runFn(this,s)}}finally{(0,T.$Uc)()?.handleAutorunFinished(this);for(const s of this.f)s.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const i of this.e)if(i.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,A.$xc)(()=>this.b>=0)}handlePossibleChange(i){this.a===3&&this.e.has(i)&&!this.f.has(i)&&(this.a=1)}handleChange(i,s){this.e.has(i)&&!this.f.has(i)&&(!this.j||this.j({changedObservable:i,change:s,didChange:w=>w===i},this.g))&&(this.a=2)}readObservable(i){if(this.c)return i.get();i.addObserver(this);const s=i.get();return this.e.add(i),this.f.delete(i),s}}e.$Ec=g,function(n){n.Observer=g}(l||(e.$Ac=l={}));function u(n,i){let s;return r({debugName:()=>(0,v.$9c)(i)},d=>{const w=n.read(d),N=s;s=w,i({lastValue:N,newValue:w})})}e.$Fc=u}),define(q[10],K([0,1,6,2,5,4]),function(z,e,A,k,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=void 0;const r=(u,n)=>u===n;function l(u,n){return n!==void 0?new g(u,void 0,n,void 0,void 0,void 0,r):new g(void 0,void 0,u,void 0,void 0,void 0,r)}e.$Wc=l;function t(u,n){return new g(u.owner,u.debugName,n,void 0,void 0,void 0,u.equalityComparer??r)}e.$Xc=t;function a(u,n){return new g(u.owner,u.debugName,n,u.createEmptyChangeSummary,u.handleChange,void 0,u.equalityComparer??r)}e.$Yc=a;function h(u,n){let i,s;n===void 0?(i=u,s=void 0):(s=u,i=n);const d=new k.$jc;return new g(s,()=>(0,v.$9c)(i)??"(anonymous)",w=>(d.clear(),i(w,d)),void 0,void 0,()=>d.dispose(),r)}e.$Zc=h,(0,v.$2c)(l);var c;(function(u){u[u.initial=0]="initial",u[u.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",u[u.stale=2]="stale",u[u.upToDate=3]="upToDate"})(c||(c={}));class g extends v.$4c{get debugName(){return(0,v.$8c)(this.n,this._computeFn,this.m,this)??"(anonymous)"}constructor(n,i,s,d,w,N=void 0,P){super(),this.m=n,this.n=i,this._computeFn=s,this.p=d,this.q=w,this.s=N,this.t=P,this.e=0,this.h=void 0,this.i=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.p?.(),(0,T.$Uc)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const n of this.j)n.removeObserver(this);this.j.clear(),this.s?.()}get(){if(this.c.size===0){const n=this._computeFn(this,this.p?.());return this.g(),n}else{do{if(this.e===1){for(const n of this.j)if(n.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.v()}while(this.e!==3);return this.h}}v(){if(this.e===3)return;const n=this.k;this.k=this.j,this.j=n;const i=this.e!==0,s=this.h;this.e=3;const d=this.l;this.l=this.p?.();try{this.h=this._computeFn(this,d)}finally{for(const N of this.k)N.removeObserver(this);this.k.clear()}const w=i&&!this.t(s,this.h);if((0,T.$Uc)()?.handleDerivedRecomputed(this,{oldValue:s,newValue:this.h,change:void 0,didChange:w,hadValue:i}),w)for(const N of this.c)N.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.i++;const i=this.i===1;if(this.e===3&&(this.e=1,!i))for(const s of this.c)s.handlePossibleChange(this);if(i)for(const s of this.c)s.beginUpdate(this)}endUpdate(n){if(this.i--,this.i===0){const i=[...this.c];for(const s of i)s.endUpdate(this)}if(this.i<0)throw new A.$ab}handlePossibleChange(n){if(this.e===3&&this.j.has(n)&&!this.k.has(n)){this.e=1;for(const i of this.c)i.handlePossibleChange(this)}}handleChange(n,i){if(this.j.has(n)&&!this.k.has(n)){const s=this.q?this.q({changedObservable:n,change:i,didChange:w=>w===n},this.l):!0,d=this.e===3;if(s&&(this.e===1||d)&&(this.e=2,d))for(const w of this.c)w.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const i=n.get();return this.j.add(n),this.k.delete(n),i}addObserver(n){const i=!this.c.has(n)&&this.i>0;super.addObserver(n),i&&n.beginUpdate(this)}removeObserver(n){const i=this.c.has(n)&&this.i>0;super.removeObserver(n),i&&n.endUpdate(this)}}e.$1c=g}),define(q[22],K([0,1,2,9,5,10,4]),function(z,e,A,k,v,T,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;function l(m){return new t(m)}e.$Gc=l;class t extends v.$3c{constructor(O){super(),this.a=O}get debugName(){return this.toString()}get(){return this.a}addObserver(O){}removeObserver(O){}toString(){return`Const: ${this.a}`}}function a(m){const O=(0,v.$0c)("promiseValue",{});return m.then(D=>{O.set({value:D},void 0)}),O}e.$Hc=a;function h(m,O){return new Promise(D=>{let $=!1,C=!1;const U=(0,k.$Ac)(F=>{const I=m.read(F);O(I)&&($?U.dispose():C=!0,D(I))});$=!0,C&&U.dispose()})}e.$Ic=h;function c(m,O){return new g(m,O)}e.$Jc=c;class g extends v.$4c{constructor(O,D){super(),this.h=O,this._getValue=D,this.b=!1,this.k=$=>{const C=this._getValue($),U=!this.b||this.a!==C;(0,r.$Uc)()?.handleFromEventObservableTriggered(this,{oldValue:this.a,newValue:C,change:void 0,didChange:U,hadValue:this.b}),U&&(this.a=C,this.b&&(0,v.$5c)(F=>{for(const I of this.c)F.updateObserver(I,this),I.handleChange(this,void 0)},()=>{const F=this.i();return"Event fired"+(F?`: ${F}`:"")}),this.b=!0)}}i(){return(0,v.$9c)(this._getValue)}get debugName(){const O=this.i();return"From Event"+(O?`: ${O}`:"")}f(){this.e=this.h(this.k)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.k(void 0),this.a):this._getValue(void 0)}}e.$Kc=g,function(m){m.Observer=g}(c||(e.$Jc=c={}));function u(m,O){return new n(m,O)}e.$Lc=u;class n extends v.$4c{constructor(O,D){super(),this.debugName=O,this.b=D,this.h=()=>{(0,v.$5c)($=>{for(const C of this.c)$.updateObserver(C,this),C.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function i(m){return typeof m=="string"?new s(m):new s(void 0,m)}e.$Mc=i;class s extends v.$4c{get debugName(){return(0,v.$8c)(this.a,void 0,this.b,this)??"Observable Signal"}constructor(O,D){super(),this.a=O,this.b=D}trigger(O,D){if(!O){(0,v.$5c)($=>{this.trigger($,D)},()=>`Trigger signal ${this.debugName}`);return}for(const $ of this.c)O.updateObserver($,this),$.handleChange(this,D)}get(){}}function d(m,O,D){const $=(0,v.$0c)("debounced",void 0);let C;return D.add((0,k.$Ac)(U=>{const F=m.read(U);C&&clearTimeout(C),C=setTimeout(()=>{(0,v.$5c)(I=>{$.set(F,I)})},O)})),$}e.$Nc=d;function w(m,O,D){const $=(0,v.$0c)("triggeredRecently",!1);let C;return D.add(m(()=>{$.set(!0,void 0),C&&clearTimeout(C),C=setTimeout(()=>{$.set(!1,void 0)},O)})),$}e.$Oc=w;function N(m){const O=new E(!1);return m.addObserver(O),(0,A.$ic)(()=>{m.removeObserver(O)})}e.$Pc=N;function P(m){const O=new E(!0);return m.addObserver(O),m.reportChanges(),(0,A.$ic)(()=>{m.removeObserver(O)})}e.$Qc=P;class E{constructor(O){this.b=O,this.a=0}beginUpdate(O){this.a++}endUpdate(O){this.a--,this.a===0&&this.b&&O.reportChanges()}handlePossibleChange(O){}handleChange(O,D){}}function f(m){let O;return(0,T.$Wc)($=>(O=m($,O),O))}e.$Rc=f;function y(m,O){let D;const $=(0,v.$0c)("derivedObservableWithWritableCache.counter",0),C=(0,T.$Wc)(m,U=>($.read(U),D=O(U,D),D));return Object.assign(C,{clearCache:U=>{D=void 0,$.set($.get()+1,U)}})}e.$Sc=y}),define(q[11],K([0,1,5,10,9,22,4]),function(z,e,A,k,v,T,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return A.$0c}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return A.$_c}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return A.$5c}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return A.$6c}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return k.$Wc}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return k.$Xc}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return k.$Yc}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return k.$Zc}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return v.$Ac}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return v.$Fc}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return v.$Bc}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return v.$Dc}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return v.$zc}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return v.$Cc}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return T.$Gc}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return T.$Nc}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return T.$Rc}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return T.$Sc}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return T.$Pc}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return T.$Qc}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return T.$Jc}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return T.$Hc}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return T.$Mc}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return T.$Lc}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return T.$Ic}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return T.$Oc}}),!1&&(0,r.$Tc)(new r.$Vc)}),define(q[23],K([0,1,6,2]),function(z,e,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=void 0;function v(P){const E=P;return E?typeof E.read=="function":!1}e.$qd=v;function T(P){const E=P;return E?[E.on,E.pause,E.resume,E.destroy].every(f=>typeof f=="function"):!1}e.$rd=T;function r(P){const E=P;return E?T(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.$sd=r;function l(P,E){return new t(P,E)}e.$td=l;class t{constructor(E,f){this.e=E,this.f=f,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(E){if(!this.a.destroyed){if(this.a.flowing)this.g(E);else if(this.b.data.push(E),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(f=>this.d.push(f))}}error(E){this.a.destroyed||(this.a.flowing?this.h(E):this.b.error.push(E))}end(E){this.a.destroyed||(typeof E<"u"&&this.write(E),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(E){this.c.data.slice(0).forEach(f=>f(E))}h(E){this.c.error.length===0?(0,A.$Y)(E):this.c.error.slice(0).forEach(f=>f(E))}i(){this.c.end.slice(0).forEach(E=>E())}on(E,f){if(!this.a.destroyed)switch(E){case"data":this.c.data.push(f),this.resume();break;case"end":this.c.end.push(f),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(f),this.a.flowing&&this.k();break}}removeListener(E,f){if(this.a.destroyed)return;let y;switch(E){case"data":y=this.c.data;break;case"end":y=this.c.end;break;case"error":y=this.c.error;break}if(y){const m=y.indexOf(f);m>=0&&y.splice(m,1)}}j(){if(this.b.data.length>0){const E=this.e(this.b.data);this.g(E),this.b.data.length=0;const f=[...this.d];this.d.length=0,f.forEach(y=>y())}}k(){if(this.c.error.length>0){for(const E of this.b.error)this.h(E);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(P,E){const f=[];let y;for(;(y=P.read())!==null;)f.push(y);return E(f)}e.$ud=a;function h(P,E,f){const y=[];let m;for(;(m=P.read())!==null&&y.length<f;)y.push(m);return m===null&&y.length>0?E(y):{read:()=>{if(y.length>0)return y.shift();if(typeof m<"u"){const O=m;return m=void 0,O}return P.read()}}}e.$vd=h;function c(P,E){return new Promise((f,y)=>{const m=[];g(P,{onData:O=>{E&&m.push(O)},onError:O=>{E?y(O):f(void 0)},onEnd:()=>{f(E?E(m):void 0)}})})}e.$wd=c;function g(P,E,f){P.on("error",y=>{f?.isCancellationRequested||E.onError(y)}),P.on("end",()=>{f?.isCancellationRequested||E.onEnd()}),P.on("data",y=>{f?.isCancellationRequested||E.onData(y)})}e.$xd=g;function u(P,E){return new Promise((f,y)=>{const m=new k.$jc,O=[],D=U=>{if(O.push(U),O.length>E)return m.dispose(),P.pause(),f({stream:P,buffer:O,ended:!1})},$=U=>(m.dispose(),y(U)),C=()=>(m.dispose(),f({stream:P,buffer:O,ended:!0}));m.add((0,k.$ic)(()=>P.removeListener("error",$))),P.on("error",$),m.add((0,k.$ic)(()=>P.removeListener("end",C))),P.on("end",C),m.add((0,k.$ic)(()=>P.removeListener("data",D))),P.on("data",D)})}e.$yd=u;function n(P,E){const f=l(E);return f.end(P),f}e.$zd=n;function i(){const P=l(()=>{throw new Error("not supported")});return P.end(),P}e.$Ad=i;function s(P){let E=!1;return{read:()=>E?null:(E=!0,P)}}e.$Bd=s;function d(P,E,f){const y=l(f);return g(P,{onData:m=>y.write(E.data(m)),onError:m=>y.error(E.error?E.error(m):m),onEnd:()=>y.end()}),y}e.$Cd=d;function w(P,E,f){let y=!1;return{read:()=>{const m=E.read();return y?m:(y=!0,m!==null?f([P,m]):P)}}}e.$Dd=w;function N(P,E,f){let y=!1;const m=l(f);return g(E,{onData:O=>y?m.write(O):(y=!0,m.write(f([P,O]))),onError:O=>m.error(O),onEnd:()=>{y||(y=!0,m.write(P)),m.end()}}),m}e.$Ed=N}),define(q[12],K([0,1,43,23]),function(z,e,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=void 0;const v=typeof Buffer<"u",T=new A.$T(()=>new Uint8Array(256));let r,l;class t{static alloc(b){return v?new t(Buffer.allocUnsafe(b)):new t(new Uint8Array(b))}static wrap(b){return v&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new t(b)}static fromString(b,j){return!(j?.dontUseNodeBuffer||!1)&&v?new t(Buffer.from(b)):(r||(r=new TextEncoder),new t(r.encode(b)))}static fromByteArray(b){const j=t.alloc(b.length);for(let V=0,G=b.length;V<G;V++)j.buffer[V]=b[V];return j}static concat(b,j){if(typeof j>"u"){j=0;for(let p=0,_=b.length;p<_;p++)j+=b[p].byteLength}const V=t.alloc(j);let G=0;for(let p=0,_=b.length;p<_;p++){const W=b[p];V.set(W,G),G+=W.byteLength}return V}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=t.alloc(this.byteLength);return b.set(this),b}toString(){return v?this.buffer.toString():(l||(l=new TextDecoder),l.decode(this.buffer))}slice(b,j){return new t(this.buffer.subarray(b,j))}set(b,j){if(b instanceof t)this.buffer.set(b.buffer,j);else if(b instanceof Uint8Array)this.buffer.set(b,j);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),j);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return g(this.buffer,b)}writeUInt32BE(b,j){u(this.buffer,b,j)}readUInt32LE(b){return n(this.buffer,b)}writeUInt32LE(b,j){i(this.buffer,b,j)}readUInt8(b){return s(this.buffer,b)}writeUInt8(b,j){d(this.buffer,b,j)}indexOf(b,j=0){return a(this.buffer,b instanceof t?b.buffer:b,j)}}e.$Fd=t;function a(I,b,j=0){const V=b.byteLength,G=I.byteLength;if(V===0)return 0;if(V===1)return I.indexOf(b[0]);if(V>G-j)return-1;const p=T.value;p.fill(b.length);for(let X=0;X<b.length;X++)p[b[X]]=b.length-X-1;let _=j+b.length-1,W=_,H=-1;for(;_<G;)if(I[_]===b[W]){if(W===0){H=_;break}_--,W--}else _+=Math.max(b.length-W,p[I[_]]),W=b.length-1;return H}e.$Gd=a;function h(I,b){return I[b+0]<<0>>>0|I[b+1]<<8>>>0}e.$Hd=h;function c(I,b,j){I[j+0]=b&255,b=b>>>8,I[j+1]=b&255}e.$Id=c;function g(I,b){return I[b]*2**24+I[b+1]*2**16+I[b+2]*2**8+I[b+3]}e.$Jd=g;function u(I,b,j){I[j+3]=b,b=b>>>8,I[j+2]=b,b=b>>>8,I[j+1]=b,b=b>>>8,I[j]=b}e.$Kd=u;function n(I,b){return I[b+0]<<0>>>0|I[b+1]<<8>>>0|I[b+2]<<16>>>0|I[b+3]<<24>>>0}e.$Ld=n;function i(I,b,j){I[j+0]=b&255,b=b>>>8,I[j+1]=b&255,b=b>>>8,I[j+2]=b&255,b=b>>>8,I[j+3]=b&255}e.$Md=i;function s(I,b){return I[b]}e.$Nd=s;function d(I,b,j){I[j]=b}e.$Od=d;function w(I){return k.$ud(I,b=>t.concat(b))}e.$Pd=w;function N(I){return k.$Bd(I)}e.$Qd=N;function P(I){return k.$wd(I,b=>t.concat(b))}e.$Rd=P;async function E(I){return I.ended?t.concat(I.buffer):t.concat([...I.buffer,await P(I.stream)])}e.$Sd=E;function f(I){return k.$zd(I,b=>t.concat(b))}e.$Td=f;function y(I){return k.$Cd(I,{data:b=>typeof b=="string"?t.fromString(b):t.wrap(b)},b=>t.concat(b))}e.$Ud=y;function m(I){return k.$td(b=>t.concat(b),I)}e.$Vd=m;function O(I,b){return k.$Dd(I,b,j=>t.concat(j))}e.$Wd=O;function D(I,b){return k.$Ed(I,b,j=>t.concat(j))}e.$Xd=D;function $(I){let b=0,j=0,V=0;const G=new Uint8Array(Math.floor(I.length/4*3)),p=W=>{switch(j){case 3:G[V++]=b|W,j=0;break;case 2:G[V++]=b|W>>>2,b=W<<6,j=3;break;case 1:G[V++]=b|W>>>4,b=W<<4,j=2;break;default:b=W<<2,j=1}};for(let W=0;W<I.length;W++){const H=I.charCodeAt(W);if(H>=65&&H<=90)p(H-65);else if(H>=97&&H<=122)p(H-97+26);else if(H>=48&&H<=57)p(H-48+52);else if(H===43||H===45)p(62);else if(H===47||H===95)p(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${I[W]}`)}}const _=V;for(;j>0;)p(0);return t.wrap(G).slice(0,_)}e.$Yd=$;const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",U="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function F({buffer:I},b=!0,j=!1){const V=j?U:C;let G="";const p=I.byteLength%3;let _=0;for(;_<I.byteLength-p;_+=3){const W=I[_+0],H=I[_+1],X=I[_+2];G+=V[W>>>2],G+=V[(W<<4|H>>>4)&63],G+=V[(H<<2|X>>>6)&63],G+=V[X&63]}if(p===1){const W=I[_+0];G+=V[W>>>2],G+=V[W<<4&63],b&&(G+="==")}else if(p===2){const W=I[_+0],H=I[_+1];G+=V[W>>>2],G+=V[(W<<4|H>>>4)&63],G+=V[H<<2&63],b&&(G+="=")}return G}e.$Zd=F}),define(q[24],K([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cd=void 0,e.$cd=Symbol("MicrotaskDelay")}),define(q[13],K([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=e.StringEOL=void 0;var A;(function(v){v[v.Unknown=0]="Unknown",v[v.Invalid=3]="Invalid",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(A||(e.StringEOL=A={}));function k(v){let T=0,r=0,l=0,t=0;for(let a=0,h=v.length;a<h;a++){const c=v.charCodeAt(a);c===13?(T===0&&(r=a),T++,a+1<h&&v.charCodeAt(a+1)===10?(t|=2,a++):t|=3,l=a+1):c===10&&(t|=1,T===0&&(r=a),T++,l=a+1)}return T===0&&(r=v.length),[T,r,v.length-l,t]}e.$Ws=k}),define(q[14],K([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var A;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(A||(e.LanguageId=A={}));var k;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(k||(e.FontStyle=k={}));var v;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(v||(e.ColorId=v={}));var T;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(T||(e.StandardTokenType=T={}));var r;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class l{static getLanguageId(a){return(a&255)>>>0}static getTokenType(a){return(a&768)>>>8}static containsBalancedBrackets(a){return(a&1024)!==0}static getFontStyle(a){return(a&30720)>>>11}static getForeground(a){return(a&16744448)>>>15}static getBackground(a){return(a&4278190080)>>>24}static getClassNameFromMetadata(a){let c="mtk"+this.getForeground(a);const g=this.getFontStyle(a);return g&1&&(c+=" mtki"),g&2&&(c+=" mtkb"),g&4&&(c+=" mtku"),g&8&&(c+=" mtks"),c}static getInlineStyleFromMetadata(a,h){const c=this.getForeground(a),g=this.getFontStyle(a);let u=`color: ${h[c]};`;g&1&&(u+="font-style: italic;"),g&2&&(u+="font-weight: bold;");let n="";return g&4&&(n+=" underline"),g&8&&(n+=" line-through"),n&&(u+=`text-decoration:${n};`),u}static getPresentationFromMetadata(a){const h=this.getForeground(a),c=this.getFontStyle(a);return{foreground:h,italic:!!(c&1),bold:!!(c&2),underline:!!(c&4),strikethrough:!!(c&8)}}}e.$Us=l}),define(q[25],K([0,1,26]),function(z,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xC=void 0;class k{constructor(r){this.b=r,this.a=[]}get(r){return r<this.a.length?this.a[r]:this.b}set(r,l){for(;r>=this.a.length;)this.a[this.a.length]=this.b;this.a[r]=l}replace(r,l,t){if(r>=this.a.length)return;if(l===0){this.insert(r,t);return}else if(t===0){this.delete(r,l);return}const a=this.a.slice(0,r),h=this.a.slice(r+l),c=v(t,this.b);this.a=a.concat(c,h)}delete(r,l){l===0||r>=this.a.length||this.a.splice(r,l)}insert(r,l){if(l===0||r>=this.a.length)return;const t=[];for(let a=0;a<l;a++)t[a]=this.b;this.a=(0,A.$Ub)(this.a,r,t)}}e.$xC=k;function v(T,r){const l=[];for(let t=0;t<T;t++)l[t]=r;return l}}),define(q[7],K([0,1,14]),function(z,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=void 0;class k{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(r,l){const t=k.defaultTokenMetadata,a=new Uint32Array(2);return a[0]=r.length,a[1]=t,new k(a,r,l)}constructor(r,l,t){this._lineTokensBrand=void 0,this.a=r,this.b=this.a.length>>>1,this.c=l,this.d=t}equals(r){return r instanceof k?this.slicedEquals(r,0,this.b):!1}slicedEquals(r,l,t){if(this.c!==r.c||this.b!==r.b)return!1;const a=l<<1,h=a+(t<<1);for(let c=a;c<h;c++)if(this.a[c]!==r.a[c])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(r){return r>0?this.a[r-1<<1]:0}getMetadata(r){return this.a[(r<<1)+1]}getLanguageId(r){const l=this.a[(r<<1)+1],t=A.$Us.getLanguageId(l);return this.d.decodeLanguageId(t)}getStandardTokenType(r){const l=this.a[(r<<1)+1];return A.$Us.getTokenType(l)}getForeground(r){const l=this.a[(r<<1)+1];return A.$Us.getForeground(l)}getClassName(r){const l=this.a[(r<<1)+1];return A.$Us.getClassNameFromMetadata(l)}getInlineStyle(r,l){const t=this.a[(r<<1)+1];return A.$Us.getInlineStyleFromMetadata(t,l)}getPresentation(r){const l=this.a[(r<<1)+1];return A.$Us.getPresentationFromMetadata(l)}getEndOffset(r){return this.a[r<<1]}findTokenIndexAtOffset(r){return k.findIndexInTokensArray(this.a,r)}inflate(){return this}sliceAndInflate(r,l,t){return new v(this,r,l,t)}static convertToEndOffset(r,l){const a=(r.length>>>1)-1;for(let h=0;h<a;h++)r[h<<1]=r[h+1<<1];r[a<<1]=l}static findIndexInTokensArray(r,l){if(r.length<=2)return 0;let t=0,a=(r.length>>>1)-1;for(;t<a;){const h=t+Math.floor((a-t)/2),c=r[h<<1];if(c===l)return h+1;c<l?t=h+1:c>l&&(a=h)}return t}withInserted(r){if(r.length===0)return this;let l=0,t=0,a="";const h=new Array;let c=0;for(;;){const g=l<this.b?this.a[l<<1]:-1,u=t<r.length?r[t]:null;if(g!==-1&&(u===null||g<=u.offset)){a+=this.c.substring(c,g);const n=this.a[(l<<1)+1];h.push(a.length,n),l++,c=g}else if(u){if(u.offset>c){a+=this.c.substring(c,u.offset);const n=this.a[(l<<1)+1];h.push(a.length,n),c=u.offset}a+=u.text,h.push(a.length,u.tokenMetadata),t++}else break}return new k(new Uint32Array(h),a,this.d)}}e.$Xs=k;class v{constructor(r,l,t,a){this.a=r,this.b=l,this.c=t,this.d=a,this.e=r.findTokenIndexAtOffset(l),this.f=0;for(let h=this.e,c=r.getCount();h<c&&!(r.getStartOffset(h)>=t);h++)this.f++}getMetadata(r){return this.a.getMetadata(this.e+r)}getLanguageId(r){return this.a.getLanguageId(this.e+r)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(r){return r instanceof v?this.b===r.b&&this.c===r.c&&this.d===r.d&&this.a.slicedEquals(r.a,this.e,this.f):!1}getCount(){return this.f}getForeground(r){return this.a.getForeground(this.e+r)}getEndOffset(r){const l=this.a.getEndOffset(this.e+r);return Math.min(this.c,l)-this.b+this.d}getClassName(r){return this.a.getClassName(this.e+r)}getInlineStyle(r,l){return this.a.getInlineStyle(this.e+r,l)}getPresentation(r){return this.a.getPresentation(this.e+r)}findTokenIndexAtOffset(r){return this.a.findTokenIndexAtOffset(r+this.b-this.d)-this.e}}}),define(q[27],K([0,1,7]),function(z,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=e.$Zs=e.$Ys=void 0,e.$Ys=new Uint32Array(0).buffer;class k{static deleteBeginning(r,l){return r===null||r===e.$Ys?r:k.delete(r,0,l)}static deleteEnding(r,l){if(r===null||r===e.$Ys)return r;const t=v(r),a=t[t.length-2];return k.delete(r,l,a)}static delete(r,l,t){if(r===null||r===e.$Ys||l===t)return r;const a=v(r),h=a.length>>>1;if(l===0&&a[a.length-2]===t)return e.$Ys;const c=A.$Xs.findIndexInTokensArray(a,l),g=c>0?a[c-1<<1]:0,u=a[c<<1];if(t<u){const w=t-l;for(let N=c;N<h;N++)a[N<<1]-=w;return r}let n,i;g!==l?(a[c<<1]=l,n=c+1<<1,i=l):(n=c<<1,i=g);const s=t-l;for(let w=c+1;w<h;w++){const N=a[w<<1]-s;N>i&&(a[n++]=N,a[n++]=a[(w<<1)+1],i=N)}if(n===a.length)return r;const d=new Uint32Array(n);return d.set(a.subarray(0,n),0),d.buffer}static append(r,l){if(l===e.$Ys)return r;if(r===e.$Ys)return l;if(r===null)return r;if(l===null)return null;const t=v(r),a=v(l),h=a.length>>>1,c=new Uint32Array(t.length+a.length);c.set(t,0);let g=t.length;const u=t[t.length-2];for(let n=0;n<h;n++)c[g++]=a[n<<1]+u,c[g++]=a[(n<<1)+1];return c.buffer}static insert(r,l,t){if(r===null||r===e.$Ys)return r;const a=v(r),h=a.length>>>1;let c=A.$Xs.findIndexInTokensArray(a,l);c>0&&a[c-1<<1]===l&&c--;for(let g=c;g<h;g++)a[g<<1]+=t;return r}}e.$Zs=k;function v(T){return T instanceof Uint32Array?T:new Uint32Array(T)}e.$1s=v}),define(q[28],K([0,1,26,12,44,13,27,15]),function(z,e,A,k,v,T,r,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=void 0;class t{static deserialize(h,c,g){const u=new Uint32Array(h.buffer),n=(0,k.$Jd)(h,c);c+=4;const i=(0,k.$Jd)(h,c);c+=4;const s=[];for(let d=0;d<i;d++){const w=(0,k.$Jd)(h,c);c+=4,s.push(u.subarray(c/4,c/4+w/4)),c+=w}return g.push(new t(n,s)),c}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(h,c){this.a=h,this.b=c}getLineRange(){return new l.$ts(this.a,this.a+this.b.length)}getLineTokens(h){return this.b[h-this.a]}appendLineTokens(h){this.b.push(h)}serializeSize(){let h=0;h+=4,h+=4;for(let c=0;c<this.b.length;c++){const g=this.b[c];if(!(g instanceof Uint32Array))throw new Error("Not supported!");h+=4,h+=g.byteLength}return h}serialize(h,c){(0,k.$Kd)(h,this.a,c),c+=4,(0,k.$Kd)(h,this.b.length,c),c+=4;for(let g=0;g<this.b.length;g++){const u=this.b[g];if(!(u instanceof Uint32Array))throw new Error("Not supported!");(0,k.$Kd)(h,u.byteLength,c),c+=4,h.set(new Uint8Array(u.buffer),c),c+=u.byteLength}return c}applyEdit(h,c){const[g,u]=(0,T.$Ws)(c);this.c(h),this.d(new v.$js(h.startLineNumber,h.startColumn),g,u)}c(h){if(h.startLineNumber===h.endLineNumber&&h.startColumn===h.endColumn)return;const c=h.startLineNumber-this.a,g=h.endLineNumber-this.a;if(g<0){const u=g-c;this.a-=u;return}if(!(c>=this.b.length)){if(c<0&&g>=this.b.length){this.a=0,this.b=[];return}if(c===g){this.b[c]=r.$Zs.delete(this.b[c],h.startColumn-1,h.endColumn-1);return}if(c>=0)if(this.b[c]=r.$Zs.deleteEnding(this.b[c],h.startColumn-1),g<this.b.length){const u=r.$Zs.deleteBeginning(this.b[g],h.endColumn-1);this.b[c]=r.$Zs.append(this.b[c],u),this.b.splice(c+1,g-c)}else this.b[c]=r.$Zs.append(this.b[c],null),this.b=this.b.slice(0,c+1);else{const u=-c;this.a-=u,this.b[g]=r.$Zs.deleteBeginning(this.b[g],h.endColumn-1),this.b=this.b.slice(g)}}}d(h,c,g){if(c===0&&g===0)return;const u=h.lineNumber-this.a;if(u<0){this.a+=c;return}if(!(u>=this.b.length)){if(c===0){this.b[u]=r.$Zs.insert(this.b[u],h.column-1,g);return}this.b[u]=r.$Zs.deleteEnding(this.b[u],h.column-1),this.b[u]=r.$Zs.insert(this.b[u],h.column-1,g),this.e(h.lineNumber,c)}}e(h,c){if(c===0)return;const g=[];for(let u=0;u<c;u++)g[u]=null;this.b=A.$Ub(this.b,h,g)}}e.$2s=t}),define(q[16],K([0,1,12,28]),function(z,e,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yC=void 0;class v{static deserialize(r){let l=0;const t=(0,A.$Jd)(r,l);l+=4;const a=[];for(let h=0;h<t;h++)l=k.$2s.deserialize(r,l,a);return a}constructor(){this.a=[]}add(r,l){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===r){t.appendLineTokens(l);return}}this.a.push(new k.$2s(r,[l]))}finalize(){return this.a}serialize(){const r=this.b(),l=new Uint8Array(r);return this.c(l),l}b(){let r=0;r+=4;for(let l=0;l<this.a.length;l++)r+=this.a[l].serializeSize();return r}c(r){let l=0;(0,A.$Kd)(r,this.a.length,l),l+=4;for(let t=0;t<this.a.length;t++)l=this.a[t].serialize(r,l)}}e.$yC=v}),define(q[29],K([0,1,30,3,31,45]),function(z,e,A,k,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=void 0;function r($){return $===47||$===92}e.$Bf=r;function l($){return $.replace(/[\\/]/g,A.$6d.sep)}e.$Cf=l;function t($){return $.indexOf("/")===-1&&($=l($)),/^[a-zA-Z]:(\/|$)/.test($)&&($="/"+$),$}e.$Df=t;function a($,C=A.$6d.sep){if(!$)return"";const U=$.length,F=$.charCodeAt(0);if(r(F)){if(r($.charCodeAt(1))&&!r($.charCodeAt(2))){let b=3;const j=b;for(;b<U&&!r($.charCodeAt(b));b++);if(j!==b&&!r($.charCodeAt(b+1))){for(b+=1;b<U;b++)if(r($.charCodeAt(b)))return $.slice(0,b+1).replace(/[\\/]/g,C)}}return C}else if(d(F)&&$.charCodeAt(1)===58)return r($.charCodeAt(2))?$.slice(0,2)+C:$.slice(0,2);let I=$.indexOf("://");if(I!==-1){for(I+=3;I<U;I++)if(r($.charCodeAt(I)))return $.slice(0,I+1)}return""}e.$Ef=a;function h($){if(!k.$i||!$||$.length<5)return!1;let C=$.charCodeAt(0);if(C!==92||(C=$.charCodeAt(1),C!==92))return!1;let U=2;const F=U;for(;U<$.length&&(C=$.charCodeAt(U),C!==92);U++);return!(F===U||(C=$.charCodeAt(U+1),isNaN(C)||C===92))}e.$Ff=h;const c=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n($,C=k.$i){const U=C?c:g;return!(!$||$.length===0||/^\s+$/.test($)||(U.lastIndex=0,U.test($))||C&&u.test($)||$==="."||$===".."||C&&$[$.length-1]==="."||C&&$.length!==$.trim().length||$.length>255)}e.$Gf=n;function i($,C,U){const F=$===C;return!U||F?F:!$||!C?!1:(0,v.$Me)($,C)}e.$Hf=i;function s($,C,U,F=A.sep){if($===C)return!0;if(!$||!C||C.length>$.length)return!1;if(U){if(!(0,v.$Ne)($,C))return!1;if(C.length===$.length)return!0;let b=C.length;return C.charAt(C.length-1)===F&&b--,$.charAt(b)===F}return C.charAt(C.length-1)!==F&&(C+=F),$.indexOf(C)===0}e.$If=s;function d($){return $>=65&&$<=90||$>=97&&$<=122}e.$Jf=d;function w($,C){return k.$i&&$.endsWith(":")&&($+=A.sep),(0,A.$8d)($)||($=(0,A.$9d)(C,$)),$=(0,A.$7d)($),k.$i?($=(0,v.$ve)($,A.sep),$.endsWith(":")&&($+=A.sep)):($=(0,v.$ve)($,A.sep),$||($=A.sep)),$}e.$Kf=w;function N($){const C=(0,A.$7d)($);return k.$i?$.length>3?!1:P(C)&&($.length===2||C.charCodeAt(2)===92):C===A.$6d.sep}e.$Lf=N;function P($,C=k.$i){return C?d($.charCodeAt(0))&&$.charCodeAt(1)===58:!1}e.$Mf=P;function E($,C=k.$i){return P($,C)?$[0]:void 0}e.$Nf=E;function f($,C,U){return C.length>$.length?-1:$===C?0:(U&&($=$.toLowerCase(),C=C.toLowerCase()),$.indexOf(C))}e.$Of=f;function y($){const C=$.split(":");let U,F,I;for(const b of C){const j=Number(b);(0,T.$nf)(j)?F===void 0?F=j:I===void 0&&(I=j):U=U?[U,b].join(":"):b}if(!U)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:U,line:F!==void 0?F:void 0,column:I!==void 0?I:F!==void 0?1:void 0}}e.$Pf=y;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",O="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D($,C,U=8){let F="";for(let b=0;b<U;b++){let j;b===0&&k.$i&&!C&&(U===3||U===4)?j=O:j=m,F+=j.charAt(Math.floor(Math.random()*j.length))}let I;return C?I=`${C}-${F}`:I=F,$?(0,A.$9d)($,I):I}e.$Qf=D}),define(q[17],K([0,1,6,3,8]),function(z,e,A,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.Schemas=void 0;var T;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(T||(e.Schemas=T={})),e.$Uf="vscode-tkn",e.$Vf="tkn";class r{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${T.vscodeRemoteResource}`}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h){this.f=`${h}/${T.vscodeRemoteResource}`}set(h,c,g){this.a[h]=c,this.b[h]=g}setConnectionToken(h,c){this.c[h]=c}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(s){return A.$Y(s),h}const c=h.authority;let g=this.a[c];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const u=this.b[c],n=this.c[c];let i=`path=${encodeURIComponent(h.path)}`;return typeof n=="string"&&(i+=`&${e.$Vf}=${encodeURIComponent(n)}`),v.URI.from({scheme:k.$o?this.d:T.vscodeRemoteResource,authority:`${g}:${u}`,path:this.f,query:i})}}e.$Wf=new r,e.$Xf="vs/../../extensions",e.$Yf="vs/../../node_modules",e.$Zf="vs/../../node_modules.asar",e.$1f="vs/../../node_modules.asar.unpacked";class l{static{this.a="vscode-app"}asBrowserUri(h){const c=this.b(h,z);return this.uriToBrowserUri(c)}uriToBrowserUri(h){return h.scheme===T.vscodeRemote?e.$Wf.rewrite(h):h.scheme===T.file&&(k.$m||k.$p&&k.$g.origin===`${T.vscodeFileResource}://${l.a}`)?h.with({scheme:T.vscodeFileResource,authority:h.authority||l.a,query:null,fragment:null}):h}asFileUri(h){const c=this.b(h,z);return this.uriToFileUri(c)}uriToFileUri(h){return h.scheme===T.vscodeFileResource?h.with({scheme:T.file,authority:h.authority!==l.a?h.authority:null,query:null,fragment:null}):h}b(h,c){return v.URI.isUri(h)?h:v.URI.parse(c.toUrl(h))}}e.$2f=new l;var t;(function(a){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(h.get("3"));const c="vscode-coi";function g(n){let i;typeof n=="string"?i=new URL(n).searchParams:n instanceof URL?i=n.searchParams:v.URI.isUri(n)&&(i=new URL(n.toString(!0)).searchParams);const s=i?.get(c);if(s)return h.get(s)}a.getHeadersFromQuery=g;function u(n,i,s){if(!globalThis.crossOriginIsolated)return;const d=i&&s?"3":s?"2":"1";n instanceof URLSearchParams?n.set(c,d):n[c]=d}a.addSearchParam=u})(t||(e.COI=t={}))}),define(q[32],K([0,1,21,17,3,8]),function(z,e,A,k,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aD=void 0;class r{constructor(g,u,n){this.id=g,this.dependencies=u,this.callback=n}}class l{static{this.INSTANCE=new l}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,u,n)=>{typeof g!="string"&&(n=u,u=g,g=null),(typeof u!="object"||!Array.isArray(u))&&(n=u,u=null),this.c.push(new r(g,u,n))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const u=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!u)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(u.dependencies)&&u.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${u.dependencies.join(", ")}`);return typeof u.callback=="function"?u.callback([]):u.callback}h(g){return new Promise((u,n)=>{const i=document.createElement("script");i.setAttribute("async","async"),i.setAttribute("type","text/javascript");const s=()=>{i.removeEventListener("load",d),i.removeEventListener("error",w)},d=N=>{s(),u(this.c.pop())},w=N=>{s(),n(N)};i.addEventListener("load",d),i.addEventListener("error",w),this.f&&(g=this.f.createScriptURL(g)),i.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(i)})}i(g){return new Promise((u,n)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),u(this.c.pop())}catch(i){n(i)}})}async j(g){try{const u=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,i=globalThis._VSCODE_NODE_MODULES.module,s=T.URI.parse(g).fsPath,d=u.readFileSync(s).toString(),w=i.wrap(d.replace(/^#!.*/,""));return new n.Script(w).runInThisContext().apply(),this.c.pop()}catch(u){throw u}}}const t=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function h(c,g,u){if(A.$R){u===void 0&&(u=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[c]&&(c=a[c]);const n=`${c}/${g}`;if(t.has(n))return t.get(n);let i;if(/^\w[\w\d+.-]*:\/\//.test(n))i=n;else{const N=`${u&&!v.$o?k.$Zf:k.$Yf}/${n}`;i=k.$2f.asBrowserUri(N).toString(!0)}const s=l.INSTANCE.load(i);return t.set(n,s),s}else return await new Promise((n,i)=>{z([c],n,i)})}e.$aD=h}),define(q[18],K([0,1,29,17,30,3,31,8]),function(z,e,A,k,v,T,r,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=e.DataUri=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=void 0;function t(u){return(0,l.$Tf)(u,!0)}e.$9f=t;class a{constructor(n){this.a=n}compare(n,i,s=!1){return n===i?0:(0,r.$Fe)(this.getComparisonKey(n,s),this.getComparisonKey(i,s))}isEqual(n,i,s=!1){return n===i?!0:!n||!i?!1:this.getComparisonKey(n,s)===this.getComparisonKey(i,s)}getComparisonKey(n,i=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,i,s=!1){if(n.scheme===i.scheme){if(n.scheme===k.Schemas.file)return A.$If(t(n),t(i),this.a(n))&&n.query===i.query&&(s||n.fragment===i.fragment);if((0,e.$ng)(n.authority,i.authority))return A.$If(n.path,i.path,this.a(n),"/")&&n.query===i.query&&(s||n.fragment===i.fragment)}return!1}joinPath(n,...i){return l.URI.joinPath(n,...i)}basenameOrAuthority(n){return(0,e.$fg)(n)||n.authority}basename(n){return v.$6d.basename(n.path)}extname(n){return v.$6d.extname(n.path)}dirname(n){if(n.path.length===0)return n;let i;return n.scheme===k.Schemas.file?i=l.URI.file(v.$_d(t(n))).path:(i=v.$6d.dirname(n.path),n.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),i="/")),n.with({path:i})}normalizePath(n){if(!n.path.length)return n;let i;return n.scheme===k.Schemas.file?i=l.URI.file(v.$7d(t(n))).path:i=v.$6d.normalize(n.path),n.with({path:i})}relativePath(n,i){if(n.scheme!==i.scheme||!(0,e.$ng)(n.authority,i.authority))return;if(n.scheme===k.Schemas.file){const w=v.$$d(t(n),t(i));return T.$i?A.$Cf(w):w}let s=n.path||"/";const d=i.path||"/";if(this.a(n)){let w=0;for(const N=Math.min(s.length,d.length);w<N&&!(s.charCodeAt(w)!==d.charCodeAt(w)&&s.charAt(w).toLowerCase()!==d.charAt(w).toLowerCase());w++);s=d.substr(0,w)+s.substr(w)}return v.$6d.relative(s,d)}resolvePath(n,i){if(n.scheme===k.Schemas.file){const s=l.URI.file(v.$0d(t(n),i));return n.with({authority:s.authority,path:s.path})}return i=A.$Df(i),n.with({path:v.$6d.resolve(n.path,i)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,i){return n===i||n!==void 0&&i!==void 0&&(0,r.$Me)(n,i)}hasTrailingPathSeparator(n,i=v.sep){if(n.scheme===k.Schemas.file){const s=t(n);return s.length>A.$Ef(s).length&&s[s.length-1]===i}else{const s=n.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,i=v.sep){return(0,e.$og)(n,i)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,i=v.sep){let s=!1;if(n.scheme===k.Schemas.file){const d=t(n);s=d!==void 0&&d.length===A.$Ef(d).length&&d[d.length-1]===i}else{i="/";const d=n.path;s=d.length===1&&d.charCodeAt(d.length-1)===47}return!s&&!(0,e.$og)(n,i)?n.with({path:n.path+"/"}):n}}e.$0f=a,e.$$f=new a(()=>!1),e.$_f=new a(u=>u.scheme===k.Schemas.file?!T.$k:!0),e.$ag=new a(u=>!0),e.$bg=e.$$f.isEqual.bind(e.$$f),e.$cg=e.$$f.isEqualOrParent.bind(e.$$f),e.$dg=e.$$f.getComparisonKey.bind(e.$$f),e.$eg=e.$$f.basenameOrAuthority.bind(e.$$f),e.$fg=e.$$f.basename.bind(e.$$f),e.$gg=e.$$f.extname.bind(e.$$f),e.$hg=e.$$f.dirname.bind(e.$$f),e.$ig=e.$$f.joinPath.bind(e.$$f),e.$jg=e.$$f.normalizePath.bind(e.$$f),e.$kg=e.$$f.relativePath.bind(e.$$f),e.$lg=e.$$f.resolvePath.bind(e.$$f),e.$mg=e.$$f.isAbsolutePath.bind(e.$$f),e.$ng=e.$$f.isEqualAuthority.bind(e.$$f),e.$og=e.$$f.hasTrailingPathSeparator.bind(e.$$f),e.$pg=e.$$f.removeTrailingPathSeparator.bind(e.$$f),e.$qg=e.$$f.addTrailingPathSeparator.bind(e.$$f);function h(u,n){const i=[];for(let s=0;s<u.length;s++){const d=n(u[s]);u.some((w,N)=>N===s?!1:(0,e.$cg)(d,n(w)))||i.push(u[s])}return i}e.$rg=h;var c;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function n(i){const s=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(N=>{const[P,E]=N.split(":");P&&E&&s.set(P,E)});const w=i.path.substring(0,i.path.indexOf(";"));return w&&s.set(u.META_DATA_MIME,w),s}u.parseMetaData=n})(c||(e.DataUri=c={}));function g(u,n,i){if(n){let s=u.path;return s&&s[0]!==v.$6d.sep&&(s=v.$6d.sep+s),u.with({scheme:i,authority:n,path:s})}return u.with({scheme:i})}e.$sg=g}),define(q[19],K([0,1,46,6,33,2,18,3,24]),function(z,e,A,k,v,T,r,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=e.$4g=e.$3g=e.Promises=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=void 0;function a(M){return!!M&&typeof M.then=="function"}e.$tg=a;function h(M){const o=new A.$pd,S=M(o.token),L=new Promise((R,B)=>{const Y=o.token.onCancellationRequested(()=>{Y.dispose(),o.dispose(),B(new k.$3)});Promise.resolve(S).then(J=>{Y.dispose(),o.dispose(),R(J)},J=>{Y.dispose(),o.dispose(),B(J)})});return new class{cancel(){o.cancel()}then(R,B){return L.then(R,B)}catch(R){return this.then(void 0,R)}finally(R){return L.finally(R)}}}e.$ug=h;function c(M,o,S){return new Promise((L,R)=>{const B=o.onCancellationRequested(()=>{B.dispose(),L(S)});M.then(L,R).finally(()=>B.dispose())})}e.$vg=c;function g(M,o){return new Promise((S,L)=>{const R=o.onCancellationRequested(()=>{R.dispose(),L(new k.$3)});M.then(S,L).finally(()=>R.dispose())})}e.$wg=g;async function u(M){let o=-1;const S=M.map((L,R)=>L.then(B=>(o=R,B)));try{return await Promise.race(S)}finally{M.forEach((L,R)=>{R!==o&&L.cancel()})}}e.$xg=u;function n(M,o,S){let L;const R=setTimeout(()=>{L?.(void 0),S?.()},o);return Promise.race([M.finally(()=>clearTimeout(R)),new Promise(B=>L=B)])}e.$yg=n;function i(M){return new Promise((o,S)=>{const L=M();a(L)?L.then(o,S):o(L)})}e.$zg=i;class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(o){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=o,!this.b){const S=()=>{if(this.b=null,this.f)return;const L=this.queue(this.d);return this.d=null,L};this.b=new Promise(L=>{this.a.then(S,S).then(L)})}return new Promise((S,L)=>{this.b.then(S,L)})}return this.a=o(),new Promise((S,L)=>{this.a.then(R=>{this.a=null,S(R)},R=>{this.a=null,L(R)})})}dispose(){this.f=!0}}e.$Ag=s;class d{constructor(){this.a=Promise.resolve(null)}queue(o){return this.a=this.a.then(()=>o(),()=>o())}}e.$Bg=d;class w{constructor(){this.a=new Map}queue(o,S){const R=(this.a.get(o)??Promise.resolve()).catch(()=>{}).then(S).finally(()=>{this.a.get(o)===R&&this.a.delete(o)});return this.a.set(o,R),R}}e.$Cg=w;const N=(M,o)=>{let S=!0;const L=setTimeout(()=>{S=!1,o()},M);return{isTriggered:()=>S,dispose:()=>{clearTimeout(L),S=!1}}},P=M=>{let o=!0;return queueMicrotask(()=>{o&&(o=!1,M())}),{isTriggered:()=>o,dispose:()=>{o=!1}}};class E{constructor(o){this.defaultDelay=o,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(o,S=this.defaultDelay){this.g=o,this.h(),this.b||(this.b=new Promise((R,B)=>{this.d=R,this.f=B}).then(()=>{if(this.b=null,this.d=null,this.g){const R=this.g;return this.g=null,R()}}));const L=()=>{this.a=null,this.d?.(null)};return this.a=S===t.$cd?P(L):N(S,L),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new k.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dg=E;class f{constructor(o){this.a=new E(o),this.b=new s}trigger(o,S){return this.a.trigger(()=>this.b.queue(o),S)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eg=f;class y{constructor(){this.a=!1,this.b=new Promise((o,S)=>{this.d=o})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fg=y;class m extends y{constructor(o){super(),this.f=setTimeout(()=>this.open(),o)}open(){clearTimeout(this.f),super.open()}}e.$Gg=m;function O(M,o){return o?new Promise((S,L)=>{const R=setTimeout(()=>{B.dispose(),S()},M),B=o.onCancellationRequested(()=>{clearTimeout(R),B.dispose(),L(new k.$3)})}):h(S=>O(M,S))}e.$Hg=O;function D(M,o=0){const S=setTimeout(M,o);return(0,T.$ic)(()=>clearTimeout(S))}e.$Ig=D;function $(M){const o=[];let S=0;const L=M.length;function R(){return S<L?M[S++]():null}function B(Y){Y!=null&&o.push(Y);const J=R();return J?J.then(B):Promise.resolve(o)}return Promise.resolve(null).then(B)}e.$Jg=$;function C(M,o=L=>!!L,S=null){let L=0;const R=M.length,B=()=>{if(L>=R)return Promise.resolve(S);const Y=M[L++];return Promise.resolve(Y()).then(Q=>o(Q)?Promise.resolve(Q):B())};return B()}e.$Kg=C;function U(M,o=L=>!!L,S=null){if(M.length===0)return Promise.resolve(S);let L=M.length;const R=()=>{L=-1;for(const B of M)B.cancel?.()};return new Promise((B,Y)=>{for(const J of M)J.then(Q=>{--L>=0&&o(Q)?(R(),B(Q)):L===0&&B(S)}).catch(Q=>{--L>=0&&(R(),Y(Q))})})}e.$Lg=U;class F{constructor(o){this.a=0,this.d=o,this.f=[],this.b=0,this.g=new v.$fd}get onDrained(){return this.g.event}get size(){return this.a}queue(o){return this.a++,new Promise((S,L)=>{this.f.push({factory:o,c:S,e:L}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const o=this.f.shift();this.b++;const S=o.factory();S.then(o.c,o.e),S.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Mg=F;class I extends F{constructor(){super(1)}}e.$Ng=I;class b{constructor(){this.a=new x,this.b=0}queue(o){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,o())):this.a.run(this.b++,o())}}e.$Og=b;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const o=new te;return this.b.add(o),o.p}g(){for(const[,o]of this.a)if(o.size>0)return!1;return!0}queueFor(o,S=r.$$f){const L=S.getComparisonKey(o);let R=this.a.get(L);if(!R){R=new I;const B=this.f++,Y=v.Event.once(R.onDrained)(()=>{R?.dispose(),this.a.delete(L),this.h(),this.d?.deleteAndDispose(B),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new T.$sc),this.d.set(B,Y),this.a.set(L,R)}return R}h(){this.g()&&this.j()}j(){for(const o of this.b)o.complete();this.b.clear()}dispose(){for(const[,o]of this.a)o.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Pg=j;class V{constructor(o,S){this.a=-1,typeof o=="function"&&typeof S=="number"&&this.setIfNotSet(o,S)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(o,S){this.cancel(),this.a=setTimeout(()=>{this.a=-1,o()},S)}setIfNotSet(o,S){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,o()},S))}}e.$Qg=V;class G{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(o,S){this.cancel(),this.a=setInterval(()=>{o()},S)}}e.$Rg=G;class p{constructor(o,S){this.b=-1,this.a=o,this.d=S,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(o=this.d){this.cancel(),this.b=setTimeout(this.f,o)}get delay(){return this.d}set delay(o){this.d=o}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sg=p;class _{constructor(o,S){S%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${S}ms is not a multiple of 1000ms.`),this.a=o,this.b=S,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(o=this.b){o%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${o}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(o/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Tg=_;class W extends p{constructor(o,S){super(o,S),this.j=[]}work(o){this.j.push(o),this.isScheduled()||this.schedule()}h(){const o=this.j;this.j=[],this.a?.(o)}dispose(){this.j=[],super.dispose()}}e.$Ug=W;class H extends T.$kc{constructor(o,S){super(),this.g=o,this.h=S,this.a=[],this.b=this.B(new T.$lc),this.f=!1}get pending(){return this.a.length}work(o){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+o.length>this.g.maxBufferedWork)return!1}else if(this.pending+o.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const S of o)this.a.push(S);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new p(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vg=H,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Wg=M=>{(0,l.$A)(()=>{if(o)return;const S=Date.now()+15;M(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,S-Date.now())}}))});let o=!1;return{dispose(){o||(o=!0)}}}:e.$Wg=(M,o)=>{const S=requestIdleCallback(M,typeof o=="number"?{timeout:o}:void 0);let L=!1;return{dispose(){L||(L=!0,cancelIdleCallback(S))}}}}();class X{constructor(o){this.d=!1,this.a=()=>{try{this.f=o()}catch(S){this.g=S}finally{this.d=!0}},this.b=(0,e.$Wg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Xg=X;async function re(M,o,S){let L;for(let R=0;R<S;R++)try{return await M()}catch(B){L=B,await O(o)}throw L}e.$Yg=re;class x{isRunning(o){return typeof o=="number"?this.a?.taskId===o:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(o,S,L){return this.a={taskId:o,cancel:()=>L?.(),promise:S},S.then(()=>this.d(o),()=>this.d(o)),S}d(o){this.a&&o===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const o=this.b;this.b=void 0,o.run().then(o.promiseResolve,o.promiseReject)}}queue(o){if(this.b)this.b.run=o;else{let S,L;const R=new Promise((B,Y)=>{S=B,L=Y});this.b={run:o,promise:R,promiseResolve:S,promiseReject:L}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Zg=x;class ae{constructor(o,S=()=>Date.now()){this.d=o,this.f=S,this.a=0,this.b=0}increment(){const o=this.f();return o-this.a>this.d&&(this.a=o,this.b=0),this.b++,this.b}}e.$1g=ae;var ee;(function(M){M[M.Resolved=0]="Resolved",M[M.Rejected=1]="Rejected"})(ee||(ee={}));class te{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((o,S)=>{this.a=o,this.b=S})}complete(o){return new Promise(S=>{this.a(o),this.d={outcome:0,value:o},S()})}error(o){return new Promise(S=>{this.b(o),this.d={outcome:1,value:o},S()})}cancel(){return this.error(new k.$3)}}e.$2g=te;var ne;(function(M){async function o(L){let R;const B=await Promise.all(L.map(Y=>Y.then(J=>J,J=>{R||(R=J)})));if(typeof R<"u")throw R;return B}M.settled=o;function S(L){return new Promise(async(R,B)=>{try{await L(R,B)}catch(Y){B(Y)}})}M.withAsyncBody=S})(ne||(e.Promises=ne={}));var ie;(function(M){M[M.Initial=0]="Initial",M[M.DoneOK=1]="DoneOK",M[M.DoneError=2]="DoneError"})(ie||(ie={}));class Z{static fromArray(o){return new Z(S=>{S.emitMany(o)})}static fromPromise(o){return new Z(async S=>{S.emitMany(await o)})}static fromPromises(o){return new Z(async S=>{await Promise.all(o.map(async L=>S.emitOne(await L)))})}static merge(o){return new Z(async S=>{await Promise.all(o.map(async L=>{for await(const R of L)S.emitOne(R)}))})}static{this.EMPTY=Z.fromArray([])}constructor(o){this.a=0,this.b=[],this.d=null,this.f=new v.$fd,queueMicrotask(async()=>{const S={emitOne:L=>this.g(L),emitMany:L=>this.h(L),reject:L=>this.k(L)};try{await Promise.resolve(o(S)),this.j()}catch(L){this.k(L)}finally{S.emitOne=void 0,S.emitMany=void 0,S.reject=void 0}})}[Symbol.asyncIterator](){let o=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(o<this.b.length)return{done:!1,value:this.b[o++]};if(this.a===1)return{done:!0,value:void 0};await v.Event.toPromise(this.f.event)}while(!0)}}}static map(o,S){return new Z(async L=>{for await(const R of o)L.emitOne(S(R))})}map(o){return Z.map(this,o)}static filter(o,S){return new Z(async L=>{for await(const R of o)S(R)&&L.emitOne(R)})}filter(o){return Z.filter(this,o)}static coalesce(o){return Z.filter(o,S=>!!S)}coalesce(){return Z.coalesce(this)}static async toPromise(o){const S=[];for await(const L of o)S.push(L);return S}toPromise(){return Z.toPromise(this)}g(o){this.a===0&&(this.b.push(o),this.f.fire())}h(o){this.a===0&&(this.b=this.b.concat(o),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(o){this.a===0&&(this.a=2,this.d=o,this.f.fire())}}e.$3g=Z;class se extends Z{constructor(o,S){super(S),this.l=o}cancel(){this.l.cancel()}}e.$4g=se;function ce(M){const o=new A.$pd,S=M(o.token);return new se(o,async L=>{const R=o.token.onCancellationRequested(()=>{R.dispose(),o.dispose(),L.reject(new k.$3)});try{for await(const B of S){if(o.token.isCancellationRequested)return;L.emitOne(B)}R.dispose(),o.dispose()}catch(B){R.dispose(),o.dispose(),L.reject(B)}})}e.$5g=ce}),define(q[20],K([0,1,34]),function(z,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wC=e.$vC=e.$uC=void 0,e.$uC=new class{clone(){return this}equals(T){return this===T}};function k(T,r){return new A.$5s([new A.$4s(0,"",T)],r)}e.$vC=k;function v(T,r){const l=new Uint32Array(2);return l[0]=0,l[1]=(T<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new A.$6s(l,r===null?e.$uC:r)}e.$wC=v}),define(q[35],K([0,1,19,6,3,36,13,15,47,20,25,16,7]),function(z,e,A,k,v,T,r,l,t,a,h,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EC=e.$DC=e.$CC=e.$BC=e.$AC=e.$zC=void 0;var u;(function(E){E[E.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(u||(u={}));class n{constructor(f,y){this.tokenizationSupport=y,this.a=this.tokenizationSupport.getInitialState(),this.store=new s(f)}getStartState(f){return this.store.getStartState(f,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$zC=n;class i extends n{constructor(f,y,m,O){super(f,y),this._textModel=m,this._languageIdCodec=O}updateTokensUntilLine(f,y){const m=this._textModel.getLanguageId();for(;;){const O=this.getFirstInvalidLine();if(!O||O.lineNumber>y)break;const D=this._textModel.getLineContent(O.lineNumber),$=N(this._languageIdCodec,m,this.tokenizationSupport,D,!0,O.startState);f.add(O.lineNumber,$.tokens),this.store.setEndState(O.lineNumber,$.endState)}}getTokenTypeIfInsertingCharacter(f,y){const m=this.getStartState(f.lineNumber);if(!m)return 0;const O=this._textModel.getLanguageId(),D=this._textModel.getLineContent(f.lineNumber),$=D.substring(0,f.column-1)+y+D.substring(f.column-1),C=N(this._languageIdCodec,O,this.tokenizationSupport,$,!0,m),U=new g.$Xs(C.tokens,$,this._languageIdCodec);if(U.getCount()===0)return 0;const F=U.findTokenIndexAtOffset(f.column-1);return U.getStandardTokenType(F)}tokenizeLineWithEdit(f,y,m){const O=f.lineNumber,D=f.column,$=this.getStartState(O);if(!$)return null;const C=this._textModel.getLineContent(O),U=C.substring(0,D-1)+m+C.substring(D-1+y),F=this._textModel.getLanguageIdAtPosition(O,0),I=N(this._languageIdCodec,F,this.tokenizationSupport,U,!0,$);return new g.$Xs(I.tokens,U,this._languageIdCodec)}isCheapToTokenize(f){const y=this.store.getFirstInvalidEndStateLineNumberOrMax();return f<y||f===y&&this._textModel.getLineLength(f)<2048}tokenizeHeuristically(f,y,m){if(m<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(y<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(f,m),{heuristicTokens:!1};let O=this.b(y);const D=this._textModel.getLanguageId();for(let $=y;$<=m;$++){const C=this._textModel.getLineContent($),U=N(this._languageIdCodec,D,this.tokenizationSupport,C,!0,O);f.add($,U.tokens),O=U.endState}return{heuristicTokens:!0}}b(f){let y=this._textModel.getLineFirstNonWhitespaceColumn(f);const m=[];let O=null;for(let C=f-1;y>1&&C>=1;C--){const U=this._textModel.getLineFirstNonWhitespaceColumn(C);if(U!==0&&U<y&&(m.push(this._textModel.getLineContent(C)),y=U,O=this.getStartState(C),O))break}O||(O=this.tokenizationSupport.getInitialState()),m.reverse();const D=this._textModel.getLanguageId();let $=O;for(const C of m)$=N(this._languageIdCodec,D,this.tokenizationSupport,C,!1,$).endState;return $}}e.$AC=i;class s{constructor(f){this.d=f,this.a=new d,this.b=new w,this.b.addRange(new t.$rs(1,f+1))}getEndState(f){return this.a.getEndState(f)}setEndState(f,y){if(!y)throw new k.$ab("Cannot set null/undefined state");this.b.delete(f);const m=this.a.setEndState(f,y);return m&&f<this.d&&this.b.addRange(new t.$rs(f+1,f+2)),m}acceptChange(f,y){this.d+=y-f.length,this.a.acceptChange(f,y),this.b.addRangeAndResize(new t.$rs(f.startLineNumber,f.endLineNumberExclusive),y)}acceptChanges(f){for(const y of f){const[m]=(0,r.$Ws)(y.text);this.acceptChange(new l.$ts(y.range.startLineNumber,y.range.endLineNumber+1),m+1)}}invalidateEndStateRange(f){this.b.addRange(new t.$rs(f.startLineNumber,f.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(f,y){return f===1?y:this.getEndState(f-1)}getFirstInvalidLine(f){const y=this.getFirstInvalidEndStateLineNumber();if(y===null)return null;const m=this.getStartState(y,f);if(!m)throw new k.$ab("Start state must be defined");return{lineNumber:y,startState:m}}}e.$BC=s;class d{constructor(){this.a=new h.$xC(null)}getEndState(f){return this.a.get(f)}setEndState(f,y){const m=this.a.get(f);return m&&m.equals(y)?!1:(this.a.set(f,y),!0)}acceptChange(f,y){let m=f.length;y>0&&m>0&&(m--,y--),this.a.replace(f.startLineNumber,m,y)}acceptChanges(f){for(const y of f){const[m]=(0,r.$Ws)(y.text);this.acceptChange(new l.$ts(y.range.startLineNumber,y.range.endLineNumber+1),m+1)}}}e.$CC=d;class w{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const f=this.a[0];return f.start+1===f.endExclusive?this.a.shift():this.a[0]=new t.$rs(f.start+1,f.endExclusive),f.start}delete(f){const y=this.a.findIndex(m=>m.contains(f));if(y!==-1){const m=this.a[y];m.start===f?m.endExclusive===f+1?this.a.splice(y,1):this.a[y]=new t.$rs(f+1,m.endExclusive):m.endExclusive===f+1?this.a[y]=new t.$rs(m.start,f):this.a.splice(y,1,new t.$rs(m.start,f),new t.$rs(f+1,m.endExclusive))}}addRange(f){t.$rs.addRange(f,this.a)}addRangeAndResize(f,y){let m=0;for(;!(m>=this.a.length||f.start<=this.a[m].endExclusive);)m++;let O=m;for(;!(O>=this.a.length||f.endExclusive<this.a[O].start);)O++;const D=y-f.length;for(let $=O;$<this.a.length;$++)this.a[$]=this.a[$].delta(D);if(m===O){const $=new t.$rs(f.start,f.start+y);$.isEmpty||this.a.splice(m,0,$)}else{const $=Math.min(f.start,this.a[m].start),C=Math.max(f.endExclusive,this.a[O-1].endExclusive),U=new t.$rs($,C+D);U.isEmpty?this.a.splice(m,O-m):this.a.splice(m,O-m,U)}}toString(){return this.a.map(f=>f.toString()).join(" + ")}}e.$DC=w;function N(E,f,y,m,O,D){let $=null;if(y)try{$=y.tokenizeEncoded(m,O,D.clone())}catch(C){(0,k.$Y)(C)}return $||($=(0,a.$wC)(E.encodeLanguageId(f),D)),g.$Xs.convertToEndOffset($.tokens,m.length),$}class P{constructor(f,y){this.b=f,this.d=y,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,A.$Wg)(f=>{this.f=!1,this.h(f)}))}h(f){const y=Date.now()+f.timeRemaining(),m=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<y?(0,v.$A)(m):this.g())};m()}j(){const f=this.b._textModel.getLineCount(),y=new c.$yC,m=T.$bd.create(!1);do if(m.elapsed()>1||this.l(y)>=f)break;while(this.k());this.d.setTokens(y.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(f){const y=this.b?.getFirstInvalidLine();return y?(this.b.updateTokensUntilLine(f,y.lineNumber),y.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(f,y){this.b.store.invalidateEndStateRange(new l.$ts(f,y))}}e.$EC=P}),define(q[37],K([0,1,33,2,36,14,34]),function(z,e,A,k,v,T,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pBb=void 0;class l extends k.$kc{constructor(a,h,c,g,u,n,i){super(),this.c=a,this.f=h,this.g=c,this.h=g,this.j=u,this.m=n,this.n=i,this.a=[],this.b=this.B(new A.$fd),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(a,h,c){throw new Error("Not supported!")}createBackgroundTokenizer(a,h){if(this.h)return this.h(a,h)}tokenizeEncoded(a,h,c){const g=Math.random()*1e4<1,u=this.n||g,n=u?new v.$bd(!0):void 0,i=this.c.tokenizeLine2(a,c,500);if(u){const d=n.elapsed();(g||d>32)&&this.m(d,a.length,g)}if(i.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${a.substring(0,100)}`),new r.$6s(i.tokens,c);if(this.g){const d=this.a,w=i.tokens;for(let N=0,P=w.length>>>1;N<P;N++){const E=w[(N<<1)+1],f=T.$Us.getLanguageId(E);d[f]||(d[f]=!0,this.b.fire(f))}}let s;return c.equals(i.ruleStack)?s=c:s=i.ruleStack,new r.$6s(i.tokens,s)}}e.$pBb=l}),define(q[38],K([0,1,20,2,11]),function(z,e,A,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qBb=void 0;class T extends k.$kc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(l,t,a){super(),this.a=l,this.b=t,this.c=a,this.B((0,v.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(l,t,a){throw new Error("Not supported!")}tokenizeEncoded(l,t,a){return l.length>=this.c.get()?(0,A.$wC)(this.a,a):this.b.tokenizeEncoded(l,t,a)}createBackgroundTokenizer(l,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(l,t)}}e.$qBb=T}),define(q[39],K([0,1,32,19,11,3,15,48,35,16,7,37,38]),function(z,e,A,k,v,T,r,l,t,a,h,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vBb=void 0;class u extends l.$Mu{constructor(s,d,w,N,P,E,f,y){super(s,d,w,N),this.s=P,this.t=E,this.u=f,this.a=null,this.b=!1,this.c=(0,v.observableValue)(this,-1),this.q=new k.$Sg(()=>this.w(),10),this.c.set(y,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(s,d){this.t=s,this.u=d,this.v()}onEvents(s){super.onEvents(s),this.a?.store.acceptChanges(s.changes),this.q.schedule()}acceptMaxTokenizationLineLength(s){this.c.set(s,void 0)}retokenize(s,d){this.a&&(this.a.store.invalidateEndStateRange(new r.$ts(s,d)),this.q.schedule())}async v(){this.a=null;const s=this.t,d=this.u,w=await this.s.getOrCreateGrammar(s,d);if(!(this.b||s!==this.t||d!==this.u||!w)){if(w.grammar){const N=new g.$qBb(this.u,new c.$pBb(w.grammar,w.initialState,!1,void 0,()=>!1,(P,E,f)=>{this.s.reportTokenizationTime(P,s,w.sourceExtensionId,E,f)},!1),this.c);this.a=new t.$zC(this.f.length,N)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:d}=await(0,A.$aD)("vscode-textmate","release/main.js");this.m=d}const s=new Date().getTime();for(;;){let d=0;const w=new a.$yC,N=new n;for(;;){const f=this.a.getFirstInvalidLine();if(f===null||d>200)break;d++;const y=this.f[f.lineNumber-1],m=this.a.tokenizationSupport.tokenizeEncoded(y,!0,f.startState);if(this.a.store.setEndState(f.lineNumber,m.endState)){const D=this.m(f.startState,m.endState);N.setState(f.lineNumber,D)}else N.setState(f.lineNumber,null);if(h.$Xs.convertToEndOffset(m.tokens,y.length),w.add(f.lineNumber,m.tokens),new Date().getTime()-s>20)break}if(d===0)break;const P=N.getStateDeltas();if(this.s.setTokensAndStates(this.h,w.serialize(),P),new Date().getTime()-s>20){(0,T.$A)(()=>this.w());return}}}}e.$vBb=u;class n{constructor(){this.a=-1,this.b=[]}setState(s,d){s===this.a+1?this.b[this.b.length-1].stateDeltas.push(d):this.b.push({startLineNumber:s,stateDeltas:[d]}),this.a=s}getStateDeltas(){return this.b}}}),define(q[40],K([0,1,18]),function(z,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sBb=void 0;class k{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(T){if(this.a[T.scopeName]){const r=this.a[T.scopeName];A.$bg(r.location,T.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${T.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${T.location.toString()}`)}this.a[T.scopeName]=T}getGrammarDefinition(T){return this.a[T]||null}}e.$sBb=k}),define(q[41],K([0,1,2,40]),function(z,e,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uBb=e.$tBb=void 0,e.$tBb="No TM Grammar registered for this language.";class v extends A.$kc{constructor(r,l,t,a){super(),this.a=r,this.b=t.INITIAL,this.c=new k.$sBb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:a,loadGrammar:async h=>{const c=this.c.getGrammarDefinition(h);if(!c)return this.a.logTrace(`No grammar found for scope ${h}`),null;const g=c.location;try{const u=await this.a.readFile(g);return t.parseRawGrammar(u,g.path)}catch(u){return this.a.logError(`Unable to load and parse grammar for scope ${h} from ${g}`,u),null}},getInjections:h=>{const c=h.split(".");let g=[];for(let u=1;u<=c.length;u++){const n=c.slice(0,u).join(".");g=[...g,...this.f[n]||[]]}return g}}));for(const h of l){if(this.c.register(h),h.injectTo){for(const c of h.injectTo){let g=this.f[c];g||(this.f[c]=g=[]),g.push(h.scopeName)}if(h.embeddedLanguages)for(const c of h.injectTo){let g=this.g[c];g||(this.g[c]=g=[]),g.push(h.embeddedLanguages)}}h.language&&this.h.set(h.language,h.scopeName)}}has(r){return this.h.has(r)}setTheme(r,l){this.j.setTheme(r,l)}getColorMap(){return this.j.getColorMap()}async createGrammar(r,l){const t=this.h.get(r);if(typeof t!="string")throw new Error(e.$tBb);const a=this.c.getGrammarDefinition(t);if(!a)throw new Error(e.$tBb);const h=a.embeddedLanguages;if(this.g[t]){const u=this.g[t];for(const n of u)for(const i of Object.keys(n))h[i]=n[i]}const c=Object.keys(h).length>0;let g;try{g=await this.j.loadGrammarWithConfiguration(t,l,{embeddedLanguages:h,tokenTypes:a.tokenTypes,balancedBracketSelectors:a.balancedBracketSelectors,unbalancedBracketSelectors:a.unbalancedBracketSelectors})}catch(u){throw u.message&&u.message.startsWith("No grammar provided for")?new Error(e.$tBb):u}return{languageId:r,grammar:g,initialState:this.b,containsEmbeddedLanguages:c,sourceExtensionId:a.sourceExtensionId}}}e.$uBb=v}),define(q[49],K([0,1,8,41,39]),function(z,e,A,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function T(l,t){return new r(l,t)}e.create=T;class r{constructor(t,a){this.f=a,this.b=new Map,this.c=[],this.a=t.host;const h=a.grammarDefinitions.map(c=>({location:A.URI.revive(c.location),language:c.language,scopeName:c.scopeName,embeddedLanguages:c.embeddedLanguages,tokenTypes:c.tokenTypes,injectTo:c.injectTo,balancedBracketSelectors:c.balancedBracketSelectors,unbalancedBracketSelectors:c.unbalancedBracketSelectors,sourceExtensionId:c.sourceExtensionId}));this.d=this.g(h)}async g(t){const a=this.f.textmateMainUri,h=await new Promise((i,s)=>{z([a],i,s)}),c=await new Promise((i,s)=>{z([this.f.onigurumaMainUri],i,s)}),u=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await c.loadWASM(u);const n=Promise.resolve({createOnigScanner:i=>c.createOnigScanner(i),createOnigString:i=>c.createOnigString(i)});return new k.$uBb({logTrace:i=>{},logError:(i,s)=>console.error(i,s),readFile:i=>this.a.readFile(i)},t,h,n)}acceptNewModel(t){const a=A.URI.revive(t.uri),h=this;this.b.set(t.controllerId,new v.$vBb(a,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(c,g){const u=await h.d;return u?(h.c[g]||(h.c[g]=u.createGrammar(c,g)),h.c[g]):Promise.resolve(null)},setTokensAndStates(c,g,u){h.a.setTokensAndStates(t.controllerId,c,g,u)},reportTokenizationTime(c,g,u,n,i){h.a.reportTokenizationTime(c,g,u,n,i)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,a){this.b.get(t).onEvents(a)}retokenize(t,a,h){this.b.get(t).retokenize(a,h)}acceptModelLanguageChanged(t,a,h){this.b.get(t).onLanguageId(a,h)}acceptRemovedModel(t){const a=this.b.get(t);a&&(a.dispose(),this.b.delete(t))}async acceptTheme(t,a){(await this.d)?.setTheme(t,a)}acceptMaxTokenizationLineLength(t,a){this.b.get(t).acceptMaxTokenizationLineLength(a)}}e.TextMateTokenizationWorker=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/10765021158cf51eaf6785361598e1668f53e06e/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
